Erector::CHARACTERS = {
  :space => 0x0020,
  :exclamation_mark => 0x0021,
  :quotation_mark => 0x0022,
  :number_sign => 0x0023,
  :dollar_sign => 0x0024,
  :percent_sign => 0x0025,
  :ampersand => 0x0026,
  :apostrophe => 0x0027,
  :apostrophe_quote => 0x0027,
  :left_parenthesis => 0x0028,
  :opening_parenthesis => 0x0028,
  :right_parenthesis => 0x0029,
  :closing_parenthesis => 0x0029,
  :asterisk => 0x002a,
  :plus_sign => 0x002b,
  :comma => 0x002c,
  :hyphen_minus => 0x002d,
  :full_stop => 0x002e,
  :period => 0x002e,
  :solidus => 0x002f,
  :slash => 0x002f,
  :digit_zero => 0x0030,
  :digit_one => 0x0031,
  :digit_two => 0x0032,
  :digit_three => 0x0033,
  :digit_four => 0x0034,
  :digit_five => 0x0035,
  :digit_six => 0x0036,
  :digit_seven => 0x0037,
  :digit_eight => 0x0038,
  :digit_nine => 0x0039,
  :colon => 0x003a,
  :semicolon => 0x003b,
  :less_than_sign => 0x003c,
  :equals_sign => 0x003d,
  :greater_than_sign => 0x003e,
  :question_mark => 0x003f,
  :commercial_at => 0x0040,
  :latin_capital_letter_a => 0x0041,
  :latin_capital_letter_b => 0x0042,
  :latin_capital_letter_c => 0x0043,
  :latin_capital_letter_d => 0x0044,
  :latin_capital_letter_e => 0x0045,
  :latin_capital_letter_f => 0x0046,
  :latin_capital_letter_g => 0x0047,
  :latin_capital_letter_h => 0x0048,
  :latin_capital_letter_i => 0x0049,
  :latin_capital_letter_j => 0x004a,
  :latin_capital_letter_k => 0x004b,
  :latin_capital_letter_l => 0x004c,
  :latin_capital_letter_m => 0x004d,
  :latin_capital_letter_n => 0x004e,
  :latin_capital_letter_o => 0x004f,
  :latin_capital_letter_p => 0x0050,
  :latin_capital_letter_q => 0x0051,
  :latin_capital_letter_r => 0x0052,
  :latin_capital_letter_s => 0x0053,
  :latin_capital_letter_t => 0x0054,
  :latin_capital_letter_u => 0x0055,
  :latin_capital_letter_v => 0x0056,
  :latin_capital_letter_w => 0x0057,
  :latin_capital_letter_x => 0x0058,
  :latin_capital_letter_y => 0x0059,
  :latin_capital_letter_z => 0x005a,
  :left_square_bracket => 0x005b,
  :opening_square_bracket => 0x005b,
  :reverse_solidus => 0x005c,
  :backslash => 0x005c,
  :right_square_bracket => 0x005d,
  :closing_square_bracket => 0x005d,
  :circumflex_accent => 0x005e,
  :spacing_circumflex => 0x005e,
  :low_line => 0x005f,
  :spacing_underscore => 0x005f,
  :grave_accent => 0x0060,
  :spacing_grave => 0x0060,
  :latin_small_letter_a => 0x0061,
  :latin_small_letter_b => 0x0062,
  :latin_small_letter_c => 0x0063,
  :latin_small_letter_d => 0x0064,
  :latin_small_letter_e => 0x0065,
  :latin_small_letter_f => 0x0066,
  :latin_small_letter_g => 0x0067,
  :latin_small_letter_h => 0x0068,
  :latin_small_letter_i => 0x0069,
  :latin_small_letter_j => 0x006a,
  :latin_small_letter_k => 0x006b,
  :latin_small_letter_l => 0x006c,
  :latin_small_letter_m => 0x006d,
  :latin_small_letter_n => 0x006e,
  :latin_small_letter_o => 0x006f,
  :latin_small_letter_p => 0x0070,
  :latin_small_letter_q => 0x0071,
  :latin_small_letter_r => 0x0072,
  :latin_small_letter_s => 0x0073,
  :latin_small_letter_t => 0x0074,
  :latin_small_letter_u => 0x0075,
  :latin_small_letter_v => 0x0076,
  :latin_small_letter_w => 0x0077,
  :latin_small_letter_x => 0x0078,
  :latin_small_letter_y => 0x0079,
  :latin_small_letter_z => 0x007a,
  :left_curly_bracket => 0x007b,
  :opening_curly_bracket => 0x007b,
  :vertical_line => 0x007c,
  :vertical_bar => 0x007c,
  :right_curly_bracket => 0x007d,
  :closing_curly_bracket => 0x007d,
  :tilde => 0x007e,
  :no_break_space => 0x00a0,
  :non_breaking_space => 0x00a0,
  :inverted_exclamation_mark => 0x00a1,
  :cent_sign => 0x00a2,
  :pound_sign => 0x00a3,
  :currency_sign => 0x00a4,
  :yen_sign => 0x00a5,
  :broken_bar => 0x00a6,
  :broken_vertical_bar => 0x00a6,
  :section_sign => 0x00a7,
  :diaeresis => 0x00a8,
  :spacing_diaeresis => 0x00a8,
  :copyright_sign => 0x00a9,
  :feminine_ordinal_indicator => 0x00aa,
  :left_pointing_double_angle_quotation_mark => 0x00ab,
  :left_pointing_guillemet => 0x00ab,
  :not_sign => 0x00ac,
  :soft_hyphen => 0x00ad,
  :registered_sign => 0x00ae,
  :registered_trade_mark_sign => 0x00ae,
  :macron => 0x00af,
  :spacing_macron => 0x00af,
  :degree_sign => 0x00b0,
  :plus_minus_sign => 0x00b1,
  :plus_or_minus_sign => 0x00b1,
  :superscript_two => 0x00b2,
  :superscript_digit_two => 0x00b2,
  :superscript_three => 0x00b3,
  :superscript_digit_three => 0x00b3,
  :acute_accent => 0x00b4,
  :spacing_acute => 0x00b4,
  :micro_sign => 0x00b5,
  :pilcrow_sign => 0x00b6,
  :paragraph_sign => 0x00b6,
  :middle_dot => 0x00b7,
  :cedilla => 0x00b8,
  :spacing_cedilla => 0x00b8,
  :superscript_one => 0x00b9,
  :superscript_digit_one => 0x00b9,
  :masculine_ordinal_indicator => 0x00ba,
  :right_pointing_double_angle_quotation_mark => 0x00bb,
  :right_pointing_guillemet => 0x00bb,
  :vulgar_fraction_one_quarter => 0x00bc,
  :fraction_one_quarter => 0x00bc,
  :vulgar_fraction_one_half => 0x00bd,
  :fraction_one_half => 0x00bd,
  :vulgar_fraction_three_quarters => 0x00be,
  :fraction_three_quarters => 0x00be,
  :inverted_question_mark => 0x00bf,
  :latin_capital_letter_a_with_grave => 0x00c0,
  :latin_capital_letter_a_grave => 0x00c0,
  :latin_capital_letter_a_with_acute => 0x00c1,
  :latin_capital_letter_a_acute => 0x00c1,
  :latin_capital_letter_a_with_circumflex => 0x00c2,
  :latin_capital_letter_a_circumflex => 0x00c2,
  :latin_capital_letter_a_with_tilde => 0x00c3,
  :latin_capital_letter_a_tilde => 0x00c3,
  :latin_capital_letter_a_with_diaeresis => 0x00c4,
  :latin_capital_letter_a_diaeresis => 0x00c4,
  :latin_capital_letter_a_with_ring_above => 0x00c5,
  :latin_capital_letter_a_ring => 0x00c5,
  :latin_capital_letter_ae => 0x00c6,
  :latin_capital_letter_a_e => 0x00c6,
  :latin_capital_letter_c_with_cedilla => 0x00c7,
  :latin_capital_letter_c_cedilla => 0x00c7,
  :latin_capital_letter_e_with_grave => 0x00c8,
  :latin_capital_letter_e_grave => 0x00c8,
  :latin_capital_letter_e_with_acute => 0x00c9,
  :latin_capital_letter_e_acute => 0x00c9,
  :latin_capital_letter_e_with_circumflex => 0x00ca,
  :latin_capital_letter_e_circumflex => 0x00ca,
  :latin_capital_letter_e_with_diaeresis => 0x00cb,
  :latin_capital_letter_e_diaeresis => 0x00cb,
  :latin_capital_letter_i_with_grave => 0x00cc,
  :latin_capital_letter_i_grave => 0x00cc,
  :latin_capital_letter_i_with_acute => 0x00cd,
  :latin_capital_letter_i_acute => 0x00cd,
  :latin_capital_letter_i_with_circumflex => 0x00ce,
  :latin_capital_letter_i_circumflex => 0x00ce,
  :latin_capital_letter_i_with_diaeresis => 0x00cf,
  :latin_capital_letter_i_diaeresis => 0x00cf,
  :latin_capital_letter_eth => 0x00d0,
  :latin_capital_letter_n_with_tilde => 0x00d1,
  :latin_capital_letter_n_tilde => 0x00d1,
  :latin_capital_letter_o_with_grave => 0x00d2,
  :latin_capital_letter_o_grave => 0x00d2,
  :latin_capital_letter_o_with_acute => 0x00d3,
  :latin_capital_letter_o_acute => 0x00d3,
  :latin_capital_letter_o_with_circumflex => 0x00d4,
  :latin_capital_letter_o_circumflex => 0x00d4,
  :latin_capital_letter_o_with_tilde => 0x00d5,
  :latin_capital_letter_o_tilde => 0x00d5,
  :latin_capital_letter_o_with_diaeresis => 0x00d6,
  :latin_capital_letter_o_diaeresis => 0x00d6,
  :multiplication_sign => 0x00d7,
  :latin_capital_letter_o_with_stroke => 0x00d8,
  :latin_capital_letter_o_slash => 0x00d8,
  :latin_capital_letter_u_with_grave => 0x00d9,
  :latin_capital_letter_u_grave => 0x00d9,
  :latin_capital_letter_u_with_acute => 0x00da,
  :latin_capital_letter_u_acute => 0x00da,
  :latin_capital_letter_u_with_circumflex => 0x00db,
  :latin_capital_letter_u_circumflex => 0x00db,
  :latin_capital_letter_u_with_diaeresis => 0x00dc,
  :latin_capital_letter_u_diaeresis => 0x00dc,
  :latin_capital_letter_y_with_acute => 0x00dd,
  :latin_capital_letter_y_acute => 0x00dd,
  :latin_capital_letter_thorn => 0x00de,
  :latin_small_letter_sharp_s => 0x00df,
  :latin_small_letter_a_with_grave => 0x00e0,
  :latin_small_letter_a_grave => 0x00e0,
  :latin_small_letter_a_with_acute => 0x00e1,
  :latin_small_letter_a_acute => 0x00e1,
  :latin_small_letter_a_with_circumflex => 0x00e2,
  :latin_small_letter_a_circumflex => 0x00e2,
  :latin_small_letter_a_with_tilde => 0x00e3,
  :latin_small_letter_a_tilde => 0x00e3,
  :latin_small_letter_a_with_diaeresis => 0x00e4,
  :latin_small_letter_a_diaeresis => 0x00e4,
  :latin_small_letter_a_with_ring_above => 0x00e5,
  :latin_small_letter_a_ring => 0x00e5,
  :latin_small_letter_ae => 0x00e6,
  :latin_small_letter_a_e => 0x00e6,
  :latin_small_letter_c_with_cedilla => 0x00e7,
  :latin_small_letter_c_cedilla => 0x00e7,
  :latin_small_letter_e_with_grave => 0x00e8,
  :latin_small_letter_e_grave => 0x00e8,
  :latin_small_letter_e_with_acute => 0x00e9,
  :latin_small_letter_e_acute => 0x00e9,
  :latin_small_letter_e_with_circumflex => 0x00ea,
  :latin_small_letter_e_circumflex => 0x00ea,
  :latin_small_letter_e_with_diaeresis => 0x00eb,
  :latin_small_letter_e_diaeresis => 0x00eb,
  :latin_small_letter_i_with_grave => 0x00ec,
  :latin_small_letter_i_grave => 0x00ec,
  :latin_small_letter_i_with_acute => 0x00ed,
  :latin_small_letter_i_acute => 0x00ed,
  :latin_small_letter_i_with_circumflex => 0x00ee,
  :latin_small_letter_i_circumflex => 0x00ee,
  :latin_small_letter_i_with_diaeresis => 0x00ef,
  :latin_small_letter_i_diaeresis => 0x00ef,
  :latin_small_letter_eth => 0x00f0,
  :latin_small_letter_n_with_tilde => 0x00f1,
  :latin_small_letter_n_tilde => 0x00f1,
  :latin_small_letter_o_with_grave => 0x00f2,
  :latin_small_letter_o_grave => 0x00f2,
  :latin_small_letter_o_with_acute => 0x00f3,
  :latin_small_letter_o_acute => 0x00f3,
  :latin_small_letter_o_with_circumflex => 0x00f4,
  :latin_small_letter_o_circumflex => 0x00f4,
  :latin_small_letter_o_with_tilde => 0x00f5,
  :latin_small_letter_o_tilde => 0x00f5,
  :latin_small_letter_o_with_diaeresis => 0x00f6,
  :latin_small_letter_o_diaeresis => 0x00f6,
  :division_sign => 0x00f7,
  :latin_small_letter_o_with_stroke => 0x00f8,
  :latin_small_letter_o_slash => 0x00f8,
  :latin_small_letter_u_with_grave => 0x00f9,
  :latin_small_letter_u_grave => 0x00f9,
  :latin_small_letter_u_with_acute => 0x00fa,
  :latin_small_letter_u_acute => 0x00fa,
  :latin_small_letter_u_with_circumflex => 0x00fb,
  :latin_small_letter_u_circumflex => 0x00fb,
  :latin_small_letter_u_with_diaeresis => 0x00fc,
  :latin_small_letter_u_diaeresis => 0x00fc,
  :latin_small_letter_y_with_acute => 0x00fd,
  :latin_small_letter_y_acute => 0x00fd,
  :latin_small_letter_thorn => 0x00fe,
  :latin_small_letter_y_with_diaeresis => 0x00ff,
  :latin_small_letter_y_diaeresis => 0x00ff,
  :latin_capital_letter_a_with_macron => 0x0100,
  :latin_capital_letter_a_macron => 0x0100,
  :latin_small_letter_a_with_macron => 0x0101,
  :latin_small_letter_a_macron => 0x0101,
  :latin_capital_letter_a_with_breve => 0x0102,
  :latin_capital_letter_a_breve => 0x0102,
  :latin_small_letter_a_with_breve => 0x0103,
  :latin_small_letter_a_breve => 0x0103,
  :latin_capital_letter_a_with_ogonek => 0x0104,
  :latin_capital_letter_a_ogonek => 0x0104,
  :latin_small_letter_a_with_ogonek => 0x0105,
  :latin_small_letter_a_ogonek => 0x0105,
  :latin_capital_letter_c_with_acute => 0x0106,
  :latin_capital_letter_c_acute => 0x0106,
  :latin_small_letter_c_with_acute => 0x0107,
  :latin_small_letter_c_acute => 0x0107,
  :latin_capital_letter_c_with_circumflex => 0x0108,
  :latin_capital_letter_c_circumflex => 0x0108,
  :latin_small_letter_c_with_circumflex => 0x0109,
  :latin_small_letter_c_circumflex => 0x0109,
  :latin_capital_letter_c_with_dot_above => 0x010a,
  :latin_capital_letter_c_dot => 0x010a,
  :latin_small_letter_c_with_dot_above => 0x010b,
  :latin_small_letter_c_dot => 0x010b,
  :latin_capital_letter_c_with_caron => 0x010c,
  :latin_capital_letter_c_hacek => 0x010c,
  :latin_small_letter_c_with_caron => 0x010d,
  :latin_small_letter_c_hacek => 0x010d,
  :latin_capital_letter_d_with_caron => 0x010e,
  :latin_capital_letter_d_hacek => 0x010e,
  :latin_small_letter_d_with_caron => 0x010f,
  :latin_small_letter_d_hacek => 0x010f,
  :latin_capital_letter_d_with_stroke => 0x0110,
  :latin_capital_letter_d_bar => 0x0110,
  :latin_small_letter_d_with_stroke => 0x0111,
  :latin_small_letter_d_bar => 0x0111,
  :latin_capital_letter_e_with_macron => 0x0112,
  :latin_capital_letter_e_macron => 0x0112,
  :latin_small_letter_e_with_macron => 0x0113,
  :latin_small_letter_e_macron => 0x0113,
  :latin_capital_letter_e_with_breve => 0x0114,
  :latin_capital_letter_e_breve => 0x0114,
  :latin_small_letter_e_with_breve => 0x0115,
  :latin_small_letter_e_breve => 0x0115,
  :latin_capital_letter_e_with_dot_above => 0x0116,
  :latin_capital_letter_e_dot => 0x0116,
  :latin_small_letter_e_with_dot_above => 0x0117,
  :latin_small_letter_e_dot => 0x0117,
  :latin_capital_letter_e_with_ogonek => 0x0118,
  :latin_capital_letter_e_ogonek => 0x0118,
  :latin_small_letter_e_with_ogonek => 0x0119,
  :latin_small_letter_e_ogonek => 0x0119,
  :latin_capital_letter_e_with_caron => 0x011a,
  :latin_capital_letter_e_hacek => 0x011a,
  :latin_small_letter_e_with_caron => 0x011b,
  :latin_small_letter_e_hacek => 0x011b,
  :latin_capital_letter_g_with_circumflex => 0x011c,
  :latin_capital_letter_g_circumflex => 0x011c,
  :latin_small_letter_g_with_circumflex => 0x011d,
  :latin_small_letter_g_circumflex => 0x011d,
  :latin_capital_letter_g_with_breve => 0x011e,
  :latin_capital_letter_g_breve => 0x011e,
  :latin_small_letter_g_with_breve => 0x011f,
  :latin_small_letter_g_breve => 0x011f,
  :latin_capital_letter_g_with_dot_above => 0x0120,
  :latin_capital_letter_g_dot => 0x0120,
  :latin_small_letter_g_with_dot_above => 0x0121,
  :latin_small_letter_g_dot => 0x0121,
  :latin_capital_letter_g_with_cedilla => 0x0122,
  :latin_capital_letter_g_cedilla => 0x0122,
  :latin_small_letter_g_with_cedilla => 0x0123,
  :latin_small_letter_g_cedilla => 0x0123,
  :latin_capital_letter_h_with_circumflex => 0x0124,
  :latin_capital_letter_h_circumflex => 0x0124,
  :latin_small_letter_h_with_circumflex => 0x0125,
  :latin_small_letter_h_circumflex => 0x0125,
  :latin_capital_letter_h_with_stroke => 0x0126,
  :latin_capital_letter_h_bar => 0x0126,
  :latin_small_letter_h_with_stroke => 0x0127,
  :latin_small_letter_h_bar => 0x0127,
  :latin_capital_letter_i_with_tilde => 0x0128,
  :latin_capital_letter_i_tilde => 0x0128,
  :latin_small_letter_i_with_tilde => 0x0129,
  :latin_small_letter_i_tilde => 0x0129,
  :latin_capital_letter_i_with_macron => 0x012a,
  :latin_capital_letter_i_macron => 0x012a,
  :latin_small_letter_i_with_macron => 0x012b,
  :latin_small_letter_i_macron => 0x012b,
  :latin_capital_letter_i_with_breve => 0x012c,
  :latin_capital_letter_i_breve => 0x012c,
  :latin_small_letter_i_with_breve => 0x012d,
  :latin_small_letter_i_breve => 0x012d,
  :latin_capital_letter_i_with_ogonek => 0x012e,
  :latin_capital_letter_i_ogonek => 0x012e,
  :latin_small_letter_i_with_ogonek => 0x012f,
  :latin_small_letter_i_ogonek => 0x012f,
  :latin_capital_letter_i_with_dot_above => 0x0130,
  :latin_capital_letter_i_dot => 0x0130,
  :latin_small_letter_dotless_i => 0x0131,
  :latin_capital_ligature_ij => 0x0132,
  :latin_capital_letter_i_j => 0x0132,
  :latin_small_ligature_ij => 0x0133,
  :latin_small_letter_i_j => 0x0133,
  :latin_capital_letter_j_with_circumflex => 0x0134,
  :latin_capital_letter_j_circumflex => 0x0134,
  :latin_small_letter_j_with_circumflex => 0x0135,
  :latin_small_letter_j_circumflex => 0x0135,
  :latin_capital_letter_k_with_cedilla => 0x0136,
  :latin_capital_letter_k_cedilla => 0x0136,
  :latin_small_letter_k_with_cedilla => 0x0137,
  :latin_small_letter_k_cedilla => 0x0137,
  :latin_small_letter_kra => 0x0138,
  :latin_capital_letter_l_with_acute => 0x0139,
  :latin_capital_letter_l_acute => 0x0139,
  :latin_small_letter_l_with_acute => 0x013a,
  :latin_small_letter_l_acute => 0x013a,
  :latin_capital_letter_l_with_cedilla => 0x013b,
  :latin_capital_letter_l_cedilla => 0x013b,
  :latin_small_letter_l_with_cedilla => 0x013c,
  :latin_small_letter_l_cedilla => 0x013c,
  :latin_capital_letter_l_with_caron => 0x013d,
  :latin_capital_letter_l_hacek => 0x013d,
  :latin_small_letter_l_with_caron => 0x013e,
  :latin_small_letter_l_hacek => 0x013e,
  :latin_capital_letter_l_with_middle_dot => 0x013f,
  :latin_small_letter_l_with_middle_dot => 0x0140,
  :latin_capital_letter_l_with_stroke => 0x0141,
  :latin_capital_letter_l_slash => 0x0141,
  :latin_small_letter_l_with_stroke => 0x0142,
  :latin_small_letter_l_slash => 0x0142,
  :latin_capital_letter_n_with_acute => 0x0143,
  :latin_capital_letter_n_acute => 0x0143,
  :latin_small_letter_n_with_acute => 0x0144,
  :latin_small_letter_n_acute => 0x0144,
  :latin_capital_letter_n_with_cedilla => 0x0145,
  :latin_capital_letter_n_cedilla => 0x0145,
  :latin_small_letter_n_with_cedilla => 0x0146,
  :latin_small_letter_n_cedilla => 0x0146,
  :latin_capital_letter_n_with_caron => 0x0147,
  :latin_capital_letter_n_hacek => 0x0147,
  :latin_small_letter_n_with_caron => 0x0148,
  :latin_small_letter_n_hacek => 0x0148,
  :latin_small_letter_n_preceded_by_apostrophe => 0x0149,
  :latin_small_letter_apostrophe_n => 0x0149,
  :latin_capital_letter_eng => 0x014a,
  :latin_small_letter_eng => 0x014b,
  :latin_capital_letter_o_with_macron => 0x014c,
  :latin_capital_letter_o_macron => 0x014c,
  :latin_small_letter_o_with_macron => 0x014d,
  :latin_small_letter_o_macron => 0x014d,
  :latin_capital_letter_o_with_breve => 0x014e,
  :latin_capital_letter_o_breve => 0x014e,
  :latin_small_letter_o_with_breve => 0x014f,
  :latin_small_letter_o_breve => 0x014f,
  :latin_capital_letter_o_with_double_acute => 0x0150,
  :latin_capital_letter_o_double_acute => 0x0150,
  :latin_small_letter_o_with_double_acute => 0x0151,
  :latin_small_letter_o_double_acute => 0x0151,
  :latin_capital_ligature_oe => 0x0152,
  :latin_capital_letter_o_e => 0x0152,
  :latin_small_ligature_oe => 0x0153,
  :latin_small_letter_o_e => 0x0153,
  :latin_capital_letter_r_with_acute => 0x0154,
  :latin_capital_letter_r_acute => 0x0154,
  :latin_small_letter_r_with_acute => 0x0155,
  :latin_small_letter_r_acute => 0x0155,
  :latin_capital_letter_r_with_cedilla => 0x0156,
  :latin_capital_letter_r_cedilla => 0x0156,
  :latin_small_letter_r_with_cedilla => 0x0157,
  :latin_small_letter_r_cedilla => 0x0157,
  :latin_capital_letter_r_with_caron => 0x0158,
  :latin_capital_letter_r_hacek => 0x0158,
  :latin_small_letter_r_with_caron => 0x0159,
  :latin_small_letter_r_hacek => 0x0159,
  :latin_capital_letter_s_with_acute => 0x015a,
  :latin_capital_letter_s_acute => 0x015a,
  :latin_small_letter_s_with_acute => 0x015b,
  :latin_small_letter_s_acute => 0x015b,
  :latin_capital_letter_s_with_circumflex => 0x015c,
  :latin_capital_letter_s_circumflex => 0x015c,
  :latin_small_letter_s_with_circumflex => 0x015d,
  :latin_small_letter_s_circumflex => 0x015d,
  :latin_capital_letter_s_with_cedilla => 0x015e,
  :latin_capital_letter_s_cedilla => 0x015e,
  :latin_small_letter_s_with_cedilla => 0x015f,
  :latin_small_letter_s_cedilla => 0x015f,
  :latin_capital_letter_s_with_caron => 0x0160,
  :latin_capital_letter_s_hacek => 0x0160,
  :latin_small_letter_s_with_caron => 0x0161,
  :latin_small_letter_s_hacek => 0x0161,
  :latin_capital_letter_t_with_cedilla => 0x0162,
  :latin_capital_letter_t_cedilla => 0x0162,
  :latin_small_letter_t_with_cedilla => 0x0163,
  :latin_small_letter_t_cedilla => 0x0163,
  :latin_capital_letter_t_with_caron => 0x0164,
  :latin_capital_letter_t_hacek => 0x0164,
  :latin_small_letter_t_with_caron => 0x0165,
  :latin_small_letter_t_hacek => 0x0165,
  :latin_capital_letter_t_with_stroke => 0x0166,
  :latin_capital_letter_t_bar => 0x0166,
  :latin_small_letter_t_with_stroke => 0x0167,
  :latin_small_letter_t_bar => 0x0167,
  :latin_capital_letter_u_with_tilde => 0x0168,
  :latin_capital_letter_u_tilde => 0x0168,
  :latin_small_letter_u_with_tilde => 0x0169,
  :latin_small_letter_u_tilde => 0x0169,
  :latin_capital_letter_u_with_macron => 0x016a,
  :latin_capital_letter_u_macron => 0x016a,
  :latin_small_letter_u_with_macron => 0x016b,
  :latin_small_letter_u_macron => 0x016b,
  :latin_capital_letter_u_with_breve => 0x016c,
  :latin_capital_letter_u_breve => 0x016c,
  :latin_small_letter_u_with_breve => 0x016d,
  :latin_small_letter_u_breve => 0x016d,
  :latin_capital_letter_u_with_ring_above => 0x016e,
  :latin_capital_letter_u_ring => 0x016e,
  :latin_small_letter_u_with_ring_above => 0x016f,
  :latin_small_letter_u_ring => 0x016f,
  :latin_capital_letter_u_with_double_acute => 0x0170,
  :latin_capital_letter_u_double_acute => 0x0170,
  :latin_small_letter_u_with_double_acute => 0x0171,
  :latin_small_letter_u_double_acute => 0x0171,
  :latin_capital_letter_u_with_ogonek => 0x0172,
  :latin_capital_letter_u_ogonek => 0x0172,
  :latin_small_letter_u_with_ogonek => 0x0173,
  :latin_small_letter_u_ogonek => 0x0173,
  :latin_capital_letter_w_with_circumflex => 0x0174,
  :latin_capital_letter_w_circumflex => 0x0174,
  :latin_small_letter_w_with_circumflex => 0x0175,
  :latin_small_letter_w_circumflex => 0x0175,
  :latin_capital_letter_y_with_circumflex => 0x0176,
  :latin_capital_letter_y_circumflex => 0x0176,
  :latin_small_letter_y_with_circumflex => 0x0177,
  :latin_small_letter_y_circumflex => 0x0177,
  :latin_capital_letter_y_with_diaeresis => 0x0178,
  :latin_capital_letter_y_diaeresis => 0x0178,
  :latin_capital_letter_z_with_acute => 0x0179,
  :latin_capital_letter_z_acute => 0x0179,
  :latin_small_letter_z_with_acute => 0x017a,
  :latin_small_letter_z_acute => 0x017a,
  :latin_capital_letter_z_with_dot_above => 0x017b,
  :latin_capital_letter_z_dot => 0x017b,
  :latin_small_letter_z_with_dot_above => 0x017c,
  :latin_small_letter_z_dot => 0x017c,
  :latin_capital_letter_z_with_caron => 0x017d,
  :latin_capital_letter_z_hacek => 0x017d,
  :latin_small_letter_z_with_caron => 0x017e,
  :latin_small_letter_z_hacek => 0x017e,
  :latin_small_letter_long_s => 0x017f,
  :latin_small_letter_b_with_stroke => 0x0180,
  :latin_small_letter_b_bar => 0x0180,
  :latin_capital_letter_b_with_hook => 0x0181,
  :latin_capital_letter_b_hook => 0x0181,
  :latin_capital_letter_b_with_topbar => 0x0182,
  :latin_capital_letter_b_topbar => 0x0182,
  :latin_small_letter_b_with_topbar => 0x0183,
  :latin_small_letter_b_topbar => 0x0183,
  :latin_capital_letter_tone_six => 0x0184,
  :latin_small_letter_tone_six => 0x0185,
  :latin_capital_letter_open_o => 0x0186,
  :latin_capital_letter_c_with_hook => 0x0187,
  :latin_capital_letter_c_hook => 0x0187,
  :latin_small_letter_c_with_hook => 0x0188,
  :latin_small_letter_c_hook => 0x0188,
  :latin_capital_letter_african_d => 0x0189,
  :latin_capital_letter_d_with_hook => 0x018a,
  :latin_capital_letter_d_hook => 0x018a,
  :latin_capital_letter_d_with_topbar => 0x018b,
  :latin_capital_letter_d_topbar => 0x018b,
  :latin_small_letter_d_with_topbar => 0x018c,
  :latin_small_letter_d_topbar => 0x018c,
  :latin_small_letter_turned_delta => 0x018d,
  :latin_capital_letter_reversed_e => 0x018e,
  :latin_capital_letter_turned_e => 0x018e,
  :latin_capital_letter_schwa => 0x018f,
  :latin_capital_letter_open_e => 0x0190,
  :latin_capital_letter_epsilon => 0x0190,
  :latin_capital_letter_f_with_hook => 0x0191,
  :latin_capital_letter_f_hook => 0x0191,
  :latin_small_letter_f_with_hook => 0x0192,
  :latin_small_letter_script_f => 0x0192,
  :latin_capital_letter_g_with_hook => 0x0193,
  :latin_capital_letter_g_hook => 0x0193,
  :latin_capital_letter_gamma => 0x0194,
  :latin_small_letter_hv => 0x0195,
  :latin_small_letter_h_v => 0x0195,
  :latin_capital_letter_iota => 0x0196,
  :latin_capital_letter_i_with_stroke => 0x0197,
  :latin_capital_letter_barred_i => 0x0197,
  :latin_capital_letter_k_with_hook => 0x0198,
  :latin_capital_letter_k_hook => 0x0198,
  :latin_small_letter_k_with_hook => 0x0199,
  :latin_small_letter_k_hook => 0x0199,
  :latin_small_letter_l_with_bar => 0x019a,
  :latin_small_letter_barred_l => 0x019a,
  :latin_small_letter_lambda_with_stroke => 0x019b,
  :latin_small_letter_barred_lambda => 0x019b,
  :latin_capital_letter_turned_m => 0x019c,
  :latin_capital_letter_n_with_left_hook => 0x019d,
  :latin_capital_letter_n_hook => 0x019d,
  :latin_small_letter_n_with_long_right_leg => 0x019e,
  :latin_capital_letter_o_with_middle_tilde => 0x019f,
  :latin_capital_letter_barred_o => 0x019f,
  :latin_capital_letter_o_with_horn => 0x01a0,
  :latin_capital_letter_o_horn => 0x01a0,
  :latin_small_letter_o_with_horn => 0x01a1,
  :latin_small_letter_o_horn => 0x01a1,
  :latin_capital_letter_oi => 0x01a2,
  :latin_capital_letter_o_i => 0x01a2,
  :latin_small_letter_oi => 0x01a3,
  :latin_small_letter_o_i => 0x01a3,
  :latin_capital_letter_p_with_hook => 0x01a4,
  :latin_capital_letter_p_hook => 0x01a4,
  :latin_small_letter_p_with_hook => 0x01a5,
  :latin_small_letter_p_hook => 0x01a5,
  :latin_letter_yr => 0x01a6,
  :latin_letter_y_r => 0x01a6,
  :latin_capital_letter_tone_two => 0x01a7,
  :latin_small_letter_tone_two => 0x01a8,
  :latin_capital_letter_esh => 0x01a9,
  :latin_letter_reversed_esh_loop => 0x01aa,
  :latin_small_letter_t_with_palatal_hook => 0x01ab,
  :latin_small_letter_t_palatal_hook => 0x01ab,
  :latin_capital_letter_t_with_hook => 0x01ac,
  :latin_capital_letter_t_hook => 0x01ac,
  :latin_small_letter_t_with_hook => 0x01ad,
  :latin_small_letter_t_hook => 0x01ad,
  :latin_capital_letter_t_with_retroflex_hook => 0x01ae,
  :latin_capital_letter_t_retroflex_hook => 0x01ae,
  :latin_capital_letter_u_with_horn => 0x01af,
  :latin_capital_letter_u_horn => 0x01af,
  :latin_small_letter_u_with_horn => 0x01b0,
  :latin_small_letter_u_horn => 0x01b0,
  :latin_capital_letter_upsilon => 0x01b1,
  :latin_capital_letter_v_with_hook => 0x01b2,
  :latin_capital_letter_script_v => 0x01b2,
  :latin_capital_letter_y_with_hook => 0x01b3,
  :latin_capital_letter_y_hook => 0x01b3,
  :latin_small_letter_y_with_hook => 0x01b4,
  :latin_small_letter_y_hook => 0x01b4,
  :latin_capital_letter_z_with_stroke => 0x01b5,
  :latin_capital_letter_z_bar => 0x01b5,
  :latin_small_letter_z_with_stroke => 0x01b6,
  :latin_small_letter_z_bar => 0x01b6,
  :latin_capital_letter_ezh => 0x01b7,
  :latin_capital_letter_yogh => 0x01b7,
  :latin_capital_letter_ezh_reversed => 0x01b8,
  :latin_capital_letter_reversed_yogh => 0x01b8,
  :latin_small_letter_ezh_reversed => 0x01b9,
  :latin_small_letter_reversed_yogh => 0x01b9,
  :latin_small_letter_ezh_with_tail => 0x01ba,
  :latin_small_letter_yogh_with_tail => 0x01ba,
  :latin_letter_two_with_stroke => 0x01bb,
  :latin_letter_two_bar => 0x01bb,
  :latin_capital_letter_tone_five => 0x01bc,
  :latin_small_letter_tone_five => 0x01bd,
  :latin_letter_inverted_glottal_stop_with_stroke => 0x01be,
  :latin_letter_inverted_glottal_stop_bar => 0x01be,
  :latin_letter_wynn => 0x01bf,
  :latin_letter_dental_click => 0x01c0,
  :latin_letter_pipe => 0x01c0,
  :latin_letter_lateral_click => 0x01c1,
  :latin_letter_double_pipe => 0x01c1,
  :latin_letter_alveolar_click => 0x01c2,
  :latin_letter_pipe_double_bar => 0x01c2,
  :latin_letter_retroflex_click => 0x01c3,
  :latin_letter_exclamation_mark => 0x01c3,
  :latin_capital_letter_dz_with_caron => 0x01c4,
  :latin_capital_letter_d_z_hacek => 0x01c4,
  :latin_capital_letter_d_with_small_letter_z_with_caron => 0x01c5,
  :latin_letter_capital_d_small_z_hacek => 0x01c5,
  :latin_small_letter_dz_with_caron => 0x01c6,
  :latin_small_letter_d_z_hacek => 0x01c6,
  :latin_capital_letter_lj => 0x01c7,
  :latin_capital_letter_l_j => 0x01c7,
  :latin_capital_letter_l_with_small_letter_j => 0x01c8,
  :latin_letter_capital_l_small_j => 0x01c8,
  :latin_small_letter_lj => 0x01c9,
  :latin_small_letter_l_j => 0x01c9,
  :latin_capital_letter_nj => 0x01ca,
  :latin_capital_letter_n_j => 0x01ca,
  :latin_capital_letter_n_with_small_letter_j => 0x01cb,
  :latin_letter_capital_n_small_j => 0x01cb,
  :latin_small_letter_nj => 0x01cc,
  :latin_small_letter_n_j => 0x01cc,
  :latin_capital_letter_a_with_caron => 0x01cd,
  :latin_capital_letter_a_hacek => 0x01cd,
  :latin_small_letter_a_with_caron => 0x01ce,
  :latin_small_letter_a_hacek => 0x01ce,
  :latin_capital_letter_i_with_caron => 0x01cf,
  :latin_capital_letter_i_hacek => 0x01cf,
  :latin_small_letter_i_with_caron => 0x01d0,
  :latin_small_letter_i_hacek => 0x01d0,
  :latin_capital_letter_o_with_caron => 0x01d1,
  :latin_capital_letter_o_hacek => 0x01d1,
  :latin_small_letter_o_with_caron => 0x01d2,
  :latin_small_letter_o_hacek => 0x01d2,
  :latin_capital_letter_u_with_caron => 0x01d3,
  :latin_capital_letter_u_hacek => 0x01d3,
  :latin_small_letter_u_with_caron => 0x01d4,
  :latin_small_letter_u_hacek => 0x01d4,
  :latin_capital_letter_u_with_diaeresis_and_macron => 0x01d5,
  :latin_capital_letter_u_diaeresis_macron => 0x01d5,
  :latin_small_letter_u_with_diaeresis_and_macron => 0x01d6,
  :latin_small_letter_u_diaeresis_macron => 0x01d6,
  :latin_capital_letter_u_with_diaeresis_and_acute => 0x01d7,
  :latin_capital_letter_u_diaeresis_acute => 0x01d7,
  :latin_small_letter_u_with_diaeresis_and_acute => 0x01d8,
  :latin_small_letter_u_diaeresis_acute => 0x01d8,
  :latin_capital_letter_u_with_diaeresis_and_caron => 0x01d9,
  :latin_capital_letter_u_diaeresis_hacek => 0x01d9,
  :latin_small_letter_u_with_diaeresis_and_caron => 0x01da,
  :latin_small_letter_u_diaeresis_hacek => 0x01da,
  :latin_capital_letter_u_with_diaeresis_and_grave => 0x01db,
  :latin_capital_letter_u_diaeresis_grave => 0x01db,
  :latin_small_letter_u_with_diaeresis_and_grave => 0x01dc,
  :latin_small_letter_u_diaeresis_grave => 0x01dc,
  :latin_small_letter_turned_e => 0x01dd,
  :latin_capital_letter_a_with_diaeresis_and_macron => 0x01de,
  :latin_capital_letter_a_diaeresis_macron => 0x01de,
  :latin_small_letter_a_with_diaeresis_and_macron => 0x01df,
  :latin_small_letter_a_diaeresis_macron => 0x01df,
  :latin_capital_letter_a_with_dot_above_and_macron => 0x01e0,
  :latin_capital_letter_a_dot_macron => 0x01e0,
  :latin_small_letter_a_with_dot_above_and_macron => 0x01e1,
  :latin_small_letter_a_dot_macron => 0x01e1,
  :latin_capital_letter_ae_with_macron => 0x01e2,
  :latin_capital_letter_a_e_macron => 0x01e2,
  :latin_small_letter_ae_with_macron => 0x01e3,
  :latin_small_letter_a_e_macron => 0x01e3,
  :latin_capital_letter_g_with_stroke => 0x01e4,
  :latin_capital_letter_g_bar => 0x01e4,
  :latin_small_letter_g_with_stroke => 0x01e5,
  :latin_small_letter_g_bar => 0x01e5,
  :latin_capital_letter_g_with_caron => 0x01e6,
  :latin_capital_letter_g_hacek => 0x01e6,
  :latin_small_letter_g_with_caron => 0x01e7,
  :latin_small_letter_g_hacek => 0x01e7,
  :latin_capital_letter_k_with_caron => 0x01e8,
  :latin_capital_letter_k_hacek => 0x01e8,
  :latin_small_letter_k_with_caron => 0x01e9,
  :latin_small_letter_k_hacek => 0x01e9,
  :latin_capital_letter_o_with_ogonek => 0x01ea,
  :latin_capital_letter_o_ogonek => 0x01ea,
  :latin_small_letter_o_with_ogonek => 0x01eb,
  :latin_small_letter_o_ogonek => 0x01eb,
  :latin_capital_letter_o_with_ogonek_and_macron => 0x01ec,
  :latin_capital_letter_o_ogonek_macron => 0x01ec,
  :latin_small_letter_o_with_ogonek_and_macron => 0x01ed,
  :latin_small_letter_o_ogonek_macron => 0x01ed,
  :latin_capital_letter_ezh_with_caron => 0x01ee,
  :latin_capital_letter_yogh_hacek => 0x01ee,
  :latin_small_letter_ezh_with_caron => 0x01ef,
  :latin_small_letter_yogh_hacek => 0x01ef,
  :latin_small_letter_j_with_caron => 0x01f0,
  :latin_small_letter_j_hacek => 0x01f0,
  :latin_capital_letter_dz => 0x01f1,
  :latin_capital_letter_d_with_small_letter_z => 0x01f2,
  :latin_small_letter_dz => 0x01f3,
  :latin_capital_letter_g_with_acute => 0x01f4,
  :latin_small_letter_g_with_acute => 0x01f5,
  :latin_capital_letter_hwair => 0x01f6,
  :latin_capital_letter_wynn => 0x01f7,
  :latin_capital_letter_n_with_grave => 0x01f8,
  :latin_small_letter_n_with_grave => 0x01f9,
  :latin_capital_letter_a_with_ring_above_and_acute => 0x01fa,
  :latin_small_letter_a_with_ring_above_and_acute => 0x01fb,
  :latin_capital_letter_ae_with_acute => 0x01fc,
  :latin_small_letter_ae_with_acute => 0x01fd,
  :latin_capital_letter_o_with_stroke_and_acute => 0x01fe,
  :latin_small_letter_o_with_stroke_and_acute => 0x01ff,
  :latin_capital_letter_a_with_double_grave => 0x0200,
  :latin_small_letter_a_with_double_grave => 0x0201,
  :latin_capital_letter_a_with_inverted_breve => 0x0202,
  :latin_small_letter_a_with_inverted_breve => 0x0203,
  :latin_capital_letter_e_with_double_grave => 0x0204,
  :latin_small_letter_e_with_double_grave => 0x0205,
  :latin_capital_letter_e_with_inverted_breve => 0x0206,
  :latin_small_letter_e_with_inverted_breve => 0x0207,
  :latin_capital_letter_i_with_double_grave => 0x0208,
  :latin_small_letter_i_with_double_grave => 0x0209,
  :latin_capital_letter_i_with_inverted_breve => 0x020a,
  :latin_small_letter_i_with_inverted_breve => 0x020b,
  :latin_capital_letter_o_with_double_grave => 0x020c,
  :latin_small_letter_o_with_double_grave => 0x020d,
  :latin_capital_letter_o_with_inverted_breve => 0x020e,
  :latin_small_letter_o_with_inverted_breve => 0x020f,
  :latin_capital_letter_r_with_double_grave => 0x0210,
  :latin_small_letter_r_with_double_grave => 0x0211,
  :latin_capital_letter_r_with_inverted_breve => 0x0212,
  :latin_small_letter_r_with_inverted_breve => 0x0213,
  :latin_capital_letter_u_with_double_grave => 0x0214,
  :latin_small_letter_u_with_double_grave => 0x0215,
  :latin_capital_letter_u_with_inverted_breve => 0x0216,
  :latin_small_letter_u_with_inverted_breve => 0x0217,
  :latin_capital_letter_s_with_comma_below => 0x0218,
  :latin_small_letter_s_with_comma_below => 0x0219,
  :latin_capital_letter_t_with_comma_below => 0x021a,
  :latin_small_letter_t_with_comma_below => 0x021b,
  :latin_capital_letter_yogh => 0x021c,
  :latin_small_letter_yogh => 0x021d,
  :latin_capital_letter_h_with_caron => 0x021e,
  :latin_small_letter_h_with_caron => 0x021f,
  :latin_capital_letter_n_with_long_right_leg => 0x0220,
  :latin_small_letter_d_with_curl => 0x0221,
  :latin_capital_letter_ou => 0x0222,
  :latin_small_letter_ou => 0x0223,
  :latin_capital_letter_z_with_hook => 0x0224,
  :latin_small_letter_z_with_hook => 0x0225,
  :latin_capital_letter_a_with_dot_above => 0x0226,
  :latin_small_letter_a_with_dot_above => 0x0227,
  :latin_capital_letter_e_with_cedilla => 0x0228,
  :latin_small_letter_e_with_cedilla => 0x0229,
  :latin_capital_letter_o_with_diaeresis_and_macron => 0x022a,
  :latin_small_letter_o_with_diaeresis_and_macron => 0x022b,
  :latin_capital_letter_o_with_tilde_and_macron => 0x022c,
  :latin_small_letter_o_with_tilde_and_macron => 0x022d,
  :latin_capital_letter_o_with_dot_above => 0x022e,
  :latin_small_letter_o_with_dot_above => 0x022f,
  :latin_capital_letter_o_with_dot_above_and_macron => 0x0230,
  :latin_small_letter_o_with_dot_above_and_macron => 0x0231,
  :latin_capital_letter_y_with_macron => 0x0232,
  :latin_small_letter_y_with_macron => 0x0233,
  :latin_small_letter_l_with_curl => 0x0234,
  :latin_small_letter_n_with_curl => 0x0235,
  :latin_small_letter_t_with_curl => 0x0236,
  :latin_small_letter_dotless_j => 0x0237,
  :latin_small_letter_db_digraph => 0x0238,
  :latin_small_letter_qp_digraph => 0x0239,
  :latin_capital_letter_a_with_stroke => 0x023a,
  :latin_capital_letter_c_with_stroke => 0x023b,
  :latin_small_letter_c_with_stroke => 0x023c,
  :latin_capital_letter_l_with_bar => 0x023d,
  :latin_capital_letter_t_with_diagonal_stroke => 0x023e,
  :latin_small_letter_s_with_swash_tail => 0x023f,
  :latin_small_letter_z_with_swash_tail => 0x0240,
  :latin_capital_letter_glottal_stop => 0x0241,
  :latin_small_letter_turned_a => 0x0250,
  :latin_small_letter_alpha => 0x0251,
  :latin_small_letter_script_a => 0x0251,
  :latin_small_letter_turned_alpha => 0x0252,
  :latin_small_letter_turned_script_a => 0x0252,
  :latin_small_letter_b_with_hook => 0x0253,
  :latin_small_letter_b_hook => 0x0253,
  :latin_small_letter_open_o => 0x0254,
  :latin_small_letter_c_with_curl => 0x0255,
  :latin_small_letter_c_curl => 0x0255,
  :latin_small_letter_d_with_tail => 0x0256,
  :latin_small_letter_d_retroflex_hook => 0x0256,
  :latin_small_letter_d_with_hook => 0x0257,
  :latin_small_letter_d_hook => 0x0257,
  :latin_small_letter_reversed_e => 0x0258,
  :latin_small_letter_schwa => 0x0259,
  :latin_small_letter_schwa_with_hook => 0x025a,
  :latin_small_letter_schwa_hook => 0x025a,
  :latin_small_letter_open_e => 0x025b,
  :latin_small_letter_epsilon => 0x025b,
  :latin_small_letter_reversed_open_e => 0x025c,
  :latin_small_letter_reversed_epsilon => 0x025c,
  :latin_small_letter_reversed_open_e_with_hook => 0x025d,
  :latin_small_letter_reversed_epsilon_hook => 0x025d,
  :latin_small_letter_closed_reversed_open_e => 0x025e,
  :latin_small_letter_closed_reversed_epsilon => 0x025e,
  :latin_small_letter_dotless_j_with_stroke => 0x025f,
  :latin_small_letter_dotless_j_bar => 0x025f,
  :latin_small_letter_g_with_hook => 0x0260,
  :latin_small_letter_g_hook => 0x0260,
  :latin_small_letter_script_g => 0x0261,
  :latin_letter_small_capital_g => 0x0262,
  :latin_small_letter_gamma => 0x0263,
  :latin_small_letter_rams_horn => 0x0264,
  :latin_small_letter_baby_gamma => 0x0264,
  :latin_small_letter_turned_h => 0x0265,
  :latin_small_letter_h_with_hook => 0x0266,
  :latin_small_letter_h_hook => 0x0266,
  :latin_small_letter_heng_with_hook => 0x0267,
  :latin_small_letter_heng_hook => 0x0267,
  :latin_small_letter_i_with_stroke => 0x0268,
  :latin_small_letter_barred_i => 0x0268,
  :latin_small_letter_iota => 0x0269,
  :latin_letter_small_capital_i => 0x026a,
  :latin_small_letter_l_with_middle_tilde => 0x026b,
  :latin_small_letter_l_with_belt => 0x026c,
  :latin_small_letter_l_belt => 0x026c,
  :latin_small_letter_l_with_retroflex_hook => 0x026d,
  :latin_small_letter_l_retroflex_hook => 0x026d,
  :latin_small_letter_lezh => 0x026e,
  :latin_small_letter_l_yogh => 0x026e,
  :latin_small_letter_turned_m => 0x026f,
  :latin_small_letter_turned_m_with_long_leg => 0x0270,
  :latin_small_letter_m_with_hook => 0x0271,
  :latin_small_letter_m_hook => 0x0271,
  :latin_small_letter_n_with_left_hook => 0x0272,
  :latin_small_letter_n_hook => 0x0272,
  :latin_small_letter_n_with_retroflex_hook => 0x0273,
  :latin_small_letter_n_retroflex_hook => 0x0273,
  :latin_letter_small_capital_n => 0x0274,
  :latin_small_letter_barred_o => 0x0275,
  :latin_letter_small_capital_oe => 0x0276,
  :latin_letter_small_capital_o_e => 0x0276,
  :latin_small_letter_closed_omega => 0x0277,
  :latin_small_letter_phi => 0x0278,
  :latin_small_letter_turned_r => 0x0279,
  :latin_small_letter_turned_r_with_long_leg => 0x027a,
  :latin_small_letter_turned_r_with_hook => 0x027b,
  :latin_small_letter_turned_r_hook => 0x027b,
  :latin_small_letter_r_with_long_leg => 0x027c,
  :latin_small_letter_r_with_tail => 0x027d,
  :latin_small_letter_r_hook => 0x027d,
  :latin_small_letter_r_with_fishhook => 0x027e,
  :latin_small_letter_fishhook_r => 0x027e,
  :latin_small_letter_reversed_r_with_fishhook => 0x027f,
  :latin_small_letter_reversed_fishhook_r => 0x027f,
  :latin_letter_small_capital_r => 0x0280,
  :latin_letter_small_capital_inverted_r => 0x0281,
  :latin_small_letter_s_with_hook => 0x0282,
  :latin_small_letter_s_hook => 0x0282,
  :latin_small_letter_esh => 0x0283,
  :latin_small_letter_dotless_j_with_stroke_and_hook => 0x0284,
  :latin_small_letter_dotless_j_bar_hook => 0x0284,
  :latin_small_letter_squat_reversed_esh => 0x0285,
  :latin_small_letter_esh_with_curl => 0x0286,
  :latin_small_letter_esh_curl => 0x0286,
  :latin_small_letter_turned_t => 0x0287,
  :latin_small_letter_t_with_retroflex_hook => 0x0288,
  :latin_small_letter_t_retroflex_hook => 0x0288,
  :latin_small_letter_u_bar => 0x0289,
  :latin_small_letter_upsilon => 0x028a,
  :latin_small_letter_v_with_hook => 0x028b,
  :latin_small_letter_script_v => 0x028b,
  :latin_small_letter_turned_v => 0x028c,
  :latin_small_letter_turned_w => 0x028d,
  :latin_small_letter_turned_y => 0x028e,
  :latin_letter_small_capital_y => 0x028f,
  :latin_small_letter_z_with_retroflex_hook => 0x0290,
  :latin_small_letter_z_retroflex_hook => 0x0290,
  :latin_small_letter_z_with_curl => 0x0291,
  :latin_small_letter_z_curl => 0x0291,
  :latin_small_letter_ezh => 0x0292,
  :latin_small_letter_yogh => 0x0292,
  :latin_small_letter_ezh_with_curl => 0x0293,
  :latin_small_letter_yogh_curl => 0x0293,
  :latin_letter_glottal_stop => 0x0294,
  :latin_letter_pharyngeal_voiced_fricative => 0x0295,
  :latin_letter_reversed_glottal_stop => 0x0295,
  :latin_letter_inverted_glottal_stop => 0x0296,
  :latin_letter_stretched_c => 0x0297,
  :latin_letter_bilabial_click => 0x0298,
  :latin_letter_bullseye => 0x0298,
  :latin_letter_small_capital_b => 0x0299,
  :latin_small_letter_closed_open_e => 0x029a,
  :latin_small_letter_closed_epsilon => 0x029a,
  :latin_letter_small_capital_g_with_hook => 0x029b,
  :latin_letter_small_capital_g_hook => 0x029b,
  :latin_letter_small_capital_h => 0x029c,
  :latin_small_letter_j_with_crossed_tail => 0x029d,
  :latin_small_letter_crossed_tail_j => 0x029d,
  :latin_small_letter_turned_k => 0x029e,
  :latin_letter_small_capital_l => 0x029f,
  :latin_small_letter_q_with_hook => 0x02a0,
  :latin_small_letter_q_hook => 0x02a0,
  :latin_letter_glottal_stop_with_stroke => 0x02a1,
  :latin_letter_glottal_stop_bar => 0x02a1,
  :latin_letter_reversed_glottal_stop_with_stroke => 0x02a2,
  :latin_letter_reversed_glottal_stop_bar => 0x02a2,
  :latin_small_letter_dz_digraph => 0x02a3,
  :latin_small_letter_d_z => 0x02a3,
  :latin_small_letter_dezh_digraph => 0x02a4,
  :latin_small_letter_d_yogh => 0x02a4,
  :latin_small_letter_dz_digraph_with_curl => 0x02a5,
  :latin_small_letter_d_z_curl => 0x02a5,
  :latin_small_letter_ts_digraph => 0x02a6,
  :latin_small_letter_t_s => 0x02a6,
  :latin_small_letter_tesh_digraph => 0x02a7,
  :latin_small_letter_t_esh => 0x02a7,
  :latin_small_letter_tc_digraph_with_curl => 0x02a8,
  :latin_small_letter_t_c_curl => 0x02a8,
  :latin_small_letter_feng_digraph => 0x02a9,
  :latin_small_letter_ls_digraph => 0x02aa,
  :latin_small_letter_lz_digraph => 0x02ab,
  :latin_letter_bilabial_percussive => 0x02ac,
  :latin_letter_bidental_percussive => 0x02ad,
  :latin_small_letter_turned_h_with_fishhook => 0x02ae,
  :latin_small_letter_turned_h_with_fishhook_and_tail => 0x02af,
  :modifier_letter_small_h => 0x02b0,
  :modifier_letter_small_h_with_hook => 0x02b1,
  :modifier_letter_small_h_hook => 0x02b1,
  :modifier_letter_small_j => 0x02b2,
  :modifier_letter_small_r => 0x02b3,
  :modifier_letter_small_turned_r => 0x02b4,
  :modifier_letter_small_turned_r_with_hook => 0x02b5,
  :modifier_letter_small_turned_r_hook => 0x02b5,
  :modifier_letter_small_capital_inverted_r => 0x02b6,
  :modifier_letter_small_w => 0x02b7,
  :modifier_letter_small_y => 0x02b8,
  :modifier_letter_prime => 0x02b9,
  :modifier_letter_double_prime => 0x02ba,
  :modifier_letter_turned_comma => 0x02bb,
  :modifier_letter_apostrophe => 0x02bc,
  :modifier_letter_reversed_comma => 0x02bd,
  :modifier_letter_right_half_ring => 0x02be,
  :modifier_letter_left_half_ring => 0x02bf,
  :modifier_letter_glottal_stop => 0x02c0,
  :modifier_letter_reversed_glottal_stop => 0x02c1,
  :modifier_letter_left_arrowhead => 0x02c2,
  :modifier_letter_right_arrowhead => 0x02c3,
  :modifier_letter_up_arrowhead => 0x02c4,
  :modifier_letter_down_arrowhead => 0x02c5,
  :modifier_letter_circumflex_accent => 0x02c6,
  :modifier_letter_circumflex => 0x02c6,
  :caron => 0x02c7,
  :modifier_letter_hacek => 0x02c7,
  :modifier_letter_vertical_line => 0x02c8,
  :modifier_letter_macron => 0x02c9,
  :modifier_letter_acute_accent => 0x02ca,
  :modifier_letter_acute => 0x02ca,
  :modifier_letter_grave_accent => 0x02cb,
  :modifier_letter_grave => 0x02cb,
  :modifier_letter_low_vertical_line => 0x02cc,
  :modifier_letter_low_macron => 0x02cd,
  :modifier_letter_low_grave_accent => 0x02ce,
  :modifier_letter_low_grave => 0x02ce,
  :modifier_letter_low_acute_accent => 0x02cf,
  :modifier_letter_low_acute => 0x02cf,
  :modifier_letter_triangular_colon => 0x02d0,
  :modifier_letter_half_triangular_colon => 0x02d1,
  :modifier_letter_centred_right_half_ring => 0x02d2,
  :modifier_letter_centered_right_half_ring => 0x02d2,
  :modifier_letter_centred_left_half_ring => 0x02d3,
  :modifier_letter_centered_left_half_ring => 0x02d3,
  :modifier_letter_up_tack => 0x02d4,
  :modifier_letter_down_tack => 0x02d5,
  :modifier_letter_plus_sign => 0x02d6,
  :modifier_letter_minus_sign => 0x02d7,
  :breve => 0x02d8,
  :spacing_breve => 0x02d8,
  :dot_above => 0x02d9,
  :spacing_dot_above => 0x02d9,
  :ring_above => 0x02da,
  :spacing_ring_above => 0x02da,
  :ogonek => 0x02db,
  :spacing_ogonek => 0x02db,
  :small_tilde => 0x02dc,
  :spacing_tilde => 0x02dc,
  :double_acute_accent => 0x02dd,
  :spacing_double_acute => 0x02dd,
  :modifier_letter_rhotic_hook => 0x02de,
  :modifier_letter_cross_accent => 0x02df,
  :modifier_letter_small_gamma => 0x02e0,
  :modifier_letter_small_l => 0x02e1,
  :modifier_letter_small_s => 0x02e2,
  :modifier_letter_small_x => 0x02e3,
  :modifier_letter_small_reversed_glottal_stop => 0x02e4,
  :modifier_letter_extra_high_tone_bar => 0x02e5,
  :modifier_letter_high_tone_bar => 0x02e6,
  :modifier_letter_mid_tone_bar => 0x02e7,
  :modifier_letter_low_tone_bar => 0x02e8,
  :modifier_letter_extra_low_tone_bar => 0x02e9,
  :modifier_letter_yin_departing_tone_mark => 0x02ea,
  :modifier_letter_yang_departing_tone_mark => 0x02eb,
  :modifier_letter_voicing => 0x02ec,
  :modifier_letter_unaspirated => 0x02ed,
  :modifier_letter_double_apostrophe => 0x02ee,
  :modifier_letter_low_down_arrowhead => 0x02ef,
  :modifier_letter_low_up_arrowhead => 0x02f0,
  :modifier_letter_low_left_arrowhead => 0x02f1,
  :modifier_letter_low_right_arrowhead => 0x02f2,
  :modifier_letter_low_ring => 0x02f3,
  :modifier_letter_middle_grave_accent => 0x02f4,
  :modifier_letter_middle_double_grave_accent => 0x02f5,
  :modifier_letter_middle_double_acute_accent => 0x02f6,
  :modifier_letter_low_tilde => 0x02f7,
  :modifier_letter_raised_colon => 0x02f8,
  :modifier_letter_begin_high_tone => 0x02f9,
  :modifier_letter_end_high_tone => 0x02fa,
  :modifier_letter_begin_low_tone => 0x02fb,
  :modifier_letter_end_low_tone => 0x02fc,
  :modifier_letter_shelf => 0x02fd,
  :modifier_letter_open_shelf => 0x02fe,
  :modifier_letter_low_left_arrow => 0x02ff,
  :combining_grave_accent => 0x0300,
  :non_spacing_grave => 0x0300,
  :combining_acute_accent => 0x0301,
  :non_spacing_acute => 0x0301,
  :combining_circumflex_accent => 0x0302,
  :non_spacing_circumflex => 0x0302,
  :combining_tilde => 0x0303,
  :non_spacing_tilde => 0x0303,
  :combining_macron => 0x0304,
  :non_spacing_macron => 0x0304,
  :combining_overline => 0x0305,
  :non_spacing_overscore => 0x0305,
  :combining_breve => 0x0306,
  :non_spacing_breve => 0x0306,
  :combining_dot_above => 0x0307,
  :non_spacing_dot_above => 0x0307,
  :combining_diaeresis => 0x0308,
  :non_spacing_diaeresis => 0x0308,
  :combining_hook_above => 0x0309,
  :non_spacing_hook_above => 0x0309,
  :combining_ring_above => 0x030a,
  :non_spacing_ring_above => 0x030a,
  :combining_double_acute_accent => 0x030b,
  :non_spacing_double_acute => 0x030b,
  :combining_caron => 0x030c,
  :non_spacing_hacek => 0x030c,
  :combining_vertical_line_above => 0x030d,
  :non_spacing_vertical_line_above => 0x030d,
  :combining_double_vertical_line_above => 0x030e,
  :non_spacing_double_vertical_line_above => 0x030e,
  :combining_double_grave_accent => 0x030f,
  :non_spacing_double_grave => 0x030f,
  :combining_candrabindu => 0x0310,
  :non_spacing_candrabindu => 0x0310,
  :combining_inverted_breve => 0x0311,
  :non_spacing_inverted_breve => 0x0311,
  :combining_turned_comma_above => 0x0312,
  :non_spacing_turned_comma_above => 0x0312,
  :combining_comma_above => 0x0313,
  :non_spacing_comma_above => 0x0313,
  :combining_reversed_comma_above => 0x0314,
  :non_spacing_reversed_comma_above => 0x0314,
  :combining_comma_above_right => 0x0315,
  :non_spacing_comma_above_right => 0x0315,
  :combining_grave_accent_below => 0x0316,
  :non_spacing_grave_below => 0x0316,
  :combining_acute_accent_below => 0x0317,
  :non_spacing_acute_below => 0x0317,
  :combining_left_tack_below => 0x0318,
  :non_spacing_left_tack_below => 0x0318,
  :combining_right_tack_below => 0x0319,
  :non_spacing_right_tack_below => 0x0319,
  :combining_left_angle_above => 0x031a,
  :non_spacing_left_angle_above => 0x031a,
  :combining_horn => 0x031b,
  :non_spacing_horn => 0x031b,
  :combining_left_half_ring_below => 0x031c,
  :non_spacing_left_half_ring_below => 0x031c,
  :combining_up_tack_below => 0x031d,
  :non_spacing_up_tack_below => 0x031d,
  :combining_down_tack_below => 0x031e,
  :non_spacing_down_tack_below => 0x031e,
  :combining_plus_sign_below => 0x031f,
  :non_spacing_plus_sign_below => 0x031f,
  :combining_minus_sign_below => 0x0320,
  :non_spacing_minus_sign_below => 0x0320,
  :combining_palatalized_hook_below => 0x0321,
  :non_spacing_palatalized_hook_below => 0x0321,
  :combining_retroflex_hook_below => 0x0322,
  :non_spacing_retroflex_hook_below => 0x0322,
  :combining_dot_below => 0x0323,
  :non_spacing_dot_below => 0x0323,
  :combining_diaeresis_below => 0x0324,
  :non_spacing_double_dot_below => 0x0324,
  :combining_ring_below => 0x0325,
  :non_spacing_ring_below => 0x0325,
  :combining_comma_below => 0x0326,
  :non_spacing_comma_below => 0x0326,
  :combining_cedilla => 0x0327,
  :non_spacing_cedilla => 0x0327,
  :combining_ogonek => 0x0328,
  :non_spacing_ogonek => 0x0328,
  :combining_vertical_line_below => 0x0329,
  :non_spacing_vertical_line_below => 0x0329,
  :combining_bridge_below => 0x032a,
  :non_spacing_bridge_below => 0x032a,
  :combining_inverted_double_arch_below => 0x032b,
  :non_spacing_inverted_double_arch_below => 0x032b,
  :combining_caron_below => 0x032c,
  :non_spacing_hacek_below => 0x032c,
  :combining_circumflex_accent_below => 0x032d,
  :non_spacing_circumflex_below => 0x032d,
  :combining_breve_below => 0x032e,
  :non_spacing_breve_below => 0x032e,
  :combining_inverted_breve_below => 0x032f,
  :non_spacing_inverted_breve_below => 0x032f,
  :combining_tilde_below => 0x0330,
  :non_spacing_tilde_below => 0x0330,
  :combining_macron_below => 0x0331,
  :non_spacing_macron_below => 0x0331,
  :combining_low_line => 0x0332,
  :non_spacing_underscore => 0x0332,
  :combining_double_low_line => 0x0333,
  :non_spacing_double_underscore => 0x0333,
  :combining_tilde_overlay => 0x0334,
  :non_spacing_tilde_overlay => 0x0334,
  :combining_short_stroke_overlay => 0x0335,
  :non_spacing_short_bar_overlay => 0x0335,
  :combining_long_stroke_overlay => 0x0336,
  :non_spacing_long_bar_overlay => 0x0336,
  :combining_short_solidus_overlay => 0x0337,
  :non_spacing_short_slash_overlay => 0x0337,
  :combining_long_solidus_overlay => 0x0338,
  :non_spacing_long_slash_overlay => 0x0338,
  :combining_right_half_ring_below => 0x0339,
  :non_spacing_right_half_ring_below => 0x0339,
  :combining_inverted_bridge_below => 0x033a,
  :non_spacing_inverted_bridge_below => 0x033a,
  :combining_square_below => 0x033b,
  :non_spacing_square_below => 0x033b,
  :combining_seagull_below => 0x033c,
  :non_spacing_seagull_below => 0x033c,
  :combining_x_above => 0x033d,
  :non_spacing_x_above => 0x033d,
  :combining_vertical_tilde => 0x033e,
  :non_spacing_vertical_tilde => 0x033e,
  :combining_double_overline => 0x033f,
  :non_spacing_double_overscore => 0x033f,
  :combining_grave_tone_mark => 0x0340,
  :non_spacing_grave_tone_mark => 0x0340,
  :combining_acute_tone_mark => 0x0341,
  :non_spacing_acute_tone_mark => 0x0341,
  :combining_greek_perispomeni => 0x0342,
  :combining_greek_koronis => 0x0343,
  :combining_greek_dialytika_tonos => 0x0344,
  :greek_non_spacing_diaeresis_tonos => 0x0344,
  :combining_greek_ypogegrammeni => 0x0345,
  :greek_non_spacing_iota_below => 0x0345,
  :combining_bridge_above => 0x0346,
  :combining_equals_sign_below => 0x0347,
  :combining_double_vertical_line_below => 0x0348,
  :combining_left_angle_below => 0x0349,
  :combining_not_tilde_above => 0x034a,
  :combining_homothetic_above => 0x034b,
  :combining_almost_equal_to_above => 0x034c,
  :combining_left_right_arrow_below => 0x034d,
  :combining_upwards_arrow_below => 0x034e,
  :combining_grapheme_joiner => 0x034f,
  :combining_right_arrowhead_above => 0x0350,
  :combining_left_half_ring_above => 0x0351,
  :combining_fermata => 0x0352,
  :combining_x_below => 0x0353,
  :combining_left_arrowhead_below => 0x0354,
  :combining_right_arrowhead_below => 0x0355,
  :combining_right_arrowhead_and_up_arrowhead_below => 0x0356,
  :combining_right_half_ring_above => 0x0357,
  :combining_dot_above_right => 0x0358,
  :combining_asterisk_below => 0x0359,
  :combining_double_ring_below => 0x035a,
  :combining_zigzag_above => 0x035b,
  :combining_double_breve_below => 0x035c,
  :combining_double_breve => 0x035d,
  :combining_double_macron => 0x035e,
  :combining_double_macron_below => 0x035f,
  :combining_double_tilde => 0x0360,
  :combining_double_inverted_breve => 0x0361,
  :combining_double_rightwards_arrow_below => 0x0362,
  :combining_latin_small_letter_a => 0x0363,
  :combining_latin_small_letter_e => 0x0364,
  :combining_latin_small_letter_i => 0x0365,
  :combining_latin_small_letter_o => 0x0366,
  :combining_latin_small_letter_u => 0x0367,
  :combining_latin_small_letter_c => 0x0368,
  :combining_latin_small_letter_d => 0x0369,
  :combining_latin_small_letter_h => 0x036a,
  :combining_latin_small_letter_m => 0x036b,
  :combining_latin_small_letter_r => 0x036c,
  :combining_latin_small_letter_t => 0x036d,
  :combining_latin_small_letter_v => 0x036e,
  :combining_latin_small_letter_x => 0x036f,
  :greek_numeral_sign => 0x0374,
  :greek_upper_numeral_sign => 0x0374,
  :greek_lower_numeral_sign => 0x0375,
  :greek_ypogegrammeni => 0x037a,
  :greek_spacing_iota_below => 0x037a,
  :greek_question_mark => 0x037e,
  :greek_tonos => 0x0384,
  :greek_spacing_tonos => 0x0384,
  :greek_dialytika_tonos => 0x0385,
  :greek_spacing_diaeresis_tonos => 0x0385,
  :greek_capital_letter_alpha_with_tonos => 0x0386,
  :greek_capital_letter_alpha_tonos => 0x0386,
  :greek_ano_teleia => 0x0387,
  :greek_capital_letter_epsilon_with_tonos => 0x0388,
  :greek_capital_letter_epsilon_tonos => 0x0388,
  :greek_capital_letter_eta_with_tonos => 0x0389,
  :greek_capital_letter_eta_tonos => 0x0389,
  :greek_capital_letter_iota_with_tonos => 0x038a,
  :greek_capital_letter_iota_tonos => 0x038a,
  :greek_capital_letter_omicron_with_tonos => 0x038c,
  :greek_capital_letter_omicron_tonos => 0x038c,
  :greek_capital_letter_upsilon_with_tonos => 0x038e,
  :greek_capital_letter_upsilon_tonos => 0x038e,
  :greek_capital_letter_omega_with_tonos => 0x038f,
  :greek_capital_letter_omega_tonos => 0x038f,
  :greek_small_letter_iota_with_dialytika_and_tonos => 0x0390,
  :greek_small_letter_iota_diaeresis_tonos => 0x0390,
  :greek_capital_letter_alpha => 0x0391,
  :greek_capital_letter_beta => 0x0392,
  :greek_capital_letter_gamma => 0x0393,
  :greek_capital_letter_delta => 0x0394,
  :greek_capital_letter_epsilon => 0x0395,
  :greek_capital_letter_zeta => 0x0396,
  :greek_capital_letter_eta => 0x0397,
  :greek_capital_letter_theta => 0x0398,
  :greek_capital_letter_iota => 0x0399,
  :greek_capital_letter_kappa => 0x039a,
  :greek_capital_letter_lamda => 0x039b,
  :greek_capital_letter_lambda => 0x039b,
  :greek_capital_letter_mu => 0x039c,
  :greek_capital_letter_nu => 0x039d,
  :greek_capital_letter_xi => 0x039e,
  :greek_capital_letter_omicron => 0x039f,
  :greek_capital_letter_pi => 0x03a0,
  :greek_capital_letter_rho => 0x03a1,
  :greek_capital_letter_sigma => 0x03a3,
  :greek_capital_letter_tau => 0x03a4,
  :greek_capital_letter_upsilon => 0x03a5,
  :greek_capital_letter_phi => 0x03a6,
  :greek_capital_letter_chi => 0x03a7,
  :greek_capital_letter_psi => 0x03a8,
  :greek_capital_letter_omega => 0x03a9,
  :greek_capital_letter_iota_with_dialytika => 0x03aa,
  :greek_capital_letter_iota_diaeresis => 0x03aa,
  :greek_capital_letter_upsilon_with_dialytika => 0x03ab,
  :greek_capital_letter_upsilon_diaeresis => 0x03ab,
  :greek_small_letter_alpha_with_tonos => 0x03ac,
  :greek_small_letter_alpha_tonos => 0x03ac,
  :greek_small_letter_epsilon_with_tonos => 0x03ad,
  :greek_small_letter_epsilon_tonos => 0x03ad,
  :greek_small_letter_eta_with_tonos => 0x03ae,
  :greek_small_letter_eta_tonos => 0x03ae,
  :greek_small_letter_iota_with_tonos => 0x03af,
  :greek_small_letter_iota_tonos => 0x03af,
  :greek_small_letter_upsilon_with_dialytika_and_tonos => 0x03b0,
  :greek_small_letter_upsilon_diaeresis_tonos => 0x03b0,
  :greek_small_letter_alpha => 0x03b1,
  :greek_small_letter_beta => 0x03b2,
  :greek_small_letter_gamma => 0x03b3,
  :greek_small_letter_delta => 0x03b4,
  :greek_small_letter_epsilon => 0x03b5,
  :greek_small_letter_zeta => 0x03b6,
  :greek_small_letter_eta => 0x03b7,
  :greek_small_letter_theta => 0x03b8,
  :greek_small_letter_iota => 0x03b9,
  :greek_small_letter_kappa => 0x03ba,
  :greek_small_letter_lamda => 0x03bb,
  :greek_small_letter_lambda => 0x03bb,
  :greek_small_letter_mu => 0x03bc,
  :greek_small_letter_nu => 0x03bd,
  :greek_small_letter_xi => 0x03be,
  :greek_small_letter_omicron => 0x03bf,
  :greek_small_letter_pi => 0x03c0,
  :greek_small_letter_rho => 0x03c1,
  :greek_small_letter_final_sigma => 0x03c2,
  :greek_small_letter_sigma => 0x03c3,
  :greek_small_letter_tau => 0x03c4,
  :greek_small_letter_upsilon => 0x03c5,
  :greek_small_letter_phi => 0x03c6,
  :greek_small_letter_chi => 0x03c7,
  :greek_small_letter_psi => 0x03c8,
  :greek_small_letter_omega => 0x03c9,
  :greek_small_letter_iota_with_dialytika => 0x03ca,
  :greek_small_letter_iota_diaeresis => 0x03ca,
  :greek_small_letter_upsilon_with_dialytika => 0x03cb,
  :greek_small_letter_upsilon_diaeresis => 0x03cb,
  :greek_small_letter_omicron_with_tonos => 0x03cc,
  :greek_small_letter_omicron_tonos => 0x03cc,
  :greek_small_letter_upsilon_with_tonos => 0x03cd,
  :greek_small_letter_upsilon_tonos => 0x03cd,
  :greek_small_letter_omega_with_tonos => 0x03ce,
  :greek_small_letter_omega_tonos => 0x03ce,
  :greek_beta_symbol => 0x03d0,
  :greek_small_letter_curled_beta => 0x03d0,
  :greek_theta_symbol => 0x03d1,
  :greek_small_letter_script_theta => 0x03d1,
  :greek_upsilon_with_hook_symbol => 0x03d2,
  :greek_capital_letter_upsilon_hook => 0x03d2,
  :greek_upsilon_with_acute_and_hook_symbol => 0x03d3,
  :greek_capital_letter_upsilon_hook_tonos => 0x03d3,
  :greek_upsilon_with_diaeresis_and_hook_symbol => 0x03d4,
  :greek_capital_letter_upsilon_hook_diaeresis => 0x03d4,
  :greek_phi_symbol => 0x03d5,
  :greek_small_letter_script_phi => 0x03d5,
  :greek_pi_symbol => 0x03d6,
  :greek_small_letter_omega_pi => 0x03d6,
  :greek_kai_symbol => 0x03d7,
  :greek_letter_archaic_koppa => 0x03d8,
  :greek_small_letter_archaic_koppa => 0x03d9,
  :greek_letter_stigma => 0x03da,
  :greek_capital_letter_stigma => 0x03da,
  :greek_small_letter_stigma => 0x03db,
  :greek_letter_digamma => 0x03dc,
  :greek_capital_letter_digamma => 0x03dc,
  :greek_small_letter_digamma => 0x03dd,
  :greek_letter_koppa => 0x03de,
  :greek_capital_letter_koppa => 0x03de,
  :greek_small_letter_koppa => 0x03df,
  :greek_letter_sampi => 0x03e0,
  :greek_capital_letter_sampi => 0x03e0,
  :greek_small_letter_sampi => 0x03e1,
  :coptic_capital_letter_shei => 0x03e2,
  :greek_capital_letter_shei => 0x03e2,
  :coptic_small_letter_shei => 0x03e3,
  :greek_small_letter_shei => 0x03e3,
  :coptic_capital_letter_fei => 0x03e4,
  :greek_capital_letter_fei => 0x03e4,
  :coptic_small_letter_fei => 0x03e5,
  :greek_small_letter_fei => 0x03e5,
  :coptic_capital_letter_khei => 0x03e6,
  :greek_capital_letter_khei => 0x03e6,
  :coptic_small_letter_khei => 0x03e7,
  :greek_small_letter_khei => 0x03e7,
  :coptic_capital_letter_hori => 0x03e8,
  :greek_capital_letter_hori => 0x03e8,
  :coptic_small_letter_hori => 0x03e9,
  :greek_small_letter_hori => 0x03e9,
  :coptic_capital_letter_gangia => 0x03ea,
  :greek_capital_letter_gangia => 0x03ea,
  :coptic_small_letter_gangia => 0x03eb,
  :greek_small_letter_gangia => 0x03eb,
  :coptic_capital_letter_shima => 0x03ec,
  :greek_capital_letter_shima => 0x03ec,
  :coptic_small_letter_shima => 0x03ed,
  :greek_small_letter_shima => 0x03ed,
  :coptic_capital_letter_dei => 0x03ee,
  :greek_capital_letter_dei => 0x03ee,
  :coptic_small_letter_dei => 0x03ef,
  :greek_small_letter_dei => 0x03ef,
  :greek_kappa_symbol => 0x03f0,
  :greek_small_letter_script_kappa => 0x03f0,
  :greek_rho_symbol => 0x03f1,
  :greek_small_letter_tailed_rho => 0x03f1,
  :greek_lunate_sigma_symbol => 0x03f2,
  :greek_small_letter_lunate_sigma => 0x03f2,
  :greek_letter_yot => 0x03f3,
  :greek_capital_theta_symbol => 0x03f4,
  :greek_lunate_epsilon_symbol => 0x03f5,
  :greek_reversed_lunate_epsilon_symbol => 0x03f6,
  :greek_capital_letter_sho => 0x03f7,
  :greek_small_letter_sho => 0x03f8,
  :greek_capital_lunate_sigma_symbol => 0x03f9,
  :greek_capital_letter_san => 0x03fa,
  :greek_small_letter_san => 0x03fb,
  :greek_rho_with_stroke_symbol => 0x03fc,
  :greek_capital_reversed_lunate_sigma_symbol => 0x03fd,
  :greek_capital_dotted_lunate_sigma_symbol => 0x03fe,
  :greek_capital_reversed_dotted_lunate_sigma_symbol => 0x03ff,
  :cyrillic_capital_letter_ie_with_grave => 0x0400,
  :cyrillic_capital_letter_io => 0x0401,
  :cyrillic_capital_letter_dje => 0x0402,
  :cyrillic_capital_letter_gje => 0x0403,
  :cyrillic_capital_letter_ukrainian_ie => 0x0404,
  :cyrillic_capital_letter_e => 0x0404,
  :cyrillic_capital_letter_dze => 0x0405,
  :cyrillic_capital_letter_byelorussian_ukrainian_i => 0x0406,
  :cyrillic_capital_letter_i => 0x0406,
  :cyrillic_capital_letter_yi => 0x0407,
  :cyrillic_capital_letter_je => 0x0408,
  :cyrillic_capital_letter_lje => 0x0409,
  :cyrillic_capital_letter_nje => 0x040a,
  :cyrillic_capital_letter_tshe => 0x040b,
  :cyrillic_capital_letter_kje => 0x040c,
  :cyrillic_capital_letter_i_with_grave => 0x040d,
  :cyrillic_capital_letter_short_u => 0x040e,
  :cyrillic_capital_letter_dzhe => 0x040f,
  :cyrillic_capital_letter_a => 0x0410,
  :cyrillic_capital_letter_be => 0x0411,
  :cyrillic_capital_letter_ve => 0x0412,
  :cyrillic_capital_letter_ghe => 0x0413,
  :cyrillic_capital_letter_ge => 0x0413,
  :cyrillic_capital_letter_de => 0x0414,
  :cyrillic_capital_letter_ie => 0x0415,
  :cyrillic_capital_letter_zhe => 0x0416,
  :cyrillic_capital_letter_ze => 0x0417,
  :cyrillic_capital_letter_i => 0x0418,
  :cyrillic_capital_letter_ii => 0x0418,
  :cyrillic_capital_letter_short_i => 0x0419,
  :cyrillic_capital_letter_short_ii => 0x0419,
  :cyrillic_capital_letter_ka => 0x041a,
  :cyrillic_capital_letter_el => 0x041b,
  :cyrillic_capital_letter_em => 0x041c,
  :cyrillic_capital_letter_en => 0x041d,
  :cyrillic_capital_letter_o => 0x041e,
  :cyrillic_capital_letter_pe => 0x041f,
  :cyrillic_capital_letter_er => 0x0420,
  :cyrillic_capital_letter_es => 0x0421,
  :cyrillic_capital_letter_te => 0x0422,
  :cyrillic_capital_letter_u => 0x0423,
  :cyrillic_capital_letter_ef => 0x0424,
  :cyrillic_capital_letter_ha => 0x0425,
  :cyrillic_capital_letter_kha => 0x0425,
  :cyrillic_capital_letter_tse => 0x0426,
  :cyrillic_capital_letter_che => 0x0427,
  :cyrillic_capital_letter_sha => 0x0428,
  :cyrillic_capital_letter_shcha => 0x0429,
  :cyrillic_capital_letter_hard_sign => 0x042a,
  :cyrillic_capital_letter_yeru => 0x042b,
  :cyrillic_capital_letter_yeri => 0x042b,
  :cyrillic_capital_letter_soft_sign => 0x042c,
  :cyrillic_capital_letter_e => 0x042d,
  :cyrillic_capital_letter_reversed_e => 0x042d,
  :cyrillic_capital_letter_yu => 0x042e,
  :cyrillic_capital_letter_iu => 0x042e,
  :cyrillic_capital_letter_ya => 0x042f,
  :cyrillic_capital_letter_ia => 0x042f,
  :cyrillic_small_letter_a => 0x0430,
  :cyrillic_small_letter_be => 0x0431,
  :cyrillic_small_letter_ve => 0x0432,
  :cyrillic_small_letter_ghe => 0x0433,
  :cyrillic_small_letter_ge => 0x0433,
  :cyrillic_small_letter_de => 0x0434,
  :cyrillic_small_letter_ie => 0x0435,
  :cyrillic_small_letter_zhe => 0x0436,
  :cyrillic_small_letter_ze => 0x0437,
  :cyrillic_small_letter_i => 0x0438,
  :cyrillic_small_letter_ii => 0x0438,
  :cyrillic_small_letter_short_i => 0x0439,
  :cyrillic_small_letter_short_ii => 0x0439,
  :cyrillic_small_letter_ka => 0x043a,
  :cyrillic_small_letter_el => 0x043b,
  :cyrillic_small_letter_em => 0x043c,
  :cyrillic_small_letter_en => 0x043d,
  :cyrillic_small_letter_o => 0x043e,
  :cyrillic_small_letter_pe => 0x043f,
  :cyrillic_small_letter_er => 0x0440,
  :cyrillic_small_letter_es => 0x0441,
  :cyrillic_small_letter_te => 0x0442,
  :cyrillic_small_letter_u => 0x0443,
  :cyrillic_small_letter_ef => 0x0444,
  :cyrillic_small_letter_ha => 0x0445,
  :cyrillic_small_letter_kha => 0x0445,
  :cyrillic_small_letter_tse => 0x0446,
  :cyrillic_small_letter_che => 0x0447,
  :cyrillic_small_letter_sha => 0x0448,
  :cyrillic_small_letter_shcha => 0x0449,
  :cyrillic_small_letter_hard_sign => 0x044a,
  :cyrillic_small_letter_yeru => 0x044b,
  :cyrillic_small_letter_yeri => 0x044b,
  :cyrillic_small_letter_soft_sign => 0x044c,
  :cyrillic_small_letter_e => 0x044d,
  :cyrillic_small_letter_reversed_e => 0x044d,
  :cyrillic_small_letter_yu => 0x044e,
  :cyrillic_small_letter_iu => 0x044e,
  :cyrillic_small_letter_ya => 0x044f,
  :cyrillic_small_letter_ia => 0x044f,
  :cyrillic_small_letter_ie_with_grave => 0x0450,
  :cyrillic_small_letter_io => 0x0451,
  :cyrillic_small_letter_dje => 0x0452,
  :cyrillic_small_letter_gje => 0x0453,
  :cyrillic_small_letter_ukrainian_ie => 0x0454,
  :cyrillic_small_letter_e => 0x0454,
  :cyrillic_small_letter_dze => 0x0455,
  :cyrillic_small_letter_byelorussian_ukrainian_i => 0x0456,
  :cyrillic_small_letter_i => 0x0456,
  :cyrillic_small_letter_yi => 0x0457,
  :cyrillic_small_letter_je => 0x0458,
  :cyrillic_small_letter_lje => 0x0459,
  :cyrillic_small_letter_nje => 0x045a,
  :cyrillic_small_letter_tshe => 0x045b,
  :cyrillic_small_letter_kje => 0x045c,
  :cyrillic_small_letter_i_with_grave => 0x045d,
  :cyrillic_small_letter_short_u => 0x045e,
  :cyrillic_small_letter_dzhe => 0x045f,
  :cyrillic_capital_letter_omega => 0x0460,
  :cyrillic_small_letter_omega => 0x0461,
  :cyrillic_capital_letter_yat => 0x0462,
  :cyrillic_small_letter_yat => 0x0463,
  :cyrillic_capital_letter_iotified_e => 0x0464,
  :cyrillic_small_letter_iotified_e => 0x0465,
  :cyrillic_capital_letter_little_yus => 0x0466,
  :cyrillic_small_letter_little_yus => 0x0467,
  :cyrillic_capital_letter_iotified_little_yus => 0x0468,
  :cyrillic_small_letter_iotified_little_yus => 0x0469,
  :cyrillic_capital_letter_big_yus => 0x046a,
  :cyrillic_small_letter_big_yus => 0x046b,
  :cyrillic_capital_letter_iotified_big_yus => 0x046c,
  :cyrillic_small_letter_iotified_big_yus => 0x046d,
  :cyrillic_capital_letter_ksi => 0x046e,
  :cyrillic_small_letter_ksi => 0x046f,
  :cyrillic_capital_letter_psi => 0x0470,
  :cyrillic_small_letter_psi => 0x0471,
  :cyrillic_capital_letter_fita => 0x0472,
  :cyrillic_small_letter_fita => 0x0473,
  :cyrillic_capital_letter_izhitsa => 0x0474,
  :cyrillic_small_letter_izhitsa => 0x0475,
  :cyrillic_capital_letter_izhitsa_with_double_grave_accent => 0x0476,
  :cyrillic_capital_letter_izhitsa_double_grave => 0x0476,
  :cyrillic_small_letter_izhitsa_with_double_grave_accent => 0x0477,
  :cyrillic_small_letter_izhitsa_double_grave => 0x0477,
  :cyrillic_capital_letter_uk => 0x0478,
  :cyrillic_capital_letter_uk_digraph => 0x0478,
  :cyrillic_small_letter_uk => 0x0479,
  :cyrillic_small_letter_uk_digraph => 0x0479,
  :cyrillic_capital_letter_round_omega => 0x047a,
  :cyrillic_small_letter_round_omega => 0x047b,
  :cyrillic_capital_letter_omega_with_titlo => 0x047c,
  :cyrillic_capital_letter_omega_titlo => 0x047c,
  :cyrillic_small_letter_omega_with_titlo => 0x047d,
  :cyrillic_small_letter_omega_titlo => 0x047d,
  :cyrillic_capital_letter_ot => 0x047e,
  :cyrillic_small_letter_ot => 0x047f,
  :cyrillic_capital_letter_koppa => 0x0480,
  :cyrillic_small_letter_koppa => 0x0481,
  :cyrillic_thousands_sign => 0x0482,
  :combining_cyrillic_titlo => 0x0483,
  :cyrillic_non_spacing_titlo => 0x0483,
  :combining_cyrillic_palatalization => 0x0484,
  :cyrillic_non_spacing_palatalization => 0x0484,
  :combining_cyrillic_dasia_pneumata => 0x0485,
  :cyrillic_non_spacing_dasia_pneumata => 0x0485,
  :combining_cyrillic_psili_pneumata => 0x0486,
  :cyrillic_non_spacing_psili_pneumata => 0x0486,
  :combining_cyrillic_hundred_thousands_sign => 0x0488,
  :combining_cyrillic_millions_sign => 0x0489,
  :cyrillic_capital_letter_short_i_with_tail => 0x048a,
  :cyrillic_small_letter_short_i_with_tail => 0x048b,
  :cyrillic_capital_letter_semisoft_sign => 0x048c,
  :cyrillic_small_letter_semisoft_sign => 0x048d,
  :cyrillic_capital_letter_er_with_tick => 0x048e,
  :cyrillic_small_letter_er_with_tick => 0x048f,
  :cyrillic_capital_letter_ghe_with_upturn => 0x0490,
  :cyrillic_capital_letter_ge_with_upturn => 0x0490,
  :cyrillic_small_letter_ghe_with_upturn => 0x0491,
  :cyrillic_small_letter_ge_with_upturn => 0x0491,
  :cyrillic_capital_letter_ghe_with_stroke => 0x0492,
  :cyrillic_capital_letter_ge_bar => 0x0492,
  :cyrillic_small_letter_ghe_with_stroke => 0x0493,
  :cyrillic_small_letter_ge_bar => 0x0493,
  :cyrillic_capital_letter_ghe_with_middle_hook => 0x0494,
  :cyrillic_capital_letter_ge_hook => 0x0494,
  :cyrillic_small_letter_ghe_with_middle_hook => 0x0495,
  :cyrillic_small_letter_ge_hook => 0x0495,
  :cyrillic_capital_letter_zhe_with_descender => 0x0496,
  :cyrillic_capital_letter_zhe_with_right_descender => 0x0496,
  :cyrillic_small_letter_zhe_with_descender => 0x0497,
  :cyrillic_small_letter_zhe_with_right_descender => 0x0497,
  :cyrillic_capital_letter_ze_with_descender => 0x0498,
  :cyrillic_capital_letter_ze_cedilla => 0x0498,
  :cyrillic_small_letter_ze_with_descender => 0x0499,
  :cyrillic_small_letter_ze_cedilla => 0x0499,
  :cyrillic_capital_letter_ka_with_descender => 0x049a,
  :cyrillic_capital_letter_ka_with_right_descender => 0x049a,
  :cyrillic_small_letter_ka_with_descender => 0x049b,
  :cyrillic_small_letter_ka_with_right_descender => 0x049b,
  :cyrillic_capital_letter_ka_with_vertical_stroke => 0x049c,
  :cyrillic_capital_letter_ka_vertical_bar => 0x049c,
  :cyrillic_small_letter_ka_with_vertical_stroke => 0x049d,
  :cyrillic_small_letter_ka_vertical_bar => 0x049d,
  :cyrillic_capital_letter_ka_with_stroke => 0x049e,
  :cyrillic_capital_letter_ka_bar => 0x049e,
  :cyrillic_small_letter_ka_with_stroke => 0x049f,
  :cyrillic_small_letter_ka_bar => 0x049f,
  :cyrillic_capital_letter_bashkir_ka => 0x04a0,
  :cyrillic_capital_letter_reversed_ge_ka => 0x04a0,
  :cyrillic_small_letter_bashkir_ka => 0x04a1,
  :cyrillic_small_letter_reversed_ge_ka => 0x04a1,
  :cyrillic_capital_letter_en_with_descender => 0x04a2,
  :cyrillic_capital_letter_en_with_right_descender => 0x04a2,
  :cyrillic_small_letter_en_with_descender => 0x04a3,
  :cyrillic_small_letter_en_with_right_descender => 0x04a3,
  :cyrillic_capital_ligature_en_ghe => 0x04a4,
  :cyrillic_capital_letter_en_ge => 0x04a4,
  :cyrillic_small_ligature_en_ghe => 0x04a5,
  :cyrillic_small_letter_en_ge => 0x04a5,
  :cyrillic_capital_letter_pe_with_middle_hook => 0x04a6,
  :cyrillic_capital_letter_pe_hook => 0x04a6,
  :cyrillic_small_letter_pe_with_middle_hook => 0x04a7,
  :cyrillic_small_letter_pe_hook => 0x04a7,
  :cyrillic_capital_letter_abkhasian_ha => 0x04a8,
  :cyrillic_capital_letter_o_hook => 0x04a8,
  :cyrillic_small_letter_abkhasian_ha => 0x04a9,
  :cyrillic_small_letter_o_hook => 0x04a9,
  :cyrillic_capital_letter_es_with_descender => 0x04aa,
  :cyrillic_capital_letter_es_cedilla => 0x04aa,
  :cyrillic_small_letter_es_with_descender => 0x04ab,
  :cyrillic_small_letter_es_cedilla => 0x04ab,
  :cyrillic_capital_letter_te_with_descender => 0x04ac,
  :cyrillic_capital_letter_te_with_right_descender => 0x04ac,
  :cyrillic_small_letter_te_with_descender => 0x04ad,
  :cyrillic_small_letter_te_with_right_descender => 0x04ad,
  :cyrillic_capital_letter_straight_u => 0x04ae,
  :cyrillic_small_letter_straight_u => 0x04af,
  :cyrillic_capital_letter_straight_u_with_stroke => 0x04b0,
  :cyrillic_capital_letter_straight_u_bar => 0x04b0,
  :cyrillic_small_letter_straight_u_with_stroke => 0x04b1,
  :cyrillic_small_letter_straight_u_bar => 0x04b1,
  :cyrillic_capital_letter_ha_with_descender => 0x04b2,
  :cyrillic_capital_letter_kha_with_right_descender => 0x04b2,
  :cyrillic_small_letter_ha_with_descender => 0x04b3,
  :cyrillic_small_letter_kha_with_right_descender => 0x04b3,
  :cyrillic_capital_ligature_te_tse => 0x04b4,
  :cyrillic_capital_letter_te_tse => 0x04b4,
  :cyrillic_small_ligature_te_tse => 0x04b5,
  :cyrillic_small_letter_te_tse => 0x04b5,
  :cyrillic_capital_letter_che_with_descender => 0x04b6,
  :cyrillic_capital_letter_che_with_right_descender => 0x04b6,
  :cyrillic_small_letter_che_with_descender => 0x04b7,
  :cyrillic_small_letter_che_with_right_descender => 0x04b7,
  :cyrillic_capital_letter_che_with_vertical_stroke => 0x04b8,
  :cyrillic_capital_letter_che_vertical_bar => 0x04b8,
  :cyrillic_small_letter_che_with_vertical_stroke => 0x04b9,
  :cyrillic_small_letter_che_vertical_bar => 0x04b9,
  :cyrillic_capital_letter_shha => 0x04ba,
  :cyrillic_capital_letter_h => 0x04ba,
  :cyrillic_small_letter_shha => 0x04bb,
  :cyrillic_small_letter_h => 0x04bb,
  :cyrillic_capital_letter_abkhasian_che => 0x04bc,
  :cyrillic_capital_letter_ie_hook => 0x04bc,
  :cyrillic_small_letter_abkhasian_che => 0x04bd,
  :cyrillic_small_letter_ie_hook => 0x04bd,
  :cyrillic_capital_letter_abkhasian_che_with_descender => 0x04be,
  :cyrillic_capital_letter_ie_hook_ogonek => 0x04be,
  :cyrillic_small_letter_abkhasian_che_with_descender => 0x04bf,
  :cyrillic_small_letter_ie_hook_ogonek => 0x04bf,
  :cyrillic_letter_palochka => 0x04c0,
  :cyrillic_letter_i => 0x04c0,
  :cyrillic_capital_letter_zhe_with_breve => 0x04c1,
  :cyrillic_capital_letter_short_zhe => 0x04c1,
  :cyrillic_small_letter_zhe_with_breve => 0x04c2,
  :cyrillic_small_letter_short_zhe => 0x04c2,
  :cyrillic_capital_letter_ka_with_hook => 0x04c3,
  :cyrillic_capital_letter_ka_hook => 0x04c3,
  :cyrillic_small_letter_ka_with_hook => 0x04c4,
  :cyrillic_small_letter_ka_hook => 0x04c4,
  :cyrillic_capital_letter_el_with_tail => 0x04c5,
  :cyrillic_small_letter_el_with_tail => 0x04c6,
  :cyrillic_capital_letter_en_with_hook => 0x04c7,
  :cyrillic_capital_letter_en_hook => 0x04c7,
  :cyrillic_small_letter_en_with_hook => 0x04c8,
  :cyrillic_small_letter_en_hook => 0x04c8,
  :cyrillic_capital_letter_en_with_tail => 0x04c9,
  :cyrillic_small_letter_en_with_tail => 0x04ca,
  :cyrillic_capital_letter_khakassian_che => 0x04cb,
  :cyrillic_capital_letter_che_with_left_descender => 0x04cb,
  :cyrillic_small_letter_khakassian_che => 0x04cc,
  :cyrillic_small_letter_che_with_left_descender => 0x04cc,
  :cyrillic_capital_letter_em_with_tail => 0x04cd,
  :cyrillic_small_letter_em_with_tail => 0x04ce,
  :cyrillic_capital_letter_a_with_breve => 0x04d0,
  :cyrillic_small_letter_a_with_breve => 0x04d1,
  :cyrillic_capital_letter_a_with_diaeresis => 0x04d2,
  :cyrillic_small_letter_a_with_diaeresis => 0x04d3,
  :cyrillic_capital_ligature_a_ie => 0x04d4,
  :cyrillic_small_ligature_a_ie => 0x04d5,
  :cyrillic_capital_letter_ie_with_breve => 0x04d6,
  :cyrillic_small_letter_ie_with_breve => 0x04d7,
  :cyrillic_capital_letter_schwa => 0x04d8,
  :cyrillic_small_letter_schwa => 0x04d9,
  :cyrillic_capital_letter_schwa_with_diaeresis => 0x04da,
  :cyrillic_small_letter_schwa_with_diaeresis => 0x04db,
  :cyrillic_capital_letter_zhe_with_diaeresis => 0x04dc,
  :cyrillic_small_letter_zhe_with_diaeresis => 0x04dd,
  :cyrillic_capital_letter_ze_with_diaeresis => 0x04de,
  :cyrillic_small_letter_ze_with_diaeresis => 0x04df,
  :cyrillic_capital_letter_abkhasian_dze => 0x04e0,
  :cyrillic_small_letter_abkhasian_dze => 0x04e1,
  :cyrillic_capital_letter_i_with_macron => 0x04e2,
  :cyrillic_small_letter_i_with_macron => 0x04e3,
  :cyrillic_capital_letter_i_with_diaeresis => 0x04e4,
  :cyrillic_small_letter_i_with_diaeresis => 0x04e5,
  :cyrillic_capital_letter_o_with_diaeresis => 0x04e6,
  :cyrillic_small_letter_o_with_diaeresis => 0x04e7,
  :cyrillic_capital_letter_barred_o => 0x04e8,
  :cyrillic_small_letter_barred_o => 0x04e9,
  :cyrillic_capital_letter_barred_o_with_diaeresis => 0x04ea,
  :cyrillic_small_letter_barred_o_with_diaeresis => 0x04eb,
  :cyrillic_capital_letter_e_with_diaeresis => 0x04ec,
  :cyrillic_small_letter_e_with_diaeresis => 0x04ed,
  :cyrillic_capital_letter_u_with_macron => 0x04ee,
  :cyrillic_small_letter_u_with_macron => 0x04ef,
  :cyrillic_capital_letter_u_with_diaeresis => 0x04f0,
  :cyrillic_small_letter_u_with_diaeresis => 0x04f1,
  :cyrillic_capital_letter_u_with_double_acute => 0x04f2,
  :cyrillic_small_letter_u_with_double_acute => 0x04f3,
  :cyrillic_capital_letter_che_with_diaeresis => 0x04f4,
  :cyrillic_small_letter_che_with_diaeresis => 0x04f5,
  :cyrillic_capital_letter_ghe_with_descender => 0x04f6,
  :cyrillic_small_letter_ghe_with_descender => 0x04f7,
  :cyrillic_capital_letter_yeru_with_diaeresis => 0x04f8,
  :cyrillic_small_letter_yeru_with_diaeresis => 0x04f9,
  :cyrillic_capital_letter_komi_de => 0x0500,
  :cyrillic_small_letter_komi_de => 0x0501,
  :cyrillic_capital_letter_komi_dje => 0x0502,
  :cyrillic_small_letter_komi_dje => 0x0503,
  :cyrillic_capital_letter_komi_zje => 0x0504,
  :cyrillic_small_letter_komi_zje => 0x0505,
  :cyrillic_capital_letter_komi_dzje => 0x0506,
  :cyrillic_small_letter_komi_dzje => 0x0507,
  :cyrillic_capital_letter_komi_lje => 0x0508,
  :cyrillic_small_letter_komi_lje => 0x0509,
  :cyrillic_capital_letter_komi_nje => 0x050a,
  :cyrillic_small_letter_komi_nje => 0x050b,
  :cyrillic_capital_letter_komi_sje => 0x050c,
  :cyrillic_small_letter_komi_sje => 0x050d,
  :cyrillic_capital_letter_komi_tje => 0x050e,
  :cyrillic_small_letter_komi_tje => 0x050f,
  :armenian_capital_letter_ayb => 0x0531,
  :armenian_capital_letter_ben => 0x0532,
  :armenian_capital_letter_gim => 0x0533,
  :armenian_capital_letter_da => 0x0534,
  :armenian_capital_letter_ech => 0x0535,
  :armenian_capital_letter_za => 0x0536,
  :armenian_capital_letter_eh => 0x0537,
  :armenian_capital_letter_et => 0x0538,
  :armenian_capital_letter_to => 0x0539,
  :armenian_capital_letter_zhe => 0x053a,
  :armenian_capital_letter_ini => 0x053b,
  :armenian_capital_letter_liwn => 0x053c,
  :armenian_capital_letter_xeh => 0x053d,
  :armenian_capital_letter_ca => 0x053e,
  :armenian_capital_letter_ken => 0x053f,
  :armenian_capital_letter_ho => 0x0540,
  :armenian_capital_letter_ja => 0x0541,
  :armenian_capital_letter_ghad => 0x0542,
  :armenian_capital_letter_lad => 0x0542,
  :armenian_capital_letter_cheh => 0x0543,
  :armenian_capital_letter_men => 0x0544,
  :armenian_capital_letter_yi => 0x0545,
  :armenian_capital_letter_now => 0x0546,
  :armenian_capital_letter_sha => 0x0547,
  :armenian_capital_letter_vo => 0x0548,
  :armenian_capital_letter_cha => 0x0549,
  :armenian_capital_letter_peh => 0x054a,
  :armenian_capital_letter_jheh => 0x054b,
  :armenian_capital_letter_ra => 0x054c,
  :armenian_capital_letter_seh => 0x054d,
  :armenian_capital_letter_vew => 0x054e,
  :armenian_capital_letter_tiwn => 0x054f,
  :armenian_capital_letter_reh => 0x0550,
  :armenian_capital_letter_co => 0x0551,
  :armenian_capital_letter_yiwn => 0x0552,
  :armenian_capital_letter_piwr => 0x0553,
  :armenian_capital_letter_keh => 0x0554,
  :armenian_capital_letter_oh => 0x0555,
  :armenian_capital_letter_feh => 0x0556,
  :armenian_modifier_letter_left_half_ring => 0x0559,
  :armenian_apostrophe => 0x055a,
  :armenian_modifier_letter_right_half_ring => 0x055a,
  :armenian_emphasis_mark => 0x055b,
  :armenian_exclamation_mark => 0x055c,
  :armenian_comma => 0x055d,
  :armenian_question_mark => 0x055e,
  :armenian_abbreviation_mark => 0x055f,
  :armenian_small_letter_ayb => 0x0561,
  :armenian_small_letter_ben => 0x0562,
  :armenian_small_letter_gim => 0x0563,
  :armenian_small_letter_da => 0x0564,
  :armenian_small_letter_ech => 0x0565,
  :armenian_small_letter_za => 0x0566,
  :armenian_small_letter_eh => 0x0567,
  :armenian_small_letter_et => 0x0568,
  :armenian_small_letter_to => 0x0569,
  :armenian_small_letter_zhe => 0x056a,
  :armenian_small_letter_ini => 0x056b,
  :armenian_small_letter_liwn => 0x056c,
  :armenian_small_letter_xeh => 0x056d,
  :armenian_small_letter_ca => 0x056e,
  :armenian_small_letter_ken => 0x056f,
  :armenian_small_letter_ho => 0x0570,
  :armenian_small_letter_ja => 0x0571,
  :armenian_small_letter_ghad => 0x0572,
  :armenian_small_letter_lad => 0x0572,
  :armenian_small_letter_cheh => 0x0573,
  :armenian_small_letter_men => 0x0574,
  :armenian_small_letter_yi => 0x0575,
  :armenian_small_letter_now => 0x0576,
  :armenian_small_letter_sha => 0x0577,
  :armenian_small_letter_vo => 0x0578,
  :armenian_small_letter_cha => 0x0579,
  :armenian_small_letter_peh => 0x057a,
  :armenian_small_letter_jheh => 0x057b,
  :armenian_small_letter_ra => 0x057c,
  :armenian_small_letter_seh => 0x057d,
  :armenian_small_letter_vew => 0x057e,
  :armenian_small_letter_tiwn => 0x057f,
  :armenian_small_letter_reh => 0x0580,
  :armenian_small_letter_co => 0x0581,
  :armenian_small_letter_yiwn => 0x0582,
  :armenian_small_letter_piwr => 0x0583,
  :armenian_small_letter_keh => 0x0584,
  :armenian_small_letter_oh => 0x0585,
  :armenian_small_letter_feh => 0x0586,
  :armenian_small_ligature_ech_yiwn => 0x0587,
  :armenian_full_stop => 0x0589,
  :armenian_period => 0x0589,
  :armenian_hyphen => 0x058a,
  :hebrew_accent_etnahta => 0x0591,
  :hebrew_accent_segol => 0x0592,
  :hebrew_accent_shalshelet => 0x0593,
  :hebrew_accent_zaqef_qatan => 0x0594,
  :hebrew_accent_zaqef_gadol => 0x0595,
  :hebrew_accent_tipeha => 0x0596,
  :hebrew_accent_revia => 0x0597,
  :hebrew_accent_zarqa => 0x0598,
  :hebrew_accent_pashta => 0x0599,
  :hebrew_accent_yetiv => 0x059a,
  :hebrew_accent_tevir => 0x059b,
  :hebrew_accent_geresh => 0x059c,
  :hebrew_accent_geresh_muqdam => 0x059d,
  :hebrew_accent_gershayim => 0x059e,
  :hebrew_accent_qarney_para => 0x059f,
  :hebrew_accent_telisha_gedola => 0x05a0,
  :hebrew_accent_pazer => 0x05a1,
  :hebrew_accent_atnah_hafukh => 0x05a2,
  :hebrew_accent_munah => 0x05a3,
  :hebrew_accent_mahapakh => 0x05a4,
  :hebrew_accent_merkha => 0x05a5,
  :hebrew_accent_merkha_kefula => 0x05a6,
  :hebrew_accent_darga => 0x05a7,
  :hebrew_accent_qadma => 0x05a8,
  :hebrew_accent_telisha_qetana => 0x05a9,
  :hebrew_accent_yerah_ben_yomo => 0x05aa,
  :hebrew_accent_ole => 0x05ab,
  :hebrew_accent_iluy => 0x05ac,
  :hebrew_accent_dehi => 0x05ad,
  :hebrew_accent_zinor => 0x05ae,
  :hebrew_mark_masora_circle => 0x05af,
  :hebrew_point_sheva => 0x05b0,
  :hebrew_point_hataf_segol => 0x05b1,
  :hebrew_point_hataf_patah => 0x05b2,
  :hebrew_point_hataf_qamats => 0x05b3,
  :hebrew_point_hiriq => 0x05b4,
  :hebrew_point_tsere => 0x05b5,
  :hebrew_point_segol => 0x05b6,
  :hebrew_point_patah => 0x05b7,
  :hebrew_point_qamats => 0x05b8,
  :hebrew_point_holam => 0x05b9,
  :hebrew_point_qubuts => 0x05bb,
  :hebrew_point_dagesh_or_mapiq => 0x05bc,
  :hebrew_point_dagesh => 0x05bc,
  :hebrew_point_meteg => 0x05bd,
  :hebrew_punctuation_maqaf => 0x05be,
  :hebrew_point_rafe => 0x05bf,
  :hebrew_punctuation_paseq => 0x05c0,
  :hebrew_point_paseq => 0x05c0,
  :hebrew_point_shin_dot => 0x05c1,
  :hebrew_point_sin_dot => 0x05c2,
  :hebrew_punctuation_sof_pasuq => 0x05c3,
  :hebrew_mark_upper_dot => 0x05c4,
  :hebrew_mark_lower_dot => 0x05c5,
  :hebrew_punctuation_nun_hafukha => 0x05c6,
  :hebrew_point_qamats_qatan => 0x05c7,
  :hebrew_letter_alef => 0x05d0,
  :hebrew_letter_bet => 0x05d1,
  :hebrew_letter_gimel => 0x05d2,
  :hebrew_letter_dalet => 0x05d3,
  :hebrew_letter_he => 0x05d4,
  :hebrew_letter_vav => 0x05d5,
  :hebrew_letter_zayin => 0x05d6,
  :hebrew_letter_het => 0x05d7,
  :hebrew_letter_tet => 0x05d8,
  :hebrew_letter_yod => 0x05d9,
  :hebrew_letter_final_kaf => 0x05da,
  :hebrew_letter_kaf => 0x05db,
  :hebrew_letter_lamed => 0x05dc,
  :hebrew_letter_final_mem => 0x05dd,
  :hebrew_letter_mem => 0x05de,
  :hebrew_letter_final_nun => 0x05df,
  :hebrew_letter_nun => 0x05e0,
  :hebrew_letter_samekh => 0x05e1,
  :hebrew_letter_ayin => 0x05e2,
  :hebrew_letter_final_pe => 0x05e3,
  :hebrew_letter_pe => 0x05e4,
  :hebrew_letter_final_tsadi => 0x05e5,
  :hebrew_letter_tsadi => 0x05e6,
  :hebrew_letter_qof => 0x05e7,
  :hebrew_letter_resh => 0x05e8,
  :hebrew_letter_shin => 0x05e9,
  :hebrew_letter_tav => 0x05ea,
  :hebrew_ligature_yiddish_double_vav => 0x05f0,
  :hebrew_letter_double_vav => 0x05f0,
  :hebrew_ligature_yiddish_vav_yod => 0x05f1,
  :hebrew_letter_vav_yod => 0x05f1,
  :hebrew_ligature_yiddish_double_yod => 0x05f2,
  :hebrew_letter_double_yod => 0x05f2,
  :hebrew_punctuation_geresh => 0x05f3,
  :hebrew_punctuation_gershayim => 0x05f4,
  :arabic_number_sign => 0x0600,
  :arabic_sign_sanah => 0x0601,
  :arabic_footnote_marker => 0x0602,
  :arabic_sign_safha => 0x0603,
  :afghani_sign => 0x060b,
  :arabic_comma => 0x060c,
  :arabic_date_separator => 0x060d,
  :arabic_poetic_verse_sign => 0x060e,
  :arabic_sign_misra => 0x060f,
  :arabic_sign_sallallahou_alayhe_wassallam => 0x0610,
  :arabic_sign_alayhe_assallam => 0x0611,
  :arabic_sign_rahmatullah_alayhe => 0x0612,
  :arabic_sign_radi_allahou_anhu => 0x0613,
  :arabic_sign_takhallus => 0x0614,
  :arabic_small_high_tah => 0x0615,
  :arabic_semicolon => 0x061b,
  :arabic_triple_dot_punctuation_mark => 0x061e,
  :arabic_question_mark => 0x061f,
  :arabic_letter_hamza => 0x0621,
  :arabic_letter_hamzah => 0x0621,
  :arabic_letter_alef_with_madda_above => 0x0622,
  :arabic_letter_maddah_on_alef => 0x0622,
  :arabic_letter_alef_with_hamza_above => 0x0623,
  :arabic_letter_hamzah_on_alef => 0x0623,
  :arabic_letter_waw_with_hamza_above => 0x0624,
  :arabic_letter_hamzah_on_waw => 0x0624,
  :arabic_letter_alef_with_hamza_below => 0x0625,
  :arabic_letter_hamzah_under_alef => 0x0625,
  :arabic_letter_yeh_with_hamza_above => 0x0626,
  :arabic_letter_hamzah_on_ya => 0x0626,
  :arabic_letter_alef => 0x0627,
  :arabic_letter_beh => 0x0628,
  :arabic_letter_baa => 0x0628,
  :arabic_letter_teh_marbuta => 0x0629,
  :arabic_letter_taa_marbutah => 0x0629,
  :arabic_letter_teh => 0x062a,
  :arabic_letter_taa => 0x062a,
  :arabic_letter_theh => 0x062b,
  :arabic_letter_thaa => 0x062b,
  :arabic_letter_jeem => 0x062c,
  :arabic_letter_hah => 0x062d,
  :arabic_letter_haa => 0x062d,
  :arabic_letter_khah => 0x062e,
  :arabic_letter_khaa => 0x062e,
  :arabic_letter_dal => 0x062f,
  :arabic_letter_thal => 0x0630,
  :arabic_letter_reh => 0x0631,
  :arabic_letter_ra => 0x0631,
  :arabic_letter_zain => 0x0632,
  :arabic_letter_seen => 0x0633,
  :arabic_letter_sheen => 0x0634,
  :arabic_letter_sad => 0x0635,
  :arabic_letter_dad => 0x0636,
  :arabic_letter_tah => 0x0637,
  :arabic_letter_zah => 0x0638,
  :arabic_letter_dhah => 0x0638,
  :arabic_letter_ain => 0x0639,
  :arabic_letter_ghain => 0x063a,
  :arabic_tatweel => 0x0640,
  :arabic_letter_feh => 0x0641,
  :arabic_letter_fa => 0x0641,
  :arabic_letter_qaf => 0x0642,
  :arabic_letter_kaf => 0x0643,
  :arabic_letter_caf => 0x0643,
  :arabic_letter_lam => 0x0644,
  :arabic_letter_meem => 0x0645,
  :arabic_letter_noon => 0x0646,
  :arabic_letter_heh => 0x0647,
  :arabic_letter_ha => 0x0647,
  :arabic_letter_waw => 0x0648,
  :arabic_letter_alef_maksura => 0x0649,
  :arabic_letter_alef_maqsurah => 0x0649,
  :arabic_letter_yeh => 0x064a,
  :arabic_letter_ya => 0x064a,
  :arabic_fathatan => 0x064b,
  :arabic_dammatan => 0x064c,
  :arabic_kasratan => 0x064d,
  :arabic_fatha => 0x064e,
  :arabic_fathah => 0x064e,
  :arabic_damma => 0x064f,
  :arabic_dammah => 0x064f,
  :arabic_kasra => 0x0650,
  :arabic_kasrah => 0x0650,
  :arabic_shadda => 0x0651,
  :arabic_shaddah => 0x0651,
  :arabic_sukun => 0x0652,
  :arabic_maddah_above => 0x0653,
  :arabic_hamza_above => 0x0654,
  :arabic_hamza_below => 0x0655,
  :arabic_subscript_alef => 0x0656,
  :arabic_inverted_damma => 0x0657,
  :arabic_mark_noon_ghunna => 0x0658,
  :arabic_zwarakay => 0x0659,
  :arabic_vowel_sign_small_v_above => 0x065a,
  :arabic_vowel_sign_inverted_small_v_above => 0x065b,
  :arabic_vowel_sign_dot_below => 0x065c,
  :arabic_reversed_damma => 0x065d,
  :arabic_fatha_with_two_dots => 0x065e,
  :arabic_indic_digit_zero => 0x0660,
  :arabic_indic_digit_one => 0x0661,
  :arabic_indic_digit_two => 0x0662,
  :arabic_indic_digit_three => 0x0663,
  :arabic_indic_digit_four => 0x0664,
  :arabic_indic_digit_five => 0x0665,
  :arabic_indic_digit_six => 0x0666,
  :arabic_indic_digit_seven => 0x0667,
  :arabic_indic_digit_eight => 0x0668,
  :arabic_indic_digit_nine => 0x0669,
  :arabic_percent_sign => 0x066a,
  :arabic_decimal_separator => 0x066b,
  :arabic_thousands_separator => 0x066c,
  :arabic_five_pointed_star => 0x066d,
  :arabic_letter_dotless_beh => 0x066e,
  :arabic_letter_dotless_qaf => 0x066f,
  :arabic_letter_superscript_alef => 0x0670,
  :arabic_alef_above => 0x0670,
  :arabic_letter_alef_wasla => 0x0671,
  :arabic_letter_hamzat_wasl_on_alef => 0x0671,
  :arabic_letter_alef_with_wavy_hamza_above => 0x0672,
  :arabic_letter_wavy_hamzah_on_alef => 0x0672,
  :arabic_letter_alef_with_wavy_hamza_below => 0x0673,
  :arabic_letter_wavy_hamzah_under_alef => 0x0673,
  :arabic_letter_high_hamza => 0x0674,
  :arabic_letter_high_hamzah => 0x0674,
  :arabic_letter_high_hamza_alef => 0x0675,
  :arabic_letter_high_hamzah_alef => 0x0675,
  :arabic_letter_high_hamza_waw => 0x0676,
  :arabic_letter_high_hamzah_waw => 0x0676,
  :arabic_letter_u_with_hamza_above => 0x0677,
  :arabic_letter_high_hamzah_waw_with_dammah => 0x0677,
  :arabic_letter_high_hamza_yeh => 0x0678,
  :arabic_letter_high_hamzah_ya => 0x0678,
  :arabic_letter_tteh => 0x0679,
  :arabic_letter_taa_with_small_tah => 0x0679,
  :arabic_letter_tteheh => 0x067a,
  :arabic_letter_taa_with_two_dots_vertical_above => 0x067a,
  :arabic_letter_beeh => 0x067b,
  :arabic_letter_baa_with_two_dots_vertical_below => 0x067b,
  :arabic_letter_teh_with_ring => 0x067c,
  :arabic_letter_taa_with_ring => 0x067c,
  :arabic_letter_teh_with_three_dots_above_downwards => 0x067d,
  :arabic_letter_taa_with_three_dots_above_downward => 0x067d,
  :arabic_letter_peh => 0x067e,
  :arabic_letter_taa_with_three_dots_below => 0x067e,
  :arabic_letter_teheh => 0x067f,
  :arabic_letter_taa_with_four_dots_above => 0x067f,
  :arabic_letter_beheh => 0x0680,
  :arabic_letter_baa_with_four_dots_below => 0x0680,
  :arabic_letter_hah_with_hamza_above => 0x0681,
  :arabic_letter_hamzah_on_haa => 0x0681,
  :arabic_letter_hah_with_two_dots_vertical_above => 0x0682,
  :arabic_letter_haa_with_two_dots_vertical_above => 0x0682,
  :arabic_letter_nyeh => 0x0683,
  :arabic_letter_haa_with_middle_two_dots => 0x0683,
  :arabic_letter_dyeh => 0x0684,
  :arabic_letter_haa_with_middle_two_dots_vertical => 0x0684,
  :arabic_letter_hah_with_three_dots_above => 0x0685,
  :arabic_letter_haa_with_three_dots_above => 0x0685,
  :arabic_letter_tcheh => 0x0686,
  :arabic_letter_haa_with_middle_three_dots_downward => 0x0686,
  :arabic_letter_tcheheh => 0x0687,
  :arabic_letter_haa_with_middle_four_dots => 0x0687,
  :arabic_letter_ddal => 0x0688,
  :arabic_letter_dal_with_small_tah => 0x0688,
  :arabic_letter_dal_with_ring => 0x0689,
  :arabic_letter_dal_with_dot_below => 0x068a,
  :arabic_letter_dal_with_dot_below_and_small_tah => 0x068b,
  :arabic_letter_dahal => 0x068c,
  :arabic_letter_dal_with_two_dots_above => 0x068c,
  :arabic_letter_ddahal => 0x068d,
  :arabic_letter_dal_with_two_dots_below => 0x068d,
  :arabic_letter_dul => 0x068e,
  :arabic_letter_dal_with_three_dots_above => 0x068e,
  :arabic_letter_dal_with_three_dots_above_downwards => 0x068f,
  :arabic_letter_dal_with_three_dots_above_downward => 0x068f,
  :arabic_letter_dal_with_four_dots_above => 0x0690,
  :arabic_letter_rreh => 0x0691,
  :arabic_letter_ra_with_small_tah => 0x0691,
  :arabic_letter_reh_with_small_v => 0x0692,
  :arabic_letter_ra_with_small_v => 0x0692,
  :arabic_letter_reh_with_ring => 0x0693,
  :arabic_letter_ra_with_ring => 0x0693,
  :arabic_letter_reh_with_dot_below => 0x0694,
  :arabic_letter_ra_with_dot_below => 0x0694,
  :arabic_letter_reh_with_small_v_below => 0x0695,
  :arabic_letter_ra_with_small_v_below => 0x0695,
  :arabic_letter_reh_with_dot_below_and_dot_above => 0x0696,
  :arabic_letter_ra_with_dot_below_and_dot_above => 0x0696,
  :arabic_letter_reh_with_two_dots_above => 0x0697,
  :arabic_letter_ra_with_two_dots_above => 0x0697,
  :arabic_letter_jeh => 0x0698,
  :arabic_letter_ra_with_three_dots_above => 0x0698,
  :arabic_letter_reh_with_four_dots_above => 0x0699,
  :arabic_letter_ra_with_four_dots_above => 0x0699,
  :arabic_letter_seen_with_dot_below_and_dot_above => 0x069a,
  :arabic_letter_seen_with_three_dots_below => 0x069b,
  :arabic_letter_seen_with_three_dots_below_and_three_dots_above => 0x069c,
  :arabic_letter_sad_with_two_dots_below => 0x069d,
  :arabic_letter_sad_with_three_dots_above => 0x069e,
  :arabic_letter_tah_with_three_dots_above => 0x069f,
  :arabic_letter_ain_with_three_dots_above => 0x06a0,
  :arabic_letter_dotless_feh => 0x06a1,
  :arabic_letter_dotless_fa => 0x06a1,
  :arabic_letter_feh_with_dot_moved_below => 0x06a2,
  :arabic_letter_fa_with_dot_moved_below => 0x06a2,
  :arabic_letter_feh_with_dot_below => 0x06a3,
  :arabic_letter_fa_with_dot_below => 0x06a3,
  :arabic_letter_veh => 0x06a4,
  :arabic_letter_fa_with_three_dots_above => 0x06a4,
  :arabic_letter_feh_with_three_dots_below => 0x06a5,
  :arabic_letter_fa_with_three_dots_below => 0x06a5,
  :arabic_letter_peheh => 0x06a6,
  :arabic_letter_fa_with_four_dots_above => 0x06a6,
  :arabic_letter_qaf_with_dot_above => 0x06a7,
  :arabic_letter_qaf_with_three_dots_above => 0x06a8,
  :arabic_letter_keheh => 0x06a9,
  :arabic_letter_open_caf => 0x06a9,
  :arabic_letter_swash_kaf => 0x06aa,
  :arabic_letter_swash_caf => 0x06aa,
  :arabic_letter_kaf_with_ring => 0x06ab,
  :arabic_letter_caf_with_ring => 0x06ab,
  :arabic_letter_kaf_with_dot_above => 0x06ac,
  :arabic_letter_caf_with_dot_above => 0x06ac,
  :arabic_letter_ng => 0x06ad,
  :arabic_letter_caf_with_three_dots_above => 0x06ad,
  :arabic_letter_kaf_with_three_dots_below => 0x06ae,
  :arabic_letter_caf_with_three_dots_below => 0x06ae,
  :arabic_letter_gaf => 0x06af,
  :arabic_letter_gaf_with_ring => 0x06b0,
  :arabic_letter_ngoeh => 0x06b1,
  :arabic_letter_gaf_with_two_dots_above => 0x06b1,
  :arabic_letter_gaf_with_two_dots_below => 0x06b2,
  :arabic_letter_gueh => 0x06b3,
  :arabic_letter_gaf_with_two_dots_vertical_below => 0x06b3,
  :arabic_letter_gaf_with_three_dots_above => 0x06b4,
  :arabic_letter_lam_with_small_v => 0x06b5,
  :arabic_letter_lam_with_dot_above => 0x06b6,
  :arabic_letter_lam_with_three_dots_above => 0x06b7,
  :arabic_letter_lam_with_three_dots_below => 0x06b8,
  :arabic_letter_noon_with_dot_below => 0x06b9,
  :arabic_letter_noon_ghunna => 0x06ba,
  :arabic_letter_dotless_noon => 0x06ba,
  :arabic_letter_rnoon => 0x06bb,
  :arabic_letter_dotless_noon_with_small_tah => 0x06bb,
  :arabic_letter_noon_with_ring => 0x06bc,
  :arabic_letter_noon_with_three_dots_above => 0x06bd,
  :arabic_letter_heh_doachashmee => 0x06be,
  :arabic_letter_knotted_ha => 0x06be,
  :arabic_letter_tcheh_with_dot_above => 0x06bf,
  :arabic_letter_heh_with_yeh_above => 0x06c0,
  :arabic_letter_hamzah_on_ha => 0x06c0,
  :arabic_letter_heh_goal => 0x06c1,
  :arabic_letter_ha_goal => 0x06c1,
  :arabic_letter_heh_goal_with_hamza_above => 0x06c2,
  :arabic_letter_hamzah_on_ha_goal => 0x06c2,
  :arabic_letter_teh_marbuta_goal => 0x06c3,
  :arabic_letter_taa_marbutah_goal => 0x06c3,
  :arabic_letter_waw_with_ring => 0x06c4,
  :arabic_letter_kirghiz_oe => 0x06c5,
  :arabic_letter_waw_with_bar => 0x06c5,
  :arabic_letter_oe => 0x06c6,
  :arabic_letter_waw_with_small_v => 0x06c6,
  :arabic_letter_u => 0x06c7,
  :arabic_letter_waw_with_dammah => 0x06c7,
  :arabic_letter_yu => 0x06c8,
  :arabic_letter_waw_with_alef_above => 0x06c8,
  :arabic_letter_kirghiz_yu => 0x06c9,
  :arabic_letter_waw_with_inverted_small_v => 0x06c9,
  :arabic_letter_waw_with_two_dots_above => 0x06ca,
  :arabic_letter_ve => 0x06cb,
  :arabic_letter_waw_with_three_dots_above => 0x06cb,
  :arabic_letter_farsi_yeh => 0x06cc,
  :arabic_letter_dotless_ya => 0x06cc,
  :arabic_letter_yeh_with_tail => 0x06cd,
  :arabic_letter_ya_with_tail => 0x06cd,
  :arabic_letter_yeh_with_small_v => 0x06ce,
  :arabic_letter_ya_with_small_v => 0x06ce,
  :arabic_letter_waw_with_dot_above => 0x06cf,
  :arabic_letter_e => 0x06d0,
  :arabic_letter_ya_with_two_dots_vertical_below => 0x06d0,
  :arabic_letter_yeh_with_three_dots_below => 0x06d1,
  :arabic_letter_ya_with_three_dots_below => 0x06d1,
  :arabic_letter_yeh_barree => 0x06d2,
  :arabic_letter_ya_barree => 0x06d2,
  :arabic_letter_yeh_barree_with_hamza_above => 0x06d3,
  :arabic_letter_hamzah_on_ya_barree => 0x06d3,
  :arabic_full_stop => 0x06d4,
  :arabic_period => 0x06d4,
  :arabic_letter_ae => 0x06d5,
  :arabic_small_high_ligature_sad_with_lam_with_alef_maksura => 0x06d6,
  :arabic_small_high_ligature_qaf_with_lam_with_alef_maksura => 0x06d7,
  :arabic_small_high_meem_initial_form => 0x06d8,
  :arabic_small_high_lam_alef => 0x06d9,
  :arabic_small_high_jeem => 0x06da,
  :arabic_small_high_three_dots => 0x06db,
  :arabic_small_high_seen => 0x06dc,
  :arabic_end_of_ayah => 0x06dd,
  :arabic_start_of_rub_el_hizb => 0x06de,
  :arabic_small_high_rounded_zero => 0x06df,
  :arabic_small_high_upright_rectangular_zero => 0x06e0,
  :arabic_small_high_dotless_head_of_khah => 0x06e1,
  :arabic_small_high_meem_isolated_form => 0x06e2,
  :arabic_small_low_seen => 0x06e3,
  :arabic_small_high_madda => 0x06e4,
  :arabic_small_waw => 0x06e5,
  :arabic_small_yeh => 0x06e6,
  :arabic_small_high_yeh => 0x06e7,
  :arabic_small_high_noon => 0x06e8,
  :arabic_place_of_sajdah => 0x06e9,
  :arabic_empty_centre_low_stop => 0x06ea,
  :arabic_empty_centre_high_stop => 0x06eb,
  :arabic_rounded_high_stop_with_filled_centre => 0x06ec,
  :arabic_small_low_meem => 0x06ed,
  :arabic_letter_dal_with_inverted_v => 0x06ee,
  :arabic_letter_reh_with_inverted_v => 0x06ef,
  :extended_arabic_indic_digit_zero => 0x06f0,
  :eastern_arabic_indic_digit_zero => 0x06f0,
  :extended_arabic_indic_digit_one => 0x06f1,
  :eastern_arabic_indic_digit_one => 0x06f1,
  :extended_arabic_indic_digit_two => 0x06f2,
  :eastern_arabic_indic_digit_two => 0x06f2,
  :extended_arabic_indic_digit_three => 0x06f3,
  :eastern_arabic_indic_digit_three => 0x06f3,
  :extended_arabic_indic_digit_four => 0x06f4,
  :eastern_arabic_indic_digit_four => 0x06f4,
  :extended_arabic_indic_digit_five => 0x06f5,
  :eastern_arabic_indic_digit_five => 0x06f5,
  :extended_arabic_indic_digit_six => 0x06f6,
  :eastern_arabic_indic_digit_six => 0x06f6,
  :extended_arabic_indic_digit_seven => 0x06f7,
  :eastern_arabic_indic_digit_seven => 0x06f7,
  :extended_arabic_indic_digit_eight => 0x06f8,
  :eastern_arabic_indic_digit_eight => 0x06f8,
  :extended_arabic_indic_digit_nine => 0x06f9,
  :eastern_arabic_indic_digit_nine => 0x06f9,
  :arabic_letter_sheen_with_dot_below => 0x06fa,
  :arabic_letter_dad_with_dot_below => 0x06fb,
  :arabic_letter_ghain_with_dot_below => 0x06fc,
  :arabic_sign_sindhi_ampersand => 0x06fd,
  :arabic_sign_sindhi_postposition_men => 0x06fe,
  :arabic_letter_heh_with_inverted_v => 0x06ff,
  :syriac_end_of_paragraph => 0x0700,
  :syriac_supralinear_full_stop => 0x0701,
  :syriac_sublinear_full_stop => 0x0702,
  :syriac_supralinear_colon => 0x0703,
  :syriac_sublinear_colon => 0x0704,
  :syriac_horizontal_colon => 0x0705,
  :syriac_colon_skewed_left => 0x0706,
  :syriac_colon_skewed_right => 0x0707,
  :syriac_supralinear_colon_skewed_left => 0x0708,
  :syriac_sublinear_colon_skewed_right => 0x0709,
  :syriac_contraction => 0x070a,
  :syriac_harklean_obelus => 0x070b,
  :syriac_harklean_metobelus => 0x070c,
  :syriac_harklean_asteriscus => 0x070d,
  :syriac_abbreviation_mark => 0x070f,
  :syriac_letter_alaph => 0x0710,
  :syriac_letter_superscript_alaph => 0x0711,
  :syriac_letter_beth => 0x0712,
  :syriac_letter_gamal => 0x0713,
  :syriac_letter_gamal_garshuni => 0x0714,
  :syriac_letter_dalath => 0x0715,
  :syriac_letter_dotless_dalath_rish => 0x0716,
  :syriac_letter_he => 0x0717,
  :syriac_letter_waw => 0x0718,
  :syriac_letter_zain => 0x0719,
  :syriac_letter_heth => 0x071a,
  :syriac_letter_teth => 0x071b,
  :syriac_letter_teth_garshuni => 0x071c,
  :syriac_letter_yudh => 0x071d,
  :syriac_letter_yudh_he => 0x071e,
  :syriac_letter_kaph => 0x071f,
  :syriac_letter_lamadh => 0x0720,
  :syriac_letter_mim => 0x0721,
  :syriac_letter_nun => 0x0722,
  :syriac_letter_semkath => 0x0723,
  :syriac_letter_final_semkath => 0x0724,
  :syriac_letter_e => 0x0725,
  :syriac_letter_pe => 0x0726,
  :syriac_letter_reversed_pe => 0x0727,
  :syriac_letter_sadhe => 0x0728,
  :syriac_letter_qaph => 0x0729,
  :syriac_letter_rish => 0x072a,
  :syriac_letter_shin => 0x072b,
  :syriac_letter_taw => 0x072c,
  :syriac_letter_persian_bheth => 0x072d,
  :syriac_letter_persian_ghamal => 0x072e,
  :syriac_letter_persian_dhalath => 0x072f,
  :syriac_pthaha_above => 0x0730,
  :syriac_pthaha_below => 0x0731,
  :syriac_pthaha_dotted => 0x0732,
  :syriac_zqapha_above => 0x0733,
  :syriac_zqapha_below => 0x0734,
  :syriac_zqapha_dotted => 0x0735,
  :syriac_rbasa_above => 0x0736,
  :syriac_rbasa_below => 0x0737,
  :syriac_dotted_zlama_horizontal => 0x0738,
  :syriac_dotted_zlama_angular => 0x0739,
  :syriac_hbasa_above => 0x073a,
  :syriac_hbasa_below => 0x073b,
  :syriac_hbasa_esasa_dotted => 0x073c,
  :syriac_esasa_above => 0x073d,
  :syriac_esasa_below => 0x073e,
  :syriac_rwaha => 0x073f,
  :syriac_feminine_dot => 0x0740,
  :syriac_qushshaya => 0x0741,
  :syriac_rukkakha => 0x0742,
  :syriac_two_vertical_dots_above => 0x0743,
  :syriac_two_vertical_dots_below => 0x0744,
  :syriac_three_dots_above => 0x0745,
  :syriac_three_dots_below => 0x0746,
  :syriac_oblique_line_above => 0x0747,
  :syriac_oblique_line_below => 0x0748,
  :syriac_music => 0x0749,
  :syriac_barrekh => 0x074a,
  :syriac_letter_sogdian_zhain => 0x074d,
  :syriac_letter_sogdian_khaph => 0x074e,
  :syriac_letter_sogdian_fe => 0x074f,
  :arabic_letter_beh_with_three_dots_horizontally_below => 0x0750,
  :arabic_letter_beh_with_dot_below_and_three_dots_above => 0x0751,
  :arabic_letter_beh_with_three_dots_pointing_upwards_below => 0x0752,
  :arabic_letter_beh_with_three_dots_pointing_upwards_below_and_two_dots_above => 0x0753,
  :arabic_letter_beh_with_two_dots_below_and_dot_above => 0x0754,
  :arabic_letter_beh_with_inverted_small_v_below => 0x0755,
  :arabic_letter_beh_with_small_v => 0x0756,
  :arabic_letter_hah_with_two_dots_above => 0x0757,
  :arabic_letter_hah_with_three_dots_pointing_upwards_below => 0x0758,
  :arabic_letter_dal_with_two_dots_vertically_below_and_small_tah => 0x0759,
  :arabic_letter_dal_with_inverted_small_v_below => 0x075a,
  :arabic_letter_reh_with_stroke => 0x075b,
  :arabic_letter_seen_with_four_dots_above => 0x075c,
  :arabic_letter_ain_with_two_dots_above => 0x075d,
  :arabic_letter_ain_with_three_dots_pointing_downwards_above => 0x075e,
  :arabic_letter_ain_with_two_dots_vertically_above => 0x075f,
  :arabic_letter_feh_with_two_dots_below => 0x0760,
  :arabic_letter_feh_with_three_dots_pointing_upwards_below => 0x0761,
  :arabic_letter_keheh_with_dot_above => 0x0762,
  :arabic_letter_keheh_with_three_dots_above => 0x0763,
  :arabic_letter_keheh_with_three_dots_pointing_upwards_below => 0x0764,
  :arabic_letter_meem_with_dot_above => 0x0765,
  :arabic_letter_meem_with_dot_below => 0x0766,
  :arabic_letter_noon_with_two_dots_below => 0x0767,
  :arabic_letter_noon_with_small_tah => 0x0768,
  :arabic_letter_noon_with_small_v => 0x0769,
  :arabic_letter_lam_with_bar => 0x076a,
  :arabic_letter_reh_with_two_dots_vertically_above => 0x076b,
  :arabic_letter_reh_with_hamza_above => 0x076c,
  :arabic_letter_seen_with_two_dots_vertically_above => 0x076d,
  :thaana_letter_haa => 0x0780,
  :thaana_letter_shaviyani => 0x0781,
  :thaana_letter_noonu => 0x0782,
  :thaana_letter_raa => 0x0783,
  :thaana_letter_baa => 0x0784,
  :thaana_letter_lhaviyani => 0x0785,
  :thaana_letter_kaafu => 0x0786,
  :thaana_letter_alifu => 0x0787,
  :thaana_letter_vaavu => 0x0788,
  :thaana_letter_meemu => 0x0789,
  :thaana_letter_faafu => 0x078a,
  :thaana_letter_dhaalu => 0x078b,
  :thaana_letter_thaa => 0x078c,
  :thaana_letter_laamu => 0x078d,
  :thaana_letter_gaafu => 0x078e,
  :thaana_letter_gnaviyani => 0x078f,
  :thaana_letter_seenu => 0x0790,
  :thaana_letter_daviyani => 0x0791,
  :thaana_letter_zaviyani => 0x0792,
  :thaana_letter_taviyani => 0x0793,
  :thaana_letter_yaa => 0x0794,
  :thaana_letter_paviyani => 0x0795,
  :thaana_letter_javiyani => 0x0796,
  :thaana_letter_chaviyani => 0x0797,
  :thaana_letter_ttaa => 0x0798,
  :thaana_letter_hhaa => 0x0799,
  :thaana_letter_khaa => 0x079a,
  :thaana_letter_thaalu => 0x079b,
  :thaana_letter_zaa => 0x079c,
  :thaana_letter_sheenu => 0x079d,
  :thaana_letter_saadhu => 0x079e,
  :thaana_letter_daadhu => 0x079f,
  :thaana_letter_to => 0x07a0,
  :thaana_letter_zo => 0x07a1,
  :thaana_letter_ainu => 0x07a2,
  :thaana_letter_ghainu => 0x07a3,
  :thaana_letter_qaafu => 0x07a4,
  :thaana_letter_waavu => 0x07a5,
  :thaana_abafili => 0x07a6,
  :thaana_aabaafili => 0x07a7,
  :thaana_ibifili => 0x07a8,
  :thaana_eebeefili => 0x07a9,
  :thaana_ubufili => 0x07aa,
  :thaana_ooboofili => 0x07ab,
  :thaana_ebefili => 0x07ac,
  :thaana_eybeyfili => 0x07ad,
  :thaana_obofili => 0x07ae,
  :thaana_oaboafili => 0x07af,
  :thaana_sukun => 0x07b0,
  :thaana_letter_naa => 0x07b1,
  :devanagari_sign_candrabindu => 0x0901,
  :devanagari_sign_anusvara => 0x0902,
  :devanagari_sign_visarga => 0x0903,
  :devanagari_letter_short_a => 0x0904,
  :devanagari_letter_a => 0x0905,
  :devanagari_letter_aa => 0x0906,
  :devanagari_letter_i => 0x0907,
  :devanagari_letter_ii => 0x0908,
  :devanagari_letter_u => 0x0909,
  :devanagari_letter_uu => 0x090a,
  :devanagari_letter_vocalic_r => 0x090b,
  :devanagari_letter_vocalic_l => 0x090c,
  :devanagari_letter_candra_e => 0x090d,
  :devanagari_letter_short_e => 0x090e,
  :devanagari_letter_e => 0x090f,
  :devanagari_letter_ai => 0x0910,
  :devanagari_letter_candra_o => 0x0911,
  :devanagari_letter_short_o => 0x0912,
  :devanagari_letter_o => 0x0913,
  :devanagari_letter_au => 0x0914,
  :devanagari_letter_ka => 0x0915,
  :devanagari_letter_kha => 0x0916,
  :devanagari_letter_ga => 0x0917,
  :devanagari_letter_gha => 0x0918,
  :devanagari_letter_nga => 0x0919,
  :devanagari_letter_ca => 0x091a,
  :devanagari_letter_cha => 0x091b,
  :devanagari_letter_ja => 0x091c,
  :devanagari_letter_jha => 0x091d,
  :devanagari_letter_nya => 0x091e,
  :devanagari_letter_tta => 0x091f,
  :devanagari_letter_ttha => 0x0920,
  :devanagari_letter_dda => 0x0921,
  :devanagari_letter_ddha => 0x0922,
  :devanagari_letter_nna => 0x0923,
  :devanagari_letter_ta => 0x0924,
  :devanagari_letter_tha => 0x0925,
  :devanagari_letter_da => 0x0926,
  :devanagari_letter_dha => 0x0927,
  :devanagari_letter_na => 0x0928,
  :devanagari_letter_nnna => 0x0929,
  :devanagari_letter_pa => 0x092a,
  :devanagari_letter_pha => 0x092b,
  :devanagari_letter_ba => 0x092c,
  :devanagari_letter_bha => 0x092d,
  :devanagari_letter_ma => 0x092e,
  :devanagari_letter_ya => 0x092f,
  :devanagari_letter_ra => 0x0930,
  :devanagari_letter_rra => 0x0931,
  :devanagari_letter_la => 0x0932,
  :devanagari_letter_lla => 0x0933,
  :devanagari_letter_llla => 0x0934,
  :devanagari_letter_va => 0x0935,
  :devanagari_letter_sha => 0x0936,
  :devanagari_letter_ssa => 0x0937,
  :devanagari_letter_sa => 0x0938,
  :devanagari_letter_ha => 0x0939,
  :devanagari_sign_nukta => 0x093c,
  :devanagari_sign_avagraha => 0x093d,
  :devanagari_vowel_sign_aa => 0x093e,
  :devanagari_vowel_sign_i => 0x093f,
  :devanagari_vowel_sign_ii => 0x0940,
  :devanagari_vowel_sign_u => 0x0941,
  :devanagari_vowel_sign_uu => 0x0942,
  :devanagari_vowel_sign_vocalic_r => 0x0943,
  :devanagari_vowel_sign_vocalic_rr => 0x0944,
  :devanagari_vowel_sign_candra_e => 0x0945,
  :devanagari_vowel_sign_short_e => 0x0946,
  :devanagari_vowel_sign_e => 0x0947,
  :devanagari_vowel_sign_ai => 0x0948,
  :devanagari_vowel_sign_candra_o => 0x0949,
  :devanagari_vowel_sign_short_o => 0x094a,
  :devanagari_vowel_sign_o => 0x094b,
  :devanagari_vowel_sign_au => 0x094c,
  :devanagari_sign_virama => 0x094d,
  :devanagari_om => 0x0950,
  :devanagari_stress_sign_udatta => 0x0951,
  :devanagari_stress_sign_anudatta => 0x0952,
  :devanagari_grave_accent => 0x0953,
  :devanagari_acute_accent => 0x0954,
  :devanagari_letter_qa => 0x0958,
  :devanagari_letter_khha => 0x0959,
  :devanagari_letter_ghha => 0x095a,
  :devanagari_letter_za => 0x095b,
  :devanagari_letter_dddha => 0x095c,
  :devanagari_letter_rha => 0x095d,
  :devanagari_letter_fa => 0x095e,
  :devanagari_letter_yya => 0x095f,
  :devanagari_letter_vocalic_rr => 0x0960,
  :devanagari_letter_vocalic_ll => 0x0961,
  :devanagari_vowel_sign_vocalic_l => 0x0962,
  :devanagari_vowel_sign_vocalic_ll => 0x0963,
  :devanagari_danda => 0x0964,
  :devanagari_double_danda => 0x0965,
  :devanagari_digit_zero => 0x0966,
  :devanagari_digit_one => 0x0967,
  :devanagari_digit_two => 0x0968,
  :devanagari_digit_three => 0x0969,
  :devanagari_digit_four => 0x096a,
  :devanagari_digit_five => 0x096b,
  :devanagari_digit_six => 0x096c,
  :devanagari_digit_seven => 0x096d,
  :devanagari_digit_eight => 0x096e,
  :devanagari_digit_nine => 0x096f,
  :devanagari_abbreviation_sign => 0x0970,
  :devanagari_letter_glottal_stop => 0x097d,
  :bengali_sign_candrabindu => 0x0981,
  :bengali_sign_anusvara => 0x0982,
  :bengali_sign_visarga => 0x0983,
  :bengali_letter_a => 0x0985,
  :bengali_letter_aa => 0x0986,
  :bengali_letter_i => 0x0987,
  :bengali_letter_ii => 0x0988,
  :bengali_letter_u => 0x0989,
  :bengali_letter_uu => 0x098a,
  :bengali_letter_vocalic_r => 0x098b,
  :bengali_letter_vocalic_l => 0x098c,
  :bengali_letter_e => 0x098f,
  :bengali_letter_ai => 0x0990,
  :bengali_letter_o => 0x0993,
  :bengali_letter_au => 0x0994,
  :bengali_letter_ka => 0x0995,
  :bengali_letter_kha => 0x0996,
  :bengali_letter_ga => 0x0997,
  :bengali_letter_gha => 0x0998,
  :bengali_letter_nga => 0x0999,
  :bengali_letter_ca => 0x099a,
  :bengali_letter_cha => 0x099b,
  :bengali_letter_ja => 0x099c,
  :bengali_letter_jha => 0x099d,
  :bengali_letter_nya => 0x099e,
  :bengali_letter_tta => 0x099f,
  :bengali_letter_ttha => 0x09a0,
  :bengali_letter_dda => 0x09a1,
  :bengali_letter_ddha => 0x09a2,
  :bengali_letter_nna => 0x09a3,
  :bengali_letter_ta => 0x09a4,
  :bengali_letter_tha => 0x09a5,
  :bengali_letter_da => 0x09a6,
  :bengali_letter_dha => 0x09a7,
  :bengali_letter_na => 0x09a8,
  :bengali_letter_pa => 0x09aa,
  :bengali_letter_pha => 0x09ab,
  :bengali_letter_ba => 0x09ac,
  :bengali_letter_bha => 0x09ad,
  :bengali_letter_ma => 0x09ae,
  :bengali_letter_ya => 0x09af,
  :bengali_letter_ra => 0x09b0,
  :bengali_letter_la => 0x09b2,
  :bengali_letter_sha => 0x09b6,
  :bengali_letter_ssa => 0x09b7,
  :bengali_letter_sa => 0x09b8,
  :bengali_letter_ha => 0x09b9,
  :bengali_sign_nukta => 0x09bc,
  :bengali_sign_avagraha => 0x09bd,
  :bengali_vowel_sign_aa => 0x09be,
  :bengali_vowel_sign_i => 0x09bf,
  :bengali_vowel_sign_ii => 0x09c0,
  :bengali_vowel_sign_u => 0x09c1,
  :bengali_vowel_sign_uu => 0x09c2,
  :bengali_vowel_sign_vocalic_r => 0x09c3,
  :bengali_vowel_sign_vocalic_rr => 0x09c4,
  :bengali_vowel_sign_e => 0x09c7,
  :bengali_vowel_sign_ai => 0x09c8,
  :bengali_vowel_sign_o => 0x09cb,
  :bengali_vowel_sign_au => 0x09cc,
  :bengali_sign_virama => 0x09cd,
  :bengali_letter_khanda_ta => 0x09ce,
  :bengali_au_length_mark => 0x09d7,
  :bengali_letter_rra => 0x09dc,
  :bengali_letter_rha => 0x09dd,
  :bengali_letter_yya => 0x09df,
  :bengali_letter_vocalic_rr => 0x09e0,
  :bengali_letter_vocalic_ll => 0x09e1,
  :bengali_vowel_sign_vocalic_l => 0x09e2,
  :bengali_vowel_sign_vocalic_ll => 0x09e3,
  :bengali_digit_zero => 0x09e6,
  :bengali_digit_one => 0x09e7,
  :bengali_digit_two => 0x09e8,
  :bengali_digit_three => 0x09e9,
  :bengali_digit_four => 0x09ea,
  :bengali_digit_five => 0x09eb,
  :bengali_digit_six => 0x09ec,
  :bengali_digit_seven => 0x09ed,
  :bengali_digit_eight => 0x09ee,
  :bengali_digit_nine => 0x09ef,
  :bengali_letter_ra_with_middle_diagonal => 0x09f0,
  :bengali_letter_ra_with_lower_diagonal => 0x09f1,
  :bengali_letter_va_with_lower_diagonal => 0x09f1,
  :bengali_rupee_mark => 0x09f2,
  :bengali_rupee_sign => 0x09f3,
  :bengali_currency_numerator_one => 0x09f4,
  :bengali_currency_numerator_two => 0x09f5,
  :bengali_currency_numerator_three => 0x09f6,
  :bengali_currency_numerator_four => 0x09f7,
  :bengali_currency_numerator_one_less_than_the_denominator => 0x09f8,
  :bengali_currency_denominator_sixteen => 0x09f9,
  :bengali_isshar => 0x09fa,
  :gurmukhi_sign_adak_bindi => 0x0a01,
  :gurmukhi_sign_bindi => 0x0a02,
  :gurmukhi_sign_visarga => 0x0a03,
  :gurmukhi_letter_a => 0x0a05,
  :gurmukhi_letter_aa => 0x0a06,
  :gurmukhi_letter_i => 0x0a07,
  :gurmukhi_letter_ii => 0x0a08,
  :gurmukhi_letter_u => 0x0a09,
  :gurmukhi_letter_uu => 0x0a0a,
  :gurmukhi_letter_ee => 0x0a0f,
  :gurmukhi_letter_ai => 0x0a10,
  :gurmukhi_letter_oo => 0x0a13,
  :gurmukhi_letter_au => 0x0a14,
  :gurmukhi_letter_ka => 0x0a15,
  :gurmukhi_letter_kha => 0x0a16,
  :gurmukhi_letter_ga => 0x0a17,
  :gurmukhi_letter_gha => 0x0a18,
  :gurmukhi_letter_nga => 0x0a19,
  :gurmukhi_letter_ca => 0x0a1a,
  :gurmukhi_letter_cha => 0x0a1b,
  :gurmukhi_letter_ja => 0x0a1c,
  :gurmukhi_letter_jha => 0x0a1d,
  :gurmukhi_letter_nya => 0x0a1e,
  :gurmukhi_letter_tta => 0x0a1f,
  :gurmukhi_letter_ttha => 0x0a20,
  :gurmukhi_letter_dda => 0x0a21,
  :gurmukhi_letter_ddha => 0x0a22,
  :gurmukhi_letter_nna => 0x0a23,
  :gurmukhi_letter_ta => 0x0a24,
  :gurmukhi_letter_tha => 0x0a25,
  :gurmukhi_letter_da => 0x0a26,
  :gurmukhi_letter_dha => 0x0a27,
  :gurmukhi_letter_na => 0x0a28,
  :gurmukhi_letter_pa => 0x0a2a,
  :gurmukhi_letter_pha => 0x0a2b,
  :gurmukhi_letter_ba => 0x0a2c,
  :gurmukhi_letter_bha => 0x0a2d,
  :gurmukhi_letter_ma => 0x0a2e,
  :gurmukhi_letter_ya => 0x0a2f,
  :gurmukhi_letter_ra => 0x0a30,
  :gurmukhi_letter_la => 0x0a32,
  :gurmukhi_letter_lla => 0x0a33,
  :gurmukhi_letter_va => 0x0a35,
  :gurmukhi_letter_sha => 0x0a36,
  :gurmukhi_letter_sa => 0x0a38,
  :gurmukhi_letter_ha => 0x0a39,
  :gurmukhi_sign_nukta => 0x0a3c,
  :gurmukhi_vowel_sign_aa => 0x0a3e,
  :gurmukhi_vowel_sign_i => 0x0a3f,
  :gurmukhi_vowel_sign_ii => 0x0a40,
  :gurmukhi_vowel_sign_u => 0x0a41,
  :gurmukhi_vowel_sign_uu => 0x0a42,
  :gurmukhi_vowel_sign_ee => 0x0a47,
  :gurmukhi_vowel_sign_ai => 0x0a48,
  :gurmukhi_vowel_sign_oo => 0x0a4b,
  :gurmukhi_vowel_sign_au => 0x0a4c,
  :gurmukhi_sign_virama => 0x0a4d,
  :gurmukhi_letter_khha => 0x0a59,
  :gurmukhi_letter_ghha => 0x0a5a,
  :gurmukhi_letter_za => 0x0a5b,
  :gurmukhi_letter_rra => 0x0a5c,
  :gurmukhi_letter_fa => 0x0a5e,
  :gurmukhi_digit_zero => 0x0a66,
  :gurmukhi_digit_one => 0x0a67,
  :gurmukhi_digit_two => 0x0a68,
  :gurmukhi_digit_three => 0x0a69,
  :gurmukhi_digit_four => 0x0a6a,
  :gurmukhi_digit_five => 0x0a6b,
  :gurmukhi_digit_six => 0x0a6c,
  :gurmukhi_digit_seven => 0x0a6d,
  :gurmukhi_digit_eight => 0x0a6e,
  :gurmukhi_digit_nine => 0x0a6f,
  :gurmukhi_tippi => 0x0a70,
  :gurmukhi_addak => 0x0a71,
  :gurmukhi_iri => 0x0a72,
  :gurmukhi_ura => 0x0a73,
  :gurmukhi_ek_onkar => 0x0a74,
  :gujarati_sign_candrabindu => 0x0a81,
  :gujarati_sign_anusvara => 0x0a82,
  :gujarati_sign_visarga => 0x0a83,
  :gujarati_letter_a => 0x0a85,
  :gujarati_letter_aa => 0x0a86,
  :gujarati_letter_i => 0x0a87,
  :gujarati_letter_ii => 0x0a88,
  :gujarati_letter_u => 0x0a89,
  :gujarati_letter_uu => 0x0a8a,
  :gujarati_letter_vocalic_r => 0x0a8b,
  :gujarati_letter_vocalic_l => 0x0a8c,
  :gujarati_vowel_candra_e => 0x0a8d,
  :gujarati_letter_e => 0x0a8f,
  :gujarati_letter_ai => 0x0a90,
  :gujarati_vowel_candra_o => 0x0a91,
  :gujarati_letter_o => 0x0a93,
  :gujarati_letter_au => 0x0a94,
  :gujarati_letter_ka => 0x0a95,
  :gujarati_letter_kha => 0x0a96,
  :gujarati_letter_ga => 0x0a97,
  :gujarati_letter_gha => 0x0a98,
  :gujarati_letter_nga => 0x0a99,
  :gujarati_letter_ca => 0x0a9a,
  :gujarati_letter_cha => 0x0a9b,
  :gujarati_letter_ja => 0x0a9c,
  :gujarati_letter_jha => 0x0a9d,
  :gujarati_letter_nya => 0x0a9e,
  :gujarati_letter_tta => 0x0a9f,
  :gujarati_letter_ttha => 0x0aa0,
  :gujarati_letter_dda => 0x0aa1,
  :gujarati_letter_ddha => 0x0aa2,
  :gujarati_letter_nna => 0x0aa3,
  :gujarati_letter_ta => 0x0aa4,
  :gujarati_letter_tha => 0x0aa5,
  :gujarati_letter_da => 0x0aa6,
  :gujarati_letter_dha => 0x0aa7,
  :gujarati_letter_na => 0x0aa8,
  :gujarati_letter_pa => 0x0aaa,
  :gujarati_letter_pha => 0x0aab,
  :gujarati_letter_ba => 0x0aac,
  :gujarati_letter_bha => 0x0aad,
  :gujarati_letter_ma => 0x0aae,
  :gujarati_letter_ya => 0x0aaf,
  :gujarati_letter_ra => 0x0ab0,
  :gujarati_letter_la => 0x0ab2,
  :gujarati_letter_lla => 0x0ab3,
  :gujarati_letter_va => 0x0ab5,
  :gujarati_letter_sha => 0x0ab6,
  :gujarati_letter_ssa => 0x0ab7,
  :gujarati_letter_sa => 0x0ab8,
  :gujarati_letter_ha => 0x0ab9,
  :gujarati_sign_nukta => 0x0abc,
  :gujarati_sign_avagraha => 0x0abd,
  :gujarati_vowel_sign_aa => 0x0abe,
  :gujarati_vowel_sign_i => 0x0abf,
  :gujarati_vowel_sign_ii => 0x0ac0,
  :gujarati_vowel_sign_u => 0x0ac1,
  :gujarati_vowel_sign_uu => 0x0ac2,
  :gujarati_vowel_sign_vocalic_r => 0x0ac3,
  :gujarati_vowel_sign_vocalic_rr => 0x0ac4,
  :gujarati_vowel_sign_candra_e => 0x0ac5,
  :gujarati_vowel_sign_e => 0x0ac7,
  :gujarati_vowel_sign_ai => 0x0ac8,
  :gujarati_vowel_sign_candra_o => 0x0ac9,
  :gujarati_vowel_sign_o => 0x0acb,
  :gujarati_vowel_sign_au => 0x0acc,
  :gujarati_sign_virama => 0x0acd,
  :gujarati_om => 0x0ad0,
  :gujarati_letter_vocalic_rr => 0x0ae0,
  :gujarati_letter_vocalic_ll => 0x0ae1,
  :gujarati_vowel_sign_vocalic_l => 0x0ae2,
  :gujarati_vowel_sign_vocalic_ll => 0x0ae3,
  :gujarati_digit_zero => 0x0ae6,
  :gujarati_digit_one => 0x0ae7,
  :gujarati_digit_two => 0x0ae8,
  :gujarati_digit_three => 0x0ae9,
  :gujarati_digit_four => 0x0aea,
  :gujarati_digit_five => 0x0aeb,
  :gujarati_digit_six => 0x0aec,
  :gujarati_digit_seven => 0x0aed,
  :gujarati_digit_eight => 0x0aee,
  :gujarati_digit_nine => 0x0aef,
  :gujarati_rupee_sign => 0x0af1,
  :oriya_sign_candrabindu => 0x0b01,
  :oriya_sign_anusvara => 0x0b02,
  :oriya_sign_visarga => 0x0b03,
  :oriya_letter_a => 0x0b05,
  :oriya_letter_aa => 0x0b06,
  :oriya_letter_i => 0x0b07,
  :oriya_letter_ii => 0x0b08,
  :oriya_letter_u => 0x0b09,
  :oriya_letter_uu => 0x0b0a,
  :oriya_letter_vocalic_r => 0x0b0b,
  :oriya_letter_vocalic_l => 0x0b0c,
  :oriya_letter_e => 0x0b0f,
  :oriya_letter_ai => 0x0b10,
  :oriya_letter_o => 0x0b13,
  :oriya_letter_au => 0x0b14,
  :oriya_letter_ka => 0x0b15,
  :oriya_letter_kha => 0x0b16,
  :oriya_letter_ga => 0x0b17,
  :oriya_letter_gha => 0x0b18,
  :oriya_letter_nga => 0x0b19,
  :oriya_letter_ca => 0x0b1a,
  :oriya_letter_cha => 0x0b1b,
  :oriya_letter_ja => 0x0b1c,
  :oriya_letter_jha => 0x0b1d,
  :oriya_letter_nya => 0x0b1e,
  :oriya_letter_tta => 0x0b1f,
  :oriya_letter_ttha => 0x0b20,
  :oriya_letter_dda => 0x0b21,
  :oriya_letter_ddha => 0x0b22,
  :oriya_letter_nna => 0x0b23,
  :oriya_letter_ta => 0x0b24,
  :oriya_letter_tha => 0x0b25,
  :oriya_letter_da => 0x0b26,
  :oriya_letter_dha => 0x0b27,
  :oriya_letter_na => 0x0b28,
  :oriya_letter_pa => 0x0b2a,
  :oriya_letter_pha => 0x0b2b,
  :oriya_letter_ba => 0x0b2c,
  :oriya_letter_bha => 0x0b2d,
  :oriya_letter_ma => 0x0b2e,
  :oriya_letter_ya => 0x0b2f,
  :oriya_letter_ra => 0x0b30,
  :oriya_letter_la => 0x0b32,
  :oriya_letter_lla => 0x0b33,
  :oriya_letter_va => 0x0b35,
  :oriya_letter_sha => 0x0b36,
  :oriya_letter_ssa => 0x0b37,
  :oriya_letter_sa => 0x0b38,
  :oriya_letter_ha => 0x0b39,
  :oriya_sign_nukta => 0x0b3c,
  :oriya_sign_avagraha => 0x0b3d,
  :oriya_vowel_sign_aa => 0x0b3e,
  :oriya_vowel_sign_i => 0x0b3f,
  :oriya_vowel_sign_ii => 0x0b40,
  :oriya_vowel_sign_u => 0x0b41,
  :oriya_vowel_sign_uu => 0x0b42,
  :oriya_vowel_sign_vocalic_r => 0x0b43,
  :oriya_vowel_sign_e => 0x0b47,
  :oriya_vowel_sign_ai => 0x0b48,
  :oriya_vowel_sign_o => 0x0b4b,
  :oriya_vowel_sign_au => 0x0b4c,
  :oriya_sign_virama => 0x0b4d,
  :oriya_ai_length_mark => 0x0b56,
  :oriya_au_length_mark => 0x0b57,
  :oriya_letter_rra => 0x0b5c,
  :oriya_letter_rha => 0x0b5d,
  :oriya_letter_yya => 0x0b5f,
  :oriya_letter_vocalic_rr => 0x0b60,
  :oriya_letter_vocalic_ll => 0x0b61,
  :oriya_digit_zero => 0x0b66,
  :oriya_digit_one => 0x0b67,
  :oriya_digit_two => 0x0b68,
  :oriya_digit_three => 0x0b69,
  :oriya_digit_four => 0x0b6a,
  :oriya_digit_five => 0x0b6b,
  :oriya_digit_six => 0x0b6c,
  :oriya_digit_seven => 0x0b6d,
  :oriya_digit_eight => 0x0b6e,
  :oriya_digit_nine => 0x0b6f,
  :oriya_isshar => 0x0b70,
  :oriya_letter_wa => 0x0b71,
  :tamil_sign_anusvara => 0x0b82,
  :tamil_sign_visarga => 0x0b83,
  :tamil_letter_a => 0x0b85,
  :tamil_letter_aa => 0x0b86,
  :tamil_letter_i => 0x0b87,
  :tamil_letter_ii => 0x0b88,
  :tamil_letter_u => 0x0b89,
  :tamil_letter_uu => 0x0b8a,
  :tamil_letter_e => 0x0b8e,
  :tamil_letter_ee => 0x0b8f,
  :tamil_letter_ai => 0x0b90,
  :tamil_letter_o => 0x0b92,
  :tamil_letter_oo => 0x0b93,
  :tamil_letter_au => 0x0b94,
  :tamil_letter_ka => 0x0b95,
  :tamil_letter_nga => 0x0b99,
  :tamil_letter_ca => 0x0b9a,
  :tamil_letter_ja => 0x0b9c,
  :tamil_letter_nya => 0x0b9e,
  :tamil_letter_tta => 0x0b9f,
  :tamil_letter_nna => 0x0ba3,
  :tamil_letter_ta => 0x0ba4,
  :tamil_letter_na => 0x0ba8,
  :tamil_letter_nnna => 0x0ba9,
  :tamil_letter_pa => 0x0baa,
  :tamil_letter_ma => 0x0bae,
  :tamil_letter_ya => 0x0baf,
  :tamil_letter_ra => 0x0bb0,
  :tamil_letter_rra => 0x0bb1,
  :tamil_letter_la => 0x0bb2,
  :tamil_letter_lla => 0x0bb3,
  :tamil_letter_llla => 0x0bb4,
  :tamil_letter_va => 0x0bb5,
  :tamil_letter_sha => 0x0bb6,
  :tamil_letter_ssa => 0x0bb7,
  :tamil_letter_sa => 0x0bb8,
  :tamil_letter_ha => 0x0bb9,
  :tamil_vowel_sign_aa => 0x0bbe,
  :tamil_vowel_sign_i => 0x0bbf,
  :tamil_vowel_sign_ii => 0x0bc0,
  :tamil_vowel_sign_u => 0x0bc1,
  :tamil_vowel_sign_uu => 0x0bc2,
  :tamil_vowel_sign_e => 0x0bc6,
  :tamil_vowel_sign_ee => 0x0bc7,
  :tamil_vowel_sign_ai => 0x0bc8,
  :tamil_vowel_sign_o => 0x0bca,
  :tamil_vowel_sign_oo => 0x0bcb,
  :tamil_vowel_sign_au => 0x0bcc,
  :tamil_sign_virama => 0x0bcd,
  :tamil_au_length_mark => 0x0bd7,
  :tamil_digit_zero => 0x0be6,
  :tamil_digit_one => 0x0be7,
  :tamil_digit_two => 0x0be8,
  :tamil_digit_three => 0x0be9,
  :tamil_digit_four => 0x0bea,
  :tamil_digit_five => 0x0beb,
  :tamil_digit_six => 0x0bec,
  :tamil_digit_seven => 0x0bed,
  :tamil_digit_eight => 0x0bee,
  :tamil_digit_nine => 0x0bef,
  :tamil_number_ten => 0x0bf0,
  :tamil_number_one_hundred => 0x0bf1,
  :tamil_number_one_thousand => 0x0bf2,
  :tamil_day_sign => 0x0bf3,
  :tamil_month_sign => 0x0bf4,
  :tamil_year_sign => 0x0bf5,
  :tamil_debit_sign => 0x0bf6,
  :tamil_credit_sign => 0x0bf7,
  :tamil_as_above_sign => 0x0bf8,
  :tamil_rupee_sign => 0x0bf9,
  :tamil_number_sign => 0x0bfa,
  :telugu_sign_candrabindu => 0x0c01,
  :telugu_sign_anusvara => 0x0c02,
  :telugu_sign_visarga => 0x0c03,
  :telugu_letter_a => 0x0c05,
  :telugu_letter_aa => 0x0c06,
  :telugu_letter_i => 0x0c07,
  :telugu_letter_ii => 0x0c08,
  :telugu_letter_u => 0x0c09,
  :telugu_letter_uu => 0x0c0a,
  :telugu_letter_vocalic_r => 0x0c0b,
  :telugu_letter_vocalic_l => 0x0c0c,
  :telugu_letter_e => 0x0c0e,
  :telugu_letter_ee => 0x0c0f,
  :telugu_letter_ai => 0x0c10,
  :telugu_letter_o => 0x0c12,
  :telugu_letter_oo => 0x0c13,
  :telugu_letter_au => 0x0c14,
  :telugu_letter_ka => 0x0c15,
  :telugu_letter_kha => 0x0c16,
  :telugu_letter_ga => 0x0c17,
  :telugu_letter_gha => 0x0c18,
  :telugu_letter_nga => 0x0c19,
  :telugu_letter_ca => 0x0c1a,
  :telugu_letter_cha => 0x0c1b,
  :telugu_letter_ja => 0x0c1c,
  :telugu_letter_jha => 0x0c1d,
  :telugu_letter_nya => 0x0c1e,
  :telugu_letter_tta => 0x0c1f,
  :telugu_letter_ttha => 0x0c20,
  :telugu_letter_dda => 0x0c21,
  :telugu_letter_ddha => 0x0c22,
  :telugu_letter_nna => 0x0c23,
  :telugu_letter_ta => 0x0c24,
  :telugu_letter_tha => 0x0c25,
  :telugu_letter_da => 0x0c26,
  :telugu_letter_dha => 0x0c27,
  :telugu_letter_na => 0x0c28,
  :telugu_letter_pa => 0x0c2a,
  :telugu_letter_pha => 0x0c2b,
  :telugu_letter_ba => 0x0c2c,
  :telugu_letter_bha => 0x0c2d,
  :telugu_letter_ma => 0x0c2e,
  :telugu_letter_ya => 0x0c2f,
  :telugu_letter_ra => 0x0c30,
  :telugu_letter_rra => 0x0c31,
  :telugu_letter_la => 0x0c32,
  :telugu_letter_lla => 0x0c33,
  :telugu_letter_va => 0x0c35,
  :telugu_letter_sha => 0x0c36,
  :telugu_letter_ssa => 0x0c37,
  :telugu_letter_sa => 0x0c38,
  :telugu_letter_ha => 0x0c39,
  :telugu_vowel_sign_aa => 0x0c3e,
  :telugu_vowel_sign_i => 0x0c3f,
  :telugu_vowel_sign_ii => 0x0c40,
  :telugu_vowel_sign_u => 0x0c41,
  :telugu_vowel_sign_uu => 0x0c42,
  :telugu_vowel_sign_vocalic_r => 0x0c43,
  :telugu_vowel_sign_vocalic_rr => 0x0c44,
  :telugu_vowel_sign_e => 0x0c46,
  :telugu_vowel_sign_ee => 0x0c47,
  :telugu_vowel_sign_ai => 0x0c48,
  :telugu_vowel_sign_o => 0x0c4a,
  :telugu_vowel_sign_oo => 0x0c4b,
  :telugu_vowel_sign_au => 0x0c4c,
  :telugu_sign_virama => 0x0c4d,
  :telugu_length_mark => 0x0c55,
  :telugu_ai_length_mark => 0x0c56,
  :telugu_letter_vocalic_rr => 0x0c60,
  :telugu_letter_vocalic_ll => 0x0c61,
  :telugu_digit_zero => 0x0c66,
  :telugu_digit_one => 0x0c67,
  :telugu_digit_two => 0x0c68,
  :telugu_digit_three => 0x0c69,
  :telugu_digit_four => 0x0c6a,
  :telugu_digit_five => 0x0c6b,
  :telugu_digit_six => 0x0c6c,
  :telugu_digit_seven => 0x0c6d,
  :telugu_digit_eight => 0x0c6e,
  :telugu_digit_nine => 0x0c6f,
  :kannada_sign_anusvara => 0x0c82,
  :kannada_sign_visarga => 0x0c83,
  :kannada_letter_a => 0x0c85,
  :kannada_letter_aa => 0x0c86,
  :kannada_letter_i => 0x0c87,
  :kannada_letter_ii => 0x0c88,
  :kannada_letter_u => 0x0c89,
  :kannada_letter_uu => 0x0c8a,
  :kannada_letter_vocalic_r => 0x0c8b,
  :kannada_letter_vocalic_l => 0x0c8c,
  :kannada_letter_e => 0x0c8e,
  :kannada_letter_ee => 0x0c8f,
  :kannada_letter_ai => 0x0c90,
  :kannada_letter_o => 0x0c92,
  :kannada_letter_oo => 0x0c93,
  :kannada_letter_au => 0x0c94,
  :kannada_letter_ka => 0x0c95,
  :kannada_letter_kha => 0x0c96,
  :kannada_letter_ga => 0x0c97,
  :kannada_letter_gha => 0x0c98,
  :kannada_letter_nga => 0x0c99,
  :kannada_letter_ca => 0x0c9a,
  :kannada_letter_cha => 0x0c9b,
  :kannada_letter_ja => 0x0c9c,
  :kannada_letter_jha => 0x0c9d,
  :kannada_letter_nya => 0x0c9e,
  :kannada_letter_tta => 0x0c9f,
  :kannada_letter_ttha => 0x0ca0,
  :kannada_letter_dda => 0x0ca1,
  :kannada_letter_ddha => 0x0ca2,
  :kannada_letter_nna => 0x0ca3,
  :kannada_letter_ta => 0x0ca4,
  :kannada_letter_tha => 0x0ca5,
  :kannada_letter_da => 0x0ca6,
  :kannada_letter_dha => 0x0ca7,
  :kannada_letter_na => 0x0ca8,
  :kannada_letter_pa => 0x0caa,
  :kannada_letter_pha => 0x0cab,
  :kannada_letter_ba => 0x0cac,
  :kannada_letter_bha => 0x0cad,
  :kannada_letter_ma => 0x0cae,
  :kannada_letter_ya => 0x0caf,
  :kannada_letter_ra => 0x0cb0,
  :kannada_letter_rra => 0x0cb1,
  :kannada_letter_la => 0x0cb2,
  :kannada_letter_lla => 0x0cb3,
  :kannada_letter_va => 0x0cb5,
  :kannada_letter_sha => 0x0cb6,
  :kannada_letter_ssa => 0x0cb7,
  :kannada_letter_sa => 0x0cb8,
  :kannada_letter_ha => 0x0cb9,
  :kannada_sign_nukta => 0x0cbc,
  :kannada_sign_avagraha => 0x0cbd,
  :kannada_vowel_sign_aa => 0x0cbe,
  :kannada_vowel_sign_i => 0x0cbf,
  :kannada_vowel_sign_ii => 0x0cc0,
  :kannada_vowel_sign_u => 0x0cc1,
  :kannada_vowel_sign_uu => 0x0cc2,
  :kannada_vowel_sign_vocalic_r => 0x0cc3,
  :kannada_vowel_sign_vocalic_rr => 0x0cc4,
  :kannada_vowel_sign_e => 0x0cc6,
  :kannada_vowel_sign_ee => 0x0cc7,
  :kannada_vowel_sign_ai => 0x0cc8,
  :kannada_vowel_sign_o => 0x0cca,
  :kannada_vowel_sign_oo => 0x0ccb,
  :kannada_vowel_sign_au => 0x0ccc,
  :kannada_sign_virama => 0x0ccd,
  :kannada_length_mark => 0x0cd5,
  :kannada_ai_length_mark => 0x0cd6,
  :kannada_letter_fa => 0x0cde,
  :kannada_letter_vocalic_rr => 0x0ce0,
  :kannada_letter_vocalic_ll => 0x0ce1,
  :kannada_digit_zero => 0x0ce6,
  :kannada_digit_one => 0x0ce7,
  :kannada_digit_two => 0x0ce8,
  :kannada_digit_three => 0x0ce9,
  :kannada_digit_four => 0x0cea,
  :kannada_digit_five => 0x0ceb,
  :kannada_digit_six => 0x0cec,
  :kannada_digit_seven => 0x0ced,
  :kannada_digit_eight => 0x0cee,
  :kannada_digit_nine => 0x0cef,
  :malayalam_sign_anusvara => 0x0d02,
  :malayalam_sign_visarga => 0x0d03,
  :malayalam_letter_a => 0x0d05,
  :malayalam_letter_aa => 0x0d06,
  :malayalam_letter_i => 0x0d07,
  :malayalam_letter_ii => 0x0d08,
  :malayalam_letter_u => 0x0d09,
  :malayalam_letter_uu => 0x0d0a,
  :malayalam_letter_vocalic_r => 0x0d0b,
  :malayalam_letter_vocalic_l => 0x0d0c,
  :malayalam_letter_e => 0x0d0e,
  :malayalam_letter_ee => 0x0d0f,
  :malayalam_letter_ai => 0x0d10,
  :malayalam_letter_o => 0x0d12,
  :malayalam_letter_oo => 0x0d13,
  :malayalam_letter_au => 0x0d14,
  :malayalam_letter_ka => 0x0d15,
  :malayalam_letter_kha => 0x0d16,
  :malayalam_letter_ga => 0x0d17,
  :malayalam_letter_gha => 0x0d18,
  :malayalam_letter_nga => 0x0d19,
  :malayalam_letter_ca => 0x0d1a,
  :malayalam_letter_cha => 0x0d1b,
  :malayalam_letter_ja => 0x0d1c,
  :malayalam_letter_jha => 0x0d1d,
  :malayalam_letter_nya => 0x0d1e,
  :malayalam_letter_tta => 0x0d1f,
  :malayalam_letter_ttha => 0x0d20,
  :malayalam_letter_dda => 0x0d21,
  :malayalam_letter_ddha => 0x0d22,
  :malayalam_letter_nna => 0x0d23,
  :malayalam_letter_ta => 0x0d24,
  :malayalam_letter_tha => 0x0d25,
  :malayalam_letter_da => 0x0d26,
  :malayalam_letter_dha => 0x0d27,
  :malayalam_letter_na => 0x0d28,
  :malayalam_letter_pa => 0x0d2a,
  :malayalam_letter_pha => 0x0d2b,
  :malayalam_letter_ba => 0x0d2c,
  :malayalam_letter_bha => 0x0d2d,
  :malayalam_letter_ma => 0x0d2e,
  :malayalam_letter_ya => 0x0d2f,
  :malayalam_letter_ra => 0x0d30,
  :malayalam_letter_rra => 0x0d31,
  :malayalam_letter_la => 0x0d32,
  :malayalam_letter_lla => 0x0d33,
  :malayalam_letter_llla => 0x0d34,
  :malayalam_letter_va => 0x0d35,
  :malayalam_letter_sha => 0x0d36,
  :malayalam_letter_ssa => 0x0d37,
  :malayalam_letter_sa => 0x0d38,
  :malayalam_letter_ha => 0x0d39,
  :malayalam_vowel_sign_aa => 0x0d3e,
  :malayalam_vowel_sign_i => 0x0d3f,
  :malayalam_vowel_sign_ii => 0x0d40,
  :malayalam_vowel_sign_u => 0x0d41,
  :malayalam_vowel_sign_uu => 0x0d42,
  :malayalam_vowel_sign_vocalic_r => 0x0d43,
  :malayalam_vowel_sign_e => 0x0d46,
  :malayalam_vowel_sign_ee => 0x0d47,
  :malayalam_vowel_sign_ai => 0x0d48,
  :malayalam_vowel_sign_o => 0x0d4a,
  :malayalam_vowel_sign_oo => 0x0d4b,
  :malayalam_vowel_sign_au => 0x0d4c,
  :malayalam_sign_virama => 0x0d4d,
  :malayalam_au_length_mark => 0x0d57,
  :malayalam_letter_vocalic_rr => 0x0d60,
  :malayalam_letter_vocalic_ll => 0x0d61,
  :malayalam_digit_zero => 0x0d66,
  :malayalam_digit_one => 0x0d67,
  :malayalam_digit_two => 0x0d68,
  :malayalam_digit_three => 0x0d69,
  :malayalam_digit_four => 0x0d6a,
  :malayalam_digit_five => 0x0d6b,
  :malayalam_digit_six => 0x0d6c,
  :malayalam_digit_seven => 0x0d6d,
  :malayalam_digit_eight => 0x0d6e,
  :malayalam_digit_nine => 0x0d6f,
  :sinhala_sign_anusvaraya => 0x0d82,
  :sinhala_sign_visargaya => 0x0d83,
  :sinhala_letter_ayanna => 0x0d85,
  :sinhala_letter_aayanna => 0x0d86,
  :sinhala_letter_aeyanna => 0x0d87,
  :sinhala_letter_aeeyanna => 0x0d88,
  :sinhala_letter_iyanna => 0x0d89,
  :sinhala_letter_iiyanna => 0x0d8a,
  :sinhala_letter_uyanna => 0x0d8b,
  :sinhala_letter_uuyanna => 0x0d8c,
  :sinhala_letter_iruyanna => 0x0d8d,
  :sinhala_letter_iruuyanna => 0x0d8e,
  :sinhala_letter_iluyanna => 0x0d8f,
  :sinhala_letter_iluuyanna => 0x0d90,
  :sinhala_letter_eyanna => 0x0d91,
  :sinhala_letter_eeyanna => 0x0d92,
  :sinhala_letter_aiyanna => 0x0d93,
  :sinhala_letter_oyanna => 0x0d94,
  :sinhala_letter_ooyanna => 0x0d95,
  :sinhala_letter_auyanna => 0x0d96,
  :sinhala_letter_alpapraana_kayanna => 0x0d9a,
  :sinhala_letter_mahaapraana_kayanna => 0x0d9b,
  :sinhala_letter_alpapraana_gayanna => 0x0d9c,
  :sinhala_letter_mahaapraana_gayanna => 0x0d9d,
  :sinhala_letter_kantaja_naasikyaya => 0x0d9e,
  :sinhala_letter_sanyaka_gayanna => 0x0d9f,
  :sinhala_letter_alpapraana_cayanna => 0x0da0,
  :sinhala_letter_mahaapraana_cayanna => 0x0da1,
  :sinhala_letter_alpapraana_jayanna => 0x0da2,
  :sinhala_letter_mahaapraana_jayanna => 0x0da3,
  :sinhala_letter_taaluja_naasikyaya => 0x0da4,
  :sinhala_letter_taaluja_sanyooga_naaksikyaya => 0x0da5,
  :sinhala_letter_sanyaka_jayanna => 0x0da6,
  :sinhala_letter_alpapraana_ttayanna => 0x0da7,
  :sinhala_letter_mahaapraana_ttayanna => 0x0da8,
  :sinhala_letter_alpapraana_ddayanna => 0x0da9,
  :sinhala_letter_mahaapraana_ddayanna => 0x0daa,
  :sinhala_letter_muurdhaja_nayanna => 0x0dab,
  :sinhala_letter_sanyaka_ddayanna => 0x0dac,
  :sinhala_letter_alpapraana_tayanna => 0x0dad,
  :sinhala_letter_mahaapraana_tayanna => 0x0dae,
  :sinhala_letter_alpapraana_dayanna => 0x0daf,
  :sinhala_letter_mahaapraana_dayanna => 0x0db0,
  :sinhala_letter_dantaja_nayanna => 0x0db1,
  :sinhala_letter_sanyaka_dayanna => 0x0db3,
  :sinhala_letter_alpapraana_payanna => 0x0db4,
  :sinhala_letter_mahaapraana_payanna => 0x0db5,
  :sinhala_letter_alpapraana_bayanna => 0x0db6,
  :sinhala_letter_mahaapraana_bayanna => 0x0db7,
  :sinhala_letter_mayanna => 0x0db8,
  :sinhala_letter_amba_bayanna => 0x0db9,
  :sinhala_letter_yayanna => 0x0dba,
  :sinhala_letter_rayanna => 0x0dbb,
  :sinhala_letter_dantaja_layanna => 0x0dbd,
  :sinhala_letter_vayanna => 0x0dc0,
  :sinhala_letter_taaluja_sayanna => 0x0dc1,
  :sinhala_letter_muurdhaja_sayanna => 0x0dc2,
  :sinhala_letter_dantaja_sayanna => 0x0dc3,
  :sinhala_letter_hayanna => 0x0dc4,
  :sinhala_letter_muurdhaja_layanna => 0x0dc5,
  :sinhala_letter_fayanna => 0x0dc6,
  :sinhala_sign_al_lakuna => 0x0dca,
  :sinhala_vowel_sign_aela_pilla => 0x0dcf,
  :sinhala_vowel_sign_ketti_aeda_pilla => 0x0dd0,
  :sinhala_vowel_sign_diga_aeda_pilla => 0x0dd1,
  :sinhala_vowel_sign_ketti_is_pilla => 0x0dd2,
  :sinhala_vowel_sign_diga_is_pilla => 0x0dd3,
  :sinhala_vowel_sign_ketti_paa_pilla => 0x0dd4,
  :sinhala_vowel_sign_diga_paa_pilla => 0x0dd6,
  :sinhala_vowel_sign_gaetta_pilla => 0x0dd8,
  :sinhala_vowel_sign_kombuva => 0x0dd9,
  :sinhala_vowel_sign_diga_kombuva => 0x0dda,
  :sinhala_vowel_sign_kombu_deka => 0x0ddb,
  :sinhala_vowel_sign_kombuva_haa_aela_pilla => 0x0ddc,
  :sinhala_vowel_sign_kombuva_haa_diga_aela_pilla => 0x0ddd,
  :sinhala_vowel_sign_kombuva_haa_gayanukitta => 0x0dde,
  :sinhala_vowel_sign_gayanukitta => 0x0ddf,
  :sinhala_vowel_sign_diga_gaetta_pilla => 0x0df2,
  :sinhala_vowel_sign_diga_gayanukitta => 0x0df3,
  :sinhala_punctuation_kunddaliya => 0x0df4,
  :thai_character_ko_kai => 0x0e01,
  :thai_letter_ko_kai => 0x0e01,
  :thai_character_kho_khai => 0x0e02,
  :thai_letter_kho_khai => 0x0e02,
  :thai_character_kho_khuat => 0x0e03,
  :thai_letter_kho_khuat => 0x0e03,
  :thai_character_kho_khwai => 0x0e04,
  :thai_letter_kho_khwai => 0x0e04,
  :thai_character_kho_khon => 0x0e05,
  :thai_letter_kho_khon => 0x0e05,
  :thai_character_kho_rakhang => 0x0e06,
  :thai_letter_kho_rakhang => 0x0e06,
  :thai_character_ngo_ngu => 0x0e07,
  :thai_letter_ngo_ngu => 0x0e07,
  :thai_character_cho_chan => 0x0e08,
  :thai_letter_cho_chan => 0x0e08,
  :thai_character_cho_ching => 0x0e09,
  :thai_letter_cho_ching => 0x0e09,
  :thai_character_cho_chang => 0x0e0a,
  :thai_letter_cho_chang => 0x0e0a,
  :thai_character_so_so => 0x0e0b,
  :thai_letter_so_so => 0x0e0b,
  :thai_character_cho_choe => 0x0e0c,
  :thai_letter_cho_choe => 0x0e0c,
  :thai_character_yo_ying => 0x0e0d,
  :thai_letter_yo_ying => 0x0e0d,
  :thai_character_do_chada => 0x0e0e,
  :thai_letter_do_chada => 0x0e0e,
  :thai_character_to_patak => 0x0e0f,
  :thai_letter_to_patak => 0x0e0f,
  :thai_character_tho_than => 0x0e10,
  :thai_letter_tho_than => 0x0e10,
  :thai_character_tho_nangmontho => 0x0e11,
  :thai_letter_tho_nangmontho => 0x0e11,
  :thai_character_tho_phuthao => 0x0e12,
  :thai_letter_tho_phuthao => 0x0e12,
  :thai_character_no_nen => 0x0e13,
  :thai_letter_no_nen => 0x0e13,
  :thai_character_do_dek => 0x0e14,
  :thai_letter_do_dek => 0x0e14,
  :thai_character_to_tao => 0x0e15,
  :thai_letter_to_tao => 0x0e15,
  :thai_character_tho_thung => 0x0e16,
  :thai_letter_tho_thung => 0x0e16,
  :thai_character_tho_thahan => 0x0e17,
  :thai_letter_tho_thahan => 0x0e17,
  :thai_character_tho_thong => 0x0e18,
  :thai_letter_tho_thong => 0x0e18,
  :thai_character_no_nu => 0x0e19,
  :thai_letter_no_nu => 0x0e19,
  :thai_character_bo_baimai => 0x0e1a,
  :thai_letter_bo_baimai => 0x0e1a,
  :thai_character_po_pla => 0x0e1b,
  :thai_letter_po_pla => 0x0e1b,
  :thai_character_pho_phung => 0x0e1c,
  :thai_letter_pho_phung => 0x0e1c,
  :thai_character_fo_fa => 0x0e1d,
  :thai_letter_fo_fa => 0x0e1d,
  :thai_character_pho_phan => 0x0e1e,
  :thai_letter_pho_phan => 0x0e1e,
  :thai_character_fo_fan => 0x0e1f,
  :thai_letter_fo_fan => 0x0e1f,
  :thai_character_pho_samphao => 0x0e20,
  :thai_letter_pho_samphao => 0x0e20,
  :thai_character_mo_ma => 0x0e21,
  :thai_letter_mo_ma => 0x0e21,
  :thai_character_yo_yak => 0x0e22,
  :thai_letter_yo_yak => 0x0e22,
  :thai_character_ro_rua => 0x0e23,
  :thai_letter_ro_rua => 0x0e23,
  :thai_character_ru => 0x0e24,
  :thai_letter_ru => 0x0e24,
  :thai_character_lo_ling => 0x0e25,
  :thai_letter_lo_ling => 0x0e25,
  :thai_character_lu => 0x0e26,
  :thai_letter_lu => 0x0e26,
  :thai_character_wo_waen => 0x0e27,
  :thai_letter_wo_waen => 0x0e27,
  :thai_character_so_sala => 0x0e28,
  :thai_letter_so_sala => 0x0e28,
  :thai_character_so_rusi => 0x0e29,
  :thai_letter_so_rusi => 0x0e29,
  :thai_character_so_sua => 0x0e2a,
  :thai_letter_so_sua => 0x0e2a,
  :thai_character_ho_hip => 0x0e2b,
  :thai_letter_ho_hip => 0x0e2b,
  :thai_character_lo_chula => 0x0e2c,
  :thai_letter_lo_chula => 0x0e2c,
  :thai_character_o_ang => 0x0e2d,
  :thai_letter_o_ang => 0x0e2d,
  :thai_character_ho_nokhuk => 0x0e2e,
  :thai_letter_ho_nok_huk => 0x0e2e,
  :thai_character_paiyannoi => 0x0e2f,
  :thai_pai_yan_noi => 0x0e2f,
  :thai_character_sara_a => 0x0e30,
  :thai_vowel_sign_sara_a => 0x0e30,
  :thai_character_mai_han_akat => 0x0e31,
  :thai_vowel_sign_mai_han_akat => 0x0e31,
  :thai_character_sara_aa => 0x0e32,
  :thai_vowel_sign_sara_aa => 0x0e32,
  :thai_character_sara_am => 0x0e33,
  :thai_vowel_sign_sara_am => 0x0e33,
  :thai_character_sara_i => 0x0e34,
  :thai_vowel_sign_sara_i => 0x0e34,
  :thai_character_sara_ii => 0x0e35,
  :thai_vowel_sign_sara_ii => 0x0e35,
  :thai_character_sara_ue => 0x0e36,
  :thai_vowel_sign_sara_ue => 0x0e36,
  :thai_character_sara_uee => 0x0e37,
  :thai_vowel_sign_sara_uee => 0x0e37,
  :thai_character_sara_u => 0x0e38,
  :thai_vowel_sign_sara_u => 0x0e38,
  :thai_character_sara_uu => 0x0e39,
  :thai_vowel_sign_sara_uu => 0x0e39,
  :thai_character_phinthu => 0x0e3a,
  :thai_vowel_sign_phinthu => 0x0e3a,
  :thai_currency_symbol_baht => 0x0e3f,
  :thai_baht_sign => 0x0e3f,
  :thai_character_sara_e => 0x0e40,
  :thai_vowel_sign_sara_e => 0x0e40,
  :thai_character_sara_ae => 0x0e41,
  :thai_vowel_sign_sara_ae => 0x0e41,
  :thai_character_sara_o => 0x0e42,
  :thai_vowel_sign_sara_o => 0x0e42,
  :thai_character_sara_ai_maimuan => 0x0e43,
  :thai_vowel_sign_sara_mai_muan => 0x0e43,
  :thai_character_sara_ai_maimalai => 0x0e44,
  :thai_vowel_sign_sara_mai_malai => 0x0e44,
  :thai_character_lakkhangyao => 0x0e45,
  :thai_lak_khang_yao => 0x0e45,
  :thai_character_maiyamok => 0x0e46,
  :thai_mai_yamok => 0x0e46,
  :thai_character_maitaikhu => 0x0e47,
  :thai_vowel_sign_mai_tai_khu => 0x0e47,
  :thai_character_mai_ek => 0x0e48,
  :thai_tone_mai_ek => 0x0e48,
  :thai_character_mai_tho => 0x0e49,
  :thai_tone_mai_tho => 0x0e49,
  :thai_character_mai_tri => 0x0e4a,
  :thai_tone_mai_tri => 0x0e4a,
  :thai_character_mai_chattawa => 0x0e4b,
  :thai_tone_mai_chattawa => 0x0e4b,
  :thai_character_thanthakhat => 0x0e4c,
  :thai_thanthakhat => 0x0e4c,
  :thai_character_nikhahit => 0x0e4d,
  :thai_nikkhahit => 0x0e4d,
  :thai_character_yamakkan => 0x0e4e,
  :thai_yamakkan => 0x0e4e,
  :thai_character_fongman => 0x0e4f,
  :thai_fongman => 0x0e4f,
  :thai_digit_zero => 0x0e50,
  :thai_digit_one => 0x0e51,
  :thai_digit_two => 0x0e52,
  :thai_digit_three => 0x0e53,
  :thai_digit_four => 0x0e54,
  :thai_digit_five => 0x0e55,
  :thai_digit_six => 0x0e56,
  :thai_digit_seven => 0x0e57,
  :thai_digit_eight => 0x0e58,
  :thai_digit_nine => 0x0e59,
  :thai_character_angkhankhu => 0x0e5a,
  :thai_angkhankhu => 0x0e5a,
  :thai_character_khomut => 0x0e5b,
  :thai_khomut => 0x0e5b,
  :lao_letter_ko => 0x0e81,
  :lao_letter_kho_sung => 0x0e82,
  :lao_letter_kho_tam => 0x0e84,
  :lao_letter_ngo => 0x0e87,
  :lao_letter_co => 0x0e88,
  :lao_letter_so_tam => 0x0e8a,
  :lao_letter_nyo => 0x0e8d,
  :lao_letter_do => 0x0e94,
  :lao_letter_to => 0x0e95,
  :lao_letter_tho_sung => 0x0e96,
  :lao_letter_tho_tam => 0x0e97,
  :lao_letter_no => 0x0e99,
  :lao_letter_bo => 0x0e9a,
  :lao_letter_po => 0x0e9b,
  :lao_letter_pho_sung => 0x0e9c,
  :lao_letter_fo_tam => 0x0e9d,
  :lao_letter_pho_tam => 0x0e9e,
  :lao_letter_fo_sung => 0x0e9f,
  :lao_letter_mo => 0x0ea1,
  :lao_letter_yo => 0x0ea2,
  :lao_letter_lo_ling => 0x0ea3,
  :lao_letter_lo_loot => 0x0ea5,
  :lao_letter_wo => 0x0ea7,
  :lao_letter_so_sung => 0x0eaa,
  :lao_letter_ho_sung => 0x0eab,
  :lao_letter_o => 0x0ead,
  :lao_letter_ho_tam => 0x0eae,
  :lao_ellipsis => 0x0eaf,
  :lao_vowel_sign_a => 0x0eb0,
  :lao_vowel_sign_mai_kan => 0x0eb1,
  :lao_vowel_sign_aa => 0x0eb2,
  :lao_vowel_sign_am => 0x0eb3,
  :lao_vowel_sign_i => 0x0eb4,
  :lao_vowel_sign_ii => 0x0eb5,
  :lao_vowel_sign_y => 0x0eb6,
  :lao_vowel_sign_yy => 0x0eb7,
  :lao_vowel_sign_u => 0x0eb8,
  :lao_vowel_sign_uu => 0x0eb9,
  :lao_vowel_sign_mai_kon => 0x0ebb,
  :lao_semivowel_sign_lo => 0x0ebc,
  :lao_semivowel_sign_nyo => 0x0ebd,
  :lao_vowel_sign_e => 0x0ec0,
  :lao_vowel_sign_ei => 0x0ec1,
  :lao_vowel_sign_o => 0x0ec2,
  :lao_vowel_sign_ay => 0x0ec3,
  :lao_vowel_sign_ai => 0x0ec4,
  :lao_ko_la => 0x0ec6,
  :lao_tone_mai_ek => 0x0ec8,
  :lao_tone_mai_tho => 0x0ec9,
  :lao_tone_mai_ti => 0x0eca,
  :lao_tone_mai_catawa => 0x0ecb,
  :lao_cancellation_mark => 0x0ecc,
  :lao_niggahita => 0x0ecd,
  :lao_digit_zero => 0x0ed0,
  :lao_digit_one => 0x0ed1,
  :lao_digit_two => 0x0ed2,
  :lao_digit_three => 0x0ed3,
  :lao_digit_four => 0x0ed4,
  :lao_digit_five => 0x0ed5,
  :lao_digit_six => 0x0ed6,
  :lao_digit_seven => 0x0ed7,
  :lao_digit_eight => 0x0ed8,
  :lao_digit_nine => 0x0ed9,
  :lao_ho_no => 0x0edc,
  :lao_ho_mo => 0x0edd,
  :tibetan_syllable_om => 0x0f00,
  :tibetan_mark_gter_yig_mgo_truncated_a => 0x0f01,
  :tibetan_mark_gter_yig_mgo__um_rnam_bcad_ma => 0x0f02,
  :tibetan_mark_gter_yig_mgo__um_gter_tsheg_ma => 0x0f03,
  :tibetan_mark_initial_yig_mgo_mdun_ma => 0x0f04,
  :tibetan_single_ornament => 0x0f04,
  :tibetan_mark_closing_yig_mgo_sgab_ma => 0x0f05,
  :tibetan_mark_caret_yig_mgo_phur_shad_ma => 0x0f06,
  :tibetan_mark_yig_mgo_tsheg_shad_ma => 0x0f07,
  :tibetan_mark_sbrul_shad => 0x0f08,
  :tibetan_rgyanshad => 0x0f08,
  :tibetan_mark_bskur_yig_mgo => 0x0f09,
  :tibetan_mark_bka__shog_yig_mgo => 0x0f0a,
  :tibetan_mark_intersyllabic_tsheg => 0x0f0b,
  :tibetan_tseg => 0x0f0b,
  :tibetan_mark_delimiter_tsheg_bstar => 0x0f0c,
  :tibetan_mark_shad => 0x0f0d,
  :tibetan_shad => 0x0f0d,
  :tibetan_mark_nyis_shad => 0x0f0e,
  :tibetan_double_shad => 0x0f0e,
  :tibetan_mark_tsheg_shad => 0x0f0f,
  :tibetan_mark_nyis_tsheg_shad => 0x0f10,
  :tibetan_mark_rin_chen_spungs_shad => 0x0f11,
  :tibetan_rinchanphungshad => 0x0f11,
  :tibetan_mark_rgya_gram_shad => 0x0f12,
  :tibetan_mark_caret__dzud_rtags_me_long_can => 0x0f13,
  :tibetan_mark_gter_tsheg => 0x0f14,
  :tibetan_comma => 0x0f14,
  :tibetan_logotype_sign_chad_rtags => 0x0f15,
  :tibetan_logotype_sign_lhag_rtags => 0x0f16,
  :tibetan_astrological_sign_sgra_gcan__char_rtags => 0x0f17,
  :tibetan_astrological_sign__khyud_pa => 0x0f18,
  :tibetan_astrological_sign_sdong_tshugs => 0x0f19,
  :tibetan_sign_rdel_dkar_gcig => 0x0f1a,
  :tibetan_sign_rdel_dkar_gnyis => 0x0f1b,
  :tibetan_sign_rdel_dkar_gsum => 0x0f1c,
  :tibetan_sign_rdel_nag_gcig => 0x0f1d,
  :tibetan_sign_rdel_nag_gnyis => 0x0f1e,
  :tibetan_sign_rdel_dkar_rdel_nag => 0x0f1f,
  :tibetan_digit_zero => 0x0f20,
  :tibetan_digit_one => 0x0f21,
  :tibetan_digit_two => 0x0f22,
  :tibetan_digit_three => 0x0f23,
  :tibetan_digit_four => 0x0f24,
  :tibetan_digit_five => 0x0f25,
  :tibetan_digit_six => 0x0f26,
  :tibetan_digit_seven => 0x0f27,
  :tibetan_digit_eight => 0x0f28,
  :tibetan_digit_nine => 0x0f29,
  :tibetan_digit_half_one => 0x0f2a,
  :tibetan_digit_half_two => 0x0f2b,
  :tibetan_digit_half_three => 0x0f2c,
  :tibetan_digit_half_four => 0x0f2d,
  :tibetan_digit_half_five => 0x0f2e,
  :tibetan_digit_half_six => 0x0f2f,
  :tibetan_digit_half_seven => 0x0f30,
  :tibetan_digit_half_eight => 0x0f31,
  :tibetan_digit_half_nine => 0x0f32,
  :tibetan_digit_half_zero => 0x0f33,
  :tibetan_mark_bsdus_rtags => 0x0f34,
  :tibetan_mark_ngas_bzung_nyi_zla => 0x0f35,
  :tibetan_honorific_under_ring => 0x0f35,
  :tibetan_mark_caret__dzud_rtags_bzhi_mig_can => 0x0f36,
  :tibetan_mark_ngas_bzung_sgor_rtags => 0x0f37,
  :tibetan_under_ring => 0x0f37,
  :tibetan_mark_che_mgo => 0x0f38,
  :tibetan_mark_tsa__phru => 0x0f39,
  :tibetan_lenition_mark => 0x0f39,
  :tibetan_mark_gug_rtags_gyon => 0x0f3a,
  :tibetan_mark_gug_rtags_gyas => 0x0f3b,
  :tibetan_mark_ang_khang_gyon => 0x0f3c,
  :tibetan_left_brace => 0x0f3c,
  :tibetan_mark_ang_khang_gyas => 0x0f3d,
  :tibetan_right_brace => 0x0f3d,
  :tibetan_sign_yar_tshes => 0x0f3e,
  :tibetan_sign_mar_tshes => 0x0f3f,
  :tibetan_letter_ka => 0x0f40,
  :tibetan_letter_kha => 0x0f41,
  :tibetan_letter_ga => 0x0f42,
  :tibetan_letter_gha => 0x0f43,
  :tibetan_letter_nga => 0x0f44,
  :tibetan_letter_ca => 0x0f45,
  :tibetan_letter_cha => 0x0f46,
  :tibetan_letter_ja => 0x0f47,
  :tibetan_letter_nya => 0x0f49,
  :tibetan_letter_tta => 0x0f4a,
  :tibetan_letter_reversed_ta => 0x0f4a,
  :tibetan_letter_ttha => 0x0f4b,
  :tibetan_letter_reversed_tha => 0x0f4b,
  :tibetan_letter_dda => 0x0f4c,
  :tibetan_letter_reversed_da => 0x0f4c,
  :tibetan_letter_ddha => 0x0f4d,
  :tibetan_letter_nna => 0x0f4e,
  :tibetan_letter_reversed_na => 0x0f4e,
  :tibetan_letter_ta => 0x0f4f,
  :tibetan_letter_tha => 0x0f50,
  :tibetan_letter_da => 0x0f51,
  :tibetan_letter_dha => 0x0f52,
  :tibetan_letter_na => 0x0f53,
  :tibetan_letter_pa => 0x0f54,
  :tibetan_letter_pha => 0x0f55,
  :tibetan_letter_ba => 0x0f56,
  :tibetan_letter_bha => 0x0f57,
  :tibetan_letter_ma => 0x0f58,
  :tibetan_letter_tsa => 0x0f59,
  :tibetan_letter_tsha => 0x0f5a,
  :tibetan_letter_dza => 0x0f5b,
  :tibetan_letter_dzha => 0x0f5c,
  :tibetan_letter_wa => 0x0f5d,
  :tibetan_letter_zha => 0x0f5e,
  :tibetan_letter_za => 0x0f5f,
  :tibetan_letter__a => 0x0f60,
  :tibetan_letter_aa => 0x0f60,
  :tibetan_letter_ya => 0x0f61,
  :tibetan_letter_ra => 0x0f62,
  :tibetan_letter_la => 0x0f63,
  :tibetan_letter_sha => 0x0f64,
  :tibetan_letter_ssa => 0x0f65,
  :tibetan_letter_reversed_sha => 0x0f65,
  :tibetan_letter_sa => 0x0f66,
  :tibetan_letter_ha => 0x0f67,
  :tibetan_letter_a => 0x0f68,
  :tibetan_letter_kssa => 0x0f69,
  :tibetan_letter_fixed_form_ra => 0x0f6a,
  :tibetan_vowel_sign_aa => 0x0f71,
  :tibetan_vowel_sign_i => 0x0f72,
  :tibetan_vowel_sign_ii => 0x0f73,
  :tibetan_vowel_sign_u => 0x0f74,
  :tibetan_vowel_sign_uu => 0x0f75,
  :tibetan_vowel_sign_vocalic_r => 0x0f76,
  :tibetan_vowel_sign_vocalic_rr => 0x0f77,
  :tibetan_vowel_sign_vocalic_l => 0x0f78,
  :tibetan_vowel_sign_vocalic_ll => 0x0f79,
  :tibetan_vowel_sign_e => 0x0f7a,
  :tibetan_vowel_sign_ee => 0x0f7b,
  :tibetan_vowel_sign_ai => 0x0f7b,
  :tibetan_vowel_sign_o => 0x0f7c,
  :tibetan_vowel_sign_oo => 0x0f7d,
  :tibetan_vowel_sign_au => 0x0f7d,
  :tibetan_sign_rjes_su_nga_ro => 0x0f7e,
  :tibetan_anusvara => 0x0f7e,
  :tibetan_sign_rnam_bcad => 0x0f7f,
  :tibetan_visarga => 0x0f7f,
  :tibetan_vowel_sign_reversed_i => 0x0f80,
  :tibetan_vowel_sign_short_i => 0x0f80,
  :tibetan_vowel_sign_reversed_ii => 0x0f81,
  :tibetan_sign_nyi_zla_naa_da => 0x0f82,
  :tibetan_candrabindu_with_ornament => 0x0f82,
  :tibetan_sign_sna_ldan => 0x0f83,
  :tibetan_candrabindu => 0x0f83,
  :tibetan_mark_halanta => 0x0f84,
  :tibetan_virama => 0x0f84,
  :tibetan_mark_paluta => 0x0f85,
  :tibetan_chuchenyige => 0x0f85,
  :tibetan_sign_lci_rtags => 0x0f86,
  :tibetan_sign_yang_rtags => 0x0f87,
  :tibetan_sign_lce_tsa_can => 0x0f88,
  :tibetan_sign_mchu_can => 0x0f89,
  :tibetan_sign_gru_can_rgyings => 0x0f8a,
  :tibetan_sign_gru_med_rgyings => 0x0f8b,
  :tibetan_subjoined_letter_ka => 0x0f90,
  :tibetan_subjoined_letter_kha => 0x0f91,
  :tibetan_subjoined_letter_ga => 0x0f92,
  :tibetan_subjoined_letter_gha => 0x0f93,
  :tibetan_subjoined_letter_nga => 0x0f94,
  :tibetan_subjoined_letter_ca => 0x0f95,
  :tibetan_subjoined_letter_cha => 0x0f96,
  :tibetan_subjoined_letter_ja => 0x0f97,
  :tibetan_subjoined_letter_nya => 0x0f99,
  :tibetan_subjoined_letter_tta => 0x0f9a,
  :tibetan_subjoined_letter_ttha => 0x0f9b,
  :tibetan_subjoined_letter_dda => 0x0f9c,
  :tibetan_subjoined_letter_ddha => 0x0f9d,
  :tibetan_subjoined_letter_nna => 0x0f9e,
  :tibetan_subjoined_letter_ta => 0x0f9f,
  :tibetan_subjoined_letter_tha => 0x0fa0,
  :tibetan_subjoined_letter_da => 0x0fa1,
  :tibetan_subjoined_letter_dha => 0x0fa2,
  :tibetan_subjoined_letter_na => 0x0fa3,
  :tibetan_subjoined_letter_pa => 0x0fa4,
  :tibetan_subjoined_letter_pha => 0x0fa5,
  :tibetan_subjoined_letter_ba => 0x0fa6,
  :tibetan_subjoined_letter_bha => 0x0fa7,
  :tibetan_subjoined_letter_ma => 0x0fa8,
  :tibetan_subjoined_letter_tsa => 0x0fa9,
  :tibetan_subjoined_letter_tsha => 0x0faa,
  :tibetan_subjoined_letter_dza => 0x0fab,
  :tibetan_subjoined_letter_dzha => 0x0fac,
  :tibetan_subjoined_letter_wa => 0x0fad,
  :tibetan_subjoined_letter_zha => 0x0fae,
  :tibetan_subjoined_letter_za => 0x0faf,
  :tibetan_subjoined_letter__a => 0x0fb0,
  :tibetan_subjoined_letter_ya => 0x0fb1,
  :tibetan_subjoined_letter_ra => 0x0fb2,
  :tibetan_subjoined_letter_la => 0x0fb3,
  :tibetan_subjoined_letter_sha => 0x0fb4,
  :tibetan_subjoined_letter_ssa => 0x0fb5,
  :tibetan_subjoined_letter_sa => 0x0fb6,
  :tibetan_subjoined_letter_ha => 0x0fb7,
  :tibetan_subjoined_letter_a => 0x0fb8,
  :tibetan_subjoined_letter_kssa => 0x0fb9,
  :tibetan_subjoined_letter_fixed_form_wa => 0x0fba,
  :tibetan_subjoined_letter_fixed_form_ya => 0x0fbb,
  :tibetan_subjoined_letter_fixed_form_ra => 0x0fbc,
  :tibetan_ku_ru_kha => 0x0fbe,
  :tibetan_ku_ru_kha_bzhi_mig_can => 0x0fbf,
  :tibetan_cantillation_sign_heavy_beat => 0x0fc0,
  :tibetan_cantillation_sign_light_beat => 0x0fc1,
  :tibetan_cantillation_sign_cang_te_u => 0x0fc2,
  :tibetan_cantillation_sign_sbub__chal => 0x0fc3,
  :tibetan_symbol_dril_bu => 0x0fc4,
  :tibetan_symbol_rdo_rje => 0x0fc5,
  :tibetan_symbol_padma_gdan => 0x0fc6,
  :tibetan_symbol_rdo_rje_rgya_gram => 0x0fc7,
  :tibetan_symbol_phur_pa => 0x0fc8,
  :tibetan_symbol_nor_bu => 0x0fc9,
  :tibetan_symbol_nor_bu_nyis__khyil => 0x0fca,
  :tibetan_symbol_nor_bu_gsum__khyil => 0x0fcb,
  :tibetan_symbol_nor_bu_bzhi__khyil => 0x0fcc,
  :tibetan_sign_rdel_nag_gsum => 0x0fcf,
  :tibetan_mark_bska__shog_gi_mgo_rgyan => 0x0fd0,
  :tibetan_mark_mnyam_yig_gi_mgo_rgyan => 0x0fd1,
  :myanmar_letter_ka => 0x1000,
  :myanmar_letter_kha => 0x1001,
  :myanmar_letter_ga => 0x1002,
  :myanmar_letter_gha => 0x1003,
  :myanmar_letter_nga => 0x1004,
  :myanmar_letter_ca => 0x1005,
  :myanmar_letter_cha => 0x1006,
  :myanmar_letter_ja => 0x1007,
  :myanmar_letter_jha => 0x1008,
  :myanmar_letter_nya => 0x1009,
  :myanmar_letter_nnya => 0x100a,
  :myanmar_letter_tta => 0x100b,
  :myanmar_letter_ttha => 0x100c,
  :myanmar_letter_dda => 0x100d,
  :myanmar_letter_ddha => 0x100e,
  :myanmar_letter_nna => 0x100f,
  :myanmar_letter_ta => 0x1010,
  :myanmar_letter_tha => 0x1011,
  :myanmar_letter_da => 0x1012,
  :myanmar_letter_dha => 0x1013,
  :myanmar_letter_na => 0x1014,
  :myanmar_letter_pa => 0x1015,
  :myanmar_letter_pha => 0x1016,
  :myanmar_letter_ba => 0x1017,
  :myanmar_letter_bha => 0x1018,
  :myanmar_letter_ma => 0x1019,
  :myanmar_letter_ya => 0x101a,
  :myanmar_letter_ra => 0x101b,
  :myanmar_letter_la => 0x101c,
  :myanmar_letter_wa => 0x101d,
  :myanmar_letter_sa => 0x101e,
  :myanmar_letter_ha => 0x101f,
  :myanmar_letter_lla => 0x1020,
  :myanmar_letter_a => 0x1021,
  :myanmar_letter_i => 0x1023,
  :myanmar_letter_ii => 0x1024,
  :myanmar_letter_u => 0x1025,
  :myanmar_letter_uu => 0x1026,
  :myanmar_letter_e => 0x1027,
  :myanmar_letter_o => 0x1029,
  :myanmar_letter_au => 0x102a,
  :myanmar_vowel_sign_aa => 0x102c,
  :myanmar_vowel_sign_i => 0x102d,
  :myanmar_vowel_sign_ii => 0x102e,
  :myanmar_vowel_sign_u => 0x102f,
  :myanmar_vowel_sign_uu => 0x1030,
  :myanmar_vowel_sign_e => 0x1031,
  :myanmar_vowel_sign_ai => 0x1032,
  :myanmar_sign_anusvara => 0x1036,
  :myanmar_sign_dot_below => 0x1037,
  :myanmar_sign_visarga => 0x1038,
  :myanmar_sign_virama => 0x1039,
  :myanmar_digit_zero => 0x1040,
  :myanmar_digit_one => 0x1041,
  :myanmar_digit_two => 0x1042,
  :myanmar_digit_three => 0x1043,
  :myanmar_digit_four => 0x1044,
  :myanmar_digit_five => 0x1045,
  :myanmar_digit_six => 0x1046,
  :myanmar_digit_seven => 0x1047,
  :myanmar_digit_eight => 0x1048,
  :myanmar_digit_nine => 0x1049,
  :myanmar_sign_little_section => 0x104a,
  :myanmar_sign_section => 0x104b,
  :myanmar_symbol_locative => 0x104c,
  :myanmar_symbol_completed => 0x104d,
  :myanmar_symbol_aforementioned => 0x104e,
  :myanmar_symbol_genitive => 0x104f,
  :myanmar_letter_sha => 0x1050,
  :myanmar_letter_ssa => 0x1051,
  :myanmar_letter_vocalic_r => 0x1052,
  :myanmar_letter_vocalic_rr => 0x1053,
  :myanmar_letter_vocalic_l => 0x1054,
  :myanmar_letter_vocalic_ll => 0x1055,
  :myanmar_vowel_sign_vocalic_r => 0x1056,
  :myanmar_vowel_sign_vocalic_rr => 0x1057,
  :myanmar_vowel_sign_vocalic_l => 0x1058,
  :myanmar_vowel_sign_vocalic_ll => 0x1059,
  :georgian_capital_letter_an => 0x10a0,
  :georgian_capital_letter_ban => 0x10a1,
  :georgian_capital_letter_gan => 0x10a2,
  :georgian_capital_letter_don => 0x10a3,
  :georgian_capital_letter_en => 0x10a4,
  :georgian_capital_letter_vin => 0x10a5,
  :georgian_capital_letter_zen => 0x10a6,
  :georgian_capital_letter_tan => 0x10a7,
  :georgian_capital_letter_in => 0x10a8,
  :georgian_capital_letter_kan => 0x10a9,
  :georgian_capital_letter_las => 0x10aa,
  :georgian_capital_letter_man => 0x10ab,
  :georgian_capital_letter_nar => 0x10ac,
  :georgian_capital_letter_on => 0x10ad,
  :georgian_capital_letter_par => 0x10ae,
  :georgian_capital_letter_zhar => 0x10af,
  :georgian_capital_letter_rae => 0x10b0,
  :georgian_capital_letter_san => 0x10b1,
  :georgian_capital_letter_tar => 0x10b2,
  :georgian_capital_letter_un => 0x10b3,
  :georgian_capital_letter_phar => 0x10b4,
  :georgian_capital_letter_khar => 0x10b5,
  :georgian_capital_letter_ghan => 0x10b6,
  :georgian_capital_letter_qar => 0x10b7,
  :georgian_capital_letter_shin => 0x10b8,
  :georgian_capital_letter_chin => 0x10b9,
  :georgian_capital_letter_can => 0x10ba,
  :georgian_capital_letter_jil => 0x10bb,
  :georgian_capital_letter_cil => 0x10bc,
  :georgian_capital_letter_char => 0x10bd,
  :georgian_capital_letter_xan => 0x10be,
  :georgian_capital_letter_jhan => 0x10bf,
  :georgian_capital_letter_hae => 0x10c0,
  :georgian_capital_letter_he => 0x10c1,
  :georgian_capital_letter_hie => 0x10c2,
  :georgian_capital_letter_we => 0x10c3,
  :georgian_capital_letter_har => 0x10c4,
  :georgian_capital_letter_hoe => 0x10c5,
  :georgian_letter_an => 0x10d0,
  :georgian_small_letter_an => 0x10d0,
  :georgian_letter_ban => 0x10d1,
  :georgian_small_letter_ban => 0x10d1,
  :georgian_letter_gan => 0x10d2,
  :georgian_small_letter_gan => 0x10d2,
  :georgian_letter_don => 0x10d3,
  :georgian_small_letter_don => 0x10d3,
  :georgian_letter_en => 0x10d4,
  :georgian_small_letter_en => 0x10d4,
  :georgian_letter_vin => 0x10d5,
  :georgian_small_letter_vin => 0x10d5,
  :georgian_letter_zen => 0x10d6,
  :georgian_small_letter_zen => 0x10d6,
  :georgian_letter_tan => 0x10d7,
  :georgian_small_letter_tan => 0x10d7,
  :georgian_letter_in => 0x10d8,
  :georgian_small_letter_in => 0x10d8,
  :georgian_letter_kan => 0x10d9,
  :georgian_small_letter_kan => 0x10d9,
  :georgian_letter_las => 0x10da,
  :georgian_small_letter_las => 0x10da,
  :georgian_letter_man => 0x10db,
  :georgian_small_letter_man => 0x10db,
  :georgian_letter_nar => 0x10dc,
  :georgian_small_letter_nar => 0x10dc,
  :georgian_letter_on => 0x10dd,
  :georgian_small_letter_on => 0x10dd,
  :georgian_letter_par => 0x10de,
  :georgian_small_letter_par => 0x10de,
  :georgian_letter_zhar => 0x10df,
  :georgian_small_letter_zhar => 0x10df,
  :georgian_letter_rae => 0x10e0,
  :georgian_small_letter_rae => 0x10e0,
  :georgian_letter_san => 0x10e1,
  :georgian_small_letter_san => 0x10e1,
  :georgian_letter_tar => 0x10e2,
  :georgian_small_letter_tar => 0x10e2,
  :georgian_letter_un => 0x10e3,
  :georgian_small_letter_un => 0x10e3,
  :georgian_letter_phar => 0x10e4,
  :georgian_small_letter_phar => 0x10e4,
  :georgian_letter_khar => 0x10e5,
  :georgian_small_letter_khar => 0x10e5,
  :georgian_letter_ghan => 0x10e6,
  :georgian_small_letter_ghan => 0x10e6,
  :georgian_letter_qar => 0x10e7,
  :georgian_small_letter_qar => 0x10e7,
  :georgian_letter_shin => 0x10e8,
  :georgian_small_letter_shin => 0x10e8,
  :georgian_letter_chin => 0x10e9,
  :georgian_small_letter_chin => 0x10e9,
  :georgian_letter_can => 0x10ea,
  :georgian_small_letter_can => 0x10ea,
  :georgian_letter_jil => 0x10eb,
  :georgian_small_letter_jil => 0x10eb,
  :georgian_letter_cil => 0x10ec,
  :georgian_small_letter_cil => 0x10ec,
  :georgian_letter_char => 0x10ed,
  :georgian_small_letter_char => 0x10ed,
  :georgian_letter_xan => 0x10ee,
  :georgian_small_letter_xan => 0x10ee,
  :georgian_letter_jhan => 0x10ef,
  :georgian_small_letter_jhan => 0x10ef,
  :georgian_letter_hae => 0x10f0,
  :georgian_small_letter_hae => 0x10f0,
  :georgian_letter_he => 0x10f1,
  :georgian_small_letter_he => 0x10f1,
  :georgian_letter_hie => 0x10f2,
  :georgian_small_letter_hie => 0x10f2,
  :georgian_letter_we => 0x10f3,
  :georgian_small_letter_we => 0x10f3,
  :georgian_letter_har => 0x10f4,
  :georgian_small_letter_har => 0x10f4,
  :georgian_letter_hoe => 0x10f5,
  :georgian_small_letter_hoe => 0x10f5,
  :georgian_letter_fi => 0x10f6,
  :georgian_small_letter_fi => 0x10f6,
  :georgian_letter_yn => 0x10f7,
  :georgian_letter_elifi => 0x10f8,
  :georgian_letter_turned_gan => 0x10f9,
  :georgian_letter_ain => 0x10fa,
  :georgian_paragraph_separator => 0x10fb,
  :modifier_letter_georgian_nar => 0x10fc,
  :hangul_choseong_kiyeok => 0x1100,
  :hangul_choseong_ssangkiyeok => 0x1101,
  :hangul_choseong_nieun => 0x1102,
  :hangul_choseong_tikeut => 0x1103,
  :hangul_choseong_ssangtikeut => 0x1104,
  :hangul_choseong_rieul => 0x1105,
  :hangul_choseong_mieum => 0x1106,
  :hangul_choseong_pieup => 0x1107,
  :hangul_choseong_ssangpieup => 0x1108,
  :hangul_choseong_sios => 0x1109,
  :hangul_choseong_ssangsios => 0x110a,
  :hangul_choseong_ieung => 0x110b,
  :hangul_choseong_cieuc => 0x110c,
  :hangul_choseong_ssangcieuc => 0x110d,
  :hangul_choseong_chieuch => 0x110e,
  :hangul_choseong_khieukh => 0x110f,
  :hangul_choseong_thieuth => 0x1110,
  :hangul_choseong_phieuph => 0x1111,
  :hangul_choseong_hieuh => 0x1112,
  :hangul_choseong_nieun_kiyeok => 0x1113,
  :hangul_choseong_ssangnieun => 0x1114,
  :hangul_choseong_nieun_tikeut => 0x1115,
  :hangul_choseong_nieun_pieup => 0x1116,
  :hangul_choseong_tikeut_kiyeok => 0x1117,
  :hangul_choseong_rieul_nieun => 0x1118,
  :hangul_choseong_ssangrieul => 0x1119,
  :hangul_choseong_rieul_hieuh => 0x111a,
  :hangul_choseong_kapyeounrieul => 0x111b,
  :hangul_choseong_mieum_pieup => 0x111c,
  :hangul_choseong_kapyeounmieum => 0x111d,
  :hangul_choseong_pieup_kiyeok => 0x111e,
  :hangul_choseong_pieup_nieun => 0x111f,
  :hangul_choseong_pieup_tikeut => 0x1120,
  :hangul_choseong_pieup_sios => 0x1121,
  :hangul_choseong_pieup_sios_kiyeok => 0x1122,
  :hangul_choseong_pieup_sios_tikeut => 0x1123,
  :hangul_choseong_pieup_sios_pieup => 0x1124,
  :hangul_choseong_pieup_ssangsios => 0x1125,
  :hangul_choseong_pieup_sios_cieuc => 0x1126,
  :hangul_choseong_pieup_cieuc => 0x1127,
  :hangul_choseong_pieup_chieuch => 0x1128,
  :hangul_choseong_pieup_thieuth => 0x1129,
  :hangul_choseong_pieup_phieuph => 0x112a,
  :hangul_choseong_kapyeounpieup => 0x112b,
  :hangul_choseong_kapyeounssangpieup => 0x112c,
  :hangul_choseong_sios_kiyeok => 0x112d,
  :hangul_choseong_sios_nieun => 0x112e,
  :hangul_choseong_sios_tikeut => 0x112f,
  :hangul_choseong_sios_rieul => 0x1130,
  :hangul_choseong_sios_mieum => 0x1131,
  :hangul_choseong_sios_pieup => 0x1132,
  :hangul_choseong_sios_pieup_kiyeok => 0x1133,
  :hangul_choseong_sios_ssangsios => 0x1134,
  :hangul_choseong_sios_ieung => 0x1135,
  :hangul_choseong_sios_cieuc => 0x1136,
  :hangul_choseong_sios_chieuch => 0x1137,
  :hangul_choseong_sios_khieukh => 0x1138,
  :hangul_choseong_sios_thieuth => 0x1139,
  :hangul_choseong_sios_phieuph => 0x113a,
  :hangul_choseong_sios_hieuh => 0x113b,
  :hangul_choseong_chitueumsios => 0x113c,
  :hangul_choseong_chitueumssangsios => 0x113d,
  :hangul_choseong_ceongchieumsios => 0x113e,
  :hangul_choseong_ceongchieumssangsios => 0x113f,
  :hangul_choseong_pansios => 0x1140,
  :hangul_choseong_ieung_kiyeok => 0x1141,
  :hangul_choseong_ieung_tikeut => 0x1142,
  :hangul_choseong_ieung_mieum => 0x1143,
  :hangul_choseong_ieung_pieup => 0x1144,
  :hangul_choseong_ieung_sios => 0x1145,
  :hangul_choseong_ieung_pansios => 0x1146,
  :hangul_choseong_ssangieung => 0x1147,
  :hangul_choseong_ieung_cieuc => 0x1148,
  :hangul_choseong_ieung_chieuch => 0x1149,
  :hangul_choseong_ieung_thieuth => 0x114a,
  :hangul_choseong_ieung_phieuph => 0x114b,
  :hangul_choseong_yesieung => 0x114c,
  :hangul_choseong_cieuc_ieung => 0x114d,
  :hangul_choseong_chitueumcieuc => 0x114e,
  :hangul_choseong_chitueumssangcieuc => 0x114f,
  :hangul_choseong_ceongchieumcieuc => 0x1150,
  :hangul_choseong_ceongchieumssangcieuc => 0x1151,
  :hangul_choseong_chieuch_khieukh => 0x1152,
  :hangul_choseong_chieuch_hieuh => 0x1153,
  :hangul_choseong_chitueumchieuch => 0x1154,
  :hangul_choseong_ceongchieumchieuch => 0x1155,
  :hangul_choseong_phieuph_pieup => 0x1156,
  :hangul_choseong_kapyeounphieuph => 0x1157,
  :hangul_choseong_ssanghieuh => 0x1158,
  :hangul_choseong_yeorinhieuh => 0x1159,
  :hangul_choseong_filler => 0x115f,
  :hangul_jungseong_filler => 0x1160,
  :hangul_jungseong_a => 0x1161,
  :hangul_jungseong_ae => 0x1162,
  :hangul_jungseong_ya => 0x1163,
  :hangul_jungseong_yae => 0x1164,
  :hangul_jungseong_eo => 0x1165,
  :hangul_jungseong_e => 0x1166,
  :hangul_jungseong_yeo => 0x1167,
  :hangul_jungseong_ye => 0x1168,
  :hangul_jungseong_o => 0x1169,
  :hangul_jungseong_wa => 0x116a,
  :hangul_jungseong_wae => 0x116b,
  :hangul_jungseong_oe => 0x116c,
  :hangul_jungseong_yo => 0x116d,
  :hangul_jungseong_u => 0x116e,
  :hangul_jungseong_weo => 0x116f,
  :hangul_jungseong_we => 0x1170,
  :hangul_jungseong_wi => 0x1171,
  :hangul_jungseong_yu => 0x1172,
  :hangul_jungseong_eu => 0x1173,
  :hangul_jungseong_yi => 0x1174,
  :hangul_jungseong_i => 0x1175,
  :hangul_jungseong_a_o => 0x1176,
  :hangul_jungseong_a_u => 0x1177,
  :hangul_jungseong_ya_o => 0x1178,
  :hangul_jungseong_ya_yo => 0x1179,
  :hangul_jungseong_eo_o => 0x117a,
  :hangul_jungseong_eo_u => 0x117b,
  :hangul_jungseong_eo_eu => 0x117c,
  :hangul_jungseong_yeo_o => 0x117d,
  :hangul_jungseong_yeo_u => 0x117e,
  :hangul_jungseong_o_eo => 0x117f,
  :hangul_jungseong_o_e => 0x1180,
  :hangul_jungseong_o_ye => 0x1181,
  :hangul_jungseong_o_o => 0x1182,
  :hangul_jungseong_o_u => 0x1183,
  :hangul_jungseong_yo_ya => 0x1184,
  :hangul_jungseong_yo_yae => 0x1185,
  :hangul_jungseong_yo_yeo => 0x1186,
  :hangul_jungseong_yo_o => 0x1187,
  :hangul_jungseong_yo_i => 0x1188,
  :hangul_jungseong_u_a => 0x1189,
  :hangul_jungseong_u_ae => 0x118a,
  :hangul_jungseong_u_eo_eu => 0x118b,
  :hangul_jungseong_u_ye => 0x118c,
  :hangul_jungseong_u_u => 0x118d,
  :hangul_jungseong_yu_a => 0x118e,
  :hangul_jungseong_yu_eo => 0x118f,
  :hangul_jungseong_yu_e => 0x1190,
  :hangul_jungseong_yu_yeo => 0x1191,
  :hangul_jungseong_yu_ye => 0x1192,
  :hangul_jungseong_yu_u => 0x1193,
  :hangul_jungseong_yu_i => 0x1194,
  :hangul_jungseong_eu_u => 0x1195,
  :hangul_jungseong_eu_eu => 0x1196,
  :hangul_jungseong_yi_u => 0x1197,
  :hangul_jungseong_i_a => 0x1198,
  :hangul_jungseong_i_ya => 0x1199,
  :hangul_jungseong_i_o => 0x119a,
  :hangul_jungseong_i_u => 0x119b,
  :hangul_jungseong_i_eu => 0x119c,
  :hangul_jungseong_i_araea => 0x119d,
  :hangul_jungseong_araea => 0x119e,
  :hangul_jungseong_araea_eo => 0x119f,
  :hangul_jungseong_araea_u => 0x11a0,
  :hangul_jungseong_araea_i => 0x11a1,
  :hangul_jungseong_ssangaraea => 0x11a2,
  :hangul_jongseong_kiyeok => 0x11a8,
  :hangul_jongseong_ssangkiyeok => 0x11a9,
  :hangul_jongseong_kiyeok_sios => 0x11aa,
  :hangul_jongseong_nieun => 0x11ab,
  :hangul_jongseong_nieun_cieuc => 0x11ac,
  :hangul_jongseong_nieun_hieuh => 0x11ad,
  :hangul_jongseong_tikeut => 0x11ae,
  :hangul_jongseong_rieul => 0x11af,
  :hangul_jongseong_rieul_kiyeok => 0x11b0,
  :hangul_jongseong_rieul_mieum => 0x11b1,
  :hangul_jongseong_rieul_pieup => 0x11b2,
  :hangul_jongseong_rieul_sios => 0x11b3,
  :hangul_jongseong_rieul_thieuth => 0x11b4,
  :hangul_jongseong_rieul_phieuph => 0x11b5,
  :hangul_jongseong_rieul_hieuh => 0x11b6,
  :hangul_jongseong_mieum => 0x11b7,
  :hangul_jongseong_pieup => 0x11b8,
  :hangul_jongseong_pieup_sios => 0x11b9,
  :hangul_jongseong_sios => 0x11ba,
  :hangul_jongseong_ssangsios => 0x11bb,
  :hangul_jongseong_ieung => 0x11bc,
  :hangul_jongseong_cieuc => 0x11bd,
  :hangul_jongseong_chieuch => 0x11be,
  :hangul_jongseong_khieukh => 0x11bf,
  :hangul_jongseong_thieuth => 0x11c0,
  :hangul_jongseong_phieuph => 0x11c1,
  :hangul_jongseong_hieuh => 0x11c2,
  :hangul_jongseong_kiyeok_rieul => 0x11c3,
  :hangul_jongseong_kiyeok_sios_kiyeok => 0x11c4,
  :hangul_jongseong_nieun_kiyeok => 0x11c5,
  :hangul_jongseong_nieun_tikeut => 0x11c6,
  :hangul_jongseong_nieun_sios => 0x11c7,
  :hangul_jongseong_nieun_pansios => 0x11c8,
  :hangul_jongseong_nieun_thieuth => 0x11c9,
  :hangul_jongseong_tikeut_kiyeok => 0x11ca,
  :hangul_jongseong_tikeut_rieul => 0x11cb,
  :hangul_jongseong_rieul_kiyeok_sios => 0x11cc,
  :hangul_jongseong_rieul_nieun => 0x11cd,
  :hangul_jongseong_rieul_tikeut => 0x11ce,
  :hangul_jongseong_rieul_tikeut_hieuh => 0x11cf,
  :hangul_jongseong_ssangrieul => 0x11d0,
  :hangul_jongseong_rieul_mieum_kiyeok => 0x11d1,
  :hangul_jongseong_rieul_mieum_sios => 0x11d2,
  :hangul_jongseong_rieul_pieup_sios => 0x11d3,
  :hangul_jongseong_rieul_pieup_hieuh => 0x11d4,
  :hangul_jongseong_rieul_kapyeounpieup => 0x11d5,
  :hangul_jongseong_rieul_ssangsios => 0x11d6,
  :hangul_jongseong_rieul_pansios => 0x11d7,
  :hangul_jongseong_rieul_khieukh => 0x11d8,
  :hangul_jongseong_rieul_yeorinhieuh => 0x11d9,
  :hangul_jongseong_mieum_kiyeok => 0x11da,
  :hangul_jongseong_mieum_rieul => 0x11db,
  :hangul_jongseong_mieum_pieup => 0x11dc,
  :hangul_jongseong_mieum_sios => 0x11dd,
  :hangul_jongseong_mieum_ssangsios => 0x11de,
  :hangul_jongseong_mieum_pansios => 0x11df,
  :hangul_jongseong_mieum_chieuch => 0x11e0,
  :hangul_jongseong_mieum_hieuh => 0x11e1,
  :hangul_jongseong_kapyeounmieum => 0x11e2,
  :hangul_jongseong_pieup_rieul => 0x11e3,
  :hangul_jongseong_pieup_phieuph => 0x11e4,
  :hangul_jongseong_pieup_hieuh => 0x11e5,
  :hangul_jongseong_kapyeounpieup => 0x11e6,
  :hangul_jongseong_sios_kiyeok => 0x11e7,
  :hangul_jongseong_sios_tikeut => 0x11e8,
  :hangul_jongseong_sios_rieul => 0x11e9,
  :hangul_jongseong_sios_pieup => 0x11ea,
  :hangul_jongseong_pansios => 0x11eb,
  :hangul_jongseong_ieung_kiyeok => 0x11ec,
  :hangul_jongseong_ieung_ssangkiyeok => 0x11ed,
  :hangul_jongseong_ssangieung => 0x11ee,
  :hangul_jongseong_ieung_khieukh => 0x11ef,
  :hangul_jongseong_yesieung => 0x11f0,
  :hangul_jongseong_yesieung_sios => 0x11f1,
  :hangul_jongseong_yesieung_pansios => 0x11f2,
  :hangul_jongseong_phieuph_pieup => 0x11f3,
  :hangul_jongseong_kapyeounphieuph => 0x11f4,
  :hangul_jongseong_hieuh_nieun => 0x11f5,
  :hangul_jongseong_hieuh_rieul => 0x11f6,
  :hangul_jongseong_hieuh_mieum => 0x11f7,
  :hangul_jongseong_hieuh_pieup => 0x11f8,
  :hangul_jongseong_yeorinhieuh => 0x11f9,
  :ethiopic_syllable_ha => 0x1200,
  :ethiopic_syllable_hu => 0x1201,
  :ethiopic_syllable_hi => 0x1202,
  :ethiopic_syllable_haa => 0x1203,
  :ethiopic_syllable_hee => 0x1204,
  :ethiopic_syllable_he => 0x1205,
  :ethiopic_syllable_ho => 0x1206,
  :ethiopic_syllable_hoa => 0x1207,
  :ethiopic_syllable_la => 0x1208,
  :ethiopic_syllable_lu => 0x1209,
  :ethiopic_syllable_li => 0x120a,
  :ethiopic_syllable_laa => 0x120b,
  :ethiopic_syllable_lee => 0x120c,
  :ethiopic_syllable_le => 0x120d,
  :ethiopic_syllable_lo => 0x120e,
  :ethiopic_syllable_lwa => 0x120f,
  :ethiopic_syllable_hha => 0x1210,
  :ethiopic_syllable_hhu => 0x1211,
  :ethiopic_syllable_hhi => 0x1212,
  :ethiopic_syllable_hhaa => 0x1213,
  :ethiopic_syllable_hhee => 0x1214,
  :ethiopic_syllable_hhe => 0x1215,
  :ethiopic_syllable_hho => 0x1216,
  :ethiopic_syllable_hhwa => 0x1217,
  :ethiopic_syllable_ma => 0x1218,
  :ethiopic_syllable_mu => 0x1219,
  :ethiopic_syllable_mi => 0x121a,
  :ethiopic_syllable_maa => 0x121b,
  :ethiopic_syllable_mee => 0x121c,
  :ethiopic_syllable_me => 0x121d,
  :ethiopic_syllable_mo => 0x121e,
  :ethiopic_syllable_mwa => 0x121f,
  :ethiopic_syllable_sza => 0x1220,
  :ethiopic_syllable_szu => 0x1221,
  :ethiopic_syllable_szi => 0x1222,
  :ethiopic_syllable_szaa => 0x1223,
  :ethiopic_syllable_szee => 0x1224,
  :ethiopic_syllable_sze => 0x1225,
  :ethiopic_syllable_szo => 0x1226,
  :ethiopic_syllable_szwa => 0x1227,
  :ethiopic_syllable_ra => 0x1228,
  :ethiopic_syllable_ru => 0x1229,
  :ethiopic_syllable_ri => 0x122a,
  :ethiopic_syllable_raa => 0x122b,
  :ethiopic_syllable_ree => 0x122c,
  :ethiopic_syllable_re => 0x122d,
  :ethiopic_syllable_ro => 0x122e,
  :ethiopic_syllable_rwa => 0x122f,
  :ethiopic_syllable_sa => 0x1230,
  :ethiopic_syllable_su => 0x1231,
  :ethiopic_syllable_si => 0x1232,
  :ethiopic_syllable_saa => 0x1233,
  :ethiopic_syllable_see => 0x1234,
  :ethiopic_syllable_se => 0x1235,
  :ethiopic_syllable_so => 0x1236,
  :ethiopic_syllable_swa => 0x1237,
  :ethiopic_syllable_sha => 0x1238,
  :ethiopic_syllable_shu => 0x1239,
  :ethiopic_syllable_shi => 0x123a,
  :ethiopic_syllable_shaa => 0x123b,
  :ethiopic_syllable_shee => 0x123c,
  :ethiopic_syllable_she => 0x123d,
  :ethiopic_syllable_sho => 0x123e,
  :ethiopic_syllable_shwa => 0x123f,
  :ethiopic_syllable_qa => 0x1240,
  :ethiopic_syllable_qu => 0x1241,
  :ethiopic_syllable_qi => 0x1242,
  :ethiopic_syllable_qaa => 0x1243,
  :ethiopic_syllable_qee => 0x1244,
  :ethiopic_syllable_qe => 0x1245,
  :ethiopic_syllable_qo => 0x1246,
  :ethiopic_syllable_qoa => 0x1247,
  :ethiopic_syllable_qwa => 0x1248,
  :ethiopic_syllable_qwi => 0x124a,
  :ethiopic_syllable_qwaa => 0x124b,
  :ethiopic_syllable_qwee => 0x124c,
  :ethiopic_syllable_qwe => 0x124d,
  :ethiopic_syllable_qha => 0x1250,
  :ethiopic_syllable_qhu => 0x1251,
  :ethiopic_syllable_qhi => 0x1252,
  :ethiopic_syllable_qhaa => 0x1253,
  :ethiopic_syllable_qhee => 0x1254,
  :ethiopic_syllable_qhe => 0x1255,
  :ethiopic_syllable_qho => 0x1256,
  :ethiopic_syllable_qhwa => 0x1258,
  :ethiopic_syllable_qhwi => 0x125a,
  :ethiopic_syllable_qhwaa => 0x125b,
  :ethiopic_syllable_qhwee => 0x125c,
  :ethiopic_syllable_qhwe => 0x125d,
  :ethiopic_syllable_ba => 0x1260,
  :ethiopic_syllable_bu => 0x1261,
  :ethiopic_syllable_bi => 0x1262,
  :ethiopic_syllable_baa => 0x1263,
  :ethiopic_syllable_bee => 0x1264,
  :ethiopic_syllable_be => 0x1265,
  :ethiopic_syllable_bo => 0x1266,
  :ethiopic_syllable_bwa => 0x1267,
  :ethiopic_syllable_va => 0x1268,
  :ethiopic_syllable_vu => 0x1269,
  :ethiopic_syllable_vi => 0x126a,
  :ethiopic_syllable_vaa => 0x126b,
  :ethiopic_syllable_vee => 0x126c,
  :ethiopic_syllable_ve => 0x126d,
  :ethiopic_syllable_vo => 0x126e,
  :ethiopic_syllable_vwa => 0x126f,
  :ethiopic_syllable_ta => 0x1270,
  :ethiopic_syllable_tu => 0x1271,
  :ethiopic_syllable_ti => 0x1272,
  :ethiopic_syllable_taa => 0x1273,
  :ethiopic_syllable_tee => 0x1274,
  :ethiopic_syllable_te => 0x1275,
  :ethiopic_syllable_to => 0x1276,
  :ethiopic_syllable_twa => 0x1277,
  :ethiopic_syllable_ca => 0x1278,
  :ethiopic_syllable_cu => 0x1279,
  :ethiopic_syllable_ci => 0x127a,
  :ethiopic_syllable_caa => 0x127b,
  :ethiopic_syllable_cee => 0x127c,
  :ethiopic_syllable_ce => 0x127d,
  :ethiopic_syllable_co => 0x127e,
  :ethiopic_syllable_cwa => 0x127f,
  :ethiopic_syllable_xa => 0x1280,
  :ethiopic_syllable_xu => 0x1281,
  :ethiopic_syllable_xi => 0x1282,
  :ethiopic_syllable_xaa => 0x1283,
  :ethiopic_syllable_xee => 0x1284,
  :ethiopic_syllable_xe => 0x1285,
  :ethiopic_syllable_xo => 0x1286,
  :ethiopic_syllable_xoa => 0x1287,
  :ethiopic_syllable_xwa => 0x1288,
  :ethiopic_syllable_xwi => 0x128a,
  :ethiopic_syllable_xwaa => 0x128b,
  :ethiopic_syllable_xwee => 0x128c,
  :ethiopic_syllable_xwe => 0x128d,
  :ethiopic_syllable_na => 0x1290,
  :ethiopic_syllable_nu => 0x1291,
  :ethiopic_syllable_ni => 0x1292,
  :ethiopic_syllable_naa => 0x1293,
  :ethiopic_syllable_nee => 0x1294,
  :ethiopic_syllable_ne => 0x1295,
  :ethiopic_syllable_no => 0x1296,
  :ethiopic_syllable_nwa => 0x1297,
  :ethiopic_syllable_nya => 0x1298,
  :ethiopic_syllable_nyu => 0x1299,
  :ethiopic_syllable_nyi => 0x129a,
  :ethiopic_syllable_nyaa => 0x129b,
  :ethiopic_syllable_nyee => 0x129c,
  :ethiopic_syllable_nye => 0x129d,
  :ethiopic_syllable_nyo => 0x129e,
  :ethiopic_syllable_nywa => 0x129f,
  :ethiopic_syllable_glottal_a => 0x12a0,
  :ethiopic_syllable_glottal_u => 0x12a1,
  :ethiopic_syllable_glottal_i => 0x12a2,
  :ethiopic_syllable_glottal_aa => 0x12a3,
  :ethiopic_syllable_glottal_ee => 0x12a4,
  :ethiopic_syllable_glottal_e => 0x12a5,
  :ethiopic_syllable_glottal_o => 0x12a6,
  :ethiopic_syllable_glottal_wa => 0x12a7,
  :ethiopic_syllable_ka => 0x12a8,
  :ethiopic_syllable_ku => 0x12a9,
  :ethiopic_syllable_ki => 0x12aa,
  :ethiopic_syllable_kaa => 0x12ab,
  :ethiopic_syllable_kee => 0x12ac,
  :ethiopic_syllable_ke => 0x12ad,
  :ethiopic_syllable_ko => 0x12ae,
  :ethiopic_syllable_koa => 0x12af,
  :ethiopic_syllable_kwa => 0x12b0,
  :ethiopic_syllable_kwi => 0x12b2,
  :ethiopic_syllable_kwaa => 0x12b3,
  :ethiopic_syllable_kwee => 0x12b4,
  :ethiopic_syllable_kwe => 0x12b5,
  :ethiopic_syllable_kxa => 0x12b8,
  :ethiopic_syllable_kxu => 0x12b9,
  :ethiopic_syllable_kxi => 0x12ba,
  :ethiopic_syllable_kxaa => 0x12bb,
  :ethiopic_syllable_kxee => 0x12bc,
  :ethiopic_syllable_kxe => 0x12bd,
  :ethiopic_syllable_kxo => 0x12be,
  :ethiopic_syllable_kxwa => 0x12c0,
  :ethiopic_syllable_kxwi => 0x12c2,
  :ethiopic_syllable_kxwaa => 0x12c3,
  :ethiopic_syllable_kxwee => 0x12c4,
  :ethiopic_syllable_kxwe => 0x12c5,
  :ethiopic_syllable_wa => 0x12c8,
  :ethiopic_syllable_wu => 0x12c9,
  :ethiopic_syllable_wi => 0x12ca,
  :ethiopic_syllable_waa => 0x12cb,
  :ethiopic_syllable_wee => 0x12cc,
  :ethiopic_syllable_we => 0x12cd,
  :ethiopic_syllable_wo => 0x12ce,
  :ethiopic_syllable_woa => 0x12cf,
  :ethiopic_syllable_pharyngeal_a => 0x12d0,
  :ethiopic_syllable_pharyngeal_u => 0x12d1,
  :ethiopic_syllable_pharyngeal_i => 0x12d2,
  :ethiopic_syllable_pharyngeal_aa => 0x12d3,
  :ethiopic_syllable_pharyngeal_ee => 0x12d4,
  :ethiopic_syllable_pharyngeal_e => 0x12d5,
  :ethiopic_syllable_pharyngeal_o => 0x12d6,
  :ethiopic_syllable_za => 0x12d8,
  :ethiopic_syllable_zu => 0x12d9,
  :ethiopic_syllable_zi => 0x12da,
  :ethiopic_syllable_zaa => 0x12db,
  :ethiopic_syllable_zee => 0x12dc,
  :ethiopic_syllable_ze => 0x12dd,
  :ethiopic_syllable_zo => 0x12de,
  :ethiopic_syllable_zwa => 0x12df,
  :ethiopic_syllable_zha => 0x12e0,
  :ethiopic_syllable_zhu => 0x12e1,
  :ethiopic_syllable_zhi => 0x12e2,
  :ethiopic_syllable_zhaa => 0x12e3,
  :ethiopic_syllable_zhee => 0x12e4,
  :ethiopic_syllable_zhe => 0x12e5,
  :ethiopic_syllable_zho => 0x12e6,
  :ethiopic_syllable_zhwa => 0x12e7,
  :ethiopic_syllable_ya => 0x12e8,
  :ethiopic_syllable_yu => 0x12e9,
  :ethiopic_syllable_yi => 0x12ea,
  :ethiopic_syllable_yaa => 0x12eb,
  :ethiopic_syllable_yee => 0x12ec,
  :ethiopic_syllable_ye => 0x12ed,
  :ethiopic_syllable_yo => 0x12ee,
  :ethiopic_syllable_yoa => 0x12ef,
  :ethiopic_syllable_da => 0x12f0,
  :ethiopic_syllable_du => 0x12f1,
  :ethiopic_syllable_di => 0x12f2,
  :ethiopic_syllable_daa => 0x12f3,
  :ethiopic_syllable_dee => 0x12f4,
  :ethiopic_syllable_de => 0x12f5,
  :ethiopic_syllable_do => 0x12f6,
  :ethiopic_syllable_dwa => 0x12f7,
  :ethiopic_syllable_dda => 0x12f8,
  :ethiopic_syllable_ddu => 0x12f9,
  :ethiopic_syllable_ddi => 0x12fa,
  :ethiopic_syllable_ddaa => 0x12fb,
  :ethiopic_syllable_ddee => 0x12fc,
  :ethiopic_syllable_dde => 0x12fd,
  :ethiopic_syllable_ddo => 0x12fe,
  :ethiopic_syllable_ddwa => 0x12ff,
  :ethiopic_syllable_ja => 0x1300,
  :ethiopic_syllable_ju => 0x1301,
  :ethiopic_syllable_ji => 0x1302,
  :ethiopic_syllable_jaa => 0x1303,
  :ethiopic_syllable_jee => 0x1304,
  :ethiopic_syllable_je => 0x1305,
  :ethiopic_syllable_jo => 0x1306,
  :ethiopic_syllable_jwa => 0x1307,
  :ethiopic_syllable_ga => 0x1308,
  :ethiopic_syllable_gu => 0x1309,
  :ethiopic_syllable_gi => 0x130a,
  :ethiopic_syllable_gaa => 0x130b,
  :ethiopic_syllable_gee => 0x130c,
  :ethiopic_syllable_ge => 0x130d,
  :ethiopic_syllable_go => 0x130e,
  :ethiopic_syllable_goa => 0x130f,
  :ethiopic_syllable_gwa => 0x1310,
  :ethiopic_syllable_gwi => 0x1312,
  :ethiopic_syllable_gwaa => 0x1313,
  :ethiopic_syllable_gwee => 0x1314,
  :ethiopic_syllable_gwe => 0x1315,
  :ethiopic_syllable_gga => 0x1318,
  :ethiopic_syllable_ggu => 0x1319,
  :ethiopic_syllable_ggi => 0x131a,
  :ethiopic_syllable_ggaa => 0x131b,
  :ethiopic_syllable_ggee => 0x131c,
  :ethiopic_syllable_gge => 0x131d,
  :ethiopic_syllable_ggo => 0x131e,
  :ethiopic_syllable_ggwaa => 0x131f,
  :ethiopic_syllable_tha => 0x1320,
  :ethiopic_syllable_thu => 0x1321,
  :ethiopic_syllable_thi => 0x1322,
  :ethiopic_syllable_thaa => 0x1323,
  :ethiopic_syllable_thee => 0x1324,
  :ethiopic_syllable_the => 0x1325,
  :ethiopic_syllable_tho => 0x1326,
  :ethiopic_syllable_thwa => 0x1327,
  :ethiopic_syllable_cha => 0x1328,
  :ethiopic_syllable_chu => 0x1329,
  :ethiopic_syllable_chi => 0x132a,
  :ethiopic_syllable_chaa => 0x132b,
  :ethiopic_syllable_chee => 0x132c,
  :ethiopic_syllable_che => 0x132d,
  :ethiopic_syllable_cho => 0x132e,
  :ethiopic_syllable_chwa => 0x132f,
  :ethiopic_syllable_pha => 0x1330,
  :ethiopic_syllable_phu => 0x1331,
  :ethiopic_syllable_phi => 0x1332,
  :ethiopic_syllable_phaa => 0x1333,
  :ethiopic_syllable_phee => 0x1334,
  :ethiopic_syllable_phe => 0x1335,
  :ethiopic_syllable_pho => 0x1336,
  :ethiopic_syllable_phwa => 0x1337,
  :ethiopic_syllable_tsa => 0x1338,
  :ethiopic_syllable_tsu => 0x1339,
  :ethiopic_syllable_tsi => 0x133a,
  :ethiopic_syllable_tsaa => 0x133b,
  :ethiopic_syllable_tsee => 0x133c,
  :ethiopic_syllable_tse => 0x133d,
  :ethiopic_syllable_tso => 0x133e,
  :ethiopic_syllable_tswa => 0x133f,
  :ethiopic_syllable_tza => 0x1340,
  :ethiopic_syllable_tzu => 0x1341,
  :ethiopic_syllable_tzi => 0x1342,
  :ethiopic_syllable_tzaa => 0x1343,
  :ethiopic_syllable_tzee => 0x1344,
  :ethiopic_syllable_tze => 0x1345,
  :ethiopic_syllable_tzo => 0x1346,
  :ethiopic_syllable_tzoa => 0x1347,
  :ethiopic_syllable_fa => 0x1348,
  :ethiopic_syllable_fu => 0x1349,
  :ethiopic_syllable_fi => 0x134a,
  :ethiopic_syllable_faa => 0x134b,
  :ethiopic_syllable_fee => 0x134c,
  :ethiopic_syllable_fe => 0x134d,
  :ethiopic_syllable_fo => 0x134e,
  :ethiopic_syllable_fwa => 0x134f,
  :ethiopic_syllable_pa => 0x1350,
  :ethiopic_syllable_pu => 0x1351,
  :ethiopic_syllable_pi => 0x1352,
  :ethiopic_syllable_paa => 0x1353,
  :ethiopic_syllable_pee => 0x1354,
  :ethiopic_syllable_pe => 0x1355,
  :ethiopic_syllable_po => 0x1356,
  :ethiopic_syllable_pwa => 0x1357,
  :ethiopic_syllable_rya => 0x1358,
  :ethiopic_syllable_mya => 0x1359,
  :ethiopic_syllable_fya => 0x135a,
  :ethiopic_combining_gemination_mark => 0x135f,
  :ethiopic_section_mark => 0x1360,
  :ethiopic_wordspace => 0x1361,
  :ethiopic_full_stop => 0x1362,
  :ethiopic_comma => 0x1363,
  :ethiopic_semicolon => 0x1364,
  :ethiopic_colon => 0x1365,
  :ethiopic_preface_colon => 0x1366,
  :ethiopic_question_mark => 0x1367,
  :ethiopic_paragraph_separator => 0x1368,
  :ethiopic_digit_one => 0x1369,
  :ethiopic_digit_two => 0x136a,
  :ethiopic_digit_three => 0x136b,
  :ethiopic_digit_four => 0x136c,
  :ethiopic_digit_five => 0x136d,
  :ethiopic_digit_six => 0x136e,
  :ethiopic_digit_seven => 0x136f,
  :ethiopic_digit_eight => 0x1370,
  :ethiopic_digit_nine => 0x1371,
  :ethiopic_number_ten => 0x1372,
  :ethiopic_number_twenty => 0x1373,
  :ethiopic_number_thirty => 0x1374,
  :ethiopic_number_forty => 0x1375,
  :ethiopic_number_fifty => 0x1376,
  :ethiopic_number_sixty => 0x1377,
  :ethiopic_number_seventy => 0x1378,
  :ethiopic_number_eighty => 0x1379,
  :ethiopic_number_ninety => 0x137a,
  :ethiopic_number_hundred => 0x137b,
  :ethiopic_number_ten_thousand => 0x137c,
  :ethiopic_syllable_sebatbeit_mwa => 0x1380,
  :ethiopic_syllable_mwi => 0x1381,
  :ethiopic_syllable_mwee => 0x1382,
  :ethiopic_syllable_mwe => 0x1383,
  :ethiopic_syllable_sebatbeit_bwa => 0x1384,
  :ethiopic_syllable_bwi => 0x1385,
  :ethiopic_syllable_bwee => 0x1386,
  :ethiopic_syllable_bwe => 0x1387,
  :ethiopic_syllable_sebatbeit_fwa => 0x1388,
  :ethiopic_syllable_fwi => 0x1389,
  :ethiopic_syllable_fwee => 0x138a,
  :ethiopic_syllable_fwe => 0x138b,
  :ethiopic_syllable_sebatbeit_pwa => 0x138c,
  :ethiopic_syllable_pwi => 0x138d,
  :ethiopic_syllable_pwee => 0x138e,
  :ethiopic_syllable_pwe => 0x138f,
  :ethiopic_tonal_mark_yizet => 0x1390,
  :ethiopic_tonal_mark_deret => 0x1391,
  :ethiopic_tonal_mark_rikrik => 0x1392,
  :ethiopic_tonal_mark_short_rikrik => 0x1393,
  :ethiopic_tonal_mark_difat => 0x1394,
  :ethiopic_tonal_mark_kenat => 0x1395,
  :ethiopic_tonal_mark_chiret => 0x1396,
  :ethiopic_tonal_mark_hidet => 0x1397,
  :ethiopic_tonal_mark_deret_hidet => 0x1398,
  :ethiopic_tonal_mark_kurt => 0x1399,
  :cherokee_letter_a => 0x13a0,
  :cherokee_letter_e => 0x13a1,
  :cherokee_letter_i => 0x13a2,
  :cherokee_letter_o => 0x13a3,
  :cherokee_letter_u => 0x13a4,
  :cherokee_letter_v => 0x13a5,
  :cherokee_letter_ga => 0x13a6,
  :cherokee_letter_ka => 0x13a7,
  :cherokee_letter_ge => 0x13a8,
  :cherokee_letter_gi => 0x13a9,
  :cherokee_letter_go => 0x13aa,
  :cherokee_letter_gu => 0x13ab,
  :cherokee_letter_gv => 0x13ac,
  :cherokee_letter_ha => 0x13ad,
  :cherokee_letter_he => 0x13ae,
  :cherokee_letter_hi => 0x13af,
  :cherokee_letter_ho => 0x13b0,
  :cherokee_letter_hu => 0x13b1,
  :cherokee_letter_hv => 0x13b2,
  :cherokee_letter_la => 0x13b3,
  :cherokee_letter_le => 0x13b4,
  :cherokee_letter_li => 0x13b5,
  :cherokee_letter_lo => 0x13b6,
  :cherokee_letter_lu => 0x13b7,
  :cherokee_letter_lv => 0x13b8,
  :cherokee_letter_ma => 0x13b9,
  :cherokee_letter_me => 0x13ba,
  :cherokee_letter_mi => 0x13bb,
  :cherokee_letter_mo => 0x13bc,
  :cherokee_letter_mu => 0x13bd,
  :cherokee_letter_na => 0x13be,
  :cherokee_letter_hna => 0x13bf,
  :cherokee_letter_nah => 0x13c0,
  :cherokee_letter_ne => 0x13c1,
  :cherokee_letter_ni => 0x13c2,
  :cherokee_letter_no => 0x13c3,
  :cherokee_letter_nu => 0x13c4,
  :cherokee_letter_nv => 0x13c5,
  :cherokee_letter_qua => 0x13c6,
  :cherokee_letter_que => 0x13c7,
  :cherokee_letter_qui => 0x13c8,
  :cherokee_letter_quo => 0x13c9,
  :cherokee_letter_quu => 0x13ca,
  :cherokee_letter_quv => 0x13cb,
  :cherokee_letter_sa => 0x13cc,
  :cherokee_letter_s => 0x13cd,
  :cherokee_letter_se => 0x13ce,
  :cherokee_letter_si => 0x13cf,
  :cherokee_letter_so => 0x13d0,
  :cherokee_letter_su => 0x13d1,
  :cherokee_letter_sv => 0x13d2,
  :cherokee_letter_da => 0x13d3,
  :cherokee_letter_ta => 0x13d4,
  :cherokee_letter_de => 0x13d5,
  :cherokee_letter_te => 0x13d6,
  :cherokee_letter_di => 0x13d7,
  :cherokee_letter_ti => 0x13d8,
  :cherokee_letter_do => 0x13d9,
  :cherokee_letter_du => 0x13da,
  :cherokee_letter_dv => 0x13db,
  :cherokee_letter_dla => 0x13dc,
  :cherokee_letter_tla => 0x13dd,
  :cherokee_letter_tle => 0x13de,
  :cherokee_letter_tli => 0x13df,
  :cherokee_letter_tlo => 0x13e0,
  :cherokee_letter_tlu => 0x13e1,
  :cherokee_letter_tlv => 0x13e2,
  :cherokee_letter_tsa => 0x13e3,
  :cherokee_letter_tse => 0x13e4,
  :cherokee_letter_tsi => 0x13e5,
  :cherokee_letter_tso => 0x13e6,
  :cherokee_letter_tsu => 0x13e7,
  :cherokee_letter_tsv => 0x13e8,
  :cherokee_letter_wa => 0x13e9,
  :cherokee_letter_we => 0x13ea,
  :cherokee_letter_wi => 0x13eb,
  :cherokee_letter_wo => 0x13ec,
  :cherokee_letter_wu => 0x13ed,
  :cherokee_letter_wv => 0x13ee,
  :cherokee_letter_ya => 0x13ef,
  :cherokee_letter_ye => 0x13f0,
  :cherokee_letter_yi => 0x13f1,
  :cherokee_letter_yo => 0x13f2,
  :cherokee_letter_yu => 0x13f3,
  :cherokee_letter_yv => 0x13f4,
  :canadian_syllabics_e => 0x1401,
  :canadian_syllabics_aai => 0x1402,
  :canadian_syllabics_i => 0x1403,
  :canadian_syllabics_ii => 0x1404,
  :canadian_syllabics_o => 0x1405,
  :canadian_syllabics_oo => 0x1406,
  :canadian_syllabics_y_cree_oo => 0x1407,
  :canadian_syllabics_carrier_ee => 0x1408,
  :canadian_syllabics_carrier_i => 0x1409,
  :canadian_syllabics_a => 0x140a,
  :canadian_syllabics_aa => 0x140b,
  :canadian_syllabics_we => 0x140c,
  :canadian_syllabics_west_cree_we => 0x140d,
  :canadian_syllabics_wi => 0x140e,
  :canadian_syllabics_west_cree_wi => 0x140f,
  :canadian_syllabics_wii => 0x1410,
  :canadian_syllabics_west_cree_wii => 0x1411,
  :canadian_syllabics_wo => 0x1412,
  :canadian_syllabics_west_cree_wo => 0x1413,
  :canadian_syllabics_woo => 0x1414,
  :canadian_syllabics_west_cree_woo => 0x1415,
  :canadian_syllabics_naskapi_woo => 0x1416,
  :canadian_syllabics_wa => 0x1417,
  :canadian_syllabics_west_cree_wa => 0x1418,
  :canadian_syllabics_waa => 0x1419,
  :canadian_syllabics_west_cree_waa => 0x141a,
  :canadian_syllabics_naskapi_waa => 0x141b,
  :canadian_syllabics_ai => 0x141c,
  :canadian_syllabics_y_cree_w => 0x141d,
  :canadian_syllabics_glottal_stop => 0x141e,
  :canadian_syllabics_final_acute => 0x141f,
  :canadian_syllabics_final_grave => 0x1420,
  :canadian_syllabics_final_bottom_half_ring => 0x1421,
  :canadian_syllabics_final_top_half_ring => 0x1422,
  :canadian_syllabics_final_right_half_ring => 0x1423,
  :canadian_syllabics_final_ring => 0x1424,
  :canadian_syllabics_final_double_acute => 0x1425,
  :canadian_syllabics_final_double_short_vertical_strokes => 0x1426,
  :canadian_syllabics_final_middle_dot => 0x1427,
  :canadian_syllabics_final_short_horizontal_stroke => 0x1428,
  :canadian_syllabics_final_plus => 0x1429,
  :canadian_syllabics_final_down_tack => 0x142a,
  :canadian_syllabics_en => 0x142b,
  :canadian_syllabics_in => 0x142c,
  :canadian_syllabics_on => 0x142d,
  :canadian_syllabics_an => 0x142e,
  :canadian_syllabics_pe => 0x142f,
  :canadian_syllabics_paai => 0x1430,
  :canadian_syllabics_pi => 0x1431,
  :canadian_syllabics_pii => 0x1432,
  :canadian_syllabics_po => 0x1433,
  :canadian_syllabics_poo => 0x1434,
  :canadian_syllabics_y_cree_poo => 0x1435,
  :canadian_syllabics_carrier_hee => 0x1436,
  :canadian_syllabics_carrier_hi => 0x1437,
  :canadian_syllabics_pa => 0x1438,
  :canadian_syllabics_paa => 0x1439,
  :canadian_syllabics_pwe => 0x143a,
  :canadian_syllabics_west_cree_pwe => 0x143b,
  :canadian_syllabics_pwi => 0x143c,
  :canadian_syllabics_west_cree_pwi => 0x143d,
  :canadian_syllabics_pwii => 0x143e,
  :canadian_syllabics_west_cree_pwii => 0x143f,
  :canadian_syllabics_pwo => 0x1440,
  :canadian_syllabics_west_cree_pwo => 0x1441,
  :canadian_syllabics_pwoo => 0x1442,
  :canadian_syllabics_west_cree_pwoo => 0x1443,
  :canadian_syllabics_pwa => 0x1444,
  :canadian_syllabics_west_cree_pwa => 0x1445,
  :canadian_syllabics_pwaa => 0x1446,
  :canadian_syllabics_west_cree_pwaa => 0x1447,
  :canadian_syllabics_y_cree_pwaa => 0x1448,
  :canadian_syllabics_p => 0x1449,
  :canadian_syllabics_west_cree_p => 0x144a,
  :canadian_syllabics_carrier_h => 0x144b,
  :canadian_syllabics_te => 0x144c,
  :canadian_syllabics_taai => 0x144d,
  :canadian_syllabics_ti => 0x144e,
  :canadian_syllabics_tii => 0x144f,
  :canadian_syllabics_to => 0x1450,
  :canadian_syllabics_too => 0x1451,
  :canadian_syllabics_y_cree_too => 0x1452,
  :canadian_syllabics_carrier_dee => 0x1453,
  :canadian_syllabics_carrier_di => 0x1454,
  :canadian_syllabics_ta => 0x1455,
  :canadian_syllabics_taa => 0x1456,
  :canadian_syllabics_twe => 0x1457,
  :canadian_syllabics_west_cree_twe => 0x1458,
  :canadian_syllabics_twi => 0x1459,
  :canadian_syllabics_west_cree_twi => 0x145a,
  :canadian_syllabics_twii => 0x145b,
  :canadian_syllabics_west_cree_twii => 0x145c,
  :canadian_syllabics_two => 0x145d,
  :canadian_syllabics_west_cree_two => 0x145e,
  :canadian_syllabics_twoo => 0x145f,
  :canadian_syllabics_west_cree_twoo => 0x1460,
  :canadian_syllabics_twa => 0x1461,
  :canadian_syllabics_west_cree_twa => 0x1462,
  :canadian_syllabics_twaa => 0x1463,
  :canadian_syllabics_west_cree_twaa => 0x1464,
  :canadian_syllabics_naskapi_twaa => 0x1465,
  :canadian_syllabics_t => 0x1466,
  :canadian_syllabics_tte => 0x1467,
  :canadian_syllabics_tti => 0x1468,
  :canadian_syllabics_tto => 0x1469,
  :canadian_syllabics_tta => 0x146a,
  :canadian_syllabics_ke => 0x146b,
  :canadian_syllabics_kaai => 0x146c,
  :canadian_syllabics_ki => 0x146d,
  :canadian_syllabics_kii => 0x146e,
  :canadian_syllabics_ko => 0x146f,
  :canadian_syllabics_koo => 0x1470,
  :canadian_syllabics_y_cree_koo => 0x1471,
  :canadian_syllabics_ka => 0x1472,
  :canadian_syllabics_kaa => 0x1473,
  :canadian_syllabics_kwe => 0x1474,
  :canadian_syllabics_west_cree_kwe => 0x1475,
  :canadian_syllabics_kwi => 0x1476,
  :canadian_syllabics_west_cree_kwi => 0x1477,
  :canadian_syllabics_kwii => 0x1478,
  :canadian_syllabics_west_cree_kwii => 0x1479,
  :canadian_syllabics_kwo => 0x147a,
  :canadian_syllabics_west_cree_kwo => 0x147b,
  :canadian_syllabics_kwoo => 0x147c,
  :canadian_syllabics_west_cree_kwoo => 0x147d,
  :canadian_syllabics_kwa => 0x147e,
  :canadian_syllabics_west_cree_kwa => 0x147f,
  :canadian_syllabics_kwaa => 0x1480,
  :canadian_syllabics_west_cree_kwaa => 0x1481,
  :canadian_syllabics_naskapi_kwaa => 0x1482,
  :canadian_syllabics_k => 0x1483,
  :canadian_syllabics_kw => 0x1484,
  :canadian_syllabics_south_slavey_keh => 0x1485,
  :canadian_syllabics_south_slavey_kih => 0x1486,
  :canadian_syllabics_south_slavey_koh => 0x1487,
  :canadian_syllabics_south_slavey_kah => 0x1488,
  :canadian_syllabics_ce => 0x1489,
  :canadian_syllabics_caai => 0x148a,
  :canadian_syllabics_ci => 0x148b,
  :canadian_syllabics_cii => 0x148c,
  :canadian_syllabics_co => 0x148d,
  :canadian_syllabics_coo => 0x148e,
  :canadian_syllabics_y_cree_coo => 0x148f,
  :canadian_syllabics_ca => 0x1490,
  :canadian_syllabics_caa => 0x1491,
  :canadian_syllabics_cwe => 0x1492,
  :canadian_syllabics_west_cree_cwe => 0x1493,
  :canadian_syllabics_cwi => 0x1494,
  :canadian_syllabics_west_cree_cwi => 0x1495,
  :canadian_syllabics_cwii => 0x1496,
  :canadian_syllabics_west_cree_cwii => 0x1497,
  :canadian_syllabics_cwo => 0x1498,
  :canadian_syllabics_west_cree_cwo => 0x1499,
  :canadian_syllabics_cwoo => 0x149a,
  :canadian_syllabics_west_cree_cwoo => 0x149b,
  :canadian_syllabics_cwa => 0x149c,
  :canadian_syllabics_west_cree_cwa => 0x149d,
  :canadian_syllabics_cwaa => 0x149e,
  :canadian_syllabics_west_cree_cwaa => 0x149f,
  :canadian_syllabics_naskapi_cwaa => 0x14a0,
  :canadian_syllabics_c => 0x14a1,
  :canadian_syllabics_sayisi_th => 0x14a2,
  :canadian_syllabics_me => 0x14a3,
  :canadian_syllabics_maai => 0x14a4,
  :canadian_syllabics_mi => 0x14a5,
  :canadian_syllabics_mii => 0x14a6,
  :canadian_syllabics_mo => 0x14a7,
  :canadian_syllabics_moo => 0x14a8,
  :canadian_syllabics_y_cree_moo => 0x14a9,
  :canadian_syllabics_ma => 0x14aa,
  :canadian_syllabics_maa => 0x14ab,
  :canadian_syllabics_mwe => 0x14ac,
  :canadian_syllabics_west_cree_mwe => 0x14ad,
  :canadian_syllabics_mwi => 0x14ae,
  :canadian_syllabics_west_cree_mwi => 0x14af,
  :canadian_syllabics_mwii => 0x14b0,
  :canadian_syllabics_west_cree_mwii => 0x14b1,
  :canadian_syllabics_mwo => 0x14b2,
  :canadian_syllabics_west_cree_mwo => 0x14b3,
  :canadian_syllabics_mwoo => 0x14b4,
  :canadian_syllabics_west_cree_mwoo => 0x14b5,
  :canadian_syllabics_mwa => 0x14b6,
  :canadian_syllabics_west_cree_mwa => 0x14b7,
  :canadian_syllabics_mwaa => 0x14b8,
  :canadian_syllabics_west_cree_mwaa => 0x14b9,
  :canadian_syllabics_naskapi_mwaa => 0x14ba,
  :canadian_syllabics_m => 0x14bb,
  :canadian_syllabics_west_cree_m => 0x14bc,
  :canadian_syllabics_mh => 0x14bd,
  :canadian_syllabics_athapascan_m => 0x14be,
  :canadian_syllabics_sayisi_m => 0x14bf,
  :canadian_syllabics_ne => 0x14c0,
  :canadian_syllabics_naai => 0x14c1,
  :canadian_syllabics_ni => 0x14c2,
  :canadian_syllabics_nii => 0x14c3,
  :canadian_syllabics_no => 0x14c4,
  :canadian_syllabics_noo => 0x14c5,
  :canadian_syllabics_y_cree_noo => 0x14c6,
  :canadian_syllabics_na => 0x14c7,
  :canadian_syllabics_naa => 0x14c8,
  :canadian_syllabics_nwe => 0x14c9,
  :canadian_syllabics_west_cree_nwe => 0x14ca,
  :canadian_syllabics_nwa => 0x14cb,
  :canadian_syllabics_west_cree_nwa => 0x14cc,
  :canadian_syllabics_nwaa => 0x14cd,
  :canadian_syllabics_west_cree_nwaa => 0x14ce,
  :canadian_syllabics_naskapi_nwaa => 0x14cf,
  :canadian_syllabics_n => 0x14d0,
  :canadian_syllabics_carrier_ng => 0x14d1,
  :canadian_syllabics_nh => 0x14d2,
  :canadian_syllabics_le => 0x14d3,
  :canadian_syllabics_laai => 0x14d4,
  :canadian_syllabics_li => 0x14d5,
  :canadian_syllabics_lii => 0x14d6,
  :canadian_syllabics_lo => 0x14d7,
  :canadian_syllabics_loo => 0x14d8,
  :canadian_syllabics_y_cree_loo => 0x14d9,
  :canadian_syllabics_la => 0x14da,
  :canadian_syllabics_laa => 0x14db,
  :canadian_syllabics_lwe => 0x14dc,
  :canadian_syllabics_west_cree_lwe => 0x14dd,
  :canadian_syllabics_lwi => 0x14de,
  :canadian_syllabics_west_cree_lwi => 0x14df,
  :canadian_syllabics_lwii => 0x14e0,
  :canadian_syllabics_west_cree_lwii => 0x14e1,
  :canadian_syllabics_lwo => 0x14e2,
  :canadian_syllabics_west_cree_lwo => 0x14e3,
  :canadian_syllabics_lwoo => 0x14e4,
  :canadian_syllabics_west_cree_lwoo => 0x14e5,
  :canadian_syllabics_lwa => 0x14e6,
  :canadian_syllabics_west_cree_lwa => 0x14e7,
  :canadian_syllabics_lwaa => 0x14e8,
  :canadian_syllabics_west_cree_lwaa => 0x14e9,
  :canadian_syllabics_l => 0x14ea,
  :canadian_syllabics_west_cree_l => 0x14eb,
  :canadian_syllabics_medial_l => 0x14ec,
  :canadian_syllabics_se => 0x14ed,
  :canadian_syllabics_saai => 0x14ee,
  :canadian_syllabics_si => 0x14ef,
  :canadian_syllabics_sii => 0x14f0,
  :canadian_syllabics_so => 0x14f1,
  :canadian_syllabics_soo => 0x14f2,
  :canadian_syllabics_y_cree_soo => 0x14f3,
  :canadian_syllabics_sa => 0x14f4,
  :canadian_syllabics_saa => 0x14f5,
  :canadian_syllabics_swe => 0x14f6,
  :canadian_syllabics_west_cree_swe => 0x14f7,
  :canadian_syllabics_swi => 0x14f8,
  :canadian_syllabics_west_cree_swi => 0x14f9,
  :canadian_syllabics_swii => 0x14fa,
  :canadian_syllabics_west_cree_swii => 0x14fb,
  :canadian_syllabics_swo => 0x14fc,
  :canadian_syllabics_west_cree_swo => 0x14fd,
  :canadian_syllabics_swoo => 0x14fe,
  :canadian_syllabics_west_cree_swoo => 0x14ff,
  :canadian_syllabics_swa => 0x1500,
  :canadian_syllabics_west_cree_swa => 0x1501,
  :canadian_syllabics_swaa => 0x1502,
  :canadian_syllabics_west_cree_swaa => 0x1503,
  :canadian_syllabics_naskapi_swaa => 0x1504,
  :canadian_syllabics_s => 0x1505,
  :canadian_syllabics_athapascan_s => 0x1506,
  :canadian_syllabics_sw => 0x1507,
  :canadian_syllabics_blackfoot_s => 0x1508,
  :canadian_syllabics_moose_cree_sk => 0x1509,
  :canadian_syllabics_naskapi_skw => 0x150a,
  :canadian_syllabics_naskapi_s_w => 0x150b,
  :canadian_syllabics_naskapi_spwa => 0x150c,
  :canadian_syllabics_naskapi_stwa => 0x150d,
  :canadian_syllabics_naskapi_skwa => 0x150e,
  :canadian_syllabics_naskapi_scwa => 0x150f,
  :canadian_syllabics_she => 0x1510,
  :canadian_syllabics_shi => 0x1511,
  :canadian_syllabics_shii => 0x1512,
  :canadian_syllabics_sho => 0x1513,
  :canadian_syllabics_shoo => 0x1514,
  :canadian_syllabics_sha => 0x1515,
  :canadian_syllabics_shaa => 0x1516,
  :canadian_syllabics_shwe => 0x1517,
  :canadian_syllabics_west_cree_shwe => 0x1518,
  :canadian_syllabics_shwi => 0x1519,
  :canadian_syllabics_west_cree_shwi => 0x151a,
  :canadian_syllabics_shwii => 0x151b,
  :canadian_syllabics_west_cree_shwii => 0x151c,
  :canadian_syllabics_shwo => 0x151d,
  :canadian_syllabics_west_cree_shwo => 0x151e,
  :canadian_syllabics_shwoo => 0x151f,
  :canadian_syllabics_west_cree_shwoo => 0x1520,
  :canadian_syllabics_shwa => 0x1521,
  :canadian_syllabics_west_cree_shwa => 0x1522,
  :canadian_syllabics_shwaa => 0x1523,
  :canadian_syllabics_west_cree_shwaa => 0x1524,
  :canadian_syllabics_sh => 0x1525,
  :canadian_syllabics_ye => 0x1526,
  :canadian_syllabics_yaai => 0x1527,
  :canadian_syllabics_yi => 0x1528,
  :canadian_syllabics_yii => 0x1529,
  :canadian_syllabics_yo => 0x152a,
  :canadian_syllabics_yoo => 0x152b,
  :canadian_syllabics_y_cree_yoo => 0x152c,
  :canadian_syllabics_ya => 0x152d,
  :canadian_syllabics_yaa => 0x152e,
  :canadian_syllabics_ywe => 0x152f,
  :canadian_syllabics_west_cree_ywe => 0x1530,
  :canadian_syllabics_ywi => 0x1531,
  :canadian_syllabics_west_cree_ywi => 0x1532,
  :canadian_syllabics_ywii => 0x1533,
  :canadian_syllabics_west_cree_ywii => 0x1534,
  :canadian_syllabics_ywo => 0x1535,
  :canadian_syllabics_west_cree_ywo => 0x1536,
  :canadian_syllabics_ywoo => 0x1537,
  :canadian_syllabics_west_cree_ywoo => 0x1538,
  :canadian_syllabics_ywa => 0x1539,
  :canadian_syllabics_west_cree_ywa => 0x153a,
  :canadian_syllabics_ywaa => 0x153b,
  :canadian_syllabics_west_cree_ywaa => 0x153c,
  :canadian_syllabics_naskapi_ywaa => 0x153d,
  :canadian_syllabics_y => 0x153e,
  :canadian_syllabics_bible_cree_y => 0x153f,
  :canadian_syllabics_west_cree_y => 0x1540,
  :canadian_syllabics_sayisi_yi => 0x1541,
  :canadian_syllabics_re => 0x1542,
  :canadian_syllabics_r_cree_re => 0x1543,
  :canadian_syllabics_west_cree_le => 0x1544,
  :canadian_syllabics_raai => 0x1545,
  :canadian_syllabics_ri => 0x1546,
  :canadian_syllabics_rii => 0x1547,
  :canadian_syllabics_ro => 0x1548,
  :canadian_syllabics_roo => 0x1549,
  :canadian_syllabics_west_cree_lo => 0x154a,
  :canadian_syllabics_ra => 0x154b,
  :canadian_syllabics_raa => 0x154c,
  :canadian_syllabics_west_cree_la => 0x154d,
  :canadian_syllabics_rwaa => 0x154e,
  :canadian_syllabics_west_cree_rwaa => 0x154f,
  :canadian_syllabics_r => 0x1550,
  :canadian_syllabics_west_cree_r => 0x1551,
  :canadian_syllabics_medial_r => 0x1552,
  :canadian_syllabics_fe => 0x1553,
  :canadian_syllabics_faai => 0x1554,
  :canadian_syllabics_fi => 0x1555,
  :canadian_syllabics_fii => 0x1556,
  :canadian_syllabics_fo => 0x1557,
  :canadian_syllabics_foo => 0x1558,
  :canadian_syllabics_fa => 0x1559,
  :canadian_syllabics_faa => 0x155a,
  :canadian_syllabics_fwaa => 0x155b,
  :canadian_syllabics_west_cree_fwaa => 0x155c,
  :canadian_syllabics_f => 0x155d,
  :canadian_syllabics_the => 0x155e,
  :canadian_syllabics_n_cree_the => 0x155f,
  :canadian_syllabics_thi => 0x1560,
  :canadian_syllabics_n_cree_thi => 0x1561,
  :canadian_syllabics_thii => 0x1562,
  :canadian_syllabics_n_cree_thii => 0x1563,
  :canadian_syllabics_tho => 0x1564,
  :canadian_syllabics_thoo => 0x1565,
  :canadian_syllabics_tha => 0x1566,
  :canadian_syllabics_thaa => 0x1567,
  :canadian_syllabics_thwaa => 0x1568,
  :canadian_syllabics_west_cree_thwaa => 0x1569,
  :canadian_syllabics_th => 0x156a,
  :canadian_syllabics_tthe => 0x156b,
  :canadian_syllabics_tthi => 0x156c,
  :canadian_syllabics_ttho => 0x156d,
  :canadian_syllabics_ttha => 0x156e,
  :canadian_syllabics_tth => 0x156f,
  :canadian_syllabics_tye => 0x1570,
  :canadian_syllabics_tyi => 0x1571,
  :canadian_syllabics_tyo => 0x1572,
  :canadian_syllabics_tya => 0x1573,
  :canadian_syllabics_nunavik_he => 0x1574,
  :canadian_syllabics_nunavik_hi => 0x1575,
  :canadian_syllabics_nunavik_hii => 0x1576,
  :canadian_syllabics_nunavik_ho => 0x1577,
  :canadian_syllabics_nunavik_hoo => 0x1578,
  :canadian_syllabics_nunavik_ha => 0x1579,
  :canadian_syllabics_nunavik_haa => 0x157a,
  :canadian_syllabics_nunavik_h => 0x157b,
  :canadian_syllabics_nunavut_h => 0x157c,
  :canadian_syllabics_hk => 0x157d,
  :canadian_syllabics_qaai => 0x157e,
  :canadian_syllabics_qi => 0x157f,
  :canadian_syllabics_qii => 0x1580,
  :canadian_syllabics_qo => 0x1581,
  :canadian_syllabics_qoo => 0x1582,
  :canadian_syllabics_qa => 0x1583,
  :canadian_syllabics_qaa => 0x1584,
  :canadian_syllabics_q => 0x1585,
  :canadian_syllabics_tlhe => 0x1586,
  :canadian_syllabics_tlhi => 0x1587,
  :canadian_syllabics_tlho => 0x1588,
  :canadian_syllabics_tlha => 0x1589,
  :canadian_syllabics_west_cree_re => 0x158a,
  :canadian_syllabics_west_cree_ri => 0x158b,
  :canadian_syllabics_west_cree_ro => 0x158c,
  :canadian_syllabics_west_cree_ra => 0x158d,
  :canadian_syllabics_ngaai => 0x158e,
  :canadian_syllabics_ngi => 0x158f,
  :canadian_syllabics_ngii => 0x1590,
  :canadian_syllabics_ngo => 0x1591,
  :canadian_syllabics_ngoo => 0x1592,
  :canadian_syllabics_nga => 0x1593,
  :canadian_syllabics_ngaa => 0x1594,
  :canadian_syllabics_ng => 0x1595,
  :canadian_syllabics_nng => 0x1596,
  :canadian_syllabics_sayisi_she => 0x1597,
  :canadian_syllabics_sayisi_shi => 0x1598,
  :canadian_syllabics_sayisi_sho => 0x1599,
  :canadian_syllabics_sayisi_sha => 0x159a,
  :canadian_syllabics_woods_cree_the => 0x159b,
  :canadian_syllabics_woods_cree_thi => 0x159c,
  :canadian_syllabics_woods_cree_tho => 0x159d,
  :canadian_syllabics_woods_cree_tha => 0x159e,
  :canadian_syllabics_woods_cree_th => 0x159f,
  :canadian_syllabics_lhi => 0x15a0,
  :canadian_syllabics_lhii => 0x15a1,
  :canadian_syllabics_lho => 0x15a2,
  :canadian_syllabics_lhoo => 0x15a3,
  :canadian_syllabics_lha => 0x15a4,
  :canadian_syllabics_lhaa => 0x15a5,
  :canadian_syllabics_lh => 0x15a6,
  :canadian_syllabics_th_cree_the => 0x15a7,
  :canadian_syllabics_th_cree_thi => 0x15a8,
  :canadian_syllabics_th_cree_thii => 0x15a9,
  :canadian_syllabics_th_cree_tho => 0x15aa,
  :canadian_syllabics_th_cree_thoo => 0x15ab,
  :canadian_syllabics_th_cree_tha => 0x15ac,
  :canadian_syllabics_th_cree_thaa => 0x15ad,
  :canadian_syllabics_th_cree_th => 0x15ae,
  :canadian_syllabics_aivilik_b => 0x15af,
  :canadian_syllabics_blackfoot_e => 0x15b0,
  :canadian_syllabics_blackfoot_i => 0x15b1,
  :canadian_syllabics_blackfoot_o => 0x15b2,
  :canadian_syllabics_blackfoot_a => 0x15b3,
  :canadian_syllabics_blackfoot_we => 0x15b4,
  :canadian_syllabics_blackfoot_wi => 0x15b5,
  :canadian_syllabics_blackfoot_wo => 0x15b6,
  :canadian_syllabics_blackfoot_wa => 0x15b7,
  :canadian_syllabics_blackfoot_ne => 0x15b8,
  :canadian_syllabics_blackfoot_ni => 0x15b9,
  :canadian_syllabics_blackfoot_no => 0x15ba,
  :canadian_syllabics_blackfoot_na => 0x15bb,
  :canadian_syllabics_blackfoot_ke => 0x15bc,
  :canadian_syllabics_blackfoot_ki => 0x15bd,
  :canadian_syllabics_blackfoot_ko => 0x15be,
  :canadian_syllabics_blackfoot_ka => 0x15bf,
  :canadian_syllabics_sayisi_he => 0x15c0,
  :canadian_syllabics_sayisi_hi => 0x15c1,
  :canadian_syllabics_sayisi_ho => 0x15c2,
  :canadian_syllabics_sayisi_ha => 0x15c3,
  :canadian_syllabics_carrier_ghu => 0x15c4,
  :canadian_syllabics_carrier_gho => 0x15c5,
  :canadian_syllabics_carrier_ghe => 0x15c6,
  :canadian_syllabics_carrier_ghee => 0x15c7,
  :canadian_syllabics_carrier_ghi => 0x15c8,
  :canadian_syllabics_carrier_gha => 0x15c9,
  :canadian_syllabics_carrier_ru => 0x15ca,
  :canadian_syllabics_carrier_ro => 0x15cb,
  :canadian_syllabics_carrier_re => 0x15cc,
  :canadian_syllabics_carrier_ree => 0x15cd,
  :canadian_syllabics_carrier_ri => 0x15ce,
  :canadian_syllabics_carrier_ra => 0x15cf,
  :canadian_syllabics_carrier_wu => 0x15d0,
  :canadian_syllabics_carrier_wo => 0x15d1,
  :canadian_syllabics_carrier_we => 0x15d2,
  :canadian_syllabics_carrier_wee => 0x15d3,
  :canadian_syllabics_carrier_wi => 0x15d4,
  :canadian_syllabics_carrier_wa => 0x15d5,
  :canadian_syllabics_carrier_hwu => 0x15d6,
  :canadian_syllabics_carrier_hwo => 0x15d7,
  :canadian_syllabics_carrier_hwe => 0x15d8,
  :canadian_syllabics_carrier_hwee => 0x15d9,
  :canadian_syllabics_carrier_hwi => 0x15da,
  :canadian_syllabics_carrier_hwa => 0x15db,
  :canadian_syllabics_carrier_thu => 0x15dc,
  :canadian_syllabics_carrier_tho => 0x15dd,
  :canadian_syllabics_carrier_the => 0x15de,
  :canadian_syllabics_carrier_thee => 0x15df,
  :canadian_syllabics_carrier_thi => 0x15e0,
  :canadian_syllabics_carrier_tha => 0x15e1,
  :canadian_syllabics_carrier_ttu => 0x15e2,
  :canadian_syllabics_carrier_tto => 0x15e3,
  :canadian_syllabics_carrier_tte => 0x15e4,
  :canadian_syllabics_carrier_ttee => 0x15e5,
  :canadian_syllabics_carrier_tti => 0x15e6,
  :canadian_syllabics_carrier_tta => 0x15e7,
  :canadian_syllabics_carrier_pu => 0x15e8,
  :canadian_syllabics_carrier_po => 0x15e9,
  :canadian_syllabics_carrier_pe => 0x15ea,
  :canadian_syllabics_carrier_pee => 0x15eb,
  :canadian_syllabics_carrier_pi => 0x15ec,
  :canadian_syllabics_carrier_pa => 0x15ed,
  :canadian_syllabics_carrier_p => 0x15ee,
  :canadian_syllabics_carrier_gu => 0x15ef,
  :canadian_syllabics_carrier_go => 0x15f0,
  :canadian_syllabics_carrier_ge => 0x15f1,
  :canadian_syllabics_carrier_gee => 0x15f2,
  :canadian_syllabics_carrier_gi => 0x15f3,
  :canadian_syllabics_carrier_ga => 0x15f4,
  :canadian_syllabics_carrier_khu => 0x15f5,
  :canadian_syllabics_carrier_kho => 0x15f6,
  :canadian_syllabics_carrier_khe => 0x15f7,
  :canadian_syllabics_carrier_khee => 0x15f8,
  :canadian_syllabics_carrier_khi => 0x15f9,
  :canadian_syllabics_carrier_kha => 0x15fa,
  :canadian_syllabics_carrier_kku => 0x15fb,
  :canadian_syllabics_carrier_kko => 0x15fc,
  :canadian_syllabics_carrier_kke => 0x15fd,
  :canadian_syllabics_carrier_kkee => 0x15fe,
  :canadian_syllabics_carrier_kki => 0x15ff,
  :canadian_syllabics_carrier_kka => 0x1600,
  :canadian_syllabics_carrier_kk => 0x1601,
  :canadian_syllabics_carrier_nu => 0x1602,
  :canadian_syllabics_carrier_no => 0x1603,
  :canadian_syllabics_carrier_ne => 0x1604,
  :canadian_syllabics_carrier_nee => 0x1605,
  :canadian_syllabics_carrier_ni => 0x1606,
  :canadian_syllabics_carrier_na => 0x1607,
  :canadian_syllabics_carrier_mu => 0x1608,
  :canadian_syllabics_carrier_mo => 0x1609,
  :canadian_syllabics_carrier_me => 0x160a,
  :canadian_syllabics_carrier_mee => 0x160b,
  :canadian_syllabics_carrier_mi => 0x160c,
  :canadian_syllabics_carrier_ma => 0x160d,
  :canadian_syllabics_carrier_yu => 0x160e,
  :canadian_syllabics_carrier_yo => 0x160f,
  :canadian_syllabics_carrier_ye => 0x1610,
  :canadian_syllabics_carrier_yee => 0x1611,
  :canadian_syllabics_carrier_yi => 0x1612,
  :canadian_syllabics_carrier_ya => 0x1613,
  :canadian_syllabics_carrier_ju => 0x1614,
  :canadian_syllabics_sayisi_ju => 0x1615,
  :canadian_syllabics_carrier_jo => 0x1616,
  :canadian_syllabics_carrier_je => 0x1617,
  :canadian_syllabics_carrier_jee => 0x1618,
  :canadian_syllabics_carrier_ji => 0x1619,
  :canadian_syllabics_sayisi_ji => 0x161a,
  :canadian_syllabics_carrier_ja => 0x161b,
  :canadian_syllabics_carrier_jju => 0x161c,
  :canadian_syllabics_carrier_jjo => 0x161d,
  :canadian_syllabics_carrier_jje => 0x161e,
  :canadian_syllabics_carrier_jjee => 0x161f,
  :canadian_syllabics_carrier_jji => 0x1620,
  :canadian_syllabics_carrier_jja => 0x1621,
  :canadian_syllabics_carrier_lu => 0x1622,
  :canadian_syllabics_carrier_lo => 0x1623,
  :canadian_syllabics_carrier_le => 0x1624,
  :canadian_syllabics_carrier_lee => 0x1625,
  :canadian_syllabics_carrier_li => 0x1626,
  :canadian_syllabics_carrier_la => 0x1627,
  :canadian_syllabics_carrier_dlu => 0x1628,
  :canadian_syllabics_carrier_dlo => 0x1629,
  :canadian_syllabics_carrier_dle => 0x162a,
  :canadian_syllabics_carrier_dlee => 0x162b,
  :canadian_syllabics_carrier_dli => 0x162c,
  :canadian_syllabics_carrier_dla => 0x162d,
  :canadian_syllabics_carrier_lhu => 0x162e,
  :canadian_syllabics_carrier_lho => 0x162f,
  :canadian_syllabics_carrier_lhe => 0x1630,
  :canadian_syllabics_carrier_lhee => 0x1631,
  :canadian_syllabics_carrier_lhi => 0x1632,
  :canadian_syllabics_carrier_lha => 0x1633,
  :canadian_syllabics_carrier_tlhu => 0x1634,
  :canadian_syllabics_carrier_tlho => 0x1635,
  :canadian_syllabics_carrier_tlhe => 0x1636,
  :canadian_syllabics_carrier_tlhee => 0x1637,
  :canadian_syllabics_carrier_tlhi => 0x1638,
  :canadian_syllabics_carrier_tlha => 0x1639,
  :canadian_syllabics_carrier_tlu => 0x163a,
  :canadian_syllabics_carrier_tlo => 0x163b,
  :canadian_syllabics_carrier_tle => 0x163c,
  :canadian_syllabics_carrier_tlee => 0x163d,
  :canadian_syllabics_carrier_tli => 0x163e,
  :canadian_syllabics_carrier_tla => 0x163f,
  :canadian_syllabics_carrier_zu => 0x1640,
  :canadian_syllabics_carrier_zo => 0x1641,
  :canadian_syllabics_carrier_ze => 0x1642,
  :canadian_syllabics_carrier_zee => 0x1643,
  :canadian_syllabics_carrier_zi => 0x1644,
  :canadian_syllabics_carrier_za => 0x1645,
  :canadian_syllabics_carrier_z => 0x1646,
  :canadian_syllabics_carrier_initial_z => 0x1647,
  :canadian_syllabics_carrier_dzu => 0x1648,
  :canadian_syllabics_carrier_dzo => 0x1649,
  :canadian_syllabics_carrier_dze => 0x164a,
  :canadian_syllabics_carrier_dzee => 0x164b,
  :canadian_syllabics_carrier_dzi => 0x164c,
  :canadian_syllabics_carrier_dza => 0x164d,
  :canadian_syllabics_carrier_su => 0x164e,
  :canadian_syllabics_carrier_so => 0x164f,
  :canadian_syllabics_carrier_se => 0x1650,
  :canadian_syllabics_carrier_see => 0x1651,
  :canadian_syllabics_carrier_si => 0x1652,
  :canadian_syllabics_carrier_sa => 0x1653,
  :canadian_syllabics_carrier_shu => 0x1654,
  :canadian_syllabics_carrier_sho => 0x1655,
  :canadian_syllabics_carrier_she => 0x1656,
  :canadian_syllabics_carrier_shee => 0x1657,
  :canadian_syllabics_carrier_shi => 0x1658,
  :canadian_syllabics_carrier_sha => 0x1659,
  :canadian_syllabics_carrier_sh => 0x165a,
  :canadian_syllabics_carrier_tsu => 0x165b,
  :canadian_syllabics_carrier_tso => 0x165c,
  :canadian_syllabics_carrier_tse => 0x165d,
  :canadian_syllabics_carrier_tsee => 0x165e,
  :canadian_syllabics_carrier_tsi => 0x165f,
  :canadian_syllabics_carrier_tsa => 0x1660,
  :canadian_syllabics_carrier_chu => 0x1661,
  :canadian_syllabics_carrier_cho => 0x1662,
  :canadian_syllabics_carrier_che => 0x1663,
  :canadian_syllabics_carrier_chee => 0x1664,
  :canadian_syllabics_carrier_chi => 0x1665,
  :canadian_syllabics_carrier_cha => 0x1666,
  :canadian_syllabics_carrier_ttsu => 0x1667,
  :canadian_syllabics_carrier_ttso => 0x1668,
  :canadian_syllabics_carrier_ttse => 0x1669,
  :canadian_syllabics_carrier_ttsee => 0x166a,
  :canadian_syllabics_carrier_ttsi => 0x166b,
  :canadian_syllabics_carrier_ttsa => 0x166c,
  :canadian_syllabics_chi_sign => 0x166d,
  :canadian_syllabics_full_stop => 0x166e,
  :canadian_syllabics_qai => 0x166f,
  :canadian_syllabics_ngai => 0x1670,
  :canadian_syllabics_nngi => 0x1671,
  :canadian_syllabics_nngii => 0x1672,
  :canadian_syllabics_nngo => 0x1673,
  :canadian_syllabics_nngoo => 0x1674,
  :canadian_syllabics_nnga => 0x1675,
  :canadian_syllabics_nngaa => 0x1676,
  :ogham_space_mark => 0x1680,
  :ogham_letter_beith => 0x1681,
  :ogham_letter_luis => 0x1682,
  :ogham_letter_fearn => 0x1683,
  :ogham_letter_sail => 0x1684,
  :ogham_letter_nion => 0x1685,
  :ogham_letter_uath => 0x1686,
  :ogham_letter_dair => 0x1687,
  :ogham_letter_tinne => 0x1688,
  :ogham_letter_coll => 0x1689,
  :ogham_letter_ceirt => 0x168a,
  :ogham_letter_muin => 0x168b,
  :ogham_letter_gort => 0x168c,
  :ogham_letter_ngeadal => 0x168d,
  :ogham_letter_straif => 0x168e,
  :ogham_letter_ruis => 0x168f,
  :ogham_letter_ailm => 0x1690,
  :ogham_letter_onn => 0x1691,
  :ogham_letter_ur => 0x1692,
  :ogham_letter_eadhadh => 0x1693,
  :ogham_letter_iodhadh => 0x1694,
  :ogham_letter_eabhadh => 0x1695,
  :ogham_letter_or => 0x1696,
  :ogham_letter_uilleann => 0x1697,
  :ogham_letter_ifin => 0x1698,
  :ogham_letter_eamhancholl => 0x1699,
  :ogham_letter_peith => 0x169a,
  :ogham_feather_mark => 0x169b,
  :ogham_reversed_feather_mark => 0x169c,
  :runic_letter_fehu_feoh_fe_f => 0x16a0,
  :runic_letter_v => 0x16a1,
  :runic_letter_uruz_ur_u => 0x16a2,
  :runic_letter_yr => 0x16a3,
  :runic_letter_y => 0x16a4,
  :runic_letter_w => 0x16a5,
  :runic_letter_thurisaz_thurs_thorn => 0x16a6,
  :runic_letter_eth => 0x16a7,
  :runic_letter_ansuz_a => 0x16a8,
  :runic_letter_os_o => 0x16a9,
  :runic_letter_ac_a => 0x16aa,
  :runic_letter_aesc => 0x16ab,
  :runic_letter_long_branch_oss_o => 0x16ac,
  :runic_letter_short_twig_oss_o => 0x16ad,
  :runic_letter_o => 0x16ae,
  :runic_letter_oe => 0x16af,
  :runic_letter_on => 0x16b0,
  :runic_letter_raido_rad_reid_r => 0x16b1,
  :runic_letter_kauna => 0x16b2,
  :runic_letter_cen => 0x16b3,
  :runic_letter_kaun_k => 0x16b4,
  :runic_letter_g => 0x16b5,
  :runic_letter_eng => 0x16b6,
  :runic_letter_gebo_gyfu_g => 0x16b7,
  :runic_letter_gar => 0x16b8,
  :runic_letter_wunjo_wynn_w => 0x16b9,
  :runic_letter_haglaz_h => 0x16ba,
  :runic_letter_haegl_h => 0x16bb,
  :runic_letter_long_branch_hagall_h => 0x16bc,
  :runic_letter_short_twig_hagall_h => 0x16bd,
  :runic_letter_naudiz_nyd_naud_n => 0x16be,
  :runic_letter_short_twig_naud_n => 0x16bf,
  :runic_letter_dotted_n => 0x16c0,
  :runic_letter_isaz_is_iss_i => 0x16c1,
  :runic_letter_e => 0x16c2,
  :runic_letter_jeran_j => 0x16c3,
  :runic_letter_ger => 0x16c4,
  :runic_letter_long_branch_ar_ae => 0x16c5,
  :runic_letter_short_twig_ar_a => 0x16c6,
  :runic_letter_iwaz_eoh => 0x16c7,
  :runic_letter_pertho_peorth_p => 0x16c8,
  :runic_letter_algiz_eolhx => 0x16c9,
  :runic_letter_sowilo_s => 0x16ca,
  :runic_letter_sigel_long_branch_sol_s => 0x16cb,
  :runic_letter_short_twig_sol_s => 0x16cc,
  :runic_letter_c => 0x16cd,
  :runic_letter_z => 0x16ce,
  :runic_letter_tiwaz_tir_tyr_t => 0x16cf,
  :runic_letter_short_twig_tyr_t => 0x16d0,
  :runic_letter_d => 0x16d1,
  :runic_letter_berkanan_beorc_bjarkan_b => 0x16d2,
  :runic_letter_short_twig_bjarkan_b => 0x16d3,
  :runic_letter_dotted_p => 0x16d4,
  :runic_letter_open_p => 0x16d5,
  :runic_letter_ehwaz_eh_e => 0x16d6,
  :runic_letter_mannaz_man_m => 0x16d7,
  :runic_letter_long_branch_madr_m => 0x16d8,
  :runic_letter_short_twig_madr_m => 0x16d9,
  :runic_letter_laukaz_lagu_logr_l => 0x16da,
  :runic_letter_dotted_l => 0x16db,
  :runic_letter_ingwaz => 0x16dc,
  :runic_letter_ing => 0x16dd,
  :runic_letter_dagaz_daeg_d => 0x16de,
  :runic_letter_othalan_ethel_o => 0x16df,
  :runic_letter_ear => 0x16e0,
  :runic_letter_ior => 0x16e1,
  :runic_letter_cweorth => 0x16e2,
  :runic_letter_calc => 0x16e3,
  :runic_letter_cealc => 0x16e4,
  :runic_letter_stan => 0x16e5,
  :runic_letter_long_branch_yr => 0x16e6,
  :runic_letter_short_twig_yr => 0x16e7,
  :runic_letter_icelandic_yr => 0x16e8,
  :runic_letter_q => 0x16e9,
  :runic_letter_x => 0x16ea,
  :runic_single_punctuation => 0x16eb,
  :runic_multiple_punctuation => 0x16ec,
  :runic_cross_punctuation => 0x16ed,
  :runic_arlaug_symbol => 0x16ee,
  :runic_tvimadur_symbol => 0x16ef,
  :runic_belgthor_symbol => 0x16f0,
  :tagalog_letter_a => 0x1700,
  :tagalog_letter_i => 0x1701,
  :tagalog_letter_u => 0x1702,
  :tagalog_letter_ka => 0x1703,
  :tagalog_letter_ga => 0x1704,
  :tagalog_letter_nga => 0x1705,
  :tagalog_letter_ta => 0x1706,
  :tagalog_letter_da => 0x1707,
  :tagalog_letter_na => 0x1708,
  :tagalog_letter_pa => 0x1709,
  :tagalog_letter_ba => 0x170a,
  :tagalog_letter_ma => 0x170b,
  :tagalog_letter_ya => 0x170c,
  :tagalog_letter_la => 0x170e,
  :tagalog_letter_wa => 0x170f,
  :tagalog_letter_sa => 0x1710,
  :tagalog_letter_ha => 0x1711,
  :tagalog_vowel_sign_i => 0x1712,
  :tagalog_vowel_sign_u => 0x1713,
  :tagalog_sign_virama => 0x1714,
  :hanunoo_letter_a => 0x1720,
  :hanunoo_letter_i => 0x1721,
  :hanunoo_letter_u => 0x1722,
  :hanunoo_letter_ka => 0x1723,
  :hanunoo_letter_ga => 0x1724,
  :hanunoo_letter_nga => 0x1725,
  :hanunoo_letter_ta => 0x1726,
  :hanunoo_letter_da => 0x1727,
  :hanunoo_letter_na => 0x1728,
  :hanunoo_letter_pa => 0x1729,
  :hanunoo_letter_ba => 0x172a,
  :hanunoo_letter_ma => 0x172b,
  :hanunoo_letter_ya => 0x172c,
  :hanunoo_letter_ra => 0x172d,
  :hanunoo_letter_la => 0x172e,
  :hanunoo_letter_wa => 0x172f,
  :hanunoo_letter_sa => 0x1730,
  :hanunoo_letter_ha => 0x1731,
  :hanunoo_vowel_sign_i => 0x1732,
  :hanunoo_vowel_sign_u => 0x1733,
  :hanunoo_sign_pamudpod => 0x1734,
  :philippine_single_punctuation => 0x1735,
  :philippine_double_punctuation => 0x1736,
  :buhid_letter_a => 0x1740,
  :buhid_letter_i => 0x1741,
  :buhid_letter_u => 0x1742,
  :buhid_letter_ka => 0x1743,
  :buhid_letter_ga => 0x1744,
  :buhid_letter_nga => 0x1745,
  :buhid_letter_ta => 0x1746,
  :buhid_letter_da => 0x1747,
  :buhid_letter_na => 0x1748,
  :buhid_letter_pa => 0x1749,
  :buhid_letter_ba => 0x174a,
  :buhid_letter_ma => 0x174b,
  :buhid_letter_ya => 0x174c,
  :buhid_letter_ra => 0x174d,
  :buhid_letter_la => 0x174e,
  :buhid_letter_wa => 0x174f,
  :buhid_letter_sa => 0x1750,
  :buhid_letter_ha => 0x1751,
  :buhid_vowel_sign_i => 0x1752,
  :buhid_vowel_sign_u => 0x1753,
  :tagbanwa_letter_a => 0x1760,
  :tagbanwa_letter_i => 0x1761,
  :tagbanwa_letter_u => 0x1762,
  :tagbanwa_letter_ka => 0x1763,
  :tagbanwa_letter_ga => 0x1764,
  :tagbanwa_letter_nga => 0x1765,
  :tagbanwa_letter_ta => 0x1766,
  :tagbanwa_letter_da => 0x1767,
  :tagbanwa_letter_na => 0x1768,
  :tagbanwa_letter_pa => 0x1769,
  :tagbanwa_letter_ba => 0x176a,
  :tagbanwa_letter_ma => 0x176b,
  :tagbanwa_letter_ya => 0x176c,
  :tagbanwa_letter_la => 0x176e,
  :tagbanwa_letter_wa => 0x176f,
  :tagbanwa_letter_sa => 0x1770,
  :tagbanwa_vowel_sign_i => 0x1772,
  :tagbanwa_vowel_sign_u => 0x1773,
  :khmer_letter_ka => 0x1780,
  :khmer_letter_kha => 0x1781,
  :khmer_letter_ko => 0x1782,
  :khmer_letter_kho => 0x1783,
  :khmer_letter_ngo => 0x1784,
  :khmer_letter_ca => 0x1785,
  :khmer_letter_cha => 0x1786,
  :khmer_letter_co => 0x1787,
  :khmer_letter_cho => 0x1788,
  :khmer_letter_nyo => 0x1789,
  :khmer_letter_da => 0x178a,
  :khmer_letter_ttha => 0x178b,
  :khmer_letter_do => 0x178c,
  :khmer_letter_ttho => 0x178d,
  :khmer_letter_nno => 0x178e,
  :khmer_letter_ta => 0x178f,
  :khmer_letter_tha => 0x1790,
  :khmer_letter_to => 0x1791,
  :khmer_letter_tho => 0x1792,
  :khmer_letter_no => 0x1793,
  :khmer_letter_ba => 0x1794,
  :khmer_letter_pha => 0x1795,
  :khmer_letter_po => 0x1796,
  :khmer_letter_pho => 0x1797,
  :khmer_letter_mo => 0x1798,
  :khmer_letter_yo => 0x1799,
  :khmer_letter_ro => 0x179a,
  :khmer_letter_lo => 0x179b,
  :khmer_letter_vo => 0x179c,
  :khmer_letter_sha => 0x179d,
  :khmer_letter_sso => 0x179e,
  :khmer_letter_sa => 0x179f,
  :khmer_letter_ha => 0x17a0,
  :khmer_letter_la => 0x17a1,
  :khmer_letter_qa => 0x17a2,
  :khmer_independent_vowel_qaq => 0x17a3,
  :khmer_independent_vowel_qaa => 0x17a4,
  :khmer_independent_vowel_qi => 0x17a5,
  :khmer_independent_vowel_qii => 0x17a6,
  :khmer_independent_vowel_qu => 0x17a7,
  :khmer_independent_vowel_quk => 0x17a8,
  :khmer_independent_vowel_quu => 0x17a9,
  :khmer_independent_vowel_quuv => 0x17aa,
  :khmer_independent_vowel_ry => 0x17ab,
  :khmer_independent_vowel_ryy => 0x17ac,
  :khmer_independent_vowel_ly => 0x17ad,
  :khmer_independent_vowel_lyy => 0x17ae,
  :khmer_independent_vowel_qe => 0x17af,
  :khmer_independent_vowel_qai => 0x17b0,
  :khmer_independent_vowel_qoo_type_one => 0x17b1,
  :khmer_independent_vowel_qoo_type_two => 0x17b2,
  :khmer_independent_vowel_qau => 0x17b3,
  :khmer_vowel_inherent_aq => 0x17b4,
  :khmer_vowel_inherent_aa => 0x17b5,
  :khmer_vowel_sign_aa => 0x17b6,
  :khmer_vowel_sign_i => 0x17b7,
  :khmer_vowel_sign_ii => 0x17b8,
  :khmer_vowel_sign_y => 0x17b9,
  :khmer_vowel_sign_yy => 0x17ba,
  :khmer_vowel_sign_u => 0x17bb,
  :khmer_vowel_sign_uu => 0x17bc,
  :khmer_vowel_sign_ua => 0x17bd,
  :khmer_vowel_sign_oe => 0x17be,
  :khmer_vowel_sign_ya => 0x17bf,
  :khmer_vowel_sign_ie => 0x17c0,
  :khmer_vowel_sign_e => 0x17c1,
  :khmer_vowel_sign_ae => 0x17c2,
  :khmer_vowel_sign_ai => 0x17c3,
  :khmer_vowel_sign_oo => 0x17c4,
  :khmer_vowel_sign_au => 0x17c5,
  :khmer_sign_nikahit => 0x17c6,
  :khmer_sign_reahmuk => 0x17c7,
  :khmer_sign_yuukaleapintu => 0x17c8,
  :khmer_sign_muusikatoan => 0x17c9,
  :khmer_sign_triisap => 0x17ca,
  :khmer_sign_bantoc => 0x17cb,
  :khmer_sign_robat => 0x17cc,
  :khmer_sign_toandakhiat => 0x17cd,
  :khmer_sign_kakabat => 0x17ce,
  :khmer_sign_ahsda => 0x17cf,
  :khmer_sign_samyok_sannya => 0x17d0,
  :khmer_sign_viriam => 0x17d1,
  :khmer_sign_coeng => 0x17d2,
  :khmer_sign_bathamasat => 0x17d3,
  :khmer_sign_khan => 0x17d4,
  :khmer_sign_bariyoosan => 0x17d5,
  :khmer_sign_camnuc_pii_kuuh => 0x17d6,
  :khmer_sign_lek_too => 0x17d7,
  :khmer_sign_beyyal => 0x17d8,
  :khmer_sign_phnaek_muan => 0x17d9,
  :khmer_sign_koomuut => 0x17da,
  :khmer_currency_symbol_riel => 0x17db,
  :khmer_sign_avakrahasanya => 0x17dc,
  :khmer_sign_atthacan => 0x17dd,
  :khmer_digit_zero => 0x17e0,
  :khmer_digit_one => 0x17e1,
  :khmer_digit_two => 0x17e2,
  :khmer_digit_three => 0x17e3,
  :khmer_digit_four => 0x17e4,
  :khmer_digit_five => 0x17e5,
  :khmer_digit_six => 0x17e6,
  :khmer_digit_seven => 0x17e7,
  :khmer_digit_eight => 0x17e8,
  :khmer_digit_nine => 0x17e9,
  :khmer_symbol_lek_attak_son => 0x17f0,
  :khmer_symbol_lek_attak_muoy => 0x17f1,
  :khmer_symbol_lek_attak_pii => 0x17f2,
  :khmer_symbol_lek_attak_bei => 0x17f3,
  :khmer_symbol_lek_attak_buon => 0x17f4,
  :khmer_symbol_lek_attak_pram => 0x17f5,
  :khmer_symbol_lek_attak_pram_muoy => 0x17f6,
  :khmer_symbol_lek_attak_pram_pii => 0x17f7,
  :khmer_symbol_lek_attak_pram_bei => 0x17f8,
  :khmer_symbol_lek_attak_pram_buon => 0x17f9,
  :mongolian_birga => 0x1800,
  :mongolian_ellipsis => 0x1801,
  :mongolian_comma => 0x1802,
  :mongolian_full_stop => 0x1803,
  :mongolian_colon => 0x1804,
  :mongolian_four_dots => 0x1805,
  :mongolian_todo_soft_hyphen => 0x1806,
  :mongolian_sibe_syllable_boundary_marker => 0x1807,
  :mongolian_manchu_comma => 0x1808,
  :mongolian_manchu_full_stop => 0x1809,
  :mongolian_nirugu => 0x180a,
  :mongolian_free_variation_selector_one => 0x180b,
  :mongolian_free_variation_selector_two => 0x180c,
  :mongolian_free_variation_selector_three => 0x180d,
  :mongolian_vowel_separator => 0x180e,
  :mongolian_digit_zero => 0x1810,
  :mongolian_digit_one => 0x1811,
  :mongolian_digit_two => 0x1812,
  :mongolian_digit_three => 0x1813,
  :mongolian_digit_four => 0x1814,
  :mongolian_digit_five => 0x1815,
  :mongolian_digit_six => 0x1816,
  :mongolian_digit_seven => 0x1817,
  :mongolian_digit_eight => 0x1818,
  :mongolian_digit_nine => 0x1819,
  :mongolian_letter_a => 0x1820,
  :mongolian_letter_e => 0x1821,
  :mongolian_letter_i => 0x1822,
  :mongolian_letter_o => 0x1823,
  :mongolian_letter_u => 0x1824,
  :mongolian_letter_oe => 0x1825,
  :mongolian_letter_ue => 0x1826,
  :mongolian_letter_ee => 0x1827,
  :mongolian_letter_na => 0x1828,
  :mongolian_letter_ang => 0x1829,
  :mongolian_letter_ba => 0x182a,
  :mongolian_letter_pa => 0x182b,
  :mongolian_letter_qa => 0x182c,
  :mongolian_letter_ga => 0x182d,
  :mongolian_letter_ma => 0x182e,
  :mongolian_letter_la => 0x182f,
  :mongolian_letter_sa => 0x1830,
  :mongolian_letter_sha => 0x1831,
  :mongolian_letter_ta => 0x1832,
  :mongolian_letter_da => 0x1833,
  :mongolian_letter_cha => 0x1834,
  :mongolian_letter_ja => 0x1835,
  :mongolian_letter_ya => 0x1836,
  :mongolian_letter_ra => 0x1837,
  :mongolian_letter_wa => 0x1838,
  :mongolian_letter_fa => 0x1839,
  :mongolian_letter_ka => 0x183a,
  :mongolian_letter_kha => 0x183b,
  :mongolian_letter_tsa => 0x183c,
  :mongolian_letter_za => 0x183d,
  :mongolian_letter_haa => 0x183e,
  :mongolian_letter_zra => 0x183f,
  :mongolian_letter_lha => 0x1840,
  :mongolian_letter_zhi => 0x1841,
  :mongolian_letter_chi => 0x1842,
  :mongolian_letter_todo_long_vowel_sign => 0x1843,
  :mongolian_letter_todo_e => 0x1844,
  :mongolian_letter_todo_i => 0x1845,
  :mongolian_letter_todo_o => 0x1846,
  :mongolian_letter_todo_u => 0x1847,
  :mongolian_letter_todo_oe => 0x1848,
  :mongolian_letter_todo_ue => 0x1849,
  :mongolian_letter_todo_ang => 0x184a,
  :mongolian_letter_todo_ba => 0x184b,
  :mongolian_letter_todo_pa => 0x184c,
  :mongolian_letter_todo_qa => 0x184d,
  :mongolian_letter_todo_ga => 0x184e,
  :mongolian_letter_todo_ma => 0x184f,
  :mongolian_letter_todo_ta => 0x1850,
  :mongolian_letter_todo_da => 0x1851,
  :mongolian_letter_todo_cha => 0x1852,
  :mongolian_letter_todo_ja => 0x1853,
  :mongolian_letter_todo_tsa => 0x1854,
  :mongolian_letter_todo_ya => 0x1855,
  :mongolian_letter_todo_wa => 0x1856,
  :mongolian_letter_todo_ka => 0x1857,
  :mongolian_letter_todo_gaa => 0x1858,
  :mongolian_letter_todo_haa => 0x1859,
  :mongolian_letter_todo_jia => 0x185a,
  :mongolian_letter_todo_nia => 0x185b,
  :mongolian_letter_todo_dza => 0x185c,
  :mongolian_letter_sibe_e => 0x185d,
  :mongolian_letter_sibe_i => 0x185e,
  :mongolian_letter_sibe_iy => 0x185f,
  :mongolian_letter_sibe_ue => 0x1860,
  :mongolian_letter_sibe_u => 0x1861,
  :mongolian_letter_sibe_ang => 0x1862,
  :mongolian_letter_sibe_ka => 0x1863,
  :mongolian_letter_sibe_ga => 0x1864,
  :mongolian_letter_sibe_ha => 0x1865,
  :mongolian_letter_sibe_pa => 0x1866,
  :mongolian_letter_sibe_sha => 0x1867,
  :mongolian_letter_sibe_ta => 0x1868,
  :mongolian_letter_sibe_da => 0x1869,
  :mongolian_letter_sibe_ja => 0x186a,
  :mongolian_letter_sibe_fa => 0x186b,
  :mongolian_letter_sibe_gaa => 0x186c,
  :mongolian_letter_sibe_haa => 0x186d,
  :mongolian_letter_sibe_tsa => 0x186e,
  :mongolian_letter_sibe_za => 0x186f,
  :mongolian_letter_sibe_raa => 0x1870,
  :mongolian_letter_sibe_cha => 0x1871,
  :mongolian_letter_sibe_zha => 0x1872,
  :mongolian_letter_manchu_i => 0x1873,
  :mongolian_letter_manchu_ka => 0x1874,
  :mongolian_letter_manchu_ra => 0x1875,
  :mongolian_letter_manchu_fa => 0x1876,
  :mongolian_letter_manchu_zha => 0x1877,
  :mongolian_letter_ali_gali_anusvara_one => 0x1880,
  :mongolian_letter_ali_gali_visarga_one => 0x1881,
  :mongolian_letter_ali_gali_damaru => 0x1882,
  :mongolian_letter_ali_gali_ubadama => 0x1883,
  :mongolian_letter_ali_gali_inverted_ubadama => 0x1884,
  :mongolian_letter_ali_gali_baluda => 0x1885,
  :mongolian_letter_ali_gali_three_baluda => 0x1886,
  :mongolian_letter_ali_gali_a => 0x1887,
  :mongolian_letter_ali_gali_i => 0x1888,
  :mongolian_letter_ali_gali_ka => 0x1889,
  :mongolian_letter_ali_gali_nga => 0x188a,
  :mongolian_letter_ali_gali_ca => 0x188b,
  :mongolian_letter_ali_gali_tta => 0x188c,
  :mongolian_letter_ali_gali_ttha => 0x188d,
  :mongolian_letter_ali_gali_dda => 0x188e,
  :mongolian_letter_ali_gali_nna => 0x188f,
  :mongolian_letter_ali_gali_ta => 0x1890,
  :mongolian_letter_ali_gali_da => 0x1891,
  :mongolian_letter_ali_gali_pa => 0x1892,
  :mongolian_letter_ali_gali_pha => 0x1893,
  :mongolian_letter_ali_gali_ssa => 0x1894,
  :mongolian_letter_ali_gali_zha => 0x1895,
  :mongolian_letter_ali_gali_za => 0x1896,
  :mongolian_letter_ali_gali_ah => 0x1897,
  :mongolian_letter_todo_ali_gali_ta => 0x1898,
  :mongolian_letter_todo_ali_gali_zha => 0x1899,
  :mongolian_letter_manchu_ali_gali_gha => 0x189a,
  :mongolian_letter_manchu_ali_gali_nga => 0x189b,
  :mongolian_letter_manchu_ali_gali_ca => 0x189c,
  :mongolian_letter_manchu_ali_gali_jha => 0x189d,
  :mongolian_letter_manchu_ali_gali_tta => 0x189e,
  :mongolian_letter_manchu_ali_gali_ddha => 0x189f,
  :mongolian_letter_manchu_ali_gali_ta => 0x18a0,
  :mongolian_letter_manchu_ali_gali_dha => 0x18a1,
  :mongolian_letter_manchu_ali_gali_ssa => 0x18a2,
  :mongolian_letter_manchu_ali_gali_cya => 0x18a3,
  :mongolian_letter_manchu_ali_gali_zha => 0x18a4,
  :mongolian_letter_manchu_ali_gali_za => 0x18a5,
  :mongolian_letter_ali_gali_half_u => 0x18a6,
  :mongolian_letter_ali_gali_half_ya => 0x18a7,
  :mongolian_letter_manchu_ali_gali_bha => 0x18a8,
  :mongolian_letter_ali_gali_dagalga => 0x18a9,
  :limbu_vowel_carrier_letter => 0x1900,
  :limbu_letter_ka => 0x1901,
  :limbu_letter_kha => 0x1902,
  :limbu_letter_ga => 0x1903,
  :limbu_letter_gha => 0x1904,
  :limbu_letter_nga => 0x1905,
  :limbu_letter_ca => 0x1906,
  :limbu_letter_cha => 0x1907,
  :limbu_letter_ja => 0x1908,
  :limbu_letter_jha => 0x1909,
  :limbu_letter_yan => 0x190a,
  :limbu_letter_ta => 0x190b,
  :limbu_letter_tha => 0x190c,
  :limbu_letter_da => 0x190d,
  :limbu_letter_dha => 0x190e,
  :limbu_letter_na => 0x190f,
  :limbu_letter_pa => 0x1910,
  :limbu_letter_pha => 0x1911,
  :limbu_letter_ba => 0x1912,
  :limbu_letter_bha => 0x1913,
  :limbu_letter_ma => 0x1914,
  :limbu_letter_ya => 0x1915,
  :limbu_letter_ra => 0x1916,
  :limbu_letter_la => 0x1917,
  :limbu_letter_wa => 0x1918,
  :limbu_letter_sha => 0x1919,
  :limbu_letter_ssa => 0x191a,
  :limbu_letter_sa => 0x191b,
  :limbu_letter_ha => 0x191c,
  :limbu_vowel_sign_a => 0x1920,
  :limbu_vowel_sign_i => 0x1921,
  :limbu_vowel_sign_u => 0x1922,
  :limbu_vowel_sign_ee => 0x1923,
  :limbu_vowel_sign_ai => 0x1924,
  :limbu_vowel_sign_oo => 0x1925,
  :limbu_vowel_sign_au => 0x1926,
  :limbu_vowel_sign_e => 0x1927,
  :limbu_vowel_sign_o => 0x1928,
  :limbu_subjoined_letter_ya => 0x1929,
  :limbu_subjoined_letter_ra => 0x192a,
  :limbu_subjoined_letter_wa => 0x192b,
  :limbu_small_letter_ka => 0x1930,
  :limbu_small_letter_nga => 0x1931,
  :limbu_small_letter_anusvara => 0x1932,
  :limbu_small_letter_ta => 0x1933,
  :limbu_small_letter_na => 0x1934,
  :limbu_small_letter_pa => 0x1935,
  :limbu_small_letter_ma => 0x1936,
  :limbu_small_letter_ra => 0x1937,
  :limbu_small_letter_la => 0x1938,
  :limbu_sign_mukphreng => 0x1939,
  :limbu_sign_kemphreng => 0x193a,
  :limbu_sign_sa_i => 0x193b,
  :limbu_sign_loo => 0x1940,
  :limbu_exclamation_mark => 0x1944,
  :limbu_question_mark => 0x1945,
  :limbu_digit_zero => 0x1946,
  :limbu_digit_one => 0x1947,
  :limbu_digit_two => 0x1948,
  :limbu_digit_three => 0x1949,
  :limbu_digit_four => 0x194a,
  :limbu_digit_five => 0x194b,
  :limbu_digit_six => 0x194c,
  :limbu_digit_seven => 0x194d,
  :limbu_digit_eight => 0x194e,
  :limbu_digit_nine => 0x194f,
  :tai_le_letter_ka => 0x1950,
  :tai_le_letter_xa => 0x1951,
  :tai_le_letter_nga => 0x1952,
  :tai_le_letter_tsa => 0x1953,
  :tai_le_letter_sa => 0x1954,
  :tai_le_letter_ya => 0x1955,
  :tai_le_letter_ta => 0x1956,
  :tai_le_letter_tha => 0x1957,
  :tai_le_letter_la => 0x1958,
  :tai_le_letter_pa => 0x1959,
  :tai_le_letter_pha => 0x195a,
  :tai_le_letter_ma => 0x195b,
  :tai_le_letter_fa => 0x195c,
  :tai_le_letter_va => 0x195d,
  :tai_le_letter_ha => 0x195e,
  :tai_le_letter_qa => 0x195f,
  :tai_le_letter_kha => 0x1960,
  :tai_le_letter_tsha => 0x1961,
  :tai_le_letter_na => 0x1962,
  :tai_le_letter_a => 0x1963,
  :tai_le_letter_i => 0x1964,
  :tai_le_letter_ee => 0x1965,
  :tai_le_letter_eh => 0x1966,
  :tai_le_letter_u => 0x1967,
  :tai_le_letter_oo => 0x1968,
  :tai_le_letter_o => 0x1969,
  :tai_le_letter_ue => 0x196a,
  :tai_le_letter_e => 0x196b,
  :tai_le_letter_aue => 0x196c,
  :tai_le_letter_ai => 0x196d,
  :tai_le_letter_tone_2 => 0x1970,
  :tai_le_letter_tone_3 => 0x1971,
  :tai_le_letter_tone_4 => 0x1972,
  :tai_le_letter_tone_5 => 0x1973,
  :tai_le_letter_tone_6 => 0x1974,
  :new_tai_lue_letter_high_qa => 0x1980,
  :new_tai_lue_letter_low_qa => 0x1981,
  :new_tai_lue_letter_high_ka => 0x1982,
  :new_tai_lue_letter_high_xa => 0x1983,
  :new_tai_lue_letter_high_nga => 0x1984,
  :new_tai_lue_letter_low_ka => 0x1985,
  :new_tai_lue_letter_low_xa => 0x1986,
  :new_tai_lue_letter_low_nga => 0x1987,
  :new_tai_lue_letter_high_tsa => 0x1988,
  :new_tai_lue_letter_high_sa => 0x1989,
  :new_tai_lue_letter_high_ya => 0x198a,
  :new_tai_lue_letter_low_tsa => 0x198b,
  :new_tai_lue_letter_low_sa => 0x198c,
  :new_tai_lue_letter_low_ya => 0x198d,
  :new_tai_lue_letter_high_ta => 0x198e,
  :new_tai_lue_letter_high_tha => 0x198f,
  :new_tai_lue_letter_high_na => 0x1990,
  :new_tai_lue_letter_low_ta => 0x1991,
  :new_tai_lue_letter_low_tha => 0x1992,
  :new_tai_lue_letter_low_na => 0x1993,
  :new_tai_lue_letter_high_pa => 0x1994,
  :new_tai_lue_letter_high_pha => 0x1995,
  :new_tai_lue_letter_high_ma => 0x1996,
  :new_tai_lue_letter_low_pa => 0x1997,
  :new_tai_lue_letter_low_pha => 0x1998,
  :new_tai_lue_letter_low_ma => 0x1999,
  :new_tai_lue_letter_high_fa => 0x199a,
  :new_tai_lue_letter_high_va => 0x199b,
  :new_tai_lue_letter_high_la => 0x199c,
  :new_tai_lue_letter_low_fa => 0x199d,
  :new_tai_lue_letter_low_va => 0x199e,
  :new_tai_lue_letter_low_la => 0x199f,
  :new_tai_lue_letter_high_ha => 0x19a0,
  :new_tai_lue_letter_high_da => 0x19a1,
  :new_tai_lue_letter_high_ba => 0x19a2,
  :new_tai_lue_letter_low_ha => 0x19a3,
  :new_tai_lue_letter_low_da => 0x19a4,
  :new_tai_lue_letter_low_ba => 0x19a5,
  :new_tai_lue_letter_high_kva => 0x19a6,
  :new_tai_lue_letter_high_xva => 0x19a7,
  :new_tai_lue_letter_low_kva => 0x19a8,
  :new_tai_lue_letter_low_xva => 0x19a9,
  :new_tai_lue_vowel_sign_vowel_shortener => 0x19b0,
  :new_tai_lue_vowel_sign_aa => 0x19b1,
  :new_tai_lue_vowel_sign_ii => 0x19b2,
  :new_tai_lue_vowel_sign_u => 0x19b3,
  :new_tai_lue_vowel_sign_uu => 0x19b4,
  :new_tai_lue_vowel_sign_e => 0x19b5,
  :new_tai_lue_vowel_sign_ae => 0x19b6,
  :new_tai_lue_vowel_sign_o => 0x19b7,
  :new_tai_lue_vowel_sign_oa => 0x19b8,
  :new_tai_lue_vowel_sign_ue => 0x19b9,
  :new_tai_lue_vowel_sign_ay => 0x19ba,
  :new_tai_lue_vowel_sign_aay => 0x19bb,
  :new_tai_lue_vowel_sign_uy => 0x19bc,
  :new_tai_lue_vowel_sign_oy => 0x19bd,
  :new_tai_lue_vowel_sign_oay => 0x19be,
  :new_tai_lue_vowel_sign_uey => 0x19bf,
  :new_tai_lue_vowel_sign_iy => 0x19c0,
  :new_tai_lue_letter_final_v => 0x19c1,
  :new_tai_lue_letter_final_ng => 0x19c2,
  :new_tai_lue_letter_final_n => 0x19c3,
  :new_tai_lue_letter_final_m => 0x19c4,
  :new_tai_lue_letter_final_k => 0x19c5,
  :new_tai_lue_letter_final_d => 0x19c6,
  :new_tai_lue_letter_final_b => 0x19c7,
  :new_tai_lue_tone_mark_1 => 0x19c8,
  :new_tai_lue_tone_mark_2 => 0x19c9,
  :new_tai_lue_digit_zero => 0x19d0,
  :new_tai_lue_digit_one => 0x19d1,
  :new_tai_lue_digit_two => 0x19d2,
  :new_tai_lue_digit_three => 0x19d3,
  :new_tai_lue_digit_four => 0x19d4,
  :new_tai_lue_digit_five => 0x19d5,
  :new_tai_lue_digit_six => 0x19d6,
  :new_tai_lue_digit_seven => 0x19d7,
  :new_tai_lue_digit_eight => 0x19d8,
  :new_tai_lue_digit_nine => 0x19d9,
  :new_tai_lue_sign_lae => 0x19de,
  :new_tai_lue_sign_laev => 0x19df,
  :khmer_symbol_pathamasat => 0x19e0,
  :khmer_symbol_muoy_koet => 0x19e1,
  :khmer_symbol_pii_koet => 0x19e2,
  :khmer_symbol_bei_koet => 0x19e3,
  :khmer_symbol_buon_koet => 0x19e4,
  :khmer_symbol_pram_koet => 0x19e5,
  :khmer_symbol_pram_muoy_koet => 0x19e6,
  :khmer_symbol_pram_pii_koet => 0x19e7,
  :khmer_symbol_pram_bei_koet => 0x19e8,
  :khmer_symbol_pram_buon_koet => 0x19e9,
  :khmer_symbol_dap_koet => 0x19ea,
  :khmer_symbol_dap_muoy_koet => 0x19eb,
  :khmer_symbol_dap_pii_koet => 0x19ec,
  :khmer_symbol_dap_bei_koet => 0x19ed,
  :khmer_symbol_dap_buon_koet => 0x19ee,
  :khmer_symbol_dap_pram_koet => 0x19ef,
  :khmer_symbol_tuteyasat => 0x19f0,
  :khmer_symbol_muoy_roc => 0x19f1,
  :khmer_symbol_pii_roc => 0x19f2,
  :khmer_symbol_bei_roc => 0x19f3,
  :khmer_symbol_buon_roc => 0x19f4,
  :khmer_symbol_pram_roc => 0x19f5,
  :khmer_symbol_pram_muoy_roc => 0x19f6,
  :khmer_symbol_pram_pii_roc => 0x19f7,
  :khmer_symbol_pram_bei_roc => 0x19f8,
  :khmer_symbol_pram_buon_roc => 0x19f9,
  :khmer_symbol_dap_roc => 0x19fa,
  :khmer_symbol_dap_muoy_roc => 0x19fb,
  :khmer_symbol_dap_pii_roc => 0x19fc,
  :khmer_symbol_dap_bei_roc => 0x19fd,
  :khmer_symbol_dap_buon_roc => 0x19fe,
  :khmer_symbol_dap_pram_roc => 0x19ff,
  :buginese_letter_ka => 0x1a00,
  :buginese_letter_ga => 0x1a01,
  :buginese_letter_nga => 0x1a02,
  :buginese_letter_ngka => 0x1a03,
  :buginese_letter_pa => 0x1a04,
  :buginese_letter_ba => 0x1a05,
  :buginese_letter_ma => 0x1a06,
  :buginese_letter_mpa => 0x1a07,
  :buginese_letter_ta => 0x1a08,
  :buginese_letter_da => 0x1a09,
  :buginese_letter_na => 0x1a0a,
  :buginese_letter_nra => 0x1a0b,
  :buginese_letter_ca => 0x1a0c,
  :buginese_letter_ja => 0x1a0d,
  :buginese_letter_nya => 0x1a0e,
  :buginese_letter_nyca => 0x1a0f,
  :buginese_letter_ya => 0x1a10,
  :buginese_letter_ra => 0x1a11,
  :buginese_letter_la => 0x1a12,
  :buginese_letter_va => 0x1a13,
  :buginese_letter_sa => 0x1a14,
  :buginese_letter_a => 0x1a15,
  :buginese_letter_ha => 0x1a16,
  :buginese_vowel_sign_i => 0x1a17,
  :buginese_vowel_sign_u => 0x1a18,
  :buginese_vowel_sign_e => 0x1a19,
  :buginese_vowel_sign_o => 0x1a1a,
  :buginese_vowel_sign_ae => 0x1a1b,
  :buginese_pallawa => 0x1a1e,
  :buginese_end_of_section => 0x1a1f,
  :latin_letter_small_capital_a => 0x1d00,
  :latin_letter_small_capital_ae => 0x1d01,
  :latin_small_letter_turned_ae => 0x1d02,
  :latin_letter_small_capital_barred_b => 0x1d03,
  :latin_letter_small_capital_c => 0x1d04,
  :latin_letter_small_capital_d => 0x1d05,
  :latin_letter_small_capital_eth => 0x1d06,
  :latin_letter_small_capital_e => 0x1d07,
  :latin_small_letter_turned_open_e => 0x1d08,
  :latin_small_letter_turned_i => 0x1d09,
  :latin_letter_small_capital_j => 0x1d0a,
  :latin_letter_small_capital_k => 0x1d0b,
  :latin_letter_small_capital_l_with_stroke => 0x1d0c,
  :latin_letter_small_capital_m => 0x1d0d,
  :latin_letter_small_capital_reversed_n => 0x1d0e,
  :latin_letter_small_capital_o => 0x1d0f,
  :latin_letter_small_capital_open_o => 0x1d10,
  :latin_small_letter_sideways_o => 0x1d11,
  :latin_small_letter_sideways_open_o => 0x1d12,
  :latin_small_letter_sideways_o_with_stroke => 0x1d13,
  :latin_small_letter_turned_oe => 0x1d14,
  :latin_letter_small_capital_ou => 0x1d15,
  :latin_small_letter_top_half_o => 0x1d16,
  :latin_small_letter_bottom_half_o => 0x1d17,
  :latin_letter_small_capital_p => 0x1d18,
  :latin_letter_small_capital_reversed_r => 0x1d19,
  :latin_letter_small_capital_turned_r => 0x1d1a,
  :latin_letter_small_capital_t => 0x1d1b,
  :latin_letter_small_capital_u => 0x1d1c,
  :latin_small_letter_sideways_u => 0x1d1d,
  :latin_small_letter_sideways_diaeresized_u => 0x1d1e,
  :latin_small_letter_sideways_turned_m => 0x1d1f,
  :latin_letter_small_capital_v => 0x1d20,
  :latin_letter_small_capital_w => 0x1d21,
  :latin_letter_small_capital_z => 0x1d22,
  :latin_letter_small_capital_ezh => 0x1d23,
  :latin_letter_voiced_laryngeal_spirant => 0x1d24,
  :latin_letter_ain => 0x1d25,
  :greek_letter_small_capital_gamma => 0x1d26,
  :greek_letter_small_capital_lamda => 0x1d27,
  :greek_letter_small_capital_pi => 0x1d28,
  :greek_letter_small_capital_rho => 0x1d29,
  :greek_letter_small_capital_psi => 0x1d2a,
  :cyrillic_letter_small_capital_el => 0x1d2b,
  :modifier_letter_capital_a => 0x1d2c,
  :modifier_letter_capital_ae => 0x1d2d,
  :modifier_letter_capital_b => 0x1d2e,
  :modifier_letter_capital_barred_b => 0x1d2f,
  :modifier_letter_capital_d => 0x1d30,
  :modifier_letter_capital_e => 0x1d31,
  :modifier_letter_capital_reversed_e => 0x1d32,
  :modifier_letter_capital_g => 0x1d33,
  :modifier_letter_capital_h => 0x1d34,
  :modifier_letter_capital_i => 0x1d35,
  :modifier_letter_capital_j => 0x1d36,
  :modifier_letter_capital_k => 0x1d37,
  :modifier_letter_capital_l => 0x1d38,
  :modifier_letter_capital_m => 0x1d39,
  :modifier_letter_capital_n => 0x1d3a,
  :modifier_letter_capital_reversed_n => 0x1d3b,
  :modifier_letter_capital_o => 0x1d3c,
  :modifier_letter_capital_ou => 0x1d3d,
  :modifier_letter_capital_p => 0x1d3e,
  :modifier_letter_capital_r => 0x1d3f,
  :modifier_letter_capital_t => 0x1d40,
  :modifier_letter_capital_u => 0x1d41,
  :modifier_letter_capital_w => 0x1d42,
  :modifier_letter_small_a => 0x1d43,
  :modifier_letter_small_turned_a => 0x1d44,
  :modifier_letter_small_alpha => 0x1d45,
  :modifier_letter_small_turned_ae => 0x1d46,
  :modifier_letter_small_b => 0x1d47,
  :modifier_letter_small_d => 0x1d48,
  :modifier_letter_small_e => 0x1d49,
  :modifier_letter_small_schwa => 0x1d4a,
  :modifier_letter_small_open_e => 0x1d4b,
  :modifier_letter_small_turned_open_e => 0x1d4c,
  :modifier_letter_small_g => 0x1d4d,
  :modifier_letter_small_turned_i => 0x1d4e,
  :modifier_letter_small_k => 0x1d4f,
  :modifier_letter_small_m => 0x1d50,
  :modifier_letter_small_eng => 0x1d51,
  :modifier_letter_small_o => 0x1d52,
  :modifier_letter_small_open_o => 0x1d53,
  :modifier_letter_small_top_half_o => 0x1d54,
  :modifier_letter_small_bottom_half_o => 0x1d55,
  :modifier_letter_small_p => 0x1d56,
  :modifier_letter_small_t => 0x1d57,
  :modifier_letter_small_u => 0x1d58,
  :modifier_letter_small_sideways_u => 0x1d59,
  :modifier_letter_small_turned_m => 0x1d5a,
  :modifier_letter_small_v => 0x1d5b,
  :modifier_letter_small_ain => 0x1d5c,
  :modifier_letter_small_beta => 0x1d5d,
  :modifier_letter_small_greek_gamma => 0x1d5e,
  :modifier_letter_small_delta => 0x1d5f,
  :modifier_letter_small_greek_phi => 0x1d60,
  :modifier_letter_small_chi => 0x1d61,
  :latin_subscript_small_letter_i => 0x1d62,
  :latin_subscript_small_letter_r => 0x1d63,
  :latin_subscript_small_letter_u => 0x1d64,
  :latin_subscript_small_letter_v => 0x1d65,
  :greek_subscript_small_letter_beta => 0x1d66,
  :greek_subscript_small_letter_gamma => 0x1d67,
  :greek_subscript_small_letter_rho => 0x1d68,
  :greek_subscript_small_letter_phi => 0x1d69,
  :greek_subscript_small_letter_chi => 0x1d6a,
  :latin_small_letter_ue => 0x1d6b,
  :latin_small_letter_b_with_middle_tilde => 0x1d6c,
  :latin_small_letter_d_with_middle_tilde => 0x1d6d,
  :latin_small_letter_f_with_middle_tilde => 0x1d6e,
  :latin_small_letter_m_with_middle_tilde => 0x1d6f,
  :latin_small_letter_n_with_middle_tilde => 0x1d70,
  :latin_small_letter_p_with_middle_tilde => 0x1d71,
  :latin_small_letter_r_with_middle_tilde => 0x1d72,
  :latin_small_letter_r_with_fishhook_and_middle_tilde => 0x1d73,
  :latin_small_letter_s_with_middle_tilde => 0x1d74,
  :latin_small_letter_t_with_middle_tilde => 0x1d75,
  :latin_small_letter_z_with_middle_tilde => 0x1d76,
  :latin_small_letter_turned_g => 0x1d77,
  :modifier_letter_cyrillic_en => 0x1d78,
  :latin_small_letter_insular_g => 0x1d79,
  :latin_small_letter_th_with_strikethrough => 0x1d7a,
  :latin_small_capital_letter_i_with_stroke => 0x1d7b,
  :latin_small_letter_iota_with_stroke => 0x1d7c,
  :latin_small_letter_p_with_stroke => 0x1d7d,
  :latin_small_capital_letter_u_with_stroke => 0x1d7e,
  :latin_small_letter_upsilon_with_stroke => 0x1d7f,
  :latin_small_letter_b_with_palatal_hook => 0x1d80,
  :latin_small_letter_d_with_palatal_hook => 0x1d81,
  :latin_small_letter_f_with_palatal_hook => 0x1d82,
  :latin_small_letter_g_with_palatal_hook => 0x1d83,
  :latin_small_letter_k_with_palatal_hook => 0x1d84,
  :latin_small_letter_l_with_palatal_hook => 0x1d85,
  :latin_small_letter_m_with_palatal_hook => 0x1d86,
  :latin_small_letter_n_with_palatal_hook => 0x1d87,
  :latin_small_letter_p_with_palatal_hook => 0x1d88,
  :latin_small_letter_r_with_palatal_hook => 0x1d89,
  :latin_small_letter_s_with_palatal_hook => 0x1d8a,
  :latin_small_letter_esh_with_palatal_hook => 0x1d8b,
  :latin_small_letter_v_with_palatal_hook => 0x1d8c,
  :latin_small_letter_x_with_palatal_hook => 0x1d8d,
  :latin_small_letter_z_with_palatal_hook => 0x1d8e,
  :latin_small_letter_a_with_retroflex_hook => 0x1d8f,
  :latin_small_letter_alpha_with_retroflex_hook => 0x1d90,
  :latin_small_letter_d_with_hook_and_tail => 0x1d91,
  :latin_small_letter_e_with_retroflex_hook => 0x1d92,
  :latin_small_letter_open_e_with_retroflex_hook => 0x1d93,
  :latin_small_letter_reversed_open_e_with_retroflex_hook => 0x1d94,
  :latin_small_letter_schwa_with_retroflex_hook => 0x1d95,
  :latin_small_letter_i_with_retroflex_hook => 0x1d96,
  :latin_small_letter_open_o_with_retroflex_hook => 0x1d97,
  :latin_small_letter_esh_with_retroflex_hook => 0x1d98,
  :latin_small_letter_u_with_retroflex_hook => 0x1d99,
  :latin_small_letter_ezh_with_retroflex_hook => 0x1d9a,
  :modifier_letter_small_turned_alpha => 0x1d9b,
  :modifier_letter_small_c => 0x1d9c,
  :modifier_letter_small_c_with_curl => 0x1d9d,
  :modifier_letter_small_eth => 0x1d9e,
  :modifier_letter_small_reversed_open_e => 0x1d9f,
  :modifier_letter_small_f => 0x1da0,
  :modifier_letter_small_dotless_j_with_stroke => 0x1da1,
  :modifier_letter_small_script_g => 0x1da2,
  :modifier_letter_small_turned_h => 0x1da3,
  :modifier_letter_small_i_with_stroke => 0x1da4,
  :modifier_letter_small_iota => 0x1da5,
  :modifier_letter_small_capital_i => 0x1da6,
  :modifier_letter_small_capital_i_with_stroke => 0x1da7,
  :modifier_letter_small_j_with_crossed_tail => 0x1da8,
  :modifier_letter_small_l_with_retroflex_hook => 0x1da9,
  :modifier_letter_small_l_with_palatal_hook => 0x1daa,
  :modifier_letter_small_capital_l => 0x1dab,
  :modifier_letter_small_m_with_hook => 0x1dac,
  :modifier_letter_small_turned_m_with_long_leg => 0x1dad,
  :modifier_letter_small_n_with_left_hook => 0x1dae,
  :modifier_letter_small_n_with_retroflex_hook => 0x1daf,
  :modifier_letter_small_capital_n => 0x1db0,
  :modifier_letter_small_barred_o => 0x1db1,
  :modifier_letter_small_phi => 0x1db2,
  :modifier_letter_small_s_with_hook => 0x1db3,
  :modifier_letter_small_esh => 0x1db4,
  :modifier_letter_small_t_with_palatal_hook => 0x1db5,
  :modifier_letter_small_u_bar => 0x1db6,
  :modifier_letter_small_upsilon => 0x1db7,
  :modifier_letter_small_capital_u => 0x1db8,
  :modifier_letter_small_v_with_hook => 0x1db9,
  :modifier_letter_small_turned_v => 0x1dba,
  :modifier_letter_small_z => 0x1dbb,
  :modifier_letter_small_z_with_retroflex_hook => 0x1dbc,
  :modifier_letter_small_z_with_curl => 0x1dbd,
  :modifier_letter_small_ezh => 0x1dbe,
  :modifier_letter_small_theta => 0x1dbf,
  :combining_dotted_grave_accent => 0x1dc0,
  :combining_dotted_acute_accent => 0x1dc1,
  :combining_snake_below => 0x1dc2,
  :combining_suspension_mark => 0x1dc3,
  :latin_capital_letter_a_with_ring_below => 0x1e00,
  :latin_small_letter_a_with_ring_below => 0x1e01,
  :latin_capital_letter_b_with_dot_above => 0x1e02,
  :latin_small_letter_b_with_dot_above => 0x1e03,
  :latin_capital_letter_b_with_dot_below => 0x1e04,
  :latin_small_letter_b_with_dot_below => 0x1e05,
  :latin_capital_letter_b_with_line_below => 0x1e06,
  :latin_small_letter_b_with_line_below => 0x1e07,
  :latin_capital_letter_c_with_cedilla_and_acute => 0x1e08,
  :latin_small_letter_c_with_cedilla_and_acute => 0x1e09,
  :latin_capital_letter_d_with_dot_above => 0x1e0a,
  :latin_small_letter_d_with_dot_above => 0x1e0b,
  :latin_capital_letter_d_with_dot_below => 0x1e0c,
  :latin_small_letter_d_with_dot_below => 0x1e0d,
  :latin_capital_letter_d_with_line_below => 0x1e0e,
  :latin_small_letter_d_with_line_below => 0x1e0f,
  :latin_capital_letter_d_with_cedilla => 0x1e10,
  :latin_small_letter_d_with_cedilla => 0x1e11,
  :latin_capital_letter_d_with_circumflex_below => 0x1e12,
  :latin_small_letter_d_with_circumflex_below => 0x1e13,
  :latin_capital_letter_e_with_macron_and_grave => 0x1e14,
  :latin_small_letter_e_with_macron_and_grave => 0x1e15,
  :latin_capital_letter_e_with_macron_and_acute => 0x1e16,
  :latin_small_letter_e_with_macron_and_acute => 0x1e17,
  :latin_capital_letter_e_with_circumflex_below => 0x1e18,
  :latin_small_letter_e_with_circumflex_below => 0x1e19,
  :latin_capital_letter_e_with_tilde_below => 0x1e1a,
  :latin_small_letter_e_with_tilde_below => 0x1e1b,
  :latin_capital_letter_e_with_cedilla_and_breve => 0x1e1c,
  :latin_small_letter_e_with_cedilla_and_breve => 0x1e1d,
  :latin_capital_letter_f_with_dot_above => 0x1e1e,
  :latin_small_letter_f_with_dot_above => 0x1e1f,
  :latin_capital_letter_g_with_macron => 0x1e20,
  :latin_small_letter_g_with_macron => 0x1e21,
  :latin_capital_letter_h_with_dot_above => 0x1e22,
  :latin_small_letter_h_with_dot_above => 0x1e23,
  :latin_capital_letter_h_with_dot_below => 0x1e24,
  :latin_small_letter_h_with_dot_below => 0x1e25,
  :latin_capital_letter_h_with_diaeresis => 0x1e26,
  :latin_small_letter_h_with_diaeresis => 0x1e27,
  :latin_capital_letter_h_with_cedilla => 0x1e28,
  :latin_small_letter_h_with_cedilla => 0x1e29,
  :latin_capital_letter_h_with_breve_below => 0x1e2a,
  :latin_small_letter_h_with_breve_below => 0x1e2b,
  :latin_capital_letter_i_with_tilde_below => 0x1e2c,
  :latin_small_letter_i_with_tilde_below => 0x1e2d,
  :latin_capital_letter_i_with_diaeresis_and_acute => 0x1e2e,
  :latin_small_letter_i_with_diaeresis_and_acute => 0x1e2f,
  :latin_capital_letter_k_with_acute => 0x1e30,
  :latin_small_letter_k_with_acute => 0x1e31,
  :latin_capital_letter_k_with_dot_below => 0x1e32,
  :latin_small_letter_k_with_dot_below => 0x1e33,
  :latin_capital_letter_k_with_line_below => 0x1e34,
  :latin_small_letter_k_with_line_below => 0x1e35,
  :latin_capital_letter_l_with_dot_below => 0x1e36,
  :latin_small_letter_l_with_dot_below => 0x1e37,
  :latin_capital_letter_l_with_dot_below_and_macron => 0x1e38,
  :latin_small_letter_l_with_dot_below_and_macron => 0x1e39,
  :latin_capital_letter_l_with_line_below => 0x1e3a,
  :latin_small_letter_l_with_line_below => 0x1e3b,
  :latin_capital_letter_l_with_circumflex_below => 0x1e3c,
  :latin_small_letter_l_with_circumflex_below => 0x1e3d,
  :latin_capital_letter_m_with_acute => 0x1e3e,
  :latin_small_letter_m_with_acute => 0x1e3f,
  :latin_capital_letter_m_with_dot_above => 0x1e40,
  :latin_small_letter_m_with_dot_above => 0x1e41,
  :latin_capital_letter_m_with_dot_below => 0x1e42,
  :latin_small_letter_m_with_dot_below => 0x1e43,
  :latin_capital_letter_n_with_dot_above => 0x1e44,
  :latin_small_letter_n_with_dot_above => 0x1e45,
  :latin_capital_letter_n_with_dot_below => 0x1e46,
  :latin_small_letter_n_with_dot_below => 0x1e47,
  :latin_capital_letter_n_with_line_below => 0x1e48,
  :latin_small_letter_n_with_line_below => 0x1e49,
  :latin_capital_letter_n_with_circumflex_below => 0x1e4a,
  :latin_small_letter_n_with_circumflex_below => 0x1e4b,
  :latin_capital_letter_o_with_tilde_and_acute => 0x1e4c,
  :latin_small_letter_o_with_tilde_and_acute => 0x1e4d,
  :latin_capital_letter_o_with_tilde_and_diaeresis => 0x1e4e,
  :latin_small_letter_o_with_tilde_and_diaeresis => 0x1e4f,
  :latin_capital_letter_o_with_macron_and_grave => 0x1e50,
  :latin_small_letter_o_with_macron_and_grave => 0x1e51,
  :latin_capital_letter_o_with_macron_and_acute => 0x1e52,
  :latin_small_letter_o_with_macron_and_acute => 0x1e53,
  :latin_capital_letter_p_with_acute => 0x1e54,
  :latin_small_letter_p_with_acute => 0x1e55,
  :latin_capital_letter_p_with_dot_above => 0x1e56,
  :latin_small_letter_p_with_dot_above => 0x1e57,
  :latin_capital_letter_r_with_dot_above => 0x1e58,
  :latin_small_letter_r_with_dot_above => 0x1e59,
  :latin_capital_letter_r_with_dot_below => 0x1e5a,
  :latin_small_letter_r_with_dot_below => 0x1e5b,
  :latin_capital_letter_r_with_dot_below_and_macron => 0x1e5c,
  :latin_small_letter_r_with_dot_below_and_macron => 0x1e5d,
  :latin_capital_letter_r_with_line_below => 0x1e5e,
  :latin_small_letter_r_with_line_below => 0x1e5f,
  :latin_capital_letter_s_with_dot_above => 0x1e60,
  :latin_small_letter_s_with_dot_above => 0x1e61,
  :latin_capital_letter_s_with_dot_below => 0x1e62,
  :latin_small_letter_s_with_dot_below => 0x1e63,
  :latin_capital_letter_s_with_acute_and_dot_above => 0x1e64,
  :latin_small_letter_s_with_acute_and_dot_above => 0x1e65,
  :latin_capital_letter_s_with_caron_and_dot_above => 0x1e66,
  :latin_small_letter_s_with_caron_and_dot_above => 0x1e67,
  :latin_capital_letter_s_with_dot_below_and_dot_above => 0x1e68,
  :latin_small_letter_s_with_dot_below_and_dot_above => 0x1e69,
  :latin_capital_letter_t_with_dot_above => 0x1e6a,
  :latin_small_letter_t_with_dot_above => 0x1e6b,
  :latin_capital_letter_t_with_dot_below => 0x1e6c,
  :latin_small_letter_t_with_dot_below => 0x1e6d,
  :latin_capital_letter_t_with_line_below => 0x1e6e,
  :latin_small_letter_t_with_line_below => 0x1e6f,
  :latin_capital_letter_t_with_circumflex_below => 0x1e70,
  :latin_small_letter_t_with_circumflex_below => 0x1e71,
  :latin_capital_letter_u_with_diaeresis_below => 0x1e72,
  :latin_small_letter_u_with_diaeresis_below => 0x1e73,
  :latin_capital_letter_u_with_tilde_below => 0x1e74,
  :latin_small_letter_u_with_tilde_below => 0x1e75,
  :latin_capital_letter_u_with_circumflex_below => 0x1e76,
  :latin_small_letter_u_with_circumflex_below => 0x1e77,
  :latin_capital_letter_u_with_tilde_and_acute => 0x1e78,
  :latin_small_letter_u_with_tilde_and_acute => 0x1e79,
  :latin_capital_letter_u_with_macron_and_diaeresis => 0x1e7a,
  :latin_small_letter_u_with_macron_and_diaeresis => 0x1e7b,
  :latin_capital_letter_v_with_tilde => 0x1e7c,
  :latin_small_letter_v_with_tilde => 0x1e7d,
  :latin_capital_letter_v_with_dot_below => 0x1e7e,
  :latin_small_letter_v_with_dot_below => 0x1e7f,
  :latin_capital_letter_w_with_grave => 0x1e80,
  :latin_small_letter_w_with_grave => 0x1e81,
  :latin_capital_letter_w_with_acute => 0x1e82,
  :latin_small_letter_w_with_acute => 0x1e83,
  :latin_capital_letter_w_with_diaeresis => 0x1e84,
  :latin_small_letter_w_with_diaeresis => 0x1e85,
  :latin_capital_letter_w_with_dot_above => 0x1e86,
  :latin_small_letter_w_with_dot_above => 0x1e87,
  :latin_capital_letter_w_with_dot_below => 0x1e88,
  :latin_small_letter_w_with_dot_below => 0x1e89,
  :latin_capital_letter_x_with_dot_above => 0x1e8a,
  :latin_small_letter_x_with_dot_above => 0x1e8b,
  :latin_capital_letter_x_with_diaeresis => 0x1e8c,
  :latin_small_letter_x_with_diaeresis => 0x1e8d,
  :latin_capital_letter_y_with_dot_above => 0x1e8e,
  :latin_small_letter_y_with_dot_above => 0x1e8f,
  :latin_capital_letter_z_with_circumflex => 0x1e90,
  :latin_small_letter_z_with_circumflex => 0x1e91,
  :latin_capital_letter_z_with_dot_below => 0x1e92,
  :latin_small_letter_z_with_dot_below => 0x1e93,
  :latin_capital_letter_z_with_line_below => 0x1e94,
  :latin_small_letter_z_with_line_below => 0x1e95,
  :latin_small_letter_h_with_line_below => 0x1e96,
  :latin_small_letter_t_with_diaeresis => 0x1e97,
  :latin_small_letter_w_with_ring_above => 0x1e98,
  :latin_small_letter_y_with_ring_above => 0x1e99,
  :latin_small_letter_a_with_right_half_ring => 0x1e9a,
  :latin_small_letter_long_s_with_dot_above => 0x1e9b,
  :latin_capital_letter_a_with_dot_below => 0x1ea0,
  :latin_small_letter_a_with_dot_below => 0x1ea1,
  :latin_capital_letter_a_with_hook_above => 0x1ea2,
  :latin_small_letter_a_with_hook_above => 0x1ea3,
  :latin_capital_letter_a_with_circumflex_and_acute => 0x1ea4,
  :latin_small_letter_a_with_circumflex_and_acute => 0x1ea5,
  :latin_capital_letter_a_with_circumflex_and_grave => 0x1ea6,
  :latin_small_letter_a_with_circumflex_and_grave => 0x1ea7,
  :latin_capital_letter_a_with_circumflex_and_hook_above => 0x1ea8,
  :latin_small_letter_a_with_circumflex_and_hook_above => 0x1ea9,
  :latin_capital_letter_a_with_circumflex_and_tilde => 0x1eaa,
  :latin_small_letter_a_with_circumflex_and_tilde => 0x1eab,
  :latin_capital_letter_a_with_circumflex_and_dot_below => 0x1eac,
  :latin_small_letter_a_with_circumflex_and_dot_below => 0x1ead,
  :latin_capital_letter_a_with_breve_and_acute => 0x1eae,
  :latin_small_letter_a_with_breve_and_acute => 0x1eaf,
  :latin_capital_letter_a_with_breve_and_grave => 0x1eb0,
  :latin_small_letter_a_with_breve_and_grave => 0x1eb1,
  :latin_capital_letter_a_with_breve_and_hook_above => 0x1eb2,
  :latin_small_letter_a_with_breve_and_hook_above => 0x1eb3,
  :latin_capital_letter_a_with_breve_and_tilde => 0x1eb4,
  :latin_small_letter_a_with_breve_and_tilde => 0x1eb5,
  :latin_capital_letter_a_with_breve_and_dot_below => 0x1eb6,
  :latin_small_letter_a_with_breve_and_dot_below => 0x1eb7,
  :latin_capital_letter_e_with_dot_below => 0x1eb8,
  :latin_small_letter_e_with_dot_below => 0x1eb9,
  :latin_capital_letter_e_with_hook_above => 0x1eba,
  :latin_small_letter_e_with_hook_above => 0x1ebb,
  :latin_capital_letter_e_with_tilde => 0x1ebc,
  :latin_small_letter_e_with_tilde => 0x1ebd,
  :latin_capital_letter_e_with_circumflex_and_acute => 0x1ebe,
  :latin_small_letter_e_with_circumflex_and_acute => 0x1ebf,
  :latin_capital_letter_e_with_circumflex_and_grave => 0x1ec0,
  :latin_small_letter_e_with_circumflex_and_grave => 0x1ec1,
  :latin_capital_letter_e_with_circumflex_and_hook_above => 0x1ec2,
  :latin_small_letter_e_with_circumflex_and_hook_above => 0x1ec3,
  :latin_capital_letter_e_with_circumflex_and_tilde => 0x1ec4,
  :latin_small_letter_e_with_circumflex_and_tilde => 0x1ec5,
  :latin_capital_letter_e_with_circumflex_and_dot_below => 0x1ec6,
  :latin_small_letter_e_with_circumflex_and_dot_below => 0x1ec7,
  :latin_capital_letter_i_with_hook_above => 0x1ec8,
  :latin_small_letter_i_with_hook_above => 0x1ec9,
  :latin_capital_letter_i_with_dot_below => 0x1eca,
  :latin_small_letter_i_with_dot_below => 0x1ecb,
  :latin_capital_letter_o_with_dot_below => 0x1ecc,
  :latin_small_letter_o_with_dot_below => 0x1ecd,
  :latin_capital_letter_o_with_hook_above => 0x1ece,
  :latin_small_letter_o_with_hook_above => 0x1ecf,
  :latin_capital_letter_o_with_circumflex_and_acute => 0x1ed0,
  :latin_small_letter_o_with_circumflex_and_acute => 0x1ed1,
  :latin_capital_letter_o_with_circumflex_and_grave => 0x1ed2,
  :latin_small_letter_o_with_circumflex_and_grave => 0x1ed3,
  :latin_capital_letter_o_with_circumflex_and_hook_above => 0x1ed4,
  :latin_small_letter_o_with_circumflex_and_hook_above => 0x1ed5,
  :latin_capital_letter_o_with_circumflex_and_tilde => 0x1ed6,
  :latin_small_letter_o_with_circumflex_and_tilde => 0x1ed7,
  :latin_capital_letter_o_with_circumflex_and_dot_below => 0x1ed8,
  :latin_small_letter_o_with_circumflex_and_dot_below => 0x1ed9,
  :latin_capital_letter_o_with_horn_and_acute => 0x1eda,
  :latin_small_letter_o_with_horn_and_acute => 0x1edb,
  :latin_capital_letter_o_with_horn_and_grave => 0x1edc,
  :latin_small_letter_o_with_horn_and_grave => 0x1edd,
  :latin_capital_letter_o_with_horn_and_hook_above => 0x1ede,
  :latin_small_letter_o_with_horn_and_hook_above => 0x1edf,
  :latin_capital_letter_o_with_horn_and_tilde => 0x1ee0,
  :latin_small_letter_o_with_horn_and_tilde => 0x1ee1,
  :latin_capital_letter_o_with_horn_and_dot_below => 0x1ee2,
  :latin_small_letter_o_with_horn_and_dot_below => 0x1ee3,
  :latin_capital_letter_u_with_dot_below => 0x1ee4,
  :latin_small_letter_u_with_dot_below => 0x1ee5,
  :latin_capital_letter_u_with_hook_above => 0x1ee6,
  :latin_small_letter_u_with_hook_above => 0x1ee7,
  :latin_capital_letter_u_with_horn_and_acute => 0x1ee8,
  :latin_small_letter_u_with_horn_and_acute => 0x1ee9,
  :latin_capital_letter_u_with_horn_and_grave => 0x1eea,
  :latin_small_letter_u_with_horn_and_grave => 0x1eeb,
  :latin_capital_letter_u_with_horn_and_hook_above => 0x1eec,
  :latin_small_letter_u_with_horn_and_hook_above => 0x1eed,
  :latin_capital_letter_u_with_horn_and_tilde => 0x1eee,
  :latin_small_letter_u_with_horn_and_tilde => 0x1eef,
  :latin_capital_letter_u_with_horn_and_dot_below => 0x1ef0,
  :latin_small_letter_u_with_horn_and_dot_below => 0x1ef1,
  :latin_capital_letter_y_with_grave => 0x1ef2,
  :latin_small_letter_y_with_grave => 0x1ef3,
  :latin_capital_letter_y_with_dot_below => 0x1ef4,
  :latin_small_letter_y_with_dot_below => 0x1ef5,
  :latin_capital_letter_y_with_hook_above => 0x1ef6,
  :latin_small_letter_y_with_hook_above => 0x1ef7,
  :latin_capital_letter_y_with_tilde => 0x1ef8,
  :latin_small_letter_y_with_tilde => 0x1ef9,
  :greek_small_letter_alpha_with_psili => 0x1f00,
  :greek_small_letter_alpha_with_dasia => 0x1f01,
  :greek_small_letter_alpha_with_psili_and_varia => 0x1f02,
  :greek_small_letter_alpha_with_dasia_and_varia => 0x1f03,
  :greek_small_letter_alpha_with_psili_and_oxia => 0x1f04,
  :greek_small_letter_alpha_with_dasia_and_oxia => 0x1f05,
  :greek_small_letter_alpha_with_psili_and_perispomeni => 0x1f06,
  :greek_small_letter_alpha_with_dasia_and_perispomeni => 0x1f07,
  :greek_capital_letter_alpha_with_psili => 0x1f08,
  :greek_capital_letter_alpha_with_dasia => 0x1f09,
  :greek_capital_letter_alpha_with_psili_and_varia => 0x1f0a,
  :greek_capital_letter_alpha_with_dasia_and_varia => 0x1f0b,
  :greek_capital_letter_alpha_with_psili_and_oxia => 0x1f0c,
  :greek_capital_letter_alpha_with_dasia_and_oxia => 0x1f0d,
  :greek_capital_letter_alpha_with_psili_and_perispomeni => 0x1f0e,
  :greek_capital_letter_alpha_with_dasia_and_perispomeni => 0x1f0f,
  :greek_small_letter_epsilon_with_psili => 0x1f10,
  :greek_small_letter_epsilon_with_dasia => 0x1f11,
  :greek_small_letter_epsilon_with_psili_and_varia => 0x1f12,
  :greek_small_letter_epsilon_with_dasia_and_varia => 0x1f13,
  :greek_small_letter_epsilon_with_psili_and_oxia => 0x1f14,
  :greek_small_letter_epsilon_with_dasia_and_oxia => 0x1f15,
  :greek_capital_letter_epsilon_with_psili => 0x1f18,
  :greek_capital_letter_epsilon_with_dasia => 0x1f19,
  :greek_capital_letter_epsilon_with_psili_and_varia => 0x1f1a,
  :greek_capital_letter_epsilon_with_dasia_and_varia => 0x1f1b,
  :greek_capital_letter_epsilon_with_psili_and_oxia => 0x1f1c,
  :greek_capital_letter_epsilon_with_dasia_and_oxia => 0x1f1d,
  :greek_small_letter_eta_with_psili => 0x1f20,
  :greek_small_letter_eta_with_dasia => 0x1f21,
  :greek_small_letter_eta_with_psili_and_varia => 0x1f22,
  :greek_small_letter_eta_with_dasia_and_varia => 0x1f23,
  :greek_small_letter_eta_with_psili_and_oxia => 0x1f24,
  :greek_small_letter_eta_with_dasia_and_oxia => 0x1f25,
  :greek_small_letter_eta_with_psili_and_perispomeni => 0x1f26,
  :greek_small_letter_eta_with_dasia_and_perispomeni => 0x1f27,
  :greek_capital_letter_eta_with_psili => 0x1f28,
  :greek_capital_letter_eta_with_dasia => 0x1f29,
  :greek_capital_letter_eta_with_psili_and_varia => 0x1f2a,
  :greek_capital_letter_eta_with_dasia_and_varia => 0x1f2b,
  :greek_capital_letter_eta_with_psili_and_oxia => 0x1f2c,
  :greek_capital_letter_eta_with_dasia_and_oxia => 0x1f2d,
  :greek_capital_letter_eta_with_psili_and_perispomeni => 0x1f2e,
  :greek_capital_letter_eta_with_dasia_and_perispomeni => 0x1f2f,
  :greek_small_letter_iota_with_psili => 0x1f30,
  :greek_small_letter_iota_with_dasia => 0x1f31,
  :greek_small_letter_iota_with_psili_and_varia => 0x1f32,
  :greek_small_letter_iota_with_dasia_and_varia => 0x1f33,
  :greek_small_letter_iota_with_psili_and_oxia => 0x1f34,
  :greek_small_letter_iota_with_dasia_and_oxia => 0x1f35,
  :greek_small_letter_iota_with_psili_and_perispomeni => 0x1f36,
  :greek_small_letter_iota_with_dasia_and_perispomeni => 0x1f37,
  :greek_capital_letter_iota_with_psili => 0x1f38,
  :greek_capital_letter_iota_with_dasia => 0x1f39,
  :greek_capital_letter_iota_with_psili_and_varia => 0x1f3a,
  :greek_capital_letter_iota_with_dasia_and_varia => 0x1f3b,
  :greek_capital_letter_iota_with_psili_and_oxia => 0x1f3c,
  :greek_capital_letter_iota_with_dasia_and_oxia => 0x1f3d,
  :greek_capital_letter_iota_with_psili_and_perispomeni => 0x1f3e,
  :greek_capital_letter_iota_with_dasia_and_perispomeni => 0x1f3f,
  :greek_small_letter_omicron_with_psili => 0x1f40,
  :greek_small_letter_omicron_with_dasia => 0x1f41,
  :greek_small_letter_omicron_with_psili_and_varia => 0x1f42,
  :greek_small_letter_omicron_with_dasia_and_varia => 0x1f43,
  :greek_small_letter_omicron_with_psili_and_oxia => 0x1f44,
  :greek_small_letter_omicron_with_dasia_and_oxia => 0x1f45,
  :greek_capital_letter_omicron_with_psili => 0x1f48,
  :greek_capital_letter_omicron_with_dasia => 0x1f49,
  :greek_capital_letter_omicron_with_psili_and_varia => 0x1f4a,
  :greek_capital_letter_omicron_with_dasia_and_varia => 0x1f4b,
  :greek_capital_letter_omicron_with_psili_and_oxia => 0x1f4c,
  :greek_capital_letter_omicron_with_dasia_and_oxia => 0x1f4d,
  :greek_small_letter_upsilon_with_psili => 0x1f50,
  :greek_small_letter_upsilon_with_dasia => 0x1f51,
  :greek_small_letter_upsilon_with_psili_and_varia => 0x1f52,
  :greek_small_letter_upsilon_with_dasia_and_varia => 0x1f53,
  :greek_small_letter_upsilon_with_psili_and_oxia => 0x1f54,
  :greek_small_letter_upsilon_with_dasia_and_oxia => 0x1f55,
  :greek_small_letter_upsilon_with_psili_and_perispomeni => 0x1f56,
  :greek_small_letter_upsilon_with_dasia_and_perispomeni => 0x1f57,
  :greek_capital_letter_upsilon_with_dasia => 0x1f59,
  :greek_capital_letter_upsilon_with_dasia_and_varia => 0x1f5b,
  :greek_capital_letter_upsilon_with_dasia_and_oxia => 0x1f5d,
  :greek_capital_letter_upsilon_with_dasia_and_perispomeni => 0x1f5f,
  :greek_small_letter_omega_with_psili => 0x1f60,
  :greek_small_letter_omega_with_dasia => 0x1f61,
  :greek_small_letter_omega_with_psili_and_varia => 0x1f62,
  :greek_small_letter_omega_with_dasia_and_varia => 0x1f63,
  :greek_small_letter_omega_with_psili_and_oxia => 0x1f64,
  :greek_small_letter_omega_with_dasia_and_oxia => 0x1f65,
  :greek_small_letter_omega_with_psili_and_perispomeni => 0x1f66,
  :greek_small_letter_omega_with_dasia_and_perispomeni => 0x1f67,
  :greek_capital_letter_omega_with_psili => 0x1f68,
  :greek_capital_letter_omega_with_dasia => 0x1f69,
  :greek_capital_letter_omega_with_psili_and_varia => 0x1f6a,
  :greek_capital_letter_omega_with_dasia_and_varia => 0x1f6b,
  :greek_capital_letter_omega_with_psili_and_oxia => 0x1f6c,
  :greek_capital_letter_omega_with_dasia_and_oxia => 0x1f6d,
  :greek_capital_letter_omega_with_psili_and_perispomeni => 0x1f6e,
  :greek_capital_letter_omega_with_dasia_and_perispomeni => 0x1f6f,
  :greek_small_letter_alpha_with_varia => 0x1f70,
  :greek_small_letter_alpha_with_oxia => 0x1f71,
  :greek_small_letter_epsilon_with_varia => 0x1f72,
  :greek_small_letter_epsilon_with_oxia => 0x1f73,
  :greek_small_letter_eta_with_varia => 0x1f74,
  :greek_small_letter_eta_with_oxia => 0x1f75,
  :greek_small_letter_iota_with_varia => 0x1f76,
  :greek_small_letter_iota_with_oxia => 0x1f77,
  :greek_small_letter_omicron_with_varia => 0x1f78,
  :greek_small_letter_omicron_with_oxia => 0x1f79,
  :greek_small_letter_upsilon_with_varia => 0x1f7a,
  :greek_small_letter_upsilon_with_oxia => 0x1f7b,
  :greek_small_letter_omega_with_varia => 0x1f7c,
  :greek_small_letter_omega_with_oxia => 0x1f7d,
  :greek_small_letter_alpha_with_psili_and_ypogegrammeni => 0x1f80,
  :greek_small_letter_alpha_with_dasia_and_ypogegrammeni => 0x1f81,
  :greek_small_letter_alpha_with_psili_and_varia_and_ypogegrammeni => 0x1f82,
  :greek_small_letter_alpha_with_dasia_and_varia_and_ypogegrammeni => 0x1f83,
  :greek_small_letter_alpha_with_psili_and_oxia_and_ypogegrammeni => 0x1f84,
  :greek_small_letter_alpha_with_dasia_and_oxia_and_ypogegrammeni => 0x1f85,
  :greek_small_letter_alpha_with_psili_and_perispomeni_and_ypogegrammeni => 0x1f86,
  :greek_small_letter_alpha_with_dasia_and_perispomeni_and_ypogegrammeni => 0x1f87,
  :greek_capital_letter_alpha_with_psili_and_prosgegrammeni => 0x1f88,
  :greek_capital_letter_alpha_with_dasia_and_prosgegrammeni => 0x1f89,
  :greek_capital_letter_alpha_with_psili_and_varia_and_prosgegrammeni => 0x1f8a,
  :greek_capital_letter_alpha_with_dasia_and_varia_and_prosgegrammeni => 0x1f8b,
  :greek_capital_letter_alpha_with_psili_and_oxia_and_prosgegrammeni => 0x1f8c,
  :greek_capital_letter_alpha_with_dasia_and_oxia_and_prosgegrammeni => 0x1f8d,
  :greek_capital_letter_alpha_with_psili_and_perispomeni_and_prosgegrammeni => 0x1f8e,
  :greek_capital_letter_alpha_with_dasia_and_perispomeni_and_prosgegrammeni => 0x1f8f,
  :greek_small_letter_eta_with_psili_and_ypogegrammeni => 0x1f90,
  :greek_small_letter_eta_with_dasia_and_ypogegrammeni => 0x1f91,
  :greek_small_letter_eta_with_psili_and_varia_and_ypogegrammeni => 0x1f92,
  :greek_small_letter_eta_with_dasia_and_varia_and_ypogegrammeni => 0x1f93,
  :greek_small_letter_eta_with_psili_and_oxia_and_ypogegrammeni => 0x1f94,
  :greek_small_letter_eta_with_dasia_and_oxia_and_ypogegrammeni => 0x1f95,
  :greek_small_letter_eta_with_psili_and_perispomeni_and_ypogegrammeni => 0x1f96,
  :greek_small_letter_eta_with_dasia_and_perispomeni_and_ypogegrammeni => 0x1f97,
  :greek_capital_letter_eta_with_psili_and_prosgegrammeni => 0x1f98,
  :greek_capital_letter_eta_with_dasia_and_prosgegrammeni => 0x1f99,
  :greek_capital_letter_eta_with_psili_and_varia_and_prosgegrammeni => 0x1f9a,
  :greek_capital_letter_eta_with_dasia_and_varia_and_prosgegrammeni => 0x1f9b,
  :greek_capital_letter_eta_with_psili_and_oxia_and_prosgegrammeni => 0x1f9c,
  :greek_capital_letter_eta_with_dasia_and_oxia_and_prosgegrammeni => 0x1f9d,
  :greek_capital_letter_eta_with_psili_and_perispomeni_and_prosgegrammeni => 0x1f9e,
  :greek_capital_letter_eta_with_dasia_and_perispomeni_and_prosgegrammeni => 0x1f9f,
  :greek_small_letter_omega_with_psili_and_ypogegrammeni => 0x1fa0,
  :greek_small_letter_omega_with_dasia_and_ypogegrammeni => 0x1fa1,
  :greek_small_letter_omega_with_psili_and_varia_and_ypogegrammeni => 0x1fa2,
  :greek_small_letter_omega_with_dasia_and_varia_and_ypogegrammeni => 0x1fa3,
  :greek_small_letter_omega_with_psili_and_oxia_and_ypogegrammeni => 0x1fa4,
  :greek_small_letter_omega_with_dasia_and_oxia_and_ypogegrammeni => 0x1fa5,
  :greek_small_letter_omega_with_psili_and_perispomeni_and_ypogegrammeni => 0x1fa6,
  :greek_small_letter_omega_with_dasia_and_perispomeni_and_ypogegrammeni => 0x1fa7,
  :greek_capital_letter_omega_with_psili_and_prosgegrammeni => 0x1fa8,
  :greek_capital_letter_omega_with_dasia_and_prosgegrammeni => 0x1fa9,
  :greek_capital_letter_omega_with_psili_and_varia_and_prosgegrammeni => 0x1faa,
  :greek_capital_letter_omega_with_dasia_and_varia_and_prosgegrammeni => 0x1fab,
  :greek_capital_letter_omega_with_psili_and_oxia_and_prosgegrammeni => 0x1fac,
  :greek_capital_letter_omega_with_dasia_and_oxia_and_prosgegrammeni => 0x1fad,
  :greek_capital_letter_omega_with_psili_and_perispomeni_and_prosgegrammeni => 0x1fae,
  :greek_capital_letter_omega_with_dasia_and_perispomeni_and_prosgegrammeni => 0x1faf,
  :greek_small_letter_alpha_with_vrachy => 0x1fb0,
  :greek_small_letter_alpha_with_macron => 0x1fb1,
  :greek_small_letter_alpha_with_varia_and_ypogegrammeni => 0x1fb2,
  :greek_small_letter_alpha_with_ypogegrammeni => 0x1fb3,
  :greek_small_letter_alpha_with_oxia_and_ypogegrammeni => 0x1fb4,
  :greek_small_letter_alpha_with_perispomeni => 0x1fb6,
  :greek_small_letter_alpha_with_perispomeni_and_ypogegrammeni => 0x1fb7,
  :greek_capital_letter_alpha_with_vrachy => 0x1fb8,
  :greek_capital_letter_alpha_with_macron => 0x1fb9,
  :greek_capital_letter_alpha_with_varia => 0x1fba,
  :greek_capital_letter_alpha_with_oxia => 0x1fbb,
  :greek_capital_letter_alpha_with_prosgegrammeni => 0x1fbc,
  :greek_koronis => 0x1fbd,
  :greek_prosgegrammeni => 0x1fbe,
  :greek_psili => 0x1fbf,
  :greek_perispomeni => 0x1fc0,
  :greek_dialytika_and_perispomeni => 0x1fc1,
  :greek_small_letter_eta_with_varia_and_ypogegrammeni => 0x1fc2,
  :greek_small_letter_eta_with_ypogegrammeni => 0x1fc3,
  :greek_small_letter_eta_with_oxia_and_ypogegrammeni => 0x1fc4,
  :greek_small_letter_eta_with_perispomeni => 0x1fc6,
  :greek_small_letter_eta_with_perispomeni_and_ypogegrammeni => 0x1fc7,
  :greek_capital_letter_epsilon_with_varia => 0x1fc8,
  :greek_capital_letter_epsilon_with_oxia => 0x1fc9,
  :greek_capital_letter_eta_with_varia => 0x1fca,
  :greek_capital_letter_eta_with_oxia => 0x1fcb,
  :greek_capital_letter_eta_with_prosgegrammeni => 0x1fcc,
  :greek_psili_and_varia => 0x1fcd,
  :greek_psili_and_oxia => 0x1fce,
  :greek_psili_and_perispomeni => 0x1fcf,
  :greek_small_letter_iota_with_vrachy => 0x1fd0,
  :greek_small_letter_iota_with_macron => 0x1fd1,
  :greek_small_letter_iota_with_dialytika_and_varia => 0x1fd2,
  :greek_small_letter_iota_with_dialytika_and_oxia => 0x1fd3,
  :greek_small_letter_iota_with_perispomeni => 0x1fd6,
  :greek_small_letter_iota_with_dialytika_and_perispomeni => 0x1fd7,
  :greek_capital_letter_iota_with_vrachy => 0x1fd8,
  :greek_capital_letter_iota_with_macron => 0x1fd9,
  :greek_capital_letter_iota_with_varia => 0x1fda,
  :greek_capital_letter_iota_with_oxia => 0x1fdb,
  :greek_dasia_and_varia => 0x1fdd,
  :greek_dasia_and_oxia => 0x1fde,
  :greek_dasia_and_perispomeni => 0x1fdf,
  :greek_small_letter_upsilon_with_vrachy => 0x1fe0,
  :greek_small_letter_upsilon_with_macron => 0x1fe1,
  :greek_small_letter_upsilon_with_dialytika_and_varia => 0x1fe2,
  :greek_small_letter_upsilon_with_dialytika_and_oxia => 0x1fe3,
  :greek_small_letter_rho_with_psili => 0x1fe4,
  :greek_small_letter_rho_with_dasia => 0x1fe5,
  :greek_small_letter_upsilon_with_perispomeni => 0x1fe6,
  :greek_small_letter_upsilon_with_dialytika_and_perispomeni => 0x1fe7,
  :greek_capital_letter_upsilon_with_vrachy => 0x1fe8,
  :greek_capital_letter_upsilon_with_macron => 0x1fe9,
  :greek_capital_letter_upsilon_with_varia => 0x1fea,
  :greek_capital_letter_upsilon_with_oxia => 0x1feb,
  :greek_capital_letter_rho_with_dasia => 0x1fec,
  :greek_dialytika_and_varia => 0x1fed,
  :greek_dialytika_and_oxia => 0x1fee,
  :greek_varia => 0x1fef,
  :greek_small_letter_omega_with_varia_and_ypogegrammeni => 0x1ff2,
  :greek_small_letter_omega_with_ypogegrammeni => 0x1ff3,
  :greek_small_letter_omega_with_oxia_and_ypogegrammeni => 0x1ff4,
  :greek_small_letter_omega_with_perispomeni => 0x1ff6,
  :greek_small_letter_omega_with_perispomeni_and_ypogegrammeni => 0x1ff7,
  :greek_capital_letter_omicron_with_varia => 0x1ff8,
  :greek_capital_letter_omicron_with_oxia => 0x1ff9,
  :greek_capital_letter_omega_with_varia => 0x1ffa,
  :greek_capital_letter_omega_with_oxia => 0x1ffb,
  :greek_capital_letter_omega_with_prosgegrammeni => 0x1ffc,
  :greek_oxia => 0x1ffd,
  :greek_dasia => 0x1ffe,
  :en_quad => 0x2000,
  :em_quad => 0x2001,
  :en_space => 0x2002,
  :em_space => 0x2003,
  :three_per_em_space => 0x2004,
  :four_per_em_space => 0x2005,
  :six_per_em_space => 0x2006,
  :figure_space => 0x2007,
  :punctuation_space => 0x2008,
  :thin_space => 0x2009,
  :hair_space => 0x200a,
  :zero_width_space => 0x200b,
  :zero_width_non_joiner => 0x200c,
  :zero_width_joiner => 0x200d,
  :left_to_right_mark => 0x200e,
  :right_to_left_mark => 0x200f,
  :hyphen => 0x2010,
  :non_breaking_hyphen => 0x2011,
  :figure_dash => 0x2012,
  :en_dash => 0x2013,
  :em_dash => 0x2014,
  :horizontal_bar => 0x2015,
  :quotation_dash => 0x2015,
  :double_vertical_line => 0x2016,
  :double_vertical_bar => 0x2016,
  :double_low_line => 0x2017,
  :spacing_double_underscore => 0x2017,
  :left_single_quotation_mark => 0x2018,
  :single_turned_comma_quotation_mark => 0x2018,
  :right_single_quotation_mark => 0x2019,
  :single_comma_quotation_mark => 0x2019,
  :single_low_9_quotation_mark => 0x201a,
  :low_single_comma_quotation_mark => 0x201a,
  :single_high_reversed_9_quotation_mark => 0x201b,
  :single_reversed_comma_quotation_mark => 0x201b,
  :left_double_quotation_mark => 0x201c,
  :double_turned_comma_quotation_mark => 0x201c,
  :right_double_quotation_mark => 0x201d,
  :double_comma_quotation_mark => 0x201d,
  :double_low_9_quotation_mark => 0x201e,
  :low_double_comma_quotation_mark => 0x201e,
  :double_high_reversed_9_quotation_mark => 0x201f,
  :double_reversed_comma_quotation_mark => 0x201f,
  :dagger => 0x2020,
  :double_dagger => 0x2021,
  :bullet => 0x2022,
  :triangular_bullet => 0x2023,
  :one_dot_leader => 0x2024,
  :two_dot_leader => 0x2025,
  :horizontal_ellipsis => 0x2026,
  :hyphenation_point => 0x2027,
  :line_separator => 0x2028,
  :paragraph_separator => 0x2029,
  :left_to_right_embedding => 0x202a,
  :right_to_left_embedding => 0x202b,
  :pop_directional_formatting => 0x202c,
  :left_to_right_override => 0x202d,
  :right_to_left_override => 0x202e,
  :narrow_no_break_space => 0x202f,
  :per_mille_sign => 0x2030,
  :per_ten_thousand_sign => 0x2031,
  :prime => 0x2032,
  :double_prime => 0x2033,
  :triple_prime => 0x2034,
  :reversed_prime => 0x2035,
  :reversed_double_prime => 0x2036,
  :reversed_triple_prime => 0x2037,
  :caret => 0x2038,
  :single_left_pointing_angle_quotation_mark => 0x2039,
  :left_pointing_single_guillemet => 0x2039,
  :single_right_pointing_angle_quotation_mark => 0x203a,
  :right_pointing_single_guillemet => 0x203a,
  :reference_mark => 0x203b,
  :double_exclamation_mark => 0x203c,
  :interrobang => 0x203d,
  :overline => 0x203e,
  :spacing_overscore => 0x203e,
  :undertie => 0x203f,
  :character_tie => 0x2040,
  :caret_insertion_point => 0x2041,
  :asterism => 0x2042,
  :hyphen_bullet => 0x2043,
  :fraction_slash => 0x2044,
  :left_square_bracket_with_quill => 0x2045,
  :right_square_bracket_with_quill => 0x2046,
  :double_question_mark => 0x2047,
  :question_exclamation_mark => 0x2048,
  :exclamation_question_mark => 0x2049,
  :tironian_sign_et => 0x204a,
  :reversed_pilcrow_sign => 0x204b,
  :black_leftwards_bullet => 0x204c,
  :black_rightwards_bullet => 0x204d,
  :low_asterisk => 0x204e,
  :reversed_semicolon => 0x204f,
  :close_up => 0x2050,
  :two_asterisks_aligned_vertically => 0x2051,
  :commercial_minus_sign => 0x2052,
  :swung_dash => 0x2053,
  :inverted_undertie => 0x2054,
  :flower_punctuation_mark => 0x2055,
  :three_dot_punctuation => 0x2056,
  :quadruple_prime => 0x2057,
  :four_dot_punctuation => 0x2058,
  :five_dot_punctuation => 0x2059,
  :two_dot_punctuation => 0x205a,
  :four_dot_mark => 0x205b,
  :dotted_cross => 0x205c,
  :tricolon => 0x205d,
  :vertical_four_dots => 0x205e,
  :medium_mathematical_space => 0x205f,
  :word_joiner => 0x2060,
  :function_application => 0x2061,
  :invisible_times => 0x2062,
  :invisible_separator => 0x2063,
  :inhibit_symmetric_swapping => 0x206a,
  :activate_symmetric_swapping => 0x206b,
  :inhibit_arabic_form_shaping => 0x206c,
  :activate_arabic_form_shaping => 0x206d,
  :national_digit_shapes => 0x206e,
  :nominal_digit_shapes => 0x206f,
  :superscript_zero => 0x2070,
  :superscript_digit_zero => 0x2070,
  :superscript_latin_small_letter_i => 0x2071,
  :superscript_four => 0x2074,
  :superscript_digit_four => 0x2074,
  :superscript_five => 0x2075,
  :superscript_digit_five => 0x2075,
  :superscript_six => 0x2076,
  :superscript_digit_six => 0x2076,
  :superscript_seven => 0x2077,
  :superscript_digit_seven => 0x2077,
  :superscript_eight => 0x2078,
  :superscript_digit_eight => 0x2078,
  :superscript_nine => 0x2079,
  :superscript_digit_nine => 0x2079,
  :superscript_plus_sign => 0x207a,
  :superscript_minus => 0x207b,
  :superscript_hyphen_minus => 0x207b,
  :superscript_equals_sign => 0x207c,
  :superscript_left_parenthesis => 0x207d,
  :superscript_opening_parenthesis => 0x207d,
  :superscript_right_parenthesis => 0x207e,
  :superscript_closing_parenthesis => 0x207e,
  :superscript_latin_small_letter_n => 0x207f,
  :subscript_zero => 0x2080,
  :subscript_digit_zero => 0x2080,
  :subscript_one => 0x2081,
  :subscript_digit_one => 0x2081,
  :subscript_two => 0x2082,
  :subscript_digit_two => 0x2082,
  :subscript_three => 0x2083,
  :subscript_digit_three => 0x2083,
  :subscript_four => 0x2084,
  :subscript_digit_four => 0x2084,
  :subscript_five => 0x2085,
  :subscript_digit_five => 0x2085,
  :subscript_six => 0x2086,
  :subscript_digit_six => 0x2086,
  :subscript_seven => 0x2087,
  :subscript_digit_seven => 0x2087,
  :subscript_eight => 0x2088,
  :subscript_digit_eight => 0x2088,
  :subscript_nine => 0x2089,
  :subscript_digit_nine => 0x2089,
  :subscript_plus_sign => 0x208a,
  :subscript_minus => 0x208b,
  :subscript_hyphen_minus => 0x208b,
  :subscript_equals_sign => 0x208c,
  :subscript_left_parenthesis => 0x208d,
  :subscript_opening_parenthesis => 0x208d,
  :subscript_right_parenthesis => 0x208e,
  :subscript_closing_parenthesis => 0x208e,
  :latin_subscript_small_letter_a => 0x2090,
  :latin_subscript_small_letter_e => 0x2091,
  :latin_subscript_small_letter_o => 0x2092,
  :latin_subscript_small_letter_x => 0x2093,
  :latin_subscript_small_letter_schwa => 0x2094,
  :euro_currency_sign => 0x20a0,
  :colon_sign => 0x20a1,
  :cruzeiro_sign => 0x20a2,
  :french_franc_sign => 0x20a3,
  :lira_sign => 0x20a4,
  :mill_sign => 0x20a5,
  :naira_sign => 0x20a6,
  :peseta_sign => 0x20a7,
  :rupee_sign => 0x20a8,
  :won_sign => 0x20a9,
  :new_sheqel_sign => 0x20aa,
  :dong_sign => 0x20ab,
  :euro_sign => 0x20ac,
  :kip_sign => 0x20ad,
  :tugrik_sign => 0x20ae,
  :drachma_sign => 0x20af,
  :german_penny_sign => 0x20b0,
  :peso_sign => 0x20b1,
  :guarani_sign => 0x20b2,
  :austral_sign => 0x20b3,
  :hryvnia_sign => 0x20b4,
  :cedi_sign => 0x20b5,
  :combining_left_harpoon_above => 0x20d0,
  :non_spacing_left_harpoon_above => 0x20d0,
  :combining_right_harpoon_above => 0x20d1,
  :non_spacing_right_harpoon_above => 0x20d1,
  :combining_long_vertical_line_overlay => 0x20d2,
  :non_spacing_long_vertical_bar_overlay => 0x20d2,
  :combining_short_vertical_line_overlay => 0x20d3,
  :non_spacing_short_vertical_bar_overlay => 0x20d3,
  :combining_anticlockwise_arrow_above => 0x20d4,
  :non_spacing_anticlockwise_arrow_above => 0x20d4,
  :combining_clockwise_arrow_above => 0x20d5,
  :non_spacing_clockwise_arrow_above => 0x20d5,
  :combining_left_arrow_above => 0x20d6,
  :non_spacing_left_arrow_above => 0x20d6,
  :combining_right_arrow_above => 0x20d7,
  :non_spacing_right_arrow_above => 0x20d7,
  :combining_ring_overlay => 0x20d8,
  :non_spacing_ring_overlay => 0x20d8,
  :combining_clockwise_ring_overlay => 0x20d9,
  :non_spacing_clockwise_ring_overlay => 0x20d9,
  :combining_anticlockwise_ring_overlay => 0x20da,
  :non_spacing_anticlockwise_ring_overlay => 0x20da,
  :combining_three_dots_above => 0x20db,
  :non_spacing_three_dots_above => 0x20db,
  :combining_four_dots_above => 0x20dc,
  :non_spacing_four_dots_above => 0x20dc,
  :combining_enclosing_circle => 0x20dd,
  :enclosing_circle => 0x20dd,
  :combining_enclosing_square => 0x20de,
  :enclosing_square => 0x20de,
  :combining_enclosing_diamond => 0x20df,
  :enclosing_diamond => 0x20df,
  :combining_enclosing_circle_backslash => 0x20e0,
  :enclosing_circle_slash => 0x20e0,
  :combining_left_right_arrow_above => 0x20e1,
  :non_spacing_left_right_arrow_above => 0x20e1,
  :combining_enclosing_screen => 0x20e2,
  :combining_enclosing_keycap => 0x20e3,
  :combining_enclosing_upward_pointing_triangle => 0x20e4,
  :combining_reverse_solidus_overlay => 0x20e5,
  :combining_double_vertical_stroke_overlay => 0x20e6,
  :combining_annuity_symbol => 0x20e7,
  :combining_triple_underdot => 0x20e8,
  :combining_wide_bridge_above => 0x20e9,
  :combining_leftwards_arrow_overlay => 0x20ea,
  :combining_long_double_solidus_overlay => 0x20eb,
  :account_of => 0x2100,
  :addressed_to_the_subject => 0x2101,
  :double_struck_capital_c => 0x2102,
  :double_struck_c => 0x2102,
  :degree_celsius => 0x2103,
  :degrees_centigrade => 0x2103,
  :centre_line_symbol => 0x2104,
  :c_l_symbol => 0x2104,
  :care_of => 0x2105,
  :cada_una => 0x2106,
  :euler_constant => 0x2107,
  :eulers => 0x2107,
  :scruple => 0x2108,
  :degree_fahrenheit => 0x2109,
  :degrees_fahrenheit => 0x2109,
  :script_small_g => 0x210a,
  :script_capital_h => 0x210b,
  :script_h => 0x210b,
  :black_letter_capital_h => 0x210c,
  :black_letter_h => 0x210c,
  :double_struck_capital_h => 0x210d,
  :double_struck_h => 0x210d,
  :planck_constant => 0x210e,
  :planck_constant_over_two_pi => 0x210f,
  :planck_constant_over_2_pi => 0x210f,
  :script_capital_i => 0x2110,
  :script_i => 0x2110,
  :black_letter_capital_i => 0x2111,
  :black_letter_i => 0x2111,
  :script_capital_l => 0x2112,
  :script_l => 0x2112,
  :script_small_l => 0x2113,
  :l_b_bar_symbol => 0x2114,
  :double_struck_capital_n => 0x2115,
  :double_struck_n => 0x2115,
  :numero_sign => 0x2116,
  :numero => 0x2116,
  :sound_recording_copyright => 0x2117,
  :script_capital_p => 0x2118,
  :script_p => 0x2118,
  :double_struck_capital_p => 0x2119,
  :double_struck_p => 0x2119,
  :double_struck_capital_q => 0x211a,
  :double_struck_q => 0x211a,
  :script_capital_r => 0x211b,
  :script_r => 0x211b,
  :black_letter_capital_r => 0x211c,
  :black_letter_r => 0x211c,
  :double_struck_capital_r => 0x211d,
  :double_struck_r => 0x211d,
  :prescription_take => 0x211e,
  :response => 0x211f,
  :service_mark => 0x2120,
  :telephone_sign => 0x2121,
  :t_e_l_symbol => 0x2121,
  :trade_mark_sign => 0x2122,
  :trademark => 0x2122,
  :versicle => 0x2123,
  :double_struck_capital_z => 0x2124,
  :double_struck_z => 0x2124,
  :ounce_sign => 0x2125,
  :ounce => 0x2125,
  :ohm_sign => 0x2126,
  :ohm => 0x2126,
  :inverted_ohm_sign => 0x2127,
  :mho => 0x2127,
  :black_letter_capital_z => 0x2128,
  :black_letter_z => 0x2128,
  :turned_greek_small_letter_iota => 0x2129,
  :kelvin_sign => 0x212a,
  :degrees_kelvin => 0x212a,
  :angstrom_sign => 0x212b,
  :angstrom_unit => 0x212b,
  :script_capital_b => 0x212c,
  :script_b => 0x212c,
  :black_letter_capital_c => 0x212d,
  :black_letter_c => 0x212d,
  :estimated_symbol => 0x212e,
  :script_small_e => 0x212f,
  :script_capital_e => 0x2130,
  :script_e => 0x2130,
  :script_capital_f => 0x2131,
  :script_f => 0x2131,
  :turned_capital_f => 0x2132,
  :turned_f => 0x2132,
  :script_capital_m => 0x2133,
  :script_m => 0x2133,
  :script_small_o => 0x2134,
  :alef_symbol => 0x2135,
  :first_transfinite_cardinal => 0x2135,
  :bet_symbol => 0x2136,
  :second_transfinite_cardinal => 0x2136,
  :gimel_symbol => 0x2137,
  :third_transfinite_cardinal => 0x2137,
  :dalet_symbol => 0x2138,
  :fourth_transfinite_cardinal => 0x2138,
  :information_source => 0x2139,
  :rotated_capital_q => 0x213a,
  :facsimile_sign => 0x213b,
  :double_struck_small_pi => 0x213c,
  :double_struck_small_gamma => 0x213d,
  :double_struck_capital_gamma => 0x213e,
  :double_struck_capital_pi => 0x213f,
  :double_struck_n_ary_summation => 0x2140,
  :turned_sans_serif_capital_g => 0x2141,
  :turned_sans_serif_capital_l => 0x2142,
  :reversed_sans_serif_capital_l => 0x2143,
  :turned_sans_serif_capital_y => 0x2144,
  :double_struck_italic_capital_d => 0x2145,
  :double_struck_italic_small_d => 0x2146,
  :double_struck_italic_small_e => 0x2147,
  :double_struck_italic_small_i => 0x2148,
  :double_struck_italic_small_j => 0x2149,
  :property_line => 0x214a,
  :turned_ampersand => 0x214b,
  :per_sign => 0x214c,
  :vulgar_fraction_one_third => 0x2153,
  :fraction_one_third => 0x2153,
  :vulgar_fraction_two_thirds => 0x2154,
  :fraction_two_thirds => 0x2154,
  :vulgar_fraction_one_fifth => 0x2155,
  :fraction_one_fifth => 0x2155,
  :vulgar_fraction_two_fifths => 0x2156,
  :fraction_two_fifths => 0x2156,
  :vulgar_fraction_three_fifths => 0x2157,
  :fraction_three_fifths => 0x2157,
  :vulgar_fraction_four_fifths => 0x2158,
  :fraction_four_fifths => 0x2158,
  :vulgar_fraction_one_sixth => 0x2159,
  :fraction_one_sixth => 0x2159,
  :vulgar_fraction_five_sixths => 0x215a,
  :fraction_five_sixths => 0x215a,
  :vulgar_fraction_one_eighth => 0x215b,
  :fraction_one_eighth => 0x215b,
  :vulgar_fraction_three_eighths => 0x215c,
  :fraction_three_eighths => 0x215c,
  :vulgar_fraction_five_eighths => 0x215d,
  :fraction_five_eighths => 0x215d,
  :vulgar_fraction_seven_eighths => 0x215e,
  :fraction_seven_eighths => 0x215e,
  :fraction_numerator_one => 0x215f,
  :roman_numeral_one => 0x2160,
  :roman_numeral_two => 0x2161,
  :roman_numeral_three => 0x2162,
  :roman_numeral_four => 0x2163,
  :roman_numeral_five => 0x2164,
  :roman_numeral_six => 0x2165,
  :roman_numeral_seven => 0x2166,
  :roman_numeral_eight => 0x2167,
  :roman_numeral_nine => 0x2168,
  :roman_numeral_ten => 0x2169,
  :roman_numeral_eleven => 0x216a,
  :roman_numeral_twelve => 0x216b,
  :roman_numeral_fifty => 0x216c,
  :roman_numeral_one_hundred => 0x216d,
  :roman_numeral_five_hundred => 0x216e,
  :roman_numeral_one_thousand => 0x216f,
  :small_roman_numeral_one => 0x2170,
  :small_roman_numeral_two => 0x2171,
  :small_roman_numeral_three => 0x2172,
  :small_roman_numeral_four => 0x2173,
  :small_roman_numeral_five => 0x2174,
  :small_roman_numeral_six => 0x2175,
  :small_roman_numeral_seven => 0x2176,
  :small_roman_numeral_eight => 0x2177,
  :small_roman_numeral_nine => 0x2178,
  :small_roman_numeral_ten => 0x2179,
  :small_roman_numeral_eleven => 0x217a,
  :small_roman_numeral_twelve => 0x217b,
  :small_roman_numeral_fifty => 0x217c,
  :small_roman_numeral_one_hundred => 0x217d,
  :small_roman_numeral_five_hundred => 0x217e,
  :small_roman_numeral_one_thousand => 0x217f,
  :roman_numeral_one_thousand_c_d => 0x2180,
  :roman_numeral_five_thousand => 0x2181,
  :roman_numeral_ten_thousand => 0x2182,
  :roman_numeral_reversed_one_hundred => 0x2183,
  :leftwards_arrow => 0x2190,
  :left_arrow => 0x2190,
  :upwards_arrow => 0x2191,
  :up_arrow => 0x2191,
  :rightwards_arrow => 0x2192,
  :right_arrow => 0x2192,
  :downwards_arrow => 0x2193,
  :down_arrow => 0x2193,
  :left_right_arrow => 0x2194,
  :up_down_arrow => 0x2195,
  :north_west_arrow => 0x2196,
  :upper_left_arrow => 0x2196,
  :north_east_arrow => 0x2197,
  :upper_right_arrow => 0x2197,
  :south_east_arrow => 0x2198,
  :lower_right_arrow => 0x2198,
  :south_west_arrow => 0x2199,
  :lower_left_arrow => 0x2199,
  :leftwards_arrow_with_stroke => 0x219a,
  :left_arrow_with_stroke => 0x219a,
  :rightwards_arrow_with_stroke => 0x219b,
  :right_arrow_with_stroke => 0x219b,
  :leftwards_wave_arrow => 0x219c,
  :left_wave_arrow => 0x219c,
  :rightwards_wave_arrow => 0x219d,
  :right_wave_arrow => 0x219d,
  :leftwards_two_headed_arrow => 0x219e,
  :left_two_headed_arrow => 0x219e,
  :upwards_two_headed_arrow => 0x219f,
  :up_two_headed_arrow => 0x219f,
  :rightwards_two_headed_arrow => 0x21a0,
  :right_two_headed_arrow => 0x21a0,
  :downwards_two_headed_arrow => 0x21a1,
  :down_two_headed_arrow => 0x21a1,
  :leftwards_arrow_with_tail => 0x21a2,
  :left_arrow_with_tail => 0x21a2,
  :rightwards_arrow_with_tail => 0x21a3,
  :right_arrow_with_tail => 0x21a3,
  :leftwards_arrow_from_bar => 0x21a4,
  :left_arrow_from_bar => 0x21a4,
  :upwards_arrow_from_bar => 0x21a5,
  :up_arrow_from_bar => 0x21a5,
  :rightwards_arrow_from_bar => 0x21a6,
  :right_arrow_from_bar => 0x21a6,
  :downwards_arrow_from_bar => 0x21a7,
  :down_arrow_from_bar => 0x21a7,
  :up_down_arrow_with_base => 0x21a8,
  :leftwards_arrow_with_hook => 0x21a9,
  :left_arrow_with_hook => 0x21a9,
  :rightwards_arrow_with_hook => 0x21aa,
  :right_arrow_with_hook => 0x21aa,
  :leftwards_arrow_with_loop => 0x21ab,
  :left_arrow_with_loop => 0x21ab,
  :rightwards_arrow_with_loop => 0x21ac,
  :right_arrow_with_loop => 0x21ac,
  :left_right_wave_arrow => 0x21ad,
  :left_right_arrow_with_stroke => 0x21ae,
  :downwards_zigzag_arrow => 0x21af,
  :down_zigzag_arrow => 0x21af,
  :upwards_arrow_with_tip_leftwards => 0x21b0,
  :up_arrow_with_tip_left => 0x21b0,
  :upwards_arrow_with_tip_rightwards => 0x21b1,
  :up_arrow_with_tip_right => 0x21b1,
  :downwards_arrow_with_tip_leftwards => 0x21b2,
  :down_arrow_with_tip_left => 0x21b2,
  :downwards_arrow_with_tip_rightwards => 0x21b3,
  :down_arrow_with_tip_right => 0x21b3,
  :rightwards_arrow_with_corner_downwards => 0x21b4,
  :right_arrow_with_corner_down => 0x21b4,
  :downwards_arrow_with_corner_leftwards => 0x21b5,
  :down_arrow_with_corner_left => 0x21b5,
  :anticlockwise_top_semicircle_arrow => 0x21b6,
  :clockwise_top_semicircle_arrow => 0x21b7,
  :north_west_arrow_to_long_bar => 0x21b8,
  :upper_left_arrow_to_long_bar => 0x21b8,
  :leftwards_arrow_to_bar_over_rightwards_arrow_to_bar => 0x21b9,
  :left_arrow_to_bar_over_right_arrow_to_bar => 0x21b9,
  :anticlockwise_open_circle_arrow => 0x21ba,
  :clockwise_open_circle_arrow => 0x21bb,
  :leftwards_harpoon_with_barb_upwards => 0x21bc,
  :left_harpoon_with_barb_up => 0x21bc,
  :leftwards_harpoon_with_barb_downwards => 0x21bd,
  :left_harpoon_with_barb_down => 0x21bd,
  :upwards_harpoon_with_barb_rightwards => 0x21be,
  :up_harpoon_with_barb_right => 0x21be,
  :upwards_harpoon_with_barb_leftwards => 0x21bf,
  :up_harpoon_with_barb_left => 0x21bf,
  :rightwards_harpoon_with_barb_upwards => 0x21c0,
  :right_harpoon_with_barb_up => 0x21c0,
  :rightwards_harpoon_with_barb_downwards => 0x21c1,
  :right_harpoon_with_barb_down => 0x21c1,
  :downwards_harpoon_with_barb_rightwards => 0x21c2,
  :down_harpoon_with_barb_right => 0x21c2,
  :downwards_harpoon_with_barb_leftwards => 0x21c3,
  :down_harpoon_with_barb_left => 0x21c3,
  :rightwards_arrow_over_leftwards_arrow => 0x21c4,
  :right_arrow_over_left_arrow => 0x21c4,
  :upwards_arrow_leftwards_of_downwards_arrow => 0x21c5,
  :up_arrow_left_of_down_arrow => 0x21c5,
  :leftwards_arrow_over_rightwards_arrow => 0x21c6,
  :left_arrow_over_right_arrow => 0x21c6,
  :leftwards_paired_arrows => 0x21c7,
  :left_paired_arrows => 0x21c7,
  :upwards_paired_arrows => 0x21c8,
  :up_paired_arrows => 0x21c8,
  :rightwards_paired_arrows => 0x21c9,
  :right_paired_arrows => 0x21c9,
  :downwards_paired_arrows => 0x21ca,
  :down_paired_arrows => 0x21ca,
  :leftwards_harpoon_over_rightwards_harpoon => 0x21cb,
  :left_harpoon_over_right_harpoon => 0x21cb,
  :rightwards_harpoon_over_leftwards_harpoon => 0x21cc,
  :right_harpoon_over_left_harpoon => 0x21cc,
  :leftwards_double_arrow_with_stroke => 0x21cd,
  :left_double_arrow_with_stroke => 0x21cd,
  :left_right_double_arrow_with_stroke => 0x21ce,
  :rightwards_double_arrow_with_stroke => 0x21cf,
  :right_double_arrow_with_stroke => 0x21cf,
  :leftwards_double_arrow => 0x21d0,
  :left_double_arrow => 0x21d0,
  :upwards_double_arrow => 0x21d1,
  :up_double_arrow => 0x21d1,
  :rightwards_double_arrow => 0x21d2,
  :right_double_arrow => 0x21d2,
  :downwards_double_arrow => 0x21d3,
  :down_double_arrow => 0x21d3,
  :left_right_double_arrow => 0x21d4,
  :up_down_double_arrow => 0x21d5,
  :north_west_double_arrow => 0x21d6,
  :upper_left_double_arrow => 0x21d6,
  :north_east_double_arrow => 0x21d7,
  :upper_right_double_arrow => 0x21d7,
  :south_east_double_arrow => 0x21d8,
  :lower_right_double_arrow => 0x21d8,
  :south_west_double_arrow => 0x21d9,
  :lower_left_double_arrow => 0x21d9,
  :leftwards_triple_arrow => 0x21da,
  :left_triple_arrow => 0x21da,
  :rightwards_triple_arrow => 0x21db,
  :right_triple_arrow => 0x21db,
  :leftwards_squiggle_arrow => 0x21dc,
  :left_squiggle_arrow => 0x21dc,
  :rightwards_squiggle_arrow => 0x21dd,
  :right_squiggle_arrow => 0x21dd,
  :upwards_arrow_with_double_stroke => 0x21de,
  :up_arrow_with_double_stroke => 0x21de,
  :downwards_arrow_with_double_stroke => 0x21df,
  :down_arrow_with_double_stroke => 0x21df,
  :leftwards_dashed_arrow => 0x21e0,
  :left_dashed_arrow => 0x21e0,
  :upwards_dashed_arrow => 0x21e1,
  :up_dashed_arrow => 0x21e1,
  :rightwards_dashed_arrow => 0x21e2,
  :right_dashed_arrow => 0x21e2,
  :downwards_dashed_arrow => 0x21e3,
  :down_dashed_arrow => 0x21e3,
  :leftwards_arrow_to_bar => 0x21e4,
  :left_arrow_to_bar => 0x21e4,
  :rightwards_arrow_to_bar => 0x21e5,
  :right_arrow_to_bar => 0x21e5,
  :leftwards_white_arrow => 0x21e6,
  :white_left_arrow => 0x21e6,
  :upwards_white_arrow => 0x21e7,
  :white_up_arrow => 0x21e7,
  :rightwards_white_arrow => 0x21e8,
  :white_right_arrow => 0x21e8,
  :downwards_white_arrow => 0x21e9,
  :white_down_arrow => 0x21e9,
  :upwards_white_arrow_from_bar => 0x21ea,
  :white_up_arrow_from_bar => 0x21ea,
  :upwards_white_arrow_on_pedestal => 0x21eb,
  :upwards_white_arrow_on_pedestal_with_horizontal_bar => 0x21ec,
  :upwards_white_arrow_on_pedestal_with_vertical_bar => 0x21ed,
  :upwards_white_double_arrow => 0x21ee,
  :upwards_white_double_arrow_on_pedestal => 0x21ef,
  :rightwards_white_arrow_from_wall => 0x21f0,
  :north_west_arrow_to_corner => 0x21f1,
  :south_east_arrow_to_corner => 0x21f2,
  :up_down_white_arrow => 0x21f3,
  :right_arrow_with_small_circle => 0x21f4,
  :downwards_arrow_leftwards_of_upwards_arrow => 0x21f5,
  :three_rightwards_arrows => 0x21f6,
  :leftwards_arrow_with_vertical_stroke => 0x21f7,
  :rightwards_arrow_with_vertical_stroke => 0x21f8,
  :left_right_arrow_with_vertical_stroke => 0x21f9,
  :leftwards_arrow_with_double_vertical_stroke => 0x21fa,
  :rightwards_arrow_with_double_vertical_stroke => 0x21fb,
  :left_right_arrow_with_double_vertical_stroke => 0x21fc,
  :leftwards_open_headed_arrow => 0x21fd,
  :rightwards_open_headed_arrow => 0x21fe,
  :left_right_open_headed_arrow => 0x21ff,
  :for_all => 0x2200,
  :complement => 0x2201,
  :partial_differential => 0x2202,
  :there_exists => 0x2203,
  :there_does_not_exist => 0x2204,
  :empty_set => 0x2205,
  :increment => 0x2206,
  :nabla => 0x2207,
  :element_of => 0x2208,
  :not_an_element_of => 0x2209,
  :small_element_of => 0x220a,
  :contains_as_member => 0x220b,
  :does_not_contain_as_member => 0x220c,
  :small_contains_as_member => 0x220d,
  :end_of_proof => 0x220e,
  :n_ary_product => 0x220f,
  :n_ary_coproduct => 0x2210,
  :n_ary_summation => 0x2211,
  :minus_sign => 0x2212,
  :minus_or_plus_sign => 0x2213,
  :dot_plus => 0x2214,
  :division_slash => 0x2215,
  :set_minus => 0x2216,
  :asterisk_operator => 0x2217,
  :ring_operator => 0x2218,
  :bullet_operator => 0x2219,
  :square_root => 0x221a,
  :cube_root => 0x221b,
  :fourth_root => 0x221c,
  :proportional_to => 0x221d,
  :infinity => 0x221e,
  :right_angle => 0x221f,
  :angle => 0x2220,
  :measured_angle => 0x2221,
  :spherical_angle => 0x2222,
  :divides => 0x2223,
  :does_not_divide => 0x2224,
  :parallel_to => 0x2225,
  :not_parallel_to => 0x2226,
  :logical_and => 0x2227,
  :logical_or => 0x2228,
  :intersection => 0x2229,
  :union => 0x222a,
  :integral => 0x222b,
  :double_integral => 0x222c,
  :triple_integral => 0x222d,
  :contour_integral => 0x222e,
  :surface_integral => 0x222f,
  :volume_integral => 0x2230,
  :clockwise_integral => 0x2231,
  :clockwise_contour_integral => 0x2232,
  :anticlockwise_contour_integral => 0x2233,
  :therefore => 0x2234,
  :because => 0x2235,
  :ratio => 0x2236,
  :proportion => 0x2237,
  :dot_minus => 0x2238,
  :excess => 0x2239,
  :geometric_proportion => 0x223a,
  :homothetic => 0x223b,
  :tilde_operator => 0x223c,
  :reversed_tilde => 0x223d,
  :inverted_lazy_s => 0x223e,
  :sine_wave => 0x223f,
  :wreath_product => 0x2240,
  :not_tilde => 0x2241,
  :minus_tilde => 0x2242,
  :asymptotically_equal_to => 0x2243,
  :not_asymptotically_equal_to => 0x2244,
  :approximately_equal_to => 0x2245,
  :approximately_but_not_actually_equal_to => 0x2246,
  :neither_approximately_nor_actually_equal_to => 0x2247,
  :almost_equal_to => 0x2248,
  :not_almost_equal_to => 0x2249,
  :almost_equal_or_equal_to => 0x224a,
  :triple_tilde => 0x224b,
  :all_equal_to => 0x224c,
  :equivalent_to => 0x224d,
  :geometrically_equivalent_to => 0x224e,
  :difference_between => 0x224f,
  :approaches_the_limit => 0x2250,
  :geometrically_equal_to => 0x2251,
  :approximately_equal_to_or_the_image_of => 0x2252,
  :image_of_or_approximately_equal_to => 0x2253,
  :colon_equals => 0x2254,
  :colon_equal => 0x2254,
  :equals_colon => 0x2255,
  :equal_colon => 0x2255,
  :ring_in_equal_to => 0x2256,
  :ring_equal_to => 0x2257,
  :corresponds_to => 0x2258,
  :estimates => 0x2259,
  :equiangular_to => 0x225a,
  :star_equals => 0x225b,
  :delta_equal_to => 0x225c,
  :equal_to_by_definition => 0x225d,
  :measured_by => 0x225e,
  :questioned_equal_to => 0x225f,
  :not_equal_to => 0x2260,
  :identical_to => 0x2261,
  :not_identical_to => 0x2262,
  :strictly_equivalent_to => 0x2263,
  :less_than_or_equal_to => 0x2264,
  :less_than_or_equal_to => 0x2264,
  :greater_than_or_equal_to => 0x2265,
  :greater_than_or_equal_to => 0x2265,
  :less_than_over_equal_to => 0x2266,
  :less_than_over_equal_to => 0x2266,
  :greater_than_over_equal_to => 0x2267,
  :greater_than_over_equal_to => 0x2267,
  :less_than_but_not_equal_to => 0x2268,
  :less_than_but_not_equal_to => 0x2268,
  :greater_than_but_not_equal_to => 0x2269,
  :greater_than_but_not_equal_to => 0x2269,
  :much_less_than => 0x226a,
  :much_less_than => 0x226a,
  :much_greater_than => 0x226b,
  :much_greater_than => 0x226b,
  :between => 0x226c,
  :not_equivalent_to => 0x226d,
  :not_less_than => 0x226e,
  :not_less_than => 0x226e,
  :not_greater_than => 0x226f,
  :not_greater_than => 0x226f,
  :neither_less_than_nor_equal_to => 0x2270,
  :neither_less_than_nor_equal_to => 0x2270,
  :neither_greater_than_nor_equal_to => 0x2271,
  :neither_greater_than_nor_equal_to => 0x2271,
  :less_than_or_equivalent_to => 0x2272,
  :less_than_or_equivalent_to => 0x2272,
  :greater_than_or_equivalent_to => 0x2273,
  :greater_than_or_equivalent_to => 0x2273,
  :neither_less_than_nor_equivalent_to => 0x2274,
  :neither_less_than_nor_equivalent_to => 0x2274,
  :neither_greater_than_nor_equivalent_to => 0x2275,
  :neither_greater_than_nor_equivalent_to => 0x2275,
  :less_than_or_greater_than => 0x2276,
  :less_than_or_greater_than => 0x2276,
  :greater_than_or_less_than => 0x2277,
  :greater_than_or_less_than => 0x2277,
  :neither_less_than_nor_greater_than => 0x2278,
  :neither_less_than_nor_greater_than => 0x2278,
  :neither_greater_than_nor_less_than => 0x2279,
  :neither_greater_than_nor_less_than => 0x2279,
  :precedes => 0x227a,
  :succeeds => 0x227b,
  :precedes_or_equal_to => 0x227c,
  :succeeds_or_equal_to => 0x227d,
  :precedes_or_equivalent_to => 0x227e,
  :succeeds_or_equivalent_to => 0x227f,
  :does_not_precede => 0x2280,
  :does_not_succeed => 0x2281,
  :subset_of => 0x2282,
  :superset_of => 0x2283,
  :not_a_subset_of => 0x2284,
  :not_a_superset_of => 0x2285,
  :subset_of_or_equal_to => 0x2286,
  :superset_of_or_equal_to => 0x2287,
  :neither_a_subset_of_nor_equal_to => 0x2288,
  :neither_a_superset_of_nor_equal_to => 0x2289,
  :subset_of_with_not_equal_to => 0x228a,
  :subset_of_or_not_equal_to => 0x228a,
  :superset_of_with_not_equal_to => 0x228b,
  :superset_of_or_not_equal_to => 0x228b,
  :multiset => 0x228c,
  :multiset_multiplication => 0x228d,
  :multiset_union => 0x228e,
  :square_image_of => 0x228f,
  :square_original_of => 0x2290,
  :square_image_of_or_equal_to => 0x2291,
  :square_original_of_or_equal_to => 0x2292,
  :square_cap => 0x2293,
  :square_cup => 0x2294,
  :circled_plus => 0x2295,
  :circled_minus => 0x2296,
  :circled_times => 0x2297,
  :circled_division_slash => 0x2298,
  :circled_dot_operator => 0x2299,
  :circled_ring_operator => 0x229a,
  :circled_asterisk_operator => 0x229b,
  :circled_equals => 0x229c,
  :circled_dash => 0x229d,
  :squared_plus => 0x229e,
  :squared_minus => 0x229f,
  :squared_times => 0x22a0,
  :squared_dot_operator => 0x22a1,
  :right_tack => 0x22a2,
  :left_tack => 0x22a3,
  :down_tack => 0x22a4,
  :up_tack => 0x22a5,
  :assertion => 0x22a6,
  :models => 0x22a7,
  :true => 0x22a8,
  :forces => 0x22a9,
  :triple_vertical_bar_right_turnstile => 0x22aa,
  :double_vertical_bar_double_right_turnstile => 0x22ab,
  :does_not_prove => 0x22ac,
  :not_true => 0x22ad,
  :does_not_force => 0x22ae,
  :negated_double_vertical_bar_double_right_turnstile => 0x22af,
  :precedes_under_relation => 0x22b0,
  :succeeds_under_relation => 0x22b1,
  :normal_subgroup_of => 0x22b2,
  :contains_as_normal_subgroup => 0x22b3,
  :normal_subgroup_of_or_equal_to => 0x22b4,
  :contains_as_normal_subgroup_or_equal_to => 0x22b5,
  :original_of => 0x22b6,
  :image_of => 0x22b7,
  :multimap => 0x22b8,
  :hermitian_conjugate_matrix => 0x22b9,
  :intercalate => 0x22ba,
  :xor => 0x22bb,
  :nand => 0x22bc,
  :nor => 0x22bd,
  :right_angle_with_arc => 0x22be,
  :right_triangle => 0x22bf,
  :n_ary_logical_and => 0x22c0,
  :n_ary_logical_or => 0x22c1,
  :n_ary_intersection => 0x22c2,
  :n_ary_union => 0x22c3,
  :diamond_operator => 0x22c4,
  :dot_operator => 0x22c5,
  :star_operator => 0x22c6,
  :division_times => 0x22c7,
  :bowtie => 0x22c8,
  :left_normal_factor_semidirect_product => 0x22c9,
  :right_normal_factor_semidirect_product => 0x22ca,
  :left_semidirect_product => 0x22cb,
  :right_semidirect_product => 0x22cc,
  :reversed_tilde_equals => 0x22cd,
  :curly_logical_or => 0x22ce,
  :curly_logical_and => 0x22cf,
  :double_subset => 0x22d0,
  :double_superset => 0x22d1,
  :double_intersection => 0x22d2,
  :double_union => 0x22d3,
  :pitchfork => 0x22d4,
  :equal_and_parallel_to => 0x22d5,
  :less_than_with_dot => 0x22d6,
  :less_than_with_dot => 0x22d6,
  :greater_than_with_dot => 0x22d7,
  :greater_than_with_dot => 0x22d7,
  :very_much_less_than => 0x22d8,
  :very_much_less_than => 0x22d8,
  :very_much_greater_than => 0x22d9,
  :very_much_greater_than => 0x22d9,
  :less_than_equal_to_or_greater_than => 0x22da,
  :less_than_equal_to_or_greater_than => 0x22da,
  :greater_than_equal_to_or_less_than => 0x22db,
  :greater_than_equal_to_or_less_than => 0x22db,
  :equal_to_or_less_than => 0x22dc,
  :equal_to_or_less_than => 0x22dc,
  :equal_to_or_greater_than => 0x22dd,
  :equal_to_or_greater_than => 0x22dd,
  :equal_to_or_precedes => 0x22de,
  :equal_to_or_succeeds => 0x22df,
  :does_not_precede_or_equal => 0x22e0,
  :does_not_succeed_or_equal => 0x22e1,
  :not_square_image_of_or_equal_to => 0x22e2,
  :not_square_original_of_or_equal_to => 0x22e3,
  :square_image_of_or_not_equal_to => 0x22e4,
  :square_original_of_or_not_equal_to => 0x22e5,
  :less_than_but_not_equivalent_to => 0x22e6,
  :less_than_but_not_equivalent_to => 0x22e6,
  :greater_than_but_not_equivalent_to => 0x22e7,
  :greater_than_but_not_equivalent_to => 0x22e7,
  :precedes_but_not_equivalent_to => 0x22e8,
  :succeeds_but_not_equivalent_to => 0x22e9,
  :not_normal_subgroup_of => 0x22ea,
  :does_not_contain_as_normal_subgroup => 0x22eb,
  :not_normal_subgroup_of_or_equal_to => 0x22ec,
  :does_not_contain_as_normal_subgroup_or_equal => 0x22ed,
  :vertical_ellipsis => 0x22ee,
  :midline_horizontal_ellipsis => 0x22ef,
  :up_right_diagonal_ellipsis => 0x22f0,
  :down_right_diagonal_ellipsis => 0x22f1,
  :element_of_with_long_horizontal_stroke => 0x22f2,
  :element_of_with_vertical_bar_at_end_of_horizontal_stroke => 0x22f3,
  :small_element_of_with_vertical_bar_at_end_of_horizontal_stroke => 0x22f4,
  :element_of_with_dot_above => 0x22f5,
  :element_of_with_overbar => 0x22f6,
  :small_element_of_with_overbar => 0x22f7,
  :element_of_with_underbar => 0x22f8,
  :element_of_with_two_horizontal_strokes => 0x22f9,
  :contains_with_long_horizontal_stroke => 0x22fa,
  :contains_with_vertical_bar_at_end_of_horizontal_stroke => 0x22fb,
  :small_contains_with_vertical_bar_at_end_of_horizontal_stroke => 0x22fc,
  :contains_with_overbar => 0x22fd,
  :small_contains_with_overbar => 0x22fe,
  :z_notation_bag_membership => 0x22ff,
  :diameter_sign => 0x2300,
  :electric_arrow => 0x2301,
  :house => 0x2302,
  :up_arrowhead => 0x2303,
  :down_arrowhead => 0x2304,
  :projective => 0x2305,
  :perspective => 0x2306,
  :wavy_line => 0x2307,
  :left_ceiling => 0x2308,
  :right_ceiling => 0x2309,
  :left_floor => 0x230a,
  :right_floor => 0x230b,
  :bottom_right_crop => 0x230c,
  :bottom_left_crop => 0x230d,
  :top_right_crop => 0x230e,
  :top_left_crop => 0x230f,
  :reversed_not_sign => 0x2310,
  :square_lozenge => 0x2311,
  :arc => 0x2312,
  :segment => 0x2313,
  :sector => 0x2314,
  :telephone_recorder => 0x2315,
  :position_indicator => 0x2316,
  :viewdata_square => 0x2317,
  :place_of_interest_sign => 0x2318,
  :command_key => 0x2318,
  :turned_not_sign => 0x2319,
  :watch => 0x231a,
  :hourglass => 0x231b,
  :top_left_corner => 0x231c,
  :top_right_corner => 0x231d,
  :bottom_left_corner => 0x231e,
  :bottom_right_corner => 0x231f,
  :top_half_integral => 0x2320,
  :bottom_half_integral => 0x2321,
  :frown => 0x2322,
  :smile => 0x2323,
  :up_arrowhead_between_two_horizontal_bars => 0x2324,
  :enter_key => 0x2324,
  :option_key => 0x2325,
  :erase_to_the_right => 0x2326,
  :delete_to_the_right_key => 0x2326,
  :x_in_a_rectangle_box => 0x2327,
  :clear_key => 0x2327,
  :keyboard => 0x2328,
  :left_pointing_angle_bracket => 0x2329,
  :bra => 0x2329,
  :right_pointing_angle_bracket => 0x232a,
  :ket => 0x232a,
  :erase_to_the_left => 0x232b,
  :delete_to_the_left_key => 0x232b,
  :benzene_ring => 0x232c,
  :cylindricity => 0x232d,
  :all_around_profile => 0x232e,
  :symmetry => 0x232f,
  :total_runout => 0x2330,
  :dimension_origin => 0x2331,
  :conical_taper => 0x2332,
  :slope => 0x2333,
  :counterbore => 0x2334,
  :countersink => 0x2335,
  :apl_functional_symbol_i_beam => 0x2336,
  :apl_functional_symbol_squish_quad => 0x2337,
  :apl_functional_symbol_quad_equal => 0x2338,
  :apl_functional_symbol_quad_divide => 0x2339,
  :apl_functional_symbol_quad_diamond => 0x233a,
  :apl_functional_symbol_quad_jot => 0x233b,
  :apl_functional_symbol_quad_circle => 0x233c,
  :apl_functional_symbol_circle_stile => 0x233d,
  :apl_functional_symbol_circle_jot => 0x233e,
  :apl_functional_symbol_slash_bar => 0x233f,
  :apl_functional_symbol_backslash_bar => 0x2340,
  :apl_functional_symbol_quad_slash => 0x2341,
  :apl_functional_symbol_quad_backslash => 0x2342,
  :apl_functional_symbol_quad_less_than => 0x2343,
  :apl_functional_symbol_quad_greater_than => 0x2344,
  :apl_functional_symbol_leftwards_vane => 0x2345,
  :apl_functional_symbol_rightwards_vane => 0x2346,
  :apl_functional_symbol_quad_leftwards_arrow => 0x2347,
  :apl_functional_symbol_quad_rightwards_arrow => 0x2348,
  :apl_functional_symbol_circle_backslash => 0x2349,
  :apl_functional_symbol_down_tack_underbar => 0x234a,
  :apl_functional_symbol_delta_stile => 0x234b,
  :apl_functional_symbol_quad_down_caret => 0x234c,
  :apl_functional_symbol_quad_delta => 0x234d,
  :apl_functional_symbol_down_tack_jot => 0x234e,
  :apl_functional_symbol_upwards_vane => 0x234f,
  :apl_functional_symbol_quad_upwards_arrow => 0x2350,
  :apl_functional_symbol_up_tack_overbar => 0x2351,
  :apl_functional_symbol_del_stile => 0x2352,
  :apl_functional_symbol_quad_up_caret => 0x2353,
  :apl_functional_symbol_quad_del => 0x2354,
  :apl_functional_symbol_up_tack_jot => 0x2355,
  :apl_functional_symbol_downwards_vane => 0x2356,
  :apl_functional_symbol_quad_downwards_arrow => 0x2357,
  :apl_functional_symbol_quote_underbar => 0x2358,
  :apl_functional_symbol_delta_underbar => 0x2359,
  :apl_functional_symbol_diamond_underbar => 0x235a,
  :apl_functional_symbol_jot_underbar => 0x235b,
  :apl_functional_symbol_circle_underbar => 0x235c,
  :apl_functional_symbol_up_shoe_jot => 0x235d,
  :apl_functional_symbol_quote_quad => 0x235e,
  :apl_functional_symbol_circle_star => 0x235f,
  :apl_functional_symbol_quad_colon => 0x2360,
  :apl_functional_symbol_up_tack_diaeresis => 0x2361,
  :apl_functional_symbol_del_diaeresis => 0x2362,
  :apl_functional_symbol_star_diaeresis => 0x2363,
  :apl_functional_symbol_jot_diaeresis => 0x2364,
  :apl_functional_symbol_circle_diaeresis => 0x2365,
  :apl_functional_symbol_down_shoe_stile => 0x2366,
  :apl_functional_symbol_left_shoe_stile => 0x2367,
  :apl_functional_symbol_tilde_diaeresis => 0x2368,
  :apl_functional_symbol_greater_than_diaeresis => 0x2369,
  :apl_functional_symbol_comma_bar => 0x236a,
  :apl_functional_symbol_del_tilde => 0x236b,
  :apl_functional_symbol_zilde => 0x236c,
  :apl_functional_symbol_stile_tilde => 0x236d,
  :apl_functional_symbol_semicolon_underbar => 0x236e,
  :apl_functional_symbol_quad_not_equal => 0x236f,
  :apl_functional_symbol_quad_question => 0x2370,
  :apl_functional_symbol_down_caret_tilde => 0x2371,
  :apl_functional_symbol_up_caret_tilde => 0x2372,
  :apl_functional_symbol_iota => 0x2373,
  :apl_functional_symbol_rho => 0x2374,
  :apl_functional_symbol_omega => 0x2375,
  :apl_functional_symbol_alpha_underbar => 0x2376,
  :apl_functional_symbol_epsilon_underbar => 0x2377,
  :apl_functional_symbol_iota_underbar => 0x2378,
  :apl_functional_symbol_omega_underbar => 0x2379,
  :apl_functional_symbol_alpha => 0x237a,
  :not_check_mark => 0x237b,
  :right_angle_with_downwards_zigzag_arrow => 0x237c,
  :shouldered_open_box => 0x237d,
  :bell_symbol => 0x237e,
  :vertical_line_with_middle_dot => 0x237f,
  :insertion_symbol => 0x2380,
  :continuous_underline_symbol => 0x2381,
  :discontinuous_underline_symbol => 0x2382,
  :emphasis_symbol => 0x2383,
  :composition_symbol => 0x2384,
  :white_square_with_centre_vertical_line => 0x2385,
  :enter_symbol => 0x2386,
  :alternative_key_symbol => 0x2387,
  :helm_symbol => 0x2388,
  :circled_horizontal_bar_with_notch => 0x2389,
  :circled_triangle_down => 0x238a,
  :broken_circle_with_northwest_arrow => 0x238b,
  :undo_symbol => 0x238c,
  :monostable_symbol => 0x238d,
  :hysteresis_symbol => 0x238e,
  :open_circuit_output_h_type_symbol => 0x238f,
  :open_circuit_output_l_type_symbol => 0x2390,
  :passive_pull_down_output_symbol => 0x2391,
  :passive_pull_up_output_symbol => 0x2392,
  :direct_current_symbol_form_two => 0x2393,
  :software_function_symbol => 0x2394,
  :apl_functional_symbol_quad => 0x2395,
  :decimal_separator_key_symbol => 0x2396,
  :previous_page => 0x2397,
  :next_page => 0x2398,
  :print_screen_symbol => 0x2399,
  :clear_screen_symbol => 0x239a,
  :left_parenthesis_upper_hook => 0x239b,
  :left_parenthesis_extension => 0x239c,
  :left_parenthesis_lower_hook => 0x239d,
  :right_parenthesis_upper_hook => 0x239e,
  :right_parenthesis_extension => 0x239f,
  :right_parenthesis_lower_hook => 0x23a0,
  :left_square_bracket_upper_corner => 0x23a1,
  :left_square_bracket_extension => 0x23a2,
  :left_square_bracket_lower_corner => 0x23a3,
  :right_square_bracket_upper_corner => 0x23a4,
  :right_square_bracket_extension => 0x23a5,
  :right_square_bracket_lower_corner => 0x23a6,
  :left_curly_bracket_upper_hook => 0x23a7,
  :left_curly_bracket_middle_piece => 0x23a8,
  :left_curly_bracket_lower_hook => 0x23a9,
  :curly_bracket_extension => 0x23aa,
  :right_curly_bracket_upper_hook => 0x23ab,
  :right_curly_bracket_middle_piece => 0x23ac,
  :right_curly_bracket_lower_hook => 0x23ad,
  :integral_extension => 0x23ae,
  :horizontal_line_extension => 0x23af,
  :upper_left_or_lower_right_curly_bracket_section => 0x23b0,
  :upper_right_or_lower_left_curly_bracket_section => 0x23b1,
  :summation_top => 0x23b2,
  :summation_bottom => 0x23b3,
  :top_square_bracket => 0x23b4,
  :bottom_square_bracket => 0x23b5,
  :bottom_square_bracket_over_top_square_bracket => 0x23b6,
  :radical_symbol_bottom => 0x23b7,
  :left_vertical_box_line => 0x23b8,
  :right_vertical_box_line => 0x23b9,
  :horizontal_scan_line_1 => 0x23ba,
  :horizontal_scan_line_3 => 0x23bb,
  :horizontal_scan_line_7 => 0x23bc,
  :horizontal_scan_line_9 => 0x23bd,
  :dentistry_symbol_light_vertical_and_top_right => 0x23be,
  :dentistry_symbol_light_vertical_and_bottom_right => 0x23bf,
  :dentistry_symbol_light_vertical_with_circle => 0x23c0,
  :dentistry_symbol_light_down_and_horizontal_with_circle => 0x23c1,
  :dentistry_symbol_light_up_and_horizontal_with_circle => 0x23c2,
  :dentistry_symbol_light_vertical_with_triangle => 0x23c3,
  :dentistry_symbol_light_down_and_horizontal_with_triangle => 0x23c4,
  :dentistry_symbol_light_up_and_horizontal_with_triangle => 0x23c5,
  :dentistry_symbol_light_vertical_and_wave => 0x23c6,
  :dentistry_symbol_light_down_and_horizontal_with_wave => 0x23c7,
  :dentistry_symbol_light_up_and_horizontal_with_wave => 0x23c8,
  :dentistry_symbol_light_down_and_horizontal => 0x23c9,
  :dentistry_symbol_light_up_and_horizontal => 0x23ca,
  :dentistry_symbol_light_vertical_and_top_left => 0x23cb,
  :dentistry_symbol_light_vertical_and_bottom_left => 0x23cc,
  :square_foot => 0x23cd,
  :return_symbol => 0x23ce,
  :eject_symbol => 0x23cf,
  :vertical_line_extension => 0x23d0,
  :metrical_breve => 0x23d1,
  :metrical_long_over_short => 0x23d2,
  :metrical_short_over_long => 0x23d3,
  :metrical_long_over_two_shorts => 0x23d4,
  :metrical_two_shorts_over_long => 0x23d5,
  :metrical_two_shorts_joined => 0x23d6,
  :metrical_triseme => 0x23d7,
  :metrical_tetraseme => 0x23d8,
  :metrical_pentaseme => 0x23d9,
  :earth_ground => 0x23da,
  :fuse => 0x23db,
  :symbol_for_null => 0x2400,
  :graphic_for_null => 0x2400,
  :symbol_for_start_of_heading => 0x2401,
  :graphic_for_start_of_heading => 0x2401,
  :symbol_for_start_of_text => 0x2402,
  :graphic_for_start_of_text => 0x2402,
  :symbol_for_end_of_text => 0x2403,
  :graphic_for_end_of_text => 0x2403,
  :symbol_for_end_of_transmission => 0x2404,
  :graphic_for_end_of_transmission => 0x2404,
  :symbol_for_enquiry => 0x2405,
  :graphic_for_enquiry => 0x2405,
  :symbol_for_acknowledge => 0x2406,
  :graphic_for_acknowledge => 0x2406,
  :symbol_for_bell => 0x2407,
  :graphic_for_bell => 0x2407,
  :symbol_for_backspace => 0x2408,
  :graphic_for_backspace => 0x2408,
  :symbol_for_horizontal_tabulation => 0x2409,
  :graphic_for_horizontal_tabulation => 0x2409,
  :symbol_for_line_feed => 0x240a,
  :graphic_for_line_feed => 0x240a,
  :symbol_for_vertical_tabulation => 0x240b,
  :graphic_for_vertical_tabulation => 0x240b,
  :symbol_for_form_feed => 0x240c,
  :graphic_for_form_feed => 0x240c,
  :symbol_for_carriage_return => 0x240d,
  :graphic_for_carriage_return => 0x240d,
  :symbol_for_shift_out => 0x240e,
  :graphic_for_shift_out => 0x240e,
  :symbol_for_shift_in => 0x240f,
  :graphic_for_shift_in => 0x240f,
  :symbol_for_data_link_escape => 0x2410,
  :graphic_for_data_link_escape => 0x2410,
  :symbol_for_device_control_one => 0x2411,
  :graphic_for_device_control_one => 0x2411,
  :symbol_for_device_control_two => 0x2412,
  :graphic_for_device_control_two => 0x2412,
  :symbol_for_device_control_three => 0x2413,
  :graphic_for_device_control_three => 0x2413,
  :symbol_for_device_control_four => 0x2414,
  :graphic_for_device_control_four => 0x2414,
  :symbol_for_negative_acknowledge => 0x2415,
  :graphic_for_negative_acknowledge => 0x2415,
  :symbol_for_synchronous_idle => 0x2416,
  :graphic_for_synchronous_idle => 0x2416,
  :symbol_for_end_of_transmission_block => 0x2417,
  :graphic_for_end_of_transmission_block => 0x2417,
  :symbol_for_cancel => 0x2418,
  :graphic_for_cancel => 0x2418,
  :symbol_for_end_of_medium => 0x2419,
  :graphic_for_end_of_medium => 0x2419,
  :symbol_for_substitute => 0x241a,
  :graphic_for_substitute => 0x241a,
  :symbol_for_escape => 0x241b,
  :graphic_for_escape => 0x241b,
  :symbol_for_file_separator => 0x241c,
  :graphic_for_file_separator => 0x241c,
  :symbol_for_group_separator => 0x241d,
  :graphic_for_group_separator => 0x241d,
  :symbol_for_record_separator => 0x241e,
  :graphic_for_record_separator => 0x241e,
  :symbol_for_unit_separator => 0x241f,
  :graphic_for_unit_separator => 0x241f,
  :symbol_for_space => 0x2420,
  :graphic_for_space => 0x2420,
  :symbol_for_delete => 0x2421,
  :graphic_for_delete => 0x2421,
  :blank_symbol => 0x2422,
  :blank => 0x2422,
  :open_box => 0x2423,
  :symbol_for_newline => 0x2424,
  :graphic_for_newline => 0x2424,
  :symbol_for_delete_form_two => 0x2425,
  :symbol_for_substitute_form_two => 0x2426,
  :ocr_hook => 0x2440,
  :ocr_chair => 0x2441,
  :ocr_fork => 0x2442,
  :ocr_inverted_fork => 0x2443,
  :ocr_belt_buckle => 0x2444,
  :ocr_bow_tie => 0x2445,
  :ocr_branch_bank_identification => 0x2446,
  :ocr_amount_of_check => 0x2447,
  :ocr_dash => 0x2448,
  :ocr_customer_account_number => 0x2449,
  :ocr_double_backslash => 0x244a,
  :circled_digit_one => 0x2460,
  :circled_digit_two => 0x2461,
  :circled_digit_three => 0x2462,
  :circled_digit_four => 0x2463,
  :circled_digit_five => 0x2464,
  :circled_digit_six => 0x2465,
  :circled_digit_seven => 0x2466,
  :circled_digit_eight => 0x2467,
  :circled_digit_nine => 0x2468,
  :circled_number_ten => 0x2469,
  :circled_number_eleven => 0x246a,
  :circled_number_twelve => 0x246b,
  :circled_number_thirteen => 0x246c,
  :circled_number_fourteen => 0x246d,
  :circled_number_fifteen => 0x246e,
  :circled_number_sixteen => 0x246f,
  :circled_number_seventeen => 0x2470,
  :circled_number_eighteen => 0x2471,
  :circled_number_nineteen => 0x2472,
  :circled_number_twenty => 0x2473,
  :parenthesized_digit_one => 0x2474,
  :parenthesized_digit_two => 0x2475,
  :parenthesized_digit_three => 0x2476,
  :parenthesized_digit_four => 0x2477,
  :parenthesized_digit_five => 0x2478,
  :parenthesized_digit_six => 0x2479,
  :parenthesized_digit_seven => 0x247a,
  :parenthesized_digit_eight => 0x247b,
  :parenthesized_digit_nine => 0x247c,
  :parenthesized_number_ten => 0x247d,
  :parenthesized_number_eleven => 0x247e,
  :parenthesized_number_twelve => 0x247f,
  :parenthesized_number_thirteen => 0x2480,
  :parenthesized_number_fourteen => 0x2481,
  :parenthesized_number_fifteen => 0x2482,
  :parenthesized_number_sixteen => 0x2483,
  :parenthesized_number_seventeen => 0x2484,
  :parenthesized_number_eighteen => 0x2485,
  :parenthesized_number_nineteen => 0x2486,
  :parenthesized_number_twenty => 0x2487,
  :digit_one_full_stop => 0x2488,
  :digit_one_period => 0x2488,
  :digit_two_full_stop => 0x2489,
  :digit_two_period => 0x2489,
  :digit_three_full_stop => 0x248a,
  :digit_three_period => 0x248a,
  :digit_four_full_stop => 0x248b,
  :digit_four_period => 0x248b,
  :digit_five_full_stop => 0x248c,
  :digit_five_period => 0x248c,
  :digit_six_full_stop => 0x248d,
  :digit_six_period => 0x248d,
  :digit_seven_full_stop => 0x248e,
  :digit_seven_period => 0x248e,
  :digit_eight_full_stop => 0x248f,
  :digit_eight_period => 0x248f,
  :digit_nine_full_stop => 0x2490,
  :digit_nine_period => 0x2490,
  :number_ten_full_stop => 0x2491,
  :number_ten_period => 0x2491,
  :number_eleven_full_stop => 0x2492,
  :number_eleven_period => 0x2492,
  :number_twelve_full_stop => 0x2493,
  :number_twelve_period => 0x2493,
  :number_thirteen_full_stop => 0x2494,
  :number_thirteen_period => 0x2494,
  :number_fourteen_full_stop => 0x2495,
  :number_fourteen_period => 0x2495,
  :number_fifteen_full_stop => 0x2496,
  :number_fifteen_period => 0x2496,
  :number_sixteen_full_stop => 0x2497,
  :number_sixteen_period => 0x2497,
  :number_seventeen_full_stop => 0x2498,
  :number_seventeen_period => 0x2498,
  :number_eighteen_full_stop => 0x2499,
  :number_eighteen_period => 0x2499,
  :number_nineteen_full_stop => 0x249a,
  :number_nineteen_period => 0x249a,
  :number_twenty_full_stop => 0x249b,
  :number_twenty_period => 0x249b,
  :parenthesized_latin_small_letter_a => 0x249c,
  :parenthesized_latin_small_letter_b => 0x249d,
  :parenthesized_latin_small_letter_c => 0x249e,
  :parenthesized_latin_small_letter_d => 0x249f,
  :parenthesized_latin_small_letter_e => 0x24a0,
  :parenthesized_latin_small_letter_f => 0x24a1,
  :parenthesized_latin_small_letter_g => 0x24a2,
  :parenthesized_latin_small_letter_h => 0x24a3,
  :parenthesized_latin_small_letter_i => 0x24a4,
  :parenthesized_latin_small_letter_j => 0x24a5,
  :parenthesized_latin_small_letter_k => 0x24a6,
  :parenthesized_latin_small_letter_l => 0x24a7,
  :parenthesized_latin_small_letter_m => 0x24a8,
  :parenthesized_latin_small_letter_n => 0x24a9,
  :parenthesized_latin_small_letter_o => 0x24aa,
  :parenthesized_latin_small_letter_p => 0x24ab,
  :parenthesized_latin_small_letter_q => 0x24ac,
  :parenthesized_latin_small_letter_r => 0x24ad,
  :parenthesized_latin_small_letter_s => 0x24ae,
  :parenthesized_latin_small_letter_t => 0x24af,
  :parenthesized_latin_small_letter_u => 0x24b0,
  :parenthesized_latin_small_letter_v => 0x24b1,
  :parenthesized_latin_small_letter_w => 0x24b2,
  :parenthesized_latin_small_letter_x => 0x24b3,
  :parenthesized_latin_small_letter_y => 0x24b4,
  :parenthesized_latin_small_letter_z => 0x24b5,
  :circled_latin_capital_letter_a => 0x24b6,
  :circled_latin_capital_letter_b => 0x24b7,
  :circled_latin_capital_letter_c => 0x24b8,
  :circled_latin_capital_letter_d => 0x24b9,
  :circled_latin_capital_letter_e => 0x24ba,
  :circled_latin_capital_letter_f => 0x24bb,
  :circled_latin_capital_letter_g => 0x24bc,
  :circled_latin_capital_letter_h => 0x24bd,
  :circled_latin_capital_letter_i => 0x24be,
  :circled_latin_capital_letter_j => 0x24bf,
  :circled_latin_capital_letter_k => 0x24c0,
  :circled_latin_capital_letter_l => 0x24c1,
  :circled_latin_capital_letter_m => 0x24c2,
  :circled_latin_capital_letter_n => 0x24c3,
  :circled_latin_capital_letter_o => 0x24c4,
  :circled_latin_capital_letter_p => 0x24c5,
  :circled_latin_capital_letter_q => 0x24c6,
  :circled_latin_capital_letter_r => 0x24c7,
  :circled_latin_capital_letter_s => 0x24c8,
  :circled_latin_capital_letter_t => 0x24c9,
  :circled_latin_capital_letter_u => 0x24ca,
  :circled_latin_capital_letter_v => 0x24cb,
  :circled_latin_capital_letter_w => 0x24cc,
  :circled_latin_capital_letter_x => 0x24cd,
  :circled_latin_capital_letter_y => 0x24ce,
  :circled_latin_capital_letter_z => 0x24cf,
  :circled_latin_small_letter_a => 0x24d0,
  :circled_latin_small_letter_b => 0x24d1,
  :circled_latin_small_letter_c => 0x24d2,
  :circled_latin_small_letter_d => 0x24d3,
  :circled_latin_small_letter_e => 0x24d4,
  :circled_latin_small_letter_f => 0x24d5,
  :circled_latin_small_letter_g => 0x24d6,
  :circled_latin_small_letter_h => 0x24d7,
  :circled_latin_small_letter_i => 0x24d8,
  :circled_latin_small_letter_j => 0x24d9,
  :circled_latin_small_letter_k => 0x24da,
  :circled_latin_small_letter_l => 0x24db,
  :circled_latin_small_letter_m => 0x24dc,
  :circled_latin_small_letter_n => 0x24dd,
  :circled_latin_small_letter_o => 0x24de,
  :circled_latin_small_letter_p => 0x24df,
  :circled_latin_small_letter_q => 0x24e0,
  :circled_latin_small_letter_r => 0x24e1,
  :circled_latin_small_letter_s => 0x24e2,
  :circled_latin_small_letter_t => 0x24e3,
  :circled_latin_small_letter_u => 0x24e4,
  :circled_latin_small_letter_v => 0x24e5,
  :circled_latin_small_letter_w => 0x24e6,
  :circled_latin_small_letter_x => 0x24e7,
  :circled_latin_small_letter_y => 0x24e8,
  :circled_latin_small_letter_z => 0x24e9,
  :circled_digit_zero => 0x24ea,
  :negative_circled_number_eleven => 0x24eb,
  :negative_circled_number_twelve => 0x24ec,
  :negative_circled_number_thirteen => 0x24ed,
  :negative_circled_number_fourteen => 0x24ee,
  :negative_circled_number_fifteen => 0x24ef,
  :negative_circled_number_sixteen => 0x24f0,
  :negative_circled_number_seventeen => 0x24f1,
  :negative_circled_number_eighteen => 0x24f2,
  :negative_circled_number_nineteen => 0x24f3,
  :negative_circled_number_twenty => 0x24f4,
  :double_circled_digit_one => 0x24f5,
  :double_circled_digit_two => 0x24f6,
  :double_circled_digit_three => 0x24f7,
  :double_circled_digit_four => 0x24f8,
  :double_circled_digit_five => 0x24f9,
  :double_circled_digit_six => 0x24fa,
  :double_circled_digit_seven => 0x24fb,
  :double_circled_digit_eight => 0x24fc,
  :double_circled_digit_nine => 0x24fd,
  :double_circled_number_ten => 0x24fe,
  :negative_circled_digit_zero => 0x24ff,
  :box_drawings_light_horizontal => 0x2500,
  :forms_light_horizontal => 0x2500,
  :box_drawings_heavy_horizontal => 0x2501,
  :forms_heavy_horizontal => 0x2501,
  :box_drawings_light_vertical => 0x2502,
  :forms_light_vertical => 0x2502,
  :box_drawings_heavy_vertical => 0x2503,
  :forms_heavy_vertical => 0x2503,
  :box_drawings_light_triple_dash_horizontal => 0x2504,
  :forms_light_triple_dash_horizontal => 0x2504,
  :box_drawings_heavy_triple_dash_horizontal => 0x2505,
  :forms_heavy_triple_dash_horizontal => 0x2505,
  :box_drawings_light_triple_dash_vertical => 0x2506,
  :forms_light_triple_dash_vertical => 0x2506,
  :box_drawings_heavy_triple_dash_vertical => 0x2507,
  :forms_heavy_triple_dash_vertical => 0x2507,
  :box_drawings_light_quadruple_dash_horizontal => 0x2508,
  :forms_light_quadruple_dash_horizontal => 0x2508,
  :box_drawings_heavy_quadruple_dash_horizontal => 0x2509,
  :forms_heavy_quadruple_dash_horizontal => 0x2509,
  :box_drawings_light_quadruple_dash_vertical => 0x250a,
  :forms_light_quadruple_dash_vertical => 0x250a,
  :box_drawings_heavy_quadruple_dash_vertical => 0x250b,
  :forms_heavy_quadruple_dash_vertical => 0x250b,
  :box_drawings_light_down_and_right => 0x250c,
  :forms_light_down_and_right => 0x250c,
  :box_drawings_down_light_and_right_heavy => 0x250d,
  :forms_down_light_and_right_heavy => 0x250d,
  :box_drawings_down_heavy_and_right_light => 0x250e,
  :forms_down_heavy_and_right_light => 0x250e,
  :box_drawings_heavy_down_and_right => 0x250f,
  :forms_heavy_down_and_right => 0x250f,
  :box_drawings_light_down_and_left => 0x2510,
  :forms_light_down_and_left => 0x2510,
  :box_drawings_down_light_and_left_heavy => 0x2511,
  :forms_down_light_and_left_heavy => 0x2511,
  :box_drawings_down_heavy_and_left_light => 0x2512,
  :forms_down_heavy_and_left_light => 0x2512,
  :box_drawings_heavy_down_and_left => 0x2513,
  :forms_heavy_down_and_left => 0x2513,
  :box_drawings_light_up_and_right => 0x2514,
  :forms_light_up_and_right => 0x2514,
  :box_drawings_up_light_and_right_heavy => 0x2515,
  :forms_up_light_and_right_heavy => 0x2515,
  :box_drawings_up_heavy_and_right_light => 0x2516,
  :forms_up_heavy_and_right_light => 0x2516,
  :box_drawings_heavy_up_and_right => 0x2517,
  :forms_heavy_up_and_right => 0x2517,
  :box_drawings_light_up_and_left => 0x2518,
  :forms_light_up_and_left => 0x2518,
  :box_drawings_up_light_and_left_heavy => 0x2519,
  :forms_up_light_and_left_heavy => 0x2519,
  :box_drawings_up_heavy_and_left_light => 0x251a,
  :forms_up_heavy_and_left_light => 0x251a,
  :box_drawings_heavy_up_and_left => 0x251b,
  :forms_heavy_up_and_left => 0x251b,
  :box_drawings_light_vertical_and_right => 0x251c,
  :forms_light_vertical_and_right => 0x251c,
  :box_drawings_vertical_light_and_right_heavy => 0x251d,
  :forms_vertical_light_and_right_heavy => 0x251d,
  :box_drawings_up_heavy_and_right_down_light => 0x251e,
  :forms_up_heavy_and_right_down_light => 0x251e,
  :box_drawings_down_heavy_and_right_up_light => 0x251f,
  :forms_down_heavy_and_right_up_light => 0x251f,
  :box_drawings_vertical_heavy_and_right_light => 0x2520,
  :forms_vertical_heavy_and_right_light => 0x2520,
  :box_drawings_down_light_and_right_up_heavy => 0x2521,
  :forms_down_light_and_right_up_heavy => 0x2521,
  :box_drawings_up_light_and_right_down_heavy => 0x2522,
  :forms_up_light_and_right_down_heavy => 0x2522,
  :box_drawings_heavy_vertical_and_right => 0x2523,
  :forms_heavy_vertical_and_right => 0x2523,
  :box_drawings_light_vertical_and_left => 0x2524,
  :forms_light_vertical_and_left => 0x2524,
  :box_drawings_vertical_light_and_left_heavy => 0x2525,
  :forms_vertical_light_and_left_heavy => 0x2525,
  :box_drawings_up_heavy_and_left_down_light => 0x2526,
  :forms_up_heavy_and_left_down_light => 0x2526,
  :box_drawings_down_heavy_and_left_up_light => 0x2527,
  :forms_down_heavy_and_left_up_light => 0x2527,
  :box_drawings_vertical_heavy_and_left_light => 0x2528,
  :forms_vertical_heavy_and_left_light => 0x2528,
  :box_drawings_down_light_and_left_up_heavy => 0x2529,
  :forms_down_light_and_left_up_heavy => 0x2529,
  :box_drawings_up_light_and_left_down_heavy => 0x252a,
  :forms_up_light_and_left_down_heavy => 0x252a,
  :box_drawings_heavy_vertical_and_left => 0x252b,
  :forms_heavy_vertical_and_left => 0x252b,
  :box_drawings_light_down_and_horizontal => 0x252c,
  :forms_light_down_and_horizontal => 0x252c,
  :box_drawings_left_heavy_and_right_down_light => 0x252d,
  :forms_left_heavy_and_right_down_light => 0x252d,
  :box_drawings_right_heavy_and_left_down_light => 0x252e,
  :forms_right_heavy_and_left_down_light => 0x252e,
  :box_drawings_down_light_and_horizontal_heavy => 0x252f,
  :forms_down_light_and_horizontal_heavy => 0x252f,
  :box_drawings_down_heavy_and_horizontal_light => 0x2530,
  :forms_down_heavy_and_horizontal_light => 0x2530,
  :box_drawings_right_light_and_left_down_heavy => 0x2531,
  :forms_right_light_and_left_down_heavy => 0x2531,
  :box_drawings_left_light_and_right_down_heavy => 0x2532,
  :forms_left_light_and_right_down_heavy => 0x2532,
  :box_drawings_heavy_down_and_horizontal => 0x2533,
  :forms_heavy_down_and_horizontal => 0x2533,
  :box_drawings_light_up_and_horizontal => 0x2534,
  :forms_light_up_and_horizontal => 0x2534,
  :box_drawings_left_heavy_and_right_up_light => 0x2535,
  :forms_left_heavy_and_right_up_light => 0x2535,
  :box_drawings_right_heavy_and_left_up_light => 0x2536,
  :forms_right_heavy_and_left_up_light => 0x2536,
  :box_drawings_up_light_and_horizontal_heavy => 0x2537,
  :forms_up_light_and_horizontal_heavy => 0x2537,
  :box_drawings_up_heavy_and_horizontal_light => 0x2538,
  :forms_up_heavy_and_horizontal_light => 0x2538,
  :box_drawings_right_light_and_left_up_heavy => 0x2539,
  :forms_right_light_and_left_up_heavy => 0x2539,
  :box_drawings_left_light_and_right_up_heavy => 0x253a,
  :forms_left_light_and_right_up_heavy => 0x253a,
  :box_drawings_heavy_up_and_horizontal => 0x253b,
  :forms_heavy_up_and_horizontal => 0x253b,
  :box_drawings_light_vertical_and_horizontal => 0x253c,
  :forms_light_vertical_and_horizontal => 0x253c,
  :box_drawings_left_heavy_and_right_vertical_light => 0x253d,
  :forms_left_heavy_and_right_vertical_light => 0x253d,
  :box_drawings_right_heavy_and_left_vertical_light => 0x253e,
  :forms_right_heavy_and_left_vertical_light => 0x253e,
  :box_drawings_vertical_light_and_horizontal_heavy => 0x253f,
  :forms_vertical_light_and_horizontal_heavy => 0x253f,
  :box_drawings_up_heavy_and_down_horizontal_light => 0x2540,
  :forms_up_heavy_and_down_horizontal_light => 0x2540,
  :box_drawings_down_heavy_and_up_horizontal_light => 0x2541,
  :forms_down_heavy_and_up_horizontal_light => 0x2541,
  :box_drawings_vertical_heavy_and_horizontal_light => 0x2542,
  :forms_vertical_heavy_and_horizontal_light => 0x2542,
  :box_drawings_left_up_heavy_and_right_down_light => 0x2543,
  :forms_left_up_heavy_and_right_down_light => 0x2543,
  :box_drawings_right_up_heavy_and_left_down_light => 0x2544,
  :forms_right_up_heavy_and_left_down_light => 0x2544,
  :box_drawings_left_down_heavy_and_right_up_light => 0x2545,
  :forms_left_down_heavy_and_right_up_light => 0x2545,
  :box_drawings_right_down_heavy_and_left_up_light => 0x2546,
  :forms_right_down_heavy_and_left_up_light => 0x2546,
  :box_drawings_down_light_and_up_horizontal_heavy => 0x2547,
  :forms_down_light_and_up_horizontal_heavy => 0x2547,
  :box_drawings_up_light_and_down_horizontal_heavy => 0x2548,
  :forms_up_light_and_down_horizontal_heavy => 0x2548,
  :box_drawings_right_light_and_left_vertical_heavy => 0x2549,
  :forms_right_light_and_left_vertical_heavy => 0x2549,
  :box_drawings_left_light_and_right_vertical_heavy => 0x254a,
  :forms_left_light_and_right_vertical_heavy => 0x254a,
  :box_drawings_heavy_vertical_and_horizontal => 0x254b,
  :forms_heavy_vertical_and_horizontal => 0x254b,
  :box_drawings_light_double_dash_horizontal => 0x254c,
  :forms_light_double_dash_horizontal => 0x254c,
  :box_drawings_heavy_double_dash_horizontal => 0x254d,
  :forms_heavy_double_dash_horizontal => 0x254d,
  :box_drawings_light_double_dash_vertical => 0x254e,
  :forms_light_double_dash_vertical => 0x254e,
  :box_drawings_heavy_double_dash_vertical => 0x254f,
  :forms_heavy_double_dash_vertical => 0x254f,
  :box_drawings_double_horizontal => 0x2550,
  :forms_double_horizontal => 0x2550,
  :box_drawings_double_vertical => 0x2551,
  :forms_double_vertical => 0x2551,
  :box_drawings_down_single_and_right_double => 0x2552,
  :forms_down_single_and_right_double => 0x2552,
  :box_drawings_down_double_and_right_single => 0x2553,
  :forms_down_double_and_right_single => 0x2553,
  :box_drawings_double_down_and_right => 0x2554,
  :forms_double_down_and_right => 0x2554,
  :box_drawings_down_single_and_left_double => 0x2555,
  :forms_down_single_and_left_double => 0x2555,
  :box_drawings_down_double_and_left_single => 0x2556,
  :forms_down_double_and_left_single => 0x2556,
  :box_drawings_double_down_and_left => 0x2557,
  :forms_double_down_and_left => 0x2557,
  :box_drawings_up_single_and_right_double => 0x2558,
  :forms_up_single_and_right_double => 0x2558,
  :box_drawings_up_double_and_right_single => 0x2559,
  :forms_up_double_and_right_single => 0x2559,
  :box_drawings_double_up_and_right => 0x255a,
  :forms_double_up_and_right => 0x255a,
  :box_drawings_up_single_and_left_double => 0x255b,
  :forms_up_single_and_left_double => 0x255b,
  :box_drawings_up_double_and_left_single => 0x255c,
  :forms_up_double_and_left_single => 0x255c,
  :box_drawings_double_up_and_left => 0x255d,
  :forms_double_up_and_left => 0x255d,
  :box_drawings_vertical_single_and_right_double => 0x255e,
  :forms_vertical_single_and_right_double => 0x255e,
  :box_drawings_vertical_double_and_right_single => 0x255f,
  :forms_vertical_double_and_right_single => 0x255f,
  :box_drawings_double_vertical_and_right => 0x2560,
  :forms_double_vertical_and_right => 0x2560,
  :box_drawings_vertical_single_and_left_double => 0x2561,
  :forms_vertical_single_and_left_double => 0x2561,
  :box_drawings_vertical_double_and_left_single => 0x2562,
  :forms_vertical_double_and_left_single => 0x2562,
  :box_drawings_double_vertical_and_left => 0x2563,
  :forms_double_vertical_and_left => 0x2563,
  :box_drawings_down_single_and_horizontal_double => 0x2564,
  :forms_down_single_and_horizontal_double => 0x2564,
  :box_drawings_down_double_and_horizontal_single => 0x2565,
  :forms_down_double_and_horizontal_single => 0x2565,
  :box_drawings_double_down_and_horizontal => 0x2566,
  :forms_double_down_and_horizontal => 0x2566,
  :box_drawings_up_single_and_horizontal_double => 0x2567,
  :forms_up_single_and_horizontal_double => 0x2567,
  :box_drawings_up_double_and_horizontal_single => 0x2568,
  :forms_up_double_and_horizontal_single => 0x2568,
  :box_drawings_double_up_and_horizontal => 0x2569,
  :forms_double_up_and_horizontal => 0x2569,
  :box_drawings_vertical_single_and_horizontal_double => 0x256a,
  :forms_vertical_single_and_horizontal_double => 0x256a,
  :box_drawings_vertical_double_and_horizontal_single => 0x256b,
  :forms_vertical_double_and_horizontal_single => 0x256b,
  :box_drawings_double_vertical_and_horizontal => 0x256c,
  :forms_double_vertical_and_horizontal => 0x256c,
  :box_drawings_light_arc_down_and_right => 0x256d,
  :forms_light_arc_down_and_right => 0x256d,
  :box_drawings_light_arc_down_and_left => 0x256e,
  :forms_light_arc_down_and_left => 0x256e,
  :box_drawings_light_arc_up_and_left => 0x256f,
  :forms_light_arc_up_and_left => 0x256f,
  :box_drawings_light_arc_up_and_right => 0x2570,
  :forms_light_arc_up_and_right => 0x2570,
  :box_drawings_light_diagonal_upper_right_to_lower_left => 0x2571,
  :forms_light_diagonal_upper_right_to_lower_left => 0x2571,
  :box_drawings_light_diagonal_upper_left_to_lower_right => 0x2572,
  :forms_light_diagonal_upper_left_to_lower_right => 0x2572,
  :box_drawings_light_diagonal_cross => 0x2573,
  :forms_light_diagonal_cross => 0x2573,
  :box_drawings_light_left => 0x2574,
  :forms_light_left => 0x2574,
  :box_drawings_light_up => 0x2575,
  :forms_light_up => 0x2575,
  :box_drawings_light_right => 0x2576,
  :forms_light_right => 0x2576,
  :box_drawings_light_down => 0x2577,
  :forms_light_down => 0x2577,
  :box_drawings_heavy_left => 0x2578,
  :forms_heavy_left => 0x2578,
  :box_drawings_heavy_up => 0x2579,
  :forms_heavy_up => 0x2579,
  :box_drawings_heavy_right => 0x257a,
  :forms_heavy_right => 0x257a,
  :box_drawings_heavy_down => 0x257b,
  :forms_heavy_down => 0x257b,
  :box_drawings_light_left_and_heavy_right => 0x257c,
  :forms_light_left_and_heavy_right => 0x257c,
  :box_drawings_light_up_and_heavy_down => 0x257d,
  :forms_light_up_and_heavy_down => 0x257d,
  :box_drawings_heavy_left_and_light_right => 0x257e,
  :forms_heavy_left_and_light_right => 0x257e,
  :box_drawings_heavy_up_and_light_down => 0x257f,
  :forms_heavy_up_and_light_down => 0x257f,
  :upper_half_block => 0x2580,
  :lower_one_eighth_block => 0x2581,
  :lower_one_quarter_block => 0x2582,
  :lower_three_eighths_block => 0x2583,
  :lower_half_block => 0x2584,
  :lower_five_eighths_block => 0x2585,
  :lower_three_quarters_block => 0x2586,
  :lower_three_quarter_block => 0x2586,
  :lower_seven_eighths_block => 0x2587,
  :full_block => 0x2588,
  :left_seven_eighths_block => 0x2589,
  :left_three_quarters_block => 0x258a,
  :left_three_quarter_block => 0x258a,
  :left_five_eighths_block => 0x258b,
  :left_half_block => 0x258c,
  :left_three_eighths_block => 0x258d,
  :left_one_quarter_block => 0x258e,
  :left_one_eighth_block => 0x258f,
  :right_half_block => 0x2590,
  :light_shade => 0x2591,
  :medium_shade => 0x2592,
  :dark_shade => 0x2593,
  :upper_one_eighth_block => 0x2594,
  :right_one_eighth_block => 0x2595,
  :quadrant_lower_left => 0x2596,
  :quadrant_lower_right => 0x2597,
  :quadrant_upper_left => 0x2598,
  :quadrant_upper_left_and_lower_left_and_lower_right => 0x2599,
  :quadrant_upper_left_and_lower_right => 0x259a,
  :quadrant_upper_left_and_upper_right_and_lower_left => 0x259b,
  :quadrant_upper_left_and_upper_right_and_lower_right => 0x259c,
  :quadrant_upper_right => 0x259d,
  :quadrant_upper_right_and_lower_left => 0x259e,
  :quadrant_upper_right_and_lower_left_and_lower_right => 0x259f,
  :black_square => 0x25a0,
  :white_square => 0x25a1,
  :white_square_with_rounded_corners => 0x25a2,
  :white_square_containing_black_small_square => 0x25a3,
  :square_with_horizontal_fill => 0x25a4,
  :square_with_vertical_fill => 0x25a5,
  :square_with_orthogonal_crosshatch_fill => 0x25a6,
  :square_with_upper_left_to_lower_right_fill => 0x25a7,
  :square_with_upper_right_to_lower_left_fill => 0x25a8,
  :square_with_diagonal_crosshatch_fill => 0x25a9,
  :black_small_square => 0x25aa,
  :white_small_square => 0x25ab,
  :black_rectangle => 0x25ac,
  :white_rectangle => 0x25ad,
  :black_vertical_rectangle => 0x25ae,
  :white_vertical_rectangle => 0x25af,
  :black_parallelogram => 0x25b0,
  :white_parallelogram => 0x25b1,
  :black_up_pointing_triangle => 0x25b2,
  :black_up_pointing_triangle => 0x25b2,
  :white_up_pointing_triangle => 0x25b3,
  :white_up_pointing_triangle => 0x25b3,
  :black_up_pointing_small_triangle => 0x25b4,
  :black_up_pointing_small_triangle => 0x25b4,
  :white_up_pointing_small_triangle => 0x25b5,
  :white_up_pointing_small_triangle => 0x25b5,
  :black_right_pointing_triangle => 0x25b6,
  :black_right_pointing_triangle => 0x25b6,
  :white_right_pointing_triangle => 0x25b7,
  :white_right_pointing_triangle => 0x25b7,
  :black_right_pointing_small_triangle => 0x25b8,
  :black_right_pointing_small_triangle => 0x25b8,
  :white_right_pointing_small_triangle => 0x25b9,
  :white_right_pointing_small_triangle => 0x25b9,
  :black_right_pointing_pointer => 0x25ba,
  :black_right_pointing_pointer => 0x25ba,
  :white_right_pointing_pointer => 0x25bb,
  :white_right_pointing_pointer => 0x25bb,
  :black_down_pointing_triangle => 0x25bc,
  :black_down_pointing_triangle => 0x25bc,
  :white_down_pointing_triangle => 0x25bd,
  :white_down_pointing_triangle => 0x25bd,
  :black_down_pointing_small_triangle => 0x25be,
  :black_down_pointing_small_triangle => 0x25be,
  :white_down_pointing_small_triangle => 0x25bf,
  :white_down_pointing_small_triangle => 0x25bf,
  :black_left_pointing_triangle => 0x25c0,
  :black_left_pointing_triangle => 0x25c0,
  :white_left_pointing_triangle => 0x25c1,
  :white_left_pointing_triangle => 0x25c1,
  :black_left_pointing_small_triangle => 0x25c2,
  :black_left_pointing_small_triangle => 0x25c2,
  :white_left_pointing_small_triangle => 0x25c3,
  :white_left_pointing_small_triangle => 0x25c3,
  :black_left_pointing_pointer => 0x25c4,
  :black_left_pointing_pointer => 0x25c4,
  :white_left_pointing_pointer => 0x25c5,
  :white_left_pointing_pointer => 0x25c5,
  :black_diamond => 0x25c6,
  :white_diamond => 0x25c7,
  :white_diamond_containing_black_small_diamond => 0x25c8,
  :fisheye => 0x25c9,
  :lozenge => 0x25ca,
  :white_circle => 0x25cb,
  :dotted_circle => 0x25cc,
  :circle_with_vertical_fill => 0x25cd,
  :bullseye => 0x25ce,
  :black_circle => 0x25cf,
  :circle_with_left_half_black => 0x25d0,
  :circle_with_right_half_black => 0x25d1,
  :circle_with_lower_half_black => 0x25d2,
  :circle_with_upper_half_black => 0x25d3,
  :circle_with_upper_right_quadrant_black => 0x25d4,
  :circle_with_all_but_upper_left_quadrant_black => 0x25d5,
  :left_half_black_circle => 0x25d6,
  :right_half_black_circle => 0x25d7,
  :inverse_bullet => 0x25d8,
  :inverse_white_circle => 0x25d9,
  :upper_half_inverse_white_circle => 0x25da,
  :lower_half_inverse_white_circle => 0x25db,
  :upper_left_quadrant_circular_arc => 0x25dc,
  :upper_right_quadrant_circular_arc => 0x25dd,
  :lower_right_quadrant_circular_arc => 0x25de,
  :lower_left_quadrant_circular_arc => 0x25df,
  :upper_half_circle => 0x25e0,
  :lower_half_circle => 0x25e1,
  :black_lower_right_triangle => 0x25e2,
  :black_lower_left_triangle => 0x25e3,
  :black_upper_left_triangle => 0x25e4,
  :black_upper_right_triangle => 0x25e5,
  :white_bullet => 0x25e6,
  :square_with_left_half_black => 0x25e7,
  :square_with_right_half_black => 0x25e8,
  :square_with_upper_left_diagonal_half_black => 0x25e9,
  :square_with_lower_right_diagonal_half_black => 0x25ea,
  :white_square_with_vertical_bisecting_line => 0x25eb,
  :white_up_pointing_triangle_with_dot => 0x25ec,
  :white_up_pointing_triangle_with_dot => 0x25ec,
  :up_pointing_triangle_with_left_half_black => 0x25ed,
  :up_pointing_triangle_with_left_half_black => 0x25ed,
  :up_pointing_triangle_with_right_half_black => 0x25ee,
  :up_pointing_triangle_with_right_half_black => 0x25ee,
  :large_circle => 0x25ef,
  :white_square_with_upper_left_quadrant => 0x25f0,
  :white_square_with_lower_left_quadrant => 0x25f1,
  :white_square_with_lower_right_quadrant => 0x25f2,
  :white_square_with_upper_right_quadrant => 0x25f3,
  :white_circle_with_upper_left_quadrant => 0x25f4,
  :white_circle_with_lower_left_quadrant => 0x25f5,
  :white_circle_with_lower_right_quadrant => 0x25f6,
  :white_circle_with_upper_right_quadrant => 0x25f7,
  :upper_left_triangle => 0x25f8,
  :upper_right_triangle => 0x25f9,
  :lower_left_triangle => 0x25fa,
  :white_medium_square => 0x25fb,
  :black_medium_square => 0x25fc,
  :white_medium_small_square => 0x25fd,
  :black_medium_small_square => 0x25fe,
  :lower_right_triangle => 0x25ff,
  :black_sun_with_rays => 0x2600,
  :cloud => 0x2601,
  :umbrella => 0x2602,
  :snowman => 0x2603,
  :comet => 0x2604,
  :black_star => 0x2605,
  :white_star => 0x2606,
  :lightning => 0x2607,
  :thunderstorm => 0x2608,
  :sun => 0x2609,
  :ascending_node => 0x260a,
  :descending_node => 0x260b,
  :conjunction => 0x260c,
  :opposition => 0x260d,
  :black_telephone => 0x260e,
  :white_telephone => 0x260f,
  :ballot_box => 0x2610,
  :ballot_box_with_check => 0x2611,
  :ballot_box_with_x => 0x2612,
  :saltire => 0x2613,
  :umbrella_with_rain_drops => 0x2614,
  :hot_beverage => 0x2615,
  :white_shogi_piece => 0x2616,
  :black_shogi_piece => 0x2617,
  :shamrock => 0x2618,
  :reversed_rotated_floral_heart_bullet => 0x2619,
  :black_left_pointing_index => 0x261a,
  :black_right_pointing_index => 0x261b,
  :white_left_pointing_index => 0x261c,
  :white_up_pointing_index => 0x261d,
  :white_right_pointing_index => 0x261e,
  :white_down_pointing_index => 0x261f,
  :skull_and_crossbones => 0x2620,
  :caution_sign => 0x2621,
  :radioactive_sign => 0x2622,
  :biohazard_sign => 0x2623,
  :caduceus => 0x2624,
  :ankh => 0x2625,
  :orthodox_cross => 0x2626,
  :chi_rho => 0x2627,
  :cross_of_lorraine => 0x2628,
  :cross_of_jerusalem => 0x2629,
  :star_and_crescent => 0x262a,
  :farsi_symbol => 0x262b,
  :symbol_of_iran => 0x262b,
  :adi_shakti => 0x262c,
  :hammer_and_sickle => 0x262d,
  :peace_symbol => 0x262e,
  :yin_yang => 0x262f,
  :trigram_for_heaven => 0x2630,
  :trigram_for_lake => 0x2631,
  :trigram_for_fire => 0x2632,
  :trigram_for_thunder => 0x2633,
  :trigram_for_wind => 0x2634,
  :trigram_for_water => 0x2635,
  :trigram_for_mountain => 0x2636,
  :trigram_for_earth => 0x2637,
  :wheel_of_dharma => 0x2638,
  :white_frowning_face => 0x2639,
  :white_smiling_face => 0x263a,
  :black_smiling_face => 0x263b,
  :white_sun_with_rays => 0x263c,
  :first_quarter_moon => 0x263d,
  :last_quarter_moon => 0x263e,
  :mercury => 0x263f,
  :female_sign => 0x2640,
  :earth => 0x2641,
  :male_sign => 0x2642,
  :jupiter => 0x2643,
  :saturn => 0x2644,
  :uranus => 0x2645,
  :neptune => 0x2646,
  :pluto => 0x2647,
  :aries => 0x2648,
  :taurus => 0x2649,
  :gemini => 0x264a,
  :cancer => 0x264b,
  :leo => 0x264c,
  :virgo => 0x264d,
  :libra => 0x264e,
  :scorpius => 0x264f,
  :sagittarius => 0x2650,
  :capricorn => 0x2651,
  :aquarius => 0x2652,
  :pisces => 0x2653,
  :white_chess_king => 0x2654,
  :white_chess_queen => 0x2655,
  :white_chess_rook => 0x2656,
  :white_chess_bishop => 0x2657,
  :white_chess_knight => 0x2658,
  :white_chess_pawn => 0x2659,
  :black_chess_king => 0x265a,
  :black_chess_queen => 0x265b,
  :black_chess_rook => 0x265c,
  :black_chess_bishop => 0x265d,
  :black_chess_knight => 0x265e,
  :black_chess_pawn => 0x265f,
  :black_spade_suit => 0x2660,
  :white_heart_suit => 0x2661,
  :white_diamond_suit => 0x2662,
  :black_club_suit => 0x2663,
  :white_spade_suit => 0x2664,
  :black_heart_suit => 0x2665,
  :black_diamond_suit => 0x2666,
  :white_club_suit => 0x2667,
  :hot_springs => 0x2668,
  :quarter_note => 0x2669,
  :eighth_note => 0x266a,
  :beamed_eighth_notes => 0x266b,
  :barred_eighth_notes => 0x266b,
  :beamed_sixteenth_notes => 0x266c,
  :barred_sixteenth_notes => 0x266c,
  :music_flat_sign => 0x266d,
  :flat => 0x266d,
  :music_natural_sign => 0x266e,
  :natural => 0x266e,
  :music_sharp_sign => 0x266f,
  :sharp => 0x266f,
  :west_syriac_cross => 0x2670,
  :east_syriac_cross => 0x2671,
  :universal_recycling_symbol => 0x2672,
  :recycling_symbol_for_type_1_plastics => 0x2673,
  :recycling_symbol_for_type_2_plastics => 0x2674,
  :recycling_symbol_for_type_3_plastics => 0x2675,
  :recycling_symbol_for_type_4_plastics => 0x2676,
  :recycling_symbol_for_type_5_plastics => 0x2677,
  :recycling_symbol_for_type_6_plastics => 0x2678,
  :recycling_symbol_for_type_7_plastics => 0x2679,
  :recycling_symbol_for_generic_materials => 0x267a,
  :black_universal_recycling_symbol => 0x267b,
  :recycled_paper_symbol => 0x267c,
  :partially_recycled_paper_symbol => 0x267d,
  :permanent_paper_sign => 0x267e,
  :wheelchair_symbol => 0x267f,
  :die_face_1 => 0x2680,
  :die_face_2 => 0x2681,
  :die_face_3 => 0x2682,
  :die_face_4 => 0x2683,
  :die_face_5 => 0x2684,
  :die_face_6 => 0x2685,
  :white_circle_with_dot_right => 0x2686,
  :white_circle_with_two_dots => 0x2687,
  :black_circle_with_white_dot_right => 0x2688,
  :black_circle_with_two_white_dots => 0x2689,
  :monogram_for_yang => 0x268a,
  :monogram_for_yin => 0x268b,
  :digram_for_greater_yang => 0x268c,
  :digram_for_lesser_yin => 0x268d,
  :digram_for_lesser_yang => 0x268e,
  :digram_for_greater_yin => 0x268f,
  :white_flag => 0x2690,
  :black_flag => 0x2691,
  :hammer_and_pick => 0x2692,
  :anchor => 0x2693,
  :crossed_swords => 0x2694,
  :staff_of_aesculapius => 0x2695,
  :scales => 0x2696,
  :alembic => 0x2697,
  :flower => 0x2698,
  :gear => 0x2699,
  :staff_of_hermes => 0x269a,
  :atom_symbol => 0x269b,
  :fleur_de_lis => 0x269c,
  :warning_sign => 0x26a0,
  :high_voltage_sign => 0x26a1,
  :doubled_female_sign => 0x26a2,
  :doubled_male_sign => 0x26a3,
  :interlocked_female_and_male_sign => 0x26a4,
  :male_and_female_sign => 0x26a5,
  :male_with_stroke_sign => 0x26a6,
  :male_with_stroke_and_male_and_female_sign => 0x26a7,
  :vertical_male_with_stroke_sign => 0x26a8,
  :horizontal_male_with_stroke_sign => 0x26a9,
  :medium_white_circle => 0x26aa,
  :medium_black_circle => 0x26ab,
  :medium_small_white_circle => 0x26ac,
  :marriage_symbol => 0x26ad,
  :divorce_symbol => 0x26ae,
  :unmarried_partnership_symbol => 0x26af,
  :coffin => 0x26b0,
  :funeral_urn => 0x26b1,
  :upper_blade_scissors => 0x2701,
  :black_scissors => 0x2702,
  :lower_blade_scissors => 0x2703,
  :white_scissors => 0x2704,
  :telephone_location_sign => 0x2706,
  :tape_drive => 0x2707,
  :airplane => 0x2708,
  :envelope => 0x2709,
  :victory_hand => 0x270c,
  :writing_hand => 0x270d,
  :lower_right_pencil => 0x270e,
  :pencil => 0x270f,
  :upper_right_pencil => 0x2710,
  :white_nib => 0x2711,
  :black_nib => 0x2712,
  :check_mark => 0x2713,
  :heavy_check_mark => 0x2714,
  :multiplication_x => 0x2715,
  :heavy_multiplication_x => 0x2716,
  :ballot_x => 0x2717,
  :heavy_ballot_x => 0x2718,
  :outlined_greek_cross => 0x2719,
  :heavy_greek_cross => 0x271a,
  :open_centre_cross => 0x271b,
  :open_center_cross => 0x271b,
  :heavy_open_centre_cross => 0x271c,
  :heavy_open_center_cross => 0x271c,
  :latin_cross => 0x271d,
  :shadowed_white_latin_cross => 0x271e,
  :outlined_latin_cross => 0x271f,
  :maltese_cross => 0x2720,
  :star_of_david => 0x2721,
  :four_teardrop_spoked_asterisk => 0x2722,
  :four_balloon_spoked_asterisk => 0x2723,
  :heavy_four_balloon_spoked_asterisk => 0x2724,
  :four_club_spoked_asterisk => 0x2725,
  :black_four_pointed_star => 0x2726,
  :white_four_pointed_star => 0x2727,
  :stress_outlined_white_star => 0x2729,
  :circled_white_star => 0x272a,
  :open_centre_black_star => 0x272b,
  :open_center_black_star => 0x272b,
  :black_centre_white_star => 0x272c,
  :black_center_white_star => 0x272c,
  :outlined_black_star => 0x272d,
  :heavy_outlined_black_star => 0x272e,
  :pinwheel_star => 0x272f,
  :shadowed_white_star => 0x2730,
  :heavy_asterisk => 0x2731,
  :open_centre_asterisk => 0x2732,
  :open_center_asterisk => 0x2732,
  :eight_spoked_asterisk => 0x2733,
  :eight_pointed_black_star => 0x2734,
  :eight_pointed_pinwheel_star => 0x2735,
  :six_pointed_black_star => 0x2736,
  :eight_pointed_rectilinear_black_star => 0x2737,
  :heavy_eight_pointed_rectilinear_black_star => 0x2738,
  :twelve_pointed_black_star => 0x2739,
  :sixteen_pointed_asterisk => 0x273a,
  :teardrop_spoked_asterisk => 0x273b,
  :open_centre_teardrop_spoked_asterisk => 0x273c,
  :open_center_teardrop_spoked_asterisk => 0x273c,
  :heavy_teardrop_spoked_asterisk => 0x273d,
  :six_petalled_black_and_white_florette => 0x273e,
  :black_florette => 0x273f,
  :white_florette => 0x2740,
  :eight_petalled_outlined_black_florette => 0x2741,
  :circled_open_centre_eight_pointed_star => 0x2742,
  :circled_open_center_eight_pointed_star => 0x2742,
  :heavy_teardrop_spoked_pinwheel_asterisk => 0x2743,
  :snowflake => 0x2744,
  :tight_trifoliate_snowflake => 0x2745,
  :heavy_chevron_snowflake => 0x2746,
  :sparkle => 0x2747,
  :heavy_sparkle => 0x2748,
  :balloon_spoked_asterisk => 0x2749,
  :eight_teardrop_spoked_propeller_asterisk => 0x274a,
  :heavy_eight_teardrop_spoked_propeller_asterisk => 0x274b,
  :shadowed_white_circle => 0x274d,
  :lower_right_drop_shadowed_white_square => 0x274f,
  :upper_right_drop_shadowed_white_square => 0x2750,
  :lower_right_shadowed_white_square => 0x2751,
  :upper_right_shadowed_white_square => 0x2752,
  :black_diamond_minus_white_x => 0x2756,
  :light_vertical_bar => 0x2758,
  :medium_vertical_bar => 0x2759,
  :heavy_vertical_bar => 0x275a,
  :heavy_single_turned_comma_quotation_mark_ornament => 0x275b,
  :heavy_single_comma_quotation_mark_ornament => 0x275c,
  :heavy_double_turned_comma_quotation_mark_ornament => 0x275d,
  :heavy_double_comma_quotation_mark_ornament => 0x275e,
  :curved_stem_paragraph_sign_ornament => 0x2761,
  :heavy_exclamation_mark_ornament => 0x2762,
  :heavy_heart_exclamation_mark_ornament => 0x2763,
  :heavy_black_heart => 0x2764,
  :rotated_heavy_black_heart_bullet => 0x2765,
  :floral_heart => 0x2766,
  :rotated_floral_heart_bullet => 0x2767,
  :medium_left_parenthesis_ornament => 0x2768,
  :medium_right_parenthesis_ornament => 0x2769,
  :medium_flattened_left_parenthesis_ornament => 0x276a,
  :medium_flattened_right_parenthesis_ornament => 0x276b,
  :medium_left_pointing_angle_bracket_ornament => 0x276c,
  :medium_right_pointing_angle_bracket_ornament => 0x276d,
  :heavy_left_pointing_angle_quotation_mark_ornament => 0x276e,
  :heavy_right_pointing_angle_quotation_mark_ornament => 0x276f,
  :heavy_left_pointing_angle_bracket_ornament => 0x2770,
  :heavy_right_pointing_angle_bracket_ornament => 0x2771,
  :light_left_tortoise_shell_bracket_ornament => 0x2772,
  :light_right_tortoise_shell_bracket_ornament => 0x2773,
  :medium_left_curly_bracket_ornament => 0x2774,
  :medium_right_curly_bracket_ornament => 0x2775,
  :dingbat_negative_circled_digit_one => 0x2776,
  :inverse_circled_digit_one => 0x2776,
  :dingbat_negative_circled_digit_two => 0x2777,
  :inverse_circled_digit_two => 0x2777,
  :dingbat_negative_circled_digit_three => 0x2778,
  :inverse_circled_digit_three => 0x2778,
  :dingbat_negative_circled_digit_four => 0x2779,
  :inverse_circled_digit_four => 0x2779,
  :dingbat_negative_circled_digit_five => 0x277a,
  :inverse_circled_digit_five => 0x277a,
  :dingbat_negative_circled_digit_six => 0x277b,
  :inverse_circled_digit_six => 0x277b,
  :dingbat_negative_circled_digit_seven => 0x277c,
  :inverse_circled_digit_seven => 0x277c,
  :dingbat_negative_circled_digit_eight => 0x277d,
  :inverse_circled_digit_eight => 0x277d,
  :dingbat_negative_circled_digit_nine => 0x277e,
  :inverse_circled_digit_nine => 0x277e,
  :dingbat_negative_circled_number_ten => 0x277f,
  :inverse_circled_number_ten => 0x277f,
  :dingbat_circled_sans_serif_digit_one => 0x2780,
  :circled_sans_serif_digit_one => 0x2780,
  :dingbat_circled_sans_serif_digit_two => 0x2781,
  :circled_sans_serif_digit_two => 0x2781,
  :dingbat_circled_sans_serif_digit_three => 0x2782,
  :circled_sans_serif_digit_three => 0x2782,
  :dingbat_circled_sans_serif_digit_four => 0x2783,
  :circled_sans_serif_digit_four => 0x2783,
  :dingbat_circled_sans_serif_digit_five => 0x2784,
  :circled_sans_serif_digit_five => 0x2784,
  :dingbat_circled_sans_serif_digit_six => 0x2785,
  :circled_sans_serif_digit_six => 0x2785,
  :dingbat_circled_sans_serif_digit_seven => 0x2786,
  :circled_sans_serif_digit_seven => 0x2786,
  :dingbat_circled_sans_serif_digit_eight => 0x2787,
  :circled_sans_serif_digit_eight => 0x2787,
  :dingbat_circled_sans_serif_digit_nine => 0x2788,
  :circled_sans_serif_digit_nine => 0x2788,
  :dingbat_circled_sans_serif_number_ten => 0x2789,
  :circled_sans_serif_number_ten => 0x2789,
  :dingbat_negative_circled_sans_serif_digit_one => 0x278a,
  :inverse_circled_sans_serif_digit_one => 0x278a,
  :dingbat_negative_circled_sans_serif_digit_two => 0x278b,
  :inverse_circled_sans_serif_digit_two => 0x278b,
  :dingbat_negative_circled_sans_serif_digit_three => 0x278c,
  :inverse_circled_sans_serif_digit_three => 0x278c,
  :dingbat_negative_circled_sans_serif_digit_four => 0x278d,
  :inverse_circled_sans_serif_digit_four => 0x278d,
  :dingbat_negative_circled_sans_serif_digit_five => 0x278e,
  :inverse_circled_sans_serif_digit_five => 0x278e,
  :dingbat_negative_circled_sans_serif_digit_six => 0x278f,
  :inverse_circled_sans_serif_digit_six => 0x278f,
  :dingbat_negative_circled_sans_serif_digit_seven => 0x2790,
  :inverse_circled_sans_serif_digit_seven => 0x2790,
  :dingbat_negative_circled_sans_serif_digit_eight => 0x2791,
  :inverse_circled_sans_serif_digit_eight => 0x2791,
  :dingbat_negative_circled_sans_serif_digit_nine => 0x2792,
  :inverse_circled_sans_serif_digit_nine => 0x2792,
  :dingbat_negative_circled_sans_serif_number_ten => 0x2793,
  :inverse_circled_sans_serif_number_ten => 0x2793,
  :heavy_wide_headed_rightwards_arrow => 0x2794,
  :heavy_wide_headed_right_arrow => 0x2794,
  :heavy_south_east_arrow => 0x2798,
  :heavy_lower_right_arrow => 0x2798,
  :heavy_rightwards_arrow => 0x2799,
  :heavy_right_arrow => 0x2799,
  :heavy_north_east_arrow => 0x279a,
  :heavy_upper_right_arrow => 0x279a,
  :drafting_point_rightwards_arrow => 0x279b,
  :drafting_point_right_arrow => 0x279b,
  :heavy_round_tipped_rightwards_arrow => 0x279c,
  :heavy_round_tipped_right_arrow => 0x279c,
  :triangle_headed_rightwards_arrow => 0x279d,
  :triangle_headed_right_arrow => 0x279d,
  :heavy_triangle_headed_rightwards_arrow => 0x279e,
  :heavy_triangle_headed_right_arrow => 0x279e,
  :dashed_triangle_headed_rightwards_arrow => 0x279f,
  :dashed_triangle_headed_right_arrow => 0x279f,
  :heavy_dashed_triangle_headed_rightwards_arrow => 0x27a0,
  :heavy_dashed_triangle_headed_right_arrow => 0x27a0,
  :black_rightwards_arrow => 0x27a1,
  :black_right_arrow => 0x27a1,
  :three_d_top_lighted_rightwards_arrowhead => 0x27a2,
  :three_d_top_lighted_right_arrowhead => 0x27a2,
  :three_d_bottom_lighted_rightwards_arrowhead => 0x27a3,
  :three_d_bottom_lighted_right_arrowhead => 0x27a3,
  :black_rightwards_arrowhead => 0x27a4,
  :black_right_arrowhead => 0x27a4,
  :heavy_black_curved_downwards_and_rightwards_arrow => 0x27a5,
  :heavy_black_curved_down_and_right_arrow => 0x27a5,
  :heavy_black_curved_upwards_and_rightwards_arrow => 0x27a6,
  :heavy_black_curved_up_and_right_arrow => 0x27a6,
  :squat_black_rightwards_arrow => 0x27a7,
  :squat_black_right_arrow => 0x27a7,
  :heavy_concave_pointed_black_rightwards_arrow => 0x27a8,
  :heavy_concave_pointed_black_right_arrow => 0x27a8,
  :right_shaded_white_rightwards_arrow => 0x27a9,
  :right_shaded_white_right_arrow => 0x27a9,
  :left_shaded_white_rightwards_arrow => 0x27aa,
  :left_shaded_white_right_arrow => 0x27aa,
  :back_tilted_shadowed_white_rightwards_arrow => 0x27ab,
  :back_tilted_shadowed_white_right_arrow => 0x27ab,
  :front_tilted_shadowed_white_rightwards_arrow => 0x27ac,
  :front_tilted_shadowed_white_right_arrow => 0x27ac,
  :heavy_lower_right_shadowed_white_rightwards_arrow => 0x27ad,
  :heavy_lower_right_shadowed_white_right_arrow => 0x27ad,
  :heavy_upper_right_shadowed_white_rightwards_arrow => 0x27ae,
  :heavy_upper_right_shadowed_white_right_arrow => 0x27ae,
  :notched_lower_right_shadowed_white_rightwards_arrow => 0x27af,
  :notched_lower_right_shadowed_white_right_arrow => 0x27af,
  :notched_upper_right_shadowed_white_rightwards_arrow => 0x27b1,
  :notched_upper_right_shadowed_white_right_arrow => 0x27b1,
  :circled_heavy_white_rightwards_arrow => 0x27b2,
  :circled_heavy_white_right_arrow => 0x27b2,
  :white_feathered_rightwards_arrow => 0x27b3,
  :white_feathered_right_arrow => 0x27b3,
  :black_feathered_south_east_arrow => 0x27b4,
  :black_feathered_lower_right_arrow => 0x27b4,
  :black_feathered_rightwards_arrow => 0x27b5,
  :black_feathered_right_arrow => 0x27b5,
  :black_feathered_north_east_arrow => 0x27b6,
  :black_feathered_upper_right_arrow => 0x27b6,
  :heavy_black_feathered_south_east_arrow => 0x27b7,
  :heavy_black_feathered_lower_right_arrow => 0x27b7,
  :heavy_black_feathered_rightwards_arrow => 0x27b8,
  :heavy_black_feathered_right_arrow => 0x27b8,
  :heavy_black_feathered_north_east_arrow => 0x27b9,
  :heavy_black_feathered_upper_right_arrow => 0x27b9,
  :teardrop_barbed_rightwards_arrow => 0x27ba,
  :teardrop_barbed_right_arrow => 0x27ba,
  :heavy_teardrop_shanked_rightwards_arrow => 0x27bb,
  :heavy_teardrop_shanked_right_arrow => 0x27bb,
  :wedge_tailed_rightwards_arrow => 0x27bc,
  :wedge_tailed_right_arrow => 0x27bc,
  :heavy_wedge_tailed_rightwards_arrow => 0x27bd,
  :heavy_wedge_tailed_right_arrow => 0x27bd,
  :open_outlined_rightwards_arrow => 0x27be,
  :open_outlined_right_arrow => 0x27be,
  :three_dimensional_angle => 0x27c0,
  :white_triangle_containing_small_white_triangle => 0x27c1,
  :perpendicular => 0x27c2,
  :open_subset => 0x27c3,
  :open_superset => 0x27c4,
  :left_s_shaped_bag_delimiter => 0x27c5,
  :right_s_shaped_bag_delimiter => 0x27c6,
  :white_diamond_with_centred_dot => 0x27d0,
  :and_with_dot => 0x27d1,
  :element_of_opening_upwards => 0x27d2,
  :lower_right_corner_with_dot => 0x27d3,
  :upper_left_corner_with_dot => 0x27d4,
  :left_outer_join => 0x27d5,
  :right_outer_join => 0x27d6,
  :full_outer_join => 0x27d7,
  :large_up_tack => 0x27d8,
  :large_down_tack => 0x27d9,
  :left_and_right_double_turnstile => 0x27da,
  :left_and_right_tack => 0x27db,
  :left_multimap => 0x27dc,
  :long_right_tack => 0x27dd,
  :long_left_tack => 0x27de,
  :up_tack_with_circle_above => 0x27df,
  :lozenge_divided_by_horizontal_rule => 0x27e0,
  :white_concave_sided_diamond => 0x27e1,
  :white_concave_sided_diamond_with_leftwards_tick => 0x27e2,
  :white_concave_sided_diamond_with_rightwards_tick => 0x27e3,
  :white_square_with_leftwards_tick => 0x27e4,
  :white_square_with_rightwards_tick => 0x27e5,
  :mathematical_left_white_square_bracket => 0x27e6,
  :mathematical_right_white_square_bracket => 0x27e7,
  :mathematical_left_angle_bracket => 0x27e8,
  :mathematical_right_angle_bracket => 0x27e9,
  :mathematical_left_double_angle_bracket => 0x27ea,
  :mathematical_right_double_angle_bracket => 0x27eb,
  :upwards_quadruple_arrow => 0x27f0,
  :downwards_quadruple_arrow => 0x27f1,
  :anticlockwise_gapped_circle_arrow => 0x27f2,
  :clockwise_gapped_circle_arrow => 0x27f3,
  :right_arrow_with_circled_plus => 0x27f4,
  :long_leftwards_arrow => 0x27f5,
  :long_rightwards_arrow => 0x27f6,
  :long_left_right_arrow => 0x27f7,
  :long_leftwards_double_arrow => 0x27f8,
  :long_rightwards_double_arrow => 0x27f9,
  :long_left_right_double_arrow => 0x27fa,
  :long_leftwards_arrow_from_bar => 0x27fb,
  :long_rightwards_arrow_from_bar => 0x27fc,
  :long_leftwards_double_arrow_from_bar => 0x27fd,
  :long_rightwards_double_arrow_from_bar => 0x27fe,
  :long_rightwards_squiggle_arrow => 0x27ff,
  :braille_pattern_blank => 0x2800,
  :braille_pattern_dots_1 => 0x2801,
  :braille_pattern_dots_2 => 0x2802,
  :braille_pattern_dots_12 => 0x2803,
  :braille_pattern_dots_3 => 0x2804,
  :braille_pattern_dots_13 => 0x2805,
  :braille_pattern_dots_23 => 0x2806,
  :braille_pattern_dots_123 => 0x2807,
  :braille_pattern_dots_4 => 0x2808,
  :braille_pattern_dots_14 => 0x2809,
  :braille_pattern_dots_24 => 0x280a,
  :braille_pattern_dots_124 => 0x280b,
  :braille_pattern_dots_34 => 0x280c,
  :braille_pattern_dots_134 => 0x280d,
  :braille_pattern_dots_234 => 0x280e,
  :braille_pattern_dots_1234 => 0x280f,
  :braille_pattern_dots_5 => 0x2810,
  :braille_pattern_dots_15 => 0x2811,
  :braille_pattern_dots_25 => 0x2812,
  :braille_pattern_dots_125 => 0x2813,
  :braille_pattern_dots_35 => 0x2814,
  :braille_pattern_dots_135 => 0x2815,
  :braille_pattern_dots_235 => 0x2816,
  :braille_pattern_dots_1235 => 0x2817,
  :braille_pattern_dots_45 => 0x2818,
  :braille_pattern_dots_145 => 0x2819,
  :braille_pattern_dots_245 => 0x281a,
  :braille_pattern_dots_1245 => 0x281b,
  :braille_pattern_dots_345 => 0x281c,
  :braille_pattern_dots_1345 => 0x281d,
  :braille_pattern_dots_2345 => 0x281e,
  :braille_pattern_dots_12345 => 0x281f,
  :braille_pattern_dots_6 => 0x2820,
  :braille_pattern_dots_16 => 0x2821,
  :braille_pattern_dots_26 => 0x2822,
  :braille_pattern_dots_126 => 0x2823,
  :braille_pattern_dots_36 => 0x2824,
  :braille_pattern_dots_136 => 0x2825,
  :braille_pattern_dots_236 => 0x2826,
  :braille_pattern_dots_1236 => 0x2827,
  :braille_pattern_dots_46 => 0x2828,
  :braille_pattern_dots_146 => 0x2829,
  :braille_pattern_dots_246 => 0x282a,
  :braille_pattern_dots_1246 => 0x282b,
  :braille_pattern_dots_346 => 0x282c,
  :braille_pattern_dots_1346 => 0x282d,
  :braille_pattern_dots_2346 => 0x282e,
  :braille_pattern_dots_12346 => 0x282f,
  :braille_pattern_dots_56 => 0x2830,
  :braille_pattern_dots_156 => 0x2831,
  :braille_pattern_dots_256 => 0x2832,
  :braille_pattern_dots_1256 => 0x2833,
  :braille_pattern_dots_356 => 0x2834,
  :braille_pattern_dots_1356 => 0x2835,
  :braille_pattern_dots_2356 => 0x2836,
  :braille_pattern_dots_12356 => 0x2837,
  :braille_pattern_dots_456 => 0x2838,
  :braille_pattern_dots_1456 => 0x2839,
  :braille_pattern_dots_2456 => 0x283a,
  :braille_pattern_dots_12456 => 0x283b,
  :braille_pattern_dots_3456 => 0x283c,
  :braille_pattern_dots_13456 => 0x283d,
  :braille_pattern_dots_23456 => 0x283e,
  :braille_pattern_dots_123456 => 0x283f,
  :braille_pattern_dots_7 => 0x2840,
  :braille_pattern_dots_17 => 0x2841,
  :braille_pattern_dots_27 => 0x2842,
  :braille_pattern_dots_127 => 0x2843,
  :braille_pattern_dots_37 => 0x2844,
  :braille_pattern_dots_137 => 0x2845,
  :braille_pattern_dots_237 => 0x2846,
  :braille_pattern_dots_1237 => 0x2847,
  :braille_pattern_dots_47 => 0x2848,
  :braille_pattern_dots_147 => 0x2849,
  :braille_pattern_dots_247 => 0x284a,
  :braille_pattern_dots_1247 => 0x284b,
  :braille_pattern_dots_347 => 0x284c,
  :braille_pattern_dots_1347 => 0x284d,
  :braille_pattern_dots_2347 => 0x284e,
  :braille_pattern_dots_12347 => 0x284f,
  :braille_pattern_dots_57 => 0x2850,
  :braille_pattern_dots_157 => 0x2851,
  :braille_pattern_dots_257 => 0x2852,
  :braille_pattern_dots_1257 => 0x2853,
  :braille_pattern_dots_357 => 0x2854,
  :braille_pattern_dots_1357 => 0x2855,
  :braille_pattern_dots_2357 => 0x2856,
  :braille_pattern_dots_12357 => 0x2857,
  :braille_pattern_dots_457 => 0x2858,
  :braille_pattern_dots_1457 => 0x2859,
  :braille_pattern_dots_2457 => 0x285a,
  :braille_pattern_dots_12457 => 0x285b,
  :braille_pattern_dots_3457 => 0x285c,
  :braille_pattern_dots_13457 => 0x285d,
  :braille_pattern_dots_23457 => 0x285e,
  :braille_pattern_dots_123457 => 0x285f,
  :braille_pattern_dots_67 => 0x2860,
  :braille_pattern_dots_167 => 0x2861,
  :braille_pattern_dots_267 => 0x2862,
  :braille_pattern_dots_1267 => 0x2863,
  :braille_pattern_dots_367 => 0x2864,
  :braille_pattern_dots_1367 => 0x2865,
  :braille_pattern_dots_2367 => 0x2866,
  :braille_pattern_dots_12367 => 0x2867,
  :braille_pattern_dots_467 => 0x2868,
  :braille_pattern_dots_1467 => 0x2869,
  :braille_pattern_dots_2467 => 0x286a,
  :braille_pattern_dots_12467 => 0x286b,
  :braille_pattern_dots_3467 => 0x286c,
  :braille_pattern_dots_13467 => 0x286d,
  :braille_pattern_dots_23467 => 0x286e,
  :braille_pattern_dots_123467 => 0x286f,
  :braille_pattern_dots_567 => 0x2870,
  :braille_pattern_dots_1567 => 0x2871,
  :braille_pattern_dots_2567 => 0x2872,
  :braille_pattern_dots_12567 => 0x2873,
  :braille_pattern_dots_3567 => 0x2874,
  :braille_pattern_dots_13567 => 0x2875,
  :braille_pattern_dots_23567 => 0x2876,
  :braille_pattern_dots_123567 => 0x2877,
  :braille_pattern_dots_4567 => 0x2878,
  :braille_pattern_dots_14567 => 0x2879,
  :braille_pattern_dots_24567 => 0x287a,
  :braille_pattern_dots_124567 => 0x287b,
  :braille_pattern_dots_34567 => 0x287c,
  :braille_pattern_dots_134567 => 0x287d,
  :braille_pattern_dots_234567 => 0x287e,
  :braille_pattern_dots_1234567 => 0x287f,
  :braille_pattern_dots_8 => 0x2880,
  :braille_pattern_dots_18 => 0x2881,
  :braille_pattern_dots_28 => 0x2882,
  :braille_pattern_dots_128 => 0x2883,
  :braille_pattern_dots_38 => 0x2884,
  :braille_pattern_dots_138 => 0x2885,
  :braille_pattern_dots_238 => 0x2886,
  :braille_pattern_dots_1238 => 0x2887,
  :braille_pattern_dots_48 => 0x2888,
  :braille_pattern_dots_148 => 0x2889,
  :braille_pattern_dots_248 => 0x288a,
  :braille_pattern_dots_1248 => 0x288b,
  :braille_pattern_dots_348 => 0x288c,
  :braille_pattern_dots_1348 => 0x288d,
  :braille_pattern_dots_2348 => 0x288e,
  :braille_pattern_dots_12348 => 0x288f,
  :braille_pattern_dots_58 => 0x2890,
  :braille_pattern_dots_158 => 0x2891,
  :braille_pattern_dots_258 => 0x2892,
  :braille_pattern_dots_1258 => 0x2893,
  :braille_pattern_dots_358 => 0x2894,
  :braille_pattern_dots_1358 => 0x2895,
  :braille_pattern_dots_2358 => 0x2896,
  :braille_pattern_dots_12358 => 0x2897,
  :braille_pattern_dots_458 => 0x2898,
  :braille_pattern_dots_1458 => 0x2899,
  :braille_pattern_dots_2458 => 0x289a,
  :braille_pattern_dots_12458 => 0x289b,
  :braille_pattern_dots_3458 => 0x289c,
  :braille_pattern_dots_13458 => 0x289d,
  :braille_pattern_dots_23458 => 0x289e,
  :braille_pattern_dots_123458 => 0x289f,
  :braille_pattern_dots_68 => 0x28a0,
  :braille_pattern_dots_168 => 0x28a1,
  :braille_pattern_dots_268 => 0x28a2,
  :braille_pattern_dots_1268 => 0x28a3,
  :braille_pattern_dots_368 => 0x28a4,
  :braille_pattern_dots_1368 => 0x28a5,
  :braille_pattern_dots_2368 => 0x28a6,
  :braille_pattern_dots_12368 => 0x28a7,
  :braille_pattern_dots_468 => 0x28a8,
  :braille_pattern_dots_1468 => 0x28a9,
  :braille_pattern_dots_2468 => 0x28aa,
  :braille_pattern_dots_12468 => 0x28ab,
  :braille_pattern_dots_3468 => 0x28ac,
  :braille_pattern_dots_13468 => 0x28ad,
  :braille_pattern_dots_23468 => 0x28ae,
  :braille_pattern_dots_123468 => 0x28af,
  :braille_pattern_dots_568 => 0x28b0,
  :braille_pattern_dots_1568 => 0x28b1,
  :braille_pattern_dots_2568 => 0x28b2,
  :braille_pattern_dots_12568 => 0x28b3,
  :braille_pattern_dots_3568 => 0x28b4,
  :braille_pattern_dots_13568 => 0x28b5,
  :braille_pattern_dots_23568 => 0x28b6,
  :braille_pattern_dots_123568 => 0x28b7,
  :braille_pattern_dots_4568 => 0x28b8,
  :braille_pattern_dots_14568 => 0x28b9,
  :braille_pattern_dots_24568 => 0x28ba,
  :braille_pattern_dots_124568 => 0x28bb,
  :braille_pattern_dots_34568 => 0x28bc,
  :braille_pattern_dots_134568 => 0x28bd,
  :braille_pattern_dots_234568 => 0x28be,
  :braille_pattern_dots_1234568 => 0x28bf,
  :braille_pattern_dots_78 => 0x28c0,
  :braille_pattern_dots_178 => 0x28c1,
  :braille_pattern_dots_278 => 0x28c2,
  :braille_pattern_dots_1278 => 0x28c3,
  :braille_pattern_dots_378 => 0x28c4,
  :braille_pattern_dots_1378 => 0x28c5,
  :braille_pattern_dots_2378 => 0x28c6,
  :braille_pattern_dots_12378 => 0x28c7,
  :braille_pattern_dots_478 => 0x28c8,
  :braille_pattern_dots_1478 => 0x28c9,
  :braille_pattern_dots_2478 => 0x28ca,
  :braille_pattern_dots_12478 => 0x28cb,
  :braille_pattern_dots_3478 => 0x28cc,
  :braille_pattern_dots_13478 => 0x28cd,
  :braille_pattern_dots_23478 => 0x28ce,
  :braille_pattern_dots_123478 => 0x28cf,
  :braille_pattern_dots_578 => 0x28d0,
  :braille_pattern_dots_1578 => 0x28d1,
  :braille_pattern_dots_2578 => 0x28d2,
  :braille_pattern_dots_12578 => 0x28d3,
  :braille_pattern_dots_3578 => 0x28d4,
  :braille_pattern_dots_13578 => 0x28d5,
  :braille_pattern_dots_23578 => 0x28d6,
  :braille_pattern_dots_123578 => 0x28d7,
  :braille_pattern_dots_4578 => 0x28d8,
  :braille_pattern_dots_14578 => 0x28d9,
  :braille_pattern_dots_24578 => 0x28da,
  :braille_pattern_dots_124578 => 0x28db,
  :braille_pattern_dots_34578 => 0x28dc,
  :braille_pattern_dots_134578 => 0x28dd,
  :braille_pattern_dots_234578 => 0x28de,
  :braille_pattern_dots_1234578 => 0x28df,
  :braille_pattern_dots_678 => 0x28e0,
  :braille_pattern_dots_1678 => 0x28e1,
  :braille_pattern_dots_2678 => 0x28e2,
  :braille_pattern_dots_12678 => 0x28e3,
  :braille_pattern_dots_3678 => 0x28e4,
  :braille_pattern_dots_13678 => 0x28e5,
  :braille_pattern_dots_23678 => 0x28e6,
  :braille_pattern_dots_123678 => 0x28e7,
  :braille_pattern_dots_4678 => 0x28e8,
  :braille_pattern_dots_14678 => 0x28e9,
  :braille_pattern_dots_24678 => 0x28ea,
  :braille_pattern_dots_124678 => 0x28eb,
  :braille_pattern_dots_34678 => 0x28ec,
  :braille_pattern_dots_134678 => 0x28ed,
  :braille_pattern_dots_234678 => 0x28ee,
  :braille_pattern_dots_1234678 => 0x28ef,
  :braille_pattern_dots_5678 => 0x28f0,
  :braille_pattern_dots_15678 => 0x28f1,
  :braille_pattern_dots_25678 => 0x28f2,
  :braille_pattern_dots_125678 => 0x28f3,
  :braille_pattern_dots_35678 => 0x28f4,
  :braille_pattern_dots_135678 => 0x28f5,
  :braille_pattern_dots_235678 => 0x28f6,
  :braille_pattern_dots_1235678 => 0x28f7,
  :braille_pattern_dots_45678 => 0x28f8,
  :braille_pattern_dots_145678 => 0x28f9,
  :braille_pattern_dots_245678 => 0x28fa,
  :braille_pattern_dots_1245678 => 0x28fb,
  :braille_pattern_dots_345678 => 0x28fc,
  :braille_pattern_dots_1345678 => 0x28fd,
  :braille_pattern_dots_2345678 => 0x28fe,
  :braille_pattern_dots_12345678 => 0x28ff,
  :rightwards_two_headed_arrow_with_vertical_stroke => 0x2900,
  :rightwards_two_headed_arrow_with_double_vertical_stroke => 0x2901,
  :leftwards_double_arrow_with_vertical_stroke => 0x2902,
  :rightwards_double_arrow_with_vertical_stroke => 0x2903,
  :left_right_double_arrow_with_vertical_stroke => 0x2904,
  :rightwards_two_headed_arrow_from_bar => 0x2905,
  :leftwards_double_arrow_from_bar => 0x2906,
  :rightwards_double_arrow_from_bar => 0x2907,
  :downwards_arrow_with_horizontal_stroke => 0x2908,
  :upwards_arrow_with_horizontal_stroke => 0x2909,
  :upwards_triple_arrow => 0x290a,
  :downwards_triple_arrow => 0x290b,
  :leftwards_double_dash_arrow => 0x290c,
  :rightwards_double_dash_arrow => 0x290d,
  :leftwards_triple_dash_arrow => 0x290e,
  :rightwards_triple_dash_arrow => 0x290f,
  :rightwards_two_headed_triple_dash_arrow => 0x2910,
  :rightwards_arrow_with_dotted_stem => 0x2911,
  :upwards_arrow_to_bar => 0x2912,
  :downwards_arrow_to_bar => 0x2913,
  :rightwards_arrow_with_tail_with_vertical_stroke => 0x2914,
  :rightwards_arrow_with_tail_with_double_vertical_stroke => 0x2915,
  :rightwards_two_headed_arrow_with_tail => 0x2916,
  :rightwards_two_headed_arrow_with_tail_with_vertical_stroke => 0x2917,
  :rightwards_two_headed_arrow_with_tail_with_double_vertical_stroke => 0x2918,
  :leftwards_arrow_tail => 0x2919,
  :rightwards_arrow_tail => 0x291a,
  :leftwards_double_arrow_tail => 0x291b,
  :rightwards_double_arrow_tail => 0x291c,
  :leftwards_arrow_to_black_diamond => 0x291d,
  :rightwards_arrow_to_black_diamond => 0x291e,
  :leftwards_arrow_from_bar_to_black_diamond => 0x291f,
  :rightwards_arrow_from_bar_to_black_diamond => 0x2920,
  :north_west_and_south_east_arrow => 0x2921,
  :north_east_and_south_west_arrow => 0x2922,
  :north_west_arrow_with_hook => 0x2923,
  :north_east_arrow_with_hook => 0x2924,
  :south_east_arrow_with_hook => 0x2925,
  :south_west_arrow_with_hook => 0x2926,
  :north_west_arrow_and_north_east_arrow => 0x2927,
  :north_east_arrow_and_south_east_arrow => 0x2928,
  :south_east_arrow_and_south_west_arrow => 0x2929,
  :south_west_arrow_and_north_west_arrow => 0x292a,
  :rising_diagonal_crossing_falling_diagonal => 0x292b,
  :falling_diagonal_crossing_rising_diagonal => 0x292c,
  :south_east_arrow_crossing_north_east_arrow => 0x292d,
  :north_east_arrow_crossing_south_east_arrow => 0x292e,
  :falling_diagonal_crossing_north_east_arrow => 0x292f,
  :rising_diagonal_crossing_south_east_arrow => 0x2930,
  :north_east_arrow_crossing_north_west_arrow => 0x2931,
  :north_west_arrow_crossing_north_east_arrow => 0x2932,
  :wave_arrow_pointing_directly_right => 0x2933,
  :arrow_pointing_rightwards_then_curving_upwards => 0x2934,
  :arrow_pointing_rightwards_then_curving_downwards => 0x2935,
  :arrow_pointing_downwards_then_curving_leftwards => 0x2936,
  :arrow_pointing_downwards_then_curving_rightwards => 0x2937,
  :right_side_arc_clockwise_arrow => 0x2938,
  :left_side_arc_anticlockwise_arrow => 0x2939,
  :top_arc_anticlockwise_arrow => 0x293a,
  :bottom_arc_anticlockwise_arrow => 0x293b,
  :top_arc_clockwise_arrow_with_minus => 0x293c,
  :top_arc_anticlockwise_arrow_with_plus => 0x293d,
  :lower_right_semicircular_clockwise_arrow => 0x293e,
  :lower_left_semicircular_anticlockwise_arrow => 0x293f,
  :anticlockwise_closed_circle_arrow => 0x2940,
  :clockwise_closed_circle_arrow => 0x2941,
  :rightwards_arrow_above_short_leftwards_arrow => 0x2942,
  :leftwards_arrow_above_short_rightwards_arrow => 0x2943,
  :short_rightwards_arrow_above_leftwards_arrow => 0x2944,
  :rightwards_arrow_with_plus_below => 0x2945,
  :leftwards_arrow_with_plus_below => 0x2946,
  :rightwards_arrow_through_x => 0x2947,
  :left_right_arrow_through_small_circle => 0x2948,
  :upwards_two_headed_arrow_from_small_circle => 0x2949,
  :left_barb_up_right_barb_down_harpoon => 0x294a,
  :left_barb_down_right_barb_up_harpoon => 0x294b,
  :up_barb_right_down_barb_left_harpoon => 0x294c,
  :up_barb_left_down_barb_right_harpoon => 0x294d,
  :left_barb_up_right_barb_up_harpoon => 0x294e,
  :up_barb_right_down_barb_right_harpoon => 0x294f,
  :left_barb_down_right_barb_down_harpoon => 0x2950,
  :up_barb_left_down_barb_left_harpoon => 0x2951,
  :leftwards_harpoon_with_barb_up_to_bar => 0x2952,
  :rightwards_harpoon_with_barb_up_to_bar => 0x2953,
  :upwards_harpoon_with_barb_right_to_bar => 0x2954,
  :downwards_harpoon_with_barb_right_to_bar => 0x2955,
  :leftwards_harpoon_with_barb_down_to_bar => 0x2956,
  :rightwards_harpoon_with_barb_down_to_bar => 0x2957,
  :upwards_harpoon_with_barb_left_to_bar => 0x2958,
  :downwards_harpoon_with_barb_left_to_bar => 0x2959,
  :leftwards_harpoon_with_barb_up_from_bar => 0x295a,
  :rightwards_harpoon_with_barb_up_from_bar => 0x295b,
  :upwards_harpoon_with_barb_right_from_bar => 0x295c,
  :downwards_harpoon_with_barb_right_from_bar => 0x295d,
  :leftwards_harpoon_with_barb_down_from_bar => 0x295e,
  :rightwards_harpoon_with_barb_down_from_bar => 0x295f,
  :upwards_harpoon_with_barb_left_from_bar => 0x2960,
  :downwards_harpoon_with_barb_left_from_bar => 0x2961,
  :leftwards_harpoon_with_barb_up_above_leftwards_harpoon_with_barb_down => 0x2962,
  :upwards_harpoon_with_barb_left_beside_upwards_harpoon_with_barb_right => 0x2963,
  :rightwards_harpoon_with_barb_up_above_rightwards_harpoon_with_barb_down => 0x2964,
  :downwards_harpoon_with_barb_left_beside_downwards_harpoon_with_barb_right => 0x2965,
  :leftwards_harpoon_with_barb_up_above_rightwards_harpoon_with_barb_up => 0x2966,
  :leftwards_harpoon_with_barb_down_above_rightwards_harpoon_with_barb_down => 0x2967,
  :rightwards_harpoon_with_barb_up_above_leftwards_harpoon_with_barb_up => 0x2968,
  :rightwards_harpoon_with_barb_down_above_leftwards_harpoon_with_barb_down => 0x2969,
  :leftwards_harpoon_with_barb_up_above_long_dash => 0x296a,
  :leftwards_harpoon_with_barb_down_below_long_dash => 0x296b,
  :rightwards_harpoon_with_barb_up_above_long_dash => 0x296c,
  :rightwards_harpoon_with_barb_down_below_long_dash => 0x296d,
  :upwards_harpoon_with_barb_left_beside_downwards_harpoon_with_barb_right => 0x296e,
  :downwards_harpoon_with_barb_left_beside_upwards_harpoon_with_barb_right => 0x296f,
  :right_double_arrow_with_rounded_head => 0x2970,
  :equals_sign_above_rightwards_arrow => 0x2971,
  :tilde_operator_above_rightwards_arrow => 0x2972,
  :leftwards_arrow_above_tilde_operator => 0x2973,
  :rightwards_arrow_above_tilde_operator => 0x2974,
  :rightwards_arrow_above_almost_equal_to => 0x2975,
  :less_than_above_leftwards_arrow => 0x2976,
  :leftwards_arrow_through_less_than => 0x2977,
  :greater_than_above_rightwards_arrow => 0x2978,
  :subset_above_rightwards_arrow => 0x2979,
  :leftwards_arrow_through_subset => 0x297a,
  :superset_above_leftwards_arrow => 0x297b,
  :left_fish_tail => 0x297c,
  :right_fish_tail => 0x297d,
  :up_fish_tail => 0x297e,
  :down_fish_tail => 0x297f,
  :triple_vertical_bar_delimiter => 0x2980,
  :z_notation_spot => 0x2981,
  :z_notation_type_colon => 0x2982,
  :left_white_curly_bracket => 0x2983,
  :right_white_curly_bracket => 0x2984,
  :left_white_parenthesis => 0x2985,
  :right_white_parenthesis => 0x2986,
  :z_notation_left_image_bracket => 0x2987,
  :z_notation_right_image_bracket => 0x2988,
  :z_notation_left_binding_bracket => 0x2989,
  :z_notation_right_binding_bracket => 0x298a,
  :left_square_bracket_with_underbar => 0x298b,
  :right_square_bracket_with_underbar => 0x298c,
  :left_square_bracket_with_tick_in_top_corner => 0x298d,
  :right_square_bracket_with_tick_in_bottom_corner => 0x298e,
  :left_square_bracket_with_tick_in_bottom_corner => 0x298f,
  :right_square_bracket_with_tick_in_top_corner => 0x2990,
  :left_angle_bracket_with_dot => 0x2991,
  :right_angle_bracket_with_dot => 0x2992,
  :left_arc_less_than_bracket => 0x2993,
  :right_arc_greater_than_bracket => 0x2994,
  :double_left_arc_greater_than_bracket => 0x2995,
  :double_right_arc_less_than_bracket => 0x2996,
  :left_black_tortoise_shell_bracket => 0x2997,
  :right_black_tortoise_shell_bracket => 0x2998,
  :dotted_fence => 0x2999,
  :vertical_zigzag_line => 0x299a,
  :measured_angle_opening_left => 0x299b,
  :right_angle_variant_with_square => 0x299c,
  :measured_right_angle_with_dot => 0x299d,
  :angle_with_s_inside => 0x299e,
  :acute_angle => 0x299f,
  :spherical_angle_opening_left => 0x29a0,
  :spherical_angle_opening_up => 0x29a1,
  :turned_angle => 0x29a2,
  :reversed_angle => 0x29a3,
  :angle_with_underbar => 0x29a4,
  :reversed_angle_with_underbar => 0x29a5,
  :oblique_angle_opening_up => 0x29a6,
  :oblique_angle_opening_down => 0x29a7,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_up_and_right => 0x29a8,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_up_and_left => 0x29a9,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_down_and_right => 0x29aa,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_down_and_left => 0x29ab,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_right_and_up => 0x29ac,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_left_and_up => 0x29ad,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_right_and_down => 0x29ae,
  :measured_angle_with_open_arm_ending_in_arrow_pointing_left_and_down => 0x29af,
  :reversed_empty_set => 0x29b0,
  :empty_set_with_overbar => 0x29b1,
  :empty_set_with_small_circle_above => 0x29b2,
  :empty_set_with_right_arrow_above => 0x29b3,
  :empty_set_with_left_arrow_above => 0x29b4,
  :circle_with_horizontal_bar => 0x29b5,
  :circled_vertical_bar => 0x29b6,
  :circled_parallel => 0x29b7,
  :circled_reverse_solidus => 0x29b8,
  :circled_perpendicular => 0x29b9,
  :circle_divided_by_horizontal_bar_and_top_half_divided_by_vertical_bar => 0x29ba,
  :circle_with_superimposed_x => 0x29bb,
  :circled_anticlockwise_rotated_division_sign => 0x29bc,
  :up_arrow_through_circle => 0x29bd,
  :circled_white_bullet => 0x29be,
  :circled_bullet => 0x29bf,
  :circled_less_than => 0x29c0,
  :circled_greater_than => 0x29c1,
  :circle_with_small_circle_to_the_right => 0x29c2,
  :circle_with_two_horizontal_strokes_to_the_right => 0x29c3,
  :squared_rising_diagonal_slash => 0x29c4,
  :squared_falling_diagonal_slash => 0x29c5,
  :squared_asterisk => 0x29c6,
  :squared_small_circle => 0x29c7,
  :squared_square => 0x29c8,
  :two_joined_squares => 0x29c9,
  :triangle_with_dot_above => 0x29ca,
  :triangle_with_underbar => 0x29cb,
  :s_in_triangle => 0x29cc,
  :triangle_with_serifs_at_bottom => 0x29cd,
  :right_triangle_above_left_triangle => 0x29ce,
  :left_triangle_beside_vertical_bar => 0x29cf,
  :vertical_bar_beside_right_triangle => 0x29d0,
  :bowtie_with_left_half_black => 0x29d1,
  :bowtie_with_right_half_black => 0x29d2,
  :black_bowtie => 0x29d3,
  :times_with_left_half_black => 0x29d4,
  :times_with_right_half_black => 0x29d5,
  :white_hourglass => 0x29d6,
  :black_hourglass => 0x29d7,
  :left_wiggly_fence => 0x29d8,
  :right_wiggly_fence => 0x29d9,
  :left_double_wiggly_fence => 0x29da,
  :right_double_wiggly_fence => 0x29db,
  :incomplete_infinity => 0x29dc,
  :tie_over_infinity => 0x29dd,
  :infinity_negated_with_vertical_bar => 0x29de,
  :double_ended_multimap => 0x29df,
  :square_with_contoured_outline => 0x29e0,
  :increases_as => 0x29e1,
  :shuffle_product => 0x29e2,
  :equals_sign_and_slanted_parallel => 0x29e3,
  :equals_sign_and_slanted_parallel_with_tilde_above => 0x29e4,
  :identical_to_and_slanted_parallel => 0x29e5,
  :gleich_stark => 0x29e6,
  :thermodynamic => 0x29e7,
  :down_pointing_triangle_with_left_half_black => 0x29e8,
  :down_pointing_triangle_with_right_half_black => 0x29e9,
  :black_diamond_with_down_arrow => 0x29ea,
  :black_lozenge => 0x29eb,
  :white_circle_with_down_arrow => 0x29ec,
  :black_circle_with_down_arrow => 0x29ed,
  :error_barred_white_square => 0x29ee,
  :error_barred_black_square => 0x29ef,
  :error_barred_white_diamond => 0x29f0,
  :error_barred_black_diamond => 0x29f1,
  :error_barred_white_circle => 0x29f2,
  :error_barred_black_circle => 0x29f3,
  :rule_delayed => 0x29f4,
  :reverse_solidus_operator => 0x29f5,
  :solidus_with_overbar => 0x29f6,
  :reverse_solidus_with_horizontal_stroke => 0x29f7,
  :big_solidus => 0x29f8,
  :big_reverse_solidus => 0x29f9,
  :double_plus => 0x29fa,
  :triple_plus => 0x29fb,
  :left_pointing_curved_angle_bracket => 0x29fc,
  :right_pointing_curved_angle_bracket => 0x29fd,
  :tiny => 0x29fe,
  :miny => 0x29ff,
  :n_ary_circled_dot_operator => 0x2a00,
  :n_ary_circled_plus_operator => 0x2a01,
  :n_ary_circled_times_operator => 0x2a02,
  :n_ary_union_operator_with_dot => 0x2a03,
  :n_ary_union_operator_with_plus => 0x2a04,
  :n_ary_square_intersection_operator => 0x2a05,
  :n_ary_square_union_operator => 0x2a06,
  :two_logical_and_operator => 0x2a07,
  :two_logical_or_operator => 0x2a08,
  :n_ary_times_operator => 0x2a09,
  :modulo_two_sum => 0x2a0a,
  :summation_with_integral => 0x2a0b,
  :quadruple_integral_operator => 0x2a0c,
  :finite_part_integral => 0x2a0d,
  :integral_with_double_stroke => 0x2a0e,
  :integral_average_with_slash => 0x2a0f,
  :circulation_function => 0x2a10,
  :anticlockwise_integration => 0x2a11,
  :line_integration_with_rectangular_path_around_pole => 0x2a12,
  :line_integration_with_semicircular_path_around_pole => 0x2a13,
  :line_integration_not_including_the_pole => 0x2a14,
  :integral_around_a_point_operator => 0x2a15,
  :quaternion_integral_operator => 0x2a16,
  :integral_with_leftwards_arrow_with_hook => 0x2a17,
  :integral_with_times_sign => 0x2a18,
  :integral_with_intersection => 0x2a19,
  :integral_with_union => 0x2a1a,
  :integral_with_overbar => 0x2a1b,
  :integral_with_underbar => 0x2a1c,
  :join => 0x2a1d,
  :large_left_triangle_operator => 0x2a1e,
  :z_notation_schema_composition => 0x2a1f,
  :z_notation_schema_piping => 0x2a20,
  :z_notation_schema_projection => 0x2a21,
  :plus_sign_with_small_circle_above => 0x2a22,
  :plus_sign_with_circumflex_accent_above => 0x2a23,
  :plus_sign_with_tilde_above => 0x2a24,
  :plus_sign_with_dot_below => 0x2a25,
  :plus_sign_with_tilde_below => 0x2a26,
  :plus_sign_with_subscript_two => 0x2a27,
  :plus_sign_with_black_triangle => 0x2a28,
  :minus_sign_with_comma_above => 0x2a29,
  :minus_sign_with_dot_below => 0x2a2a,
  :minus_sign_with_falling_dots => 0x2a2b,
  :minus_sign_with_rising_dots => 0x2a2c,
  :plus_sign_in_left_half_circle => 0x2a2d,
  :plus_sign_in_right_half_circle => 0x2a2e,
  :vector_or_cross_product => 0x2a2f,
  :multiplication_sign_with_dot_above => 0x2a30,
  :multiplication_sign_with_underbar => 0x2a31,
  :semidirect_product_with_bottom_closed => 0x2a32,
  :smash_product => 0x2a33,
  :multiplication_sign_in_left_half_circle => 0x2a34,
  :multiplication_sign_in_right_half_circle => 0x2a35,
  :circled_multiplication_sign_with_circumflex_accent => 0x2a36,
  :multiplication_sign_in_double_circle => 0x2a37,
  :circled_division_sign => 0x2a38,
  :plus_sign_in_triangle => 0x2a39,
  :minus_sign_in_triangle => 0x2a3a,
  :multiplication_sign_in_triangle => 0x2a3b,
  :interior_product => 0x2a3c,
  :righthand_interior_product => 0x2a3d,
  :z_notation_relational_composition => 0x2a3e,
  :amalgamation_or_coproduct => 0x2a3f,
  :intersection_with_dot => 0x2a40,
  :union_with_minus_sign => 0x2a41,
  :union_with_overbar => 0x2a42,
  :intersection_with_overbar => 0x2a43,
  :intersection_with_logical_and => 0x2a44,
  :union_with_logical_or => 0x2a45,
  :union_above_intersection => 0x2a46,
  :intersection_above_union => 0x2a47,
  :union_above_bar_above_intersection => 0x2a48,
  :intersection_above_bar_above_union => 0x2a49,
  :union_beside_and_joined_with_union => 0x2a4a,
  :intersection_beside_and_joined_with_intersection => 0x2a4b,
  :closed_union_with_serifs => 0x2a4c,
  :closed_intersection_with_serifs => 0x2a4d,
  :double_square_intersection => 0x2a4e,
  :double_square_union => 0x2a4f,
  :closed_union_with_serifs_and_smash_product => 0x2a50,
  :logical_and_with_dot_above => 0x2a51,
  :logical_or_with_dot_above => 0x2a52,
  :double_logical_and => 0x2a53,
  :double_logical_or => 0x2a54,
  :two_intersecting_logical_and => 0x2a55,
  :two_intersecting_logical_or => 0x2a56,
  :sloping_large_or => 0x2a57,
  :sloping_large_and => 0x2a58,
  :logical_or_overlapping_logical_and => 0x2a59,
  :logical_and_with_middle_stem => 0x2a5a,
  :logical_or_with_middle_stem => 0x2a5b,
  :logical_and_with_horizontal_dash => 0x2a5c,
  :logical_or_with_horizontal_dash => 0x2a5d,
  :logical_and_with_double_overbar => 0x2a5e,
  :logical_and_with_underbar => 0x2a5f,
  :logical_and_with_double_underbar => 0x2a60,
  :small_vee_with_underbar => 0x2a61,
  :logical_or_with_double_overbar => 0x2a62,
  :logical_or_with_double_underbar => 0x2a63,
  :z_notation_domain_antirestriction => 0x2a64,
  :z_notation_range_antirestriction => 0x2a65,
  :equals_sign_with_dot_below => 0x2a66,
  :identical_with_dot_above => 0x2a67,
  :triple_horizontal_bar_with_double_vertical_stroke => 0x2a68,
  :triple_horizontal_bar_with_triple_vertical_stroke => 0x2a69,
  :tilde_operator_with_dot_above => 0x2a6a,
  :tilde_operator_with_rising_dots => 0x2a6b,
  :similar_minus_similar => 0x2a6c,
  :congruent_with_dot_above => 0x2a6d,
  :equals_with_asterisk => 0x2a6e,
  :almost_equal_to_with_circumflex_accent => 0x2a6f,
  :approximately_equal_or_equal_to => 0x2a70,
  :equals_sign_above_plus_sign => 0x2a71,
  :plus_sign_above_equals_sign => 0x2a72,
  :equals_sign_above_tilde_operator => 0x2a73,
  :double_colon_equal => 0x2a74,
  :two_consecutive_equals_signs => 0x2a75,
  :three_consecutive_equals_signs => 0x2a76,
  :equals_sign_with_two_dots_above_and_two_dots_below => 0x2a77,
  :equivalent_with_four_dots_above => 0x2a78,
  :less_than_with_circle_inside => 0x2a79,
  :greater_than_with_circle_inside => 0x2a7a,
  :less_than_with_question_mark_above => 0x2a7b,
  :greater_than_with_question_mark_above => 0x2a7c,
  :less_than_or_slanted_equal_to => 0x2a7d,
  :greater_than_or_slanted_equal_to => 0x2a7e,
  :less_than_or_slanted_equal_to_with_dot_inside => 0x2a7f,
  :greater_than_or_slanted_equal_to_with_dot_inside => 0x2a80,
  :less_than_or_slanted_equal_to_with_dot_above => 0x2a81,
  :greater_than_or_slanted_equal_to_with_dot_above => 0x2a82,
  :less_than_or_slanted_equal_to_with_dot_above_right => 0x2a83,
  :greater_than_or_slanted_equal_to_with_dot_above_left => 0x2a84,
  :less_than_or_approximate => 0x2a85,
  :greater_than_or_approximate => 0x2a86,
  :less_than_and_single_line_not_equal_to => 0x2a87,
  :greater_than_and_single_line_not_equal_to => 0x2a88,
  :less_than_and_not_approximate => 0x2a89,
  :greater_than_and_not_approximate => 0x2a8a,
  :less_than_above_double_line_equal_above_greater_than => 0x2a8b,
  :greater_than_above_double_line_equal_above_less_than => 0x2a8c,
  :less_than_above_similar_or_equal => 0x2a8d,
  :greater_than_above_similar_or_equal => 0x2a8e,
  :less_than_above_similar_above_greater_than => 0x2a8f,
  :greater_than_above_similar_above_less_than => 0x2a90,
  :less_than_above_greater_than_above_double_line_equal => 0x2a91,
  :greater_than_above_less_than_above_double_line_equal => 0x2a92,
  :less_than_above_slanted_equal_above_greater_than_above_slanted_equal => 0x2a93,
  :greater_than_above_slanted_equal_above_less_than_above_slanted_equal => 0x2a94,
  :slanted_equal_to_or_less_than => 0x2a95,
  :slanted_equal_to_or_greater_than => 0x2a96,
  :slanted_equal_to_or_less_than_with_dot_inside => 0x2a97,
  :slanted_equal_to_or_greater_than_with_dot_inside => 0x2a98,
  :double_line_equal_to_or_less_than => 0x2a99,
  :double_line_equal_to_or_greater_than => 0x2a9a,
  :double_line_slanted_equal_to_or_less_than => 0x2a9b,
  :double_line_slanted_equal_to_or_greater_than => 0x2a9c,
  :similar_or_less_than => 0x2a9d,
  :similar_or_greater_than => 0x2a9e,
  :similar_above_less_than_above_equals_sign => 0x2a9f,
  :similar_above_greater_than_above_equals_sign => 0x2aa0,
  :double_nested_less_than => 0x2aa1,
  :double_nested_greater_than => 0x2aa2,
  :double_nested_less_than_with_underbar => 0x2aa3,
  :greater_than_overlapping_less_than => 0x2aa4,
  :greater_than_beside_less_than => 0x2aa5,
  :less_than_closed_by_curve => 0x2aa6,
  :greater_than_closed_by_curve => 0x2aa7,
  :less_than_closed_by_curve_above_slanted_equal => 0x2aa8,
  :greater_than_closed_by_curve_above_slanted_equal => 0x2aa9,
  :smaller_than => 0x2aaa,
  :larger_than => 0x2aab,
  :smaller_than_or_equal_to => 0x2aac,
  :larger_than_or_equal_to => 0x2aad,
  :equals_sign_with_bumpy_above => 0x2aae,
  :precedes_above_single_line_equals_sign => 0x2aaf,
  :succeeds_above_single_line_equals_sign => 0x2ab0,
  :precedes_above_single_line_not_equal_to => 0x2ab1,
  :succeeds_above_single_line_not_equal_to => 0x2ab2,
  :precedes_above_equals_sign => 0x2ab3,
  :succeeds_above_equals_sign => 0x2ab4,
  :precedes_above_not_equal_to => 0x2ab5,
  :succeeds_above_not_equal_to => 0x2ab6,
  :precedes_above_almost_equal_to => 0x2ab7,
  :succeeds_above_almost_equal_to => 0x2ab8,
  :precedes_above_not_almost_equal_to => 0x2ab9,
  :succeeds_above_not_almost_equal_to => 0x2aba,
  :double_precedes => 0x2abb,
  :double_succeeds => 0x2abc,
  :subset_with_dot => 0x2abd,
  :superset_with_dot => 0x2abe,
  :subset_with_plus_sign_below => 0x2abf,
  :superset_with_plus_sign_below => 0x2ac0,
  :subset_with_multiplication_sign_below => 0x2ac1,
  :superset_with_multiplication_sign_below => 0x2ac2,
  :subset_of_or_equal_to_with_dot_above => 0x2ac3,
  :superset_of_or_equal_to_with_dot_above => 0x2ac4,
  :subset_of_above_equals_sign => 0x2ac5,
  :superset_of_above_equals_sign => 0x2ac6,
  :subset_of_above_tilde_operator => 0x2ac7,
  :superset_of_above_tilde_operator => 0x2ac8,
  :subset_of_above_almost_equal_to => 0x2ac9,
  :superset_of_above_almost_equal_to => 0x2aca,
  :subset_of_above_not_equal_to => 0x2acb,
  :superset_of_above_not_equal_to => 0x2acc,
  :square_left_open_box_operator => 0x2acd,
  :square_right_open_box_operator => 0x2ace,
  :closed_subset => 0x2acf,
  :closed_superset => 0x2ad0,
  :closed_subset_or_equal_to => 0x2ad1,
  :closed_superset_or_equal_to => 0x2ad2,
  :subset_above_superset => 0x2ad3,
  :superset_above_subset => 0x2ad4,
  :subset_above_subset => 0x2ad5,
  :superset_above_superset => 0x2ad6,
  :superset_beside_subset => 0x2ad7,
  :superset_beside_and_joined_by_dash_with_subset => 0x2ad8,
  :element_of_opening_downwards => 0x2ad9,
  :pitchfork_with_tee_top => 0x2ada,
  :transversal_intersection => 0x2adb,
  :forking => 0x2adc,
  :nonforking => 0x2add,
  :short_left_tack => 0x2ade,
  :short_down_tack => 0x2adf,
  :short_up_tack => 0x2ae0,
  :perpendicular_with_s => 0x2ae1,
  :vertical_bar_triple_right_turnstile => 0x2ae2,
  :double_vertical_bar_left_turnstile => 0x2ae3,
  :vertical_bar_double_left_turnstile => 0x2ae4,
  :double_vertical_bar_double_left_turnstile => 0x2ae5,
  :long_dash_from_left_member_of_double_vertical => 0x2ae6,
  :short_down_tack_with_overbar => 0x2ae7,
  :short_up_tack_with_underbar => 0x2ae8,
  :short_up_tack_above_short_down_tack => 0x2ae9,
  :double_down_tack => 0x2aea,
  :double_up_tack => 0x2aeb,
  :double_stroke_not_sign => 0x2aec,
  :reversed_double_stroke_not_sign => 0x2aed,
  :does_not_divide_with_reversed_negation_slash => 0x2aee,
  :vertical_line_with_circle_above => 0x2aef,
  :vertical_line_with_circle_below => 0x2af0,
  :down_tack_with_circle_below => 0x2af1,
  :parallel_with_horizontal_stroke => 0x2af2,
  :parallel_with_tilde_operator => 0x2af3,
  :triple_vertical_bar_binary_relation => 0x2af4,
  :triple_vertical_bar_with_horizontal_stroke => 0x2af5,
  :triple_colon_operator => 0x2af6,
  :triple_nested_less_than => 0x2af7,
  :triple_nested_greater_than => 0x2af8,
  :double_line_slanted_less_than_or_equal_to => 0x2af9,
  :double_line_slanted_greater_than_or_equal_to => 0x2afa,
  :triple_solidus_binary_relation => 0x2afb,
  :large_triple_vertical_bar_operator => 0x2afc,
  :double_solidus_operator => 0x2afd,
  :white_vertical_bar => 0x2afe,
  :n_ary_white_vertical_bar => 0x2aff,
  :north_east_white_arrow => 0x2b00,
  :north_west_white_arrow => 0x2b01,
  :south_east_white_arrow => 0x2b02,
  :south_west_white_arrow => 0x2b03,
  :left_right_white_arrow => 0x2b04,
  :leftwards_black_arrow => 0x2b05,
  :upwards_black_arrow => 0x2b06,
  :downwards_black_arrow => 0x2b07,
  :north_east_black_arrow => 0x2b08,
  :north_west_black_arrow => 0x2b09,
  :south_east_black_arrow => 0x2b0a,
  :south_west_black_arrow => 0x2b0b,
  :left_right_black_arrow => 0x2b0c,
  :up_down_black_arrow => 0x2b0d,
  :rightwards_arrow_with_tip_downwards => 0x2b0e,
  :rightwards_arrow_with_tip_upwards => 0x2b0f,
  :leftwards_arrow_with_tip_downwards => 0x2b10,
  :leftwards_arrow_with_tip_upwards => 0x2b11,
  :square_with_top_half_black => 0x2b12,
  :square_with_bottom_half_black => 0x2b13,
  :glagolitic_capital_letter_azu => 0x2c00,
  :glagolitic_capital_letter_buky => 0x2c01,
  :glagolitic_capital_letter_vede => 0x2c02,
  :glagolitic_capital_letter_glagoli => 0x2c03,
  :glagolitic_capital_letter_dobro => 0x2c04,
  :glagolitic_capital_letter_yestu => 0x2c05,
  :glagolitic_capital_letter_zhivete => 0x2c06,
  :glagolitic_capital_letter_dzelo => 0x2c07,
  :glagolitic_capital_letter_zemlja => 0x2c08,
  :glagolitic_capital_letter_izhe => 0x2c09,
  :glagolitic_capital_letter_initial_izhe => 0x2c0a,
  :glagolitic_capital_letter_i => 0x2c0b,
  :glagolitic_capital_letter_djervi => 0x2c0c,
  :glagolitic_capital_letter_kako => 0x2c0d,
  :glagolitic_capital_letter_ljudije => 0x2c0e,
  :glagolitic_capital_letter_myslite => 0x2c0f,
  :glagolitic_capital_letter_nashi => 0x2c10,
  :glagolitic_capital_letter_onu => 0x2c11,
  :glagolitic_capital_letter_pokoji => 0x2c12,
  :glagolitic_capital_letter_ritsi => 0x2c13,
  :glagolitic_capital_letter_slovo => 0x2c14,
  :glagolitic_capital_letter_tvrido => 0x2c15,
  :glagolitic_capital_letter_uku => 0x2c16,
  :glagolitic_capital_letter_fritu => 0x2c17,
  :glagolitic_capital_letter_heru => 0x2c18,
  :glagolitic_capital_letter_otu => 0x2c19,
  :glagolitic_capital_letter_pe => 0x2c1a,
  :glagolitic_capital_letter_shta => 0x2c1b,
  :glagolitic_capital_letter_tsi => 0x2c1c,
  :glagolitic_capital_letter_chrivi => 0x2c1d,
  :glagolitic_capital_letter_sha => 0x2c1e,
  :glagolitic_capital_letter_yeru => 0x2c1f,
  :glagolitic_capital_letter_yeri => 0x2c20,
  :glagolitic_capital_letter_yati => 0x2c21,
  :glagolitic_capital_letter_spidery_ha => 0x2c22,
  :glagolitic_capital_letter_yu => 0x2c23,
  :glagolitic_capital_letter_small_yus => 0x2c24,
  :glagolitic_capital_letter_small_yus_with_tail => 0x2c25,
  :glagolitic_capital_letter_yo => 0x2c26,
  :glagolitic_capital_letter_iotated_small_yus => 0x2c27,
  :glagolitic_capital_letter_big_yus => 0x2c28,
  :glagolitic_capital_letter_iotated_big_yus => 0x2c29,
  :glagolitic_capital_letter_fita => 0x2c2a,
  :glagolitic_capital_letter_izhitsa => 0x2c2b,
  :glagolitic_capital_letter_shtapic => 0x2c2c,
  :glagolitic_capital_letter_trokutasti_a => 0x2c2d,
  :glagolitic_capital_letter_latinate_myslite => 0x2c2e,
  :glagolitic_small_letter_azu => 0x2c30,
  :glagolitic_small_letter_buky => 0x2c31,
  :glagolitic_small_letter_vede => 0x2c32,
  :glagolitic_small_letter_glagoli => 0x2c33,
  :glagolitic_small_letter_dobro => 0x2c34,
  :glagolitic_small_letter_yestu => 0x2c35,
  :glagolitic_small_letter_zhivete => 0x2c36,
  :glagolitic_small_letter_dzelo => 0x2c37,
  :glagolitic_small_letter_zemlja => 0x2c38,
  :glagolitic_small_letter_izhe => 0x2c39,
  :glagolitic_small_letter_initial_izhe => 0x2c3a,
  :glagolitic_small_letter_i => 0x2c3b,
  :glagolitic_small_letter_djervi => 0x2c3c,
  :glagolitic_small_letter_kako => 0x2c3d,
  :glagolitic_small_letter_ljudije => 0x2c3e,
  :glagolitic_small_letter_myslite => 0x2c3f,
  :glagolitic_small_letter_nashi => 0x2c40,
  :glagolitic_small_letter_onu => 0x2c41,
  :glagolitic_small_letter_pokoji => 0x2c42,
  :glagolitic_small_letter_ritsi => 0x2c43,
  :glagolitic_small_letter_slovo => 0x2c44,
  :glagolitic_small_letter_tvrido => 0x2c45,
  :glagolitic_small_letter_uku => 0x2c46,
  :glagolitic_small_letter_fritu => 0x2c47,
  :glagolitic_small_letter_heru => 0x2c48,
  :glagolitic_small_letter_otu => 0x2c49,
  :glagolitic_small_letter_pe => 0x2c4a,
  :glagolitic_small_letter_shta => 0x2c4b,
  :glagolitic_small_letter_tsi => 0x2c4c,
  :glagolitic_small_letter_chrivi => 0x2c4d,
  :glagolitic_small_letter_sha => 0x2c4e,
  :glagolitic_small_letter_yeru => 0x2c4f,
  :glagolitic_small_letter_yeri => 0x2c50,
  :glagolitic_small_letter_yati => 0x2c51,
  :glagolitic_small_letter_spidery_ha => 0x2c52,
  :glagolitic_small_letter_yu => 0x2c53,
  :glagolitic_small_letter_small_yus => 0x2c54,
  :glagolitic_small_letter_small_yus_with_tail => 0x2c55,
  :glagolitic_small_letter_yo => 0x2c56,
  :glagolitic_small_letter_iotated_small_yus => 0x2c57,
  :glagolitic_small_letter_big_yus => 0x2c58,
  :glagolitic_small_letter_iotated_big_yus => 0x2c59,
  :glagolitic_small_letter_fita => 0x2c5a,
  :glagolitic_small_letter_izhitsa => 0x2c5b,
  :glagolitic_small_letter_shtapic => 0x2c5c,
  :glagolitic_small_letter_trokutasti_a => 0x2c5d,
  :glagolitic_small_letter_latinate_myslite => 0x2c5e,
  :coptic_capital_letter_alfa => 0x2c80,
  :coptic_small_letter_alfa => 0x2c81,
  :coptic_capital_letter_vida => 0x2c82,
  :coptic_small_letter_vida => 0x2c83,
  :coptic_capital_letter_gamma => 0x2c84,
  :coptic_small_letter_gamma => 0x2c85,
  :coptic_capital_letter_dalda => 0x2c86,
  :coptic_small_letter_dalda => 0x2c87,
  :coptic_capital_letter_eie => 0x2c88,
  :coptic_small_letter_eie => 0x2c89,
  :coptic_capital_letter_sou => 0x2c8a,
  :coptic_small_letter_sou => 0x2c8b,
  :coptic_capital_letter_zata => 0x2c8c,
  :coptic_small_letter_zata => 0x2c8d,
  :coptic_capital_letter_hate => 0x2c8e,
  :coptic_small_letter_hate => 0x2c8f,
  :coptic_capital_letter_thethe => 0x2c90,
  :coptic_small_letter_thethe => 0x2c91,
  :coptic_capital_letter_iauda => 0x2c92,
  :coptic_small_letter_iauda => 0x2c93,
  :coptic_capital_letter_kapa => 0x2c94,
  :coptic_small_letter_kapa => 0x2c95,
  :coptic_capital_letter_laula => 0x2c96,
  :coptic_small_letter_laula => 0x2c97,
  :coptic_capital_letter_mi => 0x2c98,
  :coptic_small_letter_mi => 0x2c99,
  :coptic_capital_letter_ni => 0x2c9a,
  :coptic_small_letter_ni => 0x2c9b,
  :coptic_capital_letter_ksi => 0x2c9c,
  :coptic_small_letter_ksi => 0x2c9d,
  :coptic_capital_letter_o => 0x2c9e,
  :coptic_small_letter_o => 0x2c9f,
  :coptic_capital_letter_pi => 0x2ca0,
  :coptic_small_letter_pi => 0x2ca1,
  :coptic_capital_letter_ro => 0x2ca2,
  :coptic_small_letter_ro => 0x2ca3,
  :coptic_capital_letter_sima => 0x2ca4,
  :coptic_small_letter_sima => 0x2ca5,
  :coptic_capital_letter_tau => 0x2ca6,
  :coptic_small_letter_tau => 0x2ca7,
  :coptic_capital_letter_ua => 0x2ca8,
  :coptic_small_letter_ua => 0x2ca9,
  :coptic_capital_letter_fi => 0x2caa,
  :coptic_small_letter_fi => 0x2cab,
  :coptic_capital_letter_khi => 0x2cac,
  :coptic_small_letter_khi => 0x2cad,
  :coptic_capital_letter_psi => 0x2cae,
  :coptic_small_letter_psi => 0x2caf,
  :coptic_capital_letter_oou => 0x2cb0,
  :coptic_small_letter_oou => 0x2cb1,
  :coptic_capital_letter_dialect_p_alef => 0x2cb2,
  :coptic_small_letter_dialect_p_alef => 0x2cb3,
  :coptic_capital_letter_old_coptic_ain => 0x2cb4,
  :coptic_small_letter_old_coptic_ain => 0x2cb5,
  :coptic_capital_letter_cryptogrammic_eie => 0x2cb6,
  :coptic_small_letter_cryptogrammic_eie => 0x2cb7,
  :coptic_capital_letter_dialect_p_kapa => 0x2cb8,
  :coptic_small_letter_dialect_p_kapa => 0x2cb9,
  :coptic_capital_letter_dialect_p_ni => 0x2cba,
  :coptic_small_letter_dialect_p_ni => 0x2cbb,
  :coptic_capital_letter_cryptogrammic_ni => 0x2cbc,
  :coptic_small_letter_cryptogrammic_ni => 0x2cbd,
  :coptic_capital_letter_old_coptic_oou => 0x2cbe,
  :coptic_small_letter_old_coptic_oou => 0x2cbf,
  :coptic_capital_letter_sampi => 0x2cc0,
  :coptic_small_letter_sampi => 0x2cc1,
  :coptic_capital_letter_crossed_shei => 0x2cc2,
  :coptic_small_letter_crossed_shei => 0x2cc3,
  :coptic_capital_letter_old_coptic_shei => 0x2cc4,
  :coptic_small_letter_old_coptic_shei => 0x2cc5,
  :coptic_capital_letter_old_coptic_esh => 0x2cc6,
  :coptic_small_letter_old_coptic_esh => 0x2cc7,
  :coptic_capital_letter_akhmimic_khei => 0x2cc8,
  :coptic_small_letter_akhmimic_khei => 0x2cc9,
  :coptic_capital_letter_dialect_p_hori => 0x2cca,
  :coptic_small_letter_dialect_p_hori => 0x2ccb,
  :coptic_capital_letter_old_coptic_hori => 0x2ccc,
  :coptic_small_letter_old_coptic_hori => 0x2ccd,
  :coptic_capital_letter_old_coptic_ha => 0x2cce,
  :coptic_small_letter_old_coptic_ha => 0x2ccf,
  :coptic_capital_letter_l_shaped_ha => 0x2cd0,
  :coptic_small_letter_l_shaped_ha => 0x2cd1,
  :coptic_capital_letter_old_coptic_hei => 0x2cd2,
  :coptic_small_letter_old_coptic_hei => 0x2cd3,
  :coptic_capital_letter_old_coptic_hat => 0x2cd4,
  :coptic_small_letter_old_coptic_hat => 0x2cd5,
  :coptic_capital_letter_old_coptic_gangia => 0x2cd6,
  :coptic_small_letter_old_coptic_gangia => 0x2cd7,
  :coptic_capital_letter_old_coptic_dja => 0x2cd8,
  :coptic_small_letter_old_coptic_dja => 0x2cd9,
  :coptic_capital_letter_old_coptic_shima => 0x2cda,
  :coptic_small_letter_old_coptic_shima => 0x2cdb,
  :coptic_capital_letter_old_nubian_shima => 0x2cdc,
  :coptic_small_letter_old_nubian_shima => 0x2cdd,
  :coptic_capital_letter_old_nubian_ngi => 0x2cde,
  :coptic_small_letter_old_nubian_ngi => 0x2cdf,
  :coptic_capital_letter_old_nubian_nyi => 0x2ce0,
  :coptic_small_letter_old_nubian_nyi => 0x2ce1,
  :coptic_capital_letter_old_nubian_wau => 0x2ce2,
  :coptic_small_letter_old_nubian_wau => 0x2ce3,
  :coptic_symbol_kai => 0x2ce4,
  :coptic_symbol_mi_ro => 0x2ce5,
  :coptic_symbol_pi_ro => 0x2ce6,
  :coptic_symbol_stauros => 0x2ce7,
  :coptic_symbol_tau_ro => 0x2ce8,
  :coptic_symbol_khi_ro => 0x2ce9,
  :coptic_symbol_shima_sima => 0x2cea,
  :coptic_old_nubian_full_stop => 0x2cf9,
  :coptic_old_nubian_direct_question_mark => 0x2cfa,
  :coptic_old_nubian_indirect_question_mark => 0x2cfb,
  :coptic_old_nubian_verse_divider => 0x2cfc,
  :coptic_fraction_one_half => 0x2cfd,
  :coptic_full_stop => 0x2cfe,
  :coptic_morphological_divider => 0x2cff,
  :georgian_small_letter_an => 0x2d00,
  :georgian_small_letter_ban => 0x2d01,
  :georgian_small_letter_gan => 0x2d02,
  :georgian_small_letter_don => 0x2d03,
  :georgian_small_letter_en => 0x2d04,
  :georgian_small_letter_vin => 0x2d05,
  :georgian_small_letter_zen => 0x2d06,
  :georgian_small_letter_tan => 0x2d07,
  :georgian_small_letter_in => 0x2d08,
  :georgian_small_letter_kan => 0x2d09,
  :georgian_small_letter_las => 0x2d0a,
  :georgian_small_letter_man => 0x2d0b,
  :georgian_small_letter_nar => 0x2d0c,
  :georgian_small_letter_on => 0x2d0d,
  :georgian_small_letter_par => 0x2d0e,
  :georgian_small_letter_zhar => 0x2d0f,
  :georgian_small_letter_rae => 0x2d10,
  :georgian_small_letter_san => 0x2d11,
  :georgian_small_letter_tar => 0x2d12,
  :georgian_small_letter_un => 0x2d13,
  :georgian_small_letter_phar => 0x2d14,
  :georgian_small_letter_khar => 0x2d15,
  :georgian_small_letter_ghan => 0x2d16,
  :georgian_small_letter_qar => 0x2d17,
  :georgian_small_letter_shin => 0x2d18,
  :georgian_small_letter_chin => 0x2d19,
  :georgian_small_letter_can => 0x2d1a,
  :georgian_small_letter_jil => 0x2d1b,
  :georgian_small_letter_cil => 0x2d1c,
  :georgian_small_letter_char => 0x2d1d,
  :georgian_small_letter_xan => 0x2d1e,
  :georgian_small_letter_jhan => 0x2d1f,
  :georgian_small_letter_hae => 0x2d20,
  :georgian_small_letter_he => 0x2d21,
  :georgian_small_letter_hie => 0x2d22,
  :georgian_small_letter_we => 0x2d23,
  :georgian_small_letter_har => 0x2d24,
  :georgian_small_letter_hoe => 0x2d25,
  :tifinagh_letter_ya => 0x2d30,
  :tifinagh_letter_yab => 0x2d31,
  :tifinagh_letter_yabh => 0x2d32,
  :tifinagh_letter_yag => 0x2d33,
  :tifinagh_letter_yaghh => 0x2d34,
  :tifinagh_letter_berber_academy_yaj => 0x2d35,
  :tifinagh_letter_yaj => 0x2d36,
  :tifinagh_letter_yad => 0x2d37,
  :tifinagh_letter_yadh => 0x2d38,
  :tifinagh_letter_yadd => 0x2d39,
  :tifinagh_letter_yaddh => 0x2d3a,
  :tifinagh_letter_yey => 0x2d3b,
  :tifinagh_letter_yaf => 0x2d3c,
  :tifinagh_letter_yak => 0x2d3d,
  :tifinagh_letter_tuareg_yak => 0x2d3e,
  :tifinagh_letter_yakhh => 0x2d3f,
  :tifinagh_letter_yah => 0x2d40,
  :tifinagh_letter_berber_academy_yah => 0x2d41,
  :tifinagh_letter_tuareg_yah => 0x2d42,
  :tifinagh_letter_yahh => 0x2d43,
  :tifinagh_letter_yaa => 0x2d44,
  :tifinagh_letter_yakh => 0x2d45,
  :tifinagh_letter_tuareg_yakh => 0x2d46,
  :tifinagh_letter_yaq => 0x2d47,
  :tifinagh_letter_tuareg_yaq => 0x2d48,
  :tifinagh_letter_yi => 0x2d49,
  :tifinagh_letter_yazh => 0x2d4a,
  :tifinagh_letter_ahaggar_yazh => 0x2d4b,
  :tifinagh_letter_tuareg_yazh => 0x2d4c,
  :tifinagh_letter_yal => 0x2d4d,
  :tifinagh_letter_yam => 0x2d4e,
  :tifinagh_letter_yan => 0x2d4f,
  :tifinagh_letter_tuareg_yagn => 0x2d50,
  :tifinagh_letter_tuareg_yang => 0x2d51,
  :tifinagh_letter_yap => 0x2d52,
  :tifinagh_letter_yu => 0x2d53,
  :tifinagh_letter_yar => 0x2d54,
  :tifinagh_letter_yarr => 0x2d55,
  :tifinagh_letter_yagh => 0x2d56,
  :tifinagh_letter_tuareg_yagh => 0x2d57,
  :tifinagh_letter_ayer_yagh => 0x2d58,
  :tifinagh_letter_yas => 0x2d59,
  :tifinagh_letter_yass => 0x2d5a,
  :tifinagh_letter_yash => 0x2d5b,
  :tifinagh_letter_yat => 0x2d5c,
  :tifinagh_letter_yath => 0x2d5d,
  :tifinagh_letter_yach => 0x2d5e,
  :tifinagh_letter_yatt => 0x2d5f,
  :tifinagh_letter_yav => 0x2d60,
  :tifinagh_letter_yaw => 0x2d61,
  :tifinagh_letter_yay => 0x2d62,
  :tifinagh_letter_yaz => 0x2d63,
  :tifinagh_letter_tawellemet_yaz => 0x2d64,
  :tifinagh_letter_yazz => 0x2d65,
  :tifinagh_modifier_letter_labialization_mark => 0x2d6f,
  :ethiopic_syllable_loa => 0x2d80,
  :ethiopic_syllable_moa => 0x2d81,
  :ethiopic_syllable_roa => 0x2d82,
  :ethiopic_syllable_soa => 0x2d83,
  :ethiopic_syllable_shoa => 0x2d84,
  :ethiopic_syllable_boa => 0x2d85,
  :ethiopic_syllable_toa => 0x2d86,
  :ethiopic_syllable_coa => 0x2d87,
  :ethiopic_syllable_noa => 0x2d88,
  :ethiopic_syllable_nyoa => 0x2d89,
  :ethiopic_syllable_glottal_oa => 0x2d8a,
  :ethiopic_syllable_zoa => 0x2d8b,
  :ethiopic_syllable_doa => 0x2d8c,
  :ethiopic_syllable_ddoa => 0x2d8d,
  :ethiopic_syllable_joa => 0x2d8e,
  :ethiopic_syllable_thoa => 0x2d8f,
  :ethiopic_syllable_choa => 0x2d90,
  :ethiopic_syllable_phoa => 0x2d91,
  :ethiopic_syllable_poa => 0x2d92,
  :ethiopic_syllable_ggwa => 0x2d93,
  :ethiopic_syllable_ggwi => 0x2d94,
  :ethiopic_syllable_ggwee => 0x2d95,
  :ethiopic_syllable_ggwe => 0x2d96,
  :ethiopic_syllable_ssa => 0x2da0,
  :ethiopic_syllable_ssu => 0x2da1,
  :ethiopic_syllable_ssi => 0x2da2,
  :ethiopic_syllable_ssaa => 0x2da3,
  :ethiopic_syllable_ssee => 0x2da4,
  :ethiopic_syllable_sse => 0x2da5,
  :ethiopic_syllable_sso => 0x2da6,
  :ethiopic_syllable_cca => 0x2da8,
  :ethiopic_syllable_ccu => 0x2da9,
  :ethiopic_syllable_cci => 0x2daa,
  :ethiopic_syllable_ccaa => 0x2dab,
  :ethiopic_syllable_ccee => 0x2dac,
  :ethiopic_syllable_cce => 0x2dad,
  :ethiopic_syllable_cco => 0x2dae,
  :ethiopic_syllable_zza => 0x2db0,
  :ethiopic_syllable_zzu => 0x2db1,
  :ethiopic_syllable_zzi => 0x2db2,
  :ethiopic_syllable_zzaa => 0x2db3,
  :ethiopic_syllable_zzee => 0x2db4,
  :ethiopic_syllable_zze => 0x2db5,
  :ethiopic_syllable_zzo => 0x2db6,
  :ethiopic_syllable_ccha => 0x2db8,
  :ethiopic_syllable_cchu => 0x2db9,
  :ethiopic_syllable_cchi => 0x2dba,
  :ethiopic_syllable_cchaa => 0x2dbb,
  :ethiopic_syllable_cchee => 0x2dbc,
  :ethiopic_syllable_cche => 0x2dbd,
  :ethiopic_syllable_ccho => 0x2dbe,
  :ethiopic_syllable_qya => 0x2dc0,
  :ethiopic_syllable_qyu => 0x2dc1,
  :ethiopic_syllable_qyi => 0x2dc2,
  :ethiopic_syllable_qyaa => 0x2dc3,
  :ethiopic_syllable_qyee => 0x2dc4,
  :ethiopic_syllable_qye => 0x2dc5,
  :ethiopic_syllable_qyo => 0x2dc6,
  :ethiopic_syllable_kya => 0x2dc8,
  :ethiopic_syllable_kyu => 0x2dc9,
  :ethiopic_syllable_kyi => 0x2dca,
  :ethiopic_syllable_kyaa => 0x2dcb,
  :ethiopic_syllable_kyee => 0x2dcc,
  :ethiopic_syllable_kye => 0x2dcd,
  :ethiopic_syllable_kyo => 0x2dce,
  :ethiopic_syllable_xya => 0x2dd0,
  :ethiopic_syllable_xyu => 0x2dd1,
  :ethiopic_syllable_xyi => 0x2dd2,
  :ethiopic_syllable_xyaa => 0x2dd3,
  :ethiopic_syllable_xyee => 0x2dd4,
  :ethiopic_syllable_xye => 0x2dd5,
  :ethiopic_syllable_xyo => 0x2dd6,
  :ethiopic_syllable_gya => 0x2dd8,
  :ethiopic_syllable_gyu => 0x2dd9,
  :ethiopic_syllable_gyi => 0x2dda,
  :ethiopic_syllable_gyaa => 0x2ddb,
  :ethiopic_syllable_gyee => 0x2ddc,
  :ethiopic_syllable_gye => 0x2ddd,
  :ethiopic_syllable_gyo => 0x2dde,
  :right_angle_substitution_marker => 0x2e00,
  :right_angle_dotted_substitution_marker => 0x2e01,
  :left_substitution_bracket => 0x2e02,
  :right_substitution_bracket => 0x2e03,
  :left_dotted_substitution_bracket => 0x2e04,
  :right_dotted_substitution_bracket => 0x2e05,
  :raised_interpolation_marker => 0x2e06,
  :raised_dotted_interpolation_marker => 0x2e07,
  :dotted_transposition_marker => 0x2e08,
  :left_transposition_bracket => 0x2e09,
  :right_transposition_bracket => 0x2e0a,
  :raised_square => 0x2e0b,
  :left_raised_omission_bracket => 0x2e0c,
  :right_raised_omission_bracket => 0x2e0d,
  :editorial_coronis => 0x2e0e,
  :paragraphos => 0x2e0f,
  :forked_paragraphos => 0x2e10,
  :reversed_forked_paragraphos => 0x2e11,
  :hypodiastole => 0x2e12,
  :dotted_obelos => 0x2e13,
  :downwards_ancora => 0x2e14,
  :upwards_ancora => 0x2e15,
  :dotted_right_pointing_angle => 0x2e16,
  :double_oblique_hyphen => 0x2e17,
  :left_low_paraphrase_bracket => 0x2e1c,
  :right_low_paraphrase_bracket => 0x2e1d,
  :cjk_radical_repeat => 0x2e80,
  :cjk_radical_cliff => 0x2e81,
  :cjk_radical_second_one => 0x2e82,
  :cjk_radical_second_two => 0x2e83,
  :cjk_radical_second_three => 0x2e84,
  :cjk_radical_person => 0x2e85,
  :cjk_radical_box => 0x2e86,
  :cjk_radical_table => 0x2e87,
  :cjk_radical_knife_one => 0x2e88,
  :cjk_radical_knife_two => 0x2e89,
  :cjk_radical_divination => 0x2e8a,
  :cjk_radical_seal => 0x2e8b,
  :cjk_radical_small_one => 0x2e8c,
  :cjk_radical_small_two => 0x2e8d,
  :cjk_radical_lame_one => 0x2e8e,
  :cjk_radical_lame_two => 0x2e8f,
  :cjk_radical_lame_three => 0x2e90,
  :cjk_radical_lame_four => 0x2e91,
  :cjk_radical_snake => 0x2e92,
  :cjk_radical_thread => 0x2e93,
  :cjk_radical_snout_one => 0x2e94,
  :cjk_radical_snout_two => 0x2e95,
  :cjk_radical_heart_one => 0x2e96,
  :cjk_radical_heart_two => 0x2e97,
  :cjk_radical_hand => 0x2e98,
  :cjk_radical_rap => 0x2e99,
  :cjk_radical_choke => 0x2e9b,
  :cjk_radical_sun => 0x2e9c,
  :cjk_radical_moon => 0x2e9d,
  :cjk_radical_death => 0x2e9e,
  :cjk_radical_mother => 0x2e9f,
  :cjk_radical_civilian => 0x2ea0,
  :cjk_radical_water_one => 0x2ea1,
  :cjk_radical_water_two => 0x2ea2,
  :cjk_radical_fire => 0x2ea3,
  :cjk_radical_paw_one => 0x2ea4,
  :cjk_radical_paw_two => 0x2ea5,
  :cjk_radical_simplified_half_tree_trunk => 0x2ea6,
  :cjk_radical_cow => 0x2ea7,
  :cjk_radical_dog => 0x2ea8,
  :cjk_radical_jade => 0x2ea9,
  :cjk_radical_bolt_of_cloth => 0x2eaa,
  :cjk_radical_eye => 0x2eab,
  :cjk_radical_spirit_one => 0x2eac,
  :cjk_radical_spirit_two => 0x2ead,
  :cjk_radical_bamboo => 0x2eae,
  :cjk_radical_silk => 0x2eaf,
  :cjk_radical_c_simplified_silk => 0x2eb0,
  :cjk_radical_net_one => 0x2eb1,
  :cjk_radical_net_two => 0x2eb2,
  :cjk_radical_net_three => 0x2eb3,
  :cjk_radical_net_four => 0x2eb4,
  :cjk_radical_mesh => 0x2eb5,
  :cjk_radical_sheep => 0x2eb6,
  :cjk_radical_ram => 0x2eb7,
  :cjk_radical_ewe => 0x2eb8,
  :cjk_radical_old => 0x2eb9,
  :cjk_radical_brush_one => 0x2eba,
  :cjk_radical_brush_two => 0x2ebb,
  :cjk_radical_meat => 0x2ebc,
  :cjk_radical_mortar => 0x2ebd,
  :cjk_radical_grass_one => 0x2ebe,
  :cjk_radical_grass_two => 0x2ebf,
  :cjk_radical_grass_three => 0x2ec0,
  :cjk_radical_tiger => 0x2ec1,
  :cjk_radical_clothes => 0x2ec2,
  :cjk_radical_west_one => 0x2ec3,
  :cjk_radical_west_two => 0x2ec4,
  :cjk_radical_c_simplified_see => 0x2ec5,
  :cjk_radical_simplified_horn => 0x2ec6,
  :cjk_radical_horn => 0x2ec7,
  :cjk_radical_c_simplified_speech => 0x2ec8,
  :cjk_radical_c_simplified_shell => 0x2ec9,
  :cjk_radical_foot => 0x2eca,
  :cjk_radical_c_simplified_cart => 0x2ecb,
  :cjk_radical_simplified_walk => 0x2ecc,
  :cjk_radical_walk_one => 0x2ecd,
  :cjk_radical_walk_two => 0x2ece,
  :cjk_radical_city => 0x2ecf,
  :cjk_radical_c_simplified_gold => 0x2ed0,
  :cjk_radical_long_one => 0x2ed1,
  :cjk_radical_long_two => 0x2ed2,
  :cjk_radical_c_simplified_long => 0x2ed3,
  :cjk_radical_c_simplified_gate => 0x2ed4,
  :cjk_radical_mound_one => 0x2ed5,
  :cjk_radical_mound_two => 0x2ed6,
  :cjk_radical_rain => 0x2ed7,
  :cjk_radical_blue => 0x2ed8,
  :cjk_radical_c_simplified_tanned_leather => 0x2ed9,
  :cjk_radical_c_simplified_leaf => 0x2eda,
  :cjk_radical_c_simplified_wind => 0x2edb,
  :cjk_radical_c_simplified_fly => 0x2edc,
  :cjk_radical_eat_one => 0x2edd,
  :cjk_radical_eat_two => 0x2ede,
  :cjk_radical_eat_three => 0x2edf,
  :cjk_radical_c_simplified_eat => 0x2ee0,
  :cjk_radical_head => 0x2ee1,
  :cjk_radical_c_simplified_horse => 0x2ee2,
  :cjk_radical_bone => 0x2ee3,
  :cjk_radical_ghost => 0x2ee4,
  :cjk_radical_c_simplified_fish => 0x2ee5,
  :cjk_radical_c_simplified_bird => 0x2ee6,
  :cjk_radical_c_simplified_salt => 0x2ee7,
  :cjk_radical_simplified_wheat => 0x2ee8,
  :cjk_radical_simplified_yellow => 0x2ee9,
  :cjk_radical_c_simplified_frog => 0x2eea,
  :cjk_radical_j_simplified_even => 0x2eeb,
  :cjk_radical_c_simplified_even => 0x2eec,
  :cjk_radical_j_simplified_tooth => 0x2eed,
  :cjk_radical_c_simplified_tooth => 0x2eee,
  :cjk_radical_j_simplified_dragon => 0x2eef,
  :cjk_radical_c_simplified_dragon => 0x2ef0,
  :cjk_radical_turtle => 0x2ef1,
  :cjk_radical_j_simplified_turtle => 0x2ef2,
  :cjk_radical_c_simplified_turtle => 0x2ef3,
  :kangxi_radical_one => 0x2f00,
  :kangxi_radical_line => 0x2f01,
  :kangxi_radical_dot => 0x2f02,
  :kangxi_radical_slash => 0x2f03,
  :kangxi_radical_second => 0x2f04,
  :kangxi_radical_hook => 0x2f05,
  :kangxi_radical_two => 0x2f06,
  :kangxi_radical_lid => 0x2f07,
  :kangxi_radical_man => 0x2f08,
  :kangxi_radical_legs => 0x2f09,
  :kangxi_radical_enter => 0x2f0a,
  :kangxi_radical_eight => 0x2f0b,
  :kangxi_radical_down_box => 0x2f0c,
  :kangxi_radical_cover => 0x2f0d,
  :kangxi_radical_ice => 0x2f0e,
  :kangxi_radical_table => 0x2f0f,
  :kangxi_radical_open_box => 0x2f10,
  :kangxi_radical_knife => 0x2f11,
  :kangxi_radical_power => 0x2f12,
  :kangxi_radical_wrap => 0x2f13,
  :kangxi_radical_spoon => 0x2f14,
  :kangxi_radical_right_open_box => 0x2f15,
  :kangxi_radical_hiding_enclosure => 0x2f16,
  :kangxi_radical_ten => 0x2f17,
  :kangxi_radical_divination => 0x2f18,
  :kangxi_radical_seal => 0x2f19,
  :kangxi_radical_cliff => 0x2f1a,
  :kangxi_radical_private => 0x2f1b,
  :kangxi_radical_again => 0x2f1c,
  :kangxi_radical_mouth => 0x2f1d,
  :kangxi_radical_enclosure => 0x2f1e,
  :kangxi_radical_earth => 0x2f1f,
  :kangxi_radical_scholar => 0x2f20,
  :kangxi_radical_go => 0x2f21,
  :kangxi_radical_go_slowly => 0x2f22,
  :kangxi_radical_evening => 0x2f23,
  :kangxi_radical_big => 0x2f24,
  :kangxi_radical_woman => 0x2f25,
  :kangxi_radical_child => 0x2f26,
  :kangxi_radical_roof => 0x2f27,
  :kangxi_radical_inch => 0x2f28,
  :kangxi_radical_small => 0x2f29,
  :kangxi_radical_lame => 0x2f2a,
  :kangxi_radical_corpse => 0x2f2b,
  :kangxi_radical_sprout => 0x2f2c,
  :kangxi_radical_mountain => 0x2f2d,
  :kangxi_radical_river => 0x2f2e,
  :kangxi_radical_work => 0x2f2f,
  :kangxi_radical_oneself => 0x2f30,
  :kangxi_radical_turban => 0x2f31,
  :kangxi_radical_dry => 0x2f32,
  :kangxi_radical_short_thread => 0x2f33,
  :kangxi_radical_dotted_cliff => 0x2f34,
  :kangxi_radical_long_stride => 0x2f35,
  :kangxi_radical_two_hands => 0x2f36,
  :kangxi_radical_shoot => 0x2f37,
  :kangxi_radical_bow => 0x2f38,
  :kangxi_radical_snout => 0x2f39,
  :kangxi_radical_bristle => 0x2f3a,
  :kangxi_radical_step => 0x2f3b,
  :kangxi_radical_heart => 0x2f3c,
  :kangxi_radical_halberd => 0x2f3d,
  :kangxi_radical_door => 0x2f3e,
  :kangxi_radical_hand => 0x2f3f,
  :kangxi_radical_branch => 0x2f40,
  :kangxi_radical_rap => 0x2f41,
  :kangxi_radical_script => 0x2f42,
  :kangxi_radical_dipper => 0x2f43,
  :kangxi_radical_axe => 0x2f44,
  :kangxi_radical_square => 0x2f45,
  :kangxi_radical_not => 0x2f46,
  :kangxi_radical_sun => 0x2f47,
  :kangxi_radical_say => 0x2f48,
  :kangxi_radical_moon => 0x2f49,
  :kangxi_radical_tree => 0x2f4a,
  :kangxi_radical_lack => 0x2f4b,
  :kangxi_radical_stop => 0x2f4c,
  :kangxi_radical_death => 0x2f4d,
  :kangxi_radical_weapon => 0x2f4e,
  :kangxi_radical_do_not => 0x2f4f,
  :kangxi_radical_compare => 0x2f50,
  :kangxi_radical_fur => 0x2f51,
  :kangxi_radical_clan => 0x2f52,
  :kangxi_radical_steam => 0x2f53,
  :kangxi_radical_water => 0x2f54,
  :kangxi_radical_fire => 0x2f55,
  :kangxi_radical_claw => 0x2f56,
  :kangxi_radical_father => 0x2f57,
  :kangxi_radical_double_x => 0x2f58,
  :kangxi_radical_half_tree_trunk => 0x2f59,
  :kangxi_radical_slice => 0x2f5a,
  :kangxi_radical_fang => 0x2f5b,
  :kangxi_radical_cow => 0x2f5c,
  :kangxi_radical_dog => 0x2f5d,
  :kangxi_radical_profound => 0x2f5e,
  :kangxi_radical_jade => 0x2f5f,
  :kangxi_radical_melon => 0x2f60,
  :kangxi_radical_tile => 0x2f61,
  :kangxi_radical_sweet => 0x2f62,
  :kangxi_radical_life => 0x2f63,
  :kangxi_radical_use => 0x2f64,
  :kangxi_radical_field => 0x2f65,
  :kangxi_radical_bolt_of_cloth => 0x2f66,
  :kangxi_radical_sickness => 0x2f67,
  :kangxi_radical_dotted_tent => 0x2f68,
  :kangxi_radical_white => 0x2f69,
  :kangxi_radical_skin => 0x2f6a,
  :kangxi_radical_dish => 0x2f6b,
  :kangxi_radical_eye => 0x2f6c,
  :kangxi_radical_spear => 0x2f6d,
  :kangxi_radical_arrow => 0x2f6e,
  :kangxi_radical_stone => 0x2f6f,
  :kangxi_radical_spirit => 0x2f70,
  :kangxi_radical_track => 0x2f71,
  :kangxi_radical_grain => 0x2f72,
  :kangxi_radical_cave => 0x2f73,
  :kangxi_radical_stand => 0x2f74,
  :kangxi_radical_bamboo => 0x2f75,
  :kangxi_radical_rice => 0x2f76,
  :kangxi_radical_silk => 0x2f77,
  :kangxi_radical_jar => 0x2f78,
  :kangxi_radical_net => 0x2f79,
  :kangxi_radical_sheep => 0x2f7a,
  :kangxi_radical_feather => 0x2f7b,
  :kangxi_radical_old => 0x2f7c,
  :kangxi_radical_and => 0x2f7d,
  :kangxi_radical_plow => 0x2f7e,
  :kangxi_radical_ear => 0x2f7f,
  :kangxi_radical_brush => 0x2f80,
  :kangxi_radical_meat => 0x2f81,
  :kangxi_radical_minister => 0x2f82,
  :kangxi_radical_self => 0x2f83,
  :kangxi_radical_arrive => 0x2f84,
  :kangxi_radical_mortar => 0x2f85,
  :kangxi_radical_tongue => 0x2f86,
  :kangxi_radical_oppose => 0x2f87,
  :kangxi_radical_boat => 0x2f88,
  :kangxi_radical_stopping => 0x2f89,
  :kangxi_radical_color => 0x2f8a,
  :kangxi_radical_grass => 0x2f8b,
  :kangxi_radical_tiger => 0x2f8c,
  :kangxi_radical_insect => 0x2f8d,
  :kangxi_radical_blood => 0x2f8e,
  :kangxi_radical_walk_enclosure => 0x2f8f,
  :kangxi_radical_clothes => 0x2f90,
  :kangxi_radical_west => 0x2f91,
  :kangxi_radical_see => 0x2f92,
  :kangxi_radical_horn => 0x2f93,
  :kangxi_radical_speech => 0x2f94,
  :kangxi_radical_valley => 0x2f95,
  :kangxi_radical_bean => 0x2f96,
  :kangxi_radical_pig => 0x2f97,
  :kangxi_radical_badger => 0x2f98,
  :kangxi_radical_shell => 0x2f99,
  :kangxi_radical_red => 0x2f9a,
  :kangxi_radical_run => 0x2f9b,
  :kangxi_radical_foot => 0x2f9c,
  :kangxi_radical_body => 0x2f9d,
  :kangxi_radical_cart => 0x2f9e,
  :kangxi_radical_bitter => 0x2f9f,
  :kangxi_radical_morning => 0x2fa0,
  :kangxi_radical_walk => 0x2fa1,
  :kangxi_radical_city => 0x2fa2,
  :kangxi_radical_wine => 0x2fa3,
  :kangxi_radical_distinguish => 0x2fa4,
  :kangxi_radical_village => 0x2fa5,
  :kangxi_radical_gold => 0x2fa6,
  :kangxi_radical_long => 0x2fa7,
  :kangxi_radical_gate => 0x2fa8,
  :kangxi_radical_mound => 0x2fa9,
  :kangxi_radical_slave => 0x2faa,
  :kangxi_radical_short_tailed_bird => 0x2fab,
  :kangxi_radical_rain => 0x2fac,
  :kangxi_radical_blue => 0x2fad,
  :kangxi_radical_wrong => 0x2fae,
  :kangxi_radical_face => 0x2faf,
  :kangxi_radical_leather => 0x2fb0,
  :kangxi_radical_tanned_leather => 0x2fb1,
  :kangxi_radical_leek => 0x2fb2,
  :kangxi_radical_sound => 0x2fb3,
  :kangxi_radical_leaf => 0x2fb4,
  :kangxi_radical_wind => 0x2fb5,
  :kangxi_radical_fly => 0x2fb6,
  :kangxi_radical_eat => 0x2fb7,
  :kangxi_radical_head => 0x2fb8,
  :kangxi_radical_fragrant => 0x2fb9,
  :kangxi_radical_horse => 0x2fba,
  :kangxi_radical_bone => 0x2fbb,
  :kangxi_radical_tall => 0x2fbc,
  :kangxi_radical_hair => 0x2fbd,
  :kangxi_radical_fight => 0x2fbe,
  :kangxi_radical_sacrificial_wine => 0x2fbf,
  :kangxi_radical_cauldron => 0x2fc0,
  :kangxi_radical_ghost => 0x2fc1,
  :kangxi_radical_fish => 0x2fc2,
  :kangxi_radical_bird => 0x2fc3,
  :kangxi_radical_salt => 0x2fc4,
  :kangxi_radical_deer => 0x2fc5,
  :kangxi_radical_wheat => 0x2fc6,
  :kangxi_radical_hemp => 0x2fc7,
  :kangxi_radical_yellow => 0x2fc8,
  :kangxi_radical_millet => 0x2fc9,
  :kangxi_radical_black => 0x2fca,
  :kangxi_radical_embroidery => 0x2fcb,
  :kangxi_radical_frog => 0x2fcc,
  :kangxi_radical_tripod => 0x2fcd,
  :kangxi_radical_drum => 0x2fce,
  :kangxi_radical_rat => 0x2fcf,
  :kangxi_radical_nose => 0x2fd0,
  :kangxi_radical_even => 0x2fd1,
  :kangxi_radical_tooth => 0x2fd2,
  :kangxi_radical_dragon => 0x2fd3,
  :kangxi_radical_turtle => 0x2fd4,
  :kangxi_radical_flute => 0x2fd5,
  :ideographic_description_character_left_to_right => 0x2ff0,
  :ideographic_description_character_above_to_below => 0x2ff1,
  :ideographic_description_character_left_to_middle_and_right => 0x2ff2,
  :ideographic_description_character_above_to_middle_and_below => 0x2ff3,
  :ideographic_description_character_full_surround => 0x2ff4,
  :ideographic_description_character_surround_from_above => 0x2ff5,
  :ideographic_description_character_surround_from_below => 0x2ff6,
  :ideographic_description_character_surround_from_left => 0x2ff7,
  :ideographic_description_character_surround_from_upper_left => 0x2ff8,
  :ideographic_description_character_surround_from_upper_right => 0x2ff9,
  :ideographic_description_character_surround_from_lower_left => 0x2ffa,
  :ideographic_description_character_overlaid => 0x2ffb,
  :ideographic_space => 0x3000,
  :ideographic_comma => 0x3001,
  :ideographic_full_stop => 0x3002,
  :ideographic_period => 0x3002,
  :ditto_mark => 0x3003,
  :japanese_industrial_standard_symbol => 0x3004,
  :ideographic_iteration_mark => 0x3005,
  :ideographic_closing_mark => 0x3006,
  :ideographic_number_zero => 0x3007,
  :left_angle_bracket => 0x3008,
  :opening_angle_bracket => 0x3008,
  :right_angle_bracket => 0x3009,
  :closing_angle_bracket => 0x3009,
  :left_double_angle_bracket => 0x300a,
  :opening_double_angle_bracket => 0x300a,
  :right_double_angle_bracket => 0x300b,
  :closing_double_angle_bracket => 0x300b,
  :left_corner_bracket => 0x300c,
  :opening_corner_bracket => 0x300c,
  :right_corner_bracket => 0x300d,
  :closing_corner_bracket => 0x300d,
  :left_white_corner_bracket => 0x300e,
  :opening_white_corner_bracket => 0x300e,
  :right_white_corner_bracket => 0x300f,
  :closing_white_corner_bracket => 0x300f,
  :left_black_lenticular_bracket => 0x3010,
  :opening_black_lenticular_bracket => 0x3010,
  :right_black_lenticular_bracket => 0x3011,
  :closing_black_lenticular_bracket => 0x3011,
  :postal_mark => 0x3012,
  :geta_mark => 0x3013,
  :left_tortoise_shell_bracket => 0x3014,
  :opening_tortoise_shell_bracket => 0x3014,
  :right_tortoise_shell_bracket => 0x3015,
  :closing_tortoise_shell_bracket => 0x3015,
  :left_white_lenticular_bracket => 0x3016,
  :opening_white_lenticular_bracket => 0x3016,
  :right_white_lenticular_bracket => 0x3017,
  :closing_white_lenticular_bracket => 0x3017,
  :left_white_tortoise_shell_bracket => 0x3018,
  :opening_white_tortoise_shell_bracket => 0x3018,
  :right_white_tortoise_shell_bracket => 0x3019,
  :closing_white_tortoise_shell_bracket => 0x3019,
  :left_white_square_bracket => 0x301a,
  :opening_white_square_bracket => 0x301a,
  :right_white_square_bracket => 0x301b,
  :closing_white_square_bracket => 0x301b,
  :wave_dash => 0x301c,
  :reversed_double_prime_quotation_mark => 0x301d,
  :double_prime_quotation_mark => 0x301e,
  :low_double_prime_quotation_mark => 0x301f,
  :postal_mark_face => 0x3020,
  :hangzhou_numeral_one => 0x3021,
  :hangzhou_numeral_two => 0x3022,
  :hangzhou_numeral_three => 0x3023,
  :hangzhou_numeral_four => 0x3024,
  :hangzhou_numeral_five => 0x3025,
  :hangzhou_numeral_six => 0x3026,
  :hangzhou_numeral_seven => 0x3027,
  :hangzhou_numeral_eight => 0x3028,
  :hangzhou_numeral_nine => 0x3029,
  :ideographic_level_tone_mark => 0x302a,
  :ideographic_rising_tone_mark => 0x302b,
  :ideographic_departing_tone_mark => 0x302c,
  :ideographic_entering_tone_mark => 0x302d,
  :hangul_single_dot_tone_mark => 0x302e,
  :hangul_double_dot_tone_mark => 0x302f,
  :wavy_dash => 0x3030,
  :vertical_kana_repeat_mark => 0x3031,
  :vertical_kana_repeat_with_voiced_sound_mark => 0x3032,
  :vertical_kana_repeat_mark_upper_half => 0x3033,
  :vertical_kana_repeat_with_voiced_sound_mark_upper_half => 0x3034,
  :vertical_kana_repeat_mark_lower_half => 0x3035,
  :circled_postal_mark => 0x3036,
  :ideographic_telegraph_line_feed_separator_symbol => 0x3037,
  :hangzhou_numeral_ten => 0x3038,
  :hangzhou_numeral_twenty => 0x3039,
  :hangzhou_numeral_thirty => 0x303a,
  :vertical_ideographic_iteration_mark => 0x303b,
  :masu_mark => 0x303c,
  :part_alternation_mark => 0x303d,
  :ideographic_variation_indicator => 0x303e,
  :ideographic_half_fill_space => 0x303f,
  :hiragana_letter_small_a => 0x3041,
  :hiragana_letter_a => 0x3042,
  :hiragana_letter_small_i => 0x3043,
  :hiragana_letter_i => 0x3044,
  :hiragana_letter_small_u => 0x3045,
  :hiragana_letter_u => 0x3046,
  :hiragana_letter_small_e => 0x3047,
  :hiragana_letter_e => 0x3048,
  :hiragana_letter_small_o => 0x3049,
  :hiragana_letter_o => 0x304a,
  :hiragana_letter_ka => 0x304b,
  :hiragana_letter_ga => 0x304c,
  :hiragana_letter_ki => 0x304d,
  :hiragana_letter_gi => 0x304e,
  :hiragana_letter_ku => 0x304f,
  :hiragana_letter_gu => 0x3050,
  :hiragana_letter_ke => 0x3051,
  :hiragana_letter_ge => 0x3052,
  :hiragana_letter_ko => 0x3053,
  :hiragana_letter_go => 0x3054,
  :hiragana_letter_sa => 0x3055,
  :hiragana_letter_za => 0x3056,
  :hiragana_letter_si => 0x3057,
  :hiragana_letter_zi => 0x3058,
  :hiragana_letter_su => 0x3059,
  :hiragana_letter_zu => 0x305a,
  :hiragana_letter_se => 0x305b,
  :hiragana_letter_ze => 0x305c,
  :hiragana_letter_so => 0x305d,
  :hiragana_letter_zo => 0x305e,
  :hiragana_letter_ta => 0x305f,
  :hiragana_letter_da => 0x3060,
  :hiragana_letter_ti => 0x3061,
  :hiragana_letter_di => 0x3062,
  :hiragana_letter_small_tu => 0x3063,
  :hiragana_letter_tu => 0x3064,
  :hiragana_letter_du => 0x3065,
  :hiragana_letter_te => 0x3066,
  :hiragana_letter_de => 0x3067,
  :hiragana_letter_to => 0x3068,
  :hiragana_letter_do => 0x3069,
  :hiragana_letter_na => 0x306a,
  :hiragana_letter_ni => 0x306b,
  :hiragana_letter_nu => 0x306c,
  :hiragana_letter_ne => 0x306d,
  :hiragana_letter_no => 0x306e,
  :hiragana_letter_ha => 0x306f,
  :hiragana_letter_ba => 0x3070,
  :hiragana_letter_pa => 0x3071,
  :hiragana_letter_hi => 0x3072,
  :hiragana_letter_bi => 0x3073,
  :hiragana_letter_pi => 0x3074,
  :hiragana_letter_hu => 0x3075,
  :hiragana_letter_bu => 0x3076,
  :hiragana_letter_pu => 0x3077,
  :hiragana_letter_he => 0x3078,
  :hiragana_letter_be => 0x3079,
  :hiragana_letter_pe => 0x307a,
  :hiragana_letter_ho => 0x307b,
  :hiragana_letter_bo => 0x307c,
  :hiragana_letter_po => 0x307d,
  :hiragana_letter_ma => 0x307e,
  :hiragana_letter_mi => 0x307f,
  :hiragana_letter_mu => 0x3080,
  :hiragana_letter_me => 0x3081,
  :hiragana_letter_mo => 0x3082,
  :hiragana_letter_small_ya => 0x3083,
  :hiragana_letter_ya => 0x3084,
  :hiragana_letter_small_yu => 0x3085,
  :hiragana_letter_yu => 0x3086,
  :hiragana_letter_small_yo => 0x3087,
  :hiragana_letter_yo => 0x3088,
  :hiragana_letter_ra => 0x3089,
  :hiragana_letter_ri => 0x308a,
  :hiragana_letter_ru => 0x308b,
  :hiragana_letter_re => 0x308c,
  :hiragana_letter_ro => 0x308d,
  :hiragana_letter_small_wa => 0x308e,
  :hiragana_letter_wa => 0x308f,
  :hiragana_letter_wi => 0x3090,
  :hiragana_letter_we => 0x3091,
  :hiragana_letter_wo => 0x3092,
  :hiragana_letter_n => 0x3093,
  :hiragana_letter_vu => 0x3094,
  :hiragana_letter_small_ka => 0x3095,
  :hiragana_letter_small_ke => 0x3096,
  :combining_katakana_hiragana_voiced_sound_mark => 0x3099,
  :non_spacing_katakana_hiragana_voiced_sound_mark => 0x3099,
  :combining_katakana_hiragana_semi_voiced_sound_mark => 0x309a,
  :non_spacing_katakana_hiragana_semi_voiced_sound_mark => 0x309a,
  :katakana_hiragana_voiced_sound_mark => 0x309b,
  :katakana_hiragana_semi_voiced_sound_mark => 0x309c,
  :hiragana_iteration_mark => 0x309d,
  :hiragana_voiced_iteration_mark => 0x309e,
  :hiragana_digraph_yori => 0x309f,
  :katakana_hiragana_double_hyphen => 0x30a0,
  :katakana_letter_small_a => 0x30a1,
  :katakana_letter_a => 0x30a2,
  :katakana_letter_small_i => 0x30a3,
  :katakana_letter_i => 0x30a4,
  :katakana_letter_small_u => 0x30a5,
  :katakana_letter_u => 0x30a6,
  :katakana_letter_small_e => 0x30a7,
  :katakana_letter_e => 0x30a8,
  :katakana_letter_small_o => 0x30a9,
  :katakana_letter_o => 0x30aa,
  :katakana_letter_ka => 0x30ab,
  :katakana_letter_ga => 0x30ac,
  :katakana_letter_ki => 0x30ad,
  :katakana_letter_gi => 0x30ae,
  :katakana_letter_ku => 0x30af,
  :katakana_letter_gu => 0x30b0,
  :katakana_letter_ke => 0x30b1,
  :katakana_letter_ge => 0x30b2,
  :katakana_letter_ko => 0x30b3,
  :katakana_letter_go => 0x30b4,
  :katakana_letter_sa => 0x30b5,
  :katakana_letter_za => 0x30b6,
  :katakana_letter_si => 0x30b7,
  :katakana_letter_zi => 0x30b8,
  :katakana_letter_su => 0x30b9,
  :katakana_letter_zu => 0x30ba,
  :katakana_letter_se => 0x30bb,
  :katakana_letter_ze => 0x30bc,
  :katakana_letter_so => 0x30bd,
  :katakana_letter_zo => 0x30be,
  :katakana_letter_ta => 0x30bf,
  :katakana_letter_da => 0x30c0,
  :katakana_letter_ti => 0x30c1,
  :katakana_letter_di => 0x30c2,
  :katakana_letter_small_tu => 0x30c3,
  :katakana_letter_tu => 0x30c4,
  :katakana_letter_du => 0x30c5,
  :katakana_letter_te => 0x30c6,
  :katakana_letter_de => 0x30c7,
  :katakana_letter_to => 0x30c8,
  :katakana_letter_do => 0x30c9,
  :katakana_letter_na => 0x30ca,
  :katakana_letter_ni => 0x30cb,
  :katakana_letter_nu => 0x30cc,
  :katakana_letter_ne => 0x30cd,
  :katakana_letter_no => 0x30ce,
  :katakana_letter_ha => 0x30cf,
  :katakana_letter_ba => 0x30d0,
  :katakana_letter_pa => 0x30d1,
  :katakana_letter_hi => 0x30d2,
  :katakana_letter_bi => 0x30d3,
  :katakana_letter_pi => 0x30d4,
  :katakana_letter_hu => 0x30d5,
  :katakana_letter_bu => 0x30d6,
  :katakana_letter_pu => 0x30d7,
  :katakana_letter_he => 0x30d8,
  :katakana_letter_be => 0x30d9,
  :katakana_letter_pe => 0x30da,
  :katakana_letter_ho => 0x30db,
  :katakana_letter_bo => 0x30dc,
  :katakana_letter_po => 0x30dd,
  :katakana_letter_ma => 0x30de,
  :katakana_letter_mi => 0x30df,
  :katakana_letter_mu => 0x30e0,
  :katakana_letter_me => 0x30e1,
  :katakana_letter_mo => 0x30e2,
  :katakana_letter_small_ya => 0x30e3,
  :katakana_letter_ya => 0x30e4,
  :katakana_letter_small_yu => 0x30e5,
  :katakana_letter_yu => 0x30e6,
  :katakana_letter_small_yo => 0x30e7,
  :katakana_letter_yo => 0x30e8,
  :katakana_letter_ra => 0x30e9,
  :katakana_letter_ri => 0x30ea,
  :katakana_letter_ru => 0x30eb,
  :katakana_letter_re => 0x30ec,
  :katakana_letter_ro => 0x30ed,
  :katakana_letter_small_wa => 0x30ee,
  :katakana_letter_wa => 0x30ef,
  :katakana_letter_wi => 0x30f0,
  :katakana_letter_we => 0x30f1,
  :katakana_letter_wo => 0x30f2,
  :katakana_letter_n => 0x30f3,
  :katakana_letter_vu => 0x30f4,
  :katakana_letter_small_ka => 0x30f5,
  :katakana_letter_small_ke => 0x30f6,
  :katakana_letter_va => 0x30f7,
  :katakana_letter_vi => 0x30f8,
  :katakana_letter_ve => 0x30f9,
  :katakana_letter_vo => 0x30fa,
  :katakana_middle_dot => 0x30fb,
  :katakana_hiragana_prolonged_sound_mark => 0x30fc,
  :katakana_iteration_mark => 0x30fd,
  :katakana_voiced_iteration_mark => 0x30fe,
  :katakana_digraph_koto => 0x30ff,
  :bopomofo_letter_b => 0x3105,
  :bopomofo_letter_p => 0x3106,
  :bopomofo_letter_m => 0x3107,
  :bopomofo_letter_f => 0x3108,
  :bopomofo_letter_d => 0x3109,
  :bopomofo_letter_t => 0x310a,
  :bopomofo_letter_n => 0x310b,
  :bopomofo_letter_l => 0x310c,
  :bopomofo_letter_g => 0x310d,
  :bopomofo_letter_k => 0x310e,
  :bopomofo_letter_h => 0x310f,
  :bopomofo_letter_j => 0x3110,
  :bopomofo_letter_q => 0x3111,
  :bopomofo_letter_x => 0x3112,
  :bopomofo_letter_zh => 0x3113,
  :bopomofo_letter_ch => 0x3114,
  :bopomofo_letter_sh => 0x3115,
  :bopomofo_letter_r => 0x3116,
  :bopomofo_letter_z => 0x3117,
  :bopomofo_letter_c => 0x3118,
  :bopomofo_letter_s => 0x3119,
  :bopomofo_letter_a => 0x311a,
  :bopomofo_letter_o => 0x311b,
  :bopomofo_letter_e => 0x311c,
  :bopomofo_letter_eh => 0x311d,
  :bopomofo_letter_ai => 0x311e,
  :bopomofo_letter_ei => 0x311f,
  :bopomofo_letter_au => 0x3120,
  :bopomofo_letter_ou => 0x3121,
  :bopomofo_letter_an => 0x3122,
  :bopomofo_letter_en => 0x3123,
  :bopomofo_letter_ang => 0x3124,
  :bopomofo_letter_eng => 0x3125,
  :bopomofo_letter_er => 0x3126,
  :bopomofo_letter_i => 0x3127,
  :bopomofo_letter_u => 0x3128,
  :bopomofo_letter_iu => 0x3129,
  :bopomofo_letter_v => 0x312a,
  :bopomofo_letter_ng => 0x312b,
  :bopomofo_letter_gn => 0x312c,
  :hangul_letter_kiyeok => 0x3131,
  :hangul_letter_giyeog => 0x3131,
  :hangul_letter_ssangkiyeok => 0x3132,
  :hangul_letter_ssang_giyeog => 0x3132,
  :hangul_letter_kiyeok_sios => 0x3133,
  :hangul_letter_giyeog_sios => 0x3133,
  :hangul_letter_nieun => 0x3134,
  :hangul_letter_nieun_cieuc => 0x3135,
  :hangul_letter_nieun_jieuj => 0x3135,
  :hangul_letter_nieun_hieuh => 0x3136,
  :hangul_letter_nieun_hieuh => 0x3136,
  :hangul_letter_tikeut => 0x3137,
  :hangul_letter_digeud => 0x3137,
  :hangul_letter_ssangtikeut => 0x3138,
  :hangul_letter_ssang_digeud => 0x3138,
  :hangul_letter_rieul => 0x3139,
  :hangul_letter_lieul => 0x3139,
  :hangul_letter_rieul_kiyeok => 0x313a,
  :hangul_letter_lieul_giyeog => 0x313a,
  :hangul_letter_rieul_mieum => 0x313b,
  :hangul_letter_lieul_mieum => 0x313b,
  :hangul_letter_rieul_pieup => 0x313c,
  :hangul_letter_lieul_bieub => 0x313c,
  :hangul_letter_rieul_sios => 0x313d,
  :hangul_letter_lieul_sios => 0x313d,
  :hangul_letter_rieul_thieuth => 0x313e,
  :hangul_letter_lieul_tieut => 0x313e,
  :hangul_letter_rieul_phieuph => 0x313f,
  :hangul_letter_lieul_pieup => 0x313f,
  :hangul_letter_rieul_hieuh => 0x3140,
  :hangul_letter_lieul_hieuh => 0x3140,
  :hangul_letter_mieum => 0x3141,
  :hangul_letter_pieup => 0x3142,
  :hangul_letter_bieub => 0x3142,
  :hangul_letter_ssangpieup => 0x3143,
  :hangul_letter_ssang_bieub => 0x3143,
  :hangul_letter_pieup_sios => 0x3144,
  :hangul_letter_bieub_sios => 0x3144,
  :hangul_letter_sios => 0x3145,
  :hangul_letter_ssangsios => 0x3146,
  :hangul_letter_ssang_sios => 0x3146,
  :hangul_letter_ieung => 0x3147,
  :hangul_letter_cieuc => 0x3148,
  :hangul_letter_jieuj => 0x3148,
  :hangul_letter_ssangcieuc => 0x3149,
  :hangul_letter_ssang_jieuj => 0x3149,
  :hangul_letter_chieuch => 0x314a,
  :hangul_letter_cieuc => 0x314a,
  :hangul_letter_khieukh => 0x314b,
  :hangul_letter_kiyeok => 0x314b,
  :hangul_letter_thieuth => 0x314c,
  :hangul_letter_tieut => 0x314c,
  :hangul_letter_phieuph => 0x314d,
  :hangul_letter_pieup => 0x314d,
  :hangul_letter_hieuh => 0x314e,
  :hangul_letter_a => 0x314f,
  :hangul_letter_ae => 0x3150,
  :hangul_letter_ya => 0x3151,
  :hangul_letter_yae => 0x3152,
  :hangul_letter_eo => 0x3153,
  :hangul_letter_e => 0x3154,
  :hangul_letter_yeo => 0x3155,
  :hangul_letter_ye => 0x3156,
  :hangul_letter_o => 0x3157,
  :hangul_letter_wa => 0x3158,
  :hangul_letter_wae => 0x3159,
  :hangul_letter_oe => 0x315a,
  :hangul_letter_yo => 0x315b,
  :hangul_letter_u => 0x315c,
  :hangul_letter_weo => 0x315d,
  :hangul_letter_we => 0x315e,
  :hangul_letter_wi => 0x315f,
  :hangul_letter_yu => 0x3160,
  :hangul_letter_eu => 0x3161,
  :hangul_letter_yi => 0x3162,
  :hangul_letter_i => 0x3163,
  :hangul_filler => 0x3164,
  :hangul_cae_om => 0x3164,
  :hangul_letter_ssangnieun => 0x3165,
  :hangul_letter_ssang_nieun => 0x3165,
  :hangul_letter_nieun_tikeut => 0x3166,
  :hangul_letter_nieun_digeud => 0x3166,
  :hangul_letter_nieun_sios => 0x3167,
  :hangul_letter_nieun_sios => 0x3167,
  :hangul_letter_nieun_pansios => 0x3168,
  :hangul_letter_nieun_ban_chi_eum => 0x3168,
  :hangul_letter_rieul_kiyeok_sios => 0x3169,
  :hangul_letter_lieul_giyeog_sios => 0x3169,
  :hangul_letter_rieul_tikeut => 0x316a,
  :hangul_letter_lieul_digeud => 0x316a,
  :hangul_letter_rieul_pieup_sios => 0x316b,
  :hangul_letter_lieul_bieub_sios => 0x316b,
  :hangul_letter_rieul_pansios => 0x316c,
  :hangul_letter_lieul_ban_chi_eum => 0x316c,
  :hangul_letter_rieul_yeorinhieuh => 0x316d,
  :hangul_letter_lieul_yeolin_hieuh => 0x316d,
  :hangul_letter_mieum_pieup => 0x316e,
  :hangul_letter_mieum_bieub => 0x316e,
  :hangul_letter_mieum_sios => 0x316f,
  :hangul_letter_mieum_sios => 0x316f,
  :hangul_letter_mieum_pansios => 0x3170,
  :hangul_letter_bieub_ban_chi_eum => 0x3170,
  :hangul_letter_kapyeounmieum => 0x3171,
  :hangul_letter_mieum_sun_gyeong_eum => 0x3171,
  :hangul_letter_pieup_kiyeok => 0x3172,
  :hangul_letter_bieub_giyeog => 0x3172,
  :hangul_letter_pieup_tikeut => 0x3173,
  :hangul_letter_bieub_digeud => 0x3173,
  :hangul_letter_pieup_sios_kiyeok => 0x3174,
  :hangul_letter_bieub_sios_giyeog => 0x3174,
  :hangul_letter_pieup_sios_tikeut => 0x3175,
  :hangul_letter_bieub_sios_digeud => 0x3175,
  :hangul_letter_pieup_cieuc => 0x3176,
  :hangul_letter_bieub_jieuj => 0x3176,
  :hangul_letter_pieup_thieuth => 0x3177,
  :hangul_letter_bieub_tieut => 0x3177,
  :hangul_letter_kapyeounpieup => 0x3178,
  :hangul_letter_bieub_sun_gyeong_eum => 0x3178,
  :hangul_letter_kapyeounssangpieup => 0x3179,
  :hangul_letter_ssang_bieub_sun_gyeong_eum => 0x3179,
  :hangul_letter_sios_kiyeok => 0x317a,
  :hangul_letter_sios_giyeog => 0x317a,
  :hangul_letter_sios_nieun => 0x317b,
  :hangul_letter_sios_nieun => 0x317b,
  :hangul_letter_sios_tikeut => 0x317c,
  :hangul_letter_sios_digeud => 0x317c,
  :hangul_letter_sios_pieup => 0x317d,
  :hangul_letter_sios_bieub => 0x317d,
  :hangul_letter_sios_cieuc => 0x317e,
  :hangul_letter_sios_jieuj => 0x317e,
  :hangul_letter_pansios => 0x317f,
  :hangul_letter_ban_chi_eum => 0x317f,
  :hangul_letter_ssangieung => 0x3180,
  :hangul_letter_ssang_ieung => 0x3180,
  :hangul_letter_yesieung => 0x3181,
  :hangul_letter_ngieung => 0x3181,
  :hangul_letter_yesieung_sios => 0x3182,
  :hangul_letter_ngieung_sios => 0x3182,
  :hangul_letter_yesieung_pansios => 0x3183,
  :hangul_letter_ngieung_ban_chi_eum => 0x3183,
  :hangul_letter_kapyeounphieuph => 0x3184,
  :hangul_letter_pieup_sun_gyeong_eum => 0x3184,
  :hangul_letter_ssanghieuh => 0x3185,
  :hangul_letter_ssang_hieuh => 0x3185,
  :hangul_letter_yeorinhieuh => 0x3186,
  :hangul_letter_yeolin_hieuh => 0x3186,
  :hangul_letter_yo_ya => 0x3187,
  :hangul_letter_yoya => 0x3187,
  :hangul_letter_yo_yae => 0x3188,
  :hangul_letter_yoyae => 0x3188,
  :hangul_letter_yo_i => 0x3189,
  :hangul_letter_yoi => 0x3189,
  :hangul_letter_yu_yeo => 0x318a,
  :hangul_letter_yuyeo => 0x318a,
  :hangul_letter_yu_ye => 0x318b,
  :hangul_letter_yuye => 0x318b,
  :hangul_letter_yu_i => 0x318c,
  :hangul_letter_yui => 0x318c,
  :hangul_letter_araea => 0x318d,
  :hangul_letter_alae_a => 0x318d,
  :hangul_letter_araeae => 0x318e,
  :hangul_letter_alae_ae => 0x318e,
  :ideographic_annotation_linking_mark => 0x3190,
  :kanbun_tateten => 0x3190,
  :ideographic_annotation_reverse_mark => 0x3191,
  :kaeriten_re => 0x3191,
  :ideographic_annotation_one_mark => 0x3192,
  :kaeriten_iti => 0x3192,
  :ideographic_annotation_two_mark => 0x3193,
  :kaeriten_ni => 0x3193,
  :ideographic_annotation_three_mark => 0x3194,
  :kaeriten_san => 0x3194,
  :ideographic_annotation_four_mark => 0x3195,
  :kaeriten_si => 0x3195,
  :ideographic_annotation_top_mark => 0x3196,
  :kaeriten_zyou => 0x3196,
  :ideographic_annotation_middle_mark => 0x3197,
  :kaeriten_tyuu => 0x3197,
  :ideographic_annotation_bottom_mark => 0x3198,
  :kaeriten_ge => 0x3198,
  :ideographic_annotation_first_mark => 0x3199,
  :kaeriten_kou => 0x3199,
  :ideographic_annotation_second_mark => 0x319a,
  :kaeriten_otu => 0x319a,
  :ideographic_annotation_third_mark => 0x319b,
  :kaeriten_hei => 0x319b,
  :ideographic_annotation_fourth_mark => 0x319c,
  :kaeriten_tei => 0x319c,
  :ideographic_annotation_heaven_mark => 0x319d,
  :kaeriten_ten => 0x319d,
  :ideographic_annotation_earth_mark => 0x319e,
  :kaeriten_ti => 0x319e,
  :ideographic_annotation_man_mark => 0x319f,
  :kaeriten_zin => 0x319f,
  :bopomofo_letter_bu => 0x31a0,
  :bopomofo_letter_zi => 0x31a1,
  :bopomofo_letter_ji => 0x31a2,
  :bopomofo_letter_gu => 0x31a3,
  :bopomofo_letter_ee => 0x31a4,
  :bopomofo_letter_enn => 0x31a5,
  :bopomofo_letter_oo => 0x31a6,
  :bopomofo_letter_onn => 0x31a7,
  :bopomofo_letter_ir => 0x31a8,
  :bopomofo_letter_ann => 0x31a9,
  :bopomofo_letter_inn => 0x31aa,
  :bopomofo_letter_unn => 0x31ab,
  :bopomofo_letter_im => 0x31ac,
  :bopomofo_letter_ngg => 0x31ad,
  :bopomofo_letter_ainn => 0x31ae,
  :bopomofo_letter_aunn => 0x31af,
  :bopomofo_letter_am => 0x31b0,
  :bopomofo_letter_om => 0x31b1,
  :bopomofo_letter_ong => 0x31b2,
  :bopomofo_letter_innn => 0x31b3,
  :bopomofo_final_letter_p => 0x31b4,
  :bopomofo_final_letter_t => 0x31b5,
  :bopomofo_final_letter_k => 0x31b6,
  :bopomofo_final_letter_h => 0x31b7,
  :cjk_stroke_t => 0x31c0,
  :cjk_stroke_wg => 0x31c1,
  :cjk_stroke_xg => 0x31c2,
  :cjk_stroke_bxg => 0x31c3,
  :cjk_stroke_sw => 0x31c4,
  :cjk_stroke_hzz => 0x31c5,
  :cjk_stroke_hzg => 0x31c6,
  :cjk_stroke_hp => 0x31c7,
  :cjk_stroke_hzwg => 0x31c8,
  :cjk_stroke_szwg => 0x31c9,
  :cjk_stroke_hzt => 0x31ca,
  :cjk_stroke_hzzp => 0x31cb,
  :cjk_stroke_hpwg => 0x31cc,
  :cjk_stroke_hzw => 0x31cd,
  :cjk_stroke_hzzz => 0x31ce,
  :cjk_stroke_n => 0x31cf,
  :katakana_letter_small_ku => 0x31f0,
  :katakana_letter_small_si => 0x31f1,
  :katakana_letter_small_su => 0x31f2,
  :katakana_letter_small_to => 0x31f3,
  :katakana_letter_small_nu => 0x31f4,
  :katakana_letter_small_ha => 0x31f5,
  :katakana_letter_small_hi => 0x31f6,
  :katakana_letter_small_hu => 0x31f7,
  :katakana_letter_small_he => 0x31f8,
  :katakana_letter_small_ho => 0x31f9,
  :katakana_letter_small_mu => 0x31fa,
  :katakana_letter_small_ra => 0x31fb,
  :katakana_letter_small_ri => 0x31fc,
  :katakana_letter_small_ru => 0x31fd,
  :katakana_letter_small_re => 0x31fe,
  :katakana_letter_small_ro => 0x31ff,
  :parenthesized_hangul_kiyeok => 0x3200,
  :parenthesized_hangul_giyeog => 0x3200,
  :parenthesized_hangul_nieun => 0x3201,
  :parenthesized_hangul_tikeut => 0x3202,
  :parenthesized_hangul_digeud => 0x3202,
  :parenthesized_hangul_rieul => 0x3203,
  :parenthesized_hangul_lieul => 0x3203,
  :parenthesized_hangul_mieum => 0x3204,
  :parenthesized_hangul_pieup => 0x3205,
  :parenthesized_hangul_bieub => 0x3205,
  :parenthesized_hangul_sios => 0x3206,
  :parenthesized_hangul_ieung => 0x3207,
  :parenthesized_hangul_cieuc => 0x3208,
  :parenthesized_hangul_jieuj => 0x3208,
  :parenthesized_hangul_chieuch => 0x3209,
  :parenthesized_hangul_cieuc => 0x3209,
  :parenthesized_hangul_khieukh => 0x320a,
  :parenthesized_hangul_kiyeok => 0x320a,
  :parenthesized_hangul_thieuth => 0x320b,
  :parenthesized_hangul_tieut => 0x320b,
  :parenthesized_hangul_phieuph => 0x320c,
  :parenthesized_hangul_pieup => 0x320c,
  :parenthesized_hangul_hieuh => 0x320d,
  :parenthesized_hangul_kiyeok_a => 0x320e,
  :parenthesized_hangul_ga => 0x320e,
  :parenthesized_hangul_nieun_a => 0x320f,
  :parenthesized_hangul_na => 0x320f,
  :parenthesized_hangul_tikeut_a => 0x3210,
  :parenthesized_hangul_da => 0x3210,
  :parenthesized_hangul_rieul_a => 0x3211,
  :parenthesized_hangul_la => 0x3211,
  :parenthesized_hangul_mieum_a => 0x3212,
  :parenthesized_hangul_ma => 0x3212,
  :parenthesized_hangul_pieup_a => 0x3213,
  :parenthesized_hangul_ba => 0x3213,
  :parenthesized_hangul_sios_a => 0x3214,
  :parenthesized_hangul_sa => 0x3214,
  :parenthesized_hangul_ieung_a => 0x3215,
  :parenthesized_hangul_a => 0x3215,
  :parenthesized_hangul_cieuc_a => 0x3216,
  :parenthesized_hangul_ja => 0x3216,
  :parenthesized_hangul_chieuch_a => 0x3217,
  :parenthesized_hangul_ca => 0x3217,
  :parenthesized_hangul_khieukh_a => 0x3218,
  :parenthesized_hangul_ka => 0x3218,
  :parenthesized_hangul_thieuth_a => 0x3219,
  :parenthesized_hangul_ta => 0x3219,
  :parenthesized_hangul_phieuph_a => 0x321a,
  :parenthesized_hangul_pa => 0x321a,
  :parenthesized_hangul_hieuh_a => 0x321b,
  :parenthesized_hangul_ha => 0x321b,
  :parenthesized_hangul_cieuc_u => 0x321c,
  :parenthesized_hangul_ju => 0x321c,
  :parenthesized_korean_character_ojeon => 0x321d,
  :parenthesized_korean_character_o_hu => 0x321e,
  :parenthesized_ideograph_one => 0x3220,
  :parenthesized_ideograph_two => 0x3221,
  :parenthesized_ideograph_three => 0x3222,
  :parenthesized_ideograph_four => 0x3223,
  :parenthesized_ideograph_five => 0x3224,
  :parenthesized_ideograph_six => 0x3225,
  :parenthesized_ideograph_seven => 0x3226,
  :parenthesized_ideograph_eight => 0x3227,
  :parenthesized_ideograph_nine => 0x3228,
  :parenthesized_ideograph_ten => 0x3229,
  :parenthesized_ideograph_moon => 0x322a,
  :parenthesized_ideograph_fire => 0x322b,
  :parenthesized_ideograph_water => 0x322c,
  :parenthesized_ideograph_wood => 0x322d,
  :parenthesized_ideograph_metal => 0x322e,
  :parenthesized_ideograph_earth => 0x322f,
  :parenthesized_ideograph_sun => 0x3230,
  :parenthesized_ideograph_stock => 0x3231,
  :parenthesized_ideograph_have => 0x3232,
  :parenthesized_ideograph_society => 0x3233,
  :parenthesized_ideograph_name => 0x3234,
  :parenthesized_ideograph_special => 0x3235,
  :parenthesized_ideograph_financial => 0x3236,
  :parenthesized_ideograph_congratulation => 0x3237,
  :parenthesized_ideograph_labor => 0x3238,
  :parenthesized_ideograph_represent => 0x3239,
  :parenthesized_ideograph_call => 0x323a,
  :parenthesized_ideograph_study => 0x323b,
  :parenthesized_ideograph_supervise => 0x323c,
  :parenthesized_ideograph_enterprise => 0x323d,
  :parenthesized_ideograph_resource => 0x323e,
  :parenthesized_ideograph_alliance => 0x323f,
  :parenthesized_ideograph_festival => 0x3240,
  :parenthesized_ideograph_rest => 0x3241,
  :parenthesized_ideograph_self => 0x3242,
  :parenthesized_ideograph_reach => 0x3243,
  :partnership_sign => 0x3250,
  :circled_number_twenty_one => 0x3251,
  :circled_number_twenty_two => 0x3252,
  :circled_number_twenty_three => 0x3253,
  :circled_number_twenty_four => 0x3254,
  :circled_number_twenty_five => 0x3255,
  :circled_number_twenty_six => 0x3256,
  :circled_number_twenty_seven => 0x3257,
  :circled_number_twenty_eight => 0x3258,
  :circled_number_twenty_nine => 0x3259,
  :circled_number_thirty => 0x325a,
  :circled_number_thirty_one => 0x325b,
  :circled_number_thirty_two => 0x325c,
  :circled_number_thirty_three => 0x325d,
  :circled_number_thirty_four => 0x325e,
  :circled_number_thirty_five => 0x325f,
  :circled_hangul_kiyeok => 0x3260,
  :circled_hangul_giyeog => 0x3260,
  :circled_hangul_nieun => 0x3261,
  :circled_hangul_tikeut => 0x3262,
  :circled_hangul_digeud => 0x3262,
  :circled_hangul_rieul => 0x3263,
  :circled_hangul_lieul => 0x3263,
  :circled_hangul_mieum => 0x3264,
  :circled_hangul_pieup => 0x3265,
  :circled_hangul_bieub => 0x3265,
  :circled_hangul_sios => 0x3266,
  :circled_hangul_ieung => 0x3267,
  :circled_hangul_cieuc => 0x3268,
  :circled_hangul_jieuj => 0x3268,
  :circled_hangul_chieuch => 0x3269,
  :circled_hangul_cieuc => 0x3269,
  :circled_hangul_khieukh => 0x326a,
  :circled_hangul_kiyeok => 0x326a,
  :circled_hangul_thieuth => 0x326b,
  :circled_hangul_tieut => 0x326b,
  :circled_hangul_phieuph => 0x326c,
  :circled_hangul_pieup => 0x326c,
  :circled_hangul_hieuh => 0x326d,
  :circled_hangul_kiyeok_a => 0x326e,
  :circled_hangul_ga => 0x326e,
  :circled_hangul_nieun_a => 0x326f,
  :circled_hangul_na => 0x326f,
  :circled_hangul_tikeut_a => 0x3270,
  :circled_hangul_da => 0x3270,
  :circled_hangul_rieul_a => 0x3271,
  :circled_hangul_la => 0x3271,
  :circled_hangul_mieum_a => 0x3272,
  :circled_hangul_ma => 0x3272,
  :circled_hangul_pieup_a => 0x3273,
  :circled_hangul_ba => 0x3273,
  :circled_hangul_sios_a => 0x3274,
  :circled_hangul_sa => 0x3274,
  :circled_hangul_ieung_a => 0x3275,
  :circled_hangul_a => 0x3275,
  :circled_hangul_cieuc_a => 0x3276,
  :circled_hangul_ja => 0x3276,
  :circled_hangul_chieuch_a => 0x3277,
  :circled_hangul_ca => 0x3277,
  :circled_hangul_khieukh_a => 0x3278,
  :circled_hangul_ka => 0x3278,
  :circled_hangul_thieuth_a => 0x3279,
  :circled_hangul_ta => 0x3279,
  :circled_hangul_phieuph_a => 0x327a,
  :circled_hangul_pa => 0x327a,
  :circled_hangul_hieuh_a => 0x327b,
  :circled_hangul_ha => 0x327b,
  :circled_korean_character_chamko => 0x327c,
  :circled_korean_character_jueui => 0x327d,
  :circled_hangul_ieung_u => 0x327e,
  :korean_standard_symbol => 0x327f,
  :circled_ideograph_one => 0x3280,
  :circled_ideograph_two => 0x3281,
  :circled_ideograph_three => 0x3282,
  :circled_ideograph_four => 0x3283,
  :circled_ideograph_five => 0x3284,
  :circled_ideograph_six => 0x3285,
  :circled_ideograph_seven => 0x3286,
  :circled_ideograph_eight => 0x3287,
  :circled_ideograph_nine => 0x3288,
  :circled_ideograph_ten => 0x3289,
  :circled_ideograph_moon => 0x328a,
  :circled_ideograph_fire => 0x328b,
  :circled_ideograph_water => 0x328c,
  :circled_ideograph_wood => 0x328d,
  :circled_ideograph_metal => 0x328e,
  :circled_ideograph_earth => 0x328f,
  :circled_ideograph_sun => 0x3290,
  :circled_ideograph_stock => 0x3291,
  :circled_ideograph_have => 0x3292,
  :circled_ideograph_society => 0x3293,
  :circled_ideograph_name => 0x3294,
  :circled_ideograph_special => 0x3295,
  :circled_ideograph_financial => 0x3296,
  :circled_ideograph_congratulation => 0x3297,
  :circled_ideograph_labor => 0x3298,
  :circled_ideograph_secret => 0x3299,
  :circled_ideograph_male => 0x329a,
  :circled_ideograph_female => 0x329b,
  :circled_ideograph_suitable => 0x329c,
  :circled_ideograph_excellent => 0x329d,
  :circled_ideograph_print => 0x329e,
  :circled_ideograph_attention => 0x329f,
  :circled_ideograph_item => 0x32a0,
  :circled_ideograph_rest => 0x32a1,
  :circled_ideograph_copy => 0x32a2,
  :circled_ideograph_correct => 0x32a3,
  :circled_ideograph_high => 0x32a4,
  :circled_ideograph_centre => 0x32a5,
  :circled_ideograph_center => 0x32a5,
  :circled_ideograph_low => 0x32a6,
  :circled_ideograph_left => 0x32a7,
  :circled_ideograph_right => 0x32a8,
  :circled_ideograph_medicine => 0x32a9,
  :circled_ideograph_religion => 0x32aa,
  :circled_ideograph_study => 0x32ab,
  :circled_ideograph_supervise => 0x32ac,
  :circled_ideograph_enterprise => 0x32ad,
  :circled_ideograph_resource => 0x32ae,
  :circled_ideograph_alliance => 0x32af,
  :circled_ideograph_night => 0x32b0,
  :circled_number_thirty_six => 0x32b1,
  :circled_number_thirty_seven => 0x32b2,
  :circled_number_thirty_eight => 0x32b3,
  :circled_number_thirty_nine => 0x32b4,
  :circled_number_forty => 0x32b5,
  :circled_number_forty_one => 0x32b6,
  :circled_number_forty_two => 0x32b7,
  :circled_number_forty_three => 0x32b8,
  :circled_number_forty_four => 0x32b9,
  :circled_number_forty_five => 0x32ba,
  :circled_number_forty_six => 0x32bb,
  :circled_number_forty_seven => 0x32bc,
  :circled_number_forty_eight => 0x32bd,
  :circled_number_forty_nine => 0x32be,
  :circled_number_fifty => 0x32bf,
  :ideographic_telegraph_symbol_for_january => 0x32c0,
  :ideographic_telegraph_symbol_for_february => 0x32c1,
  :ideographic_telegraph_symbol_for_march => 0x32c2,
  :ideographic_telegraph_symbol_for_april => 0x32c3,
  :ideographic_telegraph_symbol_for_may => 0x32c4,
  :ideographic_telegraph_symbol_for_june => 0x32c5,
  :ideographic_telegraph_symbol_for_july => 0x32c6,
  :ideographic_telegraph_symbol_for_august => 0x32c7,
  :ideographic_telegraph_symbol_for_september => 0x32c8,
  :ideographic_telegraph_symbol_for_october => 0x32c9,
  :ideographic_telegraph_symbol_for_november => 0x32ca,
  :ideographic_telegraph_symbol_for_december => 0x32cb,
  :square_hg => 0x32cc,
  :square_erg => 0x32cd,
  :square_ev => 0x32ce,
  :limited_liability_sign => 0x32cf,
  :circled_katakana_a => 0x32d0,
  :circled_katakana_i => 0x32d1,
  :circled_katakana_u => 0x32d2,
  :circled_katakana_e => 0x32d3,
  :circled_katakana_o => 0x32d4,
  :circled_katakana_ka => 0x32d5,
  :circled_katakana_ki => 0x32d6,
  :circled_katakana_ku => 0x32d7,
  :circled_katakana_ke => 0x32d8,
  :circled_katakana_ko => 0x32d9,
  :circled_katakana_sa => 0x32da,
  :circled_katakana_si => 0x32db,
  :circled_katakana_su => 0x32dc,
  :circled_katakana_se => 0x32dd,
  :circled_katakana_so => 0x32de,
  :circled_katakana_ta => 0x32df,
  :circled_katakana_ti => 0x32e0,
  :circled_katakana_tu => 0x32e1,
  :circled_katakana_te => 0x32e2,
  :circled_katakana_to => 0x32e3,
  :circled_katakana_na => 0x32e4,
  :circled_katakana_ni => 0x32e5,
  :circled_katakana_nu => 0x32e6,
  :circled_katakana_ne => 0x32e7,
  :circled_katakana_no => 0x32e8,
  :circled_katakana_ha => 0x32e9,
  :circled_katakana_hi => 0x32ea,
  :circled_katakana_hu => 0x32eb,
  :circled_katakana_he => 0x32ec,
  :circled_katakana_ho => 0x32ed,
  :circled_katakana_ma => 0x32ee,
  :circled_katakana_mi => 0x32ef,
  :circled_katakana_mu => 0x32f0,
  :circled_katakana_me => 0x32f1,
  :circled_katakana_mo => 0x32f2,
  :circled_katakana_ya => 0x32f3,
  :circled_katakana_yu => 0x32f4,
  :circled_katakana_yo => 0x32f5,
  :circled_katakana_ra => 0x32f6,
  :circled_katakana_ri => 0x32f7,
  :circled_katakana_ru => 0x32f8,
  :circled_katakana_re => 0x32f9,
  :circled_katakana_ro => 0x32fa,
  :circled_katakana_wa => 0x32fb,
  :circled_katakana_wi => 0x32fc,
  :circled_katakana_we => 0x32fd,
  :circled_katakana_wo => 0x32fe,
  :square_apaato => 0x3300,
  :squared_apaato => 0x3300,
  :square_aruhua => 0x3301,
  :squared_aruhua => 0x3301,
  :square_anpea => 0x3302,
  :squared_anpea => 0x3302,
  :square_aaru => 0x3303,
  :squared_aaru => 0x3303,
  :square_iningu => 0x3304,
  :squared_iningu => 0x3304,
  :square_inti => 0x3305,
  :squared_inti => 0x3305,
  :square_uon => 0x3306,
  :squared_uon => 0x3306,
  :square_esukuudo => 0x3307,
  :squared_esukuudo => 0x3307,
  :square_eekaa => 0x3308,
  :squared_eekaa => 0x3308,
  :square_onsu => 0x3309,
  :squared_onsu => 0x3309,
  :square_oomu => 0x330a,
  :squared_oomu => 0x330a,
  :square_kairi => 0x330b,
  :squared_kairi => 0x330b,
  :square_karatto => 0x330c,
  :squared_karatto => 0x330c,
  :square_karorii => 0x330d,
  :squared_karorii => 0x330d,
  :square_garon => 0x330e,
  :squared_garon => 0x330e,
  :square_ganma => 0x330f,
  :squared_ganma => 0x330f,
  :square_giga => 0x3310,
  :squared_giga => 0x3310,
  :square_ginii => 0x3311,
  :squared_ginii => 0x3311,
  :square_kyurii => 0x3312,
  :squared_kyurii => 0x3312,
  :square_girudaa => 0x3313,
  :squared_girudaa => 0x3313,
  :square_kiro => 0x3314,
  :squared_kiro => 0x3314,
  :square_kiroguramu => 0x3315,
  :squared_kiroguramu => 0x3315,
  :square_kiromeetoru => 0x3316,
  :squared_kiromeetoru => 0x3316,
  :square_kirowatto => 0x3317,
  :squared_kirowatto => 0x3317,
  :square_guramu => 0x3318,
  :squared_guramu => 0x3318,
  :square_guramuton => 0x3319,
  :squared_guramuton => 0x3319,
  :square_kuruzeiro => 0x331a,
  :squared_kuruzeiro => 0x331a,
  :square_kuroone => 0x331b,
  :squared_kuroone => 0x331b,
  :square_keesu => 0x331c,
  :squared_keesu => 0x331c,
  :square_koruna => 0x331d,
  :squared_koruna => 0x331d,
  :square_koopo => 0x331e,
  :squared_koopo => 0x331e,
  :square_saikuru => 0x331f,
  :squared_saikuru => 0x331f,
  :square_santiimu => 0x3320,
  :squared_santiimu => 0x3320,
  :square_siringu => 0x3321,
  :squared_siringu => 0x3321,
  :square_senti => 0x3322,
  :squared_senti => 0x3322,
  :square_sento => 0x3323,
  :squared_sento => 0x3323,
  :square_daasu => 0x3324,
  :squared_daasu => 0x3324,
  :square_desi => 0x3325,
  :squared_desi => 0x3325,
  :square_doru => 0x3326,
  :squared_doru => 0x3326,
  :square_ton => 0x3327,
  :squared_ton => 0x3327,
  :square_nano => 0x3328,
  :squared_nano => 0x3328,
  :square_notto => 0x3329,
  :squared_notto => 0x3329,
  :square_haitu => 0x332a,
  :squared_haitu => 0x332a,
  :square_paasento => 0x332b,
  :squared_paasento => 0x332b,
  :square_paatu => 0x332c,
  :squared_paatu => 0x332c,
  :square_baareru => 0x332d,
  :squared_baareru => 0x332d,
  :square_piasutoru => 0x332e,
  :squared_piasutoru => 0x332e,
  :square_pikuru => 0x332f,
  :squared_pikuru => 0x332f,
  :square_piko => 0x3330,
  :squared_piko => 0x3330,
  :square_biru => 0x3331,
  :squared_biru => 0x3331,
  :square_huaraddo => 0x3332,
  :squared_huaraddo => 0x3332,
  :square_huiito => 0x3333,
  :squared_huiito => 0x3333,
  :square_bussyeru => 0x3334,
  :squared_bussyeru => 0x3334,
  :square_huran => 0x3335,
  :squared_huran => 0x3335,
  :square_hekutaaru => 0x3336,
  :squared_hekutaaru => 0x3336,
  :square_peso => 0x3337,
  :squared_peso => 0x3337,
  :square_penihi => 0x3338,
  :squared_penihi => 0x3338,
  :square_herutu => 0x3339,
  :squared_herutu => 0x3339,
  :square_pensu => 0x333a,
  :squared_pensu => 0x333a,
  :square_peezi => 0x333b,
  :squared_peezi => 0x333b,
  :square_beeta => 0x333c,
  :squared_beeta => 0x333c,
  :square_pointo => 0x333d,
  :squared_pointo => 0x333d,
  :square_boruto => 0x333e,
  :squared_boruto => 0x333e,
  :square_hon => 0x333f,
  :squared_hon => 0x333f,
  :square_pondo => 0x3340,
  :squared_pondo => 0x3340,
  :square_hooru => 0x3341,
  :squared_hooru => 0x3341,
  :square_hoon => 0x3342,
  :squared_hoon => 0x3342,
  :square_maikuro => 0x3343,
  :squared_maikuro => 0x3343,
  :square_mairu => 0x3344,
  :squared_mairu => 0x3344,
  :square_mahha => 0x3345,
  :squared_mahha => 0x3345,
  :square_maruku => 0x3346,
  :squared_maruku => 0x3346,
  :square_mansyon => 0x3347,
  :squared_mansyon => 0x3347,
  :square_mikuron => 0x3348,
  :squared_mikuron => 0x3348,
  :square_miri => 0x3349,
  :squared_miri => 0x3349,
  :square_miribaaru => 0x334a,
  :squared_miribaaru => 0x334a,
  :square_mega => 0x334b,
  :squared_mega => 0x334b,
  :square_megaton => 0x334c,
  :squared_megaton => 0x334c,
  :square_meetoru => 0x334d,
  :squared_meetoru => 0x334d,
  :square_yaado => 0x334e,
  :squared_yaado => 0x334e,
  :square_yaaru => 0x334f,
  :squared_yaaru => 0x334f,
  :square_yuan => 0x3350,
  :squared_yuan => 0x3350,
  :square_rittoru => 0x3351,
  :squared_rittoru => 0x3351,
  :square_rira => 0x3352,
  :squared_rira => 0x3352,
  :square_rupii => 0x3353,
  :squared_rupii => 0x3353,
  :square_ruuburu => 0x3354,
  :squared_ruuburu => 0x3354,
  :square_remu => 0x3355,
  :squared_remu => 0x3355,
  :square_rentogen => 0x3356,
  :squared_rentogen => 0x3356,
  :square_watto => 0x3357,
  :squared_watto => 0x3357,
  :ideographic_telegraph_symbol_for_hour_zero => 0x3358,
  :ideographic_telegraph_symbol_for_hour_one => 0x3359,
  :ideographic_telegraph_symbol_for_hour_two => 0x335a,
  :ideographic_telegraph_symbol_for_hour_three => 0x335b,
  :ideographic_telegraph_symbol_for_hour_four => 0x335c,
  :ideographic_telegraph_symbol_for_hour_five => 0x335d,
  :ideographic_telegraph_symbol_for_hour_six => 0x335e,
  :ideographic_telegraph_symbol_for_hour_seven => 0x335f,
  :ideographic_telegraph_symbol_for_hour_eight => 0x3360,
  :ideographic_telegraph_symbol_for_hour_nine => 0x3361,
  :ideographic_telegraph_symbol_for_hour_ten => 0x3362,
  :ideographic_telegraph_symbol_for_hour_eleven => 0x3363,
  :ideographic_telegraph_symbol_for_hour_twelve => 0x3364,
  :ideographic_telegraph_symbol_for_hour_thirteen => 0x3365,
  :ideographic_telegraph_symbol_for_hour_fourteen => 0x3366,
  :ideographic_telegraph_symbol_for_hour_fifteen => 0x3367,
  :ideographic_telegraph_symbol_for_hour_sixteen => 0x3368,
  :ideographic_telegraph_symbol_for_hour_seventeen => 0x3369,
  :ideographic_telegraph_symbol_for_hour_eighteen => 0x336a,
  :ideographic_telegraph_symbol_for_hour_nineteen => 0x336b,
  :ideographic_telegraph_symbol_for_hour_twenty => 0x336c,
  :ideographic_telegraph_symbol_for_hour_twenty_one => 0x336d,
  :ideographic_telegraph_symbol_for_hour_twenty_two => 0x336e,
  :ideographic_telegraph_symbol_for_hour_twenty_three => 0x336f,
  :ideographic_telegraph_symbol_for_hour_twenty_four => 0x3370,
  :square_hpa => 0x3371,
  :square_da => 0x3372,
  :square_au => 0x3373,
  :square_bar => 0x3374,
  :square_ov => 0x3375,
  :square_pc => 0x3376,
  :square_dm => 0x3377,
  :square_dm_squared => 0x3378,
  :square_dm_cubed => 0x3379,
  :square_iu => 0x337a,
  :square_era_name_heisei => 0x337b,
  :squared_two_ideographs_era_name_heisei => 0x337b,
  :square_era_name_syouwa => 0x337c,
  :squared_two_ideographs_era_name_syouwa => 0x337c,
  :square_era_name_taisyou => 0x337d,
  :squared_two_ideographs_era_name_taisyou => 0x337d,
  :square_era_name_meizi => 0x337e,
  :squared_two_ideographs_era_name_meizi => 0x337e,
  :square_corporation => 0x337f,
  :squared_four_ideographs_corporation => 0x337f,
  :square_pa_amps => 0x3380,
  :squared_pa_amps => 0x3380,
  :square_na => 0x3381,
  :squared_na => 0x3381,
  :square_mu_a => 0x3382,
  :squared_mu_a => 0x3382,
  :square_ma => 0x3383,
  :squared_ma => 0x3383,
  :square_ka => 0x3384,
  :squared_ka => 0x3384,
  :square_kb => 0x3385,
  :squared_kb => 0x3385,
  :square_mb => 0x3386,
  :squared_mb => 0x3386,
  :square_gb => 0x3387,
  :squared_gb => 0x3387,
  :square_cal => 0x3388,
  :squared_cal => 0x3388,
  :square_kcal => 0x3389,
  :squared_kcal => 0x3389,
  :square_pf => 0x338a,
  :squared_pf => 0x338a,
  :square_nf => 0x338b,
  :squared_nf => 0x338b,
  :square_mu_f => 0x338c,
  :squared_mu_f => 0x338c,
  :square_mu_g => 0x338d,
  :squared_mu_g => 0x338d,
  :square_mg => 0x338e,
  :squared_mg => 0x338e,
  :square_kg => 0x338f,
  :squared_kg => 0x338f,
  :square_hz => 0x3390,
  :squared_hz => 0x3390,
  :square_khz => 0x3391,
  :squared_khz => 0x3391,
  :square_mhz => 0x3392,
  :squared_mhz => 0x3392,
  :square_ghz => 0x3393,
  :squared_ghz => 0x3393,
  :square_thz => 0x3394,
  :squared_thz => 0x3394,
  :square_mu_l => 0x3395,
  :squared_mu_l => 0x3395,
  :square_ml => 0x3396,
  :squared_ml => 0x3396,
  :square_dl => 0x3397,
  :squared_dl => 0x3397,
  :square_kl => 0x3398,
  :squared_kl => 0x3398,
  :square_fm => 0x3399,
  :squared_fm => 0x3399,
  :square_nm => 0x339a,
  :squared_nm => 0x339a,
  :square_mu_m => 0x339b,
  :squared_mu_m => 0x339b,
  :square_mm => 0x339c,
  :squared_mm => 0x339c,
  :square_cm => 0x339d,
  :squared_cm => 0x339d,
  :square_km => 0x339e,
  :squared_km => 0x339e,
  :square_mm_squared => 0x339f,
  :squared_mm_squared => 0x339f,
  :square_cm_squared => 0x33a0,
  :squared_cm_squared => 0x33a0,
  :square_m_squared => 0x33a1,
  :squared_m_squared => 0x33a1,
  :square_km_squared => 0x33a2,
  :squared_km_squared => 0x33a2,
  :square_mm_cubed => 0x33a3,
  :squared_mm_cubed => 0x33a3,
  :square_cm_cubed => 0x33a4,
  :squared_cm_cubed => 0x33a4,
  :square_m_cubed => 0x33a5,
  :squared_m_cubed => 0x33a5,
  :square_km_cubed => 0x33a6,
  :squared_km_cubed => 0x33a6,
  :square_m_over_s => 0x33a7,
  :squared_m_over_s => 0x33a7,
  :square_m_over_s_squared => 0x33a8,
  :squared_m_over_s_squared => 0x33a8,
  :square_pa => 0x33a9,
  :squared_pa => 0x33a9,
  :square_kpa => 0x33aa,
  :squared_kpa => 0x33aa,
  :square_mpa => 0x33ab,
  :squared_mpa => 0x33ab,
  :square_gpa => 0x33ac,
  :squared_gpa => 0x33ac,
  :square_rad => 0x33ad,
  :squared_rad => 0x33ad,
  :square_rad_over_s => 0x33ae,
  :squared_rad_over_s => 0x33ae,
  :square_rad_over_s_squared => 0x33af,
  :squared_rad_over_s_squared => 0x33af,
  :square_ps => 0x33b0,
  :squared_ps => 0x33b0,
  :square_ns => 0x33b1,
  :squared_ns => 0x33b1,
  :square_mu_s => 0x33b2,
  :squared_mu_s => 0x33b2,
  :square_ms => 0x33b3,
  :squared_ms => 0x33b3,
  :square_pv => 0x33b4,
  :squared_pv => 0x33b4,
  :square_nv => 0x33b5,
  :squared_nv => 0x33b5,
  :square_mu_v => 0x33b6,
  :squared_mu_v => 0x33b6,
  :square_mv => 0x33b7,
  :squared_mv => 0x33b7,
  :square_kv => 0x33b8,
  :squared_kv => 0x33b8,
  :square_mv_mega => 0x33b9,
  :squared_mv_mega => 0x33b9,
  :square_pw => 0x33ba,
  :squared_pw => 0x33ba,
  :square_nw => 0x33bb,
  :squared_nw => 0x33bb,
  :square_mu_w => 0x33bc,
  :squared_mu_w => 0x33bc,
  :square_mw => 0x33bd,
  :squared_mw => 0x33bd,
  :square_kw => 0x33be,
  :squared_kw => 0x33be,
  :square_mw_mega => 0x33bf,
  :squared_mw_mega => 0x33bf,
  :square_k_ohm => 0x33c0,
  :squared_k_ohm => 0x33c0,
  :square_m_ohm => 0x33c1,
  :squared_m_ohm => 0x33c1,
  :square_am => 0x33c2,
  :squared_am => 0x33c2,
  :square_bq => 0x33c3,
  :squared_bq => 0x33c3,
  :square_cc => 0x33c4,
  :squared_cc => 0x33c4,
  :square_cd => 0x33c5,
  :squared_cd => 0x33c5,
  :square_c_over_kg => 0x33c6,
  :squared_c_over_kg => 0x33c6,
  :square_co => 0x33c7,
  :squared_co => 0x33c7,
  :square_db => 0x33c8,
  :squared_db => 0x33c8,
  :square_gy => 0x33c9,
  :squared_gy => 0x33c9,
  :square_ha => 0x33ca,
  :squared_ha => 0x33ca,
  :square_hp => 0x33cb,
  :squared_hp => 0x33cb,
  :square_in => 0x33cc,
  :squared_in => 0x33cc,
  :square_kk => 0x33cd,
  :squared_kk => 0x33cd,
  :square_km_capital => 0x33ce,
  :squared_km_capital => 0x33ce,
  :square_kt => 0x33cf,
  :squared_kt => 0x33cf,
  :square_lm => 0x33d0,
  :squared_lm => 0x33d0,
  :square_ln => 0x33d1,
  :squared_ln => 0x33d1,
  :square_log => 0x33d2,
  :squared_log => 0x33d2,
  :square_lx => 0x33d3,
  :squared_lx => 0x33d3,
  :square_mb_small => 0x33d4,
  :squared_mb_small => 0x33d4,
  :square_mil => 0x33d5,
  :squared_mil => 0x33d5,
  :square_mol => 0x33d6,
  :squared_mol => 0x33d6,
  :square_ph => 0x33d7,
  :squared_ph => 0x33d7,
  :square_pm => 0x33d8,
  :squared_pm => 0x33d8,
  :square_ppm => 0x33d9,
  :squared_ppm => 0x33d9,
  :square_pr => 0x33da,
  :squared_pr => 0x33da,
  :square_sr => 0x33db,
  :squared_sr => 0x33db,
  :square_sv => 0x33dc,
  :squared_sv => 0x33dc,
  :square_wb => 0x33dd,
  :squared_wb => 0x33dd,
  :square_v_over_m => 0x33de,
  :square_a_over_m => 0x33df,
  :ideographic_telegraph_symbol_for_day_one => 0x33e0,
  :ideographic_telegraph_symbol_for_day_two => 0x33e1,
  :ideographic_telegraph_symbol_for_day_three => 0x33e2,
  :ideographic_telegraph_symbol_for_day_four => 0x33e3,
  :ideographic_telegraph_symbol_for_day_five => 0x33e4,
  :ideographic_telegraph_symbol_for_day_six => 0x33e5,
  :ideographic_telegraph_symbol_for_day_seven => 0x33e6,
  :ideographic_telegraph_symbol_for_day_eight => 0x33e7,
  :ideographic_telegraph_symbol_for_day_nine => 0x33e8,
  :ideographic_telegraph_symbol_for_day_ten => 0x33e9,
  :ideographic_telegraph_symbol_for_day_eleven => 0x33ea,
  :ideographic_telegraph_symbol_for_day_twelve => 0x33eb,
  :ideographic_telegraph_symbol_for_day_thirteen => 0x33ec,
  :ideographic_telegraph_symbol_for_day_fourteen => 0x33ed,
  :ideographic_telegraph_symbol_for_day_fifteen => 0x33ee,
  :ideographic_telegraph_symbol_for_day_sixteen => 0x33ef,
  :ideographic_telegraph_symbol_for_day_seventeen => 0x33f0,
  :ideographic_telegraph_symbol_for_day_eighteen => 0x33f1,
  :ideographic_telegraph_symbol_for_day_nineteen => 0x33f2,
  :ideographic_telegraph_symbol_for_day_twenty => 0x33f3,
  :ideographic_telegraph_symbol_for_day_twenty_one => 0x33f4,
  :ideographic_telegraph_symbol_for_day_twenty_two => 0x33f5,
  :ideographic_telegraph_symbol_for_day_twenty_three => 0x33f6,
  :ideographic_telegraph_symbol_for_day_twenty_four => 0x33f7,
  :ideographic_telegraph_symbol_for_day_twenty_five => 0x33f8,
  :ideographic_telegraph_symbol_for_day_twenty_six => 0x33f9,
  :ideographic_telegraph_symbol_for_day_twenty_seven => 0x33fa,
  :ideographic_telegraph_symbol_for_day_twenty_eight => 0x33fb,
  :ideographic_telegraph_symbol_for_day_twenty_nine => 0x33fc,
  :ideographic_telegraph_symbol_for_day_thirty => 0x33fd,
  :ideographic_telegraph_symbol_for_day_thirty_one => 0x33fe,
  :square_gal => 0x33ff,
  :hexagram_for_the_creative_heaven => 0x4dc0,
  :hexagram_for_the_receptive_earth => 0x4dc1,
  :hexagram_for_difficulty_at_the_beginning => 0x4dc2,
  :hexagram_for_youthful_folly => 0x4dc3,
  :hexagram_for_waiting => 0x4dc4,
  :hexagram_for_conflict => 0x4dc5,
  :hexagram_for_the_army => 0x4dc6,
  :hexagram_for_holding_together => 0x4dc7,
  :hexagram_for_small_taming => 0x4dc8,
  :hexagram_for_treading => 0x4dc9,
  :hexagram_for_peace => 0x4dca,
  :hexagram_for_standstill => 0x4dcb,
  :hexagram_for_fellowship => 0x4dcc,
  :hexagram_for_great_possession => 0x4dcd,
  :hexagram_for_modesty => 0x4dce,
  :hexagram_for_enthusiasm => 0x4dcf,
  :hexagram_for_following => 0x4dd0,
  :hexagram_for_work_on_the_decayed => 0x4dd1,
  :hexagram_for_approach => 0x4dd2,
  :hexagram_for_contemplation => 0x4dd3,
  :hexagram_for_biting_through => 0x4dd4,
  :hexagram_for_grace => 0x4dd5,
  :hexagram_for_splitting_apart => 0x4dd6,
  :hexagram_for_return => 0x4dd7,
  :hexagram_for_innocence => 0x4dd8,
  :hexagram_for_great_taming => 0x4dd9,
  :hexagram_for_mouth_corners => 0x4dda,
  :hexagram_for_great_preponderance => 0x4ddb,
  :hexagram_for_the_abysmal_water => 0x4ddc,
  :hexagram_for_the_clinging_fire => 0x4ddd,
  :hexagram_for_influence => 0x4dde,
  :hexagram_for_duration => 0x4ddf,
  :hexagram_for_retreat => 0x4de0,
  :hexagram_for_great_power => 0x4de1,
  :hexagram_for_progress => 0x4de2,
  :hexagram_for_darkening_of_the_light => 0x4de3,
  :hexagram_for_the_family => 0x4de4,
  :hexagram_for_opposition => 0x4de5,
  :hexagram_for_obstruction => 0x4de6,
  :hexagram_for_deliverance => 0x4de7,
  :hexagram_for_decrease => 0x4de8,
  :hexagram_for_increase => 0x4de9,
  :hexagram_for_breakthrough => 0x4dea,
  :hexagram_for_coming_to_meet => 0x4deb,
  :hexagram_for_gathering_together => 0x4dec,
  :hexagram_for_pushing_upward => 0x4ded,
  :hexagram_for_oppression => 0x4dee,
  :hexagram_for_the_well => 0x4def,
  :hexagram_for_revolution => 0x4df0,
  :hexagram_for_the_cauldron => 0x4df1,
  :hexagram_for_the_arousing_thunder => 0x4df2,
  :hexagram_for_the_keeping_still_mountain => 0x4df3,
  :hexagram_for_development => 0x4df4,
  :hexagram_for_the_marrying_maiden => 0x4df5,
  :hexagram_for_abundance => 0x4df6,
  :hexagram_for_the_wanderer => 0x4df7,
  :hexagram_for_the_gentle_wind => 0x4df8,
  :hexagram_for_the_joyous_lake => 0x4df9,
  :hexagram_for_dispersion => 0x4dfa,
  :hexagram_for_limitation => 0x4dfb,
  :hexagram_for_inner_truth => 0x4dfc,
  :hexagram_for_small_preponderance => 0x4dfd,
  :hexagram_for_after_completion => 0x4dfe,
  :hexagram_for_before_completion => 0x4dff,
  :yi_syllable_it => 0xa000,
  :yi_syllable_ix => 0xa001,
  :yi_syllable_i => 0xa002,
  :yi_syllable_ip => 0xa003,
  :yi_syllable_iet => 0xa004,
  :yi_syllable_iex => 0xa005,
  :yi_syllable_ie => 0xa006,
  :yi_syllable_iep => 0xa007,
  :yi_syllable_at => 0xa008,
  :yi_syllable_ax => 0xa009,
  :yi_syllable_a => 0xa00a,
  :yi_syllable_ap => 0xa00b,
  :yi_syllable_uox => 0xa00c,
  :yi_syllable_uo => 0xa00d,
  :yi_syllable_uop => 0xa00e,
  :yi_syllable_ot => 0xa00f,
  :yi_syllable_ox => 0xa010,
  :yi_syllable_o => 0xa011,
  :yi_syllable_op => 0xa012,
  :yi_syllable_ex => 0xa013,
  :yi_syllable_e => 0xa014,
  :yi_syllable_wu => 0xa015,
  :yi_syllable_bit => 0xa016,
  :yi_syllable_bix => 0xa017,
  :yi_syllable_bi => 0xa018,
  :yi_syllable_bip => 0xa019,
  :yi_syllable_biet => 0xa01a,
  :yi_syllable_biex => 0xa01b,
  :yi_syllable_bie => 0xa01c,
  :yi_syllable_biep => 0xa01d,
  :yi_syllable_bat => 0xa01e,
  :yi_syllable_bax => 0xa01f,
  :yi_syllable_ba => 0xa020,
  :yi_syllable_bap => 0xa021,
  :yi_syllable_buox => 0xa022,
  :yi_syllable_buo => 0xa023,
  :yi_syllable_buop => 0xa024,
  :yi_syllable_bot => 0xa025,
  :yi_syllable_box => 0xa026,
  :yi_syllable_bo => 0xa027,
  :yi_syllable_bop => 0xa028,
  :yi_syllable_bex => 0xa029,
  :yi_syllable_be => 0xa02a,
  :yi_syllable_bep => 0xa02b,
  :yi_syllable_but => 0xa02c,
  :yi_syllable_bux => 0xa02d,
  :yi_syllable_bu => 0xa02e,
  :yi_syllable_bup => 0xa02f,
  :yi_syllable_burx => 0xa030,
  :yi_syllable_bur => 0xa031,
  :yi_syllable_byt => 0xa032,
  :yi_syllable_byx => 0xa033,
  :yi_syllable_by => 0xa034,
  :yi_syllable_byp => 0xa035,
  :yi_syllable_byrx => 0xa036,
  :yi_syllable_byr => 0xa037,
  :yi_syllable_pit => 0xa038,
  :yi_syllable_pix => 0xa039,
  :yi_syllable_pi => 0xa03a,
  :yi_syllable_pip => 0xa03b,
  :yi_syllable_piex => 0xa03c,
  :yi_syllable_pie => 0xa03d,
  :yi_syllable_piep => 0xa03e,
  :yi_syllable_pat => 0xa03f,
  :yi_syllable_pax => 0xa040,
  :yi_syllable_pa => 0xa041,
  :yi_syllable_pap => 0xa042,
  :yi_syllable_puox => 0xa043,
  :yi_syllable_puo => 0xa044,
  :yi_syllable_puop => 0xa045,
  :yi_syllable_pot => 0xa046,
  :yi_syllable_pox => 0xa047,
  :yi_syllable_po => 0xa048,
  :yi_syllable_pop => 0xa049,
  :yi_syllable_put => 0xa04a,
  :yi_syllable_pux => 0xa04b,
  :yi_syllable_pu => 0xa04c,
  :yi_syllable_pup => 0xa04d,
  :yi_syllable_purx => 0xa04e,
  :yi_syllable_pur => 0xa04f,
  :yi_syllable_pyt => 0xa050,
  :yi_syllable_pyx => 0xa051,
  :yi_syllable_py => 0xa052,
  :yi_syllable_pyp => 0xa053,
  :yi_syllable_pyrx => 0xa054,
  :yi_syllable_pyr => 0xa055,
  :yi_syllable_bbit => 0xa056,
  :yi_syllable_bbix => 0xa057,
  :yi_syllable_bbi => 0xa058,
  :yi_syllable_bbip => 0xa059,
  :yi_syllable_bbiet => 0xa05a,
  :yi_syllable_bbiex => 0xa05b,
  :yi_syllable_bbie => 0xa05c,
  :yi_syllable_bbiep => 0xa05d,
  :yi_syllable_bbat => 0xa05e,
  :yi_syllable_bbax => 0xa05f,
  :yi_syllable_bba => 0xa060,
  :yi_syllable_bbap => 0xa061,
  :yi_syllable_bbuox => 0xa062,
  :yi_syllable_bbuo => 0xa063,
  :yi_syllable_bbuop => 0xa064,
  :yi_syllable_bbot => 0xa065,
  :yi_syllable_bbox => 0xa066,
  :yi_syllable_bbo => 0xa067,
  :yi_syllable_bbop => 0xa068,
  :yi_syllable_bbex => 0xa069,
  :yi_syllable_bbe => 0xa06a,
  :yi_syllable_bbep => 0xa06b,
  :yi_syllable_bbut => 0xa06c,
  :yi_syllable_bbux => 0xa06d,
  :yi_syllable_bbu => 0xa06e,
  :yi_syllable_bbup => 0xa06f,
  :yi_syllable_bburx => 0xa070,
  :yi_syllable_bbur => 0xa071,
  :yi_syllable_bbyt => 0xa072,
  :yi_syllable_bbyx => 0xa073,
  :yi_syllable_bby => 0xa074,
  :yi_syllable_bbyp => 0xa075,
  :yi_syllable_nbit => 0xa076,
  :yi_syllable_nbix => 0xa077,
  :yi_syllable_nbi => 0xa078,
  :yi_syllable_nbip => 0xa079,
  :yi_syllable_nbiex => 0xa07a,
  :yi_syllable_nbie => 0xa07b,
  :yi_syllable_nbiep => 0xa07c,
  :yi_syllable_nbat => 0xa07d,
  :yi_syllable_nbax => 0xa07e,
  :yi_syllable_nba => 0xa07f,
  :yi_syllable_nbap => 0xa080,
  :yi_syllable_nbot => 0xa081,
  :yi_syllable_nbox => 0xa082,
  :yi_syllable_nbo => 0xa083,
  :yi_syllable_nbop => 0xa084,
  :yi_syllable_nbut => 0xa085,
  :yi_syllable_nbux => 0xa086,
  :yi_syllable_nbu => 0xa087,
  :yi_syllable_nbup => 0xa088,
  :yi_syllable_nburx => 0xa089,
  :yi_syllable_nbur => 0xa08a,
  :yi_syllable_nbyt => 0xa08b,
  :yi_syllable_nbyx => 0xa08c,
  :yi_syllable_nby => 0xa08d,
  :yi_syllable_nbyp => 0xa08e,
  :yi_syllable_nbyrx => 0xa08f,
  :yi_syllable_nbyr => 0xa090,
  :yi_syllable_hmit => 0xa091,
  :yi_syllable_hmix => 0xa092,
  :yi_syllable_hmi => 0xa093,
  :yi_syllable_hmip => 0xa094,
  :yi_syllable_hmiex => 0xa095,
  :yi_syllable_hmie => 0xa096,
  :yi_syllable_hmiep => 0xa097,
  :yi_syllable_hmat => 0xa098,
  :yi_syllable_hmax => 0xa099,
  :yi_syllable_hma => 0xa09a,
  :yi_syllable_hmap => 0xa09b,
  :yi_syllable_hmuox => 0xa09c,
  :yi_syllable_hmuo => 0xa09d,
  :yi_syllable_hmuop => 0xa09e,
  :yi_syllable_hmot => 0xa09f,
  :yi_syllable_hmox => 0xa0a0,
  :yi_syllable_hmo => 0xa0a1,
  :yi_syllable_hmop => 0xa0a2,
  :yi_syllable_hmut => 0xa0a3,
  :yi_syllable_hmux => 0xa0a4,
  :yi_syllable_hmu => 0xa0a5,
  :yi_syllable_hmup => 0xa0a6,
  :yi_syllable_hmurx => 0xa0a7,
  :yi_syllable_hmur => 0xa0a8,
  :yi_syllable_hmyx => 0xa0a9,
  :yi_syllable_hmy => 0xa0aa,
  :yi_syllable_hmyp => 0xa0ab,
  :yi_syllable_hmyrx => 0xa0ac,
  :yi_syllable_hmyr => 0xa0ad,
  :yi_syllable_mit => 0xa0ae,
  :yi_syllable_mix => 0xa0af,
  :yi_syllable_mi => 0xa0b0,
  :yi_syllable_mip => 0xa0b1,
  :yi_syllable_miex => 0xa0b2,
  :yi_syllable_mie => 0xa0b3,
  :yi_syllable_miep => 0xa0b4,
  :yi_syllable_mat => 0xa0b5,
  :yi_syllable_max => 0xa0b6,
  :yi_syllable_ma => 0xa0b7,
  :yi_syllable_map => 0xa0b8,
  :yi_syllable_muot => 0xa0b9,
  :yi_syllable_muox => 0xa0ba,
  :yi_syllable_muo => 0xa0bb,
  :yi_syllable_muop => 0xa0bc,
  :yi_syllable_mot => 0xa0bd,
  :yi_syllable_mox => 0xa0be,
  :yi_syllable_mo => 0xa0bf,
  :yi_syllable_mop => 0xa0c0,
  :yi_syllable_mex => 0xa0c1,
  :yi_syllable_me => 0xa0c2,
  :yi_syllable_mut => 0xa0c3,
  :yi_syllable_mux => 0xa0c4,
  :yi_syllable_mu => 0xa0c5,
  :yi_syllable_mup => 0xa0c6,
  :yi_syllable_murx => 0xa0c7,
  :yi_syllable_mur => 0xa0c8,
  :yi_syllable_myt => 0xa0c9,
  :yi_syllable_myx => 0xa0ca,
  :yi_syllable_my => 0xa0cb,
  :yi_syllable_myp => 0xa0cc,
  :yi_syllable_fit => 0xa0cd,
  :yi_syllable_fix => 0xa0ce,
  :yi_syllable_fi => 0xa0cf,
  :yi_syllable_fip => 0xa0d0,
  :yi_syllable_fat => 0xa0d1,
  :yi_syllable_fax => 0xa0d2,
  :yi_syllable_fa => 0xa0d3,
  :yi_syllable_fap => 0xa0d4,
  :yi_syllable_fox => 0xa0d5,
  :yi_syllable_fo => 0xa0d6,
  :yi_syllable_fop => 0xa0d7,
  :yi_syllable_fut => 0xa0d8,
  :yi_syllable_fux => 0xa0d9,
  :yi_syllable_fu => 0xa0da,
  :yi_syllable_fup => 0xa0db,
  :yi_syllable_furx => 0xa0dc,
  :yi_syllable_fur => 0xa0dd,
  :yi_syllable_fyt => 0xa0de,
  :yi_syllable_fyx => 0xa0df,
  :yi_syllable_fy => 0xa0e0,
  :yi_syllable_fyp => 0xa0e1,
  :yi_syllable_vit => 0xa0e2,
  :yi_syllable_vix => 0xa0e3,
  :yi_syllable_vi => 0xa0e4,
  :yi_syllable_vip => 0xa0e5,
  :yi_syllable_viet => 0xa0e6,
  :yi_syllable_viex => 0xa0e7,
  :yi_syllable_vie => 0xa0e8,
  :yi_syllable_viep => 0xa0e9,
  :yi_syllable_vat => 0xa0ea,
  :yi_syllable_vax => 0xa0eb,
  :yi_syllable_va => 0xa0ec,
  :yi_syllable_vap => 0xa0ed,
  :yi_syllable_vot => 0xa0ee,
  :yi_syllable_vox => 0xa0ef,
  :yi_syllable_vo => 0xa0f0,
  :yi_syllable_vop => 0xa0f1,
  :yi_syllable_vex => 0xa0f2,
  :yi_syllable_vep => 0xa0f3,
  :yi_syllable_vut => 0xa0f4,
  :yi_syllable_vux => 0xa0f5,
  :yi_syllable_vu => 0xa0f6,
  :yi_syllable_vup => 0xa0f7,
  :yi_syllable_vurx => 0xa0f8,
  :yi_syllable_vur => 0xa0f9,
  :yi_syllable_vyt => 0xa0fa,
  :yi_syllable_vyx => 0xa0fb,
  :yi_syllable_vy => 0xa0fc,
  :yi_syllable_vyp => 0xa0fd,
  :yi_syllable_vyrx => 0xa0fe,
  :yi_syllable_vyr => 0xa0ff,
  :yi_syllable_dit => 0xa100,
  :yi_syllable_dix => 0xa101,
  :yi_syllable_di => 0xa102,
  :yi_syllable_dip => 0xa103,
  :yi_syllable_diex => 0xa104,
  :yi_syllable_die => 0xa105,
  :yi_syllable_diep => 0xa106,
  :yi_syllable_dat => 0xa107,
  :yi_syllable_dax => 0xa108,
  :yi_syllable_da => 0xa109,
  :yi_syllable_dap => 0xa10a,
  :yi_syllable_duox => 0xa10b,
  :yi_syllable_duo => 0xa10c,
  :yi_syllable_dot => 0xa10d,
  :yi_syllable_dox => 0xa10e,
  :yi_syllable_do => 0xa10f,
  :yi_syllable_dop => 0xa110,
  :yi_syllable_dex => 0xa111,
  :yi_syllable_de => 0xa112,
  :yi_syllable_dep => 0xa113,
  :yi_syllable_dut => 0xa114,
  :yi_syllable_dux => 0xa115,
  :yi_syllable_du => 0xa116,
  :yi_syllable_dup => 0xa117,
  :yi_syllable_durx => 0xa118,
  :yi_syllable_dur => 0xa119,
  :yi_syllable_tit => 0xa11a,
  :yi_syllable_tix => 0xa11b,
  :yi_syllable_ti => 0xa11c,
  :yi_syllable_tip => 0xa11d,
  :yi_syllable_tiex => 0xa11e,
  :yi_syllable_tie => 0xa11f,
  :yi_syllable_tiep => 0xa120,
  :yi_syllable_tat => 0xa121,
  :yi_syllable_tax => 0xa122,
  :yi_syllable_ta => 0xa123,
  :yi_syllable_tap => 0xa124,
  :yi_syllable_tuot => 0xa125,
  :yi_syllable_tuox => 0xa126,
  :yi_syllable_tuo => 0xa127,
  :yi_syllable_tuop => 0xa128,
  :yi_syllable_tot => 0xa129,
  :yi_syllable_tox => 0xa12a,
  :yi_syllable_to => 0xa12b,
  :yi_syllable_top => 0xa12c,
  :yi_syllable_tex => 0xa12d,
  :yi_syllable_te => 0xa12e,
  :yi_syllable_tep => 0xa12f,
  :yi_syllable_tut => 0xa130,
  :yi_syllable_tux => 0xa131,
  :yi_syllable_tu => 0xa132,
  :yi_syllable_tup => 0xa133,
  :yi_syllable_turx => 0xa134,
  :yi_syllable_tur => 0xa135,
  :yi_syllable_ddit => 0xa136,
  :yi_syllable_ddix => 0xa137,
  :yi_syllable_ddi => 0xa138,
  :yi_syllable_ddip => 0xa139,
  :yi_syllable_ddiex => 0xa13a,
  :yi_syllable_ddie => 0xa13b,
  :yi_syllable_ddiep => 0xa13c,
  :yi_syllable_ddat => 0xa13d,
  :yi_syllable_ddax => 0xa13e,
  :yi_syllable_dda => 0xa13f,
  :yi_syllable_ddap => 0xa140,
  :yi_syllable_dduox => 0xa141,
  :yi_syllable_dduo => 0xa142,
  :yi_syllable_dduop => 0xa143,
  :yi_syllable_ddot => 0xa144,
  :yi_syllable_ddox => 0xa145,
  :yi_syllable_ddo => 0xa146,
  :yi_syllable_ddop => 0xa147,
  :yi_syllable_ddex => 0xa148,
  :yi_syllable_dde => 0xa149,
  :yi_syllable_ddep => 0xa14a,
  :yi_syllable_ddut => 0xa14b,
  :yi_syllable_ddux => 0xa14c,
  :yi_syllable_ddu => 0xa14d,
  :yi_syllable_ddup => 0xa14e,
  :yi_syllable_ddurx => 0xa14f,
  :yi_syllable_ddur => 0xa150,
  :yi_syllable_ndit => 0xa151,
  :yi_syllable_ndix => 0xa152,
  :yi_syllable_ndi => 0xa153,
  :yi_syllable_ndip => 0xa154,
  :yi_syllable_ndiex => 0xa155,
  :yi_syllable_ndie => 0xa156,
  :yi_syllable_ndat => 0xa157,
  :yi_syllable_ndax => 0xa158,
  :yi_syllable_nda => 0xa159,
  :yi_syllable_ndap => 0xa15a,
  :yi_syllable_ndot => 0xa15b,
  :yi_syllable_ndox => 0xa15c,
  :yi_syllable_ndo => 0xa15d,
  :yi_syllable_ndop => 0xa15e,
  :yi_syllable_ndex => 0xa15f,
  :yi_syllable_nde => 0xa160,
  :yi_syllable_ndep => 0xa161,
  :yi_syllable_ndut => 0xa162,
  :yi_syllable_ndux => 0xa163,
  :yi_syllable_ndu => 0xa164,
  :yi_syllable_ndup => 0xa165,
  :yi_syllable_ndurx => 0xa166,
  :yi_syllable_ndur => 0xa167,
  :yi_syllable_hnit => 0xa168,
  :yi_syllable_hnix => 0xa169,
  :yi_syllable_hni => 0xa16a,
  :yi_syllable_hnip => 0xa16b,
  :yi_syllable_hniet => 0xa16c,
  :yi_syllable_hniex => 0xa16d,
  :yi_syllable_hnie => 0xa16e,
  :yi_syllable_hniep => 0xa16f,
  :yi_syllable_hnat => 0xa170,
  :yi_syllable_hnax => 0xa171,
  :yi_syllable_hna => 0xa172,
  :yi_syllable_hnap => 0xa173,
  :yi_syllable_hnuox => 0xa174,
  :yi_syllable_hnuo => 0xa175,
  :yi_syllable_hnot => 0xa176,
  :yi_syllable_hnox => 0xa177,
  :yi_syllable_hnop => 0xa178,
  :yi_syllable_hnex => 0xa179,
  :yi_syllable_hne => 0xa17a,
  :yi_syllable_hnep => 0xa17b,
  :yi_syllable_hnut => 0xa17c,
  :yi_syllable_nit => 0xa17d,
  :yi_syllable_nix => 0xa17e,
  :yi_syllable_ni => 0xa17f,
  :yi_syllable_nip => 0xa180,
  :yi_syllable_niex => 0xa181,
  :yi_syllable_nie => 0xa182,
  :yi_syllable_niep => 0xa183,
  :yi_syllable_nax => 0xa184,
  :yi_syllable_na => 0xa185,
  :yi_syllable_nap => 0xa186,
  :yi_syllable_nuox => 0xa187,
  :yi_syllable_nuo => 0xa188,
  :yi_syllable_nuop => 0xa189,
  :yi_syllable_not => 0xa18a,
  :yi_syllable_nox => 0xa18b,
  :yi_syllable_no => 0xa18c,
  :yi_syllable_nop => 0xa18d,
  :yi_syllable_nex => 0xa18e,
  :yi_syllable_ne => 0xa18f,
  :yi_syllable_nep => 0xa190,
  :yi_syllable_nut => 0xa191,
  :yi_syllable_nux => 0xa192,
  :yi_syllable_nu => 0xa193,
  :yi_syllable_nup => 0xa194,
  :yi_syllable_nurx => 0xa195,
  :yi_syllable_nur => 0xa196,
  :yi_syllable_hlit => 0xa197,
  :yi_syllable_hlix => 0xa198,
  :yi_syllable_hli => 0xa199,
  :yi_syllable_hlip => 0xa19a,
  :yi_syllable_hliex => 0xa19b,
  :yi_syllable_hlie => 0xa19c,
  :yi_syllable_hliep => 0xa19d,
  :yi_syllable_hlat => 0xa19e,
  :yi_syllable_hlax => 0xa19f,
  :yi_syllable_hla => 0xa1a0,
  :yi_syllable_hlap => 0xa1a1,
  :yi_syllable_hluox => 0xa1a2,
  :yi_syllable_hluo => 0xa1a3,
  :yi_syllable_hluop => 0xa1a4,
  :yi_syllable_hlox => 0xa1a5,
  :yi_syllable_hlo => 0xa1a6,
  :yi_syllable_hlop => 0xa1a7,
  :yi_syllable_hlex => 0xa1a8,
  :yi_syllable_hle => 0xa1a9,
  :yi_syllable_hlep => 0xa1aa,
  :yi_syllable_hlut => 0xa1ab,
  :yi_syllable_hlux => 0xa1ac,
  :yi_syllable_hlu => 0xa1ad,
  :yi_syllable_hlup => 0xa1ae,
  :yi_syllable_hlurx => 0xa1af,
  :yi_syllable_hlur => 0xa1b0,
  :yi_syllable_hlyt => 0xa1b1,
  :yi_syllable_hlyx => 0xa1b2,
  :yi_syllable_hly => 0xa1b3,
  :yi_syllable_hlyp => 0xa1b4,
  :yi_syllable_hlyrx => 0xa1b5,
  :yi_syllable_hlyr => 0xa1b6,
  :yi_syllable_lit => 0xa1b7,
  :yi_syllable_lix => 0xa1b8,
  :yi_syllable_li => 0xa1b9,
  :yi_syllable_lip => 0xa1ba,
  :yi_syllable_liet => 0xa1bb,
  :yi_syllable_liex => 0xa1bc,
  :yi_syllable_lie => 0xa1bd,
  :yi_syllable_liep => 0xa1be,
  :yi_syllable_lat => 0xa1bf,
  :yi_syllable_lax => 0xa1c0,
  :yi_syllable_la => 0xa1c1,
  :yi_syllable_lap => 0xa1c2,
  :yi_syllable_luot => 0xa1c3,
  :yi_syllable_luox => 0xa1c4,
  :yi_syllable_luo => 0xa1c5,
  :yi_syllable_luop => 0xa1c6,
  :yi_syllable_lot => 0xa1c7,
  :yi_syllable_lox => 0xa1c8,
  :yi_syllable_lo => 0xa1c9,
  :yi_syllable_lop => 0xa1ca,
  :yi_syllable_lex => 0xa1cb,
  :yi_syllable_le => 0xa1cc,
  :yi_syllable_lep => 0xa1cd,
  :yi_syllable_lut => 0xa1ce,
  :yi_syllable_lux => 0xa1cf,
  :yi_syllable_lu => 0xa1d0,
  :yi_syllable_lup => 0xa1d1,
  :yi_syllable_lurx => 0xa1d2,
  :yi_syllable_lur => 0xa1d3,
  :yi_syllable_lyt => 0xa1d4,
  :yi_syllable_lyx => 0xa1d5,
  :yi_syllable_ly => 0xa1d6,
  :yi_syllable_lyp => 0xa1d7,
  :yi_syllable_lyrx => 0xa1d8,
  :yi_syllable_lyr => 0xa1d9,
  :yi_syllable_git => 0xa1da,
  :yi_syllable_gix => 0xa1db,
  :yi_syllable_gi => 0xa1dc,
  :yi_syllable_gip => 0xa1dd,
  :yi_syllable_giet => 0xa1de,
  :yi_syllable_giex => 0xa1df,
  :yi_syllable_gie => 0xa1e0,
  :yi_syllable_giep => 0xa1e1,
  :yi_syllable_gat => 0xa1e2,
  :yi_syllable_gax => 0xa1e3,
  :yi_syllable_ga => 0xa1e4,
  :yi_syllable_gap => 0xa1e5,
  :yi_syllable_guot => 0xa1e6,
  :yi_syllable_guox => 0xa1e7,
  :yi_syllable_guo => 0xa1e8,
  :yi_syllable_guop => 0xa1e9,
  :yi_syllable_got => 0xa1ea,
  :yi_syllable_gox => 0xa1eb,
  :yi_syllable_go => 0xa1ec,
  :yi_syllable_gop => 0xa1ed,
  :yi_syllable_get => 0xa1ee,
  :yi_syllable_gex => 0xa1ef,
  :yi_syllable_ge => 0xa1f0,
  :yi_syllable_gep => 0xa1f1,
  :yi_syllable_gut => 0xa1f2,
  :yi_syllable_gux => 0xa1f3,
  :yi_syllable_gu => 0xa1f4,
  :yi_syllable_gup => 0xa1f5,
  :yi_syllable_gurx => 0xa1f6,
  :yi_syllable_gur => 0xa1f7,
  :yi_syllable_kit => 0xa1f8,
  :yi_syllable_kix => 0xa1f9,
  :yi_syllable_ki => 0xa1fa,
  :yi_syllable_kip => 0xa1fb,
  :yi_syllable_kiex => 0xa1fc,
  :yi_syllable_kie => 0xa1fd,
  :yi_syllable_kiep => 0xa1fe,
  :yi_syllable_kat => 0xa1ff,
  :yi_syllable_kax => 0xa200,
  :yi_syllable_ka => 0xa201,
  :yi_syllable_kap => 0xa202,
  :yi_syllable_kuox => 0xa203,
  :yi_syllable_kuo => 0xa204,
  :yi_syllable_kuop => 0xa205,
  :yi_syllable_kot => 0xa206,
  :yi_syllable_kox => 0xa207,
  :yi_syllable_ko => 0xa208,
  :yi_syllable_kop => 0xa209,
  :yi_syllable_ket => 0xa20a,
  :yi_syllable_kex => 0xa20b,
  :yi_syllable_ke => 0xa20c,
  :yi_syllable_kep => 0xa20d,
  :yi_syllable_kut => 0xa20e,
  :yi_syllable_kux => 0xa20f,
  :yi_syllable_ku => 0xa210,
  :yi_syllable_kup => 0xa211,
  :yi_syllable_kurx => 0xa212,
  :yi_syllable_kur => 0xa213,
  :yi_syllable_ggit => 0xa214,
  :yi_syllable_ggix => 0xa215,
  :yi_syllable_ggi => 0xa216,
  :yi_syllable_ggiex => 0xa217,
  :yi_syllable_ggie => 0xa218,
  :yi_syllable_ggiep => 0xa219,
  :yi_syllable_ggat => 0xa21a,
  :yi_syllable_ggax => 0xa21b,
  :yi_syllable_gga => 0xa21c,
  :yi_syllable_ggap => 0xa21d,
  :yi_syllable_gguot => 0xa21e,
  :yi_syllable_gguox => 0xa21f,
  :yi_syllable_gguo => 0xa220,
  :yi_syllable_gguop => 0xa221,
  :yi_syllable_ggot => 0xa222,
  :yi_syllable_ggox => 0xa223,
  :yi_syllable_ggo => 0xa224,
  :yi_syllable_ggop => 0xa225,
  :yi_syllable_gget => 0xa226,
  :yi_syllable_ggex => 0xa227,
  :yi_syllable_gge => 0xa228,
  :yi_syllable_ggep => 0xa229,
  :yi_syllable_ggut => 0xa22a,
  :yi_syllable_ggux => 0xa22b,
  :yi_syllable_ggu => 0xa22c,
  :yi_syllable_ggup => 0xa22d,
  :yi_syllable_ggurx => 0xa22e,
  :yi_syllable_ggur => 0xa22f,
  :yi_syllable_mgiex => 0xa230,
  :yi_syllable_mgie => 0xa231,
  :yi_syllable_mgat => 0xa232,
  :yi_syllable_mgax => 0xa233,
  :yi_syllable_mga => 0xa234,
  :yi_syllable_mgap => 0xa235,
  :yi_syllable_mguox => 0xa236,
  :yi_syllable_mguo => 0xa237,
  :yi_syllable_mguop => 0xa238,
  :yi_syllable_mgot => 0xa239,
  :yi_syllable_mgox => 0xa23a,
  :yi_syllable_mgo => 0xa23b,
  :yi_syllable_mgop => 0xa23c,
  :yi_syllable_mgex => 0xa23d,
  :yi_syllable_mge => 0xa23e,
  :yi_syllable_mgep => 0xa23f,
  :yi_syllable_mgut => 0xa240,
  :yi_syllable_mgux => 0xa241,
  :yi_syllable_mgu => 0xa242,
  :yi_syllable_mgup => 0xa243,
  :yi_syllable_mgurx => 0xa244,
  :yi_syllable_mgur => 0xa245,
  :yi_syllable_hxit => 0xa246,
  :yi_syllable_hxix => 0xa247,
  :yi_syllable_hxi => 0xa248,
  :yi_syllable_hxip => 0xa249,
  :yi_syllable_hxiet => 0xa24a,
  :yi_syllable_hxiex => 0xa24b,
  :yi_syllable_hxie => 0xa24c,
  :yi_syllable_hxiep => 0xa24d,
  :yi_syllable_hxat => 0xa24e,
  :yi_syllable_hxax => 0xa24f,
  :yi_syllable_hxa => 0xa250,
  :yi_syllable_hxap => 0xa251,
  :yi_syllable_hxuot => 0xa252,
  :yi_syllable_hxuox => 0xa253,
  :yi_syllable_hxuo => 0xa254,
  :yi_syllable_hxuop => 0xa255,
  :yi_syllable_hxot => 0xa256,
  :yi_syllable_hxox => 0xa257,
  :yi_syllable_hxo => 0xa258,
  :yi_syllable_hxop => 0xa259,
  :yi_syllable_hxex => 0xa25a,
  :yi_syllable_hxe => 0xa25b,
  :yi_syllable_hxep => 0xa25c,
  :yi_syllable_ngiex => 0xa25d,
  :yi_syllable_ngie => 0xa25e,
  :yi_syllable_ngiep => 0xa25f,
  :yi_syllable_ngat => 0xa260,
  :yi_syllable_ngax => 0xa261,
  :yi_syllable_nga => 0xa262,
  :yi_syllable_ngap => 0xa263,
  :yi_syllable_nguot => 0xa264,
  :yi_syllable_nguox => 0xa265,
  :yi_syllable_nguo => 0xa266,
  :yi_syllable_ngot => 0xa267,
  :yi_syllable_ngox => 0xa268,
  :yi_syllable_ngo => 0xa269,
  :yi_syllable_ngop => 0xa26a,
  :yi_syllable_ngex => 0xa26b,
  :yi_syllable_nge => 0xa26c,
  :yi_syllable_ngep => 0xa26d,
  :yi_syllable_hit => 0xa26e,
  :yi_syllable_hiex => 0xa26f,
  :yi_syllable_hie => 0xa270,
  :yi_syllable_hat => 0xa271,
  :yi_syllable_hax => 0xa272,
  :yi_syllable_ha => 0xa273,
  :yi_syllable_hap => 0xa274,
  :yi_syllable_huot => 0xa275,
  :yi_syllable_huox => 0xa276,
  :yi_syllable_huo => 0xa277,
  :yi_syllable_huop => 0xa278,
  :yi_syllable_hot => 0xa279,
  :yi_syllable_hox => 0xa27a,
  :yi_syllable_ho => 0xa27b,
  :yi_syllable_hop => 0xa27c,
  :yi_syllable_hex => 0xa27d,
  :yi_syllable_he => 0xa27e,
  :yi_syllable_hep => 0xa27f,
  :yi_syllable_wat => 0xa280,
  :yi_syllable_wax => 0xa281,
  :yi_syllable_wa => 0xa282,
  :yi_syllable_wap => 0xa283,
  :yi_syllable_wuox => 0xa284,
  :yi_syllable_wuo => 0xa285,
  :yi_syllable_wuop => 0xa286,
  :yi_syllable_wox => 0xa287,
  :yi_syllable_wo => 0xa288,
  :yi_syllable_wop => 0xa289,
  :yi_syllable_wex => 0xa28a,
  :yi_syllable_we => 0xa28b,
  :yi_syllable_wep => 0xa28c,
  :yi_syllable_zit => 0xa28d,
  :yi_syllable_zix => 0xa28e,
  :yi_syllable_zi => 0xa28f,
  :yi_syllable_zip => 0xa290,
  :yi_syllable_ziex => 0xa291,
  :yi_syllable_zie => 0xa292,
  :yi_syllable_ziep => 0xa293,
  :yi_syllable_zat => 0xa294,
  :yi_syllable_zax => 0xa295,
  :yi_syllable_za => 0xa296,
  :yi_syllable_zap => 0xa297,
  :yi_syllable_zuox => 0xa298,
  :yi_syllable_zuo => 0xa299,
  :yi_syllable_zuop => 0xa29a,
  :yi_syllable_zot => 0xa29b,
  :yi_syllable_zox => 0xa29c,
  :yi_syllable_zo => 0xa29d,
  :yi_syllable_zop => 0xa29e,
  :yi_syllable_zex => 0xa29f,
  :yi_syllable_ze => 0xa2a0,
  :yi_syllable_zep => 0xa2a1,
  :yi_syllable_zut => 0xa2a2,
  :yi_syllable_zux => 0xa2a3,
  :yi_syllable_zu => 0xa2a4,
  :yi_syllable_zup => 0xa2a5,
  :yi_syllable_zurx => 0xa2a6,
  :yi_syllable_zur => 0xa2a7,
  :yi_syllable_zyt => 0xa2a8,
  :yi_syllable_zyx => 0xa2a9,
  :yi_syllable_zy => 0xa2aa,
  :yi_syllable_zyp => 0xa2ab,
  :yi_syllable_zyrx => 0xa2ac,
  :yi_syllable_zyr => 0xa2ad,
  :yi_syllable_cit => 0xa2ae,
  :yi_syllable_cix => 0xa2af,
  :yi_syllable_ci => 0xa2b0,
  :yi_syllable_cip => 0xa2b1,
  :yi_syllable_ciet => 0xa2b2,
  :yi_syllable_ciex => 0xa2b3,
  :yi_syllable_cie => 0xa2b4,
  :yi_syllable_ciep => 0xa2b5,
  :yi_syllable_cat => 0xa2b6,
  :yi_syllable_cax => 0xa2b7,
  :yi_syllable_ca => 0xa2b8,
  :yi_syllable_cap => 0xa2b9,
  :yi_syllable_cuox => 0xa2ba,
  :yi_syllable_cuo => 0xa2bb,
  :yi_syllable_cuop => 0xa2bc,
  :yi_syllable_cot => 0xa2bd,
  :yi_syllable_cox => 0xa2be,
  :yi_syllable_co => 0xa2bf,
  :yi_syllable_cop => 0xa2c0,
  :yi_syllable_cex => 0xa2c1,
  :yi_syllable_ce => 0xa2c2,
  :yi_syllable_cep => 0xa2c3,
  :yi_syllable_cut => 0xa2c4,
  :yi_syllable_cux => 0xa2c5,
  :yi_syllable_cu => 0xa2c6,
  :yi_syllable_cup => 0xa2c7,
  :yi_syllable_curx => 0xa2c8,
  :yi_syllable_cur => 0xa2c9,
  :yi_syllable_cyt => 0xa2ca,
  :yi_syllable_cyx => 0xa2cb,
  :yi_syllable_cy => 0xa2cc,
  :yi_syllable_cyp => 0xa2cd,
  :yi_syllable_cyrx => 0xa2ce,
  :yi_syllable_cyr => 0xa2cf,
  :yi_syllable_zzit => 0xa2d0,
  :yi_syllable_zzix => 0xa2d1,
  :yi_syllable_zzi => 0xa2d2,
  :yi_syllable_zzip => 0xa2d3,
  :yi_syllable_zziet => 0xa2d4,
  :yi_syllable_zziex => 0xa2d5,
  :yi_syllable_zzie => 0xa2d6,
  :yi_syllable_zziep => 0xa2d7,
  :yi_syllable_zzat => 0xa2d8,
  :yi_syllable_zzax => 0xa2d9,
  :yi_syllable_zza => 0xa2da,
  :yi_syllable_zzap => 0xa2db,
  :yi_syllable_zzox => 0xa2dc,
  :yi_syllable_zzo => 0xa2dd,
  :yi_syllable_zzop => 0xa2de,
  :yi_syllable_zzex => 0xa2df,
  :yi_syllable_zze => 0xa2e0,
  :yi_syllable_zzep => 0xa2e1,
  :yi_syllable_zzux => 0xa2e2,
  :yi_syllable_zzu => 0xa2e3,
  :yi_syllable_zzup => 0xa2e4,
  :yi_syllable_zzurx => 0xa2e5,
  :yi_syllable_zzur => 0xa2e6,
  :yi_syllable_zzyt => 0xa2e7,
  :yi_syllable_zzyx => 0xa2e8,
  :yi_syllable_zzy => 0xa2e9,
  :yi_syllable_zzyp => 0xa2ea,
  :yi_syllable_zzyrx => 0xa2eb,
  :yi_syllable_zzyr => 0xa2ec,
  :yi_syllable_nzit => 0xa2ed,
  :yi_syllable_nzix => 0xa2ee,
  :yi_syllable_nzi => 0xa2ef,
  :yi_syllable_nzip => 0xa2f0,
  :yi_syllable_nziex => 0xa2f1,
  :yi_syllable_nzie => 0xa2f2,
  :yi_syllable_nziep => 0xa2f3,
  :yi_syllable_nzat => 0xa2f4,
  :yi_syllable_nzax => 0xa2f5,
  :yi_syllable_nza => 0xa2f6,
  :yi_syllable_nzap => 0xa2f7,
  :yi_syllable_nzuox => 0xa2f8,
  :yi_syllable_nzuo => 0xa2f9,
  :yi_syllable_nzox => 0xa2fa,
  :yi_syllable_nzop => 0xa2fb,
  :yi_syllable_nzex => 0xa2fc,
  :yi_syllable_nze => 0xa2fd,
  :yi_syllable_nzux => 0xa2fe,
  :yi_syllable_nzu => 0xa2ff,
  :yi_syllable_nzup => 0xa300,
  :yi_syllable_nzurx => 0xa301,
  :yi_syllable_nzur => 0xa302,
  :yi_syllable_nzyt => 0xa303,
  :yi_syllable_nzyx => 0xa304,
  :yi_syllable_nzy => 0xa305,
  :yi_syllable_nzyp => 0xa306,
  :yi_syllable_nzyrx => 0xa307,
  :yi_syllable_nzyr => 0xa308,
  :yi_syllable_sit => 0xa309,
  :yi_syllable_six => 0xa30a,
  :yi_syllable_si => 0xa30b,
  :yi_syllable_sip => 0xa30c,
  :yi_syllable_siex => 0xa30d,
  :yi_syllable_sie => 0xa30e,
  :yi_syllable_siep => 0xa30f,
  :yi_syllable_sat => 0xa310,
  :yi_syllable_sax => 0xa311,
  :yi_syllable_sa => 0xa312,
  :yi_syllable_sap => 0xa313,
  :yi_syllable_suox => 0xa314,
  :yi_syllable_suo => 0xa315,
  :yi_syllable_suop => 0xa316,
  :yi_syllable_sot => 0xa317,
  :yi_syllable_sox => 0xa318,
  :yi_syllable_so => 0xa319,
  :yi_syllable_sop => 0xa31a,
  :yi_syllable_sex => 0xa31b,
  :yi_syllable_se => 0xa31c,
  :yi_syllable_sep => 0xa31d,
  :yi_syllable_sut => 0xa31e,
  :yi_syllable_sux => 0xa31f,
  :yi_syllable_su => 0xa320,
  :yi_syllable_sup => 0xa321,
  :yi_syllable_surx => 0xa322,
  :yi_syllable_sur => 0xa323,
  :yi_syllable_syt => 0xa324,
  :yi_syllable_syx => 0xa325,
  :yi_syllable_sy => 0xa326,
  :yi_syllable_syp => 0xa327,
  :yi_syllable_syrx => 0xa328,
  :yi_syllable_syr => 0xa329,
  :yi_syllable_ssit => 0xa32a,
  :yi_syllable_ssix => 0xa32b,
  :yi_syllable_ssi => 0xa32c,
  :yi_syllable_ssip => 0xa32d,
  :yi_syllable_ssiex => 0xa32e,
  :yi_syllable_ssie => 0xa32f,
  :yi_syllable_ssiep => 0xa330,
  :yi_syllable_ssat => 0xa331,
  :yi_syllable_ssax => 0xa332,
  :yi_syllable_ssa => 0xa333,
  :yi_syllable_ssap => 0xa334,
  :yi_syllable_ssot => 0xa335,
  :yi_syllable_ssox => 0xa336,
  :yi_syllable_sso => 0xa337,
  :yi_syllable_ssop => 0xa338,
  :yi_syllable_ssex => 0xa339,
  :yi_syllable_sse => 0xa33a,
  :yi_syllable_ssep => 0xa33b,
  :yi_syllable_ssut => 0xa33c,
  :yi_syllable_ssux => 0xa33d,
  :yi_syllable_ssu => 0xa33e,
  :yi_syllable_ssup => 0xa33f,
  :yi_syllable_ssyt => 0xa340,
  :yi_syllable_ssyx => 0xa341,
  :yi_syllable_ssy => 0xa342,
  :yi_syllable_ssyp => 0xa343,
  :yi_syllable_ssyrx => 0xa344,
  :yi_syllable_ssyr => 0xa345,
  :yi_syllable_zhat => 0xa346,
  :yi_syllable_zhax => 0xa347,
  :yi_syllable_zha => 0xa348,
  :yi_syllable_zhap => 0xa349,
  :yi_syllable_zhuox => 0xa34a,
  :yi_syllable_zhuo => 0xa34b,
  :yi_syllable_zhuop => 0xa34c,
  :yi_syllable_zhot => 0xa34d,
  :yi_syllable_zhox => 0xa34e,
  :yi_syllable_zho => 0xa34f,
  :yi_syllable_zhop => 0xa350,
  :yi_syllable_zhet => 0xa351,
  :yi_syllable_zhex => 0xa352,
  :yi_syllable_zhe => 0xa353,
  :yi_syllable_zhep => 0xa354,
  :yi_syllable_zhut => 0xa355,
  :yi_syllable_zhux => 0xa356,
  :yi_syllable_zhu => 0xa357,
  :yi_syllable_zhup => 0xa358,
  :yi_syllable_zhurx => 0xa359,
  :yi_syllable_zhur => 0xa35a,
  :yi_syllable_zhyt => 0xa35b,
  :yi_syllable_zhyx => 0xa35c,
  :yi_syllable_zhy => 0xa35d,
  :yi_syllable_zhyp => 0xa35e,
  :yi_syllable_zhyrx => 0xa35f,
  :yi_syllable_zhyr => 0xa360,
  :yi_syllable_chat => 0xa361,
  :yi_syllable_chax => 0xa362,
  :yi_syllable_cha => 0xa363,
  :yi_syllable_chap => 0xa364,
  :yi_syllable_chuot => 0xa365,
  :yi_syllable_chuox => 0xa366,
  :yi_syllable_chuo => 0xa367,
  :yi_syllable_chuop => 0xa368,
  :yi_syllable_chot => 0xa369,
  :yi_syllable_chox => 0xa36a,
  :yi_syllable_cho => 0xa36b,
  :yi_syllable_chop => 0xa36c,
  :yi_syllable_chet => 0xa36d,
  :yi_syllable_chex => 0xa36e,
  :yi_syllable_che => 0xa36f,
  :yi_syllable_chep => 0xa370,
  :yi_syllable_chux => 0xa371,
  :yi_syllable_chu => 0xa372,
  :yi_syllable_chup => 0xa373,
  :yi_syllable_churx => 0xa374,
  :yi_syllable_chur => 0xa375,
  :yi_syllable_chyt => 0xa376,
  :yi_syllable_chyx => 0xa377,
  :yi_syllable_chy => 0xa378,
  :yi_syllable_chyp => 0xa379,
  :yi_syllable_chyrx => 0xa37a,
  :yi_syllable_chyr => 0xa37b,
  :yi_syllable_rrax => 0xa37c,
  :yi_syllable_rra => 0xa37d,
  :yi_syllable_rruox => 0xa37e,
  :yi_syllable_rruo => 0xa37f,
  :yi_syllable_rrot => 0xa380,
  :yi_syllable_rrox => 0xa381,
  :yi_syllable_rro => 0xa382,
  :yi_syllable_rrop => 0xa383,
  :yi_syllable_rret => 0xa384,
  :yi_syllable_rrex => 0xa385,
  :yi_syllable_rre => 0xa386,
  :yi_syllable_rrep => 0xa387,
  :yi_syllable_rrut => 0xa388,
  :yi_syllable_rrux => 0xa389,
  :yi_syllable_rru => 0xa38a,
  :yi_syllable_rrup => 0xa38b,
  :yi_syllable_rrurx => 0xa38c,
  :yi_syllable_rrur => 0xa38d,
  :yi_syllable_rryt => 0xa38e,
  :yi_syllable_rryx => 0xa38f,
  :yi_syllable_rry => 0xa390,
  :yi_syllable_rryp => 0xa391,
  :yi_syllable_rryrx => 0xa392,
  :yi_syllable_rryr => 0xa393,
  :yi_syllable_nrat => 0xa394,
  :yi_syllable_nrax => 0xa395,
  :yi_syllable_nra => 0xa396,
  :yi_syllable_nrap => 0xa397,
  :yi_syllable_nrox => 0xa398,
  :yi_syllable_nro => 0xa399,
  :yi_syllable_nrop => 0xa39a,
  :yi_syllable_nret => 0xa39b,
  :yi_syllable_nrex => 0xa39c,
  :yi_syllable_nre => 0xa39d,
  :yi_syllable_nrep => 0xa39e,
  :yi_syllable_nrut => 0xa39f,
  :yi_syllable_nrux => 0xa3a0,
  :yi_syllable_nru => 0xa3a1,
  :yi_syllable_nrup => 0xa3a2,
  :yi_syllable_nrurx => 0xa3a3,
  :yi_syllable_nrur => 0xa3a4,
  :yi_syllable_nryt => 0xa3a5,
  :yi_syllable_nryx => 0xa3a6,
  :yi_syllable_nry => 0xa3a7,
  :yi_syllable_nryp => 0xa3a8,
  :yi_syllable_nryrx => 0xa3a9,
  :yi_syllable_nryr => 0xa3aa,
  :yi_syllable_shat => 0xa3ab,
  :yi_syllable_shax => 0xa3ac,
  :yi_syllable_sha => 0xa3ad,
  :yi_syllable_shap => 0xa3ae,
  :yi_syllable_shuox => 0xa3af,
  :yi_syllable_shuo => 0xa3b0,
  :yi_syllable_shuop => 0xa3b1,
  :yi_syllable_shot => 0xa3b2,
  :yi_syllable_shox => 0xa3b3,
  :yi_syllable_sho => 0xa3b4,
  :yi_syllable_shop => 0xa3b5,
  :yi_syllable_shet => 0xa3b6,
  :yi_syllable_shex => 0xa3b7,
  :yi_syllable_she => 0xa3b8,
  :yi_syllable_shep => 0xa3b9,
  :yi_syllable_shut => 0xa3ba,
  :yi_syllable_shux => 0xa3bb,
  :yi_syllable_shu => 0xa3bc,
  :yi_syllable_shup => 0xa3bd,
  :yi_syllable_shurx => 0xa3be,
  :yi_syllable_shur => 0xa3bf,
  :yi_syllable_shyt => 0xa3c0,
  :yi_syllable_shyx => 0xa3c1,
  :yi_syllable_shy => 0xa3c2,
  :yi_syllable_shyp => 0xa3c3,
  :yi_syllable_shyrx => 0xa3c4,
  :yi_syllable_shyr => 0xa3c5,
  :yi_syllable_rat => 0xa3c6,
  :yi_syllable_rax => 0xa3c7,
  :yi_syllable_ra => 0xa3c8,
  :yi_syllable_rap => 0xa3c9,
  :yi_syllable_ruox => 0xa3ca,
  :yi_syllable_ruo => 0xa3cb,
  :yi_syllable_ruop => 0xa3cc,
  :yi_syllable_rot => 0xa3cd,
  :yi_syllable_rox => 0xa3ce,
  :yi_syllable_ro => 0xa3cf,
  :yi_syllable_rop => 0xa3d0,
  :yi_syllable_rex => 0xa3d1,
  :yi_syllable_re => 0xa3d2,
  :yi_syllable_rep => 0xa3d3,
  :yi_syllable_rut => 0xa3d4,
  :yi_syllable_rux => 0xa3d5,
  :yi_syllable_ru => 0xa3d6,
  :yi_syllable_rup => 0xa3d7,
  :yi_syllable_rurx => 0xa3d8,
  :yi_syllable_rur => 0xa3d9,
  :yi_syllable_ryt => 0xa3da,
  :yi_syllable_ryx => 0xa3db,
  :yi_syllable_ry => 0xa3dc,
  :yi_syllable_ryp => 0xa3dd,
  :yi_syllable_ryrx => 0xa3de,
  :yi_syllable_ryr => 0xa3df,
  :yi_syllable_jit => 0xa3e0,
  :yi_syllable_jix => 0xa3e1,
  :yi_syllable_ji => 0xa3e2,
  :yi_syllable_jip => 0xa3e3,
  :yi_syllable_jiet => 0xa3e4,
  :yi_syllable_jiex => 0xa3e5,
  :yi_syllable_jie => 0xa3e6,
  :yi_syllable_jiep => 0xa3e7,
  :yi_syllable_juot => 0xa3e8,
  :yi_syllable_juox => 0xa3e9,
  :yi_syllable_juo => 0xa3ea,
  :yi_syllable_juop => 0xa3eb,
  :yi_syllable_jot => 0xa3ec,
  :yi_syllable_jox => 0xa3ed,
  :yi_syllable_jo => 0xa3ee,
  :yi_syllable_jop => 0xa3ef,
  :yi_syllable_jut => 0xa3f0,
  :yi_syllable_jux => 0xa3f1,
  :yi_syllable_ju => 0xa3f2,
  :yi_syllable_jup => 0xa3f3,
  :yi_syllable_jurx => 0xa3f4,
  :yi_syllable_jur => 0xa3f5,
  :yi_syllable_jyt => 0xa3f6,
  :yi_syllable_jyx => 0xa3f7,
  :yi_syllable_jy => 0xa3f8,
  :yi_syllable_jyp => 0xa3f9,
  :yi_syllable_jyrx => 0xa3fa,
  :yi_syllable_jyr => 0xa3fb,
  :yi_syllable_qit => 0xa3fc,
  :yi_syllable_qix => 0xa3fd,
  :yi_syllable_qi => 0xa3fe,
  :yi_syllable_qip => 0xa3ff,
  :yi_syllable_qiet => 0xa400,
  :yi_syllable_qiex => 0xa401,
  :yi_syllable_qie => 0xa402,
  :yi_syllable_qiep => 0xa403,
  :yi_syllable_quot => 0xa404,
  :yi_syllable_quox => 0xa405,
  :yi_syllable_quo => 0xa406,
  :yi_syllable_quop => 0xa407,
  :yi_syllable_qot => 0xa408,
  :yi_syllable_qox => 0xa409,
  :yi_syllable_qo => 0xa40a,
  :yi_syllable_qop => 0xa40b,
  :yi_syllable_qut => 0xa40c,
  :yi_syllable_qux => 0xa40d,
  :yi_syllable_qu => 0xa40e,
  :yi_syllable_qup => 0xa40f,
  :yi_syllable_qurx => 0xa410,
  :yi_syllable_qur => 0xa411,
  :yi_syllable_qyt => 0xa412,
  :yi_syllable_qyx => 0xa413,
  :yi_syllable_qy => 0xa414,
  :yi_syllable_qyp => 0xa415,
  :yi_syllable_qyrx => 0xa416,
  :yi_syllable_qyr => 0xa417,
  :yi_syllable_jjit => 0xa418,
  :yi_syllable_jjix => 0xa419,
  :yi_syllable_jji => 0xa41a,
  :yi_syllable_jjip => 0xa41b,
  :yi_syllable_jjiet => 0xa41c,
  :yi_syllable_jjiex => 0xa41d,
  :yi_syllable_jjie => 0xa41e,
  :yi_syllable_jjiep => 0xa41f,
  :yi_syllable_jjuox => 0xa420,
  :yi_syllable_jjuo => 0xa421,
  :yi_syllable_jjuop => 0xa422,
  :yi_syllable_jjot => 0xa423,
  :yi_syllable_jjox => 0xa424,
  :yi_syllable_jjo => 0xa425,
  :yi_syllable_jjop => 0xa426,
  :yi_syllable_jjut => 0xa427,
  :yi_syllable_jjux => 0xa428,
  :yi_syllable_jju => 0xa429,
  :yi_syllable_jjup => 0xa42a,
  :yi_syllable_jjurx => 0xa42b,
  :yi_syllable_jjur => 0xa42c,
  :yi_syllable_jjyt => 0xa42d,
  :yi_syllable_jjyx => 0xa42e,
  :yi_syllable_jjy => 0xa42f,
  :yi_syllable_jjyp => 0xa430,
  :yi_syllable_njit => 0xa431,
  :yi_syllable_njix => 0xa432,
  :yi_syllable_nji => 0xa433,
  :yi_syllable_njip => 0xa434,
  :yi_syllable_njiet => 0xa435,
  :yi_syllable_njiex => 0xa436,
  :yi_syllable_njie => 0xa437,
  :yi_syllable_njiep => 0xa438,
  :yi_syllable_njuox => 0xa439,
  :yi_syllable_njuo => 0xa43a,
  :yi_syllable_njot => 0xa43b,
  :yi_syllable_njox => 0xa43c,
  :yi_syllable_njo => 0xa43d,
  :yi_syllable_njop => 0xa43e,
  :yi_syllable_njux => 0xa43f,
  :yi_syllable_nju => 0xa440,
  :yi_syllable_njup => 0xa441,
  :yi_syllable_njurx => 0xa442,
  :yi_syllable_njur => 0xa443,
  :yi_syllable_njyt => 0xa444,
  :yi_syllable_njyx => 0xa445,
  :yi_syllable_njy => 0xa446,
  :yi_syllable_njyp => 0xa447,
  :yi_syllable_njyrx => 0xa448,
  :yi_syllable_njyr => 0xa449,
  :yi_syllable_nyit => 0xa44a,
  :yi_syllable_nyix => 0xa44b,
  :yi_syllable_nyi => 0xa44c,
  :yi_syllable_nyip => 0xa44d,
  :yi_syllable_nyiet => 0xa44e,
  :yi_syllable_nyiex => 0xa44f,
  :yi_syllable_nyie => 0xa450,
  :yi_syllable_nyiep => 0xa451,
  :yi_syllable_nyuox => 0xa452,
  :yi_syllable_nyuo => 0xa453,
  :yi_syllable_nyuop => 0xa454,
  :yi_syllable_nyot => 0xa455,
  :yi_syllable_nyox => 0xa456,
  :yi_syllable_nyo => 0xa457,
  :yi_syllable_nyop => 0xa458,
  :yi_syllable_nyut => 0xa459,
  :yi_syllable_nyux => 0xa45a,
  :yi_syllable_nyu => 0xa45b,
  :yi_syllable_nyup => 0xa45c,
  :yi_syllable_xit => 0xa45d,
  :yi_syllable_xix => 0xa45e,
  :yi_syllable_xi => 0xa45f,
  :yi_syllable_xip => 0xa460,
  :yi_syllable_xiet => 0xa461,
  :yi_syllable_xiex => 0xa462,
  :yi_syllable_xie => 0xa463,
  :yi_syllable_xiep => 0xa464,
  :yi_syllable_xuox => 0xa465,
  :yi_syllable_xuo => 0xa466,
  :yi_syllable_xot => 0xa467,
  :yi_syllable_xox => 0xa468,
  :yi_syllable_xo => 0xa469,
  :yi_syllable_xop => 0xa46a,
  :yi_syllable_xyt => 0xa46b,
  :yi_syllable_xyx => 0xa46c,
  :yi_syllable_xy => 0xa46d,
  :yi_syllable_xyp => 0xa46e,
  :yi_syllable_xyrx => 0xa46f,
  :yi_syllable_xyr => 0xa470,
  :yi_syllable_yit => 0xa471,
  :yi_syllable_yix => 0xa472,
  :yi_syllable_yi => 0xa473,
  :yi_syllable_yip => 0xa474,
  :yi_syllable_yiet => 0xa475,
  :yi_syllable_yiex => 0xa476,
  :yi_syllable_yie => 0xa477,
  :yi_syllable_yiep => 0xa478,
  :yi_syllable_yuot => 0xa479,
  :yi_syllable_yuox => 0xa47a,
  :yi_syllable_yuo => 0xa47b,
  :yi_syllable_yuop => 0xa47c,
  :yi_syllable_yot => 0xa47d,
  :yi_syllable_yox => 0xa47e,
  :yi_syllable_yo => 0xa47f,
  :yi_syllable_yop => 0xa480,
  :yi_syllable_yut => 0xa481,
  :yi_syllable_yux => 0xa482,
  :yi_syllable_yu => 0xa483,
  :yi_syllable_yup => 0xa484,
  :yi_syllable_yurx => 0xa485,
  :yi_syllable_yur => 0xa486,
  :yi_syllable_yyt => 0xa487,
  :yi_syllable_yyx => 0xa488,
  :yi_syllable_yy => 0xa489,
  :yi_syllable_yyp => 0xa48a,
  :yi_syllable_yyrx => 0xa48b,
  :yi_syllable_yyr => 0xa48c,
  :yi_radical_qot => 0xa490,
  :yi_radical_li => 0xa491,
  :yi_radical_kit => 0xa492,
  :yi_radical_nyip => 0xa493,
  :yi_radical_cyp => 0xa494,
  :yi_radical_ssi => 0xa495,
  :yi_radical_ggop => 0xa496,
  :yi_radical_gep => 0xa497,
  :yi_radical_mi => 0xa498,
  :yi_radical_hxit => 0xa499,
  :yi_radical_lyr => 0xa49a,
  :yi_radical_bbut => 0xa49b,
  :yi_radical_mop => 0xa49c,
  :yi_radical_yo => 0xa49d,
  :yi_radical_put => 0xa49e,
  :yi_radical_hxuo => 0xa49f,
  :yi_radical_tat => 0xa4a0,
  :yi_radical_ga => 0xa4a1,
  :yi_radical_zup => 0xa4a2,
  :yi_radical_cyt => 0xa4a3,
  :yi_radical_ddur => 0xa4a4,
  :yi_radical_bur => 0xa4a5,
  :yi_radical_gguo => 0xa4a6,
  :yi_radical_nyop => 0xa4a7,
  :yi_radical_tu => 0xa4a8,
  :yi_radical_op => 0xa4a9,
  :yi_radical_jjut => 0xa4aa,
  :yi_radical_zot => 0xa4ab,
  :yi_radical_pyt => 0xa4ac,
  :yi_radical_hmo => 0xa4ad,
  :yi_radical_yit => 0xa4ae,
  :yi_radical_vur => 0xa4af,
  :yi_radical_shy => 0xa4b0,
  :yi_radical_vep => 0xa4b1,
  :yi_radical_za => 0xa4b2,
  :yi_radical_jo => 0xa4b3,
  :yi_radical_nzup => 0xa4b4,
  :yi_radical_jjy => 0xa4b5,
  :yi_radical_got => 0xa4b6,
  :yi_radical_jjie => 0xa4b7,
  :yi_radical_wo => 0xa4b8,
  :yi_radical_du => 0xa4b9,
  :yi_radical_shur => 0xa4ba,
  :yi_radical_lie => 0xa4bb,
  :yi_radical_cy => 0xa4bc,
  :yi_radical_cuop => 0xa4bd,
  :yi_radical_cip => 0xa4be,
  :yi_radical_hxop => 0xa4bf,
  :yi_radical_shat => 0xa4c0,
  :yi_radical_zur => 0xa4c1,
  :yi_radical_shop => 0xa4c2,
  :yi_radical_che => 0xa4c3,
  :yi_radical_zziet => 0xa4c4,
  :yi_radical_nbie => 0xa4c5,
  :yi_radical_ke => 0xa4c6,
  :modifier_letter_chinese_tone_yin_ping => 0xa700,
  :modifier_letter_chinese_tone_yang_ping => 0xa701,
  :modifier_letter_chinese_tone_yin_shang => 0xa702,
  :modifier_letter_chinese_tone_yang_shang => 0xa703,
  :modifier_letter_chinese_tone_yin_qu => 0xa704,
  :modifier_letter_chinese_tone_yang_qu => 0xa705,
  :modifier_letter_chinese_tone_yin_ru => 0xa706,
  :modifier_letter_chinese_tone_yang_ru => 0xa707,
  :modifier_letter_extra_high_dotted_tone_bar => 0xa708,
  :modifier_letter_high_dotted_tone_bar => 0xa709,
  :modifier_letter_mid_dotted_tone_bar => 0xa70a,
  :modifier_letter_low_dotted_tone_bar => 0xa70b,
  :modifier_letter_extra_low_dotted_tone_bar => 0xa70c,
  :modifier_letter_extra_high_dotted_left_stem_tone_bar => 0xa70d,
  :modifier_letter_high_dotted_left_stem_tone_bar => 0xa70e,
  :modifier_letter_mid_dotted_left_stem_tone_bar => 0xa70f,
  :modifier_letter_low_dotted_left_stem_tone_bar => 0xa710,
  :modifier_letter_extra_low_dotted_left_stem_tone_bar => 0xa711,
  :modifier_letter_extra_high_left_stem_tone_bar => 0xa712,
  :modifier_letter_high_left_stem_tone_bar => 0xa713,
  :modifier_letter_mid_left_stem_tone_bar => 0xa714,
  :modifier_letter_low_left_stem_tone_bar => 0xa715,
  :modifier_letter_extra_low_left_stem_tone_bar => 0xa716,
  :syloti_nagri_letter_a => 0xa800,
  :syloti_nagri_letter_i => 0xa801,
  :syloti_nagri_sign_dvisvara => 0xa802,
  :syloti_nagri_letter_u => 0xa803,
  :syloti_nagri_letter_e => 0xa804,
  :syloti_nagri_letter_o => 0xa805,
  :syloti_nagri_sign_hasanta => 0xa806,
  :syloti_nagri_letter_ko => 0xa807,
  :syloti_nagri_letter_kho => 0xa808,
  :syloti_nagri_letter_go => 0xa809,
  :syloti_nagri_letter_gho => 0xa80a,
  :syloti_nagri_sign_anusvara => 0xa80b,
  :syloti_nagri_letter_co => 0xa80c,
  :syloti_nagri_letter_cho => 0xa80d,
  :syloti_nagri_letter_jo => 0xa80e,
  :syloti_nagri_letter_jho => 0xa80f,
  :syloti_nagri_letter_tto => 0xa810,
  :syloti_nagri_letter_ttho => 0xa811,
  :syloti_nagri_letter_ddo => 0xa812,
  :syloti_nagri_letter_ddho => 0xa813,
  :syloti_nagri_letter_to => 0xa814,
  :syloti_nagri_letter_tho => 0xa815,
  :syloti_nagri_letter_do => 0xa816,
  :syloti_nagri_letter_dho => 0xa817,
  :syloti_nagri_letter_no => 0xa818,
  :syloti_nagri_letter_po => 0xa819,
  :syloti_nagri_letter_pho => 0xa81a,
  :syloti_nagri_letter_bo => 0xa81b,
  :syloti_nagri_letter_bho => 0xa81c,
  :syloti_nagri_letter_mo => 0xa81d,
  :syloti_nagri_letter_ro => 0xa81e,
  :syloti_nagri_letter_lo => 0xa81f,
  :syloti_nagri_letter_rro => 0xa820,
  :syloti_nagri_letter_so => 0xa821,
  :syloti_nagri_letter_ho => 0xa822,
  :syloti_nagri_vowel_sign_a => 0xa823,
  :syloti_nagri_vowel_sign_i => 0xa824,
  :syloti_nagri_vowel_sign_u => 0xa825,
  :syloti_nagri_vowel_sign_e => 0xa826,
  :syloti_nagri_vowel_sign_oo => 0xa827,
  :syloti_nagri_poetry_mark_1 => 0xa828,
  :syloti_nagri_poetry_mark_2 => 0xa829,
  :syloti_nagri_poetry_mark_3 => 0xa82a,
  :syloti_nagri_poetry_mark_4 => 0xa82b,
  :cjk_compatibility_ideograph_f900 => 0xf900,
  :cjk_compatibility_ideograph_f901 => 0xf901,
  :cjk_compatibility_ideograph_f902 => 0xf902,
  :cjk_compatibility_ideograph_f903 => 0xf903,
  :cjk_compatibility_ideograph_f904 => 0xf904,
  :cjk_compatibility_ideograph_f905 => 0xf905,
  :cjk_compatibility_ideograph_f906 => 0xf906,
  :cjk_compatibility_ideograph_f907 => 0xf907,
  :cjk_compatibility_ideograph_f908 => 0xf908,
  :cjk_compatibility_ideograph_f909 => 0xf909,
  :cjk_compatibility_ideograph_f90a => 0xf90a,
  :cjk_compatibility_ideograph_f90b => 0xf90b,
  :cjk_compatibility_ideograph_f90c => 0xf90c,
  :cjk_compatibility_ideograph_f90d => 0xf90d,
  :cjk_compatibility_ideograph_f90e => 0xf90e,
  :cjk_compatibility_ideograph_f90f => 0xf90f,
  :cjk_compatibility_ideograph_f910 => 0xf910,
  :cjk_compatibility_ideograph_f911 => 0xf911,
  :cjk_compatibility_ideograph_f912 => 0xf912,
  :cjk_compatibility_ideograph_f913 => 0xf913,
  :cjk_compatibility_ideograph_f914 => 0xf914,
  :cjk_compatibility_ideograph_f915 => 0xf915,
  :cjk_compatibility_ideograph_f916 => 0xf916,
  :cjk_compatibility_ideograph_f917 => 0xf917,
  :cjk_compatibility_ideograph_f918 => 0xf918,
  :cjk_compatibility_ideograph_f919 => 0xf919,
  :cjk_compatibility_ideograph_f91a => 0xf91a,
  :cjk_compatibility_ideograph_f91b => 0xf91b,
  :cjk_compatibility_ideograph_f91c => 0xf91c,
  :cjk_compatibility_ideograph_f91d => 0xf91d,
  :cjk_compatibility_ideograph_f91e => 0xf91e,
  :cjk_compatibility_ideograph_f91f => 0xf91f,
  :cjk_compatibility_ideograph_f920 => 0xf920,
  :cjk_compatibility_ideograph_f921 => 0xf921,
  :cjk_compatibility_ideograph_f922 => 0xf922,
  :cjk_compatibility_ideograph_f923 => 0xf923,
  :cjk_compatibility_ideograph_f924 => 0xf924,
  :cjk_compatibility_ideograph_f925 => 0xf925,
  :cjk_compatibility_ideograph_f926 => 0xf926,
  :cjk_compatibility_ideograph_f927 => 0xf927,
  :cjk_compatibility_ideograph_f928 => 0xf928,
  :cjk_compatibility_ideograph_f929 => 0xf929,
  :cjk_compatibility_ideograph_f92a => 0xf92a,
  :cjk_compatibility_ideograph_f92b => 0xf92b,
  :cjk_compatibility_ideograph_f92c => 0xf92c,
  :cjk_compatibility_ideograph_f92d => 0xf92d,
  :cjk_compatibility_ideograph_f92e => 0xf92e,
  :cjk_compatibility_ideograph_f92f => 0xf92f,
  :cjk_compatibility_ideograph_f930 => 0xf930,
  :cjk_compatibility_ideograph_f931 => 0xf931,
  :cjk_compatibility_ideograph_f932 => 0xf932,
  :cjk_compatibility_ideograph_f933 => 0xf933,
  :cjk_compatibility_ideograph_f934 => 0xf934,
  :cjk_compatibility_ideograph_f935 => 0xf935,
  :cjk_compatibility_ideograph_f936 => 0xf936,
  :cjk_compatibility_ideograph_f937 => 0xf937,
  :cjk_compatibility_ideograph_f938 => 0xf938,
  :cjk_compatibility_ideograph_f939 => 0xf939,
  :cjk_compatibility_ideograph_f93a => 0xf93a,
  :cjk_compatibility_ideograph_f93b => 0xf93b,
  :cjk_compatibility_ideograph_f93c => 0xf93c,
  :cjk_compatibility_ideograph_f93d => 0xf93d,
  :cjk_compatibility_ideograph_f93e => 0xf93e,
  :cjk_compatibility_ideograph_f93f => 0xf93f,
  :cjk_compatibility_ideograph_f940 => 0xf940,
  :cjk_compatibility_ideograph_f941 => 0xf941,
  :cjk_compatibility_ideograph_f942 => 0xf942,
  :cjk_compatibility_ideograph_f943 => 0xf943,
  :cjk_compatibility_ideograph_f944 => 0xf944,
  :cjk_compatibility_ideograph_f945 => 0xf945,
  :cjk_compatibility_ideograph_f946 => 0xf946,
  :cjk_compatibility_ideograph_f947 => 0xf947,
  :cjk_compatibility_ideograph_f948 => 0xf948,
  :cjk_compatibility_ideograph_f949 => 0xf949,
  :cjk_compatibility_ideograph_f94a => 0xf94a,
  :cjk_compatibility_ideograph_f94b => 0xf94b,
  :cjk_compatibility_ideograph_f94c => 0xf94c,
  :cjk_compatibility_ideograph_f94d => 0xf94d,
  :cjk_compatibility_ideograph_f94e => 0xf94e,
  :cjk_compatibility_ideograph_f94f => 0xf94f,
  :cjk_compatibility_ideograph_f950 => 0xf950,
  :cjk_compatibility_ideograph_f951 => 0xf951,
  :cjk_compatibility_ideograph_f952 => 0xf952,
  :cjk_compatibility_ideograph_f953 => 0xf953,
  :cjk_compatibility_ideograph_f954 => 0xf954,
  :cjk_compatibility_ideograph_f955 => 0xf955,
  :cjk_compatibility_ideograph_f956 => 0xf956,
  :cjk_compatibility_ideograph_f957 => 0xf957,
  :cjk_compatibility_ideograph_f958 => 0xf958,
  :cjk_compatibility_ideograph_f959 => 0xf959,
  :cjk_compatibility_ideograph_f95a => 0xf95a,
  :cjk_compatibility_ideograph_f95b => 0xf95b,
  :cjk_compatibility_ideograph_f95c => 0xf95c,
  :cjk_compatibility_ideograph_f95d => 0xf95d,
  :cjk_compatibility_ideograph_f95e => 0xf95e,
  :cjk_compatibility_ideograph_f95f => 0xf95f,
  :cjk_compatibility_ideograph_f960 => 0xf960,
  :cjk_compatibility_ideograph_f961 => 0xf961,
  :cjk_compatibility_ideograph_f962 => 0xf962,
  :cjk_compatibility_ideograph_f963 => 0xf963,
  :cjk_compatibility_ideograph_f964 => 0xf964,
  :cjk_compatibility_ideograph_f965 => 0xf965,
  :cjk_compatibility_ideograph_f966 => 0xf966,
  :cjk_compatibility_ideograph_f967 => 0xf967,
  :cjk_compatibility_ideograph_f968 => 0xf968,
  :cjk_compatibility_ideograph_f969 => 0xf969,
  :cjk_compatibility_ideograph_f96a => 0xf96a,
  :cjk_compatibility_ideograph_f96b => 0xf96b,
  :cjk_compatibility_ideograph_f96c => 0xf96c,
  :cjk_compatibility_ideograph_f96d => 0xf96d,
  :cjk_compatibility_ideograph_f96e => 0xf96e,
  :cjk_compatibility_ideograph_f96f => 0xf96f,
  :cjk_compatibility_ideograph_f970 => 0xf970,
  :cjk_compatibility_ideograph_f971 => 0xf971,
  :cjk_compatibility_ideograph_f972 => 0xf972,
  :cjk_compatibility_ideograph_f973 => 0xf973,
  :cjk_compatibility_ideograph_f974 => 0xf974,
  :cjk_compatibility_ideograph_f975 => 0xf975,
  :cjk_compatibility_ideograph_f976 => 0xf976,
  :cjk_compatibility_ideograph_f977 => 0xf977,
  :cjk_compatibility_ideograph_f978 => 0xf978,
  :cjk_compatibility_ideograph_f979 => 0xf979,
  :cjk_compatibility_ideograph_f97a => 0xf97a,
  :cjk_compatibility_ideograph_f97b => 0xf97b,
  :cjk_compatibility_ideograph_f97c => 0xf97c,
  :cjk_compatibility_ideograph_f97d => 0xf97d,
  :cjk_compatibility_ideograph_f97e => 0xf97e,
  :cjk_compatibility_ideograph_f97f => 0xf97f,
  :cjk_compatibility_ideograph_f980 => 0xf980,
  :cjk_compatibility_ideograph_f981 => 0xf981,
  :cjk_compatibility_ideograph_f982 => 0xf982,
  :cjk_compatibility_ideograph_f983 => 0xf983,
  :cjk_compatibility_ideograph_f984 => 0xf984,
  :cjk_compatibility_ideograph_f985 => 0xf985,
  :cjk_compatibility_ideograph_f986 => 0xf986,
  :cjk_compatibility_ideograph_f987 => 0xf987,
  :cjk_compatibility_ideograph_f988 => 0xf988,
  :cjk_compatibility_ideograph_f989 => 0xf989,
  :cjk_compatibility_ideograph_f98a => 0xf98a,
  :cjk_compatibility_ideograph_f98b => 0xf98b,
  :cjk_compatibility_ideograph_f98c => 0xf98c,
  :cjk_compatibility_ideograph_f98d => 0xf98d,
  :cjk_compatibility_ideograph_f98e => 0xf98e,
  :cjk_compatibility_ideograph_f98f => 0xf98f,
  :cjk_compatibility_ideograph_f990 => 0xf990,
  :cjk_compatibility_ideograph_f991 => 0xf991,
  :cjk_compatibility_ideograph_f992 => 0xf992,
  :cjk_compatibility_ideograph_f993 => 0xf993,
  :cjk_compatibility_ideograph_f994 => 0xf994,
  :cjk_compatibility_ideograph_f995 => 0xf995,
  :cjk_compatibility_ideograph_f996 => 0xf996,
  :cjk_compatibility_ideograph_f997 => 0xf997,
  :cjk_compatibility_ideograph_f998 => 0xf998,
  :cjk_compatibility_ideograph_f999 => 0xf999,
  :cjk_compatibility_ideograph_f99a => 0xf99a,
  :cjk_compatibility_ideograph_f99b => 0xf99b,
  :cjk_compatibility_ideograph_f99c => 0xf99c,
  :cjk_compatibility_ideograph_f99d => 0xf99d,
  :cjk_compatibility_ideograph_f99e => 0xf99e,
  :cjk_compatibility_ideograph_f99f => 0xf99f,
  :cjk_compatibility_ideograph_f9a0 => 0xf9a0,
  :cjk_compatibility_ideograph_f9a1 => 0xf9a1,
  :cjk_compatibility_ideograph_f9a2 => 0xf9a2,
  :cjk_compatibility_ideograph_f9a3 => 0xf9a3,
  :cjk_compatibility_ideograph_f9a4 => 0xf9a4,
  :cjk_compatibility_ideograph_f9a5 => 0xf9a5,
  :cjk_compatibility_ideograph_f9a6 => 0xf9a6,
  :cjk_compatibility_ideograph_f9a7 => 0xf9a7,
  :cjk_compatibility_ideograph_f9a8 => 0xf9a8,
  :cjk_compatibility_ideograph_f9a9 => 0xf9a9,
  :cjk_compatibility_ideograph_f9aa => 0xf9aa,
  :cjk_compatibility_ideograph_f9ab => 0xf9ab,
  :cjk_compatibility_ideograph_f9ac => 0xf9ac,
  :cjk_compatibility_ideograph_f9ad => 0xf9ad,
  :cjk_compatibility_ideograph_f9ae => 0xf9ae,
  :cjk_compatibility_ideograph_f9af => 0xf9af,
  :cjk_compatibility_ideograph_f9b0 => 0xf9b0,
  :cjk_compatibility_ideograph_f9b1 => 0xf9b1,
  :cjk_compatibility_ideograph_f9b2 => 0xf9b2,
  :cjk_compatibility_ideograph_f9b3 => 0xf9b3,
  :cjk_compatibility_ideograph_f9b4 => 0xf9b4,
  :cjk_compatibility_ideograph_f9b5 => 0xf9b5,
  :cjk_compatibility_ideograph_f9b6 => 0xf9b6,
  :cjk_compatibility_ideograph_f9b7 => 0xf9b7,
  :cjk_compatibility_ideograph_f9b8 => 0xf9b8,
  :cjk_compatibility_ideograph_f9b9 => 0xf9b9,
  :cjk_compatibility_ideograph_f9ba => 0xf9ba,
  :cjk_compatibility_ideograph_f9bb => 0xf9bb,
  :cjk_compatibility_ideograph_f9bc => 0xf9bc,
  :cjk_compatibility_ideograph_f9bd => 0xf9bd,
  :cjk_compatibility_ideograph_f9be => 0xf9be,
  :cjk_compatibility_ideograph_f9bf => 0xf9bf,
  :cjk_compatibility_ideograph_f9c0 => 0xf9c0,
  :cjk_compatibility_ideograph_f9c1 => 0xf9c1,
  :cjk_compatibility_ideograph_f9c2 => 0xf9c2,
  :cjk_compatibility_ideograph_f9c3 => 0xf9c3,
  :cjk_compatibility_ideograph_f9c4 => 0xf9c4,
  :cjk_compatibility_ideograph_f9c5 => 0xf9c5,
  :cjk_compatibility_ideograph_f9c6 => 0xf9c6,
  :cjk_compatibility_ideograph_f9c7 => 0xf9c7,
  :cjk_compatibility_ideograph_f9c8 => 0xf9c8,
  :cjk_compatibility_ideograph_f9c9 => 0xf9c9,
  :cjk_compatibility_ideograph_f9ca => 0xf9ca,
  :cjk_compatibility_ideograph_f9cb => 0xf9cb,
  :cjk_compatibility_ideograph_f9cc => 0xf9cc,
  :cjk_compatibility_ideograph_f9cd => 0xf9cd,
  :cjk_compatibility_ideograph_f9ce => 0xf9ce,
  :cjk_compatibility_ideograph_f9cf => 0xf9cf,
  :cjk_compatibility_ideograph_f9d0 => 0xf9d0,
  :cjk_compatibility_ideograph_f9d1 => 0xf9d1,
  :cjk_compatibility_ideograph_f9d2 => 0xf9d2,
  :cjk_compatibility_ideograph_f9d3 => 0xf9d3,
  :cjk_compatibility_ideograph_f9d4 => 0xf9d4,
  :cjk_compatibility_ideograph_f9d5 => 0xf9d5,
  :cjk_compatibility_ideograph_f9d6 => 0xf9d6,
  :cjk_compatibility_ideograph_f9d7 => 0xf9d7,
  :cjk_compatibility_ideograph_f9d8 => 0xf9d8,
  :cjk_compatibility_ideograph_f9d9 => 0xf9d9,
  :cjk_compatibility_ideograph_f9da => 0xf9da,
  :cjk_compatibility_ideograph_f9db => 0xf9db,
  :cjk_compatibility_ideograph_f9dc => 0xf9dc,
  :cjk_compatibility_ideograph_f9dd => 0xf9dd,
  :cjk_compatibility_ideograph_f9de => 0xf9de,
  :cjk_compatibility_ideograph_f9df => 0xf9df,
  :cjk_compatibility_ideograph_f9e0 => 0xf9e0,
  :cjk_compatibility_ideograph_f9e1 => 0xf9e1,
  :cjk_compatibility_ideograph_f9e2 => 0xf9e2,
  :cjk_compatibility_ideograph_f9e3 => 0xf9e3,
  :cjk_compatibility_ideograph_f9e4 => 0xf9e4,
  :cjk_compatibility_ideograph_f9e5 => 0xf9e5,
  :cjk_compatibility_ideograph_f9e6 => 0xf9e6,
  :cjk_compatibility_ideograph_f9e7 => 0xf9e7,
  :cjk_compatibility_ideograph_f9e8 => 0xf9e8,
  :cjk_compatibility_ideograph_f9e9 => 0xf9e9,
  :cjk_compatibility_ideograph_f9ea => 0xf9ea,
  :cjk_compatibility_ideograph_f9eb => 0xf9eb,
  :cjk_compatibility_ideograph_f9ec => 0xf9ec,
  :cjk_compatibility_ideograph_f9ed => 0xf9ed,
  :cjk_compatibility_ideograph_f9ee => 0xf9ee,
  :cjk_compatibility_ideograph_f9ef => 0xf9ef,
  :cjk_compatibility_ideograph_f9f0 => 0xf9f0,
  :cjk_compatibility_ideograph_f9f1 => 0xf9f1,
  :cjk_compatibility_ideograph_f9f2 => 0xf9f2,
  :cjk_compatibility_ideograph_f9f3 => 0xf9f3,
  :cjk_compatibility_ideograph_f9f4 => 0xf9f4,
  :cjk_compatibility_ideograph_f9f5 => 0xf9f5,
  :cjk_compatibility_ideograph_f9f6 => 0xf9f6,
  :cjk_compatibility_ideograph_f9f7 => 0xf9f7,
  :cjk_compatibility_ideograph_f9f8 => 0xf9f8,
  :cjk_compatibility_ideograph_f9f9 => 0xf9f9,
  :cjk_compatibility_ideograph_f9fa => 0xf9fa,
  :cjk_compatibility_ideograph_f9fb => 0xf9fb,
  :cjk_compatibility_ideograph_f9fc => 0xf9fc,
  :cjk_compatibility_ideograph_f9fd => 0xf9fd,
  :cjk_compatibility_ideograph_f9fe => 0xf9fe,
  :cjk_compatibility_ideograph_f9ff => 0xf9ff,
  :cjk_compatibility_ideograph_fa00 => 0xfa00,
  :cjk_compatibility_ideograph_fa01 => 0xfa01,
  :cjk_compatibility_ideograph_fa02 => 0xfa02,
  :cjk_compatibility_ideograph_fa03 => 0xfa03,
  :cjk_compatibility_ideograph_fa04 => 0xfa04,
  :cjk_compatibility_ideograph_fa05 => 0xfa05,
  :cjk_compatibility_ideograph_fa06 => 0xfa06,
  :cjk_compatibility_ideograph_fa07 => 0xfa07,
  :cjk_compatibility_ideograph_fa08 => 0xfa08,
  :cjk_compatibility_ideograph_fa09 => 0xfa09,
  :cjk_compatibility_ideograph_fa0a => 0xfa0a,
  :cjk_compatibility_ideograph_fa0b => 0xfa0b,
  :cjk_compatibility_ideograph_fa0c => 0xfa0c,
  :cjk_compatibility_ideograph_fa0d => 0xfa0d,
  :cjk_compatibility_ideograph_fa0e => 0xfa0e,
  :cjk_compatibility_ideograph_fa0f => 0xfa0f,
  :cjk_compatibility_ideograph_fa10 => 0xfa10,
  :cjk_compatibility_ideograph_fa11 => 0xfa11,
  :cjk_compatibility_ideograph_fa12 => 0xfa12,
  :cjk_compatibility_ideograph_fa13 => 0xfa13,
  :cjk_compatibility_ideograph_fa14 => 0xfa14,
  :cjk_compatibility_ideograph_fa15 => 0xfa15,
  :cjk_compatibility_ideograph_fa16 => 0xfa16,
  :cjk_compatibility_ideograph_fa17 => 0xfa17,
  :cjk_compatibility_ideograph_fa18 => 0xfa18,
  :cjk_compatibility_ideograph_fa19 => 0xfa19,
  :cjk_compatibility_ideograph_fa1a => 0xfa1a,
  :cjk_compatibility_ideograph_fa1b => 0xfa1b,
  :cjk_compatibility_ideograph_fa1c => 0xfa1c,
  :cjk_compatibility_ideograph_fa1d => 0xfa1d,
  :cjk_compatibility_ideograph_fa1e => 0xfa1e,
  :cjk_compatibility_ideograph_fa1f => 0xfa1f,
  :cjk_compatibility_ideograph_fa20 => 0xfa20,
  :cjk_compatibility_ideograph_fa21 => 0xfa21,
  :cjk_compatibility_ideograph_fa22 => 0xfa22,
  :cjk_compatibility_ideograph_fa23 => 0xfa23,
  :cjk_compatibility_ideograph_fa24 => 0xfa24,
  :cjk_compatibility_ideograph_fa25 => 0xfa25,
  :cjk_compatibility_ideograph_fa26 => 0xfa26,
  :cjk_compatibility_ideograph_fa27 => 0xfa27,
  :cjk_compatibility_ideograph_fa28 => 0xfa28,
  :cjk_compatibility_ideograph_fa29 => 0xfa29,
  :cjk_compatibility_ideograph_fa2a => 0xfa2a,
  :cjk_compatibility_ideograph_fa2b => 0xfa2b,
  :cjk_compatibility_ideograph_fa2c => 0xfa2c,
  :cjk_compatibility_ideograph_fa2d => 0xfa2d,
  :cjk_compatibility_ideograph_fa30 => 0xfa30,
  :cjk_compatibility_ideograph_fa31 => 0xfa31,
  :cjk_compatibility_ideograph_fa32 => 0xfa32,
  :cjk_compatibility_ideograph_fa33 => 0xfa33,
  :cjk_compatibility_ideograph_fa34 => 0xfa34,
  :cjk_compatibility_ideograph_fa35 => 0xfa35,
  :cjk_compatibility_ideograph_fa36 => 0xfa36,
  :cjk_compatibility_ideograph_fa37 => 0xfa37,
  :cjk_compatibility_ideograph_fa38 => 0xfa38,
  :cjk_compatibility_ideograph_fa39 => 0xfa39,
  :cjk_compatibility_ideograph_fa3a => 0xfa3a,
  :cjk_compatibility_ideograph_fa3b => 0xfa3b,
  :cjk_compatibility_ideograph_fa3c => 0xfa3c,
  :cjk_compatibility_ideograph_fa3d => 0xfa3d,
  :cjk_compatibility_ideograph_fa3e => 0xfa3e,
  :cjk_compatibility_ideograph_fa3f => 0xfa3f,
  :cjk_compatibility_ideograph_fa40 => 0xfa40,
  :cjk_compatibility_ideograph_fa41 => 0xfa41,
  :cjk_compatibility_ideograph_fa42 => 0xfa42,
  :cjk_compatibility_ideograph_fa43 => 0xfa43,
  :cjk_compatibility_ideograph_fa44 => 0xfa44,
  :cjk_compatibility_ideograph_fa45 => 0xfa45,
  :cjk_compatibility_ideograph_fa46 => 0xfa46,
  :cjk_compatibility_ideograph_fa47 => 0xfa47,
  :cjk_compatibility_ideograph_fa48 => 0xfa48,
  :cjk_compatibility_ideograph_fa49 => 0xfa49,
  :cjk_compatibility_ideograph_fa4a => 0xfa4a,
  :cjk_compatibility_ideograph_fa4b => 0xfa4b,
  :cjk_compatibility_ideograph_fa4c => 0xfa4c,
  :cjk_compatibility_ideograph_fa4d => 0xfa4d,
  :cjk_compatibility_ideograph_fa4e => 0xfa4e,
  :cjk_compatibility_ideograph_fa4f => 0xfa4f,
  :cjk_compatibility_ideograph_fa50 => 0xfa50,
  :cjk_compatibility_ideograph_fa51 => 0xfa51,
  :cjk_compatibility_ideograph_fa52 => 0xfa52,
  :cjk_compatibility_ideograph_fa53 => 0xfa53,
  :cjk_compatibility_ideograph_fa54 => 0xfa54,
  :cjk_compatibility_ideograph_fa55 => 0xfa55,
  :cjk_compatibility_ideograph_fa56 => 0xfa56,
  :cjk_compatibility_ideograph_fa57 => 0xfa57,
  :cjk_compatibility_ideograph_fa58 => 0xfa58,
  :cjk_compatibility_ideograph_fa59 => 0xfa59,
  :cjk_compatibility_ideograph_fa5a => 0xfa5a,
  :cjk_compatibility_ideograph_fa5b => 0xfa5b,
  :cjk_compatibility_ideograph_fa5c => 0xfa5c,
  :cjk_compatibility_ideograph_fa5d => 0xfa5d,
  :cjk_compatibility_ideograph_fa5e => 0xfa5e,
  :cjk_compatibility_ideograph_fa5f => 0xfa5f,
  :cjk_compatibility_ideograph_fa60 => 0xfa60,
  :cjk_compatibility_ideograph_fa61 => 0xfa61,
  :cjk_compatibility_ideograph_fa62 => 0xfa62,
  :cjk_compatibility_ideograph_fa63 => 0xfa63,
  :cjk_compatibility_ideograph_fa64 => 0xfa64,
  :cjk_compatibility_ideograph_fa65 => 0xfa65,
  :cjk_compatibility_ideograph_fa66 => 0xfa66,
  :cjk_compatibility_ideograph_fa67 => 0xfa67,
  :cjk_compatibility_ideograph_fa68 => 0xfa68,
  :cjk_compatibility_ideograph_fa69 => 0xfa69,
  :cjk_compatibility_ideograph_fa6a => 0xfa6a,
  :cjk_compatibility_ideograph_fa70 => 0xfa70,
  :cjk_compatibility_ideograph_fa71 => 0xfa71,
  :cjk_compatibility_ideograph_fa72 => 0xfa72,
  :cjk_compatibility_ideograph_fa73 => 0xfa73,
  :cjk_compatibility_ideograph_fa74 => 0xfa74,
  :cjk_compatibility_ideograph_fa75 => 0xfa75,
  :cjk_compatibility_ideograph_fa76 => 0xfa76,
  :cjk_compatibility_ideograph_fa77 => 0xfa77,
  :cjk_compatibility_ideograph_fa78 => 0xfa78,
  :cjk_compatibility_ideograph_fa79 => 0xfa79,
  :cjk_compatibility_ideograph_fa7a => 0xfa7a,
  :cjk_compatibility_ideograph_fa7b => 0xfa7b,
  :cjk_compatibility_ideograph_fa7c => 0xfa7c,
  :cjk_compatibility_ideograph_fa7d => 0xfa7d,
  :cjk_compatibility_ideograph_fa7e => 0xfa7e,
  :cjk_compatibility_ideograph_fa7f => 0xfa7f,
  :cjk_compatibility_ideograph_fa80 => 0xfa80,
  :cjk_compatibility_ideograph_fa81 => 0xfa81,
  :cjk_compatibility_ideograph_fa82 => 0xfa82,
  :cjk_compatibility_ideograph_fa83 => 0xfa83,
  :cjk_compatibility_ideograph_fa84 => 0xfa84,
  :cjk_compatibility_ideograph_fa85 => 0xfa85,
  :cjk_compatibility_ideograph_fa86 => 0xfa86,
  :cjk_compatibility_ideograph_fa87 => 0xfa87,
  :cjk_compatibility_ideograph_fa88 => 0xfa88,
  :cjk_compatibility_ideograph_fa89 => 0xfa89,
  :cjk_compatibility_ideograph_fa8a => 0xfa8a,
  :cjk_compatibility_ideograph_fa8b => 0xfa8b,
  :cjk_compatibility_ideograph_fa8c => 0xfa8c,
  :cjk_compatibility_ideograph_fa8d => 0xfa8d,
  :cjk_compatibility_ideograph_fa8e => 0xfa8e,
  :cjk_compatibility_ideograph_fa8f => 0xfa8f,
  :cjk_compatibility_ideograph_fa90 => 0xfa90,
  :cjk_compatibility_ideograph_fa91 => 0xfa91,
  :cjk_compatibility_ideograph_fa92 => 0xfa92,
  :cjk_compatibility_ideograph_fa93 => 0xfa93,
  :cjk_compatibility_ideograph_fa94 => 0xfa94,
  :cjk_compatibility_ideograph_fa95 => 0xfa95,
  :cjk_compatibility_ideograph_fa96 => 0xfa96,
  :cjk_compatibility_ideograph_fa97 => 0xfa97,
  :cjk_compatibility_ideograph_fa98 => 0xfa98,
  :cjk_compatibility_ideograph_fa99 => 0xfa99,
  :cjk_compatibility_ideograph_fa9a => 0xfa9a,
  :cjk_compatibility_ideograph_fa9b => 0xfa9b,
  :cjk_compatibility_ideograph_fa9c => 0xfa9c,
  :cjk_compatibility_ideograph_fa9d => 0xfa9d,
  :cjk_compatibility_ideograph_fa9e => 0xfa9e,
  :cjk_compatibility_ideograph_fa9f => 0xfa9f,
  :cjk_compatibility_ideograph_faa0 => 0xfaa0,
  :cjk_compatibility_ideograph_faa1 => 0xfaa1,
  :cjk_compatibility_ideograph_faa2 => 0xfaa2,
  :cjk_compatibility_ideograph_faa3 => 0xfaa3,
  :cjk_compatibility_ideograph_faa4 => 0xfaa4,
  :cjk_compatibility_ideograph_faa5 => 0xfaa5,
  :cjk_compatibility_ideograph_faa6 => 0xfaa6,
  :cjk_compatibility_ideograph_faa7 => 0xfaa7,
  :cjk_compatibility_ideograph_faa8 => 0xfaa8,
  :cjk_compatibility_ideograph_faa9 => 0xfaa9,
  :cjk_compatibility_ideograph_faaa => 0xfaaa,
  :cjk_compatibility_ideograph_faab => 0xfaab,
  :cjk_compatibility_ideograph_faac => 0xfaac,
  :cjk_compatibility_ideograph_faad => 0xfaad,
  :cjk_compatibility_ideograph_faae => 0xfaae,
  :cjk_compatibility_ideograph_faaf => 0xfaaf,
  :cjk_compatibility_ideograph_fab0 => 0xfab0,
  :cjk_compatibility_ideograph_fab1 => 0xfab1,
  :cjk_compatibility_ideograph_fab2 => 0xfab2,
  :cjk_compatibility_ideograph_fab3 => 0xfab3,
  :cjk_compatibility_ideograph_fab4 => 0xfab4,
  :cjk_compatibility_ideograph_fab5 => 0xfab5,
  :cjk_compatibility_ideograph_fab6 => 0xfab6,
  :cjk_compatibility_ideograph_fab7 => 0xfab7,
  :cjk_compatibility_ideograph_fab8 => 0xfab8,
  :cjk_compatibility_ideograph_fab9 => 0xfab9,
  :cjk_compatibility_ideograph_faba => 0xfaba,
  :cjk_compatibility_ideograph_fabb => 0xfabb,
  :cjk_compatibility_ideograph_fabc => 0xfabc,
  :cjk_compatibility_ideograph_fabd => 0xfabd,
  :cjk_compatibility_ideograph_fabe => 0xfabe,
  :cjk_compatibility_ideograph_fabf => 0xfabf,
  :cjk_compatibility_ideograph_fac0 => 0xfac0,
  :cjk_compatibility_ideograph_fac1 => 0xfac1,
  :cjk_compatibility_ideograph_fac2 => 0xfac2,
  :cjk_compatibility_ideograph_fac3 => 0xfac3,
  :cjk_compatibility_ideograph_fac4 => 0xfac4,
  :cjk_compatibility_ideograph_fac5 => 0xfac5,
  :cjk_compatibility_ideograph_fac6 => 0xfac6,
  :cjk_compatibility_ideograph_fac7 => 0xfac7,
  :cjk_compatibility_ideograph_fac8 => 0xfac8,
  :cjk_compatibility_ideograph_fac9 => 0xfac9,
  :cjk_compatibility_ideograph_faca => 0xfaca,
  :cjk_compatibility_ideograph_facb => 0xfacb,
  :cjk_compatibility_ideograph_facc => 0xfacc,
  :cjk_compatibility_ideograph_facd => 0xfacd,
  :cjk_compatibility_ideograph_face => 0xface,
  :cjk_compatibility_ideograph_facf => 0xfacf,
  :cjk_compatibility_ideograph_fad0 => 0xfad0,
  :cjk_compatibility_ideograph_fad1 => 0xfad1,
  :cjk_compatibility_ideograph_fad2 => 0xfad2,
  :cjk_compatibility_ideograph_fad3 => 0xfad3,
  :cjk_compatibility_ideograph_fad4 => 0xfad4,
  :cjk_compatibility_ideograph_fad5 => 0xfad5,
  :cjk_compatibility_ideograph_fad6 => 0xfad6,
  :cjk_compatibility_ideograph_fad7 => 0xfad7,
  :cjk_compatibility_ideograph_fad8 => 0xfad8,
  :cjk_compatibility_ideograph_fad9 => 0xfad9,
  :latin_small_ligature_ff => 0xfb00,
  :latin_small_ligature_fi => 0xfb01,
  :latin_small_ligature_fl => 0xfb02,
  :latin_small_ligature_ffi => 0xfb03,
  :latin_small_ligature_ffl => 0xfb04,
  :latin_small_ligature_long_s_t => 0xfb05,
  :latin_small_ligature_st => 0xfb06,
  :armenian_small_ligature_men_now => 0xfb13,
  :armenian_small_ligature_men_ech => 0xfb14,
  :armenian_small_ligature_men_ini => 0xfb15,
  :armenian_small_ligature_vew_now => 0xfb16,
  :armenian_small_ligature_men_xeh => 0xfb17,
  :hebrew_letter_yod_with_hiriq => 0xfb1d,
  :hebrew_point_judeo_spanish_varika => 0xfb1e,
  :hebrew_point_varika => 0xfb1e,
  :hebrew_ligature_yiddish_yod_yod_patah => 0xfb1f,
  :hebrew_letter_alternative_ayin => 0xfb20,
  :hebrew_letter_wide_alef => 0xfb21,
  :hebrew_letter_wide_dalet => 0xfb22,
  :hebrew_letter_wide_he => 0xfb23,
  :hebrew_letter_wide_kaf => 0xfb24,
  :hebrew_letter_wide_lamed => 0xfb25,
  :hebrew_letter_wide_final_mem => 0xfb26,
  :hebrew_letter_wide_resh => 0xfb27,
  :hebrew_letter_wide_tav => 0xfb28,
  :hebrew_letter_alternative_plus_sign => 0xfb29,
  :hebrew_letter_shin_with_shin_dot => 0xfb2a,
  :hebrew_letter_shin_with_sin_dot => 0xfb2b,
  :hebrew_letter_shin_with_dagesh_and_shin_dot => 0xfb2c,
  :hebrew_letter_shin_with_dagesh_and_sin_dot => 0xfb2d,
  :hebrew_letter_alef_with_patah => 0xfb2e,
  :hebrew_letter_alef_with_qamats => 0xfb2f,
  :hebrew_letter_alef_with_mapiq => 0xfb30,
  :hebrew_letter_bet_with_dagesh => 0xfb31,
  :hebrew_letter_gimel_with_dagesh => 0xfb32,
  :hebrew_letter_dalet_with_dagesh => 0xfb33,
  :hebrew_letter_he_with_mapiq => 0xfb34,
  :hebrew_letter_vav_with_dagesh => 0xfb35,
  :hebrew_letter_zayin_with_dagesh => 0xfb36,
  :hebrew_letter_tet_with_dagesh => 0xfb38,
  :hebrew_letter_yod_with_dagesh => 0xfb39,
  :hebrew_letter_final_kaf_with_dagesh => 0xfb3a,
  :hebrew_letter_kaf_with_dagesh => 0xfb3b,
  :hebrew_letter_lamed_with_dagesh => 0xfb3c,
  :hebrew_letter_mem_with_dagesh => 0xfb3e,
  :hebrew_letter_nun_with_dagesh => 0xfb40,
  :hebrew_letter_samekh_with_dagesh => 0xfb41,
  :hebrew_letter_final_pe_with_dagesh => 0xfb43,
  :hebrew_letter_pe_with_dagesh => 0xfb44,
  :hebrew_letter_tsadi_with_dagesh => 0xfb46,
  :hebrew_letter_qof_with_dagesh => 0xfb47,
  :hebrew_letter_resh_with_dagesh => 0xfb48,
  :hebrew_letter_shin_with_dagesh => 0xfb49,
  :hebrew_letter_tav_with_dagesh => 0xfb4a,
  :hebrew_letter_vav_with_holam => 0xfb4b,
  :hebrew_letter_bet_with_rafe => 0xfb4c,
  :hebrew_letter_kaf_with_rafe => 0xfb4d,
  :hebrew_letter_pe_with_rafe => 0xfb4e,
  :hebrew_ligature_alef_lamed => 0xfb4f,
  :arabic_letter_alef_wasla_isolated_form => 0xfb50,
  :arabic_letter_alef_wasla_final_form => 0xfb51,
  :arabic_letter_beeh_isolated_form => 0xfb52,
  :arabic_letter_beeh_final_form => 0xfb53,
  :arabic_letter_beeh_initial_form => 0xfb54,
  :arabic_letter_beeh_medial_form => 0xfb55,
  :arabic_letter_peh_isolated_form => 0xfb56,
  :arabic_letter_peh_final_form => 0xfb57,
  :arabic_letter_peh_initial_form => 0xfb58,
  :arabic_letter_peh_medial_form => 0xfb59,
  :arabic_letter_beheh_isolated_form => 0xfb5a,
  :arabic_letter_beheh_final_form => 0xfb5b,
  :arabic_letter_beheh_initial_form => 0xfb5c,
  :arabic_letter_beheh_medial_form => 0xfb5d,
  :arabic_letter_tteheh_isolated_form => 0xfb5e,
  :arabic_letter_tteheh_final_form => 0xfb5f,
  :arabic_letter_tteheh_initial_form => 0xfb60,
  :arabic_letter_tteheh_medial_form => 0xfb61,
  :arabic_letter_teheh_isolated_form => 0xfb62,
  :arabic_letter_teheh_final_form => 0xfb63,
  :arabic_letter_teheh_initial_form => 0xfb64,
  :arabic_letter_teheh_medial_form => 0xfb65,
  :arabic_letter_tteh_isolated_form => 0xfb66,
  :arabic_letter_tteh_final_form => 0xfb67,
  :arabic_letter_tteh_initial_form => 0xfb68,
  :arabic_letter_tteh_medial_form => 0xfb69,
  :arabic_letter_veh_isolated_form => 0xfb6a,
  :arabic_letter_veh_final_form => 0xfb6b,
  :arabic_letter_veh_initial_form => 0xfb6c,
  :arabic_letter_veh_medial_form => 0xfb6d,
  :arabic_letter_peheh_isolated_form => 0xfb6e,
  :arabic_letter_peheh_final_form => 0xfb6f,
  :arabic_letter_peheh_initial_form => 0xfb70,
  :arabic_letter_peheh_medial_form => 0xfb71,
  :arabic_letter_dyeh_isolated_form => 0xfb72,
  :arabic_letter_dyeh_final_form => 0xfb73,
  :arabic_letter_dyeh_initial_form => 0xfb74,
  :arabic_letter_dyeh_medial_form => 0xfb75,
  :arabic_letter_nyeh_isolated_form => 0xfb76,
  :arabic_letter_nyeh_final_form => 0xfb77,
  :arabic_letter_nyeh_initial_form => 0xfb78,
  :arabic_letter_nyeh_medial_form => 0xfb79,
  :arabic_letter_tcheh_isolated_form => 0xfb7a,
  :arabic_letter_tcheh_final_form => 0xfb7b,
  :arabic_letter_tcheh_initial_form => 0xfb7c,
  :arabic_letter_tcheh_medial_form => 0xfb7d,
  :arabic_letter_tcheheh_isolated_form => 0xfb7e,
  :arabic_letter_tcheheh_final_form => 0xfb7f,
  :arabic_letter_tcheheh_initial_form => 0xfb80,
  :arabic_letter_tcheheh_medial_form => 0xfb81,
  :arabic_letter_ddahal_isolated_form => 0xfb82,
  :arabic_letter_ddahal_final_form => 0xfb83,
  :arabic_letter_dahal_isolated_form => 0xfb84,
  :arabic_letter_dahal_final_form => 0xfb85,
  :arabic_letter_dul_isolated_form => 0xfb86,
  :arabic_letter_dul_final_form => 0xfb87,
  :arabic_letter_ddal_isolated_form => 0xfb88,
  :arabic_letter_ddal_final_form => 0xfb89,
  :arabic_letter_jeh_isolated_form => 0xfb8a,
  :arabic_letter_jeh_final_form => 0xfb8b,
  :arabic_letter_rreh_isolated_form => 0xfb8c,
  :arabic_letter_rreh_final_form => 0xfb8d,
  :arabic_letter_keheh_isolated_form => 0xfb8e,
  :arabic_letter_keheh_final_form => 0xfb8f,
  :arabic_letter_keheh_initial_form => 0xfb90,
  :arabic_letter_keheh_medial_form => 0xfb91,
  :arabic_letter_gaf_isolated_form => 0xfb92,
  :arabic_letter_gaf_final_form => 0xfb93,
  :arabic_letter_gaf_initial_form => 0xfb94,
  :arabic_letter_gaf_medial_form => 0xfb95,
  :arabic_letter_gueh_isolated_form => 0xfb96,
  :arabic_letter_gueh_final_form => 0xfb97,
  :arabic_letter_gueh_initial_form => 0xfb98,
  :arabic_letter_gueh_medial_form => 0xfb99,
  :arabic_letter_ngoeh_isolated_form => 0xfb9a,
  :arabic_letter_ngoeh_final_form => 0xfb9b,
  :arabic_letter_ngoeh_initial_form => 0xfb9c,
  :arabic_letter_ngoeh_medial_form => 0xfb9d,
  :arabic_letter_noon_ghunna_isolated_form => 0xfb9e,
  :arabic_letter_noon_ghunna_final_form => 0xfb9f,
  :arabic_letter_rnoon_isolated_form => 0xfba0,
  :arabic_letter_rnoon_final_form => 0xfba1,
  :arabic_letter_rnoon_initial_form => 0xfba2,
  :arabic_letter_rnoon_medial_form => 0xfba3,
  :arabic_letter_heh_with_yeh_above_isolated_form => 0xfba4,
  :arabic_letter_heh_with_yeh_above_final_form => 0xfba5,
  :arabic_letter_heh_goal_isolated_form => 0xfba6,
  :arabic_letter_heh_goal_final_form => 0xfba7,
  :arabic_letter_heh_goal_initial_form => 0xfba8,
  :arabic_letter_heh_goal_medial_form => 0xfba9,
  :arabic_letter_heh_doachashmee_isolated_form => 0xfbaa,
  :arabic_letter_heh_doachashmee_final_form => 0xfbab,
  :arabic_letter_heh_doachashmee_initial_form => 0xfbac,
  :arabic_letter_heh_doachashmee_medial_form => 0xfbad,
  :arabic_letter_yeh_barree_isolated_form => 0xfbae,
  :arabic_letter_yeh_barree_final_form => 0xfbaf,
  :arabic_letter_yeh_barree_with_hamza_above_isolated_form => 0xfbb0,
  :arabic_letter_yeh_barree_with_hamza_above_final_form => 0xfbb1,
  :arabic_letter_ng_isolated_form => 0xfbd3,
  :arabic_letter_ng_final_form => 0xfbd4,
  :arabic_letter_ng_initial_form => 0xfbd5,
  :arabic_letter_ng_medial_form => 0xfbd6,
  :arabic_letter_u_isolated_form => 0xfbd7,
  :arabic_letter_u_final_form => 0xfbd8,
  :arabic_letter_oe_isolated_form => 0xfbd9,
  :arabic_letter_oe_final_form => 0xfbda,
  :arabic_letter_yu_isolated_form => 0xfbdb,
  :arabic_letter_yu_final_form => 0xfbdc,
  :arabic_letter_u_with_hamza_above_isolated_form => 0xfbdd,
  :arabic_letter_ve_isolated_form => 0xfbde,
  :arabic_letter_ve_final_form => 0xfbdf,
  :arabic_letter_kirghiz_oe_isolated_form => 0xfbe0,
  :arabic_letter_kirghiz_oe_final_form => 0xfbe1,
  :arabic_letter_kirghiz_yu_isolated_form => 0xfbe2,
  :arabic_letter_kirghiz_yu_final_form => 0xfbe3,
  :arabic_letter_e_isolated_form => 0xfbe4,
  :arabic_letter_e_final_form => 0xfbe5,
  :arabic_letter_e_initial_form => 0xfbe6,
  :arabic_letter_e_medial_form => 0xfbe7,
  :arabic_letter_uighur_kazakh_kirghiz_alef_maksura_initial_form => 0xfbe8,
  :arabic_letter_uighur_kazakh_kirghiz_alef_maksura_medial_form => 0xfbe9,
  :arabic_ligature_yeh_with_hamza_above_with_alef_isolated_form => 0xfbea,
  :arabic_ligature_yeh_with_hamza_above_with_alef_final_form => 0xfbeb,
  :arabic_ligature_yeh_with_hamza_above_with_ae_isolated_form => 0xfbec,
  :arabic_ligature_yeh_with_hamza_above_with_ae_final_form => 0xfbed,
  :arabic_ligature_yeh_with_hamza_above_with_waw_isolated_form => 0xfbee,
  :arabic_ligature_yeh_with_hamza_above_with_waw_final_form => 0xfbef,
  :arabic_ligature_yeh_with_hamza_above_with_u_isolated_form => 0xfbf0,
  :arabic_ligature_yeh_with_hamza_above_with_u_final_form => 0xfbf1,
  :arabic_ligature_yeh_with_hamza_above_with_oe_isolated_form => 0xfbf2,
  :arabic_ligature_yeh_with_hamza_above_with_oe_final_form => 0xfbf3,
  :arabic_ligature_yeh_with_hamza_above_with_yu_isolated_form => 0xfbf4,
  :arabic_ligature_yeh_with_hamza_above_with_yu_final_form => 0xfbf5,
  :arabic_ligature_yeh_with_hamza_above_with_e_isolated_form => 0xfbf6,
  :arabic_ligature_yeh_with_hamza_above_with_e_final_form => 0xfbf7,
  :arabic_ligature_yeh_with_hamza_above_with_e_initial_form => 0xfbf8,
  :arabic_ligature_uighur_kirghiz_yeh_with_hamza_above_with_alef_maksura_isolated_form => 0xfbf9,
  :arabic_ligature_uighur_kirghiz_yeh_with_hamza_above_with_alef_maksura_final_form => 0xfbfa,
  :arabic_ligature_uighur_kirghiz_yeh_with_hamza_above_with_alef_maksura_initial_form => 0xfbfb,
  :arabic_letter_farsi_yeh_isolated_form => 0xfbfc,
  :arabic_letter_farsi_yeh_final_form => 0xfbfd,
  :arabic_letter_farsi_yeh_initial_form => 0xfbfe,
  :arabic_letter_farsi_yeh_medial_form => 0xfbff,
  :arabic_ligature_yeh_with_hamza_above_with_jeem_isolated_form => 0xfc00,
  :arabic_ligature_yeh_with_hamza_above_with_hah_isolated_form => 0xfc01,
  :arabic_ligature_yeh_with_hamza_above_with_meem_isolated_form => 0xfc02,
  :arabic_ligature_yeh_with_hamza_above_with_alef_maksura_isolated_form => 0xfc03,
  :arabic_ligature_yeh_with_hamza_above_with_yeh_isolated_form => 0xfc04,
  :arabic_ligature_beh_with_jeem_isolated_form => 0xfc05,
  :arabic_ligature_beh_with_hah_isolated_form => 0xfc06,
  :arabic_ligature_beh_with_khah_isolated_form => 0xfc07,
  :arabic_ligature_beh_with_meem_isolated_form => 0xfc08,
  :arabic_ligature_beh_with_alef_maksura_isolated_form => 0xfc09,
  :arabic_ligature_beh_with_yeh_isolated_form => 0xfc0a,
  :arabic_ligature_teh_with_jeem_isolated_form => 0xfc0b,
  :arabic_ligature_teh_with_hah_isolated_form => 0xfc0c,
  :arabic_ligature_teh_with_khah_isolated_form => 0xfc0d,
  :arabic_ligature_teh_with_meem_isolated_form => 0xfc0e,
  :arabic_ligature_teh_with_alef_maksura_isolated_form => 0xfc0f,
  :arabic_ligature_teh_with_yeh_isolated_form => 0xfc10,
  :arabic_ligature_theh_with_jeem_isolated_form => 0xfc11,
  :arabic_ligature_theh_with_meem_isolated_form => 0xfc12,
  :arabic_ligature_theh_with_alef_maksura_isolated_form => 0xfc13,
  :arabic_ligature_theh_with_yeh_isolated_form => 0xfc14,
  :arabic_ligature_jeem_with_hah_isolated_form => 0xfc15,
  :arabic_ligature_jeem_with_meem_isolated_form => 0xfc16,
  :arabic_ligature_hah_with_jeem_isolated_form => 0xfc17,
  :arabic_ligature_hah_with_meem_isolated_form => 0xfc18,
  :arabic_ligature_khah_with_jeem_isolated_form => 0xfc19,
  :arabic_ligature_khah_with_hah_isolated_form => 0xfc1a,
  :arabic_ligature_khah_with_meem_isolated_form => 0xfc1b,
  :arabic_ligature_seen_with_jeem_isolated_form => 0xfc1c,
  :arabic_ligature_seen_with_hah_isolated_form => 0xfc1d,
  :arabic_ligature_seen_with_khah_isolated_form => 0xfc1e,
  :arabic_ligature_seen_with_meem_isolated_form => 0xfc1f,
  :arabic_ligature_sad_with_hah_isolated_form => 0xfc20,
  :arabic_ligature_sad_with_meem_isolated_form => 0xfc21,
  :arabic_ligature_dad_with_jeem_isolated_form => 0xfc22,
  :arabic_ligature_dad_with_hah_isolated_form => 0xfc23,
  :arabic_ligature_dad_with_khah_isolated_form => 0xfc24,
  :arabic_ligature_dad_with_meem_isolated_form => 0xfc25,
  :arabic_ligature_tah_with_hah_isolated_form => 0xfc26,
  :arabic_ligature_tah_with_meem_isolated_form => 0xfc27,
  :arabic_ligature_zah_with_meem_isolated_form => 0xfc28,
  :arabic_ligature_ain_with_jeem_isolated_form => 0xfc29,
  :arabic_ligature_ain_with_meem_isolated_form => 0xfc2a,
  :arabic_ligature_ghain_with_jeem_isolated_form => 0xfc2b,
  :arabic_ligature_ghain_with_meem_isolated_form => 0xfc2c,
  :arabic_ligature_feh_with_jeem_isolated_form => 0xfc2d,
  :arabic_ligature_feh_with_hah_isolated_form => 0xfc2e,
  :arabic_ligature_feh_with_khah_isolated_form => 0xfc2f,
  :arabic_ligature_feh_with_meem_isolated_form => 0xfc30,
  :arabic_ligature_feh_with_alef_maksura_isolated_form => 0xfc31,
  :arabic_ligature_feh_with_yeh_isolated_form => 0xfc32,
  :arabic_ligature_qaf_with_hah_isolated_form => 0xfc33,
  :arabic_ligature_qaf_with_meem_isolated_form => 0xfc34,
  :arabic_ligature_qaf_with_alef_maksura_isolated_form => 0xfc35,
  :arabic_ligature_qaf_with_yeh_isolated_form => 0xfc36,
  :arabic_ligature_kaf_with_alef_isolated_form => 0xfc37,
  :arabic_ligature_kaf_with_jeem_isolated_form => 0xfc38,
  :arabic_ligature_kaf_with_hah_isolated_form => 0xfc39,
  :arabic_ligature_kaf_with_khah_isolated_form => 0xfc3a,
  :arabic_ligature_kaf_with_lam_isolated_form => 0xfc3b,
  :arabic_ligature_kaf_with_meem_isolated_form => 0xfc3c,
  :arabic_ligature_kaf_with_alef_maksura_isolated_form => 0xfc3d,
  :arabic_ligature_kaf_with_yeh_isolated_form => 0xfc3e,
  :arabic_ligature_lam_with_jeem_isolated_form => 0xfc3f,
  :arabic_ligature_lam_with_hah_isolated_form => 0xfc40,
  :arabic_ligature_lam_with_khah_isolated_form => 0xfc41,
  :arabic_ligature_lam_with_meem_isolated_form => 0xfc42,
  :arabic_ligature_lam_with_alef_maksura_isolated_form => 0xfc43,
  :arabic_ligature_lam_with_yeh_isolated_form => 0xfc44,
  :arabic_ligature_meem_with_jeem_isolated_form => 0xfc45,
  :arabic_ligature_meem_with_hah_isolated_form => 0xfc46,
  :arabic_ligature_meem_with_khah_isolated_form => 0xfc47,
  :arabic_ligature_meem_with_meem_isolated_form => 0xfc48,
  :arabic_ligature_meem_with_alef_maksura_isolated_form => 0xfc49,
  :arabic_ligature_meem_with_yeh_isolated_form => 0xfc4a,
  :arabic_ligature_noon_with_jeem_isolated_form => 0xfc4b,
  :arabic_ligature_noon_with_hah_isolated_form => 0xfc4c,
  :arabic_ligature_noon_with_khah_isolated_form => 0xfc4d,
  :arabic_ligature_noon_with_meem_isolated_form => 0xfc4e,
  :arabic_ligature_noon_with_alef_maksura_isolated_form => 0xfc4f,
  :arabic_ligature_noon_with_yeh_isolated_form => 0xfc50,
  :arabic_ligature_heh_with_jeem_isolated_form => 0xfc51,
  :arabic_ligature_heh_with_meem_isolated_form => 0xfc52,
  :arabic_ligature_heh_with_alef_maksura_isolated_form => 0xfc53,
  :arabic_ligature_heh_with_yeh_isolated_form => 0xfc54,
  :arabic_ligature_yeh_with_jeem_isolated_form => 0xfc55,
  :arabic_ligature_yeh_with_hah_isolated_form => 0xfc56,
  :arabic_ligature_yeh_with_khah_isolated_form => 0xfc57,
  :arabic_ligature_yeh_with_meem_isolated_form => 0xfc58,
  :arabic_ligature_yeh_with_alef_maksura_isolated_form => 0xfc59,
  :arabic_ligature_yeh_with_yeh_isolated_form => 0xfc5a,
  :arabic_ligature_thal_with_superscript_alef_isolated_form => 0xfc5b,
  :arabic_ligature_reh_with_superscript_alef_isolated_form => 0xfc5c,
  :arabic_ligature_alef_maksura_with_superscript_alef_isolated_form => 0xfc5d,
  :arabic_ligature_shadda_with_dammatan_isolated_form => 0xfc5e,
  :arabic_ligature_shadda_with_kasratan_isolated_form => 0xfc5f,
  :arabic_ligature_shadda_with_fatha_isolated_form => 0xfc60,
  :arabic_ligature_shadda_with_damma_isolated_form => 0xfc61,
  :arabic_ligature_shadda_with_kasra_isolated_form => 0xfc62,
  :arabic_ligature_shadda_with_superscript_alef_isolated_form => 0xfc63,
  :arabic_ligature_yeh_with_hamza_above_with_reh_final_form => 0xfc64,
  :arabic_ligature_yeh_with_hamza_above_with_zain_final_form => 0xfc65,
  :arabic_ligature_yeh_with_hamza_above_with_meem_final_form => 0xfc66,
  :arabic_ligature_yeh_with_hamza_above_with_noon_final_form => 0xfc67,
  :arabic_ligature_yeh_with_hamza_above_with_alef_maksura_final_form => 0xfc68,
  :arabic_ligature_yeh_with_hamza_above_with_yeh_final_form => 0xfc69,
  :arabic_ligature_beh_with_reh_final_form => 0xfc6a,
  :arabic_ligature_beh_with_zain_final_form => 0xfc6b,
  :arabic_ligature_beh_with_meem_final_form => 0xfc6c,
  :arabic_ligature_beh_with_noon_final_form => 0xfc6d,
  :arabic_ligature_beh_with_alef_maksura_final_form => 0xfc6e,
  :arabic_ligature_beh_with_yeh_final_form => 0xfc6f,
  :arabic_ligature_teh_with_reh_final_form => 0xfc70,
  :arabic_ligature_teh_with_zain_final_form => 0xfc71,
  :arabic_ligature_teh_with_meem_final_form => 0xfc72,
  :arabic_ligature_teh_with_noon_final_form => 0xfc73,
  :arabic_ligature_teh_with_alef_maksura_final_form => 0xfc74,
  :arabic_ligature_teh_with_yeh_final_form => 0xfc75,
  :arabic_ligature_theh_with_reh_final_form => 0xfc76,
  :arabic_ligature_theh_with_zain_final_form => 0xfc77,
  :arabic_ligature_theh_with_meem_final_form => 0xfc78,
  :arabic_ligature_theh_with_noon_final_form => 0xfc79,
  :arabic_ligature_theh_with_alef_maksura_final_form => 0xfc7a,
  :arabic_ligature_theh_with_yeh_final_form => 0xfc7b,
  :arabic_ligature_feh_with_alef_maksura_final_form => 0xfc7c,
  :arabic_ligature_feh_with_yeh_final_form => 0xfc7d,
  :arabic_ligature_qaf_with_alef_maksura_final_form => 0xfc7e,
  :arabic_ligature_qaf_with_yeh_final_form => 0xfc7f,
  :arabic_ligature_kaf_with_alef_final_form => 0xfc80,
  :arabic_ligature_kaf_with_lam_final_form => 0xfc81,
  :arabic_ligature_kaf_with_meem_final_form => 0xfc82,
  :arabic_ligature_kaf_with_alef_maksura_final_form => 0xfc83,
  :arabic_ligature_kaf_with_yeh_final_form => 0xfc84,
  :arabic_ligature_lam_with_meem_final_form => 0xfc85,
  :arabic_ligature_lam_with_alef_maksura_final_form => 0xfc86,
  :arabic_ligature_lam_with_yeh_final_form => 0xfc87,
  :arabic_ligature_meem_with_alef_final_form => 0xfc88,
  :arabic_ligature_meem_with_meem_final_form => 0xfc89,
  :arabic_ligature_noon_with_reh_final_form => 0xfc8a,
  :arabic_ligature_noon_with_zain_final_form => 0xfc8b,
  :arabic_ligature_noon_with_meem_final_form => 0xfc8c,
  :arabic_ligature_noon_with_noon_final_form => 0xfc8d,
  :arabic_ligature_noon_with_alef_maksura_final_form => 0xfc8e,
  :arabic_ligature_noon_with_yeh_final_form => 0xfc8f,
  :arabic_ligature_alef_maksura_with_superscript_alef_final_form => 0xfc90,
  :arabic_ligature_yeh_with_reh_final_form => 0xfc91,
  :arabic_ligature_yeh_with_zain_final_form => 0xfc92,
  :arabic_ligature_yeh_with_meem_final_form => 0xfc93,
  :arabic_ligature_yeh_with_noon_final_form => 0xfc94,
  :arabic_ligature_yeh_with_alef_maksura_final_form => 0xfc95,
  :arabic_ligature_yeh_with_yeh_final_form => 0xfc96,
  :arabic_ligature_yeh_with_hamza_above_with_jeem_initial_form => 0xfc97,
  :arabic_ligature_yeh_with_hamza_above_with_hah_initial_form => 0xfc98,
  :arabic_ligature_yeh_with_hamza_above_with_khah_initial_form => 0xfc99,
  :arabic_ligature_yeh_with_hamza_above_with_meem_initial_form => 0xfc9a,
  :arabic_ligature_yeh_with_hamza_above_with_heh_initial_form => 0xfc9b,
  :arabic_ligature_beh_with_jeem_initial_form => 0xfc9c,
  :arabic_ligature_beh_with_hah_initial_form => 0xfc9d,
  :arabic_ligature_beh_with_khah_initial_form => 0xfc9e,
  :arabic_ligature_beh_with_meem_initial_form => 0xfc9f,
  :arabic_ligature_beh_with_heh_initial_form => 0xfca0,
  :arabic_ligature_teh_with_jeem_initial_form => 0xfca1,
  :arabic_ligature_teh_with_hah_initial_form => 0xfca2,
  :arabic_ligature_teh_with_khah_initial_form => 0xfca3,
  :arabic_ligature_teh_with_meem_initial_form => 0xfca4,
  :arabic_ligature_teh_with_heh_initial_form => 0xfca5,
  :arabic_ligature_theh_with_meem_initial_form => 0xfca6,
  :arabic_ligature_jeem_with_hah_initial_form => 0xfca7,
  :arabic_ligature_jeem_with_meem_initial_form => 0xfca8,
  :arabic_ligature_hah_with_jeem_initial_form => 0xfca9,
  :arabic_ligature_hah_with_meem_initial_form => 0xfcaa,
  :arabic_ligature_khah_with_jeem_initial_form => 0xfcab,
  :arabic_ligature_khah_with_meem_initial_form => 0xfcac,
  :arabic_ligature_seen_with_jeem_initial_form => 0xfcad,
  :arabic_ligature_seen_with_hah_initial_form => 0xfcae,
  :arabic_ligature_seen_with_khah_initial_form => 0xfcaf,
  :arabic_ligature_seen_with_meem_initial_form => 0xfcb0,
  :arabic_ligature_sad_with_hah_initial_form => 0xfcb1,
  :arabic_ligature_sad_with_khah_initial_form => 0xfcb2,
  :arabic_ligature_sad_with_meem_initial_form => 0xfcb3,
  :arabic_ligature_dad_with_jeem_initial_form => 0xfcb4,
  :arabic_ligature_dad_with_hah_initial_form => 0xfcb5,
  :arabic_ligature_dad_with_khah_initial_form => 0xfcb6,
  :arabic_ligature_dad_with_meem_initial_form => 0xfcb7,
  :arabic_ligature_tah_with_hah_initial_form => 0xfcb8,
  :arabic_ligature_zah_with_meem_initial_form => 0xfcb9,
  :arabic_ligature_ain_with_jeem_initial_form => 0xfcba,
  :arabic_ligature_ain_with_meem_initial_form => 0xfcbb,
  :arabic_ligature_ghain_with_jeem_initial_form => 0xfcbc,
  :arabic_ligature_ghain_with_meem_initial_form => 0xfcbd,
  :arabic_ligature_feh_with_jeem_initial_form => 0xfcbe,
  :arabic_ligature_feh_with_hah_initial_form => 0xfcbf,
  :arabic_ligature_feh_with_khah_initial_form => 0xfcc0,
  :arabic_ligature_feh_with_meem_initial_form => 0xfcc1,
  :arabic_ligature_qaf_with_hah_initial_form => 0xfcc2,
  :arabic_ligature_qaf_with_meem_initial_form => 0xfcc3,
  :arabic_ligature_kaf_with_jeem_initial_form => 0xfcc4,
  :arabic_ligature_kaf_with_hah_initial_form => 0xfcc5,
  :arabic_ligature_kaf_with_khah_initial_form => 0xfcc6,
  :arabic_ligature_kaf_with_lam_initial_form => 0xfcc7,
  :arabic_ligature_kaf_with_meem_initial_form => 0xfcc8,
  :arabic_ligature_lam_with_jeem_initial_form => 0xfcc9,
  :arabic_ligature_lam_with_hah_initial_form => 0xfcca,
  :arabic_ligature_lam_with_khah_initial_form => 0xfccb,
  :arabic_ligature_lam_with_meem_initial_form => 0xfccc,
  :arabic_ligature_lam_with_heh_initial_form => 0xfccd,
  :arabic_ligature_meem_with_jeem_initial_form => 0xfcce,
  :arabic_ligature_meem_with_hah_initial_form => 0xfccf,
  :arabic_ligature_meem_with_khah_initial_form => 0xfcd0,
  :arabic_ligature_meem_with_meem_initial_form => 0xfcd1,
  :arabic_ligature_noon_with_jeem_initial_form => 0xfcd2,
  :arabic_ligature_noon_with_hah_initial_form => 0xfcd3,
  :arabic_ligature_noon_with_khah_initial_form => 0xfcd4,
  :arabic_ligature_noon_with_meem_initial_form => 0xfcd5,
  :arabic_ligature_noon_with_heh_initial_form => 0xfcd6,
  :arabic_ligature_heh_with_jeem_initial_form => 0xfcd7,
  :arabic_ligature_heh_with_meem_initial_form => 0xfcd8,
  :arabic_ligature_heh_with_superscript_alef_initial_form => 0xfcd9,
  :arabic_ligature_yeh_with_jeem_initial_form => 0xfcda,
  :arabic_ligature_yeh_with_hah_initial_form => 0xfcdb,
  :arabic_ligature_yeh_with_khah_initial_form => 0xfcdc,
  :arabic_ligature_yeh_with_meem_initial_form => 0xfcdd,
  :arabic_ligature_yeh_with_heh_initial_form => 0xfcde,
  :arabic_ligature_yeh_with_hamza_above_with_meem_medial_form => 0xfcdf,
  :arabic_ligature_yeh_with_hamza_above_with_heh_medial_form => 0xfce0,
  :arabic_ligature_beh_with_meem_medial_form => 0xfce1,
  :arabic_ligature_beh_with_heh_medial_form => 0xfce2,
  :arabic_ligature_teh_with_meem_medial_form => 0xfce3,
  :arabic_ligature_teh_with_heh_medial_form => 0xfce4,
  :arabic_ligature_theh_with_meem_medial_form => 0xfce5,
  :arabic_ligature_theh_with_heh_medial_form => 0xfce6,
  :arabic_ligature_seen_with_meem_medial_form => 0xfce7,
  :arabic_ligature_seen_with_heh_medial_form => 0xfce8,
  :arabic_ligature_sheen_with_meem_medial_form => 0xfce9,
  :arabic_ligature_sheen_with_heh_medial_form => 0xfcea,
  :arabic_ligature_kaf_with_lam_medial_form => 0xfceb,
  :arabic_ligature_kaf_with_meem_medial_form => 0xfcec,
  :arabic_ligature_lam_with_meem_medial_form => 0xfced,
  :arabic_ligature_noon_with_meem_medial_form => 0xfcee,
  :arabic_ligature_noon_with_heh_medial_form => 0xfcef,
  :arabic_ligature_yeh_with_meem_medial_form => 0xfcf0,
  :arabic_ligature_yeh_with_heh_medial_form => 0xfcf1,
  :arabic_ligature_shadda_with_fatha_medial_form => 0xfcf2,
  :arabic_ligature_shadda_with_damma_medial_form => 0xfcf3,
  :arabic_ligature_shadda_with_kasra_medial_form => 0xfcf4,
  :arabic_ligature_tah_with_alef_maksura_isolated_form => 0xfcf5,
  :arabic_ligature_tah_with_yeh_isolated_form => 0xfcf6,
  :arabic_ligature_ain_with_alef_maksura_isolated_form => 0xfcf7,
  :arabic_ligature_ain_with_yeh_isolated_form => 0xfcf8,
  :arabic_ligature_ghain_with_alef_maksura_isolated_form => 0xfcf9,
  :arabic_ligature_ghain_with_yeh_isolated_form => 0xfcfa,
  :arabic_ligature_seen_with_alef_maksura_isolated_form => 0xfcfb,
  :arabic_ligature_seen_with_yeh_isolated_form => 0xfcfc,
  :arabic_ligature_sheen_with_alef_maksura_isolated_form => 0xfcfd,
  :arabic_ligature_sheen_with_yeh_isolated_form => 0xfcfe,
  :arabic_ligature_hah_with_alef_maksura_isolated_form => 0xfcff,
  :arabic_ligature_hah_with_yeh_isolated_form => 0xfd00,
  :arabic_ligature_jeem_with_alef_maksura_isolated_form => 0xfd01,
  :arabic_ligature_jeem_with_yeh_isolated_form => 0xfd02,
  :arabic_ligature_khah_with_alef_maksura_isolated_form => 0xfd03,
  :arabic_ligature_khah_with_yeh_isolated_form => 0xfd04,
  :arabic_ligature_sad_with_alef_maksura_isolated_form => 0xfd05,
  :arabic_ligature_sad_with_yeh_isolated_form => 0xfd06,
  :arabic_ligature_dad_with_alef_maksura_isolated_form => 0xfd07,
  :arabic_ligature_dad_with_yeh_isolated_form => 0xfd08,
  :arabic_ligature_sheen_with_jeem_isolated_form => 0xfd09,
  :arabic_ligature_sheen_with_hah_isolated_form => 0xfd0a,
  :arabic_ligature_sheen_with_khah_isolated_form => 0xfd0b,
  :arabic_ligature_sheen_with_meem_isolated_form => 0xfd0c,
  :arabic_ligature_sheen_with_reh_isolated_form => 0xfd0d,
  :arabic_ligature_seen_with_reh_isolated_form => 0xfd0e,
  :arabic_ligature_sad_with_reh_isolated_form => 0xfd0f,
  :arabic_ligature_dad_with_reh_isolated_form => 0xfd10,
  :arabic_ligature_tah_with_alef_maksura_final_form => 0xfd11,
  :arabic_ligature_tah_with_yeh_final_form => 0xfd12,
  :arabic_ligature_ain_with_alef_maksura_final_form => 0xfd13,
  :arabic_ligature_ain_with_yeh_final_form => 0xfd14,
  :arabic_ligature_ghain_with_alef_maksura_final_form => 0xfd15,
  :arabic_ligature_ghain_with_yeh_final_form => 0xfd16,
  :arabic_ligature_seen_with_alef_maksura_final_form => 0xfd17,
  :arabic_ligature_seen_with_yeh_final_form => 0xfd18,
  :arabic_ligature_sheen_with_alef_maksura_final_form => 0xfd19,
  :arabic_ligature_sheen_with_yeh_final_form => 0xfd1a,
  :arabic_ligature_hah_with_alef_maksura_final_form => 0xfd1b,
  :arabic_ligature_hah_with_yeh_final_form => 0xfd1c,
  :arabic_ligature_jeem_with_alef_maksura_final_form => 0xfd1d,
  :arabic_ligature_jeem_with_yeh_final_form => 0xfd1e,
  :arabic_ligature_khah_with_alef_maksura_final_form => 0xfd1f,
  :arabic_ligature_khah_with_yeh_final_form => 0xfd20,
  :arabic_ligature_sad_with_alef_maksura_final_form => 0xfd21,
  :arabic_ligature_sad_with_yeh_final_form => 0xfd22,
  :arabic_ligature_dad_with_alef_maksura_final_form => 0xfd23,
  :arabic_ligature_dad_with_yeh_final_form => 0xfd24,
  :arabic_ligature_sheen_with_jeem_final_form => 0xfd25,
  :arabic_ligature_sheen_with_hah_final_form => 0xfd26,
  :arabic_ligature_sheen_with_khah_final_form => 0xfd27,
  :arabic_ligature_sheen_with_meem_final_form => 0xfd28,
  :arabic_ligature_sheen_with_reh_final_form => 0xfd29,
  :arabic_ligature_seen_with_reh_final_form => 0xfd2a,
  :arabic_ligature_sad_with_reh_final_form => 0xfd2b,
  :arabic_ligature_dad_with_reh_final_form => 0xfd2c,
  :arabic_ligature_sheen_with_jeem_initial_form => 0xfd2d,
  :arabic_ligature_sheen_with_hah_initial_form => 0xfd2e,
  :arabic_ligature_sheen_with_khah_initial_form => 0xfd2f,
  :arabic_ligature_sheen_with_meem_initial_form => 0xfd30,
  :arabic_ligature_seen_with_heh_initial_form => 0xfd31,
  :arabic_ligature_sheen_with_heh_initial_form => 0xfd32,
  :arabic_ligature_tah_with_meem_initial_form => 0xfd33,
  :arabic_ligature_seen_with_jeem_medial_form => 0xfd34,
  :arabic_ligature_seen_with_hah_medial_form => 0xfd35,
  :arabic_ligature_seen_with_khah_medial_form => 0xfd36,
  :arabic_ligature_sheen_with_jeem_medial_form => 0xfd37,
  :arabic_ligature_sheen_with_hah_medial_form => 0xfd38,
  :arabic_ligature_sheen_with_khah_medial_form => 0xfd39,
  :arabic_ligature_tah_with_meem_medial_form => 0xfd3a,
  :arabic_ligature_zah_with_meem_medial_form => 0xfd3b,
  :arabic_ligature_alef_with_fathatan_final_form => 0xfd3c,
  :arabic_ligature_alef_with_fathatan_isolated_form => 0xfd3d,
  :ornate_left_parenthesis => 0xfd3e,
  :ornate_right_parenthesis => 0xfd3f,
  :arabic_ligature_teh_with_jeem_with_meem_initial_form => 0xfd50,
  :arabic_ligature_teh_with_hah_with_jeem_final_form => 0xfd51,
  :arabic_ligature_teh_with_hah_with_jeem_initial_form => 0xfd52,
  :arabic_ligature_teh_with_hah_with_meem_initial_form => 0xfd53,
  :arabic_ligature_teh_with_khah_with_meem_initial_form => 0xfd54,
  :arabic_ligature_teh_with_meem_with_jeem_initial_form => 0xfd55,
  :arabic_ligature_teh_with_meem_with_hah_initial_form => 0xfd56,
  :arabic_ligature_teh_with_meem_with_khah_initial_form => 0xfd57,
  :arabic_ligature_jeem_with_meem_with_hah_final_form => 0xfd58,
  :arabic_ligature_jeem_with_meem_with_hah_initial_form => 0xfd59,
  :arabic_ligature_hah_with_meem_with_yeh_final_form => 0xfd5a,
  :arabic_ligature_hah_with_meem_with_alef_maksura_final_form => 0xfd5b,
  :arabic_ligature_seen_with_hah_with_jeem_initial_form => 0xfd5c,
  :arabic_ligature_seen_with_jeem_with_hah_initial_form => 0xfd5d,
  :arabic_ligature_seen_with_jeem_with_alef_maksura_final_form => 0xfd5e,
  :arabic_ligature_seen_with_meem_with_hah_final_form => 0xfd5f,
  :arabic_ligature_seen_with_meem_with_hah_initial_form => 0xfd60,
  :arabic_ligature_seen_with_meem_with_jeem_initial_form => 0xfd61,
  :arabic_ligature_seen_with_meem_with_meem_final_form => 0xfd62,
  :arabic_ligature_seen_with_meem_with_meem_initial_form => 0xfd63,
  :arabic_ligature_sad_with_hah_with_hah_final_form => 0xfd64,
  :arabic_ligature_sad_with_hah_with_hah_initial_form => 0xfd65,
  :arabic_ligature_sad_with_meem_with_meem_final_form => 0xfd66,
  :arabic_ligature_sheen_with_hah_with_meem_final_form => 0xfd67,
  :arabic_ligature_sheen_with_hah_with_meem_initial_form => 0xfd68,
  :arabic_ligature_sheen_with_jeem_with_yeh_final_form => 0xfd69,
  :arabic_ligature_sheen_with_meem_with_khah_final_form => 0xfd6a,
  :arabic_ligature_sheen_with_meem_with_khah_initial_form => 0xfd6b,
  :arabic_ligature_sheen_with_meem_with_meem_final_form => 0xfd6c,
  :arabic_ligature_sheen_with_meem_with_meem_initial_form => 0xfd6d,
  :arabic_ligature_dad_with_hah_with_alef_maksura_final_form => 0xfd6e,
  :arabic_ligature_dad_with_khah_with_meem_final_form => 0xfd6f,
  :arabic_ligature_dad_with_khah_with_meem_initial_form => 0xfd70,
  :arabic_ligature_tah_with_meem_with_hah_final_form => 0xfd71,
  :arabic_ligature_tah_with_meem_with_hah_initial_form => 0xfd72,
  :arabic_ligature_tah_with_meem_with_meem_initial_form => 0xfd73,
  :arabic_ligature_tah_with_meem_with_yeh_final_form => 0xfd74,
  :arabic_ligature_ain_with_jeem_with_meem_final_form => 0xfd75,
  :arabic_ligature_ain_with_meem_with_meem_final_form => 0xfd76,
  :arabic_ligature_ain_with_meem_with_meem_initial_form => 0xfd77,
  :arabic_ligature_ain_with_meem_with_alef_maksura_final_form => 0xfd78,
  :arabic_ligature_ghain_with_meem_with_meem_final_form => 0xfd79,
  :arabic_ligature_ghain_with_meem_with_yeh_final_form => 0xfd7a,
  :arabic_ligature_ghain_with_meem_with_alef_maksura_final_form => 0xfd7b,
  :arabic_ligature_feh_with_khah_with_meem_final_form => 0xfd7c,
  :arabic_ligature_feh_with_khah_with_meem_initial_form => 0xfd7d,
  :arabic_ligature_qaf_with_meem_with_hah_final_form => 0xfd7e,
  :arabic_ligature_qaf_with_meem_with_meem_final_form => 0xfd7f,
  :arabic_ligature_lam_with_hah_with_meem_final_form => 0xfd80,
  :arabic_ligature_lam_with_hah_with_yeh_final_form => 0xfd81,
  :arabic_ligature_lam_with_hah_with_alef_maksura_final_form => 0xfd82,
  :arabic_ligature_lam_with_jeem_with_jeem_initial_form => 0xfd83,
  :arabic_ligature_lam_with_jeem_with_jeem_final_form => 0xfd84,
  :arabic_ligature_lam_with_khah_with_meem_final_form => 0xfd85,
  :arabic_ligature_lam_with_khah_with_meem_initial_form => 0xfd86,
  :arabic_ligature_lam_with_meem_with_hah_final_form => 0xfd87,
  :arabic_ligature_lam_with_meem_with_hah_initial_form => 0xfd88,
  :arabic_ligature_meem_with_hah_with_jeem_initial_form => 0xfd89,
  :arabic_ligature_meem_with_hah_with_meem_initial_form => 0xfd8a,
  :arabic_ligature_meem_with_hah_with_yeh_final_form => 0xfd8b,
  :arabic_ligature_meem_with_jeem_with_hah_initial_form => 0xfd8c,
  :arabic_ligature_meem_with_jeem_with_meem_initial_form => 0xfd8d,
  :arabic_ligature_meem_with_khah_with_jeem_initial_form => 0xfd8e,
  :arabic_ligature_meem_with_khah_with_meem_initial_form => 0xfd8f,
  :arabic_ligature_meem_with_jeem_with_khah_initial_form => 0xfd92,
  :arabic_ligature_heh_with_meem_with_jeem_initial_form => 0xfd93,
  :arabic_ligature_heh_with_meem_with_meem_initial_form => 0xfd94,
  :arabic_ligature_noon_with_hah_with_meem_initial_form => 0xfd95,
  :arabic_ligature_noon_with_hah_with_alef_maksura_final_form => 0xfd96,
  :arabic_ligature_noon_with_jeem_with_meem_final_form => 0xfd97,
  :arabic_ligature_noon_with_jeem_with_meem_initial_form => 0xfd98,
  :arabic_ligature_noon_with_jeem_with_alef_maksura_final_form => 0xfd99,
  :arabic_ligature_noon_with_meem_with_yeh_final_form => 0xfd9a,
  :arabic_ligature_noon_with_meem_with_alef_maksura_final_form => 0xfd9b,
  :arabic_ligature_yeh_with_meem_with_meem_final_form => 0xfd9c,
  :arabic_ligature_yeh_with_meem_with_meem_initial_form => 0xfd9d,
  :arabic_ligature_beh_with_khah_with_yeh_final_form => 0xfd9e,
  :arabic_ligature_teh_with_jeem_with_yeh_final_form => 0xfd9f,
  :arabic_ligature_teh_with_jeem_with_alef_maksura_final_form => 0xfda0,
  :arabic_ligature_teh_with_khah_with_yeh_final_form => 0xfda1,
  :arabic_ligature_teh_with_khah_with_alef_maksura_final_form => 0xfda2,
  :arabic_ligature_teh_with_meem_with_yeh_final_form => 0xfda3,
  :arabic_ligature_teh_with_meem_with_alef_maksura_final_form => 0xfda4,
  :arabic_ligature_jeem_with_meem_with_yeh_final_form => 0xfda5,
  :arabic_ligature_jeem_with_hah_with_alef_maksura_final_form => 0xfda6,
  :arabic_ligature_jeem_with_meem_with_alef_maksura_final_form => 0xfda7,
  :arabic_ligature_seen_with_khah_with_alef_maksura_final_form => 0xfda8,
  :arabic_ligature_sad_with_hah_with_yeh_final_form => 0xfda9,
  :arabic_ligature_sheen_with_hah_with_yeh_final_form => 0xfdaa,
  :arabic_ligature_dad_with_hah_with_yeh_final_form => 0xfdab,
  :arabic_ligature_lam_with_jeem_with_yeh_final_form => 0xfdac,
  :arabic_ligature_lam_with_meem_with_yeh_final_form => 0xfdad,
  :arabic_ligature_yeh_with_hah_with_yeh_final_form => 0xfdae,
  :arabic_ligature_yeh_with_jeem_with_yeh_final_form => 0xfdaf,
  :arabic_ligature_yeh_with_meem_with_yeh_final_form => 0xfdb0,
  :arabic_ligature_meem_with_meem_with_yeh_final_form => 0xfdb1,
  :arabic_ligature_qaf_with_meem_with_yeh_final_form => 0xfdb2,
  :arabic_ligature_noon_with_hah_with_yeh_final_form => 0xfdb3,
  :arabic_ligature_qaf_with_meem_with_hah_initial_form => 0xfdb4,
  :arabic_ligature_lam_with_hah_with_meem_initial_form => 0xfdb5,
  :arabic_ligature_ain_with_meem_with_yeh_final_form => 0xfdb6,
  :arabic_ligature_kaf_with_meem_with_yeh_final_form => 0xfdb7,
  :arabic_ligature_noon_with_jeem_with_hah_initial_form => 0xfdb8,
  :arabic_ligature_meem_with_khah_with_yeh_final_form => 0xfdb9,
  :arabic_ligature_lam_with_jeem_with_meem_initial_form => 0xfdba,
  :arabic_ligature_kaf_with_meem_with_meem_final_form => 0xfdbb,
  :arabic_ligature_lam_with_jeem_with_meem_final_form => 0xfdbc,
  :arabic_ligature_noon_with_jeem_with_hah_final_form => 0xfdbd,
  :arabic_ligature_jeem_with_hah_with_yeh_final_form => 0xfdbe,
  :arabic_ligature_hah_with_jeem_with_yeh_final_form => 0xfdbf,
  :arabic_ligature_meem_with_jeem_with_yeh_final_form => 0xfdc0,
  :arabic_ligature_feh_with_meem_with_yeh_final_form => 0xfdc1,
  :arabic_ligature_beh_with_hah_with_yeh_final_form => 0xfdc2,
  :arabic_ligature_kaf_with_meem_with_meem_initial_form => 0xfdc3,
  :arabic_ligature_ain_with_jeem_with_meem_initial_form => 0xfdc4,
  :arabic_ligature_sad_with_meem_with_meem_initial_form => 0xfdc5,
  :arabic_ligature_seen_with_khah_with_yeh_final_form => 0xfdc6,
  :arabic_ligature_noon_with_jeem_with_yeh_final_form => 0xfdc7,
  :arabic_ligature_salla_used_as_koranic_stop_sign_isolated_form => 0xfdf0,
  :arabic_ligature_qala_used_as_koranic_stop_sign_isolated_form => 0xfdf1,
  :arabic_ligature_allah_isolated_form => 0xfdf2,
  :arabic_ligature_akbar_isolated_form => 0xfdf3,
  :arabic_ligature_mohammad_isolated_form => 0xfdf4,
  :arabic_ligature_salam_isolated_form => 0xfdf5,
  :arabic_ligature_rasoul_isolated_form => 0xfdf6,
  :arabic_ligature_alayhe_isolated_form => 0xfdf7,
  :arabic_ligature_wasallam_isolated_form => 0xfdf8,
  :arabic_ligature_salla_isolated_form => 0xfdf9,
  :arabic_ligature_sallallahou_alayhe_wasallam => 0xfdfa,
  :arabic_letter_sallallahou_alayhe_wasallam => 0xfdfa,
  :arabic_ligature_jallajalalouhou => 0xfdfb,
  :arabic_letter_jallajalalouhou => 0xfdfb,
  :rial_sign => 0xfdfc,
  :arabic_ligature_bismillah_ar_rahman_ar_raheem => 0xfdfd,
  :variation_selector_1 => 0xfe00,
  :variation_selector_2 => 0xfe01,
  :variation_selector_3 => 0xfe02,
  :variation_selector_4 => 0xfe03,
  :variation_selector_5 => 0xfe04,
  :variation_selector_6 => 0xfe05,
  :variation_selector_7 => 0xfe06,
  :variation_selector_8 => 0xfe07,
  :variation_selector_9 => 0xfe08,
  :variation_selector_10 => 0xfe09,
  :variation_selector_11 => 0xfe0a,
  :variation_selector_12 => 0xfe0b,
  :variation_selector_13 => 0xfe0c,
  :variation_selector_14 => 0xfe0d,
  :variation_selector_15 => 0xfe0e,
  :variation_selector_16 => 0xfe0f,
  :presentation_form_for_vertical_comma => 0xfe10,
  :presentation_form_for_vertical_ideographic_comma => 0xfe11,
  :presentation_form_for_vertical_ideographic_full_stop => 0xfe12,
  :presentation_form_for_vertical_colon => 0xfe13,
  :presentation_form_for_vertical_semicolon => 0xfe14,
  :presentation_form_for_vertical_exclamation_mark => 0xfe15,
  :presentation_form_for_vertical_question_mark => 0xfe16,
  :presentation_form_for_vertical_left_white_lenticular_bracket => 0xfe17,
  :presentation_form_for_vertical_right_white_lenticular_brakcet => 0xfe18,
  :presentation_form_for_vertical_horizontal_ellipsis => 0xfe19,
  :combining_ligature_left_half => 0xfe20,
  :combining_ligature_right_half => 0xfe21,
  :combining_double_tilde_left_half => 0xfe22,
  :combining_double_tilde_right_half => 0xfe23,
  :presentation_form_for_vertical_two_dot_leader => 0xfe30,
  :glyph_for_vertical_two_dot_leader => 0xfe30,
  :presentation_form_for_vertical_em_dash => 0xfe31,
  :glyph_for_vertical_em_dash => 0xfe31,
  :presentation_form_for_vertical_en_dash => 0xfe32,
  :glyph_for_vertical_en_dash => 0xfe32,
  :presentation_form_for_vertical_low_line => 0xfe33,
  :glyph_for_vertical_spacing_underscore => 0xfe33,
  :presentation_form_for_vertical_wavy_low_line => 0xfe34,
  :glyph_for_vertical_spacing_wavy_underscore => 0xfe34,
  :presentation_form_for_vertical_left_parenthesis => 0xfe35,
  :glyph_for_vertical_opening_parenthesis => 0xfe35,
  :presentation_form_for_vertical_right_parenthesis => 0xfe36,
  :glyph_for_vertical_closing_parenthesis => 0xfe36,
  :presentation_form_for_vertical_left_curly_bracket => 0xfe37,
  :glyph_for_vertical_opening_curly_bracket => 0xfe37,
  :presentation_form_for_vertical_right_curly_bracket => 0xfe38,
  :glyph_for_vertical_closing_curly_bracket => 0xfe38,
  :presentation_form_for_vertical_left_tortoise_shell_bracket => 0xfe39,
  :glyph_for_vertical_opening_tortoise_shell_bracket => 0xfe39,
  :presentation_form_for_vertical_right_tortoise_shell_bracket => 0xfe3a,
  :glyph_for_vertical_closing_tortoise_shell_bracket => 0xfe3a,
  :presentation_form_for_vertical_left_black_lenticular_bracket => 0xfe3b,
  :glyph_for_vertical_opening_black_lenticular_bracket => 0xfe3b,
  :presentation_form_for_vertical_right_black_lenticular_bracket => 0xfe3c,
  :glyph_for_vertical_closing_black_lenticular_bracket => 0xfe3c,
  :presentation_form_for_vertical_left_double_angle_bracket => 0xfe3d,
  :glyph_for_vertical_opening_double_angle_bracket => 0xfe3d,
  :presentation_form_for_vertical_right_double_angle_bracket => 0xfe3e,
  :glyph_for_vertical_closing_double_angle_bracket => 0xfe3e,
  :presentation_form_for_vertical_left_angle_bracket => 0xfe3f,
  :glyph_for_vertical_opening_angle_bracket => 0xfe3f,
  :presentation_form_for_vertical_right_angle_bracket => 0xfe40,
  :glyph_for_vertical_closing_angle_bracket => 0xfe40,
  :presentation_form_for_vertical_left_corner_bracket => 0xfe41,
  :glyph_for_vertical_opening_corner_bracket => 0xfe41,
  :presentation_form_for_vertical_right_corner_bracket => 0xfe42,
  :glyph_for_vertical_closing_corner_bracket => 0xfe42,
  :presentation_form_for_vertical_left_white_corner_bracket => 0xfe43,
  :glyph_for_vertical_opening_white_corner_bracket => 0xfe43,
  :presentation_form_for_vertical_right_white_corner_bracket => 0xfe44,
  :glyph_for_vertical_closing_white_corner_bracket => 0xfe44,
  :sesame_dot => 0xfe45,
  :white_sesame_dot => 0xfe46,
  :presentation_form_for_vertical_left_square_bracket => 0xfe47,
  :presentation_form_for_vertical_right_square_bracket => 0xfe48,
  :dashed_overline => 0xfe49,
  :spacing_dashed_overscore => 0xfe49,
  :centreline_overline => 0xfe4a,
  :spacing_centerline_overscore => 0xfe4a,
  :wavy_overline => 0xfe4b,
  :spacing_wavy_overscore => 0xfe4b,
  :double_wavy_overline => 0xfe4c,
  :spacing_double_wavy_overscore => 0xfe4c,
  :dashed_low_line => 0xfe4d,
  :spacing_dashed_underscore => 0xfe4d,
  :centreline_low_line => 0xfe4e,
  :spacing_centerline_underscore => 0xfe4e,
  :wavy_low_line => 0xfe4f,
  :spacing_wavy_underscore => 0xfe4f,
  :small_comma => 0xfe50,
  :small_ideographic_comma => 0xfe51,
  :small_full_stop => 0xfe52,
  :small_period => 0xfe52,
  :small_semicolon => 0xfe54,
  :small_colon => 0xfe55,
  :small_question_mark => 0xfe56,
  :small_exclamation_mark => 0xfe57,
  :small_em_dash => 0xfe58,
  :small_left_parenthesis => 0xfe59,
  :small_opening_parenthesis => 0xfe59,
  :small_right_parenthesis => 0xfe5a,
  :small_closing_parenthesis => 0xfe5a,
  :small_left_curly_bracket => 0xfe5b,
  :small_opening_curly_bracket => 0xfe5b,
  :small_right_curly_bracket => 0xfe5c,
  :small_closing_curly_bracket => 0xfe5c,
  :small_left_tortoise_shell_bracket => 0xfe5d,
  :small_opening_tortoise_shell_bracket => 0xfe5d,
  :small_right_tortoise_shell_bracket => 0xfe5e,
  :small_closing_tortoise_shell_bracket => 0xfe5e,
  :small_number_sign => 0xfe5f,
  :small_ampersand => 0xfe60,
  :small_asterisk => 0xfe61,
  :small_plus_sign => 0xfe62,
  :small_hyphen_minus => 0xfe63,
  :small_less_than_sign => 0xfe64,
  :small_greater_than_sign => 0xfe65,
  :small_equals_sign => 0xfe66,
  :small_reverse_solidus => 0xfe68,
  :small_backslash => 0xfe68,
  :small_dollar_sign => 0xfe69,
  :small_percent_sign => 0xfe6a,
  :small_commercial_at => 0xfe6b,
  :arabic_fathatan_isolated_form => 0xfe70,
  :arabic_spacing_fathatan => 0xfe70,
  :arabic_tatweel_with_fathatan_above => 0xfe71,
  :arabic_fathatan_on_tatweel => 0xfe71,
  :arabic_dammatan_isolated_form => 0xfe72,
  :arabic_spacing_dammatan => 0xfe72,
  :arabic_tail_fragment => 0xfe73,
  :arabic_kasratan_isolated_form => 0xfe74,
  :arabic_spacing_kasratan => 0xfe74,
  :arabic_fatha_isolated_form => 0xfe76,
  :arabic_spacing_fathah => 0xfe76,
  :arabic_fatha_medial_form => 0xfe77,
  :arabic_fathah_on_tatweel => 0xfe77,
  :arabic_damma_isolated_form => 0xfe78,
  :arabic_spacing_dammah => 0xfe78,
  :arabic_damma_medial_form => 0xfe79,
  :arabic_dammah_on_tatweel => 0xfe79,
  :arabic_kasra_isolated_form => 0xfe7a,
  :arabic_spacing_kasrah => 0xfe7a,
  :arabic_kasra_medial_form => 0xfe7b,
  :arabic_kasrah_on_tatweel => 0xfe7b,
  :arabic_shadda_isolated_form => 0xfe7c,
  :arabic_spacing_shaddah => 0xfe7c,
  :arabic_shadda_medial_form => 0xfe7d,
  :arabic_shaddah_on_tatweel => 0xfe7d,
  :arabic_sukun_isolated_form => 0xfe7e,
  :arabic_spacing_sukun => 0xfe7e,
  :arabic_sukun_medial_form => 0xfe7f,
  :arabic_sukun_on_tatweel => 0xfe7f,
  :arabic_letter_hamza_isolated_form => 0xfe80,
  :glyph_for_isolate_arabic_hamzah => 0xfe80,
  :arabic_letter_alef_with_madda_above_isolated_form => 0xfe81,
  :glyph_for_isolate_arabic_maddah_on_alef => 0xfe81,
  :arabic_letter_alef_with_madda_above_final_form => 0xfe82,
  :glyph_for_final_arabic_maddah_on_alef => 0xfe82,
  :arabic_letter_alef_with_hamza_above_isolated_form => 0xfe83,
  :glyph_for_isolate_arabic_hamzah_on_alef => 0xfe83,
  :arabic_letter_alef_with_hamza_above_final_form => 0xfe84,
  :glyph_for_final_arabic_hamzah_on_alef => 0xfe84,
  :arabic_letter_waw_with_hamza_above_isolated_form => 0xfe85,
  :glyph_for_isolate_arabic_hamzah_on_waw => 0xfe85,
  :arabic_letter_waw_with_hamza_above_final_form => 0xfe86,
  :glyph_for_final_arabic_hamzah_on_waw => 0xfe86,
  :arabic_letter_alef_with_hamza_below_isolated_form => 0xfe87,
  :glyph_for_isolate_arabic_hamzah_under_alef => 0xfe87,
  :arabic_letter_alef_with_hamza_below_final_form => 0xfe88,
  :glyph_for_final_arabic_hamzah_under_alef => 0xfe88,
  :arabic_letter_yeh_with_hamza_above_isolated_form => 0xfe89,
  :glyph_for_isolate_arabic_hamzah_on_ya => 0xfe89,
  :arabic_letter_yeh_with_hamza_above_final_form => 0xfe8a,
  :glyph_for_final_arabic_hamzah_on_ya => 0xfe8a,
  :arabic_letter_yeh_with_hamza_above_initial_form => 0xfe8b,
  :glyph_for_initial_arabic_hamzah_on_ya => 0xfe8b,
  :arabic_letter_yeh_with_hamza_above_medial_form => 0xfe8c,
  :glyph_for_medial_arabic_hamzah_on_ya => 0xfe8c,
  :arabic_letter_alef_isolated_form => 0xfe8d,
  :glyph_for_isolate_arabic_alef => 0xfe8d,
  :arabic_letter_alef_final_form => 0xfe8e,
  :glyph_for_final_arabic_alef => 0xfe8e,
  :arabic_letter_beh_isolated_form => 0xfe8f,
  :glyph_for_isolate_arabic_baa => 0xfe8f,
  :arabic_letter_beh_final_form => 0xfe90,
  :glyph_for_final_arabic_baa => 0xfe90,
  :arabic_letter_beh_initial_form => 0xfe91,
  :glyph_for_initial_arabic_baa => 0xfe91,
  :arabic_letter_beh_medial_form => 0xfe92,
  :glyph_for_medial_arabic_baa => 0xfe92,
  :arabic_letter_teh_marbuta_isolated_form => 0xfe93,
  :glyph_for_isolate_arabic_taa_marbutah => 0xfe93,
  :arabic_letter_teh_marbuta_final_form => 0xfe94,
  :glyph_for_final_arabic_taa_marbutah => 0xfe94,
  :arabic_letter_teh_isolated_form => 0xfe95,
  :glyph_for_isolate_arabic_taa => 0xfe95,
  :arabic_letter_teh_final_form => 0xfe96,
  :glyph_for_final_arabic_taa => 0xfe96,
  :arabic_letter_teh_initial_form => 0xfe97,
  :glyph_for_initial_arabic_taa => 0xfe97,
  :arabic_letter_teh_medial_form => 0xfe98,
  :glyph_for_medial_arabic_taa => 0xfe98,
  :arabic_letter_theh_isolated_form => 0xfe99,
  :glyph_for_isolate_arabic_thaa => 0xfe99,
  :arabic_letter_theh_final_form => 0xfe9a,
  :glyph_for_final_arabic_thaa => 0xfe9a,
  :arabic_letter_theh_initial_form => 0xfe9b,
  :glyph_for_initial_arabic_thaa => 0xfe9b,
  :arabic_letter_theh_medial_form => 0xfe9c,
  :glyph_for_medial_arabic_thaa => 0xfe9c,
  :arabic_letter_jeem_isolated_form => 0xfe9d,
  :glyph_for_isolate_arabic_jeem => 0xfe9d,
  :arabic_letter_jeem_final_form => 0xfe9e,
  :glyph_for_final_arabic_jeem => 0xfe9e,
  :arabic_letter_jeem_initial_form => 0xfe9f,
  :glyph_for_initial_arabic_jeem => 0xfe9f,
  :arabic_letter_jeem_medial_form => 0xfea0,
  :glyph_for_medial_arabic_jeem => 0xfea0,
  :arabic_letter_hah_isolated_form => 0xfea1,
  :glyph_for_isolate_arabic_haa => 0xfea1,
  :arabic_letter_hah_final_form => 0xfea2,
  :glyph_for_final_arabic_haa => 0xfea2,
  :arabic_letter_hah_initial_form => 0xfea3,
  :glyph_for_initial_arabic_haa => 0xfea3,
  :arabic_letter_hah_medial_form => 0xfea4,
  :glyph_for_medial_arabic_haa => 0xfea4,
  :arabic_letter_khah_isolated_form => 0xfea5,
  :glyph_for_isolate_arabic_khaa => 0xfea5,
  :arabic_letter_khah_final_form => 0xfea6,
  :glyph_for_final_arabic_khaa => 0xfea6,
  :arabic_letter_khah_initial_form => 0xfea7,
  :glyph_for_initial_arabic_khaa => 0xfea7,
  :arabic_letter_khah_medial_form => 0xfea8,
  :glyph_for_medial_arabic_khaa => 0xfea8,
  :arabic_letter_dal_isolated_form => 0xfea9,
  :glyph_for_isolate_arabic_dal => 0xfea9,
  :arabic_letter_dal_final_form => 0xfeaa,
  :glyph_for_final_arabic_dal => 0xfeaa,
  :arabic_letter_thal_isolated_form => 0xfeab,
  :glyph_for_isolate_arabic_thal => 0xfeab,
  :arabic_letter_thal_final_form => 0xfeac,
  :glyph_for_final_arabic_thal => 0xfeac,
  :arabic_letter_reh_isolated_form => 0xfead,
  :glyph_for_isolate_arabic_ra => 0xfead,
  :arabic_letter_reh_final_form => 0xfeae,
  :glyph_for_final_arabic_ra => 0xfeae,
  :arabic_letter_zain_isolated_form => 0xfeaf,
  :glyph_for_isolate_arabic_zain => 0xfeaf,
  :arabic_letter_zain_final_form => 0xfeb0,
  :glyph_for_final_arabic_zain => 0xfeb0,
  :arabic_letter_seen_isolated_form => 0xfeb1,
  :glyph_for_isolate_arabic_seen => 0xfeb1,
  :arabic_letter_seen_final_form => 0xfeb2,
  :glyph_for_final_arabic_seen => 0xfeb2,
  :arabic_letter_seen_initial_form => 0xfeb3,
  :glyph_for_initial_arabic_seen => 0xfeb3,
  :arabic_letter_seen_medial_form => 0xfeb4,
  :glyph_for_medial_arabic_seen => 0xfeb4,
  :arabic_letter_sheen_isolated_form => 0xfeb5,
  :glyph_for_isolate_arabic_sheen => 0xfeb5,
  :arabic_letter_sheen_final_form => 0xfeb6,
  :glyph_for_final_arabic_sheen => 0xfeb6,
  :arabic_letter_sheen_initial_form => 0xfeb7,
  :glyph_for_initial_arabic_sheen => 0xfeb7,
  :arabic_letter_sheen_medial_form => 0xfeb8,
  :glyph_for_medial_arabic_sheen => 0xfeb8,
  :arabic_letter_sad_isolated_form => 0xfeb9,
  :glyph_for_isolate_arabic_sad => 0xfeb9,
  :arabic_letter_sad_final_form => 0xfeba,
  :glyph_for_final_arabic_sad => 0xfeba,
  :arabic_letter_sad_initial_form => 0xfebb,
  :glyph_for_initial_arabic_sad => 0xfebb,
  :arabic_letter_sad_medial_form => 0xfebc,
  :glyph_for_medial_arabic_sad => 0xfebc,
  :arabic_letter_dad_isolated_form => 0xfebd,
  :glyph_for_isolate_arabic_dad => 0xfebd,
  :arabic_letter_dad_final_form => 0xfebe,
  :glyph_for_final_arabic_dad => 0xfebe,
  :arabic_letter_dad_initial_form => 0xfebf,
  :glyph_for_initial_arabic_dad => 0xfebf,
  :arabic_letter_dad_medial_form => 0xfec0,
  :glyph_for_medial_arabic_dad => 0xfec0,
  :arabic_letter_tah_isolated_form => 0xfec1,
  :glyph_for_isolate_arabic_tah => 0xfec1,
  :arabic_letter_tah_final_form => 0xfec2,
  :glyph_for_final_arabic_tah => 0xfec2,
  :arabic_letter_tah_initial_form => 0xfec3,
  :glyph_for_initial_arabic_tah => 0xfec3,
  :arabic_letter_tah_medial_form => 0xfec4,
  :glyph_for_medial_arabic_tah => 0xfec4,
  :arabic_letter_zah_isolated_form => 0xfec5,
  :glyph_for_isolate_arabic_dhah => 0xfec5,
  :arabic_letter_zah_final_form => 0xfec6,
  :glyph_for_final_arabic_dhah => 0xfec6,
  :arabic_letter_zah_initial_form => 0xfec7,
  :glyph_for_initial_arabic_dhah => 0xfec7,
  :arabic_letter_zah_medial_form => 0xfec8,
  :glyph_for_medial_arabic_dhah => 0xfec8,
  :arabic_letter_ain_isolated_form => 0xfec9,
  :glyph_for_isolate_arabic_ain => 0xfec9,
  :arabic_letter_ain_final_form => 0xfeca,
  :glyph_for_final_arabic_ain => 0xfeca,
  :arabic_letter_ain_initial_form => 0xfecb,
  :glyph_for_initial_arabic_ain => 0xfecb,
  :arabic_letter_ain_medial_form => 0xfecc,
  :glyph_for_medial_arabic_ain => 0xfecc,
  :arabic_letter_ghain_isolated_form => 0xfecd,
  :glyph_for_isolate_arabic_ghain => 0xfecd,
  :arabic_letter_ghain_final_form => 0xfece,
  :glyph_for_final_arabic_ghain => 0xfece,
  :arabic_letter_ghain_initial_form => 0xfecf,
  :glyph_for_initial_arabic_ghain => 0xfecf,
  :arabic_letter_ghain_medial_form => 0xfed0,
  :glyph_for_medial_arabic_ghain => 0xfed0,
  :arabic_letter_feh_isolated_form => 0xfed1,
  :glyph_for_isolate_arabic_fa => 0xfed1,
  :arabic_letter_feh_final_form => 0xfed2,
  :glyph_for_final_arabic_fa => 0xfed2,
  :arabic_letter_feh_initial_form => 0xfed3,
  :glyph_for_initial_arabic_fa => 0xfed3,
  :arabic_letter_feh_medial_form => 0xfed4,
  :glyph_for_medial_arabic_fa => 0xfed4,
  :arabic_letter_qaf_isolated_form => 0xfed5,
  :glyph_for_isolate_arabic_qaf => 0xfed5,
  :arabic_letter_qaf_final_form => 0xfed6,
  :glyph_for_final_arabic_qaf => 0xfed6,
  :arabic_letter_qaf_initial_form => 0xfed7,
  :glyph_for_initial_arabic_qaf => 0xfed7,
  :arabic_letter_qaf_medial_form => 0xfed8,
  :glyph_for_medial_arabic_qaf => 0xfed8,
  :arabic_letter_kaf_isolated_form => 0xfed9,
  :glyph_for_isolate_arabic_caf => 0xfed9,
  :arabic_letter_kaf_final_form => 0xfeda,
  :glyph_for_final_arabic_caf => 0xfeda,
  :arabic_letter_kaf_initial_form => 0xfedb,
  :glyph_for_initial_arabic_caf => 0xfedb,
  :arabic_letter_kaf_medial_form => 0xfedc,
  :glyph_for_medial_arabic_caf => 0xfedc,
  :arabic_letter_lam_isolated_form => 0xfedd,
  :glyph_for_isolate_arabic_lam => 0xfedd,
  :arabic_letter_lam_final_form => 0xfede,
  :glyph_for_final_arabic_lam => 0xfede,
  :arabic_letter_lam_initial_form => 0xfedf,
  :glyph_for_initial_arabic_lam => 0xfedf,
  :arabic_letter_lam_medial_form => 0xfee0,
  :glyph_for_medial_arabic_lam => 0xfee0,
  :arabic_letter_meem_isolated_form => 0xfee1,
  :glyph_for_isolate_arabic_meem => 0xfee1,
  :arabic_letter_meem_final_form => 0xfee2,
  :glyph_for_final_arabic_meem => 0xfee2,
  :arabic_letter_meem_initial_form => 0xfee3,
  :glyph_for_initial_arabic_meem => 0xfee3,
  :arabic_letter_meem_medial_form => 0xfee4,
  :glyph_for_medial_arabic_meem => 0xfee4,
  :arabic_letter_noon_isolated_form => 0xfee5,
  :glyph_for_isolate_arabic_noon => 0xfee5,
  :arabic_letter_noon_final_form => 0xfee6,
  :glyph_for_final_arabic_noon => 0xfee6,
  :arabic_letter_noon_initial_form => 0xfee7,
  :glyph_for_initial_arabic_noon => 0xfee7,
  :arabic_letter_noon_medial_form => 0xfee8,
  :glyph_for_medial_arabic_noon => 0xfee8,
  :arabic_letter_heh_isolated_form => 0xfee9,
  :glyph_for_isolate_arabic_ha => 0xfee9,
  :arabic_letter_heh_final_form => 0xfeea,
  :glyph_for_final_arabic_ha => 0xfeea,
  :arabic_letter_heh_initial_form => 0xfeeb,
  :glyph_for_initial_arabic_ha => 0xfeeb,
  :arabic_letter_heh_medial_form => 0xfeec,
  :glyph_for_medial_arabic_ha => 0xfeec,
  :arabic_letter_waw_isolated_form => 0xfeed,
  :glyph_for_isolate_arabic_waw => 0xfeed,
  :arabic_letter_waw_final_form => 0xfeee,
  :glyph_for_final_arabic_waw => 0xfeee,
  :arabic_letter_alef_maksura_isolated_form => 0xfeef,
  :glyph_for_isolate_arabic_alef_maqsurah => 0xfeef,
  :arabic_letter_alef_maksura_final_form => 0xfef0,
  :glyph_for_final_arabic_alef_maqsurah => 0xfef0,
  :arabic_letter_yeh_isolated_form => 0xfef1,
  :glyph_for_isolate_arabic_ya => 0xfef1,
  :arabic_letter_yeh_final_form => 0xfef2,
  :glyph_for_final_arabic_ya => 0xfef2,
  :arabic_letter_yeh_initial_form => 0xfef3,
  :glyph_for_initial_arabic_ya => 0xfef3,
  :arabic_letter_yeh_medial_form => 0xfef4,
  :glyph_for_medial_arabic_ya => 0xfef4,
  :arabic_ligature_lam_with_alef_with_madda_above_isolated_form => 0xfef5,
  :glyph_for_isolate_arabic_maddah_on_ligature_lam_alef => 0xfef5,
  :arabic_ligature_lam_with_alef_with_madda_above_final_form => 0xfef6,
  :glyph_for_final_arabic_maddah_on_ligature_lam_alef => 0xfef6,
  :arabic_ligature_lam_with_alef_with_hamza_above_isolated_form => 0xfef7,
  :glyph_for_isolate_arabic_hamzah_on_ligature_lam_alef => 0xfef7,
  :arabic_ligature_lam_with_alef_with_hamza_above_final_form => 0xfef8,
  :glyph_for_final_arabic_hamzah_on_ligature_lam_alef => 0xfef8,
  :arabic_ligature_lam_with_alef_with_hamza_below_isolated_form => 0xfef9,
  :glyph_for_isolate_arabic_hamzah_under_ligature_lam_alef => 0xfef9,
  :arabic_ligature_lam_with_alef_with_hamza_below_final_form => 0xfefa,
  :glyph_for_final_arabic_hamzah_under_ligature_lam_alef => 0xfefa,
  :arabic_ligature_lam_with_alef_isolated_form => 0xfefb,
  :glyph_for_isolate_arabic_ligature_lam_alef => 0xfefb,
  :arabic_ligature_lam_with_alef_final_form => 0xfefc,
  :glyph_for_final_arabic_ligature_lam_alef => 0xfefc,
  :zero_width_no_break_space => 0xfeff,
  :byte_order_mark => 0xfeff,
  :fullwidth_exclamation_mark => 0xff01,
  :fullwidth_quotation_mark => 0xff02,
  :fullwidth_number_sign => 0xff03,
  :fullwidth_dollar_sign => 0xff04,
  :fullwidth_percent_sign => 0xff05,
  :fullwidth_ampersand => 0xff06,
  :fullwidth_apostrophe => 0xff07,
  :fullwidth_left_parenthesis => 0xff08,
  :fullwidth_opening_parenthesis => 0xff08,
  :fullwidth_right_parenthesis => 0xff09,
  :fullwidth_closing_parenthesis => 0xff09,
  :fullwidth_asterisk => 0xff0a,
  :fullwidth_plus_sign => 0xff0b,
  :fullwidth_comma => 0xff0c,
  :fullwidth_hyphen_minus => 0xff0d,
  :fullwidth_full_stop => 0xff0e,
  :fullwidth_period => 0xff0e,
  :fullwidth_solidus => 0xff0f,
  :fullwidth_slash => 0xff0f,
  :fullwidth_digit_zero => 0xff10,
  :fullwidth_digit_one => 0xff11,
  :fullwidth_digit_two => 0xff12,
  :fullwidth_digit_three => 0xff13,
  :fullwidth_digit_four => 0xff14,
  :fullwidth_digit_five => 0xff15,
  :fullwidth_digit_six => 0xff16,
  :fullwidth_digit_seven => 0xff17,
  :fullwidth_digit_eight => 0xff18,
  :fullwidth_digit_nine => 0xff19,
  :fullwidth_colon => 0xff1a,
  :fullwidth_semicolon => 0xff1b,
  :fullwidth_less_than_sign => 0xff1c,
  :fullwidth_equals_sign => 0xff1d,
  :fullwidth_greater_than_sign => 0xff1e,
  :fullwidth_question_mark => 0xff1f,
  :fullwidth_commercial_at => 0xff20,
  :fullwidth_latin_capital_letter_a => 0xff21,
  :fullwidth_latin_capital_letter_b => 0xff22,
  :fullwidth_latin_capital_letter_c => 0xff23,
  :fullwidth_latin_capital_letter_d => 0xff24,
  :fullwidth_latin_capital_letter_e => 0xff25,
  :fullwidth_latin_capital_letter_f => 0xff26,
  :fullwidth_latin_capital_letter_g => 0xff27,
  :fullwidth_latin_capital_letter_h => 0xff28,
  :fullwidth_latin_capital_letter_i => 0xff29,
  :fullwidth_latin_capital_letter_j => 0xff2a,
  :fullwidth_latin_capital_letter_k => 0xff2b,
  :fullwidth_latin_capital_letter_l => 0xff2c,
  :fullwidth_latin_capital_letter_m => 0xff2d,
  :fullwidth_latin_capital_letter_n => 0xff2e,
  :fullwidth_latin_capital_letter_o => 0xff2f,
  :fullwidth_latin_capital_letter_p => 0xff30,
  :fullwidth_latin_capital_letter_q => 0xff31,
  :fullwidth_latin_capital_letter_r => 0xff32,
  :fullwidth_latin_capital_letter_s => 0xff33,
  :fullwidth_latin_capital_letter_t => 0xff34,
  :fullwidth_latin_capital_letter_u => 0xff35,
  :fullwidth_latin_capital_letter_v => 0xff36,
  :fullwidth_latin_capital_letter_w => 0xff37,
  :fullwidth_latin_capital_letter_x => 0xff38,
  :fullwidth_latin_capital_letter_y => 0xff39,
  :fullwidth_latin_capital_letter_z => 0xff3a,
  :fullwidth_left_square_bracket => 0xff3b,
  :fullwidth_opening_square_bracket => 0xff3b,
  :fullwidth_reverse_solidus => 0xff3c,
  :fullwidth_backslash => 0xff3c,
  :fullwidth_right_square_bracket => 0xff3d,
  :fullwidth_closing_square_bracket => 0xff3d,
  :fullwidth_circumflex_accent => 0xff3e,
  :fullwidth_spacing_circumflex => 0xff3e,
  :fullwidth_low_line => 0xff3f,
  :fullwidth_spacing_underscore => 0xff3f,
  :fullwidth_grave_accent => 0xff40,
  :fullwidth_spacing_grave => 0xff40,
  :fullwidth_latin_small_letter_a => 0xff41,
  :fullwidth_latin_small_letter_b => 0xff42,
  :fullwidth_latin_small_letter_c => 0xff43,
  :fullwidth_latin_small_letter_d => 0xff44,
  :fullwidth_latin_small_letter_e => 0xff45,
  :fullwidth_latin_small_letter_f => 0xff46,
  :fullwidth_latin_small_letter_g => 0xff47,
  :fullwidth_latin_small_letter_h => 0xff48,
  :fullwidth_latin_small_letter_i => 0xff49,
  :fullwidth_latin_small_letter_j => 0xff4a,
  :fullwidth_latin_small_letter_k => 0xff4b,
  :fullwidth_latin_small_letter_l => 0xff4c,
  :fullwidth_latin_small_letter_m => 0xff4d,
  :fullwidth_latin_small_letter_n => 0xff4e,
  :fullwidth_latin_small_letter_o => 0xff4f,
  :fullwidth_latin_small_letter_p => 0xff50,
  :fullwidth_latin_small_letter_q => 0xff51,
  :fullwidth_latin_small_letter_r => 0xff52,
  :fullwidth_latin_small_letter_s => 0xff53,
  :fullwidth_latin_small_letter_t => 0xff54,
  :fullwidth_latin_small_letter_u => 0xff55,
  :fullwidth_latin_small_letter_v => 0xff56,
  :fullwidth_latin_small_letter_w => 0xff57,
  :fullwidth_latin_small_letter_x => 0xff58,
  :fullwidth_latin_small_letter_y => 0xff59,
  :fullwidth_latin_small_letter_z => 0xff5a,
  :fullwidth_left_curly_bracket => 0xff5b,
  :fullwidth_opening_curly_bracket => 0xff5b,
  :fullwidth_vertical_line => 0xff5c,
  :fullwidth_vertical_bar => 0xff5c,
  :fullwidth_right_curly_bracket => 0xff5d,
  :fullwidth_closing_curly_bracket => 0xff5d,
  :fullwidth_tilde => 0xff5e,
  :fullwidth_spacing_tilde => 0xff5e,
  :fullwidth_left_white_parenthesis => 0xff5f,
  :fullwidth_right_white_parenthesis => 0xff60,
  :halfwidth_ideographic_full_stop => 0xff61,
  :halfwidth_ideographic_period => 0xff61,
  :halfwidth_left_corner_bracket => 0xff62,
  :halfwidth_opening_corner_bracket => 0xff62,
  :halfwidth_right_corner_bracket => 0xff63,
  :halfwidth_closing_corner_bracket => 0xff63,
  :halfwidth_ideographic_comma => 0xff64,
  :halfwidth_katakana_middle_dot => 0xff65,
  :halfwidth_katakana_letter_wo => 0xff66,
  :halfwidth_katakana_letter_small_a => 0xff67,
  :halfwidth_katakana_letter_small_i => 0xff68,
  :halfwidth_katakana_letter_small_u => 0xff69,
  :halfwidth_katakana_letter_small_e => 0xff6a,
  :halfwidth_katakana_letter_small_o => 0xff6b,
  :halfwidth_katakana_letter_small_ya => 0xff6c,
  :halfwidth_katakana_letter_small_yu => 0xff6d,
  :halfwidth_katakana_letter_small_yo => 0xff6e,
  :halfwidth_katakana_letter_small_tu => 0xff6f,
  :halfwidth_katakana_hiragana_prolonged_sound_mark => 0xff70,
  :halfwidth_katakana_letter_a => 0xff71,
  :halfwidth_katakana_letter_i => 0xff72,
  :halfwidth_katakana_letter_u => 0xff73,
  :halfwidth_katakana_letter_e => 0xff74,
  :halfwidth_katakana_letter_o => 0xff75,
  :halfwidth_katakana_letter_ka => 0xff76,
  :halfwidth_katakana_letter_ki => 0xff77,
  :halfwidth_katakana_letter_ku => 0xff78,
  :halfwidth_katakana_letter_ke => 0xff79,
  :halfwidth_katakana_letter_ko => 0xff7a,
  :halfwidth_katakana_letter_sa => 0xff7b,
  :halfwidth_katakana_letter_si => 0xff7c,
  :halfwidth_katakana_letter_su => 0xff7d,
  :halfwidth_katakana_letter_se => 0xff7e,
  :halfwidth_katakana_letter_so => 0xff7f,
  :halfwidth_katakana_letter_ta => 0xff80,
  :halfwidth_katakana_letter_ti => 0xff81,
  :halfwidth_katakana_letter_tu => 0xff82,
  :halfwidth_katakana_letter_te => 0xff83,
  :halfwidth_katakana_letter_to => 0xff84,
  :halfwidth_katakana_letter_na => 0xff85,
  :halfwidth_katakana_letter_ni => 0xff86,
  :halfwidth_katakana_letter_nu => 0xff87,
  :halfwidth_katakana_letter_ne => 0xff88,
  :halfwidth_katakana_letter_no => 0xff89,
  :halfwidth_katakana_letter_ha => 0xff8a,
  :halfwidth_katakana_letter_hi => 0xff8b,
  :halfwidth_katakana_letter_hu => 0xff8c,
  :halfwidth_katakana_letter_he => 0xff8d,
  :halfwidth_katakana_letter_ho => 0xff8e,
  :halfwidth_katakana_letter_ma => 0xff8f,
  :halfwidth_katakana_letter_mi => 0xff90,
  :halfwidth_katakana_letter_mu => 0xff91,
  :halfwidth_katakana_letter_me => 0xff92,
  :halfwidth_katakana_letter_mo => 0xff93,
  :halfwidth_katakana_letter_ya => 0xff94,
  :halfwidth_katakana_letter_yu => 0xff95,
  :halfwidth_katakana_letter_yo => 0xff96,
  :halfwidth_katakana_letter_ra => 0xff97,
  :halfwidth_katakana_letter_ri => 0xff98,
  :halfwidth_katakana_letter_ru => 0xff99,
  :halfwidth_katakana_letter_re => 0xff9a,
  :halfwidth_katakana_letter_ro => 0xff9b,
  :halfwidth_katakana_letter_wa => 0xff9c,
  :halfwidth_katakana_letter_n => 0xff9d,
  :halfwidth_katakana_voiced_sound_mark => 0xff9e,
  :halfwidth_katakana_semi_voiced_sound_mark => 0xff9f,
  :halfwidth_hangul_filler => 0xffa0,
  :halfwidth_hangul_cae_om => 0xffa0,
  :halfwidth_hangul_letter_kiyeok => 0xffa1,
  :halfwidth_hangul_letter_giyeog => 0xffa1,
  :halfwidth_hangul_letter_ssangkiyeok => 0xffa2,
  :halfwidth_hangul_letter_ssang_giyeog => 0xffa2,
  :halfwidth_hangul_letter_kiyeok_sios => 0xffa3,
  :halfwidth_hangul_letter_giyeog_sios => 0xffa3,
  :halfwidth_hangul_letter_nieun => 0xffa4,
  :halfwidth_hangul_letter_nieun_cieuc => 0xffa5,
  :halfwidth_hangul_letter_nieun_jieuj => 0xffa5,
  :halfwidth_hangul_letter_nieun_hieuh => 0xffa6,
  :halfwidth_hangul_letter_nieun_hieuh => 0xffa6,
  :halfwidth_hangul_letter_tikeut => 0xffa7,
  :halfwidth_hangul_letter_digeud => 0xffa7,
  :halfwidth_hangul_letter_ssangtikeut => 0xffa8,
  :halfwidth_hangul_letter_ssang_digeud => 0xffa8,
  :halfwidth_hangul_letter_rieul => 0xffa9,
  :halfwidth_hangul_letter_lieul => 0xffa9,
  :halfwidth_hangul_letter_rieul_kiyeok => 0xffaa,
  :halfwidth_hangul_letter_lieul_giyeog => 0xffaa,
  :halfwidth_hangul_letter_rieul_mieum => 0xffab,
  :halfwidth_hangul_letter_lieul_mieum => 0xffab,
  :halfwidth_hangul_letter_rieul_pieup => 0xffac,
  :halfwidth_hangul_letter_lieul_bieub => 0xffac,
  :halfwidth_hangul_letter_rieul_sios => 0xffad,
  :halfwidth_hangul_letter_lieul_sios => 0xffad,
  :halfwidth_hangul_letter_rieul_thieuth => 0xffae,
  :halfwidth_hangul_letter_lieul_tieut => 0xffae,
  :halfwidth_hangul_letter_rieul_phieuph => 0xffaf,
  :halfwidth_hangul_letter_lieul_pieup => 0xffaf,
  :halfwidth_hangul_letter_rieul_hieuh => 0xffb0,
  :halfwidth_hangul_letter_lieul_hieuh => 0xffb0,
  :halfwidth_hangul_letter_mieum => 0xffb1,
  :halfwidth_hangul_letter_pieup => 0xffb2,
  :halfwidth_hangul_letter_bieub => 0xffb2,
  :halfwidth_hangul_letter_ssangpieup => 0xffb3,
  :halfwidth_hangul_letter_ssang_bieub => 0xffb3,
  :halfwidth_hangul_letter_pieup_sios => 0xffb4,
  :halfwidth_hangul_letter_bieub_sios => 0xffb4,
  :halfwidth_hangul_letter_sios => 0xffb5,
  :halfwidth_hangul_letter_ssangsios => 0xffb6,
  :halfwidth_hangul_letter_ssang_sios => 0xffb6,
  :halfwidth_hangul_letter_ieung => 0xffb7,
  :halfwidth_hangul_letter_cieuc => 0xffb8,
  :halfwidth_hangul_letter_jieuj => 0xffb8,
  :halfwidth_hangul_letter_ssangcieuc => 0xffb9,
  :halfwidth_hangul_letter_ssang_jieuj => 0xffb9,
  :halfwidth_hangul_letter_chieuch => 0xffba,
  :halfwidth_hangul_letter_cieuc => 0xffba,
  :halfwidth_hangul_letter_khieukh => 0xffbb,
  :halfwidth_hangul_letter_kiyeok => 0xffbb,
  :halfwidth_hangul_letter_thieuth => 0xffbc,
  :halfwidth_hangul_letter_tieut => 0xffbc,
  :halfwidth_hangul_letter_phieuph => 0xffbd,
  :halfwidth_hangul_letter_pieup => 0xffbd,
  :halfwidth_hangul_letter_hieuh => 0xffbe,
  :halfwidth_hangul_letter_a => 0xffc2,
  :halfwidth_hangul_letter_ae => 0xffc3,
  :halfwidth_hangul_letter_ya => 0xffc4,
  :halfwidth_hangul_letter_yae => 0xffc5,
  :halfwidth_hangul_letter_eo => 0xffc6,
  :halfwidth_hangul_letter_e => 0xffc7,
  :halfwidth_hangul_letter_yeo => 0xffca,
  :halfwidth_hangul_letter_ye => 0xffcb,
  :halfwidth_hangul_letter_o => 0xffcc,
  :halfwidth_hangul_letter_wa => 0xffcd,
  :halfwidth_hangul_letter_wae => 0xffce,
  :halfwidth_hangul_letter_oe => 0xffcf,
  :halfwidth_hangul_letter_yo => 0xffd2,
  :halfwidth_hangul_letter_u => 0xffd3,
  :halfwidth_hangul_letter_weo => 0xffd4,
  :halfwidth_hangul_letter_we => 0xffd5,
  :halfwidth_hangul_letter_wi => 0xffd6,
  :halfwidth_hangul_letter_yu => 0xffd7,
  :halfwidth_hangul_letter_eu => 0xffda,
  :halfwidth_hangul_letter_yi => 0xffdb,
  :halfwidth_hangul_letter_i => 0xffdc,
  :fullwidth_cent_sign => 0xffe0,
  :fullwidth_pound_sign => 0xffe1,
  :fullwidth_not_sign => 0xffe2,
  :fullwidth_macron => 0xffe3,
  :fullwidth_spacing_macron => 0xffe3,
  :fullwidth_broken_bar => 0xffe4,
  :fullwidth_broken_vertical_bar => 0xffe4,
  :fullwidth_yen_sign => 0xffe5,
  :fullwidth_won_sign => 0xffe6,
  :halfwidth_forms_light_vertical => 0xffe8,
  :halfwidth_leftwards_arrow => 0xffe9,
  :halfwidth_upwards_arrow => 0xffea,
  :halfwidth_rightwards_arrow => 0xffeb,
  :halfwidth_downwards_arrow => 0xffec,
  :halfwidth_black_square => 0xffed,
  :halfwidth_white_circle => 0xffee,
  :interlinear_annotation_anchor => 0xfff9,
  :interlinear_annotation_separator => 0xfffa,
  :interlinear_annotation_terminator => 0xfffb,
  :object_replacement_character => 0xfffc,
  :replacement_character => 0xfffd,
  :linear_b_syllable_b008_a => 0x10000,
  :linear_b_syllable_b038_e => 0x10001,
  :linear_b_syllable_b028_i => 0x10002,
  :linear_b_syllable_b061_o => 0x10003,
  :linear_b_syllable_b010_u => 0x10004,
  :linear_b_syllable_b001_da => 0x10005,
  :linear_b_syllable_b045_de => 0x10006,
  :linear_b_syllable_b007_di => 0x10007,
  :linear_b_syllable_b014_do => 0x10008,
  :linear_b_syllable_b051_du => 0x10009,
  :linear_b_syllable_b057_ja => 0x1000a,
  :linear_b_syllable_b046_je => 0x1000b,
  :linear_b_syllable_b036_jo => 0x1000d,
  :linear_b_syllable_b065_ju => 0x1000e,
  :linear_b_syllable_b077_ka => 0x1000f,
  :linear_b_syllable_b044_ke => 0x10010,
  :linear_b_syllable_b067_ki => 0x10011,
  :linear_b_syllable_b070_ko => 0x10012,
  :linear_b_syllable_b081_ku => 0x10013,
  :linear_b_syllable_b080_ma => 0x10014,
  :linear_b_syllable_b013_me => 0x10015,
  :linear_b_syllable_b073_mi => 0x10016,
  :linear_b_syllable_b015_mo => 0x10017,
  :linear_b_syllable_b023_mu => 0x10018,
  :linear_b_syllable_b006_na => 0x10019,
  :linear_b_syllable_b024_ne => 0x1001a,
  :linear_b_syllable_b030_ni => 0x1001b,
  :linear_b_syllable_b052_no => 0x1001c,
  :linear_b_syllable_b055_nu => 0x1001d,
  :linear_b_syllable_b003_pa => 0x1001e,
  :linear_b_syllable_b072_pe => 0x1001f,
  :linear_b_syllable_b039_pi => 0x10020,
  :linear_b_syllable_b011_po => 0x10021,
  :linear_b_syllable_b050_pu => 0x10022,
  :linear_b_syllable_b016_qa => 0x10023,
  :linear_b_syllable_b078_qe => 0x10024,
  :linear_b_syllable_b021_qi => 0x10025,
  :linear_b_syllable_b032_qo => 0x10026,
  :linear_b_syllable_b060_ra => 0x10028,
  :linear_b_syllable_b027_re => 0x10029,
  :linear_b_syllable_b053_ri => 0x1002a,
  :linear_b_syllable_b002_ro => 0x1002b,
  :linear_b_syllable_b026_ru => 0x1002c,
  :linear_b_syllable_b031_sa => 0x1002d,
  :linear_b_syllable_b009_se => 0x1002e,
  :linear_b_syllable_b041_si => 0x1002f,
  :linear_b_syllable_b012_so => 0x10030,
  :linear_b_syllable_b058_su => 0x10031,
  :linear_b_syllable_b059_ta => 0x10032,
  :linear_b_syllable_b004_te => 0x10033,
  :linear_b_syllable_b037_ti => 0x10034,
  :linear_b_syllable_b005_to => 0x10035,
  :linear_b_syllable_b069_tu => 0x10036,
  :linear_b_syllable_b054_wa => 0x10037,
  :linear_b_syllable_b075_we => 0x10038,
  :linear_b_syllable_b040_wi => 0x10039,
  :linear_b_syllable_b042_wo => 0x1003a,
  :linear_b_syllable_b017_za => 0x1003c,
  :linear_b_syllable_b074_ze => 0x1003d,
  :linear_b_syllable_b020_zo => 0x1003f,
  :linear_b_syllable_b025_a2 => 0x10040,
  :linear_b_syllable_b043_a3 => 0x10041,
  :linear_b_syllable_b085_au => 0x10042,
  :linear_b_syllable_b071_dwe => 0x10043,
  :linear_b_syllable_b090_dwo => 0x10044,
  :linear_b_syllable_b048_nwa => 0x10045,
  :linear_b_syllable_b029_pu2 => 0x10046,
  :linear_b_syllable_b062_pte => 0x10047,
  :linear_b_syllable_b076_ra2 => 0x10048,
  :linear_b_syllable_b033_ra3 => 0x10049,
  :linear_b_syllable_b068_ro2 => 0x1004a,
  :linear_b_syllable_b066_ta2 => 0x1004b,
  :linear_b_syllable_b087_twe => 0x1004c,
  :linear_b_syllable_b091_two => 0x1004d,
  :linear_b_symbol_b018 => 0x10050,
  :linear_b_symbol_b019 => 0x10051,
  :linear_b_symbol_b022 => 0x10052,
  :linear_b_symbol_b034 => 0x10053,
  :linear_b_symbol_b047 => 0x10054,
  :linear_b_symbol_b049 => 0x10055,
  :linear_b_symbol_b056 => 0x10056,
  :linear_b_symbol_b063 => 0x10057,
  :linear_b_symbol_b064 => 0x10058,
  :linear_b_symbol_b079 => 0x10059,
  :linear_b_symbol_b082 => 0x1005a,
  :linear_b_symbol_b083 => 0x1005b,
  :linear_b_symbol_b086 => 0x1005c,
  :linear_b_symbol_b089 => 0x1005d,
  :linear_b_ideogram_b100_man => 0x10080,
  :linear_b_ideogram_b102_woman => 0x10081,
  :linear_b_ideogram_b104_deer => 0x10082,
  :linear_b_ideogram_b105_equid => 0x10083,
  :linear_b_ideogram_b105f_mare => 0x10084,
  :linear_b_ideogram_b105m_stallion => 0x10085,
  :linear_b_ideogram_b106f_ewe => 0x10086,
  :linear_b_ideogram_b106m_ram => 0x10087,
  :linear_b_ideogram_b107f_she_goat => 0x10088,
  :linear_b_ideogram_b107m_he_goat => 0x10089,
  :linear_b_ideogram_b108f_sow => 0x1008a,
  :linear_b_ideogram_b108m_boar => 0x1008b,
  :linear_b_ideogram_b109f_cow => 0x1008c,
  :linear_b_ideogram_b109m_bull => 0x1008d,
  :linear_b_ideogram_b120_wheat => 0x1008e,
  :linear_b_ideogram_b121_barley => 0x1008f,
  :linear_b_ideogram_b122_olive => 0x10090,
  :linear_b_ideogram_b123_spice => 0x10091,
  :linear_b_ideogram_b125_cyperus => 0x10092,
  :linear_b_monogram_b127_kapo => 0x10093,
  :linear_b_monogram_b128_kanako => 0x10094,
  :linear_b_ideogram_b130_oil => 0x10095,
  :linear_b_ideogram_b131_wine => 0x10096,
  :linear_b_ideogram_b132 => 0x10097,
  :linear_b_monogram_b133_arepa => 0x10098,
  :linear_b_monogram_b135_meri => 0x10099,
  :linear_b_ideogram_b140_bronze => 0x1009a,
  :linear_b_ideogram_b141_gold => 0x1009b,
  :linear_b_ideogram_b142 => 0x1009c,
  :linear_b_ideogram_b145_wool => 0x1009d,
  :linear_b_ideogram_b146 => 0x1009e,
  :linear_b_ideogram_b150 => 0x1009f,
  :linear_b_ideogram_b151_horn => 0x100a0,
  :linear_b_ideogram_b152 => 0x100a1,
  :linear_b_ideogram_b153 => 0x100a2,
  :linear_b_ideogram_b154 => 0x100a3,
  :linear_b_monogram_b156_turo2 => 0x100a4,
  :linear_b_ideogram_b157 => 0x100a5,
  :linear_b_ideogram_b158 => 0x100a6,
  :linear_b_ideogram_b159_cloth => 0x100a7,
  :linear_b_ideogram_b160 => 0x100a8,
  :linear_b_ideogram_b161 => 0x100a9,
  :linear_b_ideogram_b162_garment => 0x100aa,
  :linear_b_ideogram_b163_armour => 0x100ab,
  :linear_b_ideogram_b164 => 0x100ac,
  :linear_b_ideogram_b165 => 0x100ad,
  :linear_b_ideogram_b166 => 0x100ae,
  :linear_b_ideogram_b167 => 0x100af,
  :linear_b_ideogram_b168 => 0x100b0,
  :linear_b_ideogram_b169 => 0x100b1,
  :linear_b_ideogram_b170 => 0x100b2,
  :linear_b_ideogram_b171 => 0x100b3,
  :linear_b_ideogram_b172 => 0x100b4,
  :linear_b_ideogram_b173_month => 0x100b5,
  :linear_b_ideogram_b174 => 0x100b6,
  :linear_b_ideogram_b176_tree => 0x100b7,
  :linear_b_ideogram_b177 => 0x100b8,
  :linear_b_ideogram_b178 => 0x100b9,
  :linear_b_ideogram_b179 => 0x100ba,
  :linear_b_ideogram_b180 => 0x100bb,
  :linear_b_ideogram_b181 => 0x100bc,
  :linear_b_ideogram_b182 => 0x100bd,
  :linear_b_ideogram_b183 => 0x100be,
  :linear_b_ideogram_b184 => 0x100bf,
  :linear_b_ideogram_b185 => 0x100c0,
  :linear_b_ideogram_b189 => 0x100c1,
  :linear_b_ideogram_b190 => 0x100c2,
  :linear_b_ideogram_b191_helmet => 0x100c3,
  :linear_b_ideogram_b220_footstool => 0x100c4,
  :linear_b_ideogram_b225_bathtub => 0x100c5,
  :linear_b_ideogram_b230_spear => 0x100c6,
  :linear_b_ideogram_b231_arrow => 0x100c7,
  :linear_b_ideogram_b232 => 0x100c8,
  :linear_b_ideogram_b233_sword => 0x100c9,
  :linear_b_ideogram_b234 => 0x100ca,
  :linear_b_ideogram_b236 => 0x100cb,
  :linear_b_ideogram_b240_wheeled_chariot => 0x100cc,
  :linear_b_ideogram_b241_chariot => 0x100cd,
  :linear_b_ideogram_b242_chariot_frame => 0x100ce,
  :linear_b_ideogram_b243_wheel => 0x100cf,
  :linear_b_ideogram_b245 => 0x100d0,
  :linear_b_ideogram_b246 => 0x100d1,
  :linear_b_monogram_b247_dipte => 0x100d2,
  :linear_b_ideogram_b248 => 0x100d3,
  :linear_b_ideogram_b249 => 0x100d4,
  :linear_b_ideogram_b251 => 0x100d5,
  :linear_b_ideogram_b252 => 0x100d6,
  :linear_b_ideogram_b253 => 0x100d7,
  :linear_b_ideogram_b254_dart => 0x100d8,
  :linear_b_ideogram_b255 => 0x100d9,
  :linear_b_ideogram_b256 => 0x100da,
  :linear_b_ideogram_b257 => 0x100db,
  :linear_b_ideogram_b258 => 0x100dc,
  :linear_b_ideogram_b259 => 0x100dd,
  :linear_b_ideogram_vessel_b155 => 0x100de,
  :linear_b_ideogram_vessel_b200 => 0x100df,
  :linear_b_ideogram_vessel_b201 => 0x100e0,
  :linear_b_ideogram_vessel_b202 => 0x100e1,
  :linear_b_ideogram_vessel_b203 => 0x100e2,
  :linear_b_ideogram_vessel_b204 => 0x100e3,
  :linear_b_ideogram_vessel_b205 => 0x100e4,
  :linear_b_ideogram_vessel_b206 => 0x100e5,
  :linear_b_ideogram_vessel_b207 => 0x100e6,
  :linear_b_ideogram_vessel_b208 => 0x100e7,
  :linear_b_ideogram_vessel_b209 => 0x100e8,
  :linear_b_ideogram_vessel_b210 => 0x100e9,
  :linear_b_ideogram_vessel_b211 => 0x100ea,
  :linear_b_ideogram_vessel_b212 => 0x100eb,
  :linear_b_ideogram_vessel_b213 => 0x100ec,
  :linear_b_ideogram_vessel_b214 => 0x100ed,
  :linear_b_ideogram_vessel_b215 => 0x100ee,
  :linear_b_ideogram_vessel_b216 => 0x100ef,
  :linear_b_ideogram_vessel_b217 => 0x100f0,
  :linear_b_ideogram_vessel_b218 => 0x100f1,
  :linear_b_ideogram_vessel_b219 => 0x100f2,
  :linear_b_ideogram_vessel_b221 => 0x100f3,
  :linear_b_ideogram_vessel_b222 => 0x100f4,
  :linear_b_ideogram_vessel_b226 => 0x100f5,
  :linear_b_ideogram_vessel_b227 => 0x100f6,
  :linear_b_ideogram_vessel_b228 => 0x100f7,
  :linear_b_ideogram_vessel_b229 => 0x100f8,
  :linear_b_ideogram_vessel_b250 => 0x100f9,
  :linear_b_ideogram_vessel_b305 => 0x100fa,
  :aegean_word_separator_line => 0x10100,
  :aegean_word_separator_dot => 0x10101,
  :aegean_check_mark => 0x10102,
  :aegean_number_one => 0x10107,
  :aegean_number_two => 0x10108,
  :aegean_number_three => 0x10109,
  :aegean_number_four => 0x1010a,
  :aegean_number_five => 0x1010b,
  :aegean_number_six => 0x1010c,
  :aegean_number_seven => 0x1010d,
  :aegean_number_eight => 0x1010e,
  :aegean_number_nine => 0x1010f,
  :aegean_number_ten => 0x10110,
  :aegean_number_twenty => 0x10111,
  :aegean_number_thirty => 0x10112,
  :aegean_number_forty => 0x10113,
  :aegean_number_fifty => 0x10114,
  :aegean_number_sixty => 0x10115,
  :aegean_number_seventy => 0x10116,
  :aegean_number_eighty => 0x10117,
  :aegean_number_ninety => 0x10118,
  :aegean_number_one_hundred => 0x10119,
  :aegean_number_two_hundred => 0x1011a,
  :aegean_number_three_hundred => 0x1011b,
  :aegean_number_four_hundred => 0x1011c,
  :aegean_number_five_hundred => 0x1011d,
  :aegean_number_six_hundred => 0x1011e,
  :aegean_number_seven_hundred => 0x1011f,
  :aegean_number_eight_hundred => 0x10120,
  :aegean_number_nine_hundred => 0x10121,
  :aegean_number_one_thousand => 0x10122,
  :aegean_number_two_thousand => 0x10123,
  :aegean_number_three_thousand => 0x10124,
  :aegean_number_four_thousand => 0x10125,
  :aegean_number_five_thousand => 0x10126,
  :aegean_number_six_thousand => 0x10127,
  :aegean_number_seven_thousand => 0x10128,
  :aegean_number_eight_thousand => 0x10129,
  :aegean_number_nine_thousand => 0x1012a,
  :aegean_number_ten_thousand => 0x1012b,
  :aegean_number_twenty_thousand => 0x1012c,
  :aegean_number_thirty_thousand => 0x1012d,
  :aegean_number_forty_thousand => 0x1012e,
  :aegean_number_fifty_thousand => 0x1012f,
  :aegean_number_sixty_thousand => 0x10130,
  :aegean_number_seventy_thousand => 0x10131,
  :aegean_number_eighty_thousand => 0x10132,
  :aegean_number_ninety_thousand => 0x10133,
  :aegean_weight_base_unit => 0x10137,
  :aegean_weight_first_subunit => 0x10138,
  :aegean_weight_second_subunit => 0x10139,
  :aegean_weight_third_subunit => 0x1013a,
  :aegean_weight_fourth_subunit => 0x1013b,
  :aegean_dry_measure_first_subunit => 0x1013c,
  :aegean_liquid_measure_first_subunit => 0x1013d,
  :aegean_measure_second_subunit => 0x1013e,
  :aegean_measure_third_subunit => 0x1013f,
  :greek_acrophonic_attic_one_quarter => 0x10140,
  :greek_acrophonic_attic_one_half => 0x10141,
  :greek_acrophonic_attic_one_drachma => 0x10142,
  :greek_acrophonic_attic_five => 0x10143,
  :greek_acrophonic_attic_fifty => 0x10144,
  :greek_acrophonic_attic_five_hundred => 0x10145,
  :greek_acrophonic_attic_five_thousand => 0x10146,
  :greek_acrophonic_attic_fifty_thousand => 0x10147,
  :greek_acrophonic_attic_five_talents => 0x10148,
  :greek_acrophonic_attic_ten_talents => 0x10149,
  :greek_acrophonic_attic_fifty_talents => 0x1014a,
  :greek_acrophonic_attic_one_hundred_talents => 0x1014b,
  :greek_acrophonic_attic_five_hundred_talents => 0x1014c,
  :greek_acrophonic_attic_one_thousand_talents => 0x1014d,
  :greek_acrophonic_attic_five_thousand_talents => 0x1014e,
  :greek_acrophonic_attic_five_staters => 0x1014f,
  :greek_acrophonic_attic_ten_staters => 0x10150,
  :greek_acrophonic_attic_fifty_staters => 0x10151,
  :greek_acrophonic_attic_one_hundred_staters => 0x10152,
  :greek_acrophonic_attic_five_hundred_staters => 0x10153,
  :greek_acrophonic_attic_one_thousand_staters => 0x10154,
  :greek_acrophonic_attic_ten_thousand_staters => 0x10155,
  :greek_acrophonic_attic_fifty_thousand_staters => 0x10156,
  :greek_acrophonic_attic_ten_mnas => 0x10157,
  :greek_acrophonic_heraeum_one_plethron => 0x10158,
  :greek_acrophonic_thespian_one => 0x10159,
  :greek_acrophonic_hermionian_one => 0x1015a,
  :greek_acrophonic_epidaurean_two => 0x1015b,
  :greek_acrophonic_thespian_two => 0x1015c,
  :greek_acrophonic_cyrenaic_two_drachmas => 0x1015d,
  :greek_acrophonic_epidaurean_two_drachmas => 0x1015e,
  :greek_acrophonic_troezenian_five => 0x1015f,
  :greek_acrophonic_troezenian_ten => 0x10160,
  :greek_acrophonic_troezenian_ten_alternate_form => 0x10161,
  :greek_acrophonic_hermionian_ten => 0x10162,
  :greek_acrophonic_messenian_ten => 0x10163,
  :greek_acrophonic_thespian_ten => 0x10164,
  :greek_acrophonic_thespian_thirty => 0x10165,
  :greek_acrophonic_troezenian_fifty => 0x10166,
  :greek_acrophonic_troezenian_fifty_alternate_form => 0x10167,
  :greek_acrophonic_hermionian_fifty => 0x10168,
  :greek_acrophonic_thespian_fifty => 0x10169,
  :greek_acrophonic_thespian_one_hundred => 0x1016a,
  :greek_acrophonic_thespian_three_hundred => 0x1016b,
  :greek_acrophonic_epidaurean_five_hundred => 0x1016c,
  :greek_acrophonic_troezenian_five_hundred => 0x1016d,
  :greek_acrophonic_thespian_five_hundred => 0x1016e,
  :greek_acrophonic_carystian_five_hundred => 0x1016f,
  :greek_acrophonic_naxian_five_hundred => 0x10170,
  :greek_acrophonic_thespian_one_thousand => 0x10171,
  :greek_acrophonic_thespian_five_thousand => 0x10172,
  :greek_acrophonic_delphic_five_mnas => 0x10173,
  :greek_acrophonic_stratian_fifty_mnas => 0x10174,
  :greek_one_half_sign => 0x10175,
  :greek_one_half_sign_alternate_form => 0x10176,
  :greek_two_thirds_sign => 0x10177,
  :greek_three_quarters_sign => 0x10178,
  :greek_year_sign => 0x10179,
  :greek_talent_sign => 0x1017a,
  :greek_drachma_sign => 0x1017b,
  :greek_obol_sign => 0x1017c,
  :greek_two_obols_sign => 0x1017d,
  :greek_three_obols_sign => 0x1017e,
  :greek_four_obols_sign => 0x1017f,
  :greek_five_obols_sign => 0x10180,
  :greek_metretes_sign => 0x10181,
  :greek_kyathos_base_sign => 0x10182,
  :greek_litra_sign => 0x10183,
  :greek_ounkia_sign => 0x10184,
  :greek_xestes_sign => 0x10185,
  :greek_artabe_sign => 0x10186,
  :greek_aroura_sign => 0x10187,
  :greek_gramma_sign => 0x10188,
  :greek_tryblion_base_sign => 0x10189,
  :greek_zero_sign => 0x1018a,
  :old_italic_letter_a => 0x10300,
  :old_italic_letter_be => 0x10301,
  :old_italic_letter_ke => 0x10302,
  :old_italic_letter_de => 0x10303,
  :old_italic_letter_e => 0x10304,
  :old_italic_letter_ve => 0x10305,
  :old_italic_letter_ze => 0x10306,
  :old_italic_letter_he => 0x10307,
  :old_italic_letter_the => 0x10308,
  :old_italic_letter_i => 0x10309,
  :old_italic_letter_ka => 0x1030a,
  :old_italic_letter_el => 0x1030b,
  :old_italic_letter_em => 0x1030c,
  :old_italic_letter_en => 0x1030d,
  :old_italic_letter_esh => 0x1030e,
  :old_italic_letter_o => 0x1030f,
  :old_italic_letter_pe => 0x10310,
  :old_italic_letter_she => 0x10311,
  :old_italic_letter_ku => 0x10312,
  :old_italic_letter_er => 0x10313,
  :old_italic_letter_es => 0x10314,
  :old_italic_letter_te => 0x10315,
  :old_italic_letter_u => 0x10316,
  :old_italic_letter_eks => 0x10317,
  :old_italic_letter_phe => 0x10318,
  :old_italic_letter_khe => 0x10319,
  :old_italic_letter_ef => 0x1031a,
  :old_italic_letter_ers => 0x1031b,
  :old_italic_letter_che => 0x1031c,
  :old_italic_letter_ii => 0x1031d,
  :old_italic_letter_uu => 0x1031e,
  :old_italic_numeral_one => 0x10320,
  :old_italic_numeral_five => 0x10321,
  :old_italic_numeral_ten => 0x10322,
  :old_italic_numeral_fifty => 0x10323,
  :gothic_letter_ahsa => 0x10330,
  :gothic_letter_bairkan => 0x10331,
  :gothic_letter_giba => 0x10332,
  :gothic_letter_dags => 0x10333,
  :gothic_letter_aihvus => 0x10334,
  :gothic_letter_qairthra => 0x10335,
  :gothic_letter_iuja => 0x10336,
  :gothic_letter_hagl => 0x10337,
  :gothic_letter_thiuth => 0x10338,
  :gothic_letter_eis => 0x10339,
  :gothic_letter_kusma => 0x1033a,
  :gothic_letter_lagus => 0x1033b,
  :gothic_letter_manna => 0x1033c,
  :gothic_letter_nauths => 0x1033d,
  :gothic_letter_jer => 0x1033e,
  :gothic_letter_urus => 0x1033f,
  :gothic_letter_pairthra => 0x10340,
  :gothic_letter_ninety => 0x10341,
  :gothic_letter_raida => 0x10342,
  :gothic_letter_sauil => 0x10343,
  :gothic_letter_teiws => 0x10344,
  :gothic_letter_winja => 0x10345,
  :gothic_letter_faihu => 0x10346,
  :gothic_letter_iggws => 0x10347,
  :gothic_letter_hwair => 0x10348,
  :gothic_letter_othal => 0x10349,
  :gothic_letter_nine_hundred => 0x1034a,
  :ugaritic_letter_alpa => 0x10380,
  :ugaritic_letter_beta => 0x10381,
  :ugaritic_letter_gamla => 0x10382,
  :ugaritic_letter_kha => 0x10383,
  :ugaritic_letter_delta => 0x10384,
  :ugaritic_letter_ho => 0x10385,
  :ugaritic_letter_wo => 0x10386,
  :ugaritic_letter_zeta => 0x10387,
  :ugaritic_letter_hota => 0x10388,
  :ugaritic_letter_tet => 0x10389,
  :ugaritic_letter_yod => 0x1038a,
  :ugaritic_letter_kaf => 0x1038b,
  :ugaritic_letter_shin => 0x1038c,
  :ugaritic_letter_lamda => 0x1038d,
  :ugaritic_letter_mem => 0x1038e,
  :ugaritic_letter_dhal => 0x1038f,
  :ugaritic_letter_nun => 0x10390,
  :ugaritic_letter_zu => 0x10391,
  :ugaritic_letter_samka => 0x10392,
  :ugaritic_letter_ain => 0x10393,
  :ugaritic_letter_pu => 0x10394,
  :ugaritic_letter_sade => 0x10395,
  :ugaritic_letter_qopa => 0x10396,
  :ugaritic_letter_rasha => 0x10397,
  :ugaritic_letter_thanna => 0x10398,
  :ugaritic_letter_ghain => 0x10399,
  :ugaritic_letter_to => 0x1039a,
  :ugaritic_letter_i => 0x1039b,
  :ugaritic_letter_u => 0x1039c,
  :ugaritic_letter_ssu => 0x1039d,
  :ugaritic_word_divider => 0x1039f,
  :old_persian_sign_a => 0x103a0,
  :old_persian_sign_i => 0x103a1,
  :old_persian_sign_u => 0x103a2,
  :old_persian_sign_ka => 0x103a3,
  :old_persian_sign_ku => 0x103a4,
  :old_persian_sign_ga => 0x103a5,
  :old_persian_sign_gu => 0x103a6,
  :old_persian_sign_xa => 0x103a7,
  :old_persian_sign_ca => 0x103a8,
  :old_persian_sign_ja => 0x103a9,
  :old_persian_sign_ji => 0x103aa,
  :old_persian_sign_ta => 0x103ab,
  :old_persian_sign_tu => 0x103ac,
  :old_persian_sign_da => 0x103ad,
  :old_persian_sign_di => 0x103ae,
  :old_persian_sign_du => 0x103af,
  :old_persian_sign_tha => 0x103b0,
  :old_persian_sign_pa => 0x103b1,
  :old_persian_sign_ba => 0x103b2,
  :old_persian_sign_fa => 0x103b3,
  :old_persian_sign_na => 0x103b4,
  :old_persian_sign_nu => 0x103b5,
  :old_persian_sign_ma => 0x103b6,
  :old_persian_sign_mi => 0x103b7,
  :old_persian_sign_mu => 0x103b8,
  :old_persian_sign_ya => 0x103b9,
  :old_persian_sign_va => 0x103ba,
  :old_persian_sign_vi => 0x103bb,
  :old_persian_sign_ra => 0x103bc,
  :old_persian_sign_ru => 0x103bd,
  :old_persian_sign_la => 0x103be,
  :old_persian_sign_sa => 0x103bf,
  :old_persian_sign_za => 0x103c0,
  :old_persian_sign_sha => 0x103c1,
  :old_persian_sign_ssa => 0x103c2,
  :old_persian_sign_ha => 0x103c3,
  :old_persian_sign_auramazdaa => 0x103c8,
  :old_persian_sign_auramazdaa_2 => 0x103c9,
  :old_persian_sign_auramazdaaha => 0x103ca,
  :old_persian_sign_xshaayathiya => 0x103cb,
  :old_persian_sign_dahyaaush => 0x103cc,
  :old_persian_sign_dahyaaush_2 => 0x103cd,
  :old_persian_sign_baga => 0x103ce,
  :old_persian_sign_buumish => 0x103cf,
  :old_persian_word_divider => 0x103d0,
  :old_persian_number_one => 0x103d1,
  :old_persian_number_two => 0x103d2,
  :old_persian_number_ten => 0x103d3,
  :old_persian_number_twenty => 0x103d4,
  :old_persian_number_hundred => 0x103d5,
  :deseret_capital_letter_long_i => 0x10400,
  :deseret_capital_letter_long_e => 0x10401,
  :deseret_capital_letter_long_a => 0x10402,
  :deseret_capital_letter_long_ah => 0x10403,
  :deseret_capital_letter_long_o => 0x10404,
  :deseret_capital_letter_long_oo => 0x10405,
  :deseret_capital_letter_short_i => 0x10406,
  :deseret_capital_letter_short_e => 0x10407,
  :deseret_capital_letter_short_a => 0x10408,
  :deseret_capital_letter_short_ah => 0x10409,
  :deseret_capital_letter_short_o => 0x1040a,
  :deseret_capital_letter_short_oo => 0x1040b,
  :deseret_capital_letter_ay => 0x1040c,
  :deseret_capital_letter_ow => 0x1040d,
  :deseret_capital_letter_wu => 0x1040e,
  :deseret_capital_letter_yee => 0x1040f,
  :deseret_capital_letter_h => 0x10410,
  :deseret_capital_letter_pee => 0x10411,
  :deseret_capital_letter_bee => 0x10412,
  :deseret_capital_letter_tee => 0x10413,
  :deseret_capital_letter_dee => 0x10414,
  :deseret_capital_letter_chee => 0x10415,
  :deseret_capital_letter_jee => 0x10416,
  :deseret_capital_letter_kay => 0x10417,
  :deseret_capital_letter_gay => 0x10418,
  :deseret_capital_letter_ef => 0x10419,
  :deseret_capital_letter_vee => 0x1041a,
  :deseret_capital_letter_eth => 0x1041b,
  :deseret_capital_letter_thee => 0x1041c,
  :deseret_capital_letter_es => 0x1041d,
  :deseret_capital_letter_zee => 0x1041e,
  :deseret_capital_letter_esh => 0x1041f,
  :deseret_capital_letter_zhee => 0x10420,
  :deseret_capital_letter_er => 0x10421,
  :deseret_capital_letter_el => 0x10422,
  :deseret_capital_letter_em => 0x10423,
  :deseret_capital_letter_en => 0x10424,
  :deseret_capital_letter_eng => 0x10425,
  :deseret_capital_letter_oi => 0x10426,
  :deseret_capital_letter_ew => 0x10427,
  :deseret_small_letter_long_i => 0x10428,
  :deseret_small_letter_long_e => 0x10429,
  :deseret_small_letter_long_a => 0x1042a,
  :deseret_small_letter_long_ah => 0x1042b,
  :deseret_small_letter_long_o => 0x1042c,
  :deseret_small_letter_long_oo => 0x1042d,
  :deseret_small_letter_short_i => 0x1042e,
  :deseret_small_letter_short_e => 0x1042f,
  :deseret_small_letter_short_a => 0x10430,
  :deseret_small_letter_short_ah => 0x10431,
  :deseret_small_letter_short_o => 0x10432,
  :deseret_small_letter_short_oo => 0x10433,
  :deseret_small_letter_ay => 0x10434,
  :deseret_small_letter_ow => 0x10435,
  :deseret_small_letter_wu => 0x10436,
  :deseret_small_letter_yee => 0x10437,
  :deseret_small_letter_h => 0x10438,
  :deseret_small_letter_pee => 0x10439,
  :deseret_small_letter_bee => 0x1043a,
  :deseret_small_letter_tee => 0x1043b,
  :deseret_small_letter_dee => 0x1043c,
  :deseret_small_letter_chee => 0x1043d,
  :deseret_small_letter_jee => 0x1043e,
  :deseret_small_letter_kay => 0x1043f,
  :deseret_small_letter_gay => 0x10440,
  :deseret_small_letter_ef => 0x10441,
  :deseret_small_letter_vee => 0x10442,
  :deseret_small_letter_eth => 0x10443,
  :deseret_small_letter_thee => 0x10444,
  :deseret_small_letter_es => 0x10445,
  :deseret_small_letter_zee => 0x10446,
  :deseret_small_letter_esh => 0x10447,
  :deseret_small_letter_zhee => 0x10448,
  :deseret_small_letter_er => 0x10449,
  :deseret_small_letter_el => 0x1044a,
  :deseret_small_letter_em => 0x1044b,
  :deseret_small_letter_en => 0x1044c,
  :deseret_small_letter_eng => 0x1044d,
  :deseret_small_letter_oi => 0x1044e,
  :deseret_small_letter_ew => 0x1044f,
  :shavian_letter_peep => 0x10450,
  :shavian_letter_tot => 0x10451,
  :shavian_letter_kick => 0x10452,
  :shavian_letter_fee => 0x10453,
  :shavian_letter_thigh => 0x10454,
  :shavian_letter_so => 0x10455,
  :shavian_letter_sure => 0x10456,
  :shavian_letter_church => 0x10457,
  :shavian_letter_yea => 0x10458,
  :shavian_letter_hung => 0x10459,
  :shavian_letter_bib => 0x1045a,
  :shavian_letter_dead => 0x1045b,
  :shavian_letter_gag => 0x1045c,
  :shavian_letter_vow => 0x1045d,
  :shavian_letter_they => 0x1045e,
  :shavian_letter_zoo => 0x1045f,
  :shavian_letter_measure => 0x10460,
  :shavian_letter_judge => 0x10461,
  :shavian_letter_woe => 0x10462,
  :shavian_letter_ha_ha => 0x10463,
  :shavian_letter_loll => 0x10464,
  :shavian_letter_mime => 0x10465,
  :shavian_letter_if => 0x10466,
  :shavian_letter_egg => 0x10467,
  :shavian_letter_ash => 0x10468,
  :shavian_letter_ado => 0x10469,
  :shavian_letter_on => 0x1046a,
  :shavian_letter_wool => 0x1046b,
  :shavian_letter_out => 0x1046c,
  :shavian_letter_ah => 0x1046d,
  :shavian_letter_roar => 0x1046e,
  :shavian_letter_nun => 0x1046f,
  :shavian_letter_eat => 0x10470,
  :shavian_letter_age => 0x10471,
  :shavian_letter_ice => 0x10472,
  :shavian_letter_up => 0x10473,
  :shavian_letter_oak => 0x10474,
  :shavian_letter_ooze => 0x10475,
  :shavian_letter_oil => 0x10476,
  :shavian_letter_awe => 0x10477,
  :shavian_letter_are => 0x10478,
  :shavian_letter_or => 0x10479,
  :shavian_letter_air => 0x1047a,
  :shavian_letter_err => 0x1047b,
  :shavian_letter_array => 0x1047c,
  :shavian_letter_ear => 0x1047d,
  :shavian_letter_ian => 0x1047e,
  :shavian_letter_yew => 0x1047f,
  :osmanya_letter_alef => 0x10480,
  :osmanya_letter_ba => 0x10481,
  :osmanya_letter_ta => 0x10482,
  :osmanya_letter_ja => 0x10483,
  :osmanya_letter_xa => 0x10484,
  :osmanya_letter_kha => 0x10485,
  :osmanya_letter_deel => 0x10486,
  :osmanya_letter_ra => 0x10487,
  :osmanya_letter_sa => 0x10488,
  :osmanya_letter_shiin => 0x10489,
  :osmanya_letter_dha => 0x1048a,
  :osmanya_letter_cayn => 0x1048b,
  :osmanya_letter_ga => 0x1048c,
  :osmanya_letter_fa => 0x1048d,
  :osmanya_letter_qaaf => 0x1048e,
  :osmanya_letter_kaaf => 0x1048f,
  :osmanya_letter_laan => 0x10490,
  :osmanya_letter_miin => 0x10491,
  :osmanya_letter_nuun => 0x10492,
  :osmanya_letter_waw => 0x10493,
  :osmanya_letter_ha => 0x10494,
  :osmanya_letter_ya => 0x10495,
  :osmanya_letter_a => 0x10496,
  :osmanya_letter_e => 0x10497,
  :osmanya_letter_i => 0x10498,
  :osmanya_letter_o => 0x10499,
  :osmanya_letter_u => 0x1049a,
  :osmanya_letter_aa => 0x1049b,
  :osmanya_letter_ee => 0x1049c,
  :osmanya_letter_oo => 0x1049d,
  :osmanya_digit_zero => 0x104a0,
  :osmanya_digit_one => 0x104a1,
  :osmanya_digit_two => 0x104a2,
  :osmanya_digit_three => 0x104a3,
  :osmanya_digit_four => 0x104a4,
  :osmanya_digit_five => 0x104a5,
  :osmanya_digit_six => 0x104a6,
  :osmanya_digit_seven => 0x104a7,
  :osmanya_digit_eight => 0x104a8,
  :osmanya_digit_nine => 0x104a9,
  :cypriot_syllable_a => 0x10800,
  :cypriot_syllable_e => 0x10801,
  :cypriot_syllable_i => 0x10802,
  :cypriot_syllable_o => 0x10803,
  :cypriot_syllable_u => 0x10804,
  :cypriot_syllable_ja => 0x10805,
  :cypriot_syllable_jo => 0x10808,
  :cypriot_syllable_ka => 0x1080a,
  :cypriot_syllable_ke => 0x1080b,
  :cypriot_syllable_ki => 0x1080c,
  :cypriot_syllable_ko => 0x1080d,
  :cypriot_syllable_ku => 0x1080e,
  :cypriot_syllable_la => 0x1080f,
  :cypriot_syllable_le => 0x10810,
  :cypriot_syllable_li => 0x10811,
  :cypriot_syllable_lo => 0x10812,
  :cypriot_syllable_lu => 0x10813,
  :cypriot_syllable_ma => 0x10814,
  :cypriot_syllable_me => 0x10815,
  :cypriot_syllable_mi => 0x10816,
  :cypriot_syllable_mo => 0x10817,
  :cypriot_syllable_mu => 0x10818,
  :cypriot_syllable_na => 0x10819,
  :cypriot_syllable_ne => 0x1081a,
  :cypriot_syllable_ni => 0x1081b,
  :cypriot_syllable_no => 0x1081c,
  :cypriot_syllable_nu => 0x1081d,
  :cypriot_syllable_pa => 0x1081e,
  :cypriot_syllable_pe => 0x1081f,
  :cypriot_syllable_pi => 0x10820,
  :cypriot_syllable_po => 0x10821,
  :cypriot_syllable_pu => 0x10822,
  :cypriot_syllable_ra => 0x10823,
  :cypriot_syllable_re => 0x10824,
  :cypriot_syllable_ri => 0x10825,
  :cypriot_syllable_ro => 0x10826,
  :cypriot_syllable_ru => 0x10827,
  :cypriot_syllable_sa => 0x10828,
  :cypriot_syllable_se => 0x10829,
  :cypriot_syllable_si => 0x1082a,
  :cypriot_syllable_so => 0x1082b,
  :cypriot_syllable_su => 0x1082c,
  :cypriot_syllable_ta => 0x1082d,
  :cypriot_syllable_te => 0x1082e,
  :cypriot_syllable_ti => 0x1082f,
  :cypriot_syllable_to => 0x10830,
  :cypriot_syllable_tu => 0x10831,
  :cypriot_syllable_wa => 0x10832,
  :cypriot_syllable_we => 0x10833,
  :cypriot_syllable_wi => 0x10834,
  :cypriot_syllable_wo => 0x10835,
  :cypriot_syllable_xa => 0x10837,
  :cypriot_syllable_xe => 0x10838,
  :cypriot_syllable_za => 0x1083c,
  :cypriot_syllable_zo => 0x1083f,
  :kharoshthi_letter_a => 0x10a00,
  :kharoshthi_vowel_sign_i => 0x10a01,
  :kharoshthi_vowel_sign_u => 0x10a02,
  :kharoshthi_vowel_sign_vocalic_r => 0x10a03,
  :kharoshthi_vowel_sign_e => 0x10a05,
  :kharoshthi_vowel_sign_o => 0x10a06,
  :kharoshthi_vowel_length_mark => 0x10a0c,
  :kharoshthi_sign_double_ring_below => 0x10a0d,
  :kharoshthi_sign_anusvara => 0x10a0e,
  :kharoshthi_sign_visarga => 0x10a0f,
  :kharoshthi_letter_ka => 0x10a10,
  :kharoshthi_letter_kha => 0x10a11,
  :kharoshthi_letter_ga => 0x10a12,
  :kharoshthi_letter_gha => 0x10a13,
  :kharoshthi_letter_ca => 0x10a15,
  :kharoshthi_letter_cha => 0x10a16,
  :kharoshthi_letter_ja => 0x10a17,
  :kharoshthi_letter_nya => 0x10a19,
  :kharoshthi_letter_tta => 0x10a1a,
  :kharoshthi_letter_ttha => 0x10a1b,
  :kharoshthi_letter_dda => 0x10a1c,
  :kharoshthi_letter_ddha => 0x10a1d,
  :kharoshthi_letter_nna => 0x10a1e,
  :kharoshthi_letter_ta => 0x10a1f,
  :kharoshthi_letter_tha => 0x10a20,
  :kharoshthi_letter_da => 0x10a21,
  :kharoshthi_letter_dha => 0x10a22,
  :kharoshthi_letter_na => 0x10a23,
  :kharoshthi_letter_pa => 0x10a24,
  :kharoshthi_letter_pha => 0x10a25,
  :kharoshthi_letter_ba => 0x10a26,
  :kharoshthi_letter_bha => 0x10a27,
  :kharoshthi_letter_ma => 0x10a28,
  :kharoshthi_letter_ya => 0x10a29,
  :kharoshthi_letter_ra => 0x10a2a,
  :kharoshthi_letter_la => 0x10a2b,
  :kharoshthi_letter_va => 0x10a2c,
  :kharoshthi_letter_sha => 0x10a2d,
  :kharoshthi_letter_ssa => 0x10a2e,
  :kharoshthi_letter_sa => 0x10a2f,
  :kharoshthi_letter_za => 0x10a30,
  :kharoshthi_letter_ha => 0x10a31,
  :kharoshthi_letter_kka => 0x10a32,
  :kharoshthi_letter_tttha => 0x10a33,
  :kharoshthi_sign_bar_above => 0x10a38,
  :kharoshthi_sign_cauda => 0x10a39,
  :kharoshthi_sign_dot_below => 0x10a3a,
  :kharoshthi_virama => 0x10a3f,
  :kharoshthi_digit_one => 0x10a40,
  :kharoshthi_digit_two => 0x10a41,
  :kharoshthi_digit_three => 0x10a42,
  :kharoshthi_digit_four => 0x10a43,
  :kharoshthi_number_ten => 0x10a44,
  :kharoshthi_number_twenty => 0x10a45,
  :kharoshthi_number_one_hundred => 0x10a46,
  :kharoshthi_number_one_thousand => 0x10a47,
  :kharoshthi_punctuation_dot => 0x10a50,
  :kharoshthi_punctuation_small_circle => 0x10a51,
  :kharoshthi_punctuation_circle => 0x10a52,
  :kharoshthi_punctuation_crescent_bar => 0x10a53,
  :kharoshthi_punctuation_mangalam => 0x10a54,
  :kharoshthi_punctuation_lotus => 0x10a55,
  :kharoshthi_punctuation_danda => 0x10a56,
  :kharoshthi_punctuation_double_danda => 0x10a57,
  :kharoshthi_punctuation_lines => 0x10a58,
  :byzantine_musical_symbol_psili => 0x1d000,
  :byzantine_musical_symbol_daseia => 0x1d001,
  :byzantine_musical_symbol_perispomeni => 0x1d002,
  :byzantine_musical_symbol_oxeia_ekfonitikon => 0x1d003,
  :byzantine_musical_symbol_oxeia_dipli => 0x1d004,
  :byzantine_musical_symbol_vareia_ekfonitikon => 0x1d005,
  :byzantine_musical_symbol_vareia_dipli => 0x1d006,
  :byzantine_musical_symbol_kathisti => 0x1d007,
  :byzantine_musical_symbol_syrmatiki => 0x1d008,
  :byzantine_musical_symbol_paraklitiki => 0x1d009,
  :byzantine_musical_symbol_ypokrisis => 0x1d00a,
  :byzantine_musical_symbol_ypokrisis_dipli => 0x1d00b,
  :byzantine_musical_symbol_kremasti => 0x1d00c,
  :byzantine_musical_symbol_apeso_ekfonitikon => 0x1d00d,
  :byzantine_musical_symbol_exo_ekfonitikon => 0x1d00e,
  :byzantine_musical_symbol_teleia => 0x1d00f,
  :byzantine_musical_symbol_kentimata => 0x1d010,
  :byzantine_musical_symbol_apostrofos => 0x1d011,
  :byzantine_musical_symbol_apostrofos_dipli => 0x1d012,
  :byzantine_musical_symbol_synevma => 0x1d013,
  :byzantine_musical_symbol_thita => 0x1d014,
  :byzantine_musical_symbol_oligon_archaion => 0x1d015,
  :byzantine_musical_symbol_gorgon_archaion => 0x1d016,
  :byzantine_musical_symbol_psilon => 0x1d017,
  :byzantine_musical_symbol_chamilon => 0x1d018,
  :byzantine_musical_symbol_vathy => 0x1d019,
  :byzantine_musical_symbol_ison_archaion => 0x1d01a,
  :byzantine_musical_symbol_kentima_archaion => 0x1d01b,
  :byzantine_musical_symbol_kentimata_archaion => 0x1d01c,
  :byzantine_musical_symbol_saximata => 0x1d01d,
  :byzantine_musical_symbol_parichon => 0x1d01e,
  :byzantine_musical_symbol_stavros_apodexia => 0x1d01f,
  :byzantine_musical_symbol_oxeiai_archaion => 0x1d020,
  :byzantine_musical_symbol_vareiai_archaion => 0x1d021,
  :byzantine_musical_symbol_apoderma_archaion => 0x1d022,
  :byzantine_musical_symbol_apothema => 0x1d023,
  :byzantine_musical_symbol_klasma => 0x1d024,
  :byzantine_musical_symbol_revma => 0x1d025,
  :byzantine_musical_symbol_piasma_archaion => 0x1d026,
  :byzantine_musical_symbol_tinagma => 0x1d027,
  :byzantine_musical_symbol_anatrichisma => 0x1d028,
  :byzantine_musical_symbol_seisma => 0x1d029,
  :byzantine_musical_symbol_synagma_archaion => 0x1d02a,
  :byzantine_musical_symbol_synagma_meta_stavrou => 0x1d02b,
  :byzantine_musical_symbol_oyranisma_archaion => 0x1d02c,
  :byzantine_musical_symbol_thema => 0x1d02d,
  :byzantine_musical_symbol_lemoi => 0x1d02e,
  :byzantine_musical_symbol_dyo => 0x1d02f,
  :byzantine_musical_symbol_tria => 0x1d030,
  :byzantine_musical_symbol_tessera => 0x1d031,
  :byzantine_musical_symbol_kratimata => 0x1d032,
  :byzantine_musical_symbol_apeso_exo_neo => 0x1d033,
  :byzantine_musical_symbol_fthora_archaion => 0x1d034,
  :byzantine_musical_symbol_imifthora => 0x1d035,
  :byzantine_musical_symbol_tromikon_archaion => 0x1d036,
  :byzantine_musical_symbol_katava_tromikon => 0x1d037,
  :byzantine_musical_symbol_pelaston => 0x1d038,
  :byzantine_musical_symbol_psifiston => 0x1d039,
  :byzantine_musical_symbol_kontevma => 0x1d03a,
  :byzantine_musical_symbol_chorevma_archaion => 0x1d03b,
  :byzantine_musical_symbol_rapisma => 0x1d03c,
  :byzantine_musical_symbol_parakalesma_archaion => 0x1d03d,
  :byzantine_musical_symbol_paraklitiki_archaion => 0x1d03e,
  :byzantine_musical_symbol_ichadin => 0x1d03f,
  :byzantine_musical_symbol_nana => 0x1d040,
  :byzantine_musical_symbol_petasma => 0x1d041,
  :byzantine_musical_symbol_kontevma_allo => 0x1d042,
  :byzantine_musical_symbol_tromikon_allo => 0x1d043,
  :byzantine_musical_symbol_straggismata => 0x1d044,
  :byzantine_musical_symbol_gronthismata => 0x1d045,
  :byzantine_musical_symbol_ison_neo => 0x1d046,
  :byzantine_musical_symbol_oligon_neo => 0x1d047,
  :byzantine_musical_symbol_oxeia_neo => 0x1d048,
  :byzantine_musical_symbol_petasti => 0x1d049,
  :byzantine_musical_symbol_koufisma => 0x1d04a,
  :byzantine_musical_symbol_petastokoufisma => 0x1d04b,
  :byzantine_musical_symbol_kratimokoufisma => 0x1d04c,
  :byzantine_musical_symbol_pelaston_neo => 0x1d04d,
  :byzantine_musical_symbol_kentimata_neo_ano => 0x1d04e,
  :byzantine_musical_symbol_kentima_neo_ano => 0x1d04f,
  :byzantine_musical_symbol_ypsili => 0x1d050,
  :byzantine_musical_symbol_apostrofos_neo => 0x1d051,
  :byzantine_musical_symbol_apostrofoi_syndesmos_neo => 0x1d052,
  :byzantine_musical_symbol_yporroi => 0x1d053,
  :byzantine_musical_symbol_kratimoyporroon => 0x1d054,
  :byzantine_musical_symbol_elafron => 0x1d055,
  :byzantine_musical_symbol_chamili => 0x1d056,
  :byzantine_musical_symbol_mikron_ison => 0x1d057,
  :byzantine_musical_symbol_vareia_neo => 0x1d058,
  :byzantine_musical_symbol_piasma_neo => 0x1d059,
  :byzantine_musical_symbol_psifiston_neo => 0x1d05a,
  :byzantine_musical_symbol_omalon => 0x1d05b,
  :byzantine_musical_symbol_antikenoma => 0x1d05c,
  :byzantine_musical_symbol_lygisma => 0x1d05d,
  :byzantine_musical_symbol_paraklitiki_neo => 0x1d05e,
  :byzantine_musical_symbol_parakalesma_neo => 0x1d05f,
  :byzantine_musical_symbol_eteron_parakalesma => 0x1d060,
  :byzantine_musical_symbol_kylisma => 0x1d061,
  :byzantine_musical_symbol_antikenokylisma => 0x1d062,
  :byzantine_musical_symbol_tromikon_neo => 0x1d063,
  :byzantine_musical_symbol_ekstrepton => 0x1d064,
  :byzantine_musical_symbol_synagma_neo => 0x1d065,
  :byzantine_musical_symbol_syrma => 0x1d066,
  :byzantine_musical_symbol_chorevma_neo => 0x1d067,
  :byzantine_musical_symbol_epegerma => 0x1d068,
  :byzantine_musical_symbol_seisma_neo => 0x1d069,
  :byzantine_musical_symbol_xiron_klasma => 0x1d06a,
  :byzantine_musical_symbol_tromikopsifiston => 0x1d06b,
  :byzantine_musical_symbol_psifistolygisma => 0x1d06c,
  :byzantine_musical_symbol_tromikolygisma => 0x1d06d,
  :byzantine_musical_symbol_tromikoparakalesma => 0x1d06e,
  :byzantine_musical_symbol_psifistoparakalesma => 0x1d06f,
  :byzantine_musical_symbol_tromikosynagma => 0x1d070,
  :byzantine_musical_symbol_psifistosynagma => 0x1d071,
  :byzantine_musical_symbol_gorgosyntheton => 0x1d072,
  :byzantine_musical_symbol_argosyntheton => 0x1d073,
  :byzantine_musical_symbol_eteron_argosyntheton => 0x1d074,
  :byzantine_musical_symbol_oyranisma_neo => 0x1d075,
  :byzantine_musical_symbol_thematismos_eso => 0x1d076,
  :byzantine_musical_symbol_thematismos_exo => 0x1d077,
  :byzantine_musical_symbol_thema_aploun => 0x1d078,
  :byzantine_musical_symbol_thes_kai_apothes => 0x1d079,
  :byzantine_musical_symbol_katavasma => 0x1d07a,
  :byzantine_musical_symbol_endofonon => 0x1d07b,
  :byzantine_musical_symbol_yfen_kato => 0x1d07c,
  :byzantine_musical_symbol_yfen_ano => 0x1d07d,
  :byzantine_musical_symbol_stavros => 0x1d07e,
  :byzantine_musical_symbol_klasma_ano => 0x1d07f,
  :byzantine_musical_symbol_dipli_archaion => 0x1d080,
  :byzantine_musical_symbol_kratima_archaion => 0x1d081,
  :byzantine_musical_symbol_kratima_allo => 0x1d082,
  :byzantine_musical_symbol_kratima_neo => 0x1d083,
  :byzantine_musical_symbol_apoderma_neo => 0x1d084,
  :byzantine_musical_symbol_apli => 0x1d085,
  :byzantine_musical_symbol_dipli => 0x1d086,
  :byzantine_musical_symbol_tripli => 0x1d087,
  :byzantine_musical_symbol_tetrapli => 0x1d088,
  :byzantine_musical_symbol_koronis => 0x1d089,
  :byzantine_musical_symbol_leimma_enos_chronou => 0x1d08a,
  :byzantine_musical_symbol_leimma_dyo_chronon => 0x1d08b,
  :byzantine_musical_symbol_leimma_trion_chronon => 0x1d08c,
  :byzantine_musical_symbol_leimma_tessaron_chronon => 0x1d08d,
  :byzantine_musical_symbol_leimma_imiseos_chronou => 0x1d08e,
  :byzantine_musical_symbol_gorgon_neo_ano => 0x1d08f,
  :byzantine_musical_symbol_gorgon_parestigmenon_aristera => 0x1d090,
  :byzantine_musical_symbol_gorgon_parestigmenon_dexia => 0x1d091,
  :byzantine_musical_symbol_digorgon => 0x1d092,
  :byzantine_musical_symbol_digorgon_parestigmenon_aristera_kato => 0x1d093,
  :byzantine_musical_symbol_digorgon_parestigmenon_aristera_ano => 0x1d094,
  :byzantine_musical_symbol_digorgon_parestigmenon_dexia => 0x1d095,
  :byzantine_musical_symbol_trigorgon => 0x1d096,
  :byzantine_musical_symbol_argon => 0x1d097,
  :byzantine_musical_symbol_imidiargon => 0x1d098,
  :byzantine_musical_symbol_diargon => 0x1d099,
  :byzantine_musical_symbol_agogi_poli_argi => 0x1d09a,
  :byzantine_musical_symbol_agogi_argoteri => 0x1d09b,
  :byzantine_musical_symbol_agogi_argi => 0x1d09c,
  :byzantine_musical_symbol_agogi_metria => 0x1d09d,
  :byzantine_musical_symbol_agogi_mesi => 0x1d09e,
  :byzantine_musical_symbol_agogi_gorgi => 0x1d09f,
  :byzantine_musical_symbol_agogi_gorgoteri => 0x1d0a0,
  :byzantine_musical_symbol_agogi_poli_gorgi => 0x1d0a1,
  :byzantine_musical_symbol_martyria_protos_ichos => 0x1d0a2,
  :byzantine_musical_symbol_martyria_alli_protos_ichos => 0x1d0a3,
  :byzantine_musical_symbol_martyria_deyteros_ichos => 0x1d0a4,
  :byzantine_musical_symbol_martyria_alli_deyteros_ichos => 0x1d0a5,
  :byzantine_musical_symbol_martyria_tritos_ichos => 0x1d0a6,
  :byzantine_musical_symbol_martyria_trifonias => 0x1d0a7,
  :byzantine_musical_symbol_martyria_tetartos_ichos => 0x1d0a8,
  :byzantine_musical_symbol_martyria_tetartos_legetos_ichos => 0x1d0a9,
  :byzantine_musical_symbol_martyria_legetos_ichos => 0x1d0aa,
  :byzantine_musical_symbol_martyria_plagios_ichos => 0x1d0ab,
  :byzantine_musical_symbol_isakia_telous_ichimatos => 0x1d0ac,
  :byzantine_musical_symbol_apostrofoi_telous_ichimatos => 0x1d0ad,
  :byzantine_musical_symbol_fanerosis_tetrafonias => 0x1d0ae,
  :byzantine_musical_symbol_fanerosis_monofonias => 0x1d0af,
  :byzantine_musical_symbol_fanerosis_difonias => 0x1d0b0,
  :byzantine_musical_symbol_martyria_varys_ichos => 0x1d0b1,
  :byzantine_musical_symbol_martyria_protovarys_ichos => 0x1d0b2,
  :byzantine_musical_symbol_martyria_plagios_tetartos_ichos => 0x1d0b3,
  :byzantine_musical_symbol_gorthmikon_n_aploun => 0x1d0b4,
  :byzantine_musical_symbol_gorthmikon_n_diploun => 0x1d0b5,
  :byzantine_musical_symbol_enarxis_kai_fthora_vou => 0x1d0b6,
  :byzantine_musical_symbol_imifonon => 0x1d0b7,
  :byzantine_musical_symbol_imifthoron => 0x1d0b8,
  :byzantine_musical_symbol_fthora_archaion_deyterou_ichou => 0x1d0b9,
  :byzantine_musical_symbol_fthora_diatoniki_pa => 0x1d0ba,
  :byzantine_musical_symbol_fthora_diatoniki_nana => 0x1d0bb,
  :byzantine_musical_symbol_fthora_naos_ichos => 0x1d0bc,
  :byzantine_musical_symbol_fthora_diatoniki_di => 0x1d0bd,
  :byzantine_musical_symbol_fthora_skliron_diatonon_di => 0x1d0be,
  :byzantine_musical_symbol_fthora_diatoniki_ke => 0x1d0bf,
  :byzantine_musical_symbol_fthora_diatoniki_zo => 0x1d0c0,
  :byzantine_musical_symbol_fthora_diatoniki_ni_kato => 0x1d0c1,
  :byzantine_musical_symbol_fthora_diatoniki_ni_ano => 0x1d0c2,
  :byzantine_musical_symbol_fthora_malakon_chroma_difonias => 0x1d0c3,
  :byzantine_musical_symbol_fthora_malakon_chroma_monofonias => 0x1d0c4,
  :byzantine_musical_symbol_fhtora_skliron_chroma_vasis => 0x1d0c5,
  :byzantine_musical_symbol_fthora_skliron_chroma_synafi => 0x1d0c6,
  :byzantine_musical_symbol_fthora_nenano => 0x1d0c7,
  :byzantine_musical_symbol_chroa_zygos => 0x1d0c8,
  :byzantine_musical_symbol_chroa_kliton => 0x1d0c9,
  :byzantine_musical_symbol_chroa_spathi => 0x1d0ca,
  :byzantine_musical_symbol_fthora_i_yfesis_tetartimorion => 0x1d0cb,
  :byzantine_musical_symbol_fthora_enarmonios_antifonia => 0x1d0cc,
  :byzantine_musical_symbol_yfesis_tritimorion => 0x1d0cd,
  :byzantine_musical_symbol_diesis_tritimorion => 0x1d0ce,
  :byzantine_musical_symbol_diesis_tetartimorion => 0x1d0cf,
  :byzantine_musical_symbol_diesis_apli_dyo_dodekata => 0x1d0d0,
  :byzantine_musical_symbol_diesis_monogrammos_tessera_dodekata => 0x1d0d1,
  :byzantine_musical_symbol_diesis_digrammos_ex_dodekata => 0x1d0d2,
  :byzantine_musical_symbol_diesis_trigrammos_okto_dodekata => 0x1d0d3,
  :byzantine_musical_symbol_yfesis_apli_dyo_dodekata => 0x1d0d4,
  :byzantine_musical_symbol_yfesis_monogrammos_tessera_dodekata => 0x1d0d5,
  :byzantine_musical_symbol_yfesis_digrammos_ex_dodekata => 0x1d0d6,
  :byzantine_musical_symbol_yfesis_trigrammos_okto_dodekata => 0x1d0d7,
  :byzantine_musical_symbol_geniki_diesis => 0x1d0d8,
  :byzantine_musical_symbol_geniki_yfesis => 0x1d0d9,
  :byzantine_musical_symbol_diastoli_apli_mikri => 0x1d0da,
  :byzantine_musical_symbol_diastoli_apli_megali => 0x1d0db,
  :byzantine_musical_symbol_diastoli_dipli => 0x1d0dc,
  :byzantine_musical_symbol_diastoli_theseos => 0x1d0dd,
  :byzantine_musical_symbol_simansis_theseos => 0x1d0de,
  :byzantine_musical_symbol_simansis_theseos_disimou => 0x1d0df,
  :byzantine_musical_symbol_simansis_theseos_trisimou => 0x1d0e0,
  :byzantine_musical_symbol_simansis_theseos_tetrasimou => 0x1d0e1,
  :byzantine_musical_symbol_simansis_arseos => 0x1d0e2,
  :byzantine_musical_symbol_simansis_arseos_disimou => 0x1d0e3,
  :byzantine_musical_symbol_simansis_arseos_trisimou => 0x1d0e4,
  :byzantine_musical_symbol_simansis_arseos_tetrasimou => 0x1d0e5,
  :byzantine_musical_symbol_digramma_gg => 0x1d0e6,
  :byzantine_musical_symbol_diftoggos_ou => 0x1d0e7,
  :byzantine_musical_symbol_stigma => 0x1d0e8,
  :byzantine_musical_symbol_arktiko_pa => 0x1d0e9,
  :byzantine_musical_symbol_arktiko_vou => 0x1d0ea,
  :byzantine_musical_symbol_arktiko_ga => 0x1d0eb,
  :byzantine_musical_symbol_arktiko_di => 0x1d0ec,
  :byzantine_musical_symbol_arktiko_ke => 0x1d0ed,
  :byzantine_musical_symbol_arktiko_zo => 0x1d0ee,
  :byzantine_musical_symbol_arktiko_ni => 0x1d0ef,
  :byzantine_musical_symbol_kentimata_neo_meso => 0x1d0f0,
  :byzantine_musical_symbol_kentima_neo_meso => 0x1d0f1,
  :byzantine_musical_symbol_kentimata_neo_kato => 0x1d0f2,
  :byzantine_musical_symbol_kentima_neo_kato => 0x1d0f3,
  :byzantine_musical_symbol_klasma_kato => 0x1d0f4,
  :byzantine_musical_symbol_gorgon_neo_kato => 0x1d0f5,
  :musical_symbol_single_barline => 0x1d100,
  :musical_symbol_double_barline => 0x1d101,
  :musical_symbol_final_barline => 0x1d102,
  :musical_symbol_reverse_final_barline => 0x1d103,
  :musical_symbol_dashed_barline => 0x1d104,
  :musical_symbol_short_barline => 0x1d105,
  :musical_symbol_left_repeat_sign => 0x1d106,
  :musical_symbol_right_repeat_sign => 0x1d107,
  :musical_symbol_repeat_dots => 0x1d108,
  :musical_symbol_dal_segno => 0x1d109,
  :musical_symbol_da_capo => 0x1d10a,
  :musical_symbol_segno => 0x1d10b,
  :musical_symbol_coda => 0x1d10c,
  :musical_symbol_repeated_figure_1 => 0x1d10d,
  :musical_symbol_repeated_figure_2 => 0x1d10e,
  :musical_symbol_repeated_figure_3 => 0x1d10f,
  :musical_symbol_fermata => 0x1d110,
  :musical_symbol_fermata_below => 0x1d111,
  :musical_symbol_breath_mark => 0x1d112,
  :musical_symbol_caesura => 0x1d113,
  :musical_symbol_brace => 0x1d114,
  :musical_symbol_bracket => 0x1d115,
  :musical_symbol_one_line_staff => 0x1d116,
  :musical_symbol_two_line_staff => 0x1d117,
  :musical_symbol_three_line_staff => 0x1d118,
  :musical_symbol_four_line_staff => 0x1d119,
  :musical_symbol_five_line_staff => 0x1d11a,
  :musical_symbol_six_line_staff => 0x1d11b,
  :musical_symbol_six_string_fretboard => 0x1d11c,
  :musical_symbol_four_string_fretboard => 0x1d11d,
  :musical_symbol_g_clef => 0x1d11e,
  :musical_symbol_g_clef_ottava_alta => 0x1d11f,
  :musical_symbol_g_clef_ottava_bassa => 0x1d120,
  :musical_symbol_c_clef => 0x1d121,
  :musical_symbol_f_clef => 0x1d122,
  :musical_symbol_f_clef_ottava_alta => 0x1d123,
  :musical_symbol_f_clef_ottava_bassa => 0x1d124,
  :musical_symbol_drum_clef_1 => 0x1d125,
  :musical_symbol_drum_clef_2 => 0x1d126,
  :musical_symbol_double_sharp => 0x1d12a,
  :musical_symbol_double_flat => 0x1d12b,
  :musical_symbol_flat_up => 0x1d12c,
  :musical_symbol_flat_down => 0x1d12d,
  :musical_symbol_natural_up => 0x1d12e,
  :musical_symbol_natural_down => 0x1d12f,
  :musical_symbol_sharp_up => 0x1d130,
  :musical_symbol_sharp_down => 0x1d131,
  :musical_symbol_quarter_tone_sharp => 0x1d132,
  :musical_symbol_quarter_tone_flat => 0x1d133,
  :musical_symbol_common_time => 0x1d134,
  :musical_symbol_cut_time => 0x1d135,
  :musical_symbol_ottava_alta => 0x1d136,
  :musical_symbol_ottava_bassa => 0x1d137,
  :musical_symbol_quindicesima_alta => 0x1d138,
  :musical_symbol_quindicesima_bassa => 0x1d139,
  :musical_symbol_multi_rest => 0x1d13a,
  :musical_symbol_whole_rest => 0x1d13b,
  :musical_symbol_half_rest => 0x1d13c,
  :musical_symbol_quarter_rest => 0x1d13d,
  :musical_symbol_eighth_rest => 0x1d13e,
  :musical_symbol_sixteenth_rest => 0x1d13f,
  :musical_symbol_thirty_second_rest => 0x1d140,
  :musical_symbol_sixty_fourth_rest => 0x1d141,
  :musical_symbol_one_hundred_twenty_eighth_rest => 0x1d142,
  :musical_symbol_x_notehead => 0x1d143,
  :musical_symbol_plus_notehead => 0x1d144,
  :musical_symbol_circle_x_notehead => 0x1d145,
  :musical_symbol_square_notehead_white => 0x1d146,
  :musical_symbol_square_notehead_black => 0x1d147,
  :musical_symbol_triangle_notehead_up_white => 0x1d148,
  :musical_symbol_triangle_notehead_up_black => 0x1d149,
  :musical_symbol_triangle_notehead_left_white => 0x1d14a,
  :musical_symbol_triangle_notehead_left_black => 0x1d14b,
  :musical_symbol_triangle_notehead_right_white => 0x1d14c,
  :musical_symbol_triangle_notehead_right_black => 0x1d14d,
  :musical_symbol_triangle_notehead_down_white => 0x1d14e,
  :musical_symbol_triangle_notehead_down_black => 0x1d14f,
  :musical_symbol_triangle_notehead_up_right_white => 0x1d150,
  :musical_symbol_triangle_notehead_up_right_black => 0x1d151,
  :musical_symbol_moon_notehead_white => 0x1d152,
  :musical_symbol_moon_notehead_black => 0x1d153,
  :musical_symbol_triangle_round_notehead_down_white => 0x1d154,
  :musical_symbol_triangle_round_notehead_down_black => 0x1d155,
  :musical_symbol_parenthesis_notehead => 0x1d156,
  :musical_symbol_void_notehead => 0x1d157,
  :musical_symbol_notehead_black => 0x1d158,
  :musical_symbol_null_notehead => 0x1d159,
  :musical_symbol_cluster_notehead_white => 0x1d15a,
  :musical_symbol_cluster_notehead_black => 0x1d15b,
  :musical_symbol_breve => 0x1d15c,
  :musical_symbol_whole_note => 0x1d15d,
  :musical_symbol_half_note => 0x1d15e,
  :musical_symbol_quarter_note => 0x1d15f,
  :musical_symbol_eighth_note => 0x1d160,
  :musical_symbol_sixteenth_note => 0x1d161,
  :musical_symbol_thirty_second_note => 0x1d162,
  :musical_symbol_sixty_fourth_note => 0x1d163,
  :musical_symbol_one_hundred_twenty_eighth_note => 0x1d164,
  :musical_symbol_combining_stem => 0x1d165,
  :musical_symbol_combining_sprechgesang_stem => 0x1d166,
  :musical_symbol_combining_tremolo_1 => 0x1d167,
  :musical_symbol_combining_tremolo_2 => 0x1d168,
  :musical_symbol_combining_tremolo_3 => 0x1d169,
  :musical_symbol_fingered_tremolo_1 => 0x1d16a,
  :musical_symbol_fingered_tremolo_2 => 0x1d16b,
  :musical_symbol_fingered_tremolo_3 => 0x1d16c,
  :musical_symbol_combining_augmentation_dot => 0x1d16d,
  :musical_symbol_combining_flag_1 => 0x1d16e,
  :musical_symbol_combining_flag_2 => 0x1d16f,
  :musical_symbol_combining_flag_3 => 0x1d170,
  :musical_symbol_combining_flag_4 => 0x1d171,
  :musical_symbol_combining_flag_5 => 0x1d172,
  :musical_symbol_begin_beam => 0x1d173,
  :musical_symbol_end_beam => 0x1d174,
  :musical_symbol_begin_tie => 0x1d175,
  :musical_symbol_end_tie => 0x1d176,
  :musical_symbol_begin_slur => 0x1d177,
  :musical_symbol_end_slur => 0x1d178,
  :musical_symbol_begin_phrase => 0x1d179,
  :musical_symbol_end_phrase => 0x1d17a,
  :musical_symbol_combining_accent => 0x1d17b,
  :musical_symbol_combining_staccato => 0x1d17c,
  :musical_symbol_combining_tenuto => 0x1d17d,
  :musical_symbol_combining_staccatissimo => 0x1d17e,
  :musical_symbol_combining_marcato => 0x1d17f,
  :musical_symbol_combining_marcato_staccato => 0x1d180,
  :musical_symbol_combining_accent_staccato => 0x1d181,
  :musical_symbol_combining_loure => 0x1d182,
  :musical_symbol_arpeggiato_up => 0x1d183,
  :musical_symbol_arpeggiato_down => 0x1d184,
  :musical_symbol_combining_doit => 0x1d185,
  :musical_symbol_combining_rip => 0x1d186,
  :musical_symbol_combining_flip => 0x1d187,
  :musical_symbol_combining_smear => 0x1d188,
  :musical_symbol_combining_bend => 0x1d189,
  :musical_symbol_combining_double_tongue => 0x1d18a,
  :musical_symbol_combining_triple_tongue => 0x1d18b,
  :musical_symbol_rinforzando => 0x1d18c,
  :musical_symbol_subito => 0x1d18d,
  :musical_symbol_z => 0x1d18e,
  :musical_symbol_piano => 0x1d18f,
  :musical_symbol_mezzo => 0x1d190,
  :musical_symbol_forte => 0x1d191,
  :musical_symbol_crescendo => 0x1d192,
  :musical_symbol_decrescendo => 0x1d193,
  :musical_symbol_grace_note_slash => 0x1d194,
  :musical_symbol_grace_note_no_slash => 0x1d195,
  :musical_symbol_tr => 0x1d196,
  :musical_symbol_turn => 0x1d197,
  :musical_symbol_inverted_turn => 0x1d198,
  :musical_symbol_turn_slash => 0x1d199,
  :musical_symbol_turn_up => 0x1d19a,
  :musical_symbol_ornament_stroke_1 => 0x1d19b,
  :musical_symbol_ornament_stroke_2 => 0x1d19c,
  :musical_symbol_ornament_stroke_3 => 0x1d19d,
  :musical_symbol_ornament_stroke_4 => 0x1d19e,
  :musical_symbol_ornament_stroke_5 => 0x1d19f,
  :musical_symbol_ornament_stroke_6 => 0x1d1a0,
  :musical_symbol_ornament_stroke_7 => 0x1d1a1,
  :musical_symbol_ornament_stroke_8 => 0x1d1a2,
  :musical_symbol_ornament_stroke_9 => 0x1d1a3,
  :musical_symbol_ornament_stroke_10 => 0x1d1a4,
  :musical_symbol_ornament_stroke_11 => 0x1d1a5,
  :musical_symbol_hauptstimme => 0x1d1a6,
  :musical_symbol_nebenstimme => 0x1d1a7,
  :musical_symbol_end_of_stimme => 0x1d1a8,
  :musical_symbol_degree_slash => 0x1d1a9,
  :musical_symbol_combining_down_bow => 0x1d1aa,
  :musical_symbol_combining_up_bow => 0x1d1ab,
  :musical_symbol_combining_harmonic => 0x1d1ac,
  :musical_symbol_combining_snap_pizzicato => 0x1d1ad,
  :musical_symbol_pedal_mark => 0x1d1ae,
  :musical_symbol_pedal_up_mark => 0x1d1af,
  :musical_symbol_half_pedal_mark => 0x1d1b0,
  :musical_symbol_glissando_up => 0x1d1b1,
  :musical_symbol_glissando_down => 0x1d1b2,
  :musical_symbol_with_fingernails => 0x1d1b3,
  :musical_symbol_damp => 0x1d1b4,
  :musical_symbol_damp_all => 0x1d1b5,
  :musical_symbol_maxima => 0x1d1b6,
  :musical_symbol_longa => 0x1d1b7,
  :musical_symbol_brevis => 0x1d1b8,
  :musical_symbol_semibrevis_white => 0x1d1b9,
  :musical_symbol_semibrevis_black => 0x1d1ba,
  :musical_symbol_minima => 0x1d1bb,
  :musical_symbol_minima_black => 0x1d1bc,
  :musical_symbol_semiminima_white => 0x1d1bd,
  :musical_symbol_semiminima_black => 0x1d1be,
  :musical_symbol_fusa_white => 0x1d1bf,
  :musical_symbol_fusa_black => 0x1d1c0,
  :musical_symbol_longa_perfecta_rest => 0x1d1c1,
  :musical_symbol_longa_imperfecta_rest => 0x1d1c2,
  :musical_symbol_brevis_rest => 0x1d1c3,
  :musical_symbol_semibrevis_rest => 0x1d1c4,
  :musical_symbol_minima_rest => 0x1d1c5,
  :musical_symbol_semiminima_rest => 0x1d1c6,
  :musical_symbol_tempus_perfectum_cum_prolatione_perfecta => 0x1d1c7,
  :musical_symbol_tempus_perfectum_cum_prolatione_imperfecta => 0x1d1c8,
  :musical_symbol_tempus_perfectum_cum_prolatione_perfecta_diminution_1 => 0x1d1c9,
  :musical_symbol_tempus_imperfectum_cum_prolatione_perfecta => 0x1d1ca,
  :musical_symbol_tempus_imperfectum_cum_prolatione_imperfecta => 0x1d1cb,
  :musical_symbol_tempus_imperfectum_cum_prolatione_imperfecta_diminution_1 => 0x1d1cc,
  :musical_symbol_tempus_imperfectum_cum_prolatione_imperfecta_diminution_2 => 0x1d1cd,
  :musical_symbol_tempus_imperfectum_cum_prolatione_imperfecta_diminution_3 => 0x1d1ce,
  :musical_symbol_croix => 0x1d1cf,
  :musical_symbol_gregorian_c_clef => 0x1d1d0,
  :musical_symbol_gregorian_f_clef => 0x1d1d1,
  :musical_symbol_square_b => 0x1d1d2,
  :musical_symbol_virga => 0x1d1d3,
  :musical_symbol_podatus => 0x1d1d4,
  :musical_symbol_clivis => 0x1d1d5,
  :musical_symbol_scandicus => 0x1d1d6,
  :musical_symbol_climacus => 0x1d1d7,
  :musical_symbol_torculus => 0x1d1d8,
  :musical_symbol_porrectus => 0x1d1d9,
  :musical_symbol_porrectus_flexus => 0x1d1da,
  :musical_symbol_scandicus_flexus => 0x1d1db,
  :musical_symbol_torculus_resupinus => 0x1d1dc,
  :musical_symbol_pes_subpunctis => 0x1d1dd,
  :greek_vocal_notation_symbol_1 => 0x1d200,
  :greek_vocal_notation_symbol_2 => 0x1d201,
  :greek_vocal_notation_symbol_3 => 0x1d202,
  :greek_vocal_notation_symbol_4 => 0x1d203,
  :greek_vocal_notation_symbol_5 => 0x1d204,
  :greek_vocal_notation_symbol_6 => 0x1d205,
  :greek_vocal_notation_symbol_7 => 0x1d206,
  :greek_vocal_notation_symbol_8 => 0x1d207,
  :greek_vocal_notation_symbol_9 => 0x1d208,
  :greek_vocal_notation_symbol_10 => 0x1d209,
  :greek_vocal_notation_symbol_11 => 0x1d20a,
  :greek_vocal_notation_symbol_12 => 0x1d20b,
  :greek_vocal_notation_symbol_13 => 0x1d20c,
  :greek_vocal_notation_symbol_14 => 0x1d20d,
  :greek_vocal_notation_symbol_15 => 0x1d20e,
  :greek_vocal_notation_symbol_16 => 0x1d20f,
  :greek_vocal_notation_symbol_17 => 0x1d210,
  :greek_vocal_notation_symbol_18 => 0x1d211,
  :greek_vocal_notation_symbol_19 => 0x1d212,
  :greek_vocal_notation_symbol_20 => 0x1d213,
  :greek_vocal_notation_symbol_21 => 0x1d214,
  :greek_vocal_notation_symbol_22 => 0x1d215,
  :greek_vocal_notation_symbol_23 => 0x1d216,
  :greek_vocal_notation_symbol_24 => 0x1d217,
  :greek_vocal_notation_symbol_50 => 0x1d218,
  :greek_vocal_notation_symbol_51 => 0x1d219,
  :greek_vocal_notation_symbol_52 => 0x1d21a,
  :greek_vocal_notation_symbol_53 => 0x1d21b,
  :greek_vocal_notation_symbol_54 => 0x1d21c,
  :greek_instrumental_notation_symbol_1 => 0x1d21d,
  :greek_instrumental_notation_symbol_2 => 0x1d21e,
  :greek_instrumental_notation_symbol_4 => 0x1d21f,
  :greek_instrumental_notation_symbol_5 => 0x1d220,
  :greek_instrumental_notation_symbol_7 => 0x1d221,
  :greek_instrumental_notation_symbol_8 => 0x1d222,
  :greek_instrumental_notation_symbol_11 => 0x1d223,
  :greek_instrumental_notation_symbol_12 => 0x1d224,
  :greek_instrumental_notation_symbol_13 => 0x1d225,
  :greek_instrumental_notation_symbol_14 => 0x1d226,
  :greek_instrumental_notation_symbol_17 => 0x1d227,
  :greek_instrumental_notation_symbol_18 => 0x1d228,
  :greek_instrumental_notation_symbol_19 => 0x1d229,
  :greek_instrumental_notation_symbol_23 => 0x1d22a,
  :greek_instrumental_notation_symbol_24 => 0x1d22b,
  :greek_instrumental_notation_symbol_25 => 0x1d22c,
  :greek_instrumental_notation_symbol_26 => 0x1d22d,
  :greek_instrumental_notation_symbol_27 => 0x1d22e,
  :greek_instrumental_notation_symbol_29 => 0x1d22f,
  :greek_instrumental_notation_symbol_30 => 0x1d230,
  :greek_instrumental_notation_symbol_32 => 0x1d231,
  :greek_instrumental_notation_symbol_36 => 0x1d232,
  :greek_instrumental_notation_symbol_37 => 0x1d233,
  :greek_instrumental_notation_symbol_38 => 0x1d234,
  :greek_instrumental_notation_symbol_39 => 0x1d235,
  :greek_instrumental_notation_symbol_40 => 0x1d236,
  :greek_instrumental_notation_symbol_42 => 0x1d237,
  :greek_instrumental_notation_symbol_43 => 0x1d238,
  :greek_instrumental_notation_symbol_45 => 0x1d239,
  :greek_instrumental_notation_symbol_47 => 0x1d23a,
  :greek_instrumental_notation_symbol_48 => 0x1d23b,
  :greek_instrumental_notation_symbol_49 => 0x1d23c,
  :greek_instrumental_notation_symbol_50 => 0x1d23d,
  :greek_instrumental_notation_symbol_51 => 0x1d23e,
  :greek_instrumental_notation_symbol_52 => 0x1d23f,
  :greek_instrumental_notation_symbol_53 => 0x1d240,
  :greek_instrumental_notation_symbol_54 => 0x1d241,
  :combining_greek_musical_triseme => 0x1d242,
  :combining_greek_musical_tetraseme => 0x1d243,
  :combining_greek_musical_pentaseme => 0x1d244,
  :greek_musical_leimma => 0x1d245,
  :monogram_for_earth => 0x1d300,
  :digram_for_heavenly_earth => 0x1d301,
  :digram_for_human_earth => 0x1d302,
  :digram_for_earthly_heaven => 0x1d303,
  :digram_for_earthly_human => 0x1d304,
  :digram_for_earth => 0x1d305,
  :tetragram_for_centre => 0x1d306,
  :tetragram_for_full_circle => 0x1d307,
  :tetragram_for_mired => 0x1d308,
  :tetragram_for_barrier => 0x1d309,
  :tetragram_for_keeping_small => 0x1d30a,
  :tetragram_for_contrariety => 0x1d30b,
  :tetragram_for_ascent => 0x1d30c,
  :tetragram_for_opposition => 0x1d30d,
  :tetragram_for_branching_out => 0x1d30e,
  :tetragram_for_defectiveness_or_distortion => 0x1d30f,
  :tetragram_for_divergence => 0x1d310,
  :tetragram_for_youthfulness => 0x1d311,
  :tetragram_for_increase => 0x1d312,
  :tetragram_for_penetration => 0x1d313,
  :tetragram_for_reach => 0x1d314,
  :tetragram_for_contact => 0x1d315,
  :tetragram_for_holding_back => 0x1d316,
  :tetragram_for_waiting => 0x1d317,
  :tetragram_for_following => 0x1d318,
  :tetragram_for_advance => 0x1d319,
  :tetragram_for_release => 0x1d31a,
  :tetragram_for_resistance => 0x1d31b,
  :tetragram_for_ease => 0x1d31c,
  :tetragram_for_joy => 0x1d31d,
  :tetragram_for_contention => 0x1d31e,
  :tetragram_for_endeavour => 0x1d31f,
  :tetragram_for_duties => 0x1d320,
  :tetragram_for_change => 0x1d321,
  :tetragram_for_decisiveness => 0x1d322,
  :tetragram_for_bold_resolution => 0x1d323,
  :tetragram_for_packing => 0x1d324,
  :tetragram_for_legion => 0x1d325,
  :tetragram_for_closeness => 0x1d326,
  :tetragram_for_kinship => 0x1d327,
  :tetragram_for_gathering => 0x1d328,
  :tetragram_for_strength => 0x1d329,
  :tetragram_for_purity => 0x1d32a,
  :tetragram_for_fullness => 0x1d32b,
  :tetragram_for_residence => 0x1d32c,
  :tetragram_for_law_or_model => 0x1d32d,
  :tetragram_for_response => 0x1d32e,
  :tetragram_for_going_to_meet => 0x1d32f,
  :tetragram_for_encounters => 0x1d330,
  :tetragram_for_stove => 0x1d331,
  :tetragram_for_greatness => 0x1d332,
  :tetragram_for_enlargement => 0x1d333,
  :tetragram_for_pattern => 0x1d334,
  :tetragram_for_ritual => 0x1d335,
  :tetragram_for_flight => 0x1d336,
  :tetragram_for_vastness_or_wasting => 0x1d337,
  :tetragram_for_constancy => 0x1d338,
  :tetragram_for_measure => 0x1d339,
  :tetragram_for_eternity => 0x1d33a,
  :tetragram_for_unity => 0x1d33b,
  :tetragram_for_diminishment => 0x1d33c,
  :tetragram_for_closed_mouth => 0x1d33d,
  :tetragram_for_guardedness => 0x1d33e,
  :tetragram_for_gathering_in => 0x1d33f,
  :tetragram_for_massing => 0x1d340,
  :tetragram_for_accumulation => 0x1d341,
  :tetragram_for_embellishment => 0x1d342,
  :tetragram_for_doubt => 0x1d343,
  :tetragram_for_watch => 0x1d344,
  :tetragram_for_sinking => 0x1d345,
  :tetragram_for_inner => 0x1d346,
  :tetragram_for_departure => 0x1d347,
  :tetragram_for_darkening => 0x1d348,
  :tetragram_for_dimming => 0x1d349,
  :tetragram_for_exhaustion => 0x1d34a,
  :tetragram_for_severance => 0x1d34b,
  :tetragram_for_stoppage => 0x1d34c,
  :tetragram_for_hardness => 0x1d34d,
  :tetragram_for_completion => 0x1d34e,
  :tetragram_for_closure => 0x1d34f,
  :tetragram_for_failure => 0x1d350,
  :tetragram_for_aggravation => 0x1d351,
  :tetragram_for_compliance => 0x1d352,
  :tetragram_for_on_the_verge => 0x1d353,
  :tetragram_for_difficulties => 0x1d354,
  :tetragram_for_labouring => 0x1d355,
  :tetragram_for_fostering => 0x1d356,
  :mathematical_bold_capital_a => 0x1d400,
  :mathematical_bold_capital_b => 0x1d401,
  :mathematical_bold_capital_c => 0x1d402,
  :mathematical_bold_capital_d => 0x1d403,
  :mathematical_bold_capital_e => 0x1d404,
  :mathematical_bold_capital_f => 0x1d405,
  :mathematical_bold_capital_g => 0x1d406,
  :mathematical_bold_capital_h => 0x1d407,
  :mathematical_bold_capital_i => 0x1d408,
  :mathematical_bold_capital_j => 0x1d409,
  :mathematical_bold_capital_k => 0x1d40a,
  :mathematical_bold_capital_l => 0x1d40b,
  :mathematical_bold_capital_m => 0x1d40c,
  :mathematical_bold_capital_n => 0x1d40d,
  :mathematical_bold_capital_o => 0x1d40e,
  :mathematical_bold_capital_p => 0x1d40f,
  :mathematical_bold_capital_q => 0x1d410,
  :mathematical_bold_capital_r => 0x1d411,
  :mathematical_bold_capital_s => 0x1d412,
  :mathematical_bold_capital_t => 0x1d413,
  :mathematical_bold_capital_u => 0x1d414,
  :mathematical_bold_capital_v => 0x1d415,
  :mathematical_bold_capital_w => 0x1d416,
  :mathematical_bold_capital_x => 0x1d417,
  :mathematical_bold_capital_y => 0x1d418,
  :mathematical_bold_capital_z => 0x1d419,
  :mathematical_bold_small_a => 0x1d41a,
  :mathematical_bold_small_b => 0x1d41b,
  :mathematical_bold_small_c => 0x1d41c,
  :mathematical_bold_small_d => 0x1d41d,
  :mathematical_bold_small_e => 0x1d41e,
  :mathematical_bold_small_f => 0x1d41f,
  :mathematical_bold_small_g => 0x1d420,
  :mathematical_bold_small_h => 0x1d421,
  :mathematical_bold_small_i => 0x1d422,
  :mathematical_bold_small_j => 0x1d423,
  :mathematical_bold_small_k => 0x1d424,
  :mathematical_bold_small_l => 0x1d425,
  :mathematical_bold_small_m => 0x1d426,
  :mathematical_bold_small_n => 0x1d427,
  :mathematical_bold_small_o => 0x1d428,
  :mathematical_bold_small_p => 0x1d429,
  :mathematical_bold_small_q => 0x1d42a,
  :mathematical_bold_small_r => 0x1d42b,
  :mathematical_bold_small_s => 0x1d42c,
  :mathematical_bold_small_t => 0x1d42d,
  :mathematical_bold_small_u => 0x1d42e,
  :mathematical_bold_small_v => 0x1d42f,
  :mathematical_bold_small_w => 0x1d430,
  :mathematical_bold_small_x => 0x1d431,
  :mathematical_bold_small_y => 0x1d432,
  :mathematical_bold_small_z => 0x1d433,
  :mathematical_italic_capital_a => 0x1d434,
  :mathematical_italic_capital_b => 0x1d435,
  :mathematical_italic_capital_c => 0x1d436,
  :mathematical_italic_capital_d => 0x1d437,
  :mathematical_italic_capital_e => 0x1d438,
  :mathematical_italic_capital_f => 0x1d439,
  :mathematical_italic_capital_g => 0x1d43a,
  :mathematical_italic_capital_h => 0x1d43b,
  :mathematical_italic_capital_i => 0x1d43c,
  :mathematical_italic_capital_j => 0x1d43d,
  :mathematical_italic_capital_k => 0x1d43e,
  :mathematical_italic_capital_l => 0x1d43f,
  :mathematical_italic_capital_m => 0x1d440,
  :mathematical_italic_capital_n => 0x1d441,
  :mathematical_italic_capital_o => 0x1d442,
  :mathematical_italic_capital_p => 0x1d443,
  :mathematical_italic_capital_q => 0x1d444,
  :mathematical_italic_capital_r => 0x1d445,
  :mathematical_italic_capital_s => 0x1d446,
  :mathematical_italic_capital_t => 0x1d447,
  :mathematical_italic_capital_u => 0x1d448,
  :mathematical_italic_capital_v => 0x1d449,
  :mathematical_italic_capital_w => 0x1d44a,
  :mathematical_italic_capital_x => 0x1d44b,
  :mathematical_italic_capital_y => 0x1d44c,
  :mathematical_italic_capital_z => 0x1d44d,
  :mathematical_italic_small_a => 0x1d44e,
  :mathematical_italic_small_b => 0x1d44f,
  :mathematical_italic_small_c => 0x1d450,
  :mathematical_italic_small_d => 0x1d451,
  :mathematical_italic_small_e => 0x1d452,
  :mathematical_italic_small_f => 0x1d453,
  :mathematical_italic_small_g => 0x1d454,
  :mathematical_italic_small_i => 0x1d456,
  :mathematical_italic_small_j => 0x1d457,
  :mathematical_italic_small_k => 0x1d458,
  :mathematical_italic_small_l => 0x1d459,
  :mathematical_italic_small_m => 0x1d45a,
  :mathematical_italic_small_n => 0x1d45b,
  :mathematical_italic_small_o => 0x1d45c,
  :mathematical_italic_small_p => 0x1d45d,
  :mathematical_italic_small_q => 0x1d45e,
  :mathematical_italic_small_r => 0x1d45f,
  :mathematical_italic_small_s => 0x1d460,
  :mathematical_italic_small_t => 0x1d461,
  :mathematical_italic_small_u => 0x1d462,
  :mathematical_italic_small_v => 0x1d463,
  :mathematical_italic_small_w => 0x1d464,
  :mathematical_italic_small_x => 0x1d465,
  :mathematical_italic_small_y => 0x1d466,
  :mathematical_italic_small_z => 0x1d467,
  :mathematical_bold_italic_capital_a => 0x1d468,
  :mathematical_bold_italic_capital_b => 0x1d469,
  :mathematical_bold_italic_capital_c => 0x1d46a,
  :mathematical_bold_italic_capital_d => 0x1d46b,
  :mathematical_bold_italic_capital_e => 0x1d46c,
  :mathematical_bold_italic_capital_f => 0x1d46d,
  :mathematical_bold_italic_capital_g => 0x1d46e,
  :mathematical_bold_italic_capital_h => 0x1d46f,
  :mathematical_bold_italic_capital_i => 0x1d470,
  :mathematical_bold_italic_capital_j => 0x1d471,
  :mathematical_bold_italic_capital_k => 0x1d472,
  :mathematical_bold_italic_capital_l => 0x1d473,
  :mathematical_bold_italic_capital_m => 0x1d474,
  :mathematical_bold_italic_capital_n => 0x1d475,
  :mathematical_bold_italic_capital_o => 0x1d476,
  :mathematical_bold_italic_capital_p => 0x1d477,
  :mathematical_bold_italic_capital_q => 0x1d478,
  :mathematical_bold_italic_capital_r => 0x1d479,
  :mathematical_bold_italic_capital_s => 0x1d47a,
  :mathematical_bold_italic_capital_t => 0x1d47b,
  :mathematical_bold_italic_capital_u => 0x1d47c,
  :mathematical_bold_italic_capital_v => 0x1d47d,
  :mathematical_bold_italic_capital_w => 0x1d47e,
  :mathematical_bold_italic_capital_x => 0x1d47f,
  :mathematical_bold_italic_capital_y => 0x1d480,
  :mathematical_bold_italic_capital_z => 0x1d481,
  :mathematical_bold_italic_small_a => 0x1d482,
  :mathematical_bold_italic_small_b => 0x1d483,
  :mathematical_bold_italic_small_c => 0x1d484,
  :mathematical_bold_italic_small_d => 0x1d485,
  :mathematical_bold_italic_small_e => 0x1d486,
  :mathematical_bold_italic_small_f => 0x1d487,
  :mathematical_bold_italic_small_g => 0x1d488,
  :mathematical_bold_italic_small_h => 0x1d489,
  :mathematical_bold_italic_small_i => 0x1d48a,
  :mathematical_bold_italic_small_j => 0x1d48b,
  :mathematical_bold_italic_small_k => 0x1d48c,
  :mathematical_bold_italic_small_l => 0x1d48d,
  :mathematical_bold_italic_small_m => 0x1d48e,
  :mathematical_bold_italic_small_n => 0x1d48f,
  :mathematical_bold_italic_small_o => 0x1d490,
  :mathematical_bold_italic_small_p => 0x1d491,
  :mathematical_bold_italic_small_q => 0x1d492,
  :mathematical_bold_italic_small_r => 0x1d493,
  :mathematical_bold_italic_small_s => 0x1d494,
  :mathematical_bold_italic_small_t => 0x1d495,
  :mathematical_bold_italic_small_u => 0x1d496,
  :mathematical_bold_italic_small_v => 0x1d497,
  :mathematical_bold_italic_small_w => 0x1d498,
  :mathematical_bold_italic_small_x => 0x1d499,
  :mathematical_bold_italic_small_y => 0x1d49a,
  :mathematical_bold_italic_small_z => 0x1d49b,
  :mathematical_script_capital_a => 0x1d49c,
  :mathematical_script_capital_c => 0x1d49e,
  :mathematical_script_capital_d => 0x1d49f,
  :mathematical_script_capital_g => 0x1d4a2,
  :mathematical_script_capital_j => 0x1d4a5,
  :mathematical_script_capital_k => 0x1d4a6,
  :mathematical_script_capital_n => 0x1d4a9,
  :mathematical_script_capital_o => 0x1d4aa,
  :mathematical_script_capital_p => 0x1d4ab,
  :mathematical_script_capital_q => 0x1d4ac,
  :mathematical_script_capital_s => 0x1d4ae,
  :mathematical_script_capital_t => 0x1d4af,
  :mathematical_script_capital_u => 0x1d4b0,
  :mathematical_script_capital_v => 0x1d4b1,
  :mathematical_script_capital_w => 0x1d4b2,
  :mathematical_script_capital_x => 0x1d4b3,
  :mathematical_script_capital_y => 0x1d4b4,
  :mathematical_script_capital_z => 0x1d4b5,
  :mathematical_script_small_a => 0x1d4b6,
  :mathematical_script_small_b => 0x1d4b7,
  :mathematical_script_small_c => 0x1d4b8,
  :mathematical_script_small_d => 0x1d4b9,
  :mathematical_script_small_f => 0x1d4bb,
  :mathematical_script_small_h => 0x1d4bd,
  :mathematical_script_small_i => 0x1d4be,
  :mathematical_script_small_j => 0x1d4bf,
  :mathematical_script_small_k => 0x1d4c0,
  :mathematical_script_small_l => 0x1d4c1,
  :mathematical_script_small_m => 0x1d4c2,
  :mathematical_script_small_n => 0x1d4c3,
  :mathematical_script_small_p => 0x1d4c5,
  :mathematical_script_small_q => 0x1d4c6,
  :mathematical_script_small_r => 0x1d4c7,
  :mathematical_script_small_s => 0x1d4c8,
  :mathematical_script_small_t => 0x1d4c9,
  :mathematical_script_small_u => 0x1d4ca,
  :mathematical_script_small_v => 0x1d4cb,
  :mathematical_script_small_w => 0x1d4cc,
  :mathematical_script_small_x => 0x1d4cd,
  :mathematical_script_small_y => 0x1d4ce,
  :mathematical_script_small_z => 0x1d4cf,
  :mathematical_bold_script_capital_a => 0x1d4d0,
  :mathematical_bold_script_capital_b => 0x1d4d1,
  :mathematical_bold_script_capital_c => 0x1d4d2,
  :mathematical_bold_script_capital_d => 0x1d4d3,
  :mathematical_bold_script_capital_e => 0x1d4d4,
  :mathematical_bold_script_capital_f => 0x1d4d5,
  :mathematical_bold_script_capital_g => 0x1d4d6,
  :mathematical_bold_script_capital_h => 0x1d4d7,
  :mathematical_bold_script_capital_i => 0x1d4d8,
  :mathematical_bold_script_capital_j => 0x1d4d9,
  :mathematical_bold_script_capital_k => 0x1d4da,
  :mathematical_bold_script_capital_l => 0x1d4db,
  :mathematical_bold_script_capital_m => 0x1d4dc,
  :mathematical_bold_script_capital_n => 0x1d4dd,
  :mathematical_bold_script_capital_o => 0x1d4de,
  :mathematical_bold_script_capital_p => 0x1d4df,
  :mathematical_bold_script_capital_q => 0x1d4e0,
  :mathematical_bold_script_capital_r => 0x1d4e1,
  :mathematical_bold_script_capital_s => 0x1d4e2,
  :mathematical_bold_script_capital_t => 0x1d4e3,
  :mathematical_bold_script_capital_u => 0x1d4e4,
  :mathematical_bold_script_capital_v => 0x1d4e5,
  :mathematical_bold_script_capital_w => 0x1d4e6,
  :mathematical_bold_script_capital_x => 0x1d4e7,
  :mathematical_bold_script_capital_y => 0x1d4e8,
  :mathematical_bold_script_capital_z => 0x1d4e9,
  :mathematical_bold_script_small_a => 0x1d4ea,
  :mathematical_bold_script_small_b => 0x1d4eb,
  :mathematical_bold_script_small_c => 0x1d4ec,
  :mathematical_bold_script_small_d => 0x1d4ed,
  :mathematical_bold_script_small_e => 0x1d4ee,
  :mathematical_bold_script_small_f => 0x1d4ef,
  :mathematical_bold_script_small_g => 0x1d4f0,
  :mathematical_bold_script_small_h => 0x1d4f1,
  :mathematical_bold_script_small_i => 0x1d4f2,
  :mathematical_bold_script_small_j => 0x1d4f3,
  :mathematical_bold_script_small_k => 0x1d4f4,
  :mathematical_bold_script_small_l => 0x1d4f5,
  :mathematical_bold_script_small_m => 0x1d4f6,
  :mathematical_bold_script_small_n => 0x1d4f7,
  :mathematical_bold_script_small_o => 0x1d4f8,
  :mathematical_bold_script_small_p => 0x1d4f9,
  :mathematical_bold_script_small_q => 0x1d4fa,
  :mathematical_bold_script_small_r => 0x1d4fb,
  :mathematical_bold_script_small_s => 0x1d4fc,
  :mathematical_bold_script_small_t => 0x1d4fd,
  :mathematical_bold_script_small_u => 0x1d4fe,
  :mathematical_bold_script_small_v => 0x1d4ff,
  :mathematical_bold_script_small_w => 0x1d500,
  :mathematical_bold_script_small_x => 0x1d501,
  :mathematical_bold_script_small_y => 0x1d502,
  :mathematical_bold_script_small_z => 0x1d503,
  :mathematical_fraktur_capital_a => 0x1d504,
  :mathematical_fraktur_capital_b => 0x1d505,
  :mathematical_fraktur_capital_d => 0x1d507,
  :mathematical_fraktur_capital_e => 0x1d508,
  :mathematical_fraktur_capital_f => 0x1d509,
  :mathematical_fraktur_capital_g => 0x1d50a,
  :mathematical_fraktur_capital_j => 0x1d50d,
  :mathematical_fraktur_capital_k => 0x1d50e,
  :mathematical_fraktur_capital_l => 0x1d50f,
  :mathematical_fraktur_capital_m => 0x1d510,
  :mathematical_fraktur_capital_n => 0x1d511,
  :mathematical_fraktur_capital_o => 0x1d512,
  :mathematical_fraktur_capital_p => 0x1d513,
  :mathematical_fraktur_capital_q => 0x1d514,
  :mathematical_fraktur_capital_s => 0x1d516,
  :mathematical_fraktur_capital_t => 0x1d517,
  :mathematical_fraktur_capital_u => 0x1d518,
  :mathematical_fraktur_capital_v => 0x1d519,
  :mathematical_fraktur_capital_w => 0x1d51a,
  :mathematical_fraktur_capital_x => 0x1d51b,
  :mathematical_fraktur_capital_y => 0x1d51c,
  :mathematical_fraktur_small_a => 0x1d51e,
  :mathematical_fraktur_small_b => 0x1d51f,
  :mathematical_fraktur_small_c => 0x1d520,
  :mathematical_fraktur_small_d => 0x1d521,
  :mathematical_fraktur_small_e => 0x1d522,
  :mathematical_fraktur_small_f => 0x1d523,
  :mathematical_fraktur_small_g => 0x1d524,
  :mathematical_fraktur_small_h => 0x1d525,
  :mathematical_fraktur_small_i => 0x1d526,
  :mathematical_fraktur_small_j => 0x1d527,
  :mathematical_fraktur_small_k => 0x1d528,
  :mathematical_fraktur_small_l => 0x1d529,
  :mathematical_fraktur_small_m => 0x1d52a,
  :mathematical_fraktur_small_n => 0x1d52b,
  :mathematical_fraktur_small_o => 0x1d52c,
  :mathematical_fraktur_small_p => 0x1d52d,
  :mathematical_fraktur_small_q => 0x1d52e,
  :mathematical_fraktur_small_r => 0x1d52f,
  :mathematical_fraktur_small_s => 0x1d530,
  :mathematical_fraktur_small_t => 0x1d531,
  :mathematical_fraktur_small_u => 0x1d532,
  :mathematical_fraktur_small_v => 0x1d533,
  :mathematical_fraktur_small_w => 0x1d534,
  :mathematical_fraktur_small_x => 0x1d535,
  :mathematical_fraktur_small_y => 0x1d536,
  :mathematical_fraktur_small_z => 0x1d537,
  :mathematical_double_struck_capital_a => 0x1d538,
  :mathematical_double_struck_capital_b => 0x1d539,
  :mathematical_double_struck_capital_d => 0x1d53b,
  :mathematical_double_struck_capital_e => 0x1d53c,
  :mathematical_double_struck_capital_f => 0x1d53d,
  :mathematical_double_struck_capital_g => 0x1d53e,
  :mathematical_double_struck_capital_i => 0x1d540,
  :mathematical_double_struck_capital_j => 0x1d541,
  :mathematical_double_struck_capital_k => 0x1d542,
  :mathematical_double_struck_capital_l => 0x1d543,
  :mathematical_double_struck_capital_m => 0x1d544,
  :mathematical_double_struck_capital_o => 0x1d546,
  :mathematical_double_struck_capital_s => 0x1d54a,
  :mathematical_double_struck_capital_t => 0x1d54b,
  :mathematical_double_struck_capital_u => 0x1d54c,
  :mathematical_double_struck_capital_v => 0x1d54d,
  :mathematical_double_struck_capital_w => 0x1d54e,
  :mathematical_double_struck_capital_x => 0x1d54f,
  :mathematical_double_struck_capital_y => 0x1d550,
  :mathematical_double_struck_small_a => 0x1d552,
  :mathematical_double_struck_small_b => 0x1d553,
  :mathematical_double_struck_small_c => 0x1d554,
  :mathematical_double_struck_small_d => 0x1d555,
  :mathematical_double_struck_small_e => 0x1d556,
  :mathematical_double_struck_small_f => 0x1d557,
  :mathematical_double_struck_small_g => 0x1d558,
  :mathematical_double_struck_small_h => 0x1d559,
  :mathematical_double_struck_small_i => 0x1d55a,
  :mathematical_double_struck_small_j => 0x1d55b,
  :mathematical_double_struck_small_k => 0x1d55c,
  :mathematical_double_struck_small_l => 0x1d55d,
  :mathematical_double_struck_small_m => 0x1d55e,
  :mathematical_double_struck_small_n => 0x1d55f,
  :mathematical_double_struck_small_o => 0x1d560,
  :mathematical_double_struck_small_p => 0x1d561,
  :mathematical_double_struck_small_q => 0x1d562,
  :mathematical_double_struck_small_r => 0x1d563,
  :mathematical_double_struck_small_s => 0x1d564,
  :mathematical_double_struck_small_t => 0x1d565,
  :mathematical_double_struck_small_u => 0x1d566,
  :mathematical_double_struck_small_v => 0x1d567,
  :mathematical_double_struck_small_w => 0x1d568,
  :mathematical_double_struck_small_x => 0x1d569,
  :mathematical_double_struck_small_y => 0x1d56a,
  :mathematical_double_struck_small_z => 0x1d56b,
  :mathematical_bold_fraktur_capital_a => 0x1d56c,
  :mathematical_bold_fraktur_capital_b => 0x1d56d,
  :mathematical_bold_fraktur_capital_c => 0x1d56e,
  :mathematical_bold_fraktur_capital_d => 0x1d56f,
  :mathematical_bold_fraktur_capital_e => 0x1d570,
  :mathematical_bold_fraktur_capital_f => 0x1d571,
  :mathematical_bold_fraktur_capital_g => 0x1d572,
  :mathematical_bold_fraktur_capital_h => 0x1d573,
  :mathematical_bold_fraktur_capital_i => 0x1d574,
  :mathematical_bold_fraktur_capital_j => 0x1d575,
  :mathematical_bold_fraktur_capital_k => 0x1d576,
  :mathematical_bold_fraktur_capital_l => 0x1d577,
  :mathematical_bold_fraktur_capital_m => 0x1d578,
  :mathematical_bold_fraktur_capital_n => 0x1d579,
  :mathematical_bold_fraktur_capital_o => 0x1d57a,
  :mathematical_bold_fraktur_capital_p => 0x1d57b,
  :mathematical_bold_fraktur_capital_q => 0x1d57c,
  :mathematical_bold_fraktur_capital_r => 0x1d57d,
  :mathematical_bold_fraktur_capital_s => 0x1d57e,
  :mathematical_bold_fraktur_capital_t => 0x1d57f,
  :mathematical_bold_fraktur_capital_u => 0x1d580,
  :mathematical_bold_fraktur_capital_v => 0x1d581,
  :mathematical_bold_fraktur_capital_w => 0x1d582,
  :mathematical_bold_fraktur_capital_x => 0x1d583,
  :mathematical_bold_fraktur_capital_y => 0x1d584,
  :mathematical_bold_fraktur_capital_z => 0x1d585,
  :mathematical_bold_fraktur_small_a => 0x1d586,
  :mathematical_bold_fraktur_small_b => 0x1d587,
  :mathematical_bold_fraktur_small_c => 0x1d588,
  :mathematical_bold_fraktur_small_d => 0x1d589,
  :mathematical_bold_fraktur_small_e => 0x1d58a,
  :mathematical_bold_fraktur_small_f => 0x1d58b,
  :mathematical_bold_fraktur_small_g => 0x1d58c,
  :mathematical_bold_fraktur_small_h => 0x1d58d,
  :mathematical_bold_fraktur_small_i => 0x1d58e,
  :mathematical_bold_fraktur_small_j => 0x1d58f,
  :mathematical_bold_fraktur_small_k => 0x1d590,
  :mathematical_bold_fraktur_small_l => 0x1d591,
  :mathematical_bold_fraktur_small_m => 0x1d592,
  :mathematical_bold_fraktur_small_n => 0x1d593,
  :mathematical_bold_fraktur_small_o => 0x1d594,
  :mathematical_bold_fraktur_small_p => 0x1d595,
  :mathematical_bold_fraktur_small_q => 0x1d596,
  :mathematical_bold_fraktur_small_r => 0x1d597,
  :mathematical_bold_fraktur_small_s => 0x1d598,
  :mathematical_bold_fraktur_small_t => 0x1d599,
  :mathematical_bold_fraktur_small_u => 0x1d59a,
  :mathematical_bold_fraktur_small_v => 0x1d59b,
  :mathematical_bold_fraktur_small_w => 0x1d59c,
  :mathematical_bold_fraktur_small_x => 0x1d59d,
  :mathematical_bold_fraktur_small_y => 0x1d59e,
  :mathematical_bold_fraktur_small_z => 0x1d59f,
  :mathematical_sans_serif_capital_a => 0x1d5a0,
  :mathematical_sans_serif_capital_b => 0x1d5a1,
  :mathematical_sans_serif_capital_c => 0x1d5a2,
  :mathematical_sans_serif_capital_d => 0x1d5a3,
  :mathematical_sans_serif_capital_e => 0x1d5a4,
  :mathematical_sans_serif_capital_f => 0x1d5a5,
  :mathematical_sans_serif_capital_g => 0x1d5a6,
  :mathematical_sans_serif_capital_h => 0x1d5a7,
  :mathematical_sans_serif_capital_i => 0x1d5a8,
  :mathematical_sans_serif_capital_j => 0x1d5a9,
  :mathematical_sans_serif_capital_k => 0x1d5aa,
  :mathematical_sans_serif_capital_l => 0x1d5ab,
  :mathematical_sans_serif_capital_m => 0x1d5ac,
  :mathematical_sans_serif_capital_n => 0x1d5ad,
  :mathematical_sans_serif_capital_o => 0x1d5ae,
  :mathematical_sans_serif_capital_p => 0x1d5af,
  :mathematical_sans_serif_capital_q => 0x1d5b0,
  :mathematical_sans_serif_capital_r => 0x1d5b1,
  :mathematical_sans_serif_capital_s => 0x1d5b2,
  :mathematical_sans_serif_capital_t => 0x1d5b3,
  :mathematical_sans_serif_capital_u => 0x1d5b4,
  :mathematical_sans_serif_capital_v => 0x1d5b5,
  :mathematical_sans_serif_capital_w => 0x1d5b6,
  :mathematical_sans_serif_capital_x => 0x1d5b7,
  :mathematical_sans_serif_capital_y => 0x1d5b8,
  :mathematical_sans_serif_capital_z => 0x1d5b9,
  :mathematical_sans_serif_small_a => 0x1d5ba,
  :mathematical_sans_serif_small_b => 0x1d5bb,
  :mathematical_sans_serif_small_c => 0x1d5bc,
  :mathematical_sans_serif_small_d => 0x1d5bd,
  :mathematical_sans_serif_small_e => 0x1d5be,
  :mathematical_sans_serif_small_f => 0x1d5bf,
  :mathematical_sans_serif_small_g => 0x1d5c0,
  :mathematical_sans_serif_small_h => 0x1d5c1,
  :mathematical_sans_serif_small_i => 0x1d5c2,
  :mathematical_sans_serif_small_j => 0x1d5c3,
  :mathematical_sans_serif_small_k => 0x1d5c4,
  :mathematical_sans_serif_small_l => 0x1d5c5,
  :mathematical_sans_serif_small_m => 0x1d5c6,
  :mathematical_sans_serif_small_n => 0x1d5c7,
  :mathematical_sans_serif_small_o => 0x1d5c8,
  :mathematical_sans_serif_small_p => 0x1d5c9,
  :mathematical_sans_serif_small_q => 0x1d5ca,
  :mathematical_sans_serif_small_r => 0x1d5cb,
  :mathematical_sans_serif_small_s => 0x1d5cc,
  :mathematical_sans_serif_small_t => 0x1d5cd,
  :mathematical_sans_serif_small_u => 0x1d5ce,
  :mathematical_sans_serif_small_v => 0x1d5cf,
  :mathematical_sans_serif_small_w => 0x1d5d0,
  :mathematical_sans_serif_small_x => 0x1d5d1,
  :mathematical_sans_serif_small_y => 0x1d5d2,
  :mathematical_sans_serif_small_z => 0x1d5d3,
  :mathematical_sans_serif_bold_capital_a => 0x1d5d4,
  :mathematical_sans_serif_bold_capital_b => 0x1d5d5,
  :mathematical_sans_serif_bold_capital_c => 0x1d5d6,
  :mathematical_sans_serif_bold_capital_d => 0x1d5d7,
  :mathematical_sans_serif_bold_capital_e => 0x1d5d8,
  :mathematical_sans_serif_bold_capital_f => 0x1d5d9,
  :mathematical_sans_serif_bold_capital_g => 0x1d5da,
  :mathematical_sans_serif_bold_capital_h => 0x1d5db,
  :mathematical_sans_serif_bold_capital_i => 0x1d5dc,
  :mathematical_sans_serif_bold_capital_j => 0x1d5dd,
  :mathematical_sans_serif_bold_capital_k => 0x1d5de,
  :mathematical_sans_serif_bold_capital_l => 0x1d5df,
  :mathematical_sans_serif_bold_capital_m => 0x1d5e0,
  :mathematical_sans_serif_bold_capital_n => 0x1d5e1,
  :mathematical_sans_serif_bold_capital_o => 0x1d5e2,
  :mathematical_sans_serif_bold_capital_p => 0x1d5e3,
  :mathematical_sans_serif_bold_capital_q => 0x1d5e4,
  :mathematical_sans_serif_bold_capital_r => 0x1d5e5,
  :mathematical_sans_serif_bold_capital_s => 0x1d5e6,
  :mathematical_sans_serif_bold_capital_t => 0x1d5e7,
  :mathematical_sans_serif_bold_capital_u => 0x1d5e8,
  :mathematical_sans_serif_bold_capital_v => 0x1d5e9,
  :mathematical_sans_serif_bold_capital_w => 0x1d5ea,
  :mathematical_sans_serif_bold_capital_x => 0x1d5eb,
  :mathematical_sans_serif_bold_capital_y => 0x1d5ec,
  :mathematical_sans_serif_bold_capital_z => 0x1d5ed,
  :mathematical_sans_serif_bold_small_a => 0x1d5ee,
  :mathematical_sans_serif_bold_small_b => 0x1d5ef,
  :mathematical_sans_serif_bold_small_c => 0x1d5f0,
  :mathematical_sans_serif_bold_small_d => 0x1d5f1,
  :mathematical_sans_serif_bold_small_e => 0x1d5f2,
  :mathematical_sans_serif_bold_small_f => 0x1d5f3,
  :mathematical_sans_serif_bold_small_g => 0x1d5f4,
  :mathematical_sans_serif_bold_small_h => 0x1d5f5,
  :mathematical_sans_serif_bold_small_i => 0x1d5f6,
  :mathematical_sans_serif_bold_small_j => 0x1d5f7,
  :mathematical_sans_serif_bold_small_k => 0x1d5f8,
  :mathematical_sans_serif_bold_small_l => 0x1d5f9,
  :mathematical_sans_serif_bold_small_m => 0x1d5fa,
  :mathematical_sans_serif_bold_small_n => 0x1d5fb,
  :mathematical_sans_serif_bold_small_o => 0x1d5fc,
  :mathematical_sans_serif_bold_small_p => 0x1d5fd,
  :mathematical_sans_serif_bold_small_q => 0x1d5fe,
  :mathematical_sans_serif_bold_small_r => 0x1d5ff,
  :mathematical_sans_serif_bold_small_s => 0x1d600,
  :mathematical_sans_serif_bold_small_t => 0x1d601,
  :mathematical_sans_serif_bold_small_u => 0x1d602,
  :mathematical_sans_serif_bold_small_v => 0x1d603,
  :mathematical_sans_serif_bold_small_w => 0x1d604,
  :mathematical_sans_serif_bold_small_x => 0x1d605,
  :mathematical_sans_serif_bold_small_y => 0x1d606,
  :mathematical_sans_serif_bold_small_z => 0x1d607,
  :mathematical_sans_serif_italic_capital_a => 0x1d608,
  :mathematical_sans_serif_italic_capital_b => 0x1d609,
  :mathematical_sans_serif_italic_capital_c => 0x1d60a,
  :mathematical_sans_serif_italic_capital_d => 0x1d60b,
  :mathematical_sans_serif_italic_capital_e => 0x1d60c,
  :mathematical_sans_serif_italic_capital_f => 0x1d60d,
  :mathematical_sans_serif_italic_capital_g => 0x1d60e,
  :mathematical_sans_serif_italic_capital_h => 0x1d60f,
  :mathematical_sans_serif_italic_capital_i => 0x1d610,
  :mathematical_sans_serif_italic_capital_j => 0x1d611,
  :mathematical_sans_serif_italic_capital_k => 0x1d612,
  :mathematical_sans_serif_italic_capital_l => 0x1d613,
  :mathematical_sans_serif_italic_capital_m => 0x1d614,
  :mathematical_sans_serif_italic_capital_n => 0x1d615,
  :mathematical_sans_serif_italic_capital_o => 0x1d616,
  :mathematical_sans_serif_italic_capital_p => 0x1d617,
  :mathematical_sans_serif_italic_capital_q => 0x1d618,
  :mathematical_sans_serif_italic_capital_r => 0x1d619,
  :mathematical_sans_serif_italic_capital_s => 0x1d61a,
  :mathematical_sans_serif_italic_capital_t => 0x1d61b,
  :mathematical_sans_serif_italic_capital_u => 0x1d61c,
  :mathematical_sans_serif_italic_capital_v => 0x1d61d,
  :mathematical_sans_serif_italic_capital_w => 0x1d61e,
  :mathematical_sans_serif_italic_capital_x => 0x1d61f,
  :mathematical_sans_serif_italic_capital_y => 0x1d620,
  :mathematical_sans_serif_italic_capital_z => 0x1d621,
  :mathematical_sans_serif_italic_small_a => 0x1d622,
  :mathematical_sans_serif_italic_small_b => 0x1d623,
  :mathematical_sans_serif_italic_small_c => 0x1d624,
  :mathematical_sans_serif_italic_small_d => 0x1d625,
  :mathematical_sans_serif_italic_small_e => 0x1d626,
  :mathematical_sans_serif_italic_small_f => 0x1d627,
  :mathematical_sans_serif_italic_small_g => 0x1d628,
  :mathematical_sans_serif_italic_small_h => 0x1d629,
  :mathematical_sans_serif_italic_small_i => 0x1d62a,
  :mathematical_sans_serif_italic_small_j => 0x1d62b,
  :mathematical_sans_serif_italic_small_k => 0x1d62c,
  :mathematical_sans_serif_italic_small_l => 0x1d62d,
  :mathematical_sans_serif_italic_small_m => 0x1d62e,
  :mathematical_sans_serif_italic_small_n => 0x1d62f,
  :mathematical_sans_serif_italic_small_o => 0x1d630,
  :mathematical_sans_serif_italic_small_p => 0x1d631,
  :mathematical_sans_serif_italic_small_q => 0x1d632,
  :mathematical_sans_serif_italic_small_r => 0x1d633,
  :mathematical_sans_serif_italic_small_s => 0x1d634,
  :mathematical_sans_serif_italic_small_t => 0x1d635,
  :mathematical_sans_serif_italic_small_u => 0x1d636,
  :mathematical_sans_serif_italic_small_v => 0x1d637,
  :mathematical_sans_serif_italic_small_w => 0x1d638,
  :mathematical_sans_serif_italic_small_x => 0x1d639,
  :mathematical_sans_serif_italic_small_y => 0x1d63a,
  :mathematical_sans_serif_italic_small_z => 0x1d63b,
  :mathematical_sans_serif_bold_italic_capital_a => 0x1d63c,
  :mathematical_sans_serif_bold_italic_capital_b => 0x1d63d,
  :mathematical_sans_serif_bold_italic_capital_c => 0x1d63e,
  :mathematical_sans_serif_bold_italic_capital_d => 0x1d63f,
  :mathematical_sans_serif_bold_italic_capital_e => 0x1d640,
  :mathematical_sans_serif_bold_italic_capital_f => 0x1d641,
  :mathematical_sans_serif_bold_italic_capital_g => 0x1d642,
  :mathematical_sans_serif_bold_italic_capital_h => 0x1d643,
  :mathematical_sans_serif_bold_italic_capital_i => 0x1d644,
  :mathematical_sans_serif_bold_italic_capital_j => 0x1d645,
  :mathematical_sans_serif_bold_italic_capital_k => 0x1d646,
  :mathematical_sans_serif_bold_italic_capital_l => 0x1d647,
  :mathematical_sans_serif_bold_italic_capital_m => 0x1d648,
  :mathematical_sans_serif_bold_italic_capital_n => 0x1d649,
  :mathematical_sans_serif_bold_italic_capital_o => 0x1d64a,
  :mathematical_sans_serif_bold_italic_capital_p => 0x1d64b,
  :mathematical_sans_serif_bold_italic_capital_q => 0x1d64c,
  :mathematical_sans_serif_bold_italic_capital_r => 0x1d64d,
  :mathematical_sans_serif_bold_italic_capital_s => 0x1d64e,
  :mathematical_sans_serif_bold_italic_capital_t => 0x1d64f,
  :mathematical_sans_serif_bold_italic_capital_u => 0x1d650,
  :mathematical_sans_serif_bold_italic_capital_v => 0x1d651,
  :mathematical_sans_serif_bold_italic_capital_w => 0x1d652,
  :mathematical_sans_serif_bold_italic_capital_x => 0x1d653,
  :mathematical_sans_serif_bold_italic_capital_y => 0x1d654,
  :mathematical_sans_serif_bold_italic_capital_z => 0x1d655,
  :mathematical_sans_serif_bold_italic_small_a => 0x1d656,
  :mathematical_sans_serif_bold_italic_small_b => 0x1d657,
  :mathematical_sans_serif_bold_italic_small_c => 0x1d658,
  :mathematical_sans_serif_bold_italic_small_d => 0x1d659,
  :mathematical_sans_serif_bold_italic_small_e => 0x1d65a,
  :mathematical_sans_serif_bold_italic_small_f => 0x1d65b,
  :mathematical_sans_serif_bold_italic_small_g => 0x1d65c,
  :mathematical_sans_serif_bold_italic_small_h => 0x1d65d,
  :mathematical_sans_serif_bold_italic_small_i => 0x1d65e,
  :mathematical_sans_serif_bold_italic_small_j => 0x1d65f,
  :mathematical_sans_serif_bold_italic_small_k => 0x1d660,
  :mathematical_sans_serif_bold_italic_small_l => 0x1d661,
  :mathematical_sans_serif_bold_italic_small_m => 0x1d662,
  :mathematical_sans_serif_bold_italic_small_n => 0x1d663,
  :mathematical_sans_serif_bold_italic_small_o => 0x1d664,
  :mathematical_sans_serif_bold_italic_small_p => 0x1d665,
  :mathematical_sans_serif_bold_italic_small_q => 0x1d666,
  :mathematical_sans_serif_bold_italic_small_r => 0x1d667,
  :mathematical_sans_serif_bold_italic_small_s => 0x1d668,
  :mathematical_sans_serif_bold_italic_small_t => 0x1d669,
  :mathematical_sans_serif_bold_italic_small_u => 0x1d66a,
  :mathematical_sans_serif_bold_italic_small_v => 0x1d66b,
  :mathematical_sans_serif_bold_italic_small_w => 0x1d66c,
  :mathematical_sans_serif_bold_italic_small_x => 0x1d66d,
  :mathematical_sans_serif_bold_italic_small_y => 0x1d66e,
  :mathematical_sans_serif_bold_italic_small_z => 0x1d66f,
  :mathematical_monospace_capital_a => 0x1d670,
  :mathematical_monospace_capital_b => 0x1d671,
  :mathematical_monospace_capital_c => 0x1d672,
  :mathematical_monospace_capital_d => 0x1d673,
  :mathematical_monospace_capital_e => 0x1d674,
  :mathematical_monospace_capital_f => 0x1d675,
  :mathematical_monospace_capital_g => 0x1d676,
  :mathematical_monospace_capital_h => 0x1d677,
  :mathematical_monospace_capital_i => 0x1d678,
  :mathematical_monospace_capital_j => 0x1d679,
  :mathematical_monospace_capital_k => 0x1d67a,
  :mathematical_monospace_capital_l => 0x1d67b,
  :mathematical_monospace_capital_m => 0x1d67c,
  :mathematical_monospace_capital_n => 0x1d67d,
  :mathematical_monospace_capital_o => 0x1d67e,
  :mathematical_monospace_capital_p => 0x1d67f,
  :mathematical_monospace_capital_q => 0x1d680,
  :mathematical_monospace_capital_r => 0x1d681,
  :mathematical_monospace_capital_s => 0x1d682,
  :mathematical_monospace_capital_t => 0x1d683,
  :mathematical_monospace_capital_u => 0x1d684,
  :mathematical_monospace_capital_v => 0x1d685,
  :mathematical_monospace_capital_w => 0x1d686,
  :mathematical_monospace_capital_x => 0x1d687,
  :mathematical_monospace_capital_y => 0x1d688,
  :mathematical_monospace_capital_z => 0x1d689,
  :mathematical_monospace_small_a => 0x1d68a,
  :mathematical_monospace_small_b => 0x1d68b,
  :mathematical_monospace_small_c => 0x1d68c,
  :mathematical_monospace_small_d => 0x1d68d,
  :mathematical_monospace_small_e => 0x1d68e,
  :mathematical_monospace_small_f => 0x1d68f,
  :mathematical_monospace_small_g => 0x1d690,
  :mathematical_monospace_small_h => 0x1d691,
  :mathematical_monospace_small_i => 0x1d692,
  :mathematical_monospace_small_j => 0x1d693,
  :mathematical_monospace_small_k => 0x1d694,
  :mathematical_monospace_small_l => 0x1d695,
  :mathematical_monospace_small_m => 0x1d696,
  :mathematical_monospace_small_n => 0x1d697,
  :mathematical_monospace_small_o => 0x1d698,
  :mathematical_monospace_small_p => 0x1d699,
  :mathematical_monospace_small_q => 0x1d69a,
  :mathematical_monospace_small_r => 0x1d69b,
  :mathematical_monospace_small_s => 0x1d69c,
  :mathematical_monospace_small_t => 0x1d69d,
  :mathematical_monospace_small_u => 0x1d69e,
  :mathematical_monospace_small_v => 0x1d69f,
  :mathematical_monospace_small_w => 0x1d6a0,
  :mathematical_monospace_small_x => 0x1d6a1,
  :mathematical_monospace_small_y => 0x1d6a2,
  :mathematical_monospace_small_z => 0x1d6a3,
  :mathematical_italic_small_dotless_i => 0x1d6a4,
  :mathematical_italic_small_dotless_j => 0x1d6a5,
  :mathematical_bold_capital_alpha => 0x1d6a8,
  :mathematical_bold_capital_beta => 0x1d6a9,
  :mathematical_bold_capital_gamma => 0x1d6aa,
  :mathematical_bold_capital_delta => 0x1d6ab,
  :mathematical_bold_capital_epsilon => 0x1d6ac,
  :mathematical_bold_capital_zeta => 0x1d6ad,
  :mathematical_bold_capital_eta => 0x1d6ae,
  :mathematical_bold_capital_theta => 0x1d6af,
  :mathematical_bold_capital_iota => 0x1d6b0,
  :mathematical_bold_capital_kappa => 0x1d6b1,
  :mathematical_bold_capital_lamda => 0x1d6b2,
  :mathematical_bold_capital_mu => 0x1d6b3,
  :mathematical_bold_capital_nu => 0x1d6b4,
  :mathematical_bold_capital_xi => 0x1d6b5,
  :mathematical_bold_capital_omicron => 0x1d6b6,
  :mathematical_bold_capital_pi => 0x1d6b7,
  :mathematical_bold_capital_rho => 0x1d6b8,
  :mathematical_bold_capital_theta_symbol => 0x1d6b9,
  :mathematical_bold_capital_sigma => 0x1d6ba,
  :mathematical_bold_capital_tau => 0x1d6bb,
  :mathematical_bold_capital_upsilon => 0x1d6bc,
  :mathematical_bold_capital_phi => 0x1d6bd,
  :mathematical_bold_capital_chi => 0x1d6be,
  :mathematical_bold_capital_psi => 0x1d6bf,
  :mathematical_bold_capital_omega => 0x1d6c0,
  :mathematical_bold_nabla => 0x1d6c1,
  :mathematical_bold_small_alpha => 0x1d6c2,
  :mathematical_bold_small_beta => 0x1d6c3,
  :mathematical_bold_small_gamma => 0x1d6c4,
  :mathematical_bold_small_delta => 0x1d6c5,
  :mathematical_bold_small_epsilon => 0x1d6c6,
  :mathematical_bold_small_zeta => 0x1d6c7,
  :mathematical_bold_small_eta => 0x1d6c8,
  :mathematical_bold_small_theta => 0x1d6c9,
  :mathematical_bold_small_iota => 0x1d6ca,
  :mathematical_bold_small_kappa => 0x1d6cb,
  :mathematical_bold_small_lamda => 0x1d6cc,
  :mathematical_bold_small_mu => 0x1d6cd,
  :mathematical_bold_small_nu => 0x1d6ce,
  :mathematical_bold_small_xi => 0x1d6cf,
  :mathematical_bold_small_omicron => 0x1d6d0,
  :mathematical_bold_small_pi => 0x1d6d1,
  :mathematical_bold_small_rho => 0x1d6d2,
  :mathematical_bold_small_final_sigma => 0x1d6d3,
  :mathematical_bold_small_sigma => 0x1d6d4,
  :mathematical_bold_small_tau => 0x1d6d5,
  :mathematical_bold_small_upsilon => 0x1d6d6,
  :mathematical_bold_small_phi => 0x1d6d7,
  :mathematical_bold_small_chi => 0x1d6d8,
  :mathematical_bold_small_psi => 0x1d6d9,
  :mathematical_bold_small_omega => 0x1d6da,
  :mathematical_bold_partial_differential => 0x1d6db,
  :mathematical_bold_epsilon_symbol => 0x1d6dc,
  :mathematical_bold_theta_symbol => 0x1d6dd,
  :mathematical_bold_kappa_symbol => 0x1d6de,
  :mathematical_bold_phi_symbol => 0x1d6df,
  :mathematical_bold_rho_symbol => 0x1d6e0,
  :mathematical_bold_pi_symbol => 0x1d6e1,
  :mathematical_italic_capital_alpha => 0x1d6e2,
  :mathematical_italic_capital_beta => 0x1d6e3,
  :mathematical_italic_capital_gamma => 0x1d6e4,
  :mathematical_italic_capital_delta => 0x1d6e5,
  :mathematical_italic_capital_epsilon => 0x1d6e6,
  :mathematical_italic_capital_zeta => 0x1d6e7,
  :mathematical_italic_capital_eta => 0x1d6e8,
  :mathematical_italic_capital_theta => 0x1d6e9,
  :mathematical_italic_capital_iota => 0x1d6ea,
  :mathematical_italic_capital_kappa => 0x1d6eb,
  :mathematical_italic_capital_lamda => 0x1d6ec,
  :mathematical_italic_capital_mu => 0x1d6ed,
  :mathematical_italic_capital_nu => 0x1d6ee,
  :mathematical_italic_capital_xi => 0x1d6ef,
  :mathematical_italic_capital_omicron => 0x1d6f0,
  :mathematical_italic_capital_pi => 0x1d6f1,
  :mathematical_italic_capital_rho => 0x1d6f2,
  :mathematical_italic_capital_theta_symbol => 0x1d6f3,
  :mathematical_italic_capital_sigma => 0x1d6f4,
  :mathematical_italic_capital_tau => 0x1d6f5,
  :mathematical_italic_capital_upsilon => 0x1d6f6,
  :mathematical_italic_capital_phi => 0x1d6f7,
  :mathematical_italic_capital_chi => 0x1d6f8,
  :mathematical_italic_capital_psi => 0x1d6f9,
  :mathematical_italic_capital_omega => 0x1d6fa,
  :mathematical_italic_nabla => 0x1d6fb,
  :mathematical_italic_small_alpha => 0x1d6fc,
  :mathematical_italic_small_beta => 0x1d6fd,
  :mathematical_italic_small_gamma => 0x1d6fe,
  :mathematical_italic_small_delta => 0x1d6ff,
  :mathematical_italic_small_epsilon => 0x1d700,
  :mathematical_italic_small_zeta => 0x1d701,
  :mathematical_italic_small_eta => 0x1d702,
  :mathematical_italic_small_theta => 0x1d703,
  :mathematical_italic_small_iota => 0x1d704,
  :mathematical_italic_small_kappa => 0x1d705,
  :mathematical_italic_small_lamda => 0x1d706,
  :mathematical_italic_small_mu => 0x1d707,
  :mathematical_italic_small_nu => 0x1d708,
  :mathematical_italic_small_xi => 0x1d709,
  :mathematical_italic_small_omicron => 0x1d70a,
  :mathematical_italic_small_pi => 0x1d70b,
  :mathematical_italic_small_rho => 0x1d70c,
  :mathematical_italic_small_final_sigma => 0x1d70d,
  :mathematical_italic_small_sigma => 0x1d70e,
  :mathematical_italic_small_tau => 0x1d70f,
  :mathematical_italic_small_upsilon => 0x1d710,
  :mathematical_italic_small_phi => 0x1d711,
  :mathematical_italic_small_chi => 0x1d712,
  :mathematical_italic_small_psi => 0x1d713,
  :mathematical_italic_small_omega => 0x1d714,
  :mathematical_italic_partial_differential => 0x1d715,
  :mathematical_italic_epsilon_symbol => 0x1d716,
  :mathematical_italic_theta_symbol => 0x1d717,
  :mathematical_italic_kappa_symbol => 0x1d718,
  :mathematical_italic_phi_symbol => 0x1d719,
  :mathematical_italic_rho_symbol => 0x1d71a,
  :mathematical_italic_pi_symbol => 0x1d71b,
  :mathematical_bold_italic_capital_alpha => 0x1d71c,
  :mathematical_bold_italic_capital_beta => 0x1d71d,
  :mathematical_bold_italic_capital_gamma => 0x1d71e,
  :mathematical_bold_italic_capital_delta => 0x1d71f,
  :mathematical_bold_italic_capital_epsilon => 0x1d720,
  :mathematical_bold_italic_capital_zeta => 0x1d721,
  :mathematical_bold_italic_capital_eta => 0x1d722,
  :mathematical_bold_italic_capital_theta => 0x1d723,
  :mathematical_bold_italic_capital_iota => 0x1d724,
  :mathematical_bold_italic_capital_kappa => 0x1d725,
  :mathematical_bold_italic_capital_lamda => 0x1d726,
  :mathematical_bold_italic_capital_mu => 0x1d727,
  :mathematical_bold_italic_capital_nu => 0x1d728,
  :mathematical_bold_italic_capital_xi => 0x1d729,
  :mathematical_bold_italic_capital_omicron => 0x1d72a,
  :mathematical_bold_italic_capital_pi => 0x1d72b,
  :mathematical_bold_italic_capital_rho => 0x1d72c,
  :mathematical_bold_italic_capital_theta_symbol => 0x1d72d,
  :mathematical_bold_italic_capital_sigma => 0x1d72e,
  :mathematical_bold_italic_capital_tau => 0x1d72f,
  :mathematical_bold_italic_capital_upsilon => 0x1d730,
  :mathematical_bold_italic_capital_phi => 0x1d731,
  :mathematical_bold_italic_capital_chi => 0x1d732,
  :mathematical_bold_italic_capital_psi => 0x1d733,
  :mathematical_bold_italic_capital_omega => 0x1d734,
  :mathematical_bold_italic_nabla => 0x1d735,
  :mathematical_bold_italic_small_alpha => 0x1d736,
  :mathematical_bold_italic_small_beta => 0x1d737,
  :mathematical_bold_italic_small_gamma => 0x1d738,
  :mathematical_bold_italic_small_delta => 0x1d739,
  :mathematical_bold_italic_small_epsilon => 0x1d73a,
  :mathematical_bold_italic_small_zeta => 0x1d73b,
  :mathematical_bold_italic_small_eta => 0x1d73c,
  :mathematical_bold_italic_small_theta => 0x1d73d,
  :mathematical_bold_italic_small_iota => 0x1d73e,
  :mathematical_bold_italic_small_kappa => 0x1d73f,
  :mathematical_bold_italic_small_lamda => 0x1d740,
  :mathematical_bold_italic_small_mu => 0x1d741,
  :mathematical_bold_italic_small_nu => 0x1d742,
  :mathematical_bold_italic_small_xi => 0x1d743,
  :mathematical_bold_italic_small_omicron => 0x1d744,
  :mathematical_bold_italic_small_pi => 0x1d745,
  :mathematical_bold_italic_small_rho => 0x1d746,
  :mathematical_bold_italic_small_final_sigma => 0x1d747,
  :mathematical_bold_italic_small_sigma => 0x1d748,
  :mathematical_bold_italic_small_tau => 0x1d749,
  :mathematical_bold_italic_small_upsilon => 0x1d74a,
  :mathematical_bold_italic_small_phi => 0x1d74b,
  :mathematical_bold_italic_small_chi => 0x1d74c,
  :mathematical_bold_italic_small_psi => 0x1d74d,
  :mathematical_bold_italic_small_omega => 0x1d74e,
  :mathematical_bold_italic_partial_differential => 0x1d74f,
  :mathematical_bold_italic_epsilon_symbol => 0x1d750,
  :mathematical_bold_italic_theta_symbol => 0x1d751,
  :mathematical_bold_italic_kappa_symbol => 0x1d752,
  :mathematical_bold_italic_phi_symbol => 0x1d753,
  :mathematical_bold_italic_rho_symbol => 0x1d754,
  :mathematical_bold_italic_pi_symbol => 0x1d755,
  :mathematical_sans_serif_bold_capital_alpha => 0x1d756,
  :mathematical_sans_serif_bold_capital_beta => 0x1d757,
  :mathematical_sans_serif_bold_capital_gamma => 0x1d758,
  :mathematical_sans_serif_bold_capital_delta => 0x1d759,
  :mathematical_sans_serif_bold_capital_epsilon => 0x1d75a,
  :mathematical_sans_serif_bold_capital_zeta => 0x1d75b,
  :mathematical_sans_serif_bold_capital_eta => 0x1d75c,
  :mathematical_sans_serif_bold_capital_theta => 0x1d75d,
  :mathematical_sans_serif_bold_capital_iota => 0x1d75e,
  :mathematical_sans_serif_bold_capital_kappa => 0x1d75f,
  :mathematical_sans_serif_bold_capital_lamda => 0x1d760,
  :mathematical_sans_serif_bold_capital_mu => 0x1d761,
  :mathematical_sans_serif_bold_capital_nu => 0x1d762,
  :mathematical_sans_serif_bold_capital_xi => 0x1d763,
  :mathematical_sans_serif_bold_capital_omicron => 0x1d764,
  :mathematical_sans_serif_bold_capital_pi => 0x1d765,
  :mathematical_sans_serif_bold_capital_rho => 0x1d766,
  :mathematical_sans_serif_bold_capital_theta_symbol => 0x1d767,
  :mathematical_sans_serif_bold_capital_sigma => 0x1d768,
  :mathematical_sans_serif_bold_capital_tau => 0x1d769,
  :mathematical_sans_serif_bold_capital_upsilon => 0x1d76a,
  :mathematical_sans_serif_bold_capital_phi => 0x1d76b,
  :mathematical_sans_serif_bold_capital_chi => 0x1d76c,
  :mathematical_sans_serif_bold_capital_psi => 0x1d76d,
  :mathematical_sans_serif_bold_capital_omega => 0x1d76e,
  :mathematical_sans_serif_bold_nabla => 0x1d76f,
  :mathematical_sans_serif_bold_small_alpha => 0x1d770,
  :mathematical_sans_serif_bold_small_beta => 0x1d771,
  :mathematical_sans_serif_bold_small_gamma => 0x1d772,
  :mathematical_sans_serif_bold_small_delta => 0x1d773,
  :mathematical_sans_serif_bold_small_epsilon => 0x1d774,
  :mathematical_sans_serif_bold_small_zeta => 0x1d775,
  :mathematical_sans_serif_bold_small_eta => 0x1d776,
  :mathematical_sans_serif_bold_small_theta => 0x1d777,
  :mathematical_sans_serif_bold_small_iota => 0x1d778,
  :mathematical_sans_serif_bold_small_kappa => 0x1d779,
  :mathematical_sans_serif_bold_small_lamda => 0x1d77a,
  :mathematical_sans_serif_bold_small_mu => 0x1d77b,
  :mathematical_sans_serif_bold_small_nu => 0x1d77c,
  :mathematical_sans_serif_bold_small_xi => 0x1d77d,
  :mathematical_sans_serif_bold_small_omicron => 0x1d77e,
  :mathematical_sans_serif_bold_small_pi => 0x1d77f,
  :mathematical_sans_serif_bold_small_rho => 0x1d780,
  :mathematical_sans_serif_bold_small_final_sigma => 0x1d781,
  :mathematical_sans_serif_bold_small_sigma => 0x1d782,
  :mathematical_sans_serif_bold_small_tau => 0x1d783,
  :mathematical_sans_serif_bold_small_upsilon => 0x1d784,
  :mathematical_sans_serif_bold_small_phi => 0x1d785,
  :mathematical_sans_serif_bold_small_chi => 0x1d786,
  :mathematical_sans_serif_bold_small_psi => 0x1d787,
  :mathematical_sans_serif_bold_small_omega => 0x1d788,
  :mathematical_sans_serif_bold_partial_differential => 0x1d789,
  :mathematical_sans_serif_bold_epsilon_symbol => 0x1d78a,
  :mathematical_sans_serif_bold_theta_symbol => 0x1d78b,
  :mathematical_sans_serif_bold_kappa_symbol => 0x1d78c,
  :mathematical_sans_serif_bold_phi_symbol => 0x1d78d,
  :mathematical_sans_serif_bold_rho_symbol => 0x1d78e,
  :mathematical_sans_serif_bold_pi_symbol => 0x1d78f,
  :mathematical_sans_serif_bold_italic_capital_alpha => 0x1d790,
  :mathematical_sans_serif_bold_italic_capital_beta => 0x1d791,
  :mathematical_sans_serif_bold_italic_capital_gamma => 0x1d792,
  :mathematical_sans_serif_bold_italic_capital_delta => 0x1d793,
  :mathematical_sans_serif_bold_italic_capital_epsilon => 0x1d794,
  :mathematical_sans_serif_bold_italic_capital_zeta => 0x1d795,
  :mathematical_sans_serif_bold_italic_capital_eta => 0x1d796,
  :mathematical_sans_serif_bold_italic_capital_theta => 0x1d797,
  :mathematical_sans_serif_bold_italic_capital_iota => 0x1d798,
  :mathematical_sans_serif_bold_italic_capital_kappa => 0x1d799,
  :mathematical_sans_serif_bold_italic_capital_lamda => 0x1d79a,
  :mathematical_sans_serif_bold_italic_capital_mu => 0x1d79b,
  :mathematical_sans_serif_bold_italic_capital_nu => 0x1d79c,
  :mathematical_sans_serif_bold_italic_capital_xi => 0x1d79d,
  :mathematical_sans_serif_bold_italic_capital_omicron => 0x1d79e,
  :mathematical_sans_serif_bold_italic_capital_pi => 0x1d79f,
  :mathematical_sans_serif_bold_italic_capital_rho => 0x1d7a0,
  :mathematical_sans_serif_bold_italic_capital_theta_symbol => 0x1d7a1,
  :mathematical_sans_serif_bold_italic_capital_sigma => 0x1d7a2,
  :mathematical_sans_serif_bold_italic_capital_tau => 0x1d7a3,
  :mathematical_sans_serif_bold_italic_capital_upsilon => 0x1d7a4,
  :mathematical_sans_serif_bold_italic_capital_phi => 0x1d7a5,
  :mathematical_sans_serif_bold_italic_capital_chi => 0x1d7a6,
  :mathematical_sans_serif_bold_italic_capital_psi => 0x1d7a7,
  :mathematical_sans_serif_bold_italic_capital_omega => 0x1d7a8,
  :mathematical_sans_serif_bold_italic_nabla => 0x1d7a9,
  :mathematical_sans_serif_bold_italic_small_alpha => 0x1d7aa,
  :mathematical_sans_serif_bold_italic_small_beta => 0x1d7ab,
  :mathematical_sans_serif_bold_italic_small_gamma => 0x1d7ac,
  :mathematical_sans_serif_bold_italic_small_delta => 0x1d7ad,
  :mathematical_sans_serif_bold_italic_small_epsilon => 0x1d7ae,
  :mathematical_sans_serif_bold_italic_small_zeta => 0x1d7af,
  :mathematical_sans_serif_bold_italic_small_eta => 0x1d7b0,
  :mathematical_sans_serif_bold_italic_small_theta => 0x1d7b1,
  :mathematical_sans_serif_bold_italic_small_iota => 0x1d7b2,
  :mathematical_sans_serif_bold_italic_small_kappa => 0x1d7b3,
  :mathematical_sans_serif_bold_italic_small_lamda => 0x1d7b4,
  :mathematical_sans_serif_bold_italic_small_mu => 0x1d7b5,
  :mathematical_sans_serif_bold_italic_small_nu => 0x1d7b6,
  :mathematical_sans_serif_bold_italic_small_xi => 0x1d7b7,
  :mathematical_sans_serif_bold_italic_small_omicron => 0x1d7b8,
  :mathematical_sans_serif_bold_italic_small_pi => 0x1d7b9,
  :mathematical_sans_serif_bold_italic_small_rho => 0x1d7ba,
  :mathematical_sans_serif_bold_italic_small_final_sigma => 0x1d7bb,
  :mathematical_sans_serif_bold_italic_small_sigma => 0x1d7bc,
  :mathematical_sans_serif_bold_italic_small_tau => 0x1d7bd,
  :mathematical_sans_serif_bold_italic_small_upsilon => 0x1d7be,
  :mathematical_sans_serif_bold_italic_small_phi => 0x1d7bf,
  :mathematical_sans_serif_bold_italic_small_chi => 0x1d7c0,
  :mathematical_sans_serif_bold_italic_small_psi => 0x1d7c1,
  :mathematical_sans_serif_bold_italic_small_omega => 0x1d7c2,
  :mathematical_sans_serif_bold_italic_partial_differential => 0x1d7c3,
  :mathematical_sans_serif_bold_italic_epsilon_symbol => 0x1d7c4,
  :mathematical_sans_serif_bold_italic_theta_symbol => 0x1d7c5,
  :mathematical_sans_serif_bold_italic_kappa_symbol => 0x1d7c6,
  :mathematical_sans_serif_bold_italic_phi_symbol => 0x1d7c7,
  :mathematical_sans_serif_bold_italic_rho_symbol => 0x1d7c8,
  :mathematical_sans_serif_bold_italic_pi_symbol => 0x1d7c9,
  :mathematical_bold_digit_zero => 0x1d7ce,
  :mathematical_bold_digit_one => 0x1d7cf,
  :mathematical_bold_digit_two => 0x1d7d0,
  :mathematical_bold_digit_three => 0x1d7d1,
  :mathematical_bold_digit_four => 0x1d7d2,
  :mathematical_bold_digit_five => 0x1d7d3,
  :mathematical_bold_digit_six => 0x1d7d4,
  :mathematical_bold_digit_seven => 0x1d7d5,
  :mathematical_bold_digit_eight => 0x1d7d6,
  :mathematical_bold_digit_nine => 0x1d7d7,
  :mathematical_double_struck_digit_zero => 0x1d7d8,
  :mathematical_double_struck_digit_one => 0x1d7d9,
  :mathematical_double_struck_digit_two => 0x1d7da,
  :mathematical_double_struck_digit_three => 0x1d7db,
  :mathematical_double_struck_digit_four => 0x1d7dc,
  :mathematical_double_struck_digit_five => 0x1d7dd,
  :mathematical_double_struck_digit_six => 0x1d7de,
  :mathematical_double_struck_digit_seven => 0x1d7df,
  :mathematical_double_struck_digit_eight => 0x1d7e0,
  :mathematical_double_struck_digit_nine => 0x1d7e1,
  :mathematical_sans_serif_digit_zero => 0x1d7e2,
  :mathematical_sans_serif_digit_one => 0x1d7e3,
  :mathematical_sans_serif_digit_two => 0x1d7e4,
  :mathematical_sans_serif_digit_three => 0x1d7e5,
  :mathematical_sans_serif_digit_four => 0x1d7e6,
  :mathematical_sans_serif_digit_five => 0x1d7e7,
  :mathematical_sans_serif_digit_six => 0x1d7e8,
  :mathematical_sans_serif_digit_seven => 0x1d7e9,
  :mathematical_sans_serif_digit_eight => 0x1d7ea,
  :mathematical_sans_serif_digit_nine => 0x1d7eb,
  :mathematical_sans_serif_bold_digit_zero => 0x1d7ec,
  :mathematical_sans_serif_bold_digit_one => 0x1d7ed,
  :mathematical_sans_serif_bold_digit_two => 0x1d7ee,
  :mathematical_sans_serif_bold_digit_three => 0x1d7ef,
  :mathematical_sans_serif_bold_digit_four => 0x1d7f0,
  :mathematical_sans_serif_bold_digit_five => 0x1d7f1,
  :mathematical_sans_serif_bold_digit_six => 0x1d7f2,
  :mathematical_sans_serif_bold_digit_seven => 0x1d7f3,
  :mathematical_sans_serif_bold_digit_eight => 0x1d7f4,
  :mathematical_sans_serif_bold_digit_nine => 0x1d7f5,
  :mathematical_monospace_digit_zero => 0x1d7f6,
  :mathematical_monospace_digit_one => 0x1d7f7,
  :mathematical_monospace_digit_two => 0x1d7f8,
  :mathematical_monospace_digit_three => 0x1d7f9,
  :mathematical_monospace_digit_four => 0x1d7fa,
  :mathematical_monospace_digit_five => 0x1d7fb,
  :mathematical_monospace_digit_six => 0x1d7fc,
  :mathematical_monospace_digit_seven => 0x1d7fd,
  :mathematical_monospace_digit_eight => 0x1d7fe,
  :mathematical_monospace_digit_nine => 0x1d7ff,
  :cjk_compatibility_ideograph_2f800 => 0x2f800,
  :cjk_compatibility_ideograph_2f801 => 0x2f801,
  :cjk_compatibility_ideograph_2f802 => 0x2f802,
  :cjk_compatibility_ideograph_2f803 => 0x2f803,
  :cjk_compatibility_ideograph_2f804 => 0x2f804,
  :cjk_compatibility_ideograph_2f805 => 0x2f805,
  :cjk_compatibility_ideograph_2f806 => 0x2f806,
  :cjk_compatibility_ideograph_2f807 => 0x2f807,
  :cjk_compatibility_ideograph_2f808 => 0x2f808,
  :cjk_compatibility_ideograph_2f809 => 0x2f809,
  :cjk_compatibility_ideograph_2f80a => 0x2f80a,
  :cjk_compatibility_ideograph_2f80b => 0x2f80b,
  :cjk_compatibility_ideograph_2f80c => 0x2f80c,
  :cjk_compatibility_ideograph_2f80d => 0x2f80d,
  :cjk_compatibility_ideograph_2f80e => 0x2f80e,
  :cjk_compatibility_ideograph_2f80f => 0x2f80f,
  :cjk_compatibility_ideograph_2f810 => 0x2f810,
  :cjk_compatibility_ideograph_2f811 => 0x2f811,
  :cjk_compatibility_ideograph_2f812 => 0x2f812,
  :cjk_compatibility_ideograph_2f813 => 0x2f813,
  :cjk_compatibility_ideograph_2f814 => 0x2f814,
  :cjk_compatibility_ideograph_2f815 => 0x2f815,
  :cjk_compatibility_ideograph_2f816 => 0x2f816,
  :cjk_compatibility_ideograph_2f817 => 0x2f817,
  :cjk_compatibility_ideograph_2f818 => 0x2f818,
  :cjk_compatibility_ideograph_2f819 => 0x2f819,
  :cjk_compatibility_ideograph_2f81a => 0x2f81a,
  :cjk_compatibility_ideograph_2f81b => 0x2f81b,
  :cjk_compatibility_ideograph_2f81c => 0x2f81c,
  :cjk_compatibility_ideograph_2f81d => 0x2f81d,
  :cjk_compatibility_ideograph_2f81e => 0x2f81e,
  :cjk_compatibility_ideograph_2f81f => 0x2f81f,
  :cjk_compatibility_ideograph_2f820 => 0x2f820,
  :cjk_compatibility_ideograph_2f821 => 0x2f821,
  :cjk_compatibility_ideograph_2f822 => 0x2f822,
  :cjk_compatibility_ideograph_2f823 => 0x2f823,
  :cjk_compatibility_ideograph_2f824 => 0x2f824,
  :cjk_compatibility_ideograph_2f825 => 0x2f825,
  :cjk_compatibility_ideograph_2f826 => 0x2f826,
  :cjk_compatibility_ideograph_2f827 => 0x2f827,
  :cjk_compatibility_ideograph_2f828 => 0x2f828,
  :cjk_compatibility_ideograph_2f829 => 0x2f829,
  :cjk_compatibility_ideograph_2f82a => 0x2f82a,
  :cjk_compatibility_ideograph_2f82b => 0x2f82b,
  :cjk_compatibility_ideograph_2f82c => 0x2f82c,
  :cjk_compatibility_ideograph_2f82d => 0x2f82d,
  :cjk_compatibility_ideograph_2f82e => 0x2f82e,
  :cjk_compatibility_ideograph_2f82f => 0x2f82f,
  :cjk_compatibility_ideograph_2f830 => 0x2f830,
  :cjk_compatibility_ideograph_2f831 => 0x2f831,
  :cjk_compatibility_ideograph_2f832 => 0x2f832,
  :cjk_compatibility_ideograph_2f833 => 0x2f833,
  :cjk_compatibility_ideograph_2f834 => 0x2f834,
  :cjk_compatibility_ideograph_2f835 => 0x2f835,
  :cjk_compatibility_ideograph_2f836 => 0x2f836,
  :cjk_compatibility_ideograph_2f837 => 0x2f837,
  :cjk_compatibility_ideograph_2f838 => 0x2f838,
  :cjk_compatibility_ideograph_2f839 => 0x2f839,
  :cjk_compatibility_ideograph_2f83a => 0x2f83a,
  :cjk_compatibility_ideograph_2f83b => 0x2f83b,
  :cjk_compatibility_ideograph_2f83c => 0x2f83c,
  :cjk_compatibility_ideograph_2f83d => 0x2f83d,
  :cjk_compatibility_ideograph_2f83e => 0x2f83e,
  :cjk_compatibility_ideograph_2f83f => 0x2f83f,
  :cjk_compatibility_ideograph_2f840 => 0x2f840,
  :cjk_compatibility_ideograph_2f841 => 0x2f841,
  :cjk_compatibility_ideograph_2f842 => 0x2f842,
  :cjk_compatibility_ideograph_2f843 => 0x2f843,
  :cjk_compatibility_ideograph_2f844 => 0x2f844,
  :cjk_compatibility_ideograph_2f845 => 0x2f845,
  :cjk_compatibility_ideograph_2f846 => 0x2f846,
  :cjk_compatibility_ideograph_2f847 => 0x2f847,
  :cjk_compatibility_ideograph_2f848 => 0x2f848,
  :cjk_compatibility_ideograph_2f849 => 0x2f849,
  :cjk_compatibility_ideograph_2f84a => 0x2f84a,
  :cjk_compatibility_ideograph_2f84b => 0x2f84b,
  :cjk_compatibility_ideograph_2f84c => 0x2f84c,
  :cjk_compatibility_ideograph_2f84d => 0x2f84d,
  :cjk_compatibility_ideograph_2f84e => 0x2f84e,
  :cjk_compatibility_ideograph_2f84f => 0x2f84f,
  :cjk_compatibility_ideograph_2f850 => 0x2f850,
  :cjk_compatibility_ideograph_2f851 => 0x2f851,
  :cjk_compatibility_ideograph_2f852 => 0x2f852,
  :cjk_compatibility_ideograph_2f853 => 0x2f853,
  :cjk_compatibility_ideograph_2f854 => 0x2f854,
  :cjk_compatibility_ideograph_2f855 => 0x2f855,
  :cjk_compatibility_ideograph_2f856 => 0x2f856,
  :cjk_compatibility_ideograph_2f857 => 0x2f857,
  :cjk_compatibility_ideograph_2f858 => 0x2f858,
  :cjk_compatibility_ideograph_2f859 => 0x2f859,
  :cjk_compatibility_ideograph_2f85a => 0x2f85a,
  :cjk_compatibility_ideograph_2f85b => 0x2f85b,
  :cjk_compatibility_ideograph_2f85c => 0x2f85c,
  :cjk_compatibility_ideograph_2f85d => 0x2f85d,
  :cjk_compatibility_ideograph_2f85e => 0x2f85e,
  :cjk_compatibility_ideograph_2f85f => 0x2f85f,
  :cjk_compatibility_ideograph_2f860 => 0x2f860,
  :cjk_compatibility_ideograph_2f861 => 0x2f861,
  :cjk_compatibility_ideograph_2f862 => 0x2f862,
  :cjk_compatibility_ideograph_2f863 => 0x2f863,
  :cjk_compatibility_ideograph_2f864 => 0x2f864,
  :cjk_compatibility_ideograph_2f865 => 0x2f865,
  :cjk_compatibility_ideograph_2f866 => 0x2f866,
  :cjk_compatibility_ideograph_2f867 => 0x2f867,
  :cjk_compatibility_ideograph_2f868 => 0x2f868,
  :cjk_compatibility_ideograph_2f869 => 0x2f869,
  :cjk_compatibility_ideograph_2f86a => 0x2f86a,
  :cjk_compatibility_ideograph_2f86b => 0x2f86b,
  :cjk_compatibility_ideograph_2f86c => 0x2f86c,
  :cjk_compatibility_ideograph_2f86d => 0x2f86d,
  :cjk_compatibility_ideograph_2f86e => 0x2f86e,
  :cjk_compatibility_ideograph_2f86f => 0x2f86f,
  :cjk_compatibility_ideograph_2f870 => 0x2f870,
  :cjk_compatibility_ideograph_2f871 => 0x2f871,
  :cjk_compatibility_ideograph_2f872 => 0x2f872,
  :cjk_compatibility_ideograph_2f873 => 0x2f873,
  :cjk_compatibility_ideograph_2f874 => 0x2f874,
  :cjk_compatibility_ideograph_2f875 => 0x2f875,
  :cjk_compatibility_ideograph_2f876 => 0x2f876,
  :cjk_compatibility_ideograph_2f877 => 0x2f877,
  :cjk_compatibility_ideograph_2f878 => 0x2f878,
  :cjk_compatibility_ideograph_2f879 => 0x2f879,
  :cjk_compatibility_ideograph_2f87a => 0x2f87a,
  :cjk_compatibility_ideograph_2f87b => 0x2f87b,
  :cjk_compatibility_ideograph_2f87c => 0x2f87c,
  :cjk_compatibility_ideograph_2f87d => 0x2f87d,
  :cjk_compatibility_ideograph_2f87e => 0x2f87e,
  :cjk_compatibility_ideograph_2f87f => 0x2f87f,
  :cjk_compatibility_ideograph_2f880 => 0x2f880,
  :cjk_compatibility_ideograph_2f881 => 0x2f881,
  :cjk_compatibility_ideograph_2f882 => 0x2f882,
  :cjk_compatibility_ideograph_2f883 => 0x2f883,
  :cjk_compatibility_ideograph_2f884 => 0x2f884,
  :cjk_compatibility_ideograph_2f885 => 0x2f885,
  :cjk_compatibility_ideograph_2f886 => 0x2f886,
  :cjk_compatibility_ideograph_2f887 => 0x2f887,
  :cjk_compatibility_ideograph_2f888 => 0x2f888,
  :cjk_compatibility_ideograph_2f889 => 0x2f889,
  :cjk_compatibility_ideograph_2f88a => 0x2f88a,
  :cjk_compatibility_ideograph_2f88b => 0x2f88b,
  :cjk_compatibility_ideograph_2f88c => 0x2f88c,
  :cjk_compatibility_ideograph_2f88d => 0x2f88d,
  :cjk_compatibility_ideograph_2f88e => 0x2f88e,
  :cjk_compatibility_ideograph_2f88f => 0x2f88f,
  :cjk_compatibility_ideograph_2f890 => 0x2f890,
  :cjk_compatibility_ideograph_2f891 => 0x2f891,
  :cjk_compatibility_ideograph_2f892 => 0x2f892,
  :cjk_compatibility_ideograph_2f893 => 0x2f893,
  :cjk_compatibility_ideograph_2f894 => 0x2f894,
  :cjk_compatibility_ideograph_2f895 => 0x2f895,
  :cjk_compatibility_ideograph_2f896 => 0x2f896,
  :cjk_compatibility_ideograph_2f897 => 0x2f897,
  :cjk_compatibility_ideograph_2f898 => 0x2f898,
  :cjk_compatibility_ideograph_2f899 => 0x2f899,
  :cjk_compatibility_ideograph_2f89a => 0x2f89a,
  :cjk_compatibility_ideograph_2f89b => 0x2f89b,
  :cjk_compatibility_ideograph_2f89c => 0x2f89c,
  :cjk_compatibility_ideograph_2f89d => 0x2f89d,
  :cjk_compatibility_ideograph_2f89e => 0x2f89e,
  :cjk_compatibility_ideograph_2f89f => 0x2f89f,
  :cjk_compatibility_ideograph_2f8a0 => 0x2f8a0,
  :cjk_compatibility_ideograph_2f8a1 => 0x2f8a1,
  :cjk_compatibility_ideograph_2f8a2 => 0x2f8a2,
  :cjk_compatibility_ideograph_2f8a3 => 0x2f8a3,
  :cjk_compatibility_ideograph_2f8a4 => 0x2f8a4,
  :cjk_compatibility_ideograph_2f8a5 => 0x2f8a5,
  :cjk_compatibility_ideograph_2f8a6 => 0x2f8a6,
  :cjk_compatibility_ideograph_2f8a7 => 0x2f8a7,
  :cjk_compatibility_ideograph_2f8a8 => 0x2f8a8,
  :cjk_compatibility_ideograph_2f8a9 => 0x2f8a9,
  :cjk_compatibility_ideograph_2f8aa => 0x2f8aa,
  :cjk_compatibility_ideograph_2f8ab => 0x2f8ab,
  :cjk_compatibility_ideograph_2f8ac => 0x2f8ac,
  :cjk_compatibility_ideograph_2f8ad => 0x2f8ad,
  :cjk_compatibility_ideograph_2f8ae => 0x2f8ae,
  :cjk_compatibility_ideograph_2f8af => 0x2f8af,
  :cjk_compatibility_ideograph_2f8b0 => 0x2f8b0,
  :cjk_compatibility_ideograph_2f8b1 => 0x2f8b1,
  :cjk_compatibility_ideograph_2f8b2 => 0x2f8b2,
  :cjk_compatibility_ideograph_2f8b3 => 0x2f8b3,
  :cjk_compatibility_ideograph_2f8b4 => 0x2f8b4,
  :cjk_compatibility_ideograph_2f8b5 => 0x2f8b5,
  :cjk_compatibility_ideograph_2f8b6 => 0x2f8b6,
  :cjk_compatibility_ideograph_2f8b7 => 0x2f8b7,
  :cjk_compatibility_ideograph_2f8b8 => 0x2f8b8,
  :cjk_compatibility_ideograph_2f8b9 => 0x2f8b9,
  :cjk_compatibility_ideograph_2f8ba => 0x2f8ba,
  :cjk_compatibility_ideograph_2f8bb => 0x2f8bb,
  :cjk_compatibility_ideograph_2f8bc => 0x2f8bc,
  :cjk_compatibility_ideograph_2f8bd => 0x2f8bd,
  :cjk_compatibility_ideograph_2f8be => 0x2f8be,
  :cjk_compatibility_ideograph_2f8bf => 0x2f8bf,
  :cjk_compatibility_ideograph_2f8c0 => 0x2f8c0,
  :cjk_compatibility_ideograph_2f8c1 => 0x2f8c1,
  :cjk_compatibility_ideograph_2f8c2 => 0x2f8c2,
  :cjk_compatibility_ideograph_2f8c3 => 0x2f8c3,
  :cjk_compatibility_ideograph_2f8c4 => 0x2f8c4,
  :cjk_compatibility_ideograph_2f8c5 => 0x2f8c5,
  :cjk_compatibility_ideograph_2f8c6 => 0x2f8c6,
  :cjk_compatibility_ideograph_2f8c7 => 0x2f8c7,
  :cjk_compatibility_ideograph_2f8c8 => 0x2f8c8,
  :cjk_compatibility_ideograph_2f8c9 => 0x2f8c9,
  :cjk_compatibility_ideograph_2f8ca => 0x2f8ca,
  :cjk_compatibility_ideograph_2f8cb => 0x2f8cb,
  :cjk_compatibility_ideograph_2f8cc => 0x2f8cc,
  :cjk_compatibility_ideograph_2f8cd => 0x2f8cd,
  :cjk_compatibility_ideograph_2f8ce => 0x2f8ce,
  :cjk_compatibility_ideograph_2f8cf => 0x2f8cf,
  :cjk_compatibility_ideograph_2f8d0 => 0x2f8d0,
  :cjk_compatibility_ideograph_2f8d1 => 0x2f8d1,
  :cjk_compatibility_ideograph_2f8d2 => 0x2f8d2,
  :cjk_compatibility_ideograph_2f8d3 => 0x2f8d3,
  :cjk_compatibility_ideograph_2f8d4 => 0x2f8d4,
  :cjk_compatibility_ideograph_2f8d5 => 0x2f8d5,
  :cjk_compatibility_ideograph_2f8d6 => 0x2f8d6,
  :cjk_compatibility_ideograph_2f8d7 => 0x2f8d7,
  :cjk_compatibility_ideograph_2f8d8 => 0x2f8d8,
  :cjk_compatibility_ideograph_2f8d9 => 0x2f8d9,
  :cjk_compatibility_ideograph_2f8da => 0x2f8da,
  :cjk_compatibility_ideograph_2f8db => 0x2f8db,
  :cjk_compatibility_ideograph_2f8dc => 0x2f8dc,
  :cjk_compatibility_ideograph_2f8dd => 0x2f8dd,
  :cjk_compatibility_ideograph_2f8de => 0x2f8de,
  :cjk_compatibility_ideograph_2f8df => 0x2f8df,
  :cjk_compatibility_ideograph_2f8e0 => 0x2f8e0,
  :cjk_compatibility_ideograph_2f8e1 => 0x2f8e1,
  :cjk_compatibility_ideograph_2f8e2 => 0x2f8e2,
  :cjk_compatibility_ideograph_2f8e3 => 0x2f8e3,
  :cjk_compatibility_ideograph_2f8e4 => 0x2f8e4,
  :cjk_compatibility_ideograph_2f8e5 => 0x2f8e5,
  :cjk_compatibility_ideograph_2f8e6 => 0x2f8e6,
  :cjk_compatibility_ideograph_2f8e7 => 0x2f8e7,
  :cjk_compatibility_ideograph_2f8e8 => 0x2f8e8,
  :cjk_compatibility_ideograph_2f8e9 => 0x2f8e9,
  :cjk_compatibility_ideograph_2f8ea => 0x2f8ea,
  :cjk_compatibility_ideograph_2f8eb => 0x2f8eb,
  :cjk_compatibility_ideograph_2f8ec => 0x2f8ec,
  :cjk_compatibility_ideograph_2f8ed => 0x2f8ed,
  :cjk_compatibility_ideograph_2f8ee => 0x2f8ee,
  :cjk_compatibility_ideograph_2f8ef => 0x2f8ef,
  :cjk_compatibility_ideograph_2f8f0 => 0x2f8f0,
  :cjk_compatibility_ideograph_2f8f1 => 0x2f8f1,
  :cjk_compatibility_ideograph_2f8f2 => 0x2f8f2,
  :cjk_compatibility_ideograph_2f8f3 => 0x2f8f3,
  :cjk_compatibility_ideograph_2f8f4 => 0x2f8f4,
  :cjk_compatibility_ideograph_2f8f5 => 0x2f8f5,
  :cjk_compatibility_ideograph_2f8f6 => 0x2f8f6,
  :cjk_compatibility_ideograph_2f8f7 => 0x2f8f7,
  :cjk_compatibility_ideograph_2f8f8 => 0x2f8f8,
  :cjk_compatibility_ideograph_2f8f9 => 0x2f8f9,
  :cjk_compatibility_ideograph_2f8fa => 0x2f8fa,
  :cjk_compatibility_ideograph_2f8fb => 0x2f8fb,
  :cjk_compatibility_ideograph_2f8fc => 0x2f8fc,
  :cjk_compatibility_ideograph_2f8fd => 0x2f8fd,
  :cjk_compatibility_ideograph_2f8fe => 0x2f8fe,
  :cjk_compatibility_ideograph_2f8ff => 0x2f8ff,
  :cjk_compatibility_ideograph_2f900 => 0x2f900,
  :cjk_compatibility_ideograph_2f901 => 0x2f901,
  :cjk_compatibility_ideograph_2f902 => 0x2f902,
  :cjk_compatibility_ideograph_2f903 => 0x2f903,
  :cjk_compatibility_ideograph_2f904 => 0x2f904,
  :cjk_compatibility_ideograph_2f905 => 0x2f905,
  :cjk_compatibility_ideograph_2f906 => 0x2f906,
  :cjk_compatibility_ideograph_2f907 => 0x2f907,
  :cjk_compatibility_ideograph_2f908 => 0x2f908,
  :cjk_compatibility_ideograph_2f909 => 0x2f909,
  :cjk_compatibility_ideograph_2f90a => 0x2f90a,
  :cjk_compatibility_ideograph_2f90b => 0x2f90b,
  :cjk_compatibility_ideograph_2f90c => 0x2f90c,
  :cjk_compatibility_ideograph_2f90d => 0x2f90d,
  :cjk_compatibility_ideograph_2f90e => 0x2f90e,
  :cjk_compatibility_ideograph_2f90f => 0x2f90f,
  :cjk_compatibility_ideograph_2f910 => 0x2f910,
  :cjk_compatibility_ideograph_2f911 => 0x2f911,
  :cjk_compatibility_ideograph_2f912 => 0x2f912,
  :cjk_compatibility_ideograph_2f913 => 0x2f913,
  :cjk_compatibility_ideograph_2f914 => 0x2f914,
  :cjk_compatibility_ideograph_2f915 => 0x2f915,
  :cjk_compatibility_ideograph_2f916 => 0x2f916,
  :cjk_compatibility_ideograph_2f917 => 0x2f917,
  :cjk_compatibility_ideograph_2f918 => 0x2f918,
  :cjk_compatibility_ideograph_2f919 => 0x2f919,
  :cjk_compatibility_ideograph_2f91a => 0x2f91a,
  :cjk_compatibility_ideograph_2f91b => 0x2f91b,
  :cjk_compatibility_ideograph_2f91c => 0x2f91c,
  :cjk_compatibility_ideograph_2f91d => 0x2f91d,
  :cjk_compatibility_ideograph_2f91e => 0x2f91e,
  :cjk_compatibility_ideograph_2f91f => 0x2f91f,
  :cjk_compatibility_ideograph_2f920 => 0x2f920,
  :cjk_compatibility_ideograph_2f921 => 0x2f921,
  :cjk_compatibility_ideograph_2f922 => 0x2f922,
  :cjk_compatibility_ideograph_2f923 => 0x2f923,
  :cjk_compatibility_ideograph_2f924 => 0x2f924,
  :cjk_compatibility_ideograph_2f925 => 0x2f925,
  :cjk_compatibility_ideograph_2f926 => 0x2f926,
  :cjk_compatibility_ideograph_2f927 => 0x2f927,
  :cjk_compatibility_ideograph_2f928 => 0x2f928,
  :cjk_compatibility_ideograph_2f929 => 0x2f929,
  :cjk_compatibility_ideograph_2f92a => 0x2f92a,
  :cjk_compatibility_ideograph_2f92b => 0x2f92b,
  :cjk_compatibility_ideograph_2f92c => 0x2f92c,
  :cjk_compatibility_ideograph_2f92d => 0x2f92d,
  :cjk_compatibility_ideograph_2f92e => 0x2f92e,
  :cjk_compatibility_ideograph_2f92f => 0x2f92f,
  :cjk_compatibility_ideograph_2f930 => 0x2f930,
  :cjk_compatibility_ideograph_2f931 => 0x2f931,
  :cjk_compatibility_ideograph_2f932 => 0x2f932,
  :cjk_compatibility_ideograph_2f933 => 0x2f933,
  :cjk_compatibility_ideograph_2f934 => 0x2f934,
  :cjk_compatibility_ideograph_2f935 => 0x2f935,
  :cjk_compatibility_ideograph_2f936 => 0x2f936,
  :cjk_compatibility_ideograph_2f937 => 0x2f937,
  :cjk_compatibility_ideograph_2f938 => 0x2f938,
  :cjk_compatibility_ideograph_2f939 => 0x2f939,
  :cjk_compatibility_ideograph_2f93a => 0x2f93a,
  :cjk_compatibility_ideograph_2f93b => 0x2f93b,
  :cjk_compatibility_ideograph_2f93c => 0x2f93c,
  :cjk_compatibility_ideograph_2f93d => 0x2f93d,
  :cjk_compatibility_ideograph_2f93e => 0x2f93e,
  :cjk_compatibility_ideograph_2f93f => 0x2f93f,
  :cjk_compatibility_ideograph_2f940 => 0x2f940,
  :cjk_compatibility_ideograph_2f941 => 0x2f941,
  :cjk_compatibility_ideograph_2f942 => 0x2f942,
  :cjk_compatibility_ideograph_2f943 => 0x2f943,
  :cjk_compatibility_ideograph_2f944 => 0x2f944,
  :cjk_compatibility_ideograph_2f945 => 0x2f945,
  :cjk_compatibility_ideograph_2f946 => 0x2f946,
  :cjk_compatibility_ideograph_2f947 => 0x2f947,
  :cjk_compatibility_ideograph_2f948 => 0x2f948,
  :cjk_compatibility_ideograph_2f949 => 0x2f949,
  :cjk_compatibility_ideograph_2f94a => 0x2f94a,
  :cjk_compatibility_ideograph_2f94b => 0x2f94b,
  :cjk_compatibility_ideograph_2f94c => 0x2f94c,
  :cjk_compatibility_ideograph_2f94d => 0x2f94d,
  :cjk_compatibility_ideograph_2f94e => 0x2f94e,
  :cjk_compatibility_ideograph_2f94f => 0x2f94f,
  :cjk_compatibility_ideograph_2f950 => 0x2f950,
  :cjk_compatibility_ideograph_2f951 => 0x2f951,
  :cjk_compatibility_ideograph_2f952 => 0x2f952,
  :cjk_compatibility_ideograph_2f953 => 0x2f953,
  :cjk_compatibility_ideograph_2f954 => 0x2f954,
  :cjk_compatibility_ideograph_2f955 => 0x2f955,
  :cjk_compatibility_ideograph_2f956 => 0x2f956,
  :cjk_compatibility_ideograph_2f957 => 0x2f957,
  :cjk_compatibility_ideograph_2f958 => 0x2f958,
  :cjk_compatibility_ideograph_2f959 => 0x2f959,
  :cjk_compatibility_ideograph_2f95a => 0x2f95a,
  :cjk_compatibility_ideograph_2f95b => 0x2f95b,
  :cjk_compatibility_ideograph_2f95c => 0x2f95c,
  :cjk_compatibility_ideograph_2f95d => 0x2f95d,
  :cjk_compatibility_ideograph_2f95e => 0x2f95e,
  :cjk_compatibility_ideograph_2f95f => 0x2f95f,
  :cjk_compatibility_ideograph_2f960 => 0x2f960,
  :cjk_compatibility_ideograph_2f961 => 0x2f961,
  :cjk_compatibility_ideograph_2f962 => 0x2f962,
  :cjk_compatibility_ideograph_2f963 => 0x2f963,
  :cjk_compatibility_ideograph_2f964 => 0x2f964,
  :cjk_compatibility_ideograph_2f965 => 0x2f965,
  :cjk_compatibility_ideograph_2f966 => 0x2f966,
  :cjk_compatibility_ideograph_2f967 => 0x2f967,
  :cjk_compatibility_ideograph_2f968 => 0x2f968,
  :cjk_compatibility_ideograph_2f969 => 0x2f969,
  :cjk_compatibility_ideograph_2f96a => 0x2f96a,
  :cjk_compatibility_ideograph_2f96b => 0x2f96b,
  :cjk_compatibility_ideograph_2f96c => 0x2f96c,
  :cjk_compatibility_ideograph_2f96d => 0x2f96d,
  :cjk_compatibility_ideograph_2f96e => 0x2f96e,
  :cjk_compatibility_ideograph_2f96f => 0x2f96f,
  :cjk_compatibility_ideograph_2f970 => 0x2f970,
  :cjk_compatibility_ideograph_2f971 => 0x2f971,
  :cjk_compatibility_ideograph_2f972 => 0x2f972,
  :cjk_compatibility_ideograph_2f973 => 0x2f973,
  :cjk_compatibility_ideograph_2f974 => 0x2f974,
  :cjk_compatibility_ideograph_2f975 => 0x2f975,
  :cjk_compatibility_ideograph_2f976 => 0x2f976,
  :cjk_compatibility_ideograph_2f977 => 0x2f977,
  :cjk_compatibility_ideograph_2f978 => 0x2f978,
  :cjk_compatibility_ideograph_2f979 => 0x2f979,
  :cjk_compatibility_ideograph_2f97a => 0x2f97a,
  :cjk_compatibility_ideograph_2f97b => 0x2f97b,
  :cjk_compatibility_ideograph_2f97c => 0x2f97c,
  :cjk_compatibility_ideograph_2f97d => 0x2f97d,
  :cjk_compatibility_ideograph_2f97e => 0x2f97e,
  :cjk_compatibility_ideograph_2f97f => 0x2f97f,
  :cjk_compatibility_ideograph_2f980 => 0x2f980,
  :cjk_compatibility_ideograph_2f981 => 0x2f981,
  :cjk_compatibility_ideograph_2f982 => 0x2f982,
  :cjk_compatibility_ideograph_2f983 => 0x2f983,
  :cjk_compatibility_ideograph_2f984 => 0x2f984,
  :cjk_compatibility_ideograph_2f985 => 0x2f985,
  :cjk_compatibility_ideograph_2f986 => 0x2f986,
  :cjk_compatibility_ideograph_2f987 => 0x2f987,
  :cjk_compatibility_ideograph_2f988 => 0x2f988,
  :cjk_compatibility_ideograph_2f989 => 0x2f989,
  :cjk_compatibility_ideograph_2f98a => 0x2f98a,
  :cjk_compatibility_ideograph_2f98b => 0x2f98b,
  :cjk_compatibility_ideograph_2f98c => 0x2f98c,
  :cjk_compatibility_ideograph_2f98d => 0x2f98d,
  :cjk_compatibility_ideograph_2f98e => 0x2f98e,
  :cjk_compatibility_ideograph_2f98f => 0x2f98f,
  :cjk_compatibility_ideograph_2f990 => 0x2f990,
  :cjk_compatibility_ideograph_2f991 => 0x2f991,
  :cjk_compatibility_ideograph_2f992 => 0x2f992,
  :cjk_compatibility_ideograph_2f993 => 0x2f993,
  :cjk_compatibility_ideograph_2f994 => 0x2f994,
  :cjk_compatibility_ideograph_2f995 => 0x2f995,
  :cjk_compatibility_ideograph_2f996 => 0x2f996,
  :cjk_compatibility_ideograph_2f997 => 0x2f997,
  :cjk_compatibility_ideograph_2f998 => 0x2f998,
  :cjk_compatibility_ideograph_2f999 => 0x2f999,
  :cjk_compatibility_ideograph_2f99a => 0x2f99a,
  :cjk_compatibility_ideograph_2f99b => 0x2f99b,
  :cjk_compatibility_ideograph_2f99c => 0x2f99c,
  :cjk_compatibility_ideograph_2f99d => 0x2f99d,
  :cjk_compatibility_ideograph_2f99e => 0x2f99e,
  :cjk_compatibility_ideograph_2f99f => 0x2f99f,
  :cjk_compatibility_ideograph_2f9a0 => 0x2f9a0,
  :cjk_compatibility_ideograph_2f9a1 => 0x2f9a1,
  :cjk_compatibility_ideograph_2f9a2 => 0x2f9a2,
  :cjk_compatibility_ideograph_2f9a3 => 0x2f9a3,
  :cjk_compatibility_ideograph_2f9a4 => 0x2f9a4,
  :cjk_compatibility_ideograph_2f9a5 => 0x2f9a5,
  :cjk_compatibility_ideograph_2f9a6 => 0x2f9a6,
  :cjk_compatibility_ideograph_2f9a7 => 0x2f9a7,
  :cjk_compatibility_ideograph_2f9a8 => 0x2f9a8,
  :cjk_compatibility_ideograph_2f9a9 => 0x2f9a9,
  :cjk_compatibility_ideograph_2f9aa => 0x2f9aa,
  :cjk_compatibility_ideograph_2f9ab => 0x2f9ab,
  :cjk_compatibility_ideograph_2f9ac => 0x2f9ac,
  :cjk_compatibility_ideograph_2f9ad => 0x2f9ad,
  :cjk_compatibility_ideograph_2f9ae => 0x2f9ae,
  :cjk_compatibility_ideograph_2f9af => 0x2f9af,
  :cjk_compatibility_ideograph_2f9b0 => 0x2f9b0,
  :cjk_compatibility_ideograph_2f9b1 => 0x2f9b1,
  :cjk_compatibility_ideograph_2f9b2 => 0x2f9b2,
  :cjk_compatibility_ideograph_2f9b3 => 0x2f9b3,
  :cjk_compatibility_ideograph_2f9b4 => 0x2f9b4,
  :cjk_compatibility_ideograph_2f9b5 => 0x2f9b5,
  :cjk_compatibility_ideograph_2f9b6 => 0x2f9b6,
  :cjk_compatibility_ideograph_2f9b7 => 0x2f9b7,
  :cjk_compatibility_ideograph_2f9b8 => 0x2f9b8,
  :cjk_compatibility_ideograph_2f9b9 => 0x2f9b9,
  :cjk_compatibility_ideograph_2f9ba => 0x2f9ba,
  :cjk_compatibility_ideograph_2f9bb => 0x2f9bb,
  :cjk_compatibility_ideograph_2f9bc => 0x2f9bc,
  :cjk_compatibility_ideograph_2f9bd => 0x2f9bd,
  :cjk_compatibility_ideograph_2f9be => 0x2f9be,
  :cjk_compatibility_ideograph_2f9bf => 0x2f9bf,
  :cjk_compatibility_ideograph_2f9c0 => 0x2f9c0,
  :cjk_compatibility_ideograph_2f9c1 => 0x2f9c1,
  :cjk_compatibility_ideograph_2f9c2 => 0x2f9c2,
  :cjk_compatibility_ideograph_2f9c3 => 0x2f9c3,
  :cjk_compatibility_ideograph_2f9c4 => 0x2f9c4,
  :cjk_compatibility_ideograph_2f9c5 => 0x2f9c5,
  :cjk_compatibility_ideograph_2f9c6 => 0x2f9c6,
  :cjk_compatibility_ideograph_2f9c7 => 0x2f9c7,
  :cjk_compatibility_ideograph_2f9c8 => 0x2f9c8,
  :cjk_compatibility_ideograph_2f9c9 => 0x2f9c9,
  :cjk_compatibility_ideograph_2f9ca => 0x2f9ca,
  :cjk_compatibility_ideograph_2f9cb => 0x2f9cb,
  :cjk_compatibility_ideograph_2f9cc => 0x2f9cc,
  :cjk_compatibility_ideograph_2f9cd => 0x2f9cd,
  :cjk_compatibility_ideograph_2f9ce => 0x2f9ce,
  :cjk_compatibility_ideograph_2f9cf => 0x2f9cf,
  :cjk_compatibility_ideograph_2f9d0 => 0x2f9d0,
  :cjk_compatibility_ideograph_2f9d1 => 0x2f9d1,
  :cjk_compatibility_ideograph_2f9d2 => 0x2f9d2,
  :cjk_compatibility_ideograph_2f9d3 => 0x2f9d3,
  :cjk_compatibility_ideograph_2f9d4 => 0x2f9d4,
  :cjk_compatibility_ideograph_2f9d5 => 0x2f9d5,
  :cjk_compatibility_ideograph_2f9d6 => 0x2f9d6,
  :cjk_compatibility_ideograph_2f9d7 => 0x2f9d7,
  :cjk_compatibility_ideograph_2f9d8 => 0x2f9d8,
  :cjk_compatibility_ideograph_2f9d9 => 0x2f9d9,
  :cjk_compatibility_ideograph_2f9da => 0x2f9da,
  :cjk_compatibility_ideograph_2f9db => 0x2f9db,
  :cjk_compatibility_ideograph_2f9dc => 0x2f9dc,
  :cjk_compatibility_ideograph_2f9dd => 0x2f9dd,
  :cjk_compatibility_ideograph_2f9de => 0x2f9de,
  :cjk_compatibility_ideograph_2f9df => 0x2f9df,
  :cjk_compatibility_ideograph_2f9e0 => 0x2f9e0,
  :cjk_compatibility_ideograph_2f9e1 => 0x2f9e1,
  :cjk_compatibility_ideograph_2f9e2 => 0x2f9e2,
  :cjk_compatibility_ideograph_2f9e3 => 0x2f9e3,
  :cjk_compatibility_ideograph_2f9e4 => 0x2f9e4,
  :cjk_compatibility_ideograph_2f9e5 => 0x2f9e5,
  :cjk_compatibility_ideograph_2f9e6 => 0x2f9e6,
  :cjk_compatibility_ideograph_2f9e7 => 0x2f9e7,
  :cjk_compatibility_ideograph_2f9e8 => 0x2f9e8,
  :cjk_compatibility_ideograph_2f9e9 => 0x2f9e9,
  :cjk_compatibility_ideograph_2f9ea => 0x2f9ea,
  :cjk_compatibility_ideograph_2f9eb => 0x2f9eb,
  :cjk_compatibility_ideograph_2f9ec => 0x2f9ec,
  :cjk_compatibility_ideograph_2f9ed => 0x2f9ed,
  :cjk_compatibility_ideograph_2f9ee => 0x2f9ee,
  :cjk_compatibility_ideograph_2f9ef => 0x2f9ef,
  :cjk_compatibility_ideograph_2f9f0 => 0x2f9f0,
  :cjk_compatibility_ideograph_2f9f1 => 0x2f9f1,
  :cjk_compatibility_ideograph_2f9f2 => 0x2f9f2,
  :cjk_compatibility_ideograph_2f9f3 => 0x2f9f3,
  :cjk_compatibility_ideograph_2f9f4 => 0x2f9f4,
  :cjk_compatibility_ideograph_2f9f5 => 0x2f9f5,
  :cjk_compatibility_ideograph_2f9f6 => 0x2f9f6,
  :cjk_compatibility_ideograph_2f9f7 => 0x2f9f7,
  :cjk_compatibility_ideograph_2f9f8 => 0x2f9f8,
  :cjk_compatibility_ideograph_2f9f9 => 0x2f9f9,
  :cjk_compatibility_ideograph_2f9fa => 0x2f9fa,
  :cjk_compatibility_ideograph_2f9fb => 0x2f9fb,
  :cjk_compatibility_ideograph_2f9fc => 0x2f9fc,
  :cjk_compatibility_ideograph_2f9fd => 0x2f9fd,
  :cjk_compatibility_ideograph_2f9fe => 0x2f9fe,
  :cjk_compatibility_ideograph_2f9ff => 0x2f9ff,
  :cjk_compatibility_ideograph_2fa00 => 0x2fa00,
  :cjk_compatibility_ideograph_2fa01 => 0x2fa01,
  :cjk_compatibility_ideograph_2fa02 => 0x2fa02,
  :cjk_compatibility_ideograph_2fa03 => 0x2fa03,
  :cjk_compatibility_ideograph_2fa04 => 0x2fa04,
  :cjk_compatibility_ideograph_2fa05 => 0x2fa05,
  :cjk_compatibility_ideograph_2fa06 => 0x2fa06,
  :cjk_compatibility_ideograph_2fa07 => 0x2fa07,
  :cjk_compatibility_ideograph_2fa08 => 0x2fa08,
  :cjk_compatibility_ideograph_2fa09 => 0x2fa09,
  :cjk_compatibility_ideograph_2fa0a => 0x2fa0a,
  :cjk_compatibility_ideograph_2fa0b => 0x2fa0b,
  :cjk_compatibility_ideograph_2fa0c => 0x2fa0c,
  :cjk_compatibility_ideograph_2fa0d => 0x2fa0d,
  :cjk_compatibility_ideograph_2fa0e => 0x2fa0e,
  :cjk_compatibility_ideograph_2fa0f => 0x2fa0f,
  :cjk_compatibility_ideograph_2fa10 => 0x2fa10,
  :cjk_compatibility_ideograph_2fa11 => 0x2fa11,
  :cjk_compatibility_ideograph_2fa12 => 0x2fa12,
  :cjk_compatibility_ideograph_2fa13 => 0x2fa13,
  :cjk_compatibility_ideograph_2fa14 => 0x2fa14,
  :cjk_compatibility_ideograph_2fa15 => 0x2fa15,
  :cjk_compatibility_ideograph_2fa16 => 0x2fa16,
  :cjk_compatibility_ideograph_2fa17 => 0x2fa17,
  :cjk_compatibility_ideograph_2fa18 => 0x2fa18,
  :cjk_compatibility_ideograph_2fa19 => 0x2fa19,
  :cjk_compatibility_ideograph_2fa1a => 0x2fa1a,
  :cjk_compatibility_ideograph_2fa1b => 0x2fa1b,
  :cjk_compatibility_ideograph_2fa1c => 0x2fa1c,
  :cjk_compatibility_ideograph_2fa1d => 0x2fa1d,
  :language_tag => 0xe0001,
  :tag_space => 0xe0020,
  :tag_exclamation_mark => 0xe0021,
  :tag_quotation_mark => 0xe0022,
  :tag_number_sign => 0xe0023,
  :tag_dollar_sign => 0xe0024,
  :tag_percent_sign => 0xe0025,
  :tag_ampersand => 0xe0026,
  :tag_apostrophe => 0xe0027,
  :tag_left_parenthesis => 0xe0028,
  :tag_right_parenthesis => 0xe0029,
  :tag_asterisk => 0xe002a,
  :tag_plus_sign => 0xe002b,
  :tag_comma => 0xe002c,
  :tag_hyphen_minus => 0xe002d,
  :tag_full_stop => 0xe002e,
  :tag_solidus => 0xe002f,
  :tag_digit_zero => 0xe0030,
  :tag_digit_one => 0xe0031,
  :tag_digit_two => 0xe0032,
  :tag_digit_three => 0xe0033,
  :tag_digit_four => 0xe0034,
  :tag_digit_five => 0xe0035,
  :tag_digit_six => 0xe0036,
  :tag_digit_seven => 0xe0037,
  :tag_digit_eight => 0xe0038,
  :tag_digit_nine => 0xe0039,
  :tag_colon => 0xe003a,
  :tag_semicolon => 0xe003b,
  :tag_less_than_sign => 0xe003c,
  :tag_equals_sign => 0xe003d,
  :tag_greater_than_sign => 0xe003e,
  :tag_question_mark => 0xe003f,
  :tag_commercial_at => 0xe0040,
  :tag_latin_capital_letter_a => 0xe0041,
  :tag_latin_capital_letter_b => 0xe0042,
  :tag_latin_capital_letter_c => 0xe0043,
  :tag_latin_capital_letter_d => 0xe0044,
  :tag_latin_capital_letter_e => 0xe0045,
  :tag_latin_capital_letter_f => 0xe0046,
  :tag_latin_capital_letter_g => 0xe0047,
  :tag_latin_capital_letter_h => 0xe0048,
  :tag_latin_capital_letter_i => 0xe0049,
  :tag_latin_capital_letter_j => 0xe004a,
  :tag_latin_capital_letter_k => 0xe004b,
  :tag_latin_capital_letter_l => 0xe004c,
  :tag_latin_capital_letter_m => 0xe004d,
  :tag_latin_capital_letter_n => 0xe004e,
  :tag_latin_capital_letter_o => 0xe004f,
  :tag_latin_capital_letter_p => 0xe0050,
  :tag_latin_capital_letter_q => 0xe0051,
  :tag_latin_capital_letter_r => 0xe0052,
  :tag_latin_capital_letter_s => 0xe0053,
  :tag_latin_capital_letter_t => 0xe0054,
  :tag_latin_capital_letter_u => 0xe0055,
  :tag_latin_capital_letter_v => 0xe0056,
  :tag_latin_capital_letter_w => 0xe0057,
  :tag_latin_capital_letter_x => 0xe0058,
  :tag_latin_capital_letter_y => 0xe0059,
  :tag_latin_capital_letter_z => 0xe005a,
  :tag_left_square_bracket => 0xe005b,
  :tag_reverse_solidus => 0xe005c,
  :tag_right_square_bracket => 0xe005d,
  :tag_circumflex_accent => 0xe005e,
  :tag_low_line => 0xe005f,
  :tag_grave_accent => 0xe0060,
  :tag_latin_small_letter_a => 0xe0061,
  :tag_latin_small_letter_b => 0xe0062,
  :tag_latin_small_letter_c => 0xe0063,
  :tag_latin_small_letter_d => 0xe0064,
  :tag_latin_small_letter_e => 0xe0065,
  :tag_latin_small_letter_f => 0xe0066,
  :tag_latin_small_letter_g => 0xe0067,
  :tag_latin_small_letter_h => 0xe0068,
  :tag_latin_small_letter_i => 0xe0069,
  :tag_latin_small_letter_j => 0xe006a,
  :tag_latin_small_letter_k => 0xe006b,
  :tag_latin_small_letter_l => 0xe006c,
  :tag_latin_small_letter_m => 0xe006d,
  :tag_latin_small_letter_n => 0xe006e,
  :tag_latin_small_letter_o => 0xe006f,
  :tag_latin_small_letter_p => 0xe0070,
  :tag_latin_small_letter_q => 0xe0071,
  :tag_latin_small_letter_r => 0xe0072,
  :tag_latin_small_letter_s => 0xe0073,
  :tag_latin_small_letter_t => 0xe0074,
  :tag_latin_small_letter_u => 0xe0075,
  :tag_latin_small_letter_v => 0xe0076,
  :tag_latin_small_letter_w => 0xe0077,
  :tag_latin_small_letter_x => 0xe0078,
  :tag_latin_small_letter_y => 0xe0079,
  :tag_latin_small_letter_z => 0xe007a,
  :tag_left_curly_bracket => 0xe007b,
  :tag_vertical_line => 0xe007c,
  :tag_right_curly_bracket => 0xe007d,
  :tag_tilde => 0xe007e,
  :cancel_tag => 0xe007f,
  :variation_selector_17 => 0xe0100,
  :variation_selector_18 => 0xe0101,
  :variation_selector_19 => 0xe0102,
  :variation_selector_20 => 0xe0103,
  :variation_selector_21 => 0xe0104,
  :variation_selector_22 => 0xe0105,
  :variation_selector_23 => 0xe0106,
  :variation_selector_24 => 0xe0107,
  :variation_selector_25 => 0xe0108,
  :variation_selector_26 => 0xe0109,
  :variation_selector_27 => 0xe010a,
  :variation_selector_28 => 0xe010b,
  :variation_selector_29 => 0xe010c,
  :variation_selector_30 => 0xe010d,
  :variation_selector_31 => 0xe010e,
  :variation_selector_32 => 0xe010f,
  :variation_selector_33 => 0xe0110,
  :variation_selector_34 => 0xe0111,
  :variation_selector_35 => 0xe0112,
  :variation_selector_36 => 0xe0113,
  :variation_selector_37 => 0xe0114,
  :variation_selector_38 => 0xe0115,
  :variation_selector_39 => 0xe0116,
  :variation_selector_40 => 0xe0117,
  :variation_selector_41 => 0xe0118,
  :variation_selector_42 => 0xe0119,
  :variation_selector_43 => 0xe011a,
  :variation_selector_44 => 0xe011b,
  :variation_selector_45 => 0xe011c,
  :variation_selector_46 => 0xe011d,
  :variation_selector_47 => 0xe011e,
  :variation_selector_48 => 0xe011f,
  :variation_selector_49 => 0xe0120,
  :variation_selector_50 => 0xe0121,
  :variation_selector_51 => 0xe0122,
  :variation_selector_52 => 0xe0123,
  :variation_selector_53 => 0xe0124,
  :variation_selector_54 => 0xe0125,
  :variation_selector_55 => 0xe0126,
  :variation_selector_56 => 0xe0127,
  :variation_selector_57 => 0xe0128,
  :variation_selector_58 => 0xe0129,
  :variation_selector_59 => 0xe012a,
  :variation_selector_60 => 0xe012b,
  :variation_selector_61 => 0xe012c,
  :variation_selector_62 => 0xe012d,
  :variation_selector_63 => 0xe012e,
  :variation_selector_64 => 0xe012f,
  :variation_selector_65 => 0xe0130,
  :variation_selector_66 => 0xe0131,
  :variation_selector_67 => 0xe0132,
  :variation_selector_68 => 0xe0133,
  :variation_selector_69 => 0xe0134,
  :variation_selector_70 => 0xe0135,
  :variation_selector_71 => 0xe0136,
  :variation_selector_72 => 0xe0137,
  :variation_selector_73 => 0xe0138,
  :variation_selector_74 => 0xe0139,
  :variation_selector_75 => 0xe013a,
  :variation_selector_76 => 0xe013b,
  :variation_selector_77 => 0xe013c,
  :variation_selector_78 => 0xe013d,
  :variation_selector_79 => 0xe013e,
  :variation_selector_80 => 0xe013f,
  :variation_selector_81 => 0xe0140,
  :variation_selector_82 => 0xe0141,
  :variation_selector_83 => 0xe0142,
  :variation_selector_84 => 0xe0143,
  :variation_selector_85 => 0xe0144,
  :variation_selector_86 => 0xe0145,
  :variation_selector_87 => 0xe0146,
  :variation_selector_88 => 0xe0147,
  :variation_selector_89 => 0xe0148,
  :variation_selector_90 => 0xe0149,
  :variation_selector_91 => 0xe014a,
  :variation_selector_92 => 0xe014b,
  :variation_selector_93 => 0xe014c,
  :variation_selector_94 => 0xe014d,
  :variation_selector_95 => 0xe014e,
  :variation_selector_96 => 0xe014f,
  :variation_selector_97 => 0xe0150,
  :variation_selector_98 => 0xe0151,
  :variation_selector_99 => 0xe0152,
  :variation_selector_100 => 0xe0153,
  :variation_selector_101 => 0xe0154,
  :variation_selector_102 => 0xe0155,
  :variation_selector_103 => 0xe0156,
  :variation_selector_104 => 0xe0157,
  :variation_selector_105 => 0xe0158,
  :variation_selector_106 => 0xe0159,
  :variation_selector_107 => 0xe015a,
  :variation_selector_108 => 0xe015b,
  :variation_selector_109 => 0xe015c,
  :variation_selector_110 => 0xe015d,
  :variation_selector_111 => 0xe015e,
  :variation_selector_112 => 0xe015f,
  :variation_selector_113 => 0xe0160,
  :variation_selector_114 => 0xe0161,
  :variation_selector_115 => 0xe0162,
  :variation_selector_116 => 0xe0163,
  :variation_selector_117 => 0xe0164,
  :variation_selector_118 => 0xe0165,
  :variation_selector_119 => 0xe0166,
  :variation_selector_120 => 0xe0167,
  :variation_selector_121 => 0xe0168,
  :variation_selector_122 => 0xe0169,
  :variation_selector_123 => 0xe016a,
  :variation_selector_124 => 0xe016b,
  :variation_selector_125 => 0xe016c,
  :variation_selector_126 => 0xe016d,
  :variation_selector_127 => 0xe016e,
  :variation_selector_128 => 0xe016f,
  :variation_selector_129 => 0xe0170,
  :variation_selector_130 => 0xe0171,
  :variation_selector_131 => 0xe0172,
  :variation_selector_132 => 0xe0173,
  :variation_selector_133 => 0xe0174,
  :variation_selector_134 => 0xe0175,
  :variation_selector_135 => 0xe0176,
  :variation_selector_136 => 0xe0177,
  :variation_selector_137 => 0xe0178,
  :variation_selector_138 => 0xe0179,
  :variation_selector_139 => 0xe017a,
  :variation_selector_140 => 0xe017b,
  :variation_selector_141 => 0xe017c,
  :variation_selector_142 => 0xe017d,
  :variation_selector_143 => 0xe017e,
  :variation_selector_144 => 0xe017f,
  :variation_selector_145 => 0xe0180,
  :variation_selector_146 => 0xe0181,
  :variation_selector_147 => 0xe0182,
  :variation_selector_148 => 0xe0183,
  :variation_selector_149 => 0xe0184,
  :variation_selector_150 => 0xe0185,
  :variation_selector_151 => 0xe0186,
  :variation_selector_152 => 0xe0187,
  :variation_selector_153 => 0xe0188,
  :variation_selector_154 => 0xe0189,
  :variation_selector_155 => 0xe018a,
  :variation_selector_156 => 0xe018b,
  :variation_selector_157 => 0xe018c,
  :variation_selector_158 => 0xe018d,
  :variation_selector_159 => 0xe018e,
  :variation_selector_160 => 0xe018f,
  :variation_selector_161 => 0xe0190,
  :variation_selector_162 => 0xe0191,
  :variation_selector_163 => 0xe0192,
  :variation_selector_164 => 0xe0193,
  :variation_selector_165 => 0xe0194,
  :variation_selector_166 => 0xe0195,
  :variation_selector_167 => 0xe0196,
  :variation_selector_168 => 0xe0197,
  :variation_selector_169 => 0xe0198,
  :variation_selector_170 => 0xe0199,
  :variation_selector_171 => 0xe019a,
  :variation_selector_172 => 0xe019b,
  :variation_selector_173 => 0xe019c,
  :variation_selector_174 => 0xe019d,
  :variation_selector_175 => 0xe019e,
  :variation_selector_176 => 0xe019f,
  :variation_selector_177 => 0xe01a0,
  :variation_selector_178 => 0xe01a1,
  :variation_selector_179 => 0xe01a2,
  :variation_selector_180 => 0xe01a3,
  :variation_selector_181 => 0xe01a4,
  :variation_selector_182 => 0xe01a5,
  :variation_selector_183 => 0xe01a6,
  :variation_selector_184 => 0xe01a7,
  :variation_selector_185 => 0xe01a8,
  :variation_selector_186 => 0xe01a9,
  :variation_selector_187 => 0xe01aa,
  :variation_selector_188 => 0xe01ab,
  :variation_selector_189 => 0xe01ac,
  :variation_selector_190 => 0xe01ad,
  :variation_selector_191 => 0xe01ae,
  :variation_selector_192 => 0xe01af,
  :variation_selector_193 => 0xe01b0,
  :variation_selector_194 => 0xe01b1,
  :variation_selector_195 => 0xe01b2,
  :variation_selector_196 => 0xe01b3,
  :variation_selector_197 => 0xe01b4,
  :variation_selector_198 => 0xe01b5,
  :variation_selector_199 => 0xe01b6,
  :variation_selector_200 => 0xe01b7,
  :variation_selector_201 => 0xe01b8,
  :variation_selector_202 => 0xe01b9,
  :variation_selector_203 => 0xe01ba,
  :variation_selector_204 => 0xe01bb,
  :variation_selector_205 => 0xe01bc,
  :variation_selector_206 => 0xe01bd,
  :variation_selector_207 => 0xe01be,
  :variation_selector_208 => 0xe01bf,
  :variation_selector_209 => 0xe01c0,
  :variation_selector_210 => 0xe01c1,
  :variation_selector_211 => 0xe01c2,
  :variation_selector_212 => 0xe01c3,
  :variation_selector_213 => 0xe01c4,
  :variation_selector_214 => 0xe01c5,
  :variation_selector_215 => 0xe01c6,
  :variation_selector_216 => 0xe01c7,
  :variation_selector_217 => 0xe01c8,
  :variation_selector_218 => 0xe01c9,
  :variation_selector_219 => 0xe01ca,
  :variation_selector_220 => 0xe01cb,
  :variation_selector_221 => 0xe01cc,
  :variation_selector_222 => 0xe01cd,
  :variation_selector_223 => 0xe01ce,
  :variation_selector_224 => 0xe01cf,
  :variation_selector_225 => 0xe01d0,
  :variation_selector_226 => 0xe01d1,
  :variation_selector_227 => 0xe01d2,
  :variation_selector_228 => 0xe01d3,
  :variation_selector_229 => 0xe01d4,
  :variation_selector_230 => 0xe01d5,
  :variation_selector_231 => 0xe01d6,
  :variation_selector_232 => 0xe01d7,
  :variation_selector_233 => 0xe01d8,
  :variation_selector_234 => 0xe01d9,
  :variation_selector_235 => 0xe01da,
  :variation_selector_236 => 0xe01db,
  :variation_selector_237 => 0xe01dc,
  :variation_selector_238 => 0xe01dd,
  :variation_selector_239 => 0xe01de,
  :variation_selector_240 => 0xe01df,
  :variation_selector_241 => 0xe01e0,
  :variation_selector_242 => 0xe01e1,
  :variation_selector_243 => 0xe01e2,
  :variation_selector_244 => 0xe01e3,
  :variation_selector_245 => 0xe01e4,
  :variation_selector_246 => 0xe01e5,
  :variation_selector_247 => 0xe01e6,
  :variation_selector_248 => 0xe01e7,
  :variation_selector_249 => 0xe01e8,
  :variation_selector_250 => 0xe01e9,
  :variation_selector_251 => 0xe01ea,
  :variation_selector_252 => 0xe01eb,
  :variation_selector_253 => 0xe01ec,
  :variation_selector_254 => 0xe01ed,
  :variation_selector_255 => 0xe01ee,
  :variation_selector_256 => 0xe01ef
}
